/* 
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *
 * $tvt: buttons.c,v 1.4 2001/11/10 02:11:26 damian Exp $ 
 */

#include <fgl.h>

extern fgl_font_t *font;

void draw_button( fgl_context_t *gc, int x, int y, int width, 
		  int height, char *text, int active) {

	int text_length;
	int text_height;

	if ( active ) {
		fgl_setColor( gc, fgl_getPixelValue (0xd0d0d0));
	} else {
		fgl_setColor( gc, fgl_getPixelValue (0xc0c0c0));
	}

	fgl_fillRect( gc, x, y + 8, x + width, y + height - 4);

	if ( active ) {
		fgl_setColor( gc, fgl_getPixelValue (0xd0d0d0));
	} else {
		fgl_setColor( gc, fgl_getPixelValue (0xb0b0b0));
	}

	fgl_drawRect( gc, x, y + 8, x + width, y + height - 4);

	if ( active ) {
		fgl_setColor( gc, fgl_getPixelValue(0xff0000));
	} else {
		fgl_setColor( gc, fgl_getPixelValue(0x000000));
	}

	text_height = font->fontHeight;
	text_length = fgl_getTextLength( font, text, -1);
	fgl_drawText( gc, x + ( width - text_length) / 2, y + height/4 + text_height , text,-1);
}
