#!/bin/sh
#
# Shell script that is run to generate all the initial makefile.
# This is a concept borrowed from the gnome project except that ours
# is much simpler.
#
# $tvt: autogen.sh,v 1.9 2001/11/21 22:02:53 samc Exp $

if [ -z "$srcdir" ]; then
  srcdir=.
fi

(autoconf --version) < /dev/null > /dev/null 2>&1 || {
  echo ""
  echo "**Error**: You must have 'autoconf' installed to generate"
  echo "to configure script for this package."
  exit 1
}

(aclocal --version) < /dev/null > /dev/null 2>&1 || {
  echo
  echo "**Error**: You must have 'aclocal' installed to generate"
  echo "to configure script for this package."
  echo "'aclocal' usually ships as part 'automake' package."
  exit 1
}

if [ -z "$*" ]; then
  echo "**Warning**: I am going to run 'configure' with no arguments."
  echo "If you wish to pass any to it, please specify them on the"
  echo "'$0' command line."
  echo
fi

echo "Running aclocal $ACLOCAL_FLAGS ..."
(cd $srcdir && aclocal $ACLOCAL_FLAGS) || exit 1

if [ -n "$RUN_AUTOHEADER" ]; then
  echo "Running autoheader ..."
  (cd $srcdir && autoheader) || exit 1
fi

echo "Running autoconf ..."
(cd $srcdir && autoconf) || exit 1

echo "Running configure $@ ..."
$srcdir/configure $@ || exit 1

echo "Now type 'make' to compile"
