/* -*- mode: C; mode: fold -*- */ 

#include "fgl.h"
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

int main ( int argc, char* argv[] ) /*{{{*/
{
  int i, j, width, height, slength;
  char *filename;
  char header[256];
  int length;
  int fid;
  char *linebuffer, *pos;
  u32 r,g,b;

  fgl_slc_t *capture, *temp;

  
  if ( !fgl_init( 0, 0, 0) ){
      puts( "aborting..");
      return 1;
  }

  width   = fgl_screenBmp->width;
  height  = fgl_screenBmp->height;
  slength = fgl_screenBmp->sLength;
 
  capture = (fgl_slc_t *) malloc ( width * height * sizeof( fgl_slc_t ));

  for ( i = 0 ; i < height ; i++ )
    {
      fgl_cpySlc( fgl_screenBmp->surface + slength * i, 0, capture + i * width, 0, width );
    }
      
  
  fprintf(stderr,"screen image (%i,%i) [%i]\n",width,height,slength);
  
  /* store captured image in a file */

  if ( argc <= 1 ) 
    {
      filename = "capture.pnm";
    }
  else 
    {
      filename = argv[1];
    }
 
  linebuffer = (char *) malloc ( width * 3 * sizeof( char ));
  
  fid = open ( filename, O_WRONLY | O_CREAT | O_TRUNC, S_IWUSR | S_IRUSR | S_IRGRP );

  sprintf ( header, "P6\n%i %i\n255\n",width,height);
  length = strlen ( header );
  write ( fid, header, length );
  temp = capture;
  for ( j = 0; j < height ; j ++ ) 
    {
      pos = linebuffer;
      for ( i = 0 ; i < width; i++ ) 
        {
          fgl_getRgbValues ( *temp, &r, &g, &b );
          temp++;
          pos[0] = r;
          pos[1] = g;
          pos[2] = b;
          pos += 3;
        }
      write(fid,linebuffer,width*3);      
    }
  
  close ( fid );

  fgl_terminate();
  free ( capture );
  return 0;
}
/*}}}*/
