#include "fgl.h"
#include "ipl.h"

u32 spd_cmap[] = {
	0x000000,
	0xffff00,
	0xff0000
};

fgl_color_t spd_data[] = {
	1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	1,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,1,2,2,1,1,0,0,0,0,0,0,0,0,0,0,0,
	0,1,2,2,2,2,1,1,0,0,0,0,0,0,0,0,0,
	0,0,1,2,2,2,2,2,1,1,0,0,0,0,0,0,0,
	0,0,1,2,2,2,2,2,2,2,1,1,0,0,0,0,0,
	0,0,0,1,2,2,2,2,2,2,2,2,1,1,0,0,0,
	0,0,0,1,2,2,2,2,2,2,2,2,2,2,1,0,0,
	0,0,0,0,1,2,2,2,2,2,2,2,1,1,0,0,0,
	0,0,0,0,1,2,2,2,2,2,1,1,0,0,0,0,0,
	0,0,0,0,0,1,2,2,2,1,2,1,0,0,0,0,0,
	0,0,0,0,0,1,2,2,2,1,1,2,1,0,0,0,0,
	0,0,0,0,0,0,1,2,1,0,0,1,2,1,0,0,0,
	0,0,0,0,0,0,1,2,1,0,0,0,1,2,1,0,0,
	0,0,0,0,0,0,0,1,0,0,0,0,0,1,2,1,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};

fgl_spriteData_t spd = {
	17, 17,                                   /* width, height */
	0, 0,                                     /* xhot, yhot */
	3, 0,                                     /* nColors, transp */
	spd_cmap,
	spd_data
};

int main ( int argc, char* argv[] )
{
	fgl_context_t *gc;
	fgl_sprite_t *sp;
    ipl_event_t e;

	if ( !fgl_init() ){
		puts( "aborting..");
		return 1;
	}

    if ( !ipl_init( fgl_getScreenWidth(), fgl_getScreenHeight()) ){
	    puts("aborting..");
	    return 1;
	}
  
	gc = fgl_getContext( fgl_screenBmp);
	sp = fgl_createSprite( &spd );

	fgl_setCursor( sp);
	fgl_moveCursor( 100, 100);
	fgl_showCursor();

    while ( 1 ) {
        if ( ipl_getEvent( &e) ){
			if ( e.type == EVT_MOUSE_MOVE ){
				fgl_moveCursor( e.x, e.y);
			}
			else if ( e.type == EVT_BUTTON_DOWN ){
				break;
			}
		}
	}

    ipl_reset();
	fgl_terminate();

	return 1;
}
