/* -*- mode: C; mode: fold -*- */ 

#include "fgl.h"
#define TEST 4
#define SIZE 41

int main ( int argc, char* argv[] ) /*{{{*/
{
  fgl_slc_t *src;
  fgl_slc_t *dst;
  int i,test1,test2,error;

  fgl_slc_t *s;
  fgl_slc_t *d;

  src = (fgl_slc_t *)malloc((SIZE+4)*sizeof(u32));
  dst = (fgl_slc_t *)malloc((SIZE+4)*sizeof(u32));

  /* set the test cases */

  /* run test 0 */

  for(test1 = 0; test1 < TEST; test1++ ) {
  for(test2 = 0; test2 < TEST; test2++ ) {
    
    for( i = 0; i < SIZE+4 ; i++ ) {
      src[i] = i+0xfacd;
      dst[i] = 0;
    }

    s = src + test1;
    d = dst + test2;

    fgl_cpySlc(s,0,d,0,SIZE);
 
    error = 0;

    for( i = 0; i < SIZE ; i++ ) {
      if ( s[i] != d[i]) error++;
    }

    
    if (error) {
      fprintf(stderr,"MC TEST (%i %i) ALIGNMENT SRC (%2lx) ALIGNMENT DST (%2lx) ERRORS  (%i)\n",
	      test1,test2,(unsigned long)s%8,(unsigned long)d%8,error);
      for( i = 0; i < SIZE ; i++ ) {
	printf("%4x: %4x -> %4x",i,s[i],d[i]);
	if (s[i] == d[i] ) printf("\n");
	else printf(" *\n");
      }
      
    }
    else {
      fprintf(stderr,"MC TEST (%i %i) ALIGNMENT SRC (%2lx) ALIGNMENT DST (%2lx) SUCCESS (%i)\n",
	      test1,test2,(unsigned long)s%8,(unsigned long)d%8,error);
    }
  }
  }
  free(src);
  free(dst);

  return 1;
}
/*}}}*/
