/* -*- mode: C; mode: fold -*- */ 

#include "fgl.h"
#include "penpen.h"

#include <math.h>
#include <string.h>

void test1 ( fgl_context_t *gc , int x, int y) /*{{{*/
{
	puts( "basic shapes");

	fgl_setColor( gc, fgl_clrRed);

	fgl_drawRect( gc, x+170, y+5, x+200, y+35);

	fgl_fillRect( gc, x+150, y+135, x+250, y+235);
	fgl_drawLine( gc, x, y+0, x+100, y+200);

	fgl_setColor( gc, fgl_clrGreen);
	fgl_drawLine( gc, x, y, x+200, y+100);

	fgl_setColor( gc, fgl_clrBlue);
	fgl_drawLine( gc, x, y+200, x+200, y+100);

	fgl_setColor( gc, fgl_clrYellow);
	fgl_drawLine( gc, x, y+200, x+100, y);

	fgl_setColor( gc, fgl_clrBlue);
	fgl_fillEllipse( gc, x+285, y+100, 30, 80);

	fgl_setColor( gc, fgl_clrGreen);
	fgl_drawEllipse( gc, x+285, y+100, 30, 80);

	fgl_setColor( gc, fgl_clrOrange);
	fgl_fillCircle( gc, x+180, y+180, 20);

	fgl_setColor( gc, fgl_clrYellow);
	fgl_drawCircle( gc, x+180, y+180, 20);
}
/*}}}*/

void test2 ( fgl_context_t *gc, int x, int y) /*{{{*/
{
	u32 cx0 = gc->x0Clip;
	u32 cx1 = gc->x1Clip;
	u32 cy0 = gc->y0Clip;
	u32 cy1 = gc->y1Clip;

	puts( "basic clipping");

	fgl_setColor( gc, fgl_clrBlue);
	fgl_fillRect( gc, x+100, y+20, x+300, y+220);

	fgl_setClip( gc, x+100, y+20, x+300, y+220);

	/* clipped */
	fgl_setColor( gc, fgl_clrYellow);
	fgl_drawLine( gc, x+80, y+50, x+280, y+250);
	fgl_drawLine( gc, x+170, y+230, x+170, y+10);
	fgl_drawLine( gc, x+50, y+120, x+320, y+120);

	/* out */
	fgl_setColor( gc, fgl_clrRed);
	fgl_drawLine( gc, x+160, y+10, x+300, y+15);
	fgl_drawLine( gc, x+310, y+0, x+310, y+240);

	/* in */
	fgl_setColor( gc, fgl_clrCyan);
	//fgl_drawLine( gc, 120, 120, 250, 250);
	//fgl_drawLine( gc, 150, 200, 250, 200);
	//fgl_drawLine( gc, 150, 140, 250, 200); 

	//fgl_drawLine( gc, 150, 200, 200, 200);
	//fgl_drawLine( gc, 150, 200, 250, 200);
	fgl_drawLine( gc, x+200, y+80, x+200, y+120);
	fgl_drawLine( gc, x+202, y+120, x+202, y+80);

	fgl_setClip( gc, cx0, cy0, cx1, cy1);
}
/*}}}*/

void test3 ( fgl_context_t *gc , int x, int y) /*{{{*/
{
	fgl_point_t  poly1[] = {
		{ x+100, y+100 },
		{ x+120, y+150 },
		{ x+130, y+130 },
		{ x+150, y+160 },
		{ x+90, y+180 },
		{ x+80, y+170 },
		{ x+110, y+140 },
		{ x+50, y+130 },
		{ x+100, y+100 }
	};
	int n1 = sizeof(poly1)/sizeof(poly1[0]);

	fgl_point_t poly2[] = {
		{ x+100, y+200 },
		{ x+130, y+180 },
		{ x+130, y+220 }
	};
	int n2 = sizeof(poly2)/sizeof(poly2[0]);

	puts( "polygons");

	fgl_setColor( gc, fgl_clrBlue);
	fgl_fillPolygon( gc, poly1, n1);
	fgl_setColor( gc, fgl_clrYellow);
	fgl_drawPolygon( gc, poly1, n1);

	fgl_setColor( gc, fgl_clrRed);
	fgl_fillPolygon( gc, poly2, n2);
}
/*}}}*/

void test4 ( fgl_context_t *gc, int ox, int oy) /*{{{*/
{
	int x, y, dx = 0, dy=2, d=80, s;
	fgl_bitmap_t   *penpen;
	fgl_monoBitmap_t *mask;

	get_penpen( &penpen, &mask);


	puts( "scrolling (copyArea)");

	x = ox+100;
	y = oy;
	
	fgl_setColor( gc, fgl_clrBlue);
	fgl_bitBlt( gc, x-100, y, penpen,0,0,80,80);
	fgl_bitBlt( gc, x, y, penpen,0,0,80,80);
	fgl_bitBlt( gc, x+100, y, penpen,0,0,80,80);
	fgl_bitBlt( gc, x+200, y, penpen,0,0,80,80);
	fgl_bitBlt( gc, x+300, y, penpen,0,0,80,80);

	fgl_setColor( gc, fgl_clrYellow);
	fgl_fillRect( gc, x+400, y, x+480, y+80);
	fgl_maskBlt( gc, x+400, y, penpen,0,0,80,80,mask);

	fgl_setColor( gc, fgl_clrRed);
	fgl_fillRect( gc, x+400, y+100, x+480, y+180);
	fgl_maskBlt( gc, x+400, y+100, penpen,0,0,80,80,mask);

	fgl_setColor( gc, fgl_clrGreen);
	fgl_fillRect( gc, x+400, y+200, x+480, y+280);
	fgl_maskBlt( gc, x+400, y+200, penpen,0,0,80,80,mask);

	fgl_setColor( gc, fgl_clrBlue);
	fgl_fillRect( gc, x+400, y+300, x+480, y+380);
	fgl_maskBlt( gc, x+400, y+300, penpen,0,0,80,80,mask);

	for( s = 0; s < 100000000 ; s++);

	fgl_moveArea( gc, x+100, y, x+180, y+80, 0, 20);
	fgl_moveArea( gc, x+200, y, x+280, y+80, 0, 40);
	fgl_moveArea( gc, x+300, y, x+380, y+80, 0, 60);

	for ( ; (x < gc->x1Clip) && (y < gc->y1Clip) ; x += dx, y += dy ){
		fgl_setColor( gc, fgl_clrRed);
		fgl_moveArea( gc, x, y, x+d, y+d, dx, dy);

		fgl_setColor( gc, fgl_clrBlack);
		for( s = 0; s < 1000000 ; s++);
		if ( dy ){
			if ( dy > 0 )
				fgl_fillRect( gc, x, y, x+d, y+dy);
			else 
				fgl_fillRect( gc, x, y+d-dy, x+d, y+d);
		}
		if ( dx ){
			if ( dx > 0 )
				fgl_fillRect( gc, x, y, x+dx, y+d);
			else
				fgl_fillRect( gc, x+d-dx, y, x+d, y+d);
		}
	}
}
/*}}}*/

void test5 ( fgl_context_t *gc , int ox, int oy, int os) /*{{{*/
{
	fgl_color_t clrs[] = { fgl_clrYellow, fgl_clrOrange, fgl_clrRed,
						   fgl_clrGreen, fgl_clrCyan, fgl_clrBlue };
	fgl_monoBitmap_t *bmp = fgl_createMonoBitmap( 32, 32, 0xff );
	fgl_monoBitmap_t *bmp1 = fgl_createMonoBitmap( 32, 64, 0xaa );
	fgl_monoBitmap_t *bmp2 = fgl_createMonoBitmap( 64, 32, 0xaa );
	int i;
	int d;
	int x = ox+100;

	puts( "monoBitmap");
	
	fgl_setColor( gc, fgl_clrYellow);
	fgl_drawRect( gc, x + bmp->width, oy+100,
				  x + 2*bmp->width-1, oy+100 + bmp->height-1);

	fgl_drawRect( gc, x, oy + 100 + bmp->height,
				  x + bmp->width-1, oy + 100 + 2*bmp->height-1);
	fgl_drawRect( gc, x + bmp->width, oy + 100 + bmp->height,
				  x + 2 * bmp->width-1, oy + 100 + 2*bmp->height-1);
	fgl_drawRect( gc, x + 2 * bmp->width, oy + 100 + 2 * bmp->height,
				  x + 3 * bmp->width-1, oy + 100 + 3 * bmp->height-1);

	for ( i=0; i<6; i++ ){
		fgl_monoBlt( gc, x, oy + 100,
					 bmp, 2, 2, bmp->width-1, bmp->height-1, clrs[i]);
		fgl_monoBlt( gc, x, oy + 166,
					 bmp2, 2, 2, bmp2->width-1, bmp2->height-1, clrs[i]);
		fgl_monoBlt( gc, x+66, oy + 100,
					 bmp1, 2, 2, bmp1->width-1, bmp1->height-1, clrs[i]);
		for ( d=0; d<10000000/os; d+=2);
	}
}
/*}}}*/

void test6 ( fgl_context_t *gc, int ox, int oy) /*{{{*/
{
	fgl_bitmap_t     *src  = fgl_createBitmap( 32, 32, fgl_clrRed);
	fgl_monoBitmap_t *mask = fgl_createMonoBitmap( src->width, src->height, 0x88);
	
	puts( "maskBlt");
	fgl_maskBlt( gc, ox+100,oy+100,
				 src, 4, 4, src->width-1, src->height-1, mask);
}
/*}}}*/

void test7 ( fgl_context_t *gc, int ox, int oy) /*{{{*/
{
	fgl_bitmap_t   *sav = fgl_createBitmap( 32, 32, -1);

	puts( "saveArea");

	fgl_setColor( gc, fgl_clrRed);
	fgl_fillRect( gc, ox+100, oy+100, ox+200, oy+200);

	fgl_saveArea( sav, 0, 0, gc->bmp, ox+100, oy+100, ox+100+sav->width-1, oy+100+sav->height-1);
	fgl_setColor( gc, fgl_clrBlack);
	fgl_clear( gc);

	fgl_bitBltBmp( gc, ox+100, oy+100, sav);
}
/*}}}*/

u32 spd_cmap[] = { /*{{{*/
	0x000000,
	0xffff00,
	0xff0000
};

u8 spd_data[] = {
	1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	1,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,1,2,2,1,1,0,0,0,0,0,0,0,0,0,0,0,
	0,1,2,2,2,2,1,1,0,0,0,0,0,0,0,0,0,
	0,0,1,2,2,2,2,2,1,1,0,0,0,0,0,0,0,
	0,0,1,2,2,2,2,2,2,2,1,1,0,0,0,0,0,
	0,0,0,1,2,2,2,2,2,2,2,2,1,1,0,0,0,
	0,0,0,1,2,2,2,2,2,2,2,2,2,2,1,0,0,
	0,0,0,0,1,2,2,2,2,2,2,2,1,1,0,0,0,
	0,0,0,0,1,2,2,2,2,2,1,1,0,0,0,0,0,
	0,0,0,0,0,1,2,2,2,1,2,1,0,0,0,0,0,
	0,0,0,0,0,1,2,2,2,1,1,2,1,0,0,0,0,
	0,0,0,0,0,0,1,2,1,0,0,1,2,1,0,0,0,
	0,0,0,0,0,0,1,2,1,0,0,0,1,2,1,0,0,
	0,0,0,0,0,0,0,1,0,0,0,0,0,1,2,1,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};

fgl_spriteData_t spd = {
	17, 17,                                   /* width, height */
	0, 0,                                     /* xhot, yhot */
	3, 0,                                     /* nColors, transp */
	spd_cmap,
	spd_data
};
/*}}}*/

void test8 ( fgl_context_t *gc, int ox, int oy, int os ) /*{{{*/
{
	int i, l;
	fgl_sprite_t *sp = fgl_createSprite( &spd );

	puts( "sprite");

	fgl_setColor( gc, fgl_clrBlue);
	fgl_fillRect( gc, ox+20, oy+80, ox+280, oy+120);

	fgl_moveSprite( gc, sp, ox+30, oy+100);
	fgl_showSprite( gc, sp);


	for ( i=30; i<310; i++ ){
	  fgl_moveSprite( gc, sp, ox+i, oy+100);
	  for ( l=1000000/os; l; l-- );
	}

	fgl_hideSprite(gc, sp);
	fgl_setColor( gc, fgl_clrGreen);
	fgl_fillRect( gc, ox+20, oy+80, ox+280, oy+120);
	fgl_showSprite(gc, sp);
	
	for ( i=100; i<200; i++ ){
	  fgl_moveSprite( gc, sp, ox+310, oy+i);
	  for ( l=1000000/os; l; l-- );
	}
	
	fgl_hideSprite(gc, sp);
	fgl_setColor( gc, fgl_clrBlue);
	fgl_fillRect( gc, ox+20, oy+80, ox+280, oy+120);
	fgl_showSprite(gc, sp);
	
	for ( i=310; i>=30; i-- ){
	  fgl_moveSprite( gc, sp, ox+i, oy+200);
	  for ( l=1000000/os; l; l-- );
	}
	
	fgl_hideSprite(gc, sp);
	fgl_setColor( gc, fgl_clrOrange);
	fgl_fillRect( gc, ox+20, oy+80, ox+280, oy+120);
	fgl_showSprite(gc, sp);

	for ( i=200; i>=100; i-- ){
	  fgl_moveSprite( gc, sp, ox+30, oy+i);
	  for ( l=1000000/os; l; l-- );
	}
       
}
/*}}}*/

void test9 ( fgl_context_t *gc, int ox, int oy) /*{{{*/
{
  fgl_font_t *fnt = fgl_getFont( "arial", 11);
	char       *text;
	int        y = 100+oy;
	int        x = 100+ox;

	//fgl_font_t *f1 =  fgl_getFont( "courbd", 11);
	//fgl_disposeFont( f1);

	puts( "fonts");

	fgl_setFont( gc, fnt);
	fgl_setColor( gc, fgl_clrYellow);

	text = "Don't stare at me, gonzo (iii) %$%$%$%";
	//fgl_drawLine( gc, 600, y, 600 + fgl_getTextLength( fnt, text, -1), y);
	fgl_drawText( gc, x, y, text, -1);

	y += fnt->fontHeight;
	text = "Gotcha!";
	//fgl_drawLine( gc, 600, y, 600 + fgl_getTextLength( fnt, text, -1), y);
	fgl_drawText( gc, x, y, text, -1);

	fgl_disposeFont( fnt);
}
/*}}}*/

void test10 ( fgl_context_t *gc, int ox, int oy) /*{{{*/
{
	fgl_font_t *fnt = fgl_getFont( "arial", 11);
	unsigned short text[22] = { 'P', 'o', 'c', 'k', 'e', 't', 'L', 'i', 'n', 'u', 'x', ' ',
		 0x30dd, 0x30b1, 0x30c3, 0x30c8, 0x30ea, 0x30ca, 0x30c3,
		 0x30b1, 0x30b9 , 0x00};
	int            y = 100+oy;
	int            x = 100+ox;

	puts( "japanese fonts");

	fgl_setFont( gc, fnt);
	fgl_setColor( gc, fgl_clrYellow);

	fgl_drawWText( gc, x+50, y, text, -1);
	fgl_drawWVertText(gc, x, y-100, text, -1);

	fgl_disposeFont( fnt );
}
/*}}}*/

void test11 ( fgl_context_t *gc, int ox, int oy, int os ) /*{{{*/
{
	int x, y, dx, dy, r = 120;
	double a, da;
	int d;

	puts( "xor - lines");

	fgl_setColor( gc, fgl_clrBlue);
	fgl_fillRect( gc, ox+100, oy+70, ox+200, oy+170);

	fgl_setColor( gc, fgl_clrYellow);
	fgl_setXorMode( gc, fgl_clrBlack);

	x = ox+150;
	y = oy+120;
	for ( a=0, da=2*M_PI/360.; a<= 2*M_PI; a += da ){
		dx = (int) r * sin( a);
		dy = (int) r * cos( a);

		fgl_drawLine( gc, x, y, x+dx, y+dy);
		for ( d=0; d<100000/os; d += 1);
		fgl_drawLine( gc, x, y, x+dx, y+dy);
	}

	fgl_setPaintMode( gc);
	fgl_drawLine( gc, x, oy+0, x, oy+240);
}
/*}}}*/

void test12 ( fgl_context_t *gc ,int ox, int oy) /*{{{*/
{
	int x, y;
	fgl_a8Bitmap_t* bmp = fgl_createA8Bitmap( 256, 10, -1);
	fgl_bitmap_t* src = fgl_createBitmap( 256, 10, fgl_clrYellow);

	fgl_fillRectClr( gc, ox+40, oy+105, ox+80, oy+145, fgl_clrBlue);
	fgl_setAlpha( gc, 0xff);
	fgl_bitBltBmp( gc, ox+20, oy+110, src);
	fgl_setAlpha( gc, 128);
	fgl_bitBltBmp( gc, ox+20, oy+130, src);

	puts( "a8 bitmap");

	for (y=0; y<bmp->height; y++ ){
		for ( x=0; x<bmp->width; x++ ){
			fgl_setPixelA8( bmp, x, y, (u8)x);
		}
	}

	puts( "a8BltBmp");

	fgl_a8BltBmp( gc, ox+20, oy+10, bmp, fgl_clrBlue);
	fgl_a8BltBmp( gc, ox+20, oy+20, bmp, fgl_clrGreen);
	fgl_a8BltBmp( gc, ox+20, oy+30, bmp, fgl_clrRed);

	fgl_setAlpha( gc, 0xff);
	puts( "alphaMaskBltBmp");

	fgl_alphaMaskBltBmp( gc, ox+20, oy+50, src, bmp);

}
/*}}}*/

void test13 ( fgl_context_t *gc ,int ox, int oy) /*{{{*/
{
	fgl_a2Bitmap_t* src0 = fgl_createA2Bitmap( 256, 10, 0x00);
	fgl_a2Bitmap_t* src1 = fgl_createA2Bitmap( 256, 10, 0x55);
	fgl_a2Bitmap_t* src2 = fgl_createA2Bitmap( 256, 10, 0xaa);
	fgl_a2Bitmap_t* src3 = fgl_createA2Bitmap( 256, 10, 0xff);

	puts( "a2 bitmap");

	fgl_setColor( gc, fgl_clrRed);
	fgl_fillRect( gc, ox+100, oy+100, ox+200, oy+200);

	fgl_a2BltBmp( gc, ox+20, oy+110, src0, fgl_clrYellow);
	fgl_a2BltBmp( gc, ox+20, oy+130, src1, fgl_clrYellow);
	fgl_a2BltBmp( gc, ox+20, oy+150, src2, fgl_clrYellow);
	fgl_a2BltBmp( gc, ox+20, oy+170, src3, fgl_clrYellow);

}
/*}}}*/

void test14 ( fgl_context_t *gc, int ox, int oy) /*{{{*/
{
	fgl_setColor( gc, fgl_clrYellow);
	fgl_drawLine( gc, ox+0, oy+0, ox+300, oy+0);
	fgl_setColor( gc, fgl_clrBlue);
	fgl_drawLine( gc, ox+300, oy+0, ox+300, oy+200);
	fgl_setColor( gc, fgl_clrRed);
	fgl_drawLine( gc, ox+300, oy+200, ox+0, oy+200);
	fgl_setColor( gc, fgl_clrGreen);
	fgl_drawLine( gc, ox+0, oy+200, ox+0, oy+0);

	fgl_setColor( gc, fgl_clrYellow);
	fgl_drawVLine( gc, ox+140, oy+10, oy+190);
	fgl_drawVLine( gc, ox+160, oy+10, oy+190);

	fgl_setColor( gc, fgl_clrGreen);
	fgl_drawHLine( gc, ox+10, oy+90,  ox+290);
	fgl_drawHLine( gc, ox+10, oy+110, ox+290);

}
/*}}}*/

void test15 ( fgl_context_t *gc, int ox, int oy) /*{{{*/
{
	fgl_bitmap_t   *penpen;
	fgl_monoBitmap_t *mask;

	get_penpen( &penpen, &mask);


	puts( "transparent blt");

	fgl_setColor( gc, fgl_clrBlue);
	fgl_setColor( gc, fgl_clrGreen);
	fgl_fillRect( gc, ox+20, oy, ox+60, oy+80);
	fgl_bitBlt( gc, ox, oy, penpen,0,0,80,80);

	fgl_setColor( gc, fgl_clrRed);
	fgl_fillRect( gc, ox+100, oy, ox+180, oy+80);
	fgl_maskBlt( gc, ox+100, oy, penpen,0,0,80,80,mask);

	fgl_setColor( gc, fgl_clrOrange);
	fgl_fillRect( gc, ox, oy+100, ox+80, oy+180);
	fgl_maskBlt( gc, ox, oy+100, penpen,0,0,80,80,mask);

	fgl_setColor( gc, fgl_clrGreen);
	fgl_fillRect( gc, ox+100, oy+100, ox+180, oy+180);
	fgl_maskBlt( gc, ox+100, oy+100, penpen,0,0,80,80,mask);

	fgl_moveArea( gc, ox, oy, ox+80, oy+80, 200, 100);

}
/*}}}*/


int main ( int argc, char* argv[] ) /*{{{*/
{   
	int i=1, stop=0;
	fgl_context_t *gc;
	int ox,oy,c;
	int os = 1;

	ox = 0;
	oy = 0;

	if ( argc >= 1 ){
	  /* chech all the arguments */
	  /* -t test number          */
	  /* -x x offset             */
	  /* -y y offset             */
	  for(c = 1;c<argc;c++) {
	 
	    if(strcmp(argv[c],"-h")==0) {
	      fprintf(stderr,"usage: tfgl001 <-x x_offset> <-y y_offset> <-t test>\n");
	      fprintf(stderr,"               <-s speed> <-h>\n");
	      exit(0);
	    }
	    if(strcmp(argv[c],"-t")==0) {i = atoi( argv[c+1]); stop = 1;}
	    if(strcmp(argv[c],"-x")==0) ox = atoi( argv[c+1]);
	    if(strcmp(argv[c],"-y")==0) oy = atoi( argv[c+1]);
	    if(strcmp(argv[c],"-s")==0) os = atoi( argv[c+1]);
	  }
		
	}

	if ( !fgl_init( 0, 0, 0) ){
		puts( "aborting..");
		return 1;
	}

	gc = fgl_getContext( fgl_screenBmp);

	do {
		printf( "press <CR> for test %d\n", i);
		getchar();

		fgl_setColor( gc, fgl_clrBlack);
		fgl_clear( gc);

		switch ( i ) {
		case 1:  test1( gc,ox,oy); break;
		case 2:  test2( gc,ox,oy); break;
		case 3:  test3( gc,ox,oy); break;
		case 4:  test4( gc,ox,oy); break;
		case 5:  test5( gc,ox,oy,os); break;
		case 6:  test6( gc,ox,oy); break;
		case 7:  test7( gc,ox,oy); break;
		case 8:  test8( gc,ox,oy,os); break;
		case 9:  test9( gc,ox,oy); break;
		case 10:  test10( gc,ox,oy); break;
		case 11:  test11( gc,ox,oy,os); break;
		case 12:  test12( gc,ox,oy); break;
		case 13:  test13( gc,ox,oy); break;
		case 14:  test14( gc,ox,oy); break;
		case 15:  test15( gc,ox,oy); break;
		default: stop = 1;
		}
		i++;
	} while ( !stop );

	fgl_terminate();

	return 1;
}
/*}}}*/
