/* -*- mode: C; mode: fold -*- */
/*
 * feng_hdr.c - fgl module to implement a header font file (*.h)
 *              font engine
 * 
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 *
 * $tvt: feng_hdr.c,v 1.8 2001/07/04 00:47:55 samc Exp $
 */

#ifndef FGL_FENG_INCLUDED
#define FGL_FENG_INCLUDED

#define FGL_MODULE
#include "fgl.h"


/*****************************************/
#include "fonts/arial_8.h"

#include "fonts/arial_10.h"
#include "fonts/arialbd_10.h"
#include "fonts/ariali_10.h"
#include "fonts/arialbi_10.h"

#include "fonts/cour_11.h"
#include "fonts/courbd_11.h"
#include "fonts/couri_11.h"
#include "fonts/courbi_11.h"

#include "fonts/times_11.h"
#include "fonts/timesbd_11.h"
#include "fonts/timesi_11.h"
#include "fonts/timesbi_11.h"

fgl_font_t* ari_8[] = {
	&arial_8,
	&arial_8,
	&arial_8,
	&arial_8
};

fgl_font_t* ari_10[] = {
	&arial_10,
	&arialbd_10,
	&ariali_10,
	&arialbi_10
};

fgl_font_t* cou_11[] = {
	&cour_11,
	&courbd_11,
	&couri_11,
	&courbi_11
};

fgl_font_t* tms_11[] = {
	&times_11,
	&timesbd_11,
	&timesi_11,
	&timesbi_11
};
/****************************************/

/**** FIX ME ****

#include "fonts/arialbd_9.h"
#include "fonts/arialbd_12.h"
#include "fonts/courbd_12.h"

fgl_font_t* ari_8[] = {
	&arialbd_9,
	&arialbd_9,
	&arialbd_9,
	&arialbd_9
};

fgl_font_t* ari_10[] = {
	&arialbd_12,
	&arialbd_12,
	&arialbd_12,
	&arialbd_12
};

fgl_font_t* cou_11[] = {
	&courbd_12,
	&courbd_12,
	&courbd_12,
	&courbd_12
};

fgl_font_t* tms_11[] = {
	&arialbd_12,
	&arialbd_12,
	&arialbd_12,
	&arialbd_12
};

***************************************/

int fgl_initFontEngine ()
{
	fgl_defaultFont = ari_10[0];

	return 1;
}


static inline
int getFontAttrs ( char* fname )
{
	int i;

	for ( i=0; fname[i]; i++ );

	if ( i==0 ){
		return 0;
	}

	/* get bold & italic attributes */
	if ( fname[i-1] == 'i' ){
		if ( fname[i-2] == 'b' ){
			return 3;
		}
		else {
			return 2;
		}
	}
	else if ( fname[i-1] == 'd' ){
		return 1;
	}
	else {
		return 0;
	}
}

fgl_font_t* fgl_loadFont ( char* fname, u8 ptSize )
{
	int idx = getFontAttrs( fname);

	switch ( fname[0] ){
	case 'a':
		if ( ptSize < 10 )
			return ari_8[idx];
		else
			return ari_10[idx];

	case 'c':
		return cou_11[idx];

	case 't':
		return tms_11[idx];
	}

	return fgl_defaultFont;
}

void fgl_unloadFont ( fgl_font_t* fnt )
{
	/* are you kidding - no way to unload static data */
}

#endif /* FGL_FENG_INCLUDED */
