/* -*- mode: C; mode: fold -*- */
/*
 * fgld_16_arm.h - fgl header for ARM specific framebuffer access
 *                  accelerations for 16-bpp framebuffer formats
 *           
 * 
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * 11/29/00  Damian Kowalewski
 *
 * $tvt: fgld_16_arm.h,v 1.2 2001/07/04 00:47:55 samc Exp $
 */

static inline
  void _stoswl_ ( unsigned int val, unsigned short* dst, int length ) /*{{{*/
{
           int dum1, dum2, dum3;
           
           asm volatile ("mov\tr7,%0\n\t"
			 "mov\tr7,r7,lsl $16\n\t"
			 "add\tr7,r7,%0\n\t"
			 "ands\tr9,%1,$3\n\t"
			 "beq\t0f\n\t"
			 "strh\t%0,[%1],$2\n\t"
			 "sub\t%2,%2,$1\n"

			 "0:\n\t"
			 "mov\tr0,r7\n\t"
                         "mov\tr1,r7\n\t"
			 "mov\tr2,r7\n\t"
			 "mov\tr3,r7\n\t"
			 "mov\tr4,r7\n\t"
			 "mov\tr5,r7\n\t"
			 "mov\tr6,r7\n\t"

			 "1:\n\t"
			 "subs\tr9,%2,$16\n\t"
			 "blt\t2f\n\t"
			 "stmia\t%1!,{r0-r7}\n\t"
			 "mov\t%2,r9\n\t"
			 "bal\t1b\n"
			 
			 "2:\n\t"
			 "subs\tr9,%2,$8\n\t"
			 "blt\t3f\n\t"
			 "stmia\t%1!,{r0-r3}\n\t"
			 "mov\t%2,r9\n\t"
			 "bal\t2b\n"
			 
			 "3:\n\t"
			 "subs\tr9,%2,$4\n\t"
			 "blt\t4f\n\t"
			 "stmia\t%1!,{r0-r1}\n\t"
			 "mov\t%2,r9\n\t"
			 "bal\t3b\n"

			 "4:\n\t"
			 "subs\tr9,%2,$1\n\t"
			 "blt\t5f\n\t"
			 "strh\tr0,[%1],$2\n\t"
			 "mov\t%2,r9\n\t"
			 "bal\t4b\n"
			 
			 "5:\n"
			 
			 : "=r" (dum1), "=r" (dum2), "=r" (dum3)
			 : "0" (val), "1" (dst), "2" (length)
			 : "r0","r1","r2","r3","r4","r5","r6","r7","r9"
			 );
} 
/*}}}*/

static inline
  void _movswl_ ( unsigned short* src, unsigned short* dest, int length ) /*{{{*/
{
 
   int dum1,dum2,dum3;
    
   __asm__ __volatile__ (
			 "ands\tr9,%0,$3          @test the alignment of src\n\t"    
			 "beq\t0f\n\t"
			 "ands\tr9,%1,$3          @test the alignment of dst\n\t"
			 "beq\t5f\n\t"
			 "ldrh\tr4,[%0],$2\n\t"
			 "strh\tr4,[%1],$2\n\t"
			 "sub\t%2,%2,$1\n\t"
			 "b\t1f\n"
			 "0:\n\t"
			 "ands\tr9,%1,$3          @test the alignment of dst\n\t"
			 "bne\t4f\n"

			 "1:\n\t"
			 "subs\tr9,%2,$16\n\t"
			 "blt\t2f\n\t"
			 "ldmia\t%0!,{r0-r7}\n\t"
			 "stmia\t%1!,{r0-r7}\n\t"
			 "mov\t%2,r9\n\t"
			 "bal\t1b\n"

			 "2:\n\t"
			 "subs\tr9,%2,$8\n\t"
			 "blt\t3f\n\t"
			 "ldmia\t%0!,{r0-r3}\n\t"
			 "stmia\t%1!,{r0-r3}\n\t"
			 "mov\t%2,r9\n\t"
			 "bal\t2b\n"
			 
			 "3:\n\t"
			 "subs\tr9,%2,$4\n\t"
			 "blt\t6f\n\t"
			 "ldmia\t%0!,{r0-r1}\n\t"
			 "stmia\t%1!,{r0-r1}\n\t"
			 "mov\t%2,r9\n\t"
			 "bal\t3b\n"
			 
			 "4:\n\t"
			 "ldrh\tr4,[%0],$2\n\t"
			 "strh\tr4,[%1],$2\n\t"
			 "sub\t%2,%2,$1\n"

			 "5:\n\t"
			 "subs\tr9,%2,$8\n\t"
			 "blt\t6f\n\t"
			 "ldrh\tr0,[%0],$2\n\t"
			 "ldmia\t%0!,{r1-r3}\n\t"
			 "ldrh\tr4,[%0],$2\n\t"
			 "mov\tr4,r4,lsl $16\n\t"
			 "orr\tr4,r4,r3,lsr $16\n\t"
			 "mov\tr3,r3,lsl $16\n\t"
			 "orr\tr3,r3,r2,lsr $16\n\t"
			 "mov\tr2,r2,lsl $16\n\t"
			 "orr\tr2,r2,r1,lsr $16\n\t"
			 "mov\tr1,r1,lsl $16\n\t"
			 "orr\tr1,r1,r0\n\t"
			 "stmia\t%1!,{r1-r4}\n\t"
			 "mov\t%2,r9\n\t"
			 "bal\t5b\n"
			 
			 "6:\n\t"
			 "subs\tr9,%2,$1\n\t"
			 "blt\t7f\n\t"
			 "ldrh\tr4,[%0],$2\n\t"
			 "strh\tr4,[%1],$2\n\t"
			 "mov\t%2,r9\n\t"
			 "bal\t6b\n"
			 "7:\n"
			 : "=r" (dum1), "=r" (dum2), "=r" (dum3)
			 : "0" (src), "1" (dest), "2" (length)
			 : "r0","r1","r2","r3","r4","r5","r6","r7","r8","r9"
			 );
}
/*}}}*/

#define HAVE_SETSLCCOLS
static inline
  void fgl_setSlcCols ( fgl_slc_t *p, u32 x, u32 len, fgl_color_t clr ) /*{{{*/
{
           _stoswl_( clr, p, len);
}
/*}}}*/


#define HAVE_INITBMP
static inline
  void fgl_initBmp ( fgl_bitmap_t* bmp, i32 clr )  /*{{{*/
{
           fgl_slc_t* p = bmp->surface;
           u32 len = bmp->sLength * bmp->height;
   
           _stoswl_( clr, p, len);
}
/*}}}*/


#define HAVE_CPYSLC
static inline
  void fgl_cpySlc ( fgl_slc_t *src, u32 x, fgl_slc_t *dest, u32 u, u32 len )  /*{{{*/
{
   _movswl_( src, dest, len);
}
/*}}}*/


#ifdef NEVER
#define HAVE_MOVESLC
static inline
  void fgl_moveSlc ( fgl_slc_t *src, u32 x, fgl_slc_t *dest, u32 u, u32 len )  /*{{{*/										
{
   _movswl_( src, dest, len);
}
/*}}}*/
#endif
       
