/* -*- mode: C; mode: fold -*- */
/*
 * fgld_16_i386_mmx.h - fgl header for i386 mmx specific framebuffer access
 *                  accelerations for 16-bpp framebuffer formats
 *           
 * 
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/16/01  Damian Kowalewski
 *
 * $tvt: fgld_16_i386_mmx.h,v 1.7 2001/07/04 00:47:55 samc Exp $
 */

static inline
void _stoswl_ ( unsigned int val, unsigned short* dst, int numwords ) /*{{{*/
{
	int dum1, dum2, dum3;
	
	asm volatile (
		      "	movl	%%edx,	%%ebx	\n"
		      "	movl	%%edi,	%%eax	\n"
		      "	sall	$16,	%%ebx	\n"
		      "	andl	$7,	%%eax	\n"
		      "	orl	%%edx,	%%ebx	\n"
		      "	movd	%%ebx,	%%mm0	\n"
		      "	movd	%%ebx,	%%mm1	\n"
		      "	psllq	$32,	%%mm0	\n"
		      "	por	%%mm1,	%%mm0	\n"		 
		      "	addl	$0,	%%eax	\n"
		      "	je	4f		\n"
		      "	subl	$4,	%%eax	\n"
		      "	je	2f		\n"
		      "	jg	3f		\n"

		      "1:			\n"
		      "	subl	$1,	%%ecx	\n"
		      "	movl	%%edx,	%%eax	\n"
		      "	sarl	$24,	%%eax	\n"
		      "	mov	%%edx,	(%%edi)	\n"
		      "	addl	$2,	%%edi	\n"
		      "	mov	%%eax,	1(%%edi)\n"		      

		      "2:			\n"
		      "	subl	$2,	%%ecx	\n"
		      "	movl	%%ebx,	(%%edi)	\n"
		      "	addl	$4,	%%edi	\n"
		      "	jmp	4f		\n"

		      "3:			\n"
		      "	subl	$1,	%%ecx	\n"
		      "	movl	%%edx,	%%eax	\n"
		      "	sarl	$24,	%%eax	\n"
		      "	mov	%%edx,	(%%edi)	\n"
		      "	addl	$2,	%%edi	\n"
		      "	mov	%%eax,	1(%%edi)\n"		      		      
		      
		      "4:			\n"
		      "	subl	$16,	%%ecx	\n"
		      "	jl	5f		\n"
		      "	movq	%%mm0,	(%%edi)	\n"
		      "	movq	%%mm0,	8(%%edi)\n"
		      "	movq	%%mm0,	16(%%edi)\n"
		      "	movq	%%mm0,	24(%%edi)\n"
		      "	addl	$32,	%%edi	\n"
		      "	jmp	4b		\n"

		      "5:			\n"
		      "	addl	$16,	%%ecx	\n"
		      "	jle	11f		\n"

		      "6:			\n"
		      "	subl	$8,	%%ecx	\n"
		      "	jl	7f		\n"
		      "	movq	%%mm0,	(%%edi)	\n"
		      "	movq	%%mm0,	8(%%edi)\n"
		      "	addl	$16,	%%edi	\n"
		      "	jmp	6b		\n"

		      "7:			\n"
		      "	addl	$8,	%%ecx	\n"
		      "	jle	11f		\n"

		      "8:			\n"
		      "	subl	$2,	%%ecx	\n"
		      "	jl	9f		\n"
		      "	movl	%%ebx,	(%%edi)	\n"
		      "	addl	$4,	%%edi	\n"
		      "	jmp	8b		\n"

		      "9:			\n"
		      "	addl	$2,	%%ecx	\n"
		      "	jle	11f		\n"

		      "10:			\n"
		      "	subl	$1,	%%ecx	\n"
		      "	jl	11f		\n"
		      "	mov	%%edx,	(%%edi)	\n"
		      "	addl	$2,	%%edi	\n"
		      "	mov	%%eax,	1(%%edi)\n"
		      "	jmp	10b		\n"
		      
		      "11:			\n"
		      "	emms			\n"

		      : "=d" (dum1), "=D" (dum2), "=c" (dum3)
		      : "d" (val), "D" (dst), "c" (numwords)
		      : "%ebx", "%eax", "%ebp", "cc");
} 
/*}}}*/


static inline
void _movswl_ ( unsigned short* src, unsigned short* dest, int numwords ) /*{{{*/
{
	int dum1, dum2, dum3;
	
	asm  volatile (


		       "	testl	$7,	%%edi	\n"
		       "	je	1f		\n"

		       "0:				\n"
		       "	movw	(%%esi),%%ax	#destination is not aligned, so we\n"
		       "	addl	$2,	%%esi	#align it ourselves. \n"
		       "	movw	%%ax,	(%%edi)	\n"
		       "	subl	$1,	%%ecx	\n"
		       "	je	20f		\n"
		       "	addl	$2,	%%edi	\n"
		       "	testl	$7,     %%edi   \n"
		       "	jg	0b		\n"

		       "1:				\n"
		       "	testl	$7,	%%esi	# depending on it take appropiate\n"
		       "	jne	7f		# jump.\n"

		       "2:				\n"
		       "	subl	$16,	%%ecx	\n"
		       "	jl	3f		\n"
		       "	movq	(%%esi),%%mm0	\n"
		       "	movq	8(%%esi),%%mm1	\n"
		       "	movq	16(%%esi),%%mm2	\n"
		       "	movq	24(%%esi),%%mm3	\n"		      
		       "	addl	$32,	%%esi	\n"
		       "	movq	%%mm0,	(%%edi)	\n"
		       "	movq	%%mm1,	8(%%edi)\n"
		       "	movq	%%mm2,	16(%%edi)\n"
		       "	movq	%%mm3,	24(%%edi)\n"
		       "	addl	$32,	%%edi	\n"
		       "	jmp	2b		\n"

		       "3:				\n"
		       "	addl	$16,	%%ecx	\n"
		       "	jle	20f		# to be changed \n"

		       "4:				\n"
		       "	subl	$8,	%%ecx   \n"
		       "	jl	5f	        \n"
		       "	movq	(%%esi),%%mm0	\n"
		       "	movq	8(%%esi),%%mm1	\n"
		       "	addl	$16,	%%esi	\n"
		       "	movq	%%mm0,	(%%edi) \n"
		       "	movq	%%mm1,	8(%%edi)\n"
		       "	addl	$16,	%%edi	\n"
		       "	jmp	4b		\n"

		       "5:				\n"
		       "	addl	$8,	%%ecx	\n"
		       "	jle	20f		# to be changed \n"

		       "6:				\n"
		       "	subl	$2,	%%ecx	\n"
		       "	jl	18f		\n"
		       "	movl	(%%esi),%%ebx	\n"
		       "	addl	$4,	%%esi	\n"
		       "	movl	%%ebx,	(%%edi)	\n"
		       "	addl	$4,	%%edi	\n"
		       "	jmp	6b		\n"


		       "7:				# memory is misaligned	\n"
		       "				# we have three cases:	\n"
		       "				#	2	      	\n"
		       "				#	4	      	\n"
		       "				#	6		\n"
		       "				# of value in ebx	\n"
		       "	testl	$4,	%%esi	#			\n"       
		       "	jne	14f		# difference is not 4	\n"
		       
		       "8:				# cosider the case of 4	\n"
		       "	subl	$16,	%%ecx	\n"
		       "	jl	9f		\n"
		       "	movd	(%%esi),%%mm0	\n"		       
		       "	movq	4(%%esi),%%mm1	\n"
		       "	movq	12(%%esi),%%mm2	\n"
		       "	movq	20(%%esi),%%mm3	\n"
		       "	movd	28(%%esi),%%mm4	\n"		      

		       "	psllq	$32,	%%mm4	\n"

		       "	movq	%%mm1,	%%mm5	\n"
		       "	psllq	$32,	%%mm5	\n"
		       "	por	%%mm5,	%%mm0	\n"
		       "	psrlq	$32,	%%mm1	\n"		       

		       "	movq	%%mm2,	%%mm5	\n"		       
		       "	psllq	$32,	%%mm5	\n"
		       "	por	%%mm5,	%%mm1	\n"
		       "	psrlq	$32,	%%mm2 	\n"		       
		      
		       "	movq	%%mm3,	%%mm5	\n"
		       "	psllq	$32,	%%mm5	\n"
		       "	por	%%mm5,	%%mm2	\n"
		       "	psrlq	$32,	%%mm3	\n"		       

		       "	addl	$32,	%%esi	\n"
		       "	por	%%mm4,	%%mm3	\n"

		       "	movq	%%mm3,	24(%%edi)\n"
		       "	movq	%%mm2,	16(%%edi)\n"
		       "	movq	%%mm1,	8(%%edi)\n"
		       "	movq	%%mm0,	(%%edi)	\n"

		       "	addl	$32,	%%edi	\n"
		       "	jmp	8b		\n"

		       
		       "9:				\n"
		       "	addl	$16,	%%ecx	\n"
		       "	jle	20f		# to be changed \n"

		       "10:				\n"
		       "	subl	$8,	%%ecx   \n"
		       "	jl	11f	        \n"
		       "	movd	(%%esi),%%mm0	\n"
		       "	movq	4(%%esi),%%mm1	\n"
		       "	movd	12(%%esi),%%mm2	\n"


		       "	psllq	$32,	%%mm2	\n"		       

		       "	movq	%%mm1,	%%mm5	\n"
		       "	psllq	$32,	%%mm5	\n"
		       "	por	%%mm5,	%%mm0	\n"
		       "	psrlq	$32,	%%mm1	\n"		       

		       "	addl	$16,	%%esi	\n"
		       "	por	%%mm2,	%%mm1	\n"


		       "	movq	%%mm1,	8(%%edi) \n"
		       "	movq	%%mm0,	(%%edi)\n"
		       "	addl	$16,	%%edi	\n"
		       "	jmp	10b		\n"

		       "11:				\n"
		       "	addl	$8,	%%ecx	\n"
		       "      	jle	20f		# to be changed \n"

		       "12:				\n"
		       "	subl	$2,	%%ecx	\n"
		       "	jl	18f		\n"
		       "	movd	(%%esi),%%mm0	\n"
		       "	addl	$4,	%%esi	\n"
		       "	movd	%%mm0,	(%%edi)	\n"
		       "	addl	$4,	%%edi	\n"
		       "	jmp	12b		\n"
		       
		       "14:				\n"
		       "	testl 	$3, 	%%esi	\n"
		       "	je 	15f		\n"

		       "	movw 	(%%esi),%%bx	\n"
		       "	movw 	%%bx, 	(%%edi)	\n"
		       "	addl 	$2, 	%%esi	\n"
		       "	addl 	$2, 	%%edi	\n"
		       "	decl 	%%ecx		\n"
		       "15:				\n"
		       "	movl 	%%ecx,	%%ebx	\n"
		       "	sarl 	$1, 	%%ecx	\n"

		       "	rep			\n"
		       "	movsl			\n"

		       "	testl 	$1,	%%ebx	\n"
		       "	je 	20f		\n"

		       "	movw	(%%esi),%%bx	\n"
		       "	movw	%%bx, 	(%%edi)	\n"
		       "	jmp	20f		\n"
      
		       "18:				\n"
		       "	addl	$2,	%%ecx	\n"
		       "	jle	20f		\n"

		       "19:				\n"
		       "	subl	$1,	%%ecx	\n"
		       "	jl	20f		\n"
		       "	movw	(%%esi),%%dx	\n"
		       "	addl	$2,	%%esi	\n"
		       "	movw	%%dx,	(%%edi)	\n"
		       "	addl	$2,	%%edi	\n"
		       "	jmp	19b		\n"
		      
		       "20:				\n"
		       "	emms			\n"

		       : "=S" (dum1), "=D" (dum2), "=c" (dum3)
		       : "S" (src), "D" (dest), "c" (numwords)
		       : "%eax", "%ebx", "%edx", "cc");
}
/*}}}*/


#define HAVE_SETSLCCOLS
static inline
void fgl_setSlcCols ( fgl_slc_t *p, u32 x, u32 len, fgl_color_t clr ) /*{{{*/
{
	_stoswl_( clr, p, len);
}
/*}}}*/


#define HAVE_INITBMP
static inline
void fgl_initBmp ( fgl_bitmap_t* bmp, i32 clr )  /*{{{*/
{
	fgl_slc_t* p = bmp->surface;
	u32 len = bmp->sLength * bmp->height;

	_stoswl_( clr, p, len);
}
/*}}}*/


#define HAVE_CPYSLC
static inline
void fgl_cpySlc ( fgl_slc_t *src, u32 x, fgl_slc_t *dest, u32 u, u32 len )  /*{{{*/
{
	_movswl_( src, dest, len);
}
/*}}}*/


#ifdef NEVER
#define HAVE_MOVESLC
static inline
void fgl_moveSlc ( fgl_slc_t *src, u32 x, fgl_slc_t *dest, u32 u, u32 len )  /*{{{*/
{
	_movswl_( src, dest, len);
}
/*}}}*/
#endif
