/* -*- mode: C; mode: fold -*- */
/*
 * fgld_16_mipsel.h - fgl header for mips specific framebuffer access
 *                    accelerations for 16-bpp framebuffer formats
 *           
 * 
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * 12/14/00  Damian Kowalewski
 *
 * $tvt: fgld_16_mipsel.h,v 1.8 2001/07/04 00:47:55 samc Exp $
 */

static inline
  void _stoswl_ ( unsigned int val, unsigned short* dst, int length ) /*{{{*/
{
  int dum1, dum2, dum3;
  
  __asm__ __volatile__ (".set noreorder		\n\t"
			"sll	$9,%0,16	# prepare the value to copy\n\t"
			"and	$8,%1,3		# test alignment of src\n\t"
			"beqz	$8,0f		\n\t"
			"or	$9,$9,%0	\n\t"
			"sh	$9,0(%1)	\n\t"
			"addu	%1,%1,2		\n\t"
			"subu	%2,%2,1		\n"

			"0:			\n\t"
			"blt	%2,6,1f		\n\t"
			"addu	%1,%1,12	\n\t"
			"sw	$9,-12(%1)	\n\t"
			"sw	$9,-8(%1)	\n\t"
			"sw	$9,-4(%1)	\n\t"
			"j	0b		\n\t"
			"subu	%2,%2,6		\n"
		
			"1:			\n\t"
			"blt	%2,2,2f		\n\t"
			"addu	%1,%1,4		\n\t"
			"sw	$9,-16(%1)	\n\t"
			"j	1b		\n\t"
			"subu	%2,%2,2		\n"

			"2:			\n\t"
			"blt	%2,1,3f		\n\t"
			"addu	%1,%1,2		\n\t"
			"sh	$9,-18(%1)	\n\t"
			"j	2b		\n\t"
			"subu	%2,%2,1		\n"
			
			"3:			\n\t"
			".set reorder		\n\t"
		
			: "=r" (dum1), "=r" (dum2), "=r" (dum3)
			: "0" (val), "1" (dst), "2" (length)
			: "$8","$9"
			);
} 
/*}}}*/



static inline
void _movswl_ ( unsigned short* src, unsigned short* dst, int length )
{
  int dum1, dum2, dum3;
  __asm__ __volatile__(".set noreorder		\n\t"
		       "and	$8,%0,3		# test alignment of src\n\t"
		       "beqz	$8,0f		\n\t"
		       "and	$9,%1,3		# test alignment of dst\n\t"
		       "beqz	$9,3f		\n\t"
		       "lh	$10,0(%0)	\n\t"
		       "addu	%0,2		\n\t"
		       "sh	$10,0(%1)	\n\t"
		       "addu	%1,2		\n\t"
		       "j	1f		\n\t"
		       "subu	%2,1		\n"

		       "0:			\n\t"
		       "beqz	$9,1f		\n\t"
		       "nop			\n\t"
		       "lh	$10,0(%0)	\n\t"
		       "addu	%0,2		\n\t"
		       "sh	$10,0(%1)	\n\t"
		       "addu	%1,2		\n\t"
		       "j	3f		\n\t"
		       "subu	%2,1		\n"

		       "1:			\n\t"
		       "blt	%2,6,2f		\n\t"
                       "addu	%0,%0,12	\n\t"
                       "lw	$8,-12(%0)	\n\t"
                       "lw	$9,-8(%0)	\n\t"
                       "lw	$10,-4(%0)	\n\t"
                       "sw	$8,0(%1)	\n\t"
                       "sw	$9,4(%1)	\n\t"
                       "sw	$10,8(%1)	\n\t"
                       "addu	%1,%1,12	\n\t"
                       "j	1b		\n\t"
                       "subu	%2,%2,6		\n"

                       "2:			\n\t"
                       "blt	%2,2,5f		\n\t"
                       "addu	%0,%0,4		\n\t"
                       "lw	$8,-16(%0)	\n\t"
		       "addu	%1,%1,4		\n\t"
		       "sw	$8,-4(%1)	\n\t"
                       "j	2b		\n\t"
                       "subu	%2,%2,2		\n"

		       "3:			\n\t"
		       "blt	%2,6,4f		\n\t"
                       "addu	%0,%0,12	\n\t"
                       "lhu	$11,-2(%0)	\n\t"
		       "lw	$10,-6(%0)	\n\t"
                       "lw	$9,-10(%0)	\n\t"
                       "lhu	$8,-12(%0)	\n\t"
	       
		       "sll	$12,$11,16	\n\t"
		       "srl	$11,$10,16	\n\t"
		       "or	$12,$12,$11	\n\t"
		       "sll	$11,$10,16	\n\t"
		       "srl	$10,$9,16	\n\t"
		       "or	$11,$11,$10	\n\t"
		       "sll	$10,$9,16	\n\t"
		       "or	$10,$10,$8	\n\t"
	       
                       "sw	$10,0(%1)	\n\t"
                       "sw	$11,4(%1)	\n\t"
                       "sw	$12,8(%1)	\n\t"
                       "addu	%1,%1,12	\n\t"
                       "j	3b		\n\t"
                       "subu	%2,%2,6		\n"

		       "4:			\n\t"
		       "blt	%2,2,5f		\n\t"
                       "addu	%0,%0,4		\n\t"
                       "lhu	$9,-14(%0)	\n\t"
                       "lhu	$8,-16(%0)	\n\t"
	       
		       "sll	$12,$9,16	\n\t"
		       "or	$12,$12,$8	\n\t"
    
                       "sw	$12,0(%1)	\n\t"
                       "addu	%1,%1,4		\n\t"
                       "j	4b		\n\t"
                       "subu	%2,%2,2		\n"

                       "5:			\n\t"
                       "blt	%2,1,6f		\n\t"
                       "addu	%0,%0,2		\n\t"
                       "lhu	$8,-18(%0)	\n\t"
                       "addu	%1,%1,2		\n\t"
                       "sh	$8,-2(%1)	\n\t"
                       "j	5b		\n\t"
                       "subu	%2,%2,1		\n"

                       "6:			\n\t"
		       ".set reorder		\n\t"

		       : "=r" (dum1), "=r" (dum2), "=r" (dum3)
		       : "0" (src), "1" (dst), "2" (length)
		       : "$8", "$9", "$10", "$11", "$12"
		       );
}

#define HAVE_SETSLCCOLS
static inline
  void fgl_setSlcCols ( fgl_slc_t *p, u32 x, u32 len, fgl_color_t clr ) /*{{{*/
{
           _stoswl_( clr, p, len);
}
/*}}}*/


#define HAVE_INITBMP
static inline
  void fgl_initBmp ( fgl_bitmap_t* bmp, i32 clr )  /*{{{*/
{
           fgl_slc_t* p = bmp->surface;
           u32 len = bmp->sLength * bmp->height;
   
           _stoswl_( clr, p, len);
}
/*}}}*/

#define HAVE_CPYSLC
static inline
void fgl_cpySlc ( fgl_slc_t *src, u32 x, fgl_slc_t *dest, u32 u, u32 len )  /*{{{*/
{
	_movswl_( src, dest, len);
}
/*}}}*/


#ifdef NEVER
#define HAVE_MOVESLC
static inline
void fgl_moveSlc ( fgl_slc_t *src, u32 x, fgl_slc_t *dest, u32 u, u32 len )  /*{{{*/
{
	_movswl_( src, dest, len);
}
/*}}}*/
#endif

