/* -*- mode: C; mode: fold -*- */
/*
 * heap_kaffe.c - fgl module for kaffe specific heap management
 *                (don't compete with kaffe's memory mgnt)
 * 
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 *
 * $tvt: heap_kaffe.c,v 1.5 2001/07/04 00:47:55 samc Exp $
 */

/* fgl module epilog */ /*{{{*/
#ifndef FGL_HEAP_INCLUDED
#define FGL_HEAP_INCLUDED

#define FGL_MODULE
#include "fgl.h"

#if (__INCLUDE_LEVEL__ == 0)
#  undef FGL_PROTO
#endif

#ifdef FGL_INLINE_HEAP
#  define FUNC_ATTR static inline
#else
#  define FUNC_ATTR
#endif
/*}}}*/


extern void* __kaffe_awt_malloc(size_t);
extern void  __kaffe_awt_free(void*);


/* FGL_xx heap macros */ /*{{{*/
#define FGL_MALLOC(_n)      __kaffe_awt_malloc( _n)

#define FGL_CALLOC(_n,_sz)  __kaffe_awt_malloc( (_n) * (_sz))

#define FGL_FREE(_r)        __kaffe_awt_free( _r)

#define FGL_ALLOCA(_n)      alloca( _n)

#define FGL_ALLOCA_FREE(_r)

/*}}}*/


/* fgl module epilog */ /*{{{*/
#endif /* FGL_HEAP_INCLUDED */
/*}}}*/
