/* -*- mode: C; mode: fold -*- */
/*
 * heap_posix.c - fgl module for posix specific heap management
 *                (essentially a dummy providing the macros)
 * 
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 *
 * $tvt: heap_posix.c,v 1.3 2001/07/04 00:47:55 samc Exp $
 */


/* fgl module epilog */ /*{{{*/
#ifndef FGL_HEAP_INCLUDED
#define FGL_HEAP_INCLUDED

#define FGL_MODULE
#include "fgl.h"

#if (__INCLUDE_LEVEL__ == 0)
#  undef FGL_PROTO
#endif

#ifdef FGL_INLINE_HEAP
#  define FUNC_ATTR static inline
#else
#  define FUNC_ATTR
#endif
/*}}}*/


/* FGL_xx heap macros */ /*{{{*/

#define FGL_MALLOC(_n)      malloc( _n)

#define FGL_CALLOC(_n,_sz)  calloc( (_n), (_sz))

#define FGL_FREE(_r)        free( _r)

#define FGL_ALLOCA(_n)      alloca( _n)

#define FGL_ALLOCA_FREE(_r)

/*}}}*/


/* fgl module epilog */ /*{{{*/
#endif /* FGL_HEAP_INCLUDED */
/*}}}*/
