/* -*- mode: C; mode: fold -*- */
/*
 * locale.h - fgl locale header (only included part in clients)
 * 
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * 02/01/01  Damian Kowalewski
 *
 * $tvt: locale.h,v 1.5 2001/07/04 00:47:55 samc Exp $
 */

#ifndef FGL_LOCALE_H_INCLUDED
#define FGL_LOCALE_H_INCLUDED 

#if defined(LOCALE_JP)

#define LOCALE_INT
/*
 * LOCALE_EXTENSION_NUM defines the number of unicode
 * extensions used in particular locale
 *
 */
#define LOCALE_EXTENSION_NUM 2

/* if called from withing feng module define local
 * data structures. should not be called from fgl.h
 *
 */
#if defined(FGL_FENG_INCLUDED)

/*
 * ext_names defines arrays with names of specific
 * character set fonts for each extension in 
 * particular locale
 *
 */
char *ext_names[LOCALE_EXTENSION_NUM]  = {
  "jp/kana",
  "jp/cjk" 
};

/*
 * ext_delta designates possible size mapping for
 * extensions in the locale:
 * min, 1st , 2nd, 3rd, 4th guess 
 * where the min will be used for font sizes
 * min and smaller, otherwise will try to map.
 */
char ext_delta[6] = { 10, 0, +1, +2, -1, -2};

#endif /* FGL_FENG_INCLUDED */
#endif /* LOCALE_JP */
#endif /* FGL_LOCALE_H_INCLUDED */
