/* -*- mode: C; mode: fold -*- */
/*
 * ximage_b4.c - fgl module to map a virtual 4bpp grayscale framebuffer
 *               to X
 * 
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 *
 * $tvt: ximage_b4.c,v 1.3 2001/07/04 00:47:55 samc Exp $
 */

static
void
updateXImage ( int x0, int y0, int x1, int y1 )
{
	int x, y;
	int r, g, b;
	fgl_slc_t *src;
	u16 *dst, pix;
	
	for ( y = y0; y < y1; y++ ){
		src = fgl_getSlc( fgl_screenBmp, x0, y);
		dst = (u16*) (xImg->data + (y * xImg->bytes_per_line) + (x*2)); 

		for ( x = x0; x < x1; x++ ){
			c = fgl_getSlcPixel( src, x);
			fgl_getRgbValues( c, &r, &g, &b);

			pix = ((r & xRedMask)   << xRedShift) |
				  ((g & xGreenMask) << xGreenShift) |
				  ((b & xBlueMask)  << xBlueShift);
			
			*dst = pix;
			
			dst++;
			fgl_incSlc( &src, x);
		}
	}

	XShmPutImage( xDsp, xWnd, xGc, xImg, x0, y0, x1, y1, false);
}
