/*
 * xinput_tp.c - fgl module to map X input to Helio tp events
 *               (-> MOVE TO IPL)
 * 
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 *
 * $tvt: xinput_tp.c,v 1.3 2001/07/04 00:47:55 samc Exp $
 */

#include "../ipl/tp_helio.h"

static int fd_rtp;   /* filehandle to read touchpad info */
static int fd_wtp;   /* filehandle to write touchpad info */

int initXMouseEvent ()
{
	int fd[2];

	if ( pipe( fd) == 0 ){
		fd_rtp = fd[0];
		fd_wtp = fd[1];
	}
	else {
		return 0;
	}

	return 1;
}

int initXKeyEvent ()
{
	return 1;
}


void
emitXMouseEvent ( XEvent* event )
{
	tp_packet_t buf;

	if ( event->xany.type == ButtonPress || event->xany.type == ButtonRelease ) {

		if ( event->xany.type == ButtonPress ){
			buf.status |= (XYZ_VALID | PEN_CONTACT);
		}
		else {
			buf.status |= XYZ_VALID;
			buf.status &= ~PEN_CONTACT;
		}

		buf.xplus  = event->xbutton.x;
		buf.xminus = event->xbutton.x;

		buf.yplus  = event->xbutton.y;
		buf.yminus = event->xbutton.y;

		buf.z = 1;

		write( fd_wtp, &buf, sizeof(buf));
	}
}

void 
emitXKeyEvent ( XEvent* evt )
{
}
