/*
 * ximage_g4.c - fgl module to map a virtual 4bpp grayscale framebuffer
 *               to X
 * 
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 *
 * $tvt: xpixel_g4.c,v 1.3 2001/07/04 00:47:55 samc Exp $
 */

static unsigned long xpix[16];

inline
unsigned long getXpix ( int r, int g, int b )
{
	return  (slshift( (b & xBlueMask), xBlueShift) |
			 slshift( (g & xGreenMask), xGreenShift) |
			 slshift( (r & xRedMask), xRedShift));
}

void
setupXPixelMap ()
{
	xpix[0]  = getXpix( 195, 195, 195);
	xpix[1]  = getXpix( 182, 182, 182);
	xpix[2]  = getXpix( 169, 169, 169);
	xpix[3]  = getXpix( 156, 156, 156);
	xpix[4]  = getXpix( 143, 143, 143);
	xpix[5]  = getXpix( 130, 130, 130);
	xpix[6]  = getXpix( 117, 117, 117);
	xpix[7]  = getXpix( 104, 104, 104);
	xpix[8]  = getXpix(  91,  91,  91);
	xpix[9]  = getXpix(  78,  78,  78);
	xpix[10] = getXpix(  65,  65,  65);
	xpix[11] = getXpix(  52,  52,  52);
	xpix[12] = getXpix(  39,  39,  39);
	xpix[13] = getXpix(  26,  26,  26);
	xpix[14] = getXpix(  13,  13,  13);
	xpix[15] = getXpix(   0,   0,   0);
}

u32
getXPixelBackground ()
{
	return xpix[0];
}

inline
unsigned long
getXPixel ( fgl_color_t c )
{
	return xpix[ c & 0xf];
}
