/*
 * io_jthreads.h - header file for non-blocked jthreads-based IO
 *
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


/* we just need to import these two from jthreads, since reads
 * and writes only occur when we know there is no blocking
 */
extern int jthreadedSelect(int, fd_set*, fd_set*, fd_set*, struct timeval*);
extern int jthreadedFileDescriptor(int fd);




static inline
int _ipl_select ( int  n,
				  fd_set *readfds, fd_set *writefds, fd_set *exceptfds,
				  struct timeval *timeout )
{
	return jthreadedSelect( n, readfds, writefds, exceptfds, timeout);
}

static inline
int _ipl_threadedFd ( int fd )
{
	return jthreadedFileDescriptor( fd);
}

static inline
int _ipl_read ( int fd, void *buf, size_t count )
{
	return read( fd, buf, count);
}

static inline
int _ipl_write ( int fd, void *buf, size_t count )
{
	return write( fd, buf, count);
}
