/*
 * tpconfig.c - generic touch screen config file reader
 *
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * $Id: tpconfig.c,v 1.6 2001/06/05 18:33:16 jsimmons Exp $
 */
#include <stdlib.h>
#define MAX_PATH 128

int
readTsConfig ( ts_config_t* cfg ) {
	FILE* fp;
	int n;
	int val;
	char *c, key[32];
	char buf[MAX_PATH];
	char *cfgFile;

	cfg->xscale   = TS_UNDEF;
	cfg->xoff     = TS_UNDEF;
	cfg->yscale   = TS_UNDEF;
	cfg->yoff     = TS_UNDEF;
	cfg->swap     = TS_UNDEF;
	cfg->rate     = TS_UNDEF;
	cfg->pressure = TS_UNDEF;

	buf[0] = '\0';
	if ( (cfgFile = getenv( "TP_CONFIG")) ){
		strncat( buf, cfgFile, MAX_PATH - 1);
	}
	else {
		strncat( buf, DEFAULT_TP_CONFIG, MAX_PATH -1);
	}

	if ( (fp = fopen( buf, "r")) ) {
		do {
			c = key;
			n = fscanf( fp, "%s %d", (char*)&key, &val);
			if ( n < 0 ) break;
			
			if ( n && key[0] == '#' ){
				while ( ((val = fgetc( fp)) != EOF) && (val != '\n') );
				continue;
			}
			
			if ( n == 2 ){
			    *c |= 0x20;
				switch ( *c ){
				case 'x':
					c++; *c |= 0x20;
					if ( *c == 's' ){
						cfg->xscale = val;
					}
					else if ( *c == 'o' ){
						cfg->xoff = val;
					}
					break;

				case 'y':
					c++; *c |= 0x20;
					if ( *c == 's' ){
						cfg->yscale = val;
					}
					else if ( *c == 'o' ){
						cfg->yoff = val;
					}
					break;

				case 'r':
					cfg->rate = val;
					break;

				case 's':
					cfg->swap = val;
					break;

				case 'p':
					cfg->pressure = val;
					break;

				}
			}
		} while ( (*c == '#') || (n == 2) );
		
		fclose( fp);
		return 1;
	}
	
	return 0;
}
