/*
 * ttykeytab-102-us.h - standard US keyboard char/code bindings
 *
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


#include "vk_constants.h"

#define VK_ 0

typedef struct {
	unsigned char keyChar;
	unsigned char keyCode;
	unsigned char mods;
} ttyMap_t;

ttyMap_t keyTab[] = {
/*   0 (00) */  {   0, VK_  , CTRL },
/*   1 (01) */  { 'a', VK_A , CTRL },
/*   2 (02) */  { 'b', VK_B , CTRL },
/*   3 (03) */  { 'c', VK_C , CTRL },
/*   4 (04) */  { 'd', VK_D , CTRL },
/*   5 (05) */  { 'e', VK_E , CTRL },
/*   6 (06) */  { 'f', VK_F , CTRL },
/*   7 (07) */  { 'g', VK_G , CTRL },
/*   8 (08) */  { 'h', VK_H , CTRL },
/*   9 (09) */  { '\t', VK_TAB , 0 },
/*  10 (0a) */  { '\n', VK_ENTER , 0 },
/*  11 (0b) */  { 'k', VK_K , CTRL },
/*  12 (0c) */  { 'l', VK_L , CTRL },
/*  13 (0d) */  { 'm', VK_M , CTRL },
/*  14 (0e) */  { 'n', VK_N , CTRL },
/*  15 (0f) */  { 'o', VK_O , CTRL },

/*  16 (10) */  { 'p', VK_P , CTRL },
/*  17 (11) */  { 'q', VK_Q , CTRL },
/*  18 (12) */  { 'r', VK_R , CTRL },
/*  19 (13) */  { 's', VK_S , CTRL },
/*  20 (14) */  { 't', VK_T , CTRL },
/*  21 (15) */  { 'u', VK_U , CTRL },
/*  22 (16) */  { 'v', VK_V , CTRL },
/*  23 (17) */  { 'w', VK_W , CTRL },
/*  24 (18) */  { 'x', VK_X , CTRL },
/*  25 (19) */  { 'y', VK_Y , CTRL },
/*  26 (1a) */  { 'z', VK_Z , CTRL },
/*  27 (1b) */  {   0, VK_ESCAPE , 0 },
/*  28 (1c) */  {   0, VK_ , 0 },
/*  29 (1d) */  {   0, VK_ , 0 },
/*  30 (1e) */  {   0, VK_ , 0 },
/*  31 (1f) */  {   0, VK_ , 0 },

/*  32 (20) */  { ' ', VK_SPACE , 0 },
/*  33 (21) */  { '!', VK_ , SHIFT },
/*  34 (22) */  { '"', VK_QUOTE , SHIFT },
/*  35 (23) */  { '#', VK_ , SHIFT },
/*  36 (24) */  { '$', VK_ , SHIFT },
/*  37 (25) */  { '%', VK_ , SHIFT },
/*  38 (26) */  { '&', VK_ , SHIFT },
/*  39 (27) */  { '\'', VK_QUOTE , 0 },
/*  40 (28) */  { '(', VK_9 , SHIFT },
/*  41 (29) */  { ')', VK_0 , SHIFT },
/*  42 (2a) */  { '*', VK_ , SHIFT },
/*  43 (2b) */  { '+', VK_EQUALS , SHIFT },
/*  44 (2c) */  { ',', VK_COMMA , 0 },
/*  45 (2d) */  { '-', VK_ , 0 },
/*  46 (2e) */  { '.', VK_PERIOD , 0 },
/*  47 (2f) */  { '/', VK_SLASH , 0 },

/*  48 (30) */  { '0', VK_0 , 0 },
/*  49 (31) */  { '1', VK_1 , 0 },
/*  50 (32) */  { '2', VK_2 , 0 },
/*  51 (33) */  { '3', VK_3 , 0 },
/*  52 (34) */  { '4', VK_4 , 0 },
/*  53 (35) */  { '5', VK_5 , 0 },
/*  54 (36) */  { '6', VK_6 , 0 },
/*  55 (37) */  { '7', VK_7 , 0 },
/*  56 (38) */  { '8', VK_8 , 0 },
/*  57 (39) */  { '9', VK_9 , 0 },
/*  58 (3a) */  { ':', VK_ , SHIFT },
/*  59 (3b) */  { ';', VK_SEMICOLON , 0 },
/*  60 (3c) */  { '<', VK_COMMA , SHIFT },
/*  61 (3d) */  { '=', VK_EQUALS , 0 },
/*  62 (3e) */  { '>', VK_PERIOD , SHIFT },
/*  63 (3f) */  { '?', VK_ , SHIFT },

/*  64 (40) */  { '@', VK_ , SHIFT },
/*  65 (41) */  { 'A', VK_A, SHIFT },
/*  66 (42) */  { 'B', VK_B, SHIFT },
/*  67 (43) */  { 'C', VK_C, SHIFT },
/*  68 (44) */  { 'D', VK_D, SHIFT },
/*  69 (45) */  { 'E', VK_E, SHIFT },
/*  70 (46) */  { 'F', VK_F, SHIFT },
/*  71 (47) */  { 'G', VK_G, SHIFT },
/*  72 (48) */  { 'H', VK_H, SHIFT },
/*  73 (49) */  { 'I', VK_I, SHIFT },
/*  74 (4a) */  { 'J', VK_J, SHIFT },
/*  75 (4b) */  { 'K', VK_K, SHIFT },
/*  76 (4c) */  { 'L', VK_L, SHIFT },
/*  77 (4d) */  { 'M', VK_M, SHIFT },
/*  78 (4e) */  { 'N', VK_N, SHIFT },
/*  79 (4f) */  { 'O', VK_O, SHIFT },

/*  80 (50) */  { 'P', VK_P, SHIFT },
/*  81 (51) */  { 'Q', VK_Q, SHIFT },
/*  82 (52) */  { 'R', VK_R, SHIFT },
/*  83 (53) */  { 'S', VK_S, SHIFT },
/*  84 (54) */  { 'T', VK_T, SHIFT },
/*  85 (55) */  { 'U', VK_U, SHIFT },
/*  86 (56) */  { 'V', VK_V, SHIFT },
/*  87 (57) */  { 'W', VK_W, SHIFT },
/*  88 (58) */  { 'X', VK_X, SHIFT },
/*  89 (59) */  { 'Y', VK_Y, SHIFT },
/*  90 (5a) */  { 'Z', VK_Z, SHIFT },
/*  91 (5b) */  { '[', VK_OPEN_BRACKET , 0 },
/*  92 (5c) */  { '\\', VK_BACK_SLASH , 0 },
/*  93 (5d) */  { ']', VK_CLOSE_BRACKET , 0 },
/*  94 (5e) */  { '^', VK_ , SHIFT },
/*  95 (5f) */  { '_', VK_ , SHIFT },

/*  96 (60) */  { '`', VK_BACK_QUOTE , 0 },
/*  97 (61) */  { 'a', VK_A, 0 },
/*  98 (62) */  { 'b', VK_B, 0 },
/*  99 (63) */  { 'c', VK_C, 0 },
/* 100 (64) */  { 'd', VK_D, 0 },
/* 101 (65) */  { 'e', VK_E, 0 },
/* 102 (66) */  { 'f', VK_F, 0 },
/* 103 (67) */  { 'g', VK_G, 0 },
/* 104 (68) */  { 'h', VK_H, 0 },
/* 105 (69) */  { 'i', VK_I, 0 },
/* 106 (6a) */  { 'j', VK_J, 0 },
/* 107 (6b) */  { 'k', VK_K, 0 },
/* 108 (6c) */  { 'l', VK_L, 0 },
/* 109 (6d) */  { 'm', VK_M, 0 },
/* 110 (6e) */  { 'n', VK_N, 0 },
/* 111 (6f) */  { 'o', VK_O, 0 },

/* 112 (70) */  { 'p', VK_P, 0 },
/* 113 (71) */  { 'q', VK_Q, 0 },
/* 114 (72) */  { 'r', VK_R, 0 },
/* 115 (73) */  { 's', VK_S, 0 },
/* 116 (74) */  { 't', VK_T, 0 },
/* 117 (75) */  { 'u', VK_U, 0 },
/* 118 (76) */  { 'v', VK_V, 0 },
/* 119 (77) */  { 'w', VK_W, 0 },
/* 120 (78) */  { 'x', VK_X, 0 },
/* 121 (79) */  { 'y', VK_Y, 0 },
/* 122 (7a) */  { 'z', VK_Z, 0 },
/* 123 (7b) */  { '{', VK_OPEN_BRACKET , SHIFT },
/* 124 (7c) */  { '|', VK_ , SHIFT },
/* 125 (7d) */  { '}', VK_CLOSE_BRACKET , SHIFT },
/* 126 (7e) */  { '~', VK_ , SHIFT },
/* 127 (7f) */  {   0, VK_BACK_SPACE , 0 },

/* 128 (80) */  { '', VK_ , 0 },
/* 129 (81) */  { '', VK_ , 0 },
/* 130 (82) */  { '', VK_ , 0 },
/* 131 (83) */  { '', VK_ , 0 },
/* 132 (84) */  { '', VK_ , 0 },
/* 133 (85) */  { '', VK_ , 0 },
/* 134 (86) */  { '', VK_ , 0 },
/* 135 (87) */  { '', VK_ , 0 },
/* 136 (88) */  { '', VK_ , 0 },
/* 137 (89) */  { '', VK_ , 0 },
/* 138 (8a) */  { '', VK_ , 0 },
/* 139 (8b) */  { '', VK_ , 0 },
/* 140 (8c) */  { '', VK_ , 0 },
/* 141 (8d) */  { '', VK_ , 0 },
/* 142 (8e) */  { '', VK_ , 0 },
/* 143 (8f) */  { '', VK_ , 0 },

/* 144 (90) */  { '', VK_ , 0 },
/* 145 (91) */  { '', VK_ , 0 },
/* 146 (92) */  { '', VK_ , 0 },
/* 147 (93) */  { '', VK_ , 0 },
/* 148 (94) */  { '', VK_ , 0 },
/* 149 (95) */  { '', VK_ , 0 },
/* 150 (96) */  { '', VK_ , 0 },
/* 151 (97) */  { '', VK_ , 0 },
/* 152 (98) */  { '', VK_ , 0 },
/* 153 (99) */  { '', VK_ , 0 },
/* 154 (9a) */  { '', VK_ , 0 },
/* 155 (9b) */  { '', VK_ , 0 },
/* 156 (9c) */  { '', VK_ , 0 },
/* 157 (9d) */  { '', VK_ , 0 },
/* 158 (9e) */  { '', VK_ , 0 },
/* 159 (9f) */  { '', VK_ , 0 },

/* 160 (a0) */  { '', VK_ , 0 },
/* 161 (a1) */  { '', VK_ , 0 },
/* 162 (a2) */  { '', VK_ , 0 },
/* 163 (a3) */  { '', VK_ , 0 },
/* 164 (a4) */  { '', VK_ , 0 },
/* 165 (a5) */  { '', VK_ , 0 },
/* 166 (a6) */  { '', VK_ , 0 },
/* 167 (a7) */  { '', VK_ , 0 },
/* 168 (a8) */  { '', VK_ , 0 },
/* 169 (a9) */  { '', VK_ , 0 },
/* 170 (aa) */  { '', VK_ , 0 },
/* 171 (ab) */  { '', VK_ , 0 },
/* 172 (ac) */  { '', VK_ , 0 },
/* 173 (ad) */  { '', VK_ , 0 },
/* 174 (ae) */  { '', VK_ , 0 },
/* 175 (af) */  { '', VK_ , 0 },

/* 176 (b0) */  { '', VK_ , 0 },
/* 177 (b1) */  { '', VK_ , 0 },
/* 178 (b2) */  { '', VK_ , 0 },
/* 179 (b3) */  { '', VK_ , 0 },
/* 180 (b4) */  { '', VK_ , 0 },
/* 181 (b5) */  { '', VK_ , 0 },
/* 182 (b6) */  { '', VK_ , 0 },
/* 183 (b7) */  { '', VK_ , 0 },
/* 184 (b8) */  { '', VK_ , 0 },
/* 185 (b9) */  { '', VK_ , 0 },
/* 186 (ba) */  { '', VK_ , 0 },
/* 187 (bb) */  { '', VK_ , 0 },
/* 188 (bc) */  { '', VK_ , 0 },
/* 189 (bd) */  { '', VK_ , 0 },
/* 190 (be) */  { '', VK_ , 0 },
/* 191 (bf) */  { '', VK_ , 0 },

/* 192 (c0) */  { '', VK_ , 0 },
/* 193 (c1) */  { '', VK_ , 0 },
/* 194 (c2) */  { '', VK_ , 0 },
/* 195 (c3) */  { '', VK_ , 0 },
/* 196 (c4) */  { '', VK_ , 0 },
/* 197 (c5) */  { '', VK_ , 0 },
/* 198 (c6) */  { '', VK_ , 0 },
/* 199 (c7) */  { '', VK_ , 0 },
/* 200 (c8) */  { '', VK_ , 0 },
/* 201 (c9) */  { '', VK_ , 0 },
/* 202 (ca) */  { '', VK_ , 0 },
/* 203 (cb) */  { '', VK_ , 0 },
/* 204 (cc) */  { '', VK_ , 0 },
/* 205 (cd) */  { '', VK_ , 0 },
/* 206 (ce) */  { '', VK_ , 0 },
/* 207 (cf) */  { '', VK_ , 0 },

/* 208 (d0) */  { '', VK_ , 0 },
/* 209 (d1) */  { '', VK_ , 0 },
/* 210 (d2) */  { '', VK_ , 0 },
/* 211 (d3) */  { '', VK_ , 0 },
/* 212 (d4) */  { '', VK_ , 0 },
/* 213 (d5) */  { '', VK_ , 0 },
/* 214 (d6) */  { '', VK_ , 0 },
/* 215 (d7) */  { '', VK_ , 0 },
/* 216 (d8) */  { '', VK_ , 0 },
/* 217 (d9) */  { '', VK_ , 0 },
/* 218 (da) */  { '', VK_ , 0 },
/* 219 (db) */  { '', VK_ , 0 },
/* 220 (dc) */  { '', VK_ , 0 },
/* 221 (dd) */  { '', VK_ , 0 },
/* 222 (de) */  { '', VK_ , 0 },
/* 223 (df) */  { '', VK_ , 0 },

/* 224 (e0) */  { '', VK_ , 0 },
/* 225 (e1) */  { '', VK_ , 0 },
/* 226 (e2) */  { '', VK_ , 0 },
/* 227 (e3) */  { '', VK_ , 0 },
/* 228 (e4) */  { '', VK_ , 0 },
/* 229 (e5) */  { '', VK_ , 0 },
/* 230 (e6) */  { '', VK_ , 0 },
/* 231 (e7) */  { '', VK_ , 0 },
/* 232 (e8) */  { '', VK_ , 0 },
/* 233 (e9) */  { '', VK_ , 0 },
/* 234 (ea) */  { '', VK_ , 0 },
/* 235 (eb) */  { '', VK_ , 0 },
/* 236 (ec) */  { '', VK_ , 0 },
/* 237 (ed) */  { '', VK_ , 0 },
/* 238 (ee) */  { '', VK_ , 0 },
/* 239 (ef) */  { '', VK_ , 0 },

/* 240 (f0) */  { '', VK_ , 0 },
/* 241 (f1) */  { '', VK_ , 0 },
/* 242 (f2) */  { '', VK_ , 0 },
/* 243 (f3) */  { '', VK_ , 0 },
/* 244 (f4) */  { '', VK_ , 0 },
/* 245 (f5) */  { '', VK_ , 0 },
/* 246 (f6) */  { '', VK_ , 0 },
/* 247 (f7) */  { '', VK_ , 0 },
/* 248 (f8) */  { '', VK_ , 0 },
/* 249 (f9) */  { '', VK_ , 0 },
/* 250 (fa) */  { '', VK_ , 0 },
/* 251 (fb) */  { '', VK_ , 0 },
/* 252 (fc) */  { '', VK_ , 0 },
/* 253 (fd) */  { '', VK_ , 0 },
/* 254 (fe) */  { '', VK_ , 0 },
/* 255 (ff) */  {   0, VK_ , 0 }
};
