# FGL based AWT support for standard Java libraries
#
# Copyright (c) 1998
#	Transvirtual Technologies, Inc.  All rights reserved.
#
# See the file "lib-license.terms" for information on usage and redistribution 
# of this file. 

# FGL components
include $(FGLINC)

VPATH+=no-native-wm/fgl

VPATH+=$(fgl_src)
INCLUDES+=$(FGL_INCLUDES)
OBJECT+=$(FGL_OBJECTS)

# IPL components
include $(IPLINC)

VPATH+=$(ipl_src)
INCLUDES+=$(IPL_INCLUDES)
OBJECT+=$(IPL_OBJECTS)


TDIR=no-native-wm/fgl
CDIR=no-native-wm

# files containing exported (native) methods
EXPORTS=$(srcdir)/*.c $(srcdir)/$(CDIR)/*.c $(srcdir)/$(TDIR)/*.c

OBJECT+=\
		$(TDIR)/tlk$(OBJEXT) \
		$(TDIR)/wnd$(OBJEXT) \
		$(TDIR)/evt$(OBJEXT) \
		$(TDIR)/gra$(OBJEXT) \
		$(TDIR)/fnt$(OBJEXT) \
		$(TDIR)/clr$(OBJEXT) \
		$(TDIR)/img$(OBJEXT) \
		$(CDIR)/cbd$(OBJEXT) \
		$(CDIR)/geometry$(OBJEXT) \
		imggif$(OBJEXT)  \
		imgjpeg$(OBJEXT) \
		imgpng$(OBJEXT)  \
		imgtiff$(OBJEXT)  \
		imgxbm$(OBJEXT)  \
		theme$(OBJEXT) 

# FIXME: Don't build ui-independent flash just yet
#		flash$(OBJEXT)		


HDRS=$(TDIR)/toolkit.h \
     $(CDIR)/toolkit-common.h \
     $(TDIR)/grlib.h
	 
EXTDEP=$(FGL_HEADERS) \
	   $(IPL_HEADERS) \
	   $(FGL_OBJECTS) \
	   $(IPL_OBJECTS)

$(TDIR)/tlk$(OBJEXT): $(TDIR)/tlk.c $(HDRS) $(EXTDEP)

$(TDIR)/wnd$(OBJEXT): $(TDIR)/wnd.c $(CDIR)/wnd-common.c $(HDRS) $(EXTDEP)

$(TDIR)/evt$(OBJEXT): $(TDIR)/evt.c $(CDIR)/evt-common.c $(HDRS) $(EXTDEP)

$(TDIR)/gra$(OBJEXT): $(TDIR)/gra.c $(CDIR)/gra-common.c $(HDRS) $(EXTDEP)

$(TDIR)/fnt$(OBJEXT): $(TDIR)/fnt.c $(HDRS) $(EXTDEP)

$(TDIR)/clr$(OBJEXT): $(TDIR)/clr.c $(CDIR)/clr-common.c $(HDRS) $(EXTDEP)

$(TDIR)/img$(OBJEXT): $(TDIR)/img.c $(CDIR)/img-common.c $(HDRS) $(EXTDEP)

$(CDIR)/cbd$(OBJEXT): $(CDIR)/cbd.c $(HDRS) $(EXTDEP)

$(CDIR)/geometry$(OBJEXT): $(CDIR)/geometry.c $(HDRS) $(EXTDEP)

imggif$(OBJEXT): imggif.c $(HDRS) $(EXTDEP)

imgjpeg$(OBJEXT): imgjpeg.c $(HDRS) $(EXTDEP)

imgpng$(OBJEXT): imgpng.c $(HDRS) $(EXTDEP)

imgtiff$(OBJEXT): imgtiff.c $(HDRS) $(EXTDEP)

imgxbm$(OBJEXT): imgxbm.c $(HDRS) $(EXTDEP)

theme$(OBJEXT): theme.c $(HDRS) $(EXTDEP)

# FIXME: Don't build ui-independent flash just yet
#flash$(OBJEXT): flash.c $(HDRS) $(EXTDEP)
