/*
 * arm/linux/jit-md.h
 * ARM Linux JIT configuration information.
 *
 * Copyright (c) 1996, 1997, 1999
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __arm_linux_jit_md_h
#define __arm_linux_jit_md_h

/**
 * Note.  For the moment at least we're trashing the whole damn cache
 * rather than just the bit we need to.  Trashing just the right bit
 * doesn't seem to work reliable (and right now I don't know why until
 * I have time to decipher the kernel source for this stuff).
 */
#define	FLUSH_DCACHE(BEG, END) \
  { \
    /*register unsigned long _beg __asm ("a1") = (unsigned long)(BEG);*/ \
    /*register unsigned long _end __asm ("a2") = (unsigned long)(END);*/ \
    register unsigned long _beg __asm ("a1") = (unsigned long)(0); \
    register unsigned long _end __asm ("a2") = (unsigned long)(0x7FFFFFFF); \
    register unsigned long _flg __asm ("a3") = 0; \
    asm volatile ("swi 0x9f0002 @ sys_cacheflush" \
      : /* no outputs */ \
      : "r" (_beg), "r" (_end), "r" (_flg) \
      : "a1"); \
  }

/**/
/* Include common information. */
/**/
#include "arm/jit.h"

#endif
