/*    
 * arm/linux/md.h
 * Linux arm configuration information.
 *
 * Copyright (c) 1996, 1997
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */
 
#ifndef __arm_linux_md_h
#define __arm_linux_md_h
 
#include "arm/common.h"
#include "arm/threads.h"

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

#include <asm/sigcontext.h>

#define EXCEPTIONPROTO  int sig, int d1, int d2, int d3, struct sigcontext ctx

#undef SP_OFFSET
#undef FP_OFFSET
#define SP_OFFSET               20
#define FP_OFFSET               19

#define	EXCEPTIONFIXRETURN() \
	asm volatile("str %0,[fp, #-4]\n\tstr %1,[fp, #-12]\n\tstr %2,[fp, #-8]" : : "r" (ctx.arm_pc) , "r" (ctx.arm_fp), "r" (ctx.arm_sp));

#define EXCEPTIONPC() \
	(ctx.arm_pc)

/* The Linux implementation of this provides a large amount
 * of information for real-time stuff.  We don't need that and
 * the standard version returns the sigcontext which is all
 * we're interested in.  So just turn this flag off.
 */
#if defined(SA_SIGINFO)
#undef  SA_SIGINFO
#endif

#endif
