/*
 * arm/threadx/md.h
 * Linux ARM configuration information.
 *
 * Copyright (c) 1998
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __arm_threadx_md_h
#define __arm_threadx_md_h

#include "arm/common.h"
#include "arm/threads.h"

/* ThreadX uses it's own threads so we don't need to know the SP_OFFSET */
#undef	SP_OFFSET

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

/*
 * We don't support exceptions yet so this is just a dummy.
 */
#define	EXCEPTIONPROTO	int sig, void* ctx

/* Get the first exception frame from a signal handler - dummy XXX */
#define EXCEPTIONFRAME(f, c)	\
        (f).return_frame = 0;	\
        (f).return_pc = 0;

/* For ThreadX on SmartMove we dont do this */
#undef DOUBLE_WORDS_BIG_ENDIAN

/*
 * Define various function prototype which are missing.
 */
size_t read(int, void*, size_t);
size_t write(int, const void*, size_t);
int open(const char*, int, int);
int close(int);
off_t lseek(int, off_t, int);

/*
 * Define various function prototypes which are missing.
 */
size_t read(int, void*, size_t);
size_t write(int, const void*, size_t);
int open(const char*, int, int);
int close(int);
off_t lseek(int, off_t, int);

#endif
