/*
 * config-mem.h
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __config_mem_h
#define __config_mem_h

#if defined(HAVE_STRING_H)
#include <string.h>
#endif
#if defined(HAVE_MALLOC_H)
#include <malloc.h>
#endif
#if defined(HAVE_ALLOCA_H)
#include <alloca.h>
#endif
#if defined(HAVE_MEMORY_H)
#include <memory.h>
#endif
#if defined(HAVE_MMAP)
#include <sys/mman.h>
#endif

#if defined(SMX)
/* We are actually just interested in xheap, but that requires a lot of other
 * smx specific stuff
 * Make sure we don't have malloc.h included, too (since the xheap macros
 * would scramble it)
 */
#include "xsmx.h"

/* itchy, too - it's defined in malloc.h, but we can't include this because of xheap.h */
void* __cdecl _alloca(size_t);
#define alloca(_n) _alloca(_n)
#pragma intrinsic(_alloca)

#endif

#if !defined(HAVE_MEMCPY)
void bcopy(void*, void*, size_t);
#define	memcpy(_d, _s, _n)	bcopy((_s), (_d), (_n))
#endif

#if !defined(HAVE_GETPAGESIZE)
#define	getpagesize()	8192
#endif

#if !defined(HAVE_ALLOCA)
#define	ALLOCA_GET(S)	gc_malloc_fixed(S)
#define	ALLOCA_FREE(M)	gc_free_fixed(M)
#else
#define	ALLOCA_GET(S)	alloca(S)
#define	ALLOCA_FREE(M)
#endif

#endif
