/*
 * config-net.h
 *
 * Copyright (c) 1996, 1997, 1998
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __config_net_h
#define __config_net_h

/* SMX XNET specific hacks (common header names, but depending on switches)
 * These do not belong here - they should be but into the config-hacks.h
 * file since that's what they are - TIM.
 */
#if defined(SMXNET)
#if !defined(INCLUDE_RTIP)   /* otherwise the XNET socket.h is useless */
#define INCLUDE_RTIP
#endif
#define AT_MOTHERBOARD 1
#include "rtip.h"
#define	SET_ADDRESS(A,V)	(A) = (dword)(V)
#define	GET_ADDRESS(A)		(A)
#endif

#if !defined(SET_ADDRESS)
#define SET_ADDRESS(A,V) 	(A).s_addr = (V)
#endif
#if !defined(GET_ADDRESS)
#define	GET_ADDRESS(A)		(A).s_addr
#endif

#if defined(HAVE_SOCKET_H)
#include <socket.h>
#endif
#if defined(HAVE_SYS_SOCKET_H)
#include <sys/socket.h>
#endif
#if defined(HAVE_NETINET_IN_H)
#include <netinet/in.h>
#endif
#if defined(HAVE_NETDB_H)
#include <netdb.h>
#endif
#if defined(HAVE_NETINET_TCP_H)
#include <netinet/tcp.h>
#endif
#if defined(HAVE_WINSOCK2_H)
#include <winsock2.h>
#endif
#if defined(HAVE_ADNS_H) && defined(HAVE_LIBADNS)
#define ASYNC_DNS       1
#include <adns.h>
typedef void (*adns_callback)(void*, char*, int);
extern adns_callback adns_vec;
extern adns_state adns;
#endif

#endif
