/*
 * i386/lynxos/md.h
 * LynxOS i386 configuration information.
 *
 * Copyright (c) 1996 - 2000
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __ki386_lynxos_md_h
#define __ki386_lynxos_md_h

#include "i386/common.h"
#include "i386/threads.h"

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

#if defined(HAVE_SIGNAL_H)
#include <signal.h>
#endif

#define	EXCEPTIONPROTO							\
	int sig, int code, struct sigcontext* ctx/*, struct fp_context* fctx*/

/*
 * We fixup the exception system by copying the exception pc & fp into
 * the return pc & fp.
 */
//#if (KAFFE_LYNX_VERSION >= 310)

#define EXCEPTIONFIXRETURN()                                            \
	asm volatile("movl %0,4(%%ebp)\n\tmovl %1,(%%ebp)" : : "r" (ctx->sig_pc), "r" (ctx->sig_fp))

//#else

//#define EXCEPTIONFIXRETURN()                                            \
//	asm volatile("movl %0,4(%%ebp)\n\tmovl %1,(%%ebp)" : : "r" (ctx->eip), "r" (ctx->ebp))

//#endif

/* We don't want the realtime information */
#if defined(SA_SIGINFO)
#undef	SA_SIGINFO
#endif

#define CREATE_NULLPOINTER_CHECKS 1

#endif
