/*
 * i386/lynxos/md.h
 * LynxOS i386 configuration information.
 *
 * Copyright (c) 1996 - 2000
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __ki386_lynxos_md_h
#define __ki386_lynxos_md_h

#include "i386/common.h"
#include "i386/threads.h"

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

#if defined(HAVE_SIGNAL_H)
#include <signal.h>
#endif

#define	EXCEPTIONPROTO							\
	int sig, int code, struct sigcontext* ctx, struct fp_context* fctx

/* Get the first exception frame from a signal handler */
#define	EXCEPTIONFRAME(f, c)						\
	(f).return_frame = (void*)(c)->ebp;				\
	(f).return_pc = (void*)(c)->eip + 1

#if 0
/*
 * LynxOS virtual timer seems broken, so turn off preemption.
 */
#define	HAVE_NO_PREEMPTION	1
#endif

/* We don't want the realtime information */
#undef	SA_SIGINFO

/* We don't have any async events (alarms) but we do have
 * async I/O (using select) though we dont support SIGIO
 */
#define	NO_ASYNC_EVENTS		1
#undef	NO_ASYNC_IO
#define	NO_IO_SIGNAL		1

#endif
