/*
 * i386/openbsd2/md.h
 * OpenBSD i386 configuration information.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __i386_openbsd2_md_h
#define __i386_openbsd2_md_h

#include "i386/common.h"
#include "i386/threads.h"

/*
 * Redefine stack pointer offset.
 */
#undef SP_OFFSET
#define SP_OFFSET 2

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

/**/
/* Extra exception handling information. */
/**/

/* Function prototype for signal handlers */
#define EXCEPTIONPROTO							\
        int sig, int code, struct sigcontext* ctx

/* Get the first exception frame from a signal handler */
#define EXCEPTIONFRAME(f, c)						\
        (f).return_frame = (c)->sc_ebp;					\
        (f).return_pc = (c)->sc_eip + 1

#endif
