/* 
 * m68k/coldfire.h
 * m68k Coldfire JIT configuration information.
 *
 * Copyright (c) 1999 
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */
   
#ifndef __m68k_coldfire_h  
#define __m68k_coldfire_h
  
/*
 * We don't need to flush the cache (it's a combined I+D cache).
 */
#undef	FLUSH_DCACHE

/*
 * We don't have long branches so use 16 bits ones.
 */
#define	HAVE_NO_LONG_BRANCHES	1

/*
 * We don't have exc instructions.
 */
#define	HAVE_NO_SWAP_ANY	1

/*
 * We don't have FP support.
 */
#define HAVE_NO_FLOATING_POINT  1

/*
 * We don't support these instructions:
 *	move.m
 *	adda.w
 *	suba.w
 *	exg
 */
#define	HAVE_NO_MOVEM		1
#define	HAVE_NO_ADDAW		1
#define	HAVE_NO_SUBAW		1
#define	HAVE_NO_EXG		1
#define	HAVE_NO_MULINTCONST	1

#endif
