/*
 * m68k/uclinux/md.h
 * uclinux/m68k specific functions.
 *
 * Copyright (c) 1999
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __m68k_uclinux_md_h
#define __m68k_uclinux_md_h

#include "m68k/common.h"
#include "m68k/threads.h"

/*
 * Keep the heap small by allocating in small chunks.
 */
#define	ALLOC_HEAPSIZE	(504*1024)

/*
 * Redefine stack pointer offset.
 */
#undef  SP_OFFSET
#define SP_OFFSET       2

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

/*
 * Define the PATHSEP.
 */
#define	PATHSEP	":"

/*
 * Define various functions needed for JNI.
 */
extern int vfprintf(FILE*, const char*, va_list);
extern void abort(void);
extern void exit(void);

/*
 * We don't have signal handlers yet so use the inline checks.
 * Define the various exception macro to be dummies.
 */

#define	CREATE_NULLPOINTER_CHECKS	1
#define	CREATE_DIVZERO_CHECKS		1

#define	EXCEPTIONPROTO \
	int sig

/* Get the first exception frame from a signal handler */
#define	EXCEPTIONFRAME(F, C) \
	do { \
		(F).return_frame = 0; \
		(F).return_pc = 0; \
	} while (0)

#endif
