/*
 * mips/linux/e115.h
 * Vendor specific configuration.
 *
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __mips_linux_e115_h
#define __mips_linux_e115_h

/* Use soft floats */
#define	HAVE_NO_FLOATING_POINT	1

/* No async events */
#define	NO_ASYNC_EVENTS		1
#define	NO_ASYNC_IO		1
#define	NO_IO_SIGNAL		1

/* No atomic instructions */
#define	HAVE_NO_COMPARE_AND_EXCHANGE	1

/* Don't abort - just exit */
#define	_ABORT			_EXIT

/* Keep thread stacks small */
#define	THREADSTACKSIZE		(32*1024)

/*
 * We don't include these modules.
 */
#undef	HAVE_MODULE_SERIALIZATION
#undef	HAVE_MODULE_RMI
#undef	HAVE_MODULE_COLLECTIONS
//#undef	HAVE_MODULE_NET_DATAGRAM

/* We can't handle getuid() yet */
#undef	HAVE_GETUID

#endif
