/*
 * mips/linux/md.h
 * Linux MIPS configuration information.
 *
 * Copyright (c) 1996, 1997, 1998, 1999
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __mips_linux_md_h
#define __mips_linux_md_h

/*
 * For the Vtech Helio.
 */
#if defined(TARGET_DEVICE_HELIO)
#include "mips/linux/helio.h"
#endif

/*
 * For the Casio Cassiopeia E115.
 */
#if defined(TARGET_DEVICE_E115)
#include "mips/linux/e115.h"
#endif
#if defined(TARGET_DEVICE_AGENDA)
#include "mips/linux/agenda.h"
#endif

#if !defined(_MIPS_ISA)
#define	_MIPS_ISA		_MIPS_ISA_MIPS3
#endif
#if !defined(_MIPS_SIM)
#define	_MIPS_SIM		_MIPS_SIM_ABI32
#endif
#if !defined(_MIPS_SZINT)
#define	_MIPS_SZINT		32
#endif
#if !defined(_MIPS_SZLONG)
#define	_MIPS_SZLONG		32
#endif
#if !defined(_MIPS_SZPTR)
#define	_MIPS_SZPTR		32
#endif

#include <asm/sgidefs.h>

#include "mips/common.h"
#include "mips/threads.h"

#undef  SP_OFFSET
#define SP_OFFSET       1
#undef  FP_OFFSET
#define FP_OFFSET       10

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

/**/
/* Signal handling */
/**/
#include <signal.h>
#if defined(HAVE_SIGCONTEXT_H)
#include <sigcontext.h>
#endif

/* The Linux implementation of this provides a large amount
 * of information for real-time stuff.  We don't need that and
 * the standard version returns the sigcontext which is all
 * we're interested in.  So just turn this flag off.
 */
#if defined(SA_SIGINFO)
#undef  SA_SIGINFO
#endif

#include "mips/fixupinline.c"

#if !defined(MIPS_FP)
#define	MIPS_FP	30

/* Define the entry into a signal handler */
#define EXCEPTIONPROTO \
	int sig, int c1, int c2, int c3, int c4, int c5, int c6, int c7, \
		struct sigcontext ctx

#define	EXCEPTIONFIXRETURN() \
	__mipsFixup(ctx.sc_pc, ctx.sc_regs[MIPS_FP])

#define EXCEPTIONPC() \
        (ctx.sc_pc)

#endif

#endif
