/*
 * sparc/solaris2/md.h
 * Solaris2 sparc configuration information.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __sparc_solaris2_md_h
#define __sparc_solaris2_md_h

#include "sparc/common.h"
#include "sparc/threads.h"

#if defined(TRANSLATOR)
#include "jit-md.h"
#endif

/**/
/* Extra exception handling information. */
/**/
#include <siginfo.h>
#include <ucontext.h>

/* Function prototype for signal handlers */
#define EXCEPTIONPROTO							\
	int sig, siginfo_t* sip, ucontext_t* ctx

/* Get the first exception frame from a signal handler */
#define EXCEPTIONFRAME(F, C)						\
	(F).return_frame = (void*)(C)->uc_mcontext.gregs[REG_SP];	\
	(F).return_pc = (void*)(C)->uc_mcontext.gregs[REG_PC]

/* Get the first exception frame from a signal handler */
#define EXCEPTIONFIXRETURN() \
	assert( 0 ); \
	asm( "mov %0, %%fp \n\
	mov %1, %%i7 \n\
	" : : "r" (ctx->uc_mcontext.gregs[REG_SP]), "r" (ctx->uc_mcontext.gregs[REG_PC]) )

#endif
