/*
 * files.h
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * $tvt: files.h,v 1.5 2001/07/09 22:43:00 samc Exp $
 */

#ifndef __files_h
#define __files_h

#include "config.h"
#include "config-std.h"
#include "config-io.h"
#include <jtypes.h>
#if defined(HAVE_ERRNO_H)
#include <errno.h>
#endif

#if defined(HAVE_STRERROR)
extern char* strerror(int);
#define	SYS_ERROR	strerror(errno)
#elif defined(HAVE_SYS_ERRLIST)
extern char* sys_errlist[];
#define	SYS_ERROR	sys_errlist[errno]
#else
#define	SYS_ERROR	"unknown"
#endif

/* Define access() flags if not already defined */
#if !defined(W_OK)
#define	W_OK		2
#define	R_OK		4
#endif

/* Define lseek() flags if not already defined */
#if !defined(SEEK_SET)
#define	SEEK_SET	0
#endif
#if !defined(SEEK_CUR)
#define	SEEK_CUR	1
#endif
#if !defined(SEEK_END)
#define	SEEK_END	2
#endif

/* If we don't have O_BINARY, define it to be 0 */
#if !defined(O_BINARY)
#define	O_BINARY	0
#endif

#endif
