/*
 * VM specific locking macros.
 *
 * Copyright (c) 2000
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * $tvt: jlocks.h,v 1.2 2001/07/09 22:43:00 samc Exp $
 */

#ifndef __jlocks_h
#define __jlocks_h


/* CAUTION - make sure this is consistent with the kaffevm/locks.h
 * definition
 *
 * EXTREME CAUTION - make sure you don't execute unblocked code
 * which might harm the locking consistency
 */

#if !defined (UNBLOCK_EXECUTE)

#include "java_lang_Object.h"

struct _iLock;

JNIEXPORT void* _releaseLock(struct _iLock**);
JNIEXPORT void 	_acquireLock(struct _iLock**, void*);


#define	UNBLOCK_EXECUTE(_env,_obj,_stmts) {                                 \
           void* st = _releaseLock( &((Hjava_lang_Object*)(_obj))->lock);   \
		   _stmts;                                                          \
		   _acquireLock( &((Hjava_lang_Object*)(_obj))->lock, st);          \
	}

#endif /* !defined (UNBLOCK_EXECUTE) */

#endif /* __jlocks_h */
