/*
 * Redirect the malloc/free functions
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 *
 * $tvt: jmalloc.h,v 1.12 2001/08/16 18:49:51 samc Exp $
 */

#ifndef __jmalloc_h
#define __jmalloc_h

/* do not include this if we are building kaffeh. */
#if !defined(KAFFEH) 

#include <jconfig.h>

#if defined(__cplusplus)
extern "C" {
#endif

void*	__kaffe_malloc(int);
void*	__kaffe_realloc(void*, int);
void	__kaffe_free(void*);

#if defined(__cplusplus)
}
#endif

/*
 * If the system has a malloc.h include it before we redefine
 */
#if defined(HAVE_MALLOC_H)
/* make sure we don't screw up the calloc definition in a subseq. included malloc.h */
/* (but this only helps if config.h is included) */
#include "stdlib.h" /* fix for glibc 2.1.91 */
#include "malloc.h"
#endif /* HAVE_MALLOC_H */

#undef malloc
#undef calloc
#undef realloc
#undef free

#define	malloc(A)	__kaffe_malloc(A)
#define	calloc(A, B)	__kaffe_malloc((A)*(B))
#define	realloc(A, B)	__kaffe_realloc(A,B)
#define	free(A)		__kaffe_free(A)

#endif /* ! KAFFEH */

#endif /* __jmalloc_h */
