/*
 * Define the Java-to-system call interface.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * $tvt: jsyscall.h,v 1.13 2001/08/01 23:40:33 samc Exp $
 */

#ifndef __jsyscall_h
#define __jsyscall_h

#include <jfilesystem.h>
#include <jnetwork.h>

#if !defined(FD_SET)
/* if FD_SET isn't defined, we most probably don't have fd_set, too, but we need a default */
typedef int fd_set;
#endif


typedef struct KernelCallInterface {

	int	(*_fixfd)(int);
	int	(*_select)(int, fd_set*, fd_set*, fd_set*, struct timeval*);
	int	(*_waitpid)(int, int*, int);
	void*	(*_pagealloc)(int);
	void	(*_pagefree)(void*);
	int	(*_stdinread)(void);
	void	(*_stdoutwrite)(int);
	void	(*_stderrwrite)(int);
	jlong	(*_time)(void);
	int	(*_stdinavailable)(void);

} KernelCallInterface;

JNIEXPORT KernelCallInterface Kaffe_KernelCallInterface;

#if !defined(NOUNIXPROTOTYPES)
/*
 * Define some 'UNIX' like macros to make things simpler.
 */

#define	select(A,B,C,D,E) \
			(*Kaffe_KernelCallInterface._select)(A,B,C,D,E)
#define	waitpid(A,B,C)	(*Kaffe_KernelCallInterface._waitpid)(A,B,C)
#endif

#define fixfd(A)	(*Kaffe_KernelCallInterface._fixfd)(A)
#define pagealloc(A)	(*Kaffe_KernelCallInterface._pagealloc)(A)
#define pagefree(A)	(*Kaffe_KernelCallInterface._pagefree)(A)
#define	currtime()	(*Kaffe_KernelCallInterface._time)()


#endif
