/*
 * Native method support.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * $tvt: native.h,v 1.9 2001/08/01 23:40:33 samc Exp $
 */

#ifndef __native_h
#define __native_h

#undef	__NORETURN__
#if defined(__GNUC__)
#define	__NORETURN__	__attribute__((noreturn))
#else
#define	__NORETURN__
#endif

#include <jtypes.h>
#include <jmalloc.h>

struct _methods;
struct Hjava_lang_Class;
struct _strconst;

#if !defined(__DEFINED_METHOD)
#define	__DEFINED_METHOD
typedef struct _methods Method;
#endif
#if !defined(__DEFINED_UTF8CONST)
#define	__DEFINED_UTF8CONST
typedef struct _strconst Utf8Const;
#endif
#if !defined(__DEFINED_CLASS)
#define	__DEFINED_CLASS
typedef struct Hjava_lang_Class Hjava_lang_Class;
#endif

#include <java_lang_Object.h>

/* Build an object handle */
#define	HandleTo(class)					\
	typedef struct H##class {			\
		Hjava_lang_Object base;			\
		struct Class##class data[1];		\
	} H##class

/* Turn a handle into the real thing */
#define	unhand(o)	((o)->data)
#define	unhand_array(o)	((o)->data)

/* Include array types */
#include "Arrays.h"

/* Get the strings */
#include <java_lang_String.h>

/* Some internal machine object conversions to "standard" types. */
typedef	Hjava_lang_Class	HClass;
typedef	Hjava_lang_Object	HObject;
typedef	Hjava_lang_String	HString;

/*
 * Function used for Kaffe Native Interface (KNI).
 */
JNIEXPORT jvalue	JNICALL do_execute_java_method(void*, char*, char*, Method*, int, ...);
JNIEXPORT jvalue	JNICALL do_execute_java_class_method(char*, char*, char*, ...);
JNIEXPORT HObject*	JNICALL execute_java_constructor(char*, HClass*, char*, ...);

JNIEXPORT char*	JNICALL javaString2CString(HString*, char*, int);
JNIEXPORT char*	JNICALL makeCString(HString*);
JNIEXPORT HString*	JNICALL makeJavaString(char*, int);
JNIEXPORT int	JNICALL equalUtf8JavaStrings(Utf8Const*, HString*);
JNIEXPORT Utf8Const* JNICALL makeUtf8ConstFixed(char*, int);

JNIEXPORT void	JNICALL SignalError(char*, char*);

JNIEXPORT HObject*	JNICALL AllocObject(char*);
JNIEXPORT HObject*	JNICALL AllocArray(int, int);
JNIEXPORT HObject*	JNICALL AllocObjectArray(int, char*);

JNIEXPORT int	JNICALL addNativeMethod(char*, void*);

JNIEXPORT void	JNICALL classname2pathname(char*, char*);

/*
 * Support for new desktop stuff.
 */
#define	stringC2Java(S)		makeJavaString((S), -1)
#define	utf8ConstNew(S,L)	makeUtf8ConstFixed(S,L)
#define	utf8ConstEqual(A,B)	equalUtf8Consts(A,B)
#define	utf8Const2Java(S)	Utf8Const2JavaString(S)
#define	KMALLOC(S)		gc_malloc_fixed(S)
#define	KFREE(M)		gc_free_fixed(M)

#endif /* __native_h */
