/*
 * baseClasses.h
 * Handle base classes.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __baseclasses_h
#define __baseclasses_h

#include "objects.h"
#include "native.h"
#include "java_lang_String.h"
#include "java_lang_Throwable.h"

void initBaseClasses(void);

struct Hjava_lang_Class;
struct _methods;

JNIEXPORT struct Hjava_lang_Class*	ClassClass;
JNIEXPORT struct Hjava_lang_Class*	ObjectClass;
JNIEXPORT struct Hjava_lang_Class*	StringClass;
JNIEXPORT struct Hjava_lang_Class*	SerialClass;
JNIEXPORT struct Hjava_lang_Class*	CloneClass;
JNIEXPORT struct Hjava_lang_Class*	ThreadClass;
JNIEXPORT struct Hjava_lang_Class*	ThreadGroupClass;
JNIEXPORT struct Hjava_lang_Class*	ClassLoaderClass;
JNIEXPORT struct Hjava_lang_Class*	PrintWriterClass;

JNIEXPORT struct Hjava_lang_Class*	ReferenceClass;

JNIEXPORT struct Hjava_lang_Class*	javaLangVoidClass;
JNIEXPORT struct Hjava_lang_Class*	javaLangBooleanClass;
JNIEXPORT struct Hjava_lang_Class*	javaLangByteClass;
JNIEXPORT struct Hjava_lang_Class*	javaLangCharacterClass;
JNIEXPORT struct Hjava_lang_Class*	javaLangShortClass;
JNIEXPORT struct Hjava_lang_Class*	javaLangIntegerClass;
JNIEXPORT struct Hjava_lang_Class*	javaLangLongClass;
JNIEXPORT struct Hjava_lang_Class*	javaLangFloatClass;
JNIEXPORT struct Hjava_lang_Class*	javaLangDoubleClass;

JNIEXPORT struct Hjava_lang_Class*	ThrowableClass;
JNIEXPORT struct Hjava_lang_Class*	javaLangArrayIndexOutOfBoundsException;
JNIEXPORT struct Hjava_lang_Class*	OOMClass;
JNIEXPORT struct Hjava_lang_Class*	SOClass;

JNIEXPORT struct Hjava_lang_Class*	SoftcallClass;

JNIEXPORT struct Hjava_lang_ClassLoader	systemClassLoader;

JNIEXPORT struct _methods*		loadClassMethod;
JNIEXPORT struct _methods*		printlnMethod;
JNIEXPORT struct _methods*		flushMethod;
JNIEXPORT struct _methods*		addThreadMethod;
JNIEXPORT struct _methods*		printStackTraceMethod;

#endif
