/*
 * classpath.h
 * Define information about the classpath
 *
 * Copyright (c) 1998
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __classpath_h
#define __classpath_h

#define	CP_INVALID	0
#define	CP_ZIPFILE	1
#define	CP_DIR		2
#define	CP_SOFILE	3

#include "config.h"
struct _jarFile;

typedef struct classpathElement {
	int	type;
	char*	path;
	union {
		struct _jarFile* jar;
	} u;
	struct classpathElement* next;
} classpathElement;

JNIEXPORT classpathElement* classpath;
JNIEXPORT char* realClassPath;
JNIEXPORT char* realKaffeHome;

/*
 * Interface to the classpath system.
 */
typedef struct ClasspathInterface {

	void	(*init)(void);
	int	(*append)(char*);
	int	(*prepend)(char*);
	int	(*remove)(char*);

} ClasspathInterface;

JNIEXPORT ClasspathInterface Kaffe_ClasspathInterface;

#endif
