/*
 * dispatch.h
 * Java virtual machine interpreter dispatch table.
 *
 * Copyright (c) 1996-1999
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

static const void* insn_dispatch[] = {

	&&insn_NOP,
	&&insn_ACONST_NULL,
	&&insn_ICONST_M1,
	&&insn_ICONST_0,
	&&insn_ICONST_1,
	&&insn_ICONST_2,
	&&insn_ICONST_3,
	&&insn_ICONST_4,
	&&insn_ICONST_5,
	&&insn_LCONST_0,
	&&insn_LCONST_1,
	&&insn_FCONST_0,
	&&insn_FCONST_1,
	&&insn_FCONST_2,
	&&insn_DCONST_0,
	&&insn_DCONST_1,
	&&insn_BIPUSH,
	&&insn_SIPUSH,
	&&insn_LDC1,
	&&insn_LDC2,
	&&insn_LDC2W,
	&&insn_ILOAD,
	&&insn_LLOAD,
	&&insn_FLOAD,
	&&insn_DLOAD,
	&&insn_ALOAD,
	&&insn_ILOAD_0,
	&&insn_ILOAD_1,
	&&insn_ILOAD_2,
	&&insn_ILOAD_3,
	&&insn_LLOAD_0,
	&&insn_LLOAD_1,
	&&insn_LLOAD_2,
	&&insn_LLOAD_3,
	&&insn_FLOAD_0,
	&&insn_FLOAD_1,
	&&insn_FLOAD_2,
	&&insn_FLOAD_3,
	&&insn_DLOAD_0,
	&&insn_DLOAD_1,
	&&insn_DLOAD_2,
	&&insn_DLOAD_3,
	&&insn_ALOAD_0,
	&&insn_ALOAD_1,
	&&insn_ALOAD_2,
	&&insn_ALOAD_3,
	&&insn_IALOAD,
	&&insn_LALOAD,
	&&insn_FALOAD,
	&&insn_DALOAD,
	&&insn_AALOAD,
	&&insn_BALOAD,
	&&insn_CALOAD,
	&&insn_SALOAD,
	&&insn_ISTORE,
	&&insn_LSTORE,
	&&insn_FSTORE,
	&&insn_DSTORE,
	&&insn_ASTORE,
	&&insn_ISTORE_0,
	&&insn_ISTORE_1,
	&&insn_ISTORE_2,
	&&insn_ISTORE_3,
	&&insn_LSTORE_0,
	&&insn_LSTORE_1,
	&&insn_LSTORE_2,
	&&insn_LSTORE_3,
	&&insn_FSTORE_0,
	&&insn_FSTORE_1,
	&&insn_FSTORE_2,
	&&insn_FSTORE_3,
	&&insn_DSTORE_0,
	&&insn_DSTORE_1,
	&&insn_DSTORE_2,
	&&insn_DSTORE_3,
	&&insn_ASTORE_0,
	&&insn_ASTORE_1,
	&&insn_ASTORE_2,
	&&insn_ASTORE_3,
	&&insn_IASTORE,
	&&insn_LASTORE,
	&&insn_FASTORE,
	&&insn_DASTORE,
	&&insn_AASTORE,
	&&insn_BASTORE,
	&&insn_CASTORE,
	&&insn_SASTORE,
	&&insn_POP,
	&&insn_POP2,
	&&insn_DUP,
	&&insn_DUP_X1,
	&&insn_DUP_X2,
	&&insn_DUP2,
	&&insn_DUP2_X1,
	&&insn_DUP2_X2,
	&&insn_SWAP,
	&&insn_IADD,
	&&insn_LADD,
	&&insn_FADD,
	&&insn_DADD,
	&&insn_ISUB,
	&&insn_LSUB,
	&&insn_FSUB,
	&&insn_DSUB,
	&&insn_IMUL,
	&&insn_LMUL,
	&&insn_FMUL,
	&&insn_DMUL,
	&&insn_IDIV,
	&&insn_LDIV,
	&&insn_FDIV,
	&&insn_DDIV,
	&&insn_IREM,
	&&insn_LREM,
	&&insn_FREM,
	&&insn_DREM,
	&&insn_INEG,
	&&insn_LNEG,
	&&insn_FNEG,
	&&insn_DNEG,
	&&insn_ISHL,
	&&insn_LSHL,
	&&insn_ISHR,
	&&insn_LSHR,
	&&insn_IUSHR,
	&&insn_LUSHR,
	&&insn_IAND,
	&&insn_LAND,
	&&insn_IOR,
	&&insn_LOR,
	&&insn_IXOR,
	&&insn_LXOR,
	&&insn_IINC,
	&&insn_I2L,
	&&insn_I2F,
	&&insn_I2D,
	&&insn_L2I,
	&&insn_L2F,
	&&insn_L2D,
	&&insn_F2I,
	&&insn_F2L,
	&&insn_F2D,
	&&insn_D2I,
	&&insn_D2L,
	&&insn_D2F,
	&&insn_INT2BYTE,
	&&insn_INT2CHAR,
	&&insn_INT2SHORT,
	&&insn_LCMP,
	&&insn_FCMPL,
	&&insn_FCMPG,
	&&insn_DCMPL,
	&&insn_DCMPG,
	&&insn_IFEQ,
	&&insn_IFNE,
	&&insn_IFLT,
	&&insn_IFGE,
	&&insn_IFGT,
	&&insn_IFLE,
	&&insn_IF_ICMPEQ,
	&&insn_IF_ICMPNE,
	&&insn_IF_ICMPLT,
	&&insn_IF_ICMPGE,
	&&insn_IF_ICMPGT,
	&&insn_IF_ICMPLE,
	&&insn_IF_ACMPEQ,
	&&insn_IF_ACMPNE,
	&&insn_GOTO,
	&&insn_JSR,
	&&insn_RET,
	&&insn_TABLESWITCH,
	&&insn_LOOKUPSWITCH,
	&&insn_IRETURN,
	&&insn_LRETURN,
	&&insn_FRETURN,
	&&insn_DRETURN,
	&&insn_ARETURN,
	&&insn_RETURN,
	&&insn_GETSTATIC,
	&&insn_PUTSTATIC,
	&&insn_GETFIELD,
	&&insn_PUTFIELD,
	&&insn_INVOKEVIRTUAL,
	&&insn_INVOKESPECIAL,
	&&insn_INVOKESTATIC,
	&&insn_INVOKEINTERFACE,
	&&insn_default,
	&&insn_NEW,
	&&insn_NEWARRAY,
	&&insn_ANEWARRAY,
	&&insn_ARRAYLENGTH,
	&&insn_ATHROW,
	&&insn_CHECKCAST,
	&&insn_INSTANCEOF,
	&&insn_MONITORENTER,
	&&insn_MONITOREXIT,
	&&insn_WIDE,
	&&insn_MULTIANEWARRAY,
	&&insn_IFNULL,
	&&insn_IFNONNULL,
	&&insn_GOTO_W,
	&&insn_JSR_W,
	&&insn_BREAKPOINT,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,
	&&insn_default,

};
