/* code.h
 * Define a code module.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __code_h
#define __code_h

#include "md.h"

union _attribute_info;
struct _jexception;

typedef struct bytecodeInfo {
	methodTrampoline	trampoline;
	u2			stacksz;
	u2			localsz;
        uint16                  codelen;
        uint8                   code[1];
} bytecodeInfo;

typedef struct _lineNumberEntry {
	uint16			line_nr;
	int16			pc_offset;
} lineNumberEntry;

typedef struct _lineNumbers {
	uint32			length;
	lineNumberEntry		entry[1];
} lineNumbers;

typedef struct _localVariableEntry {
	int16			start_pc;
	int16			length;
	int16			idx;
        char*			name;
        char*			type;
} localVariableEntry;

typedef struct _localVariables {
	uint32			length;
	localVariableEntry	entry[1];
} localVariables;

struct _methods;
struct _classFile;
struct Hjava_lang_Class;

void	addCode(struct _methods*, struct Hjava_lang_Class*, uint32, struct _classFile*);
void	addLineNumbers(struct _methods*, uint32, struct _classFile*);
void	addLocalVariables(struct _methods*, struct Hjava_lang_Class*, uint32, struct _classFile*);
void	addDeclaredExceptions(struct _methods*, uint32, struct _classFile*);

#endif
