/*
 * Define the interface to the execution engines.
 *
 * Copyright (c) 1998
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * $tvt: engine.h,v 1.23 2001/11/10 04:12:16 samc Exp $
 */

#ifndef __engine_h
#define __engine_h

struct _methods;
struct _stackTraceInfo;
struct _stackFrame;
struct _callMethodInfo;
struct Hjava_lang_Object;
struct Hjava_lang_Class;
struct Hjava_lang_ClassLoader;

/*
 * An engine is expected to dump its stack information in the
 * following form.
 */
typedef struct _stackTraceInfo {
        uintp   pc;
        Method* meth;
	struct Hjava_lang_Class* clazz;
	void*	object;
        uintp   arg0;
	void*	rframe;
} stackTraceInfo;

#define ENDOFTRACE	((Method*)1)
#define UNKNOWN_METHOD	((Method*)2)

struct _stackFrame;
struct Hjava_lang_Throwable;

JNIEXPORT stackTraceInfo* JNICALL buildStackTrace(void);
JNIEXPORT stackTraceInfo* JNICALL buildStackTraceGC(void);
JNIEXPORT stackTraceInfo* JNICALL buildStackTraceFrom(void*, int);
JNIEXPORT void JNICALL freeStackTrace(stackTraceInfo*);
JNIEXPORT void JNICALL printStackTrace(struct Hjava_lang_Throwable*, struct Hjava_lang_Object*, int);
JNIEXPORT int JNICALL makeMethodActive(Method*, struct Hjava_lang_Class*, void*, void*);
JNIEXPORT void JNICALL makeMethodInactive(Method*);
JNIEXPORT void JNICALL dumpActiveMethods(struct Hjava_lang_Object* printstream, struct Hjava_lang_ClassLoader* loader);
JNIEXPORT bool JNICALL findFrameMethod(struct _stackTraceInfo*);

/*
 * Define the interface between the runtime and the execution engine.
 */
JNIEXPORT void Kaffe_EngineInterface_init(void);
JNIEXPORT char* Kaffe_EngineInterface_getName(void);
JNIEXPORT char* Kaffe_EngineInterface_getVersion(void);
JNIEXPORT void* Kaffe_EngineInterface_setupTrampoline(Method*, struct Hjava_lang_Class*);
JNIEXPORT void Kaffe_EngineInterface_processExceptionMethod(stackTraceInfo*);
JNIEXPORT void Kaffe_EngineInterface_callInterEngine(struct _callMethodInfo*);
JNIEXPORT int Kaffe_EngineInterface_setupJNIcall(Method*, struct Hjava_lang_Class*, void*);
JNIEXPORT void Kaffe_EngineInterface_callExceptionHandler(Method*, uintp, stackTraceInfo*);

#endif
