/*
 * exception.h
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __exception_h
#define __exception_h

#include "config.h"
#include "config-setjmp.h"

struct _exceptionFrame;
struct Hjava_lang_Class;
struct Hjava_lang_Object;
struct Hjava_lang_Throwable;
struct _methods;
struct _stackTraceInfo;
struct _stackFrame;
struct _strconst;

typedef struct _jexceptionEntry {
	uintp				start_pc;
	uintp				end_pc;
	uintp				handler_pc;
	char*				catch;
} jexceptionEntry;

#define	MAKE_CATCH(C,I)			((I) == 0 ? 0 : makeReplaceUtf8Const(WORD2UTF(CLASS_CONSTANTS(C)->data[I])->data, -1, '/', '.'))

typedef struct _declexception {
	uint16				length;
	constIndex			entry[1];
} declexception;

typedef struct _vmException {
	struct _vmException*		prev;
	jmp_buf				jbuf;
	struct _methods*		meth;
	u4				pc;
	struct Hjava_lang_Object*	mobj;
	void*				frame;
} vmException;

JNIEXPORT void JNICALL dispatchException(void);
JNIEXPORT void JNICALL postException(char*, char*);
JNIEXPORT void JNICALL postOutOfMemory(void);
JNIEXPORT void JNICALL postExceptionInException(char*);
JNIEXPORT void JNICALL throwPostedException(void);
JNIEXPORT void JNICALL postAndThrowException(char*, char*);
JNIEXPORT void JNICALL postAndThrowOutOfMemory(void);
JNIEXPORT void JNICALL postExternalException(struct Hjava_lang_Throwable*);
JNIEXPORT void JNICALL postAndThrowExternalException(struct Hjava_lang_Throwable*);
JNIEXPORT void JNICALL clearPostedException(void);
JNIEXPORT int JNICALL postedExceptionIs(char*);
JNIEXPORT struct Hjava_lang_Throwable* JNICALL getPostedException(void);
JNIEXPORT void JNICALL unimp(char*);

#endif
