/*
 * fp.h
 *
 * Floating point routines
 *
 * Copyright (c) 1999
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __fp_h
#define __fp_h

#include "soft.h"

/*
 * Bit patterns according to IEEE 754.
 */

#define	DSIGNBIT	(((uint64)1)<<63)
#define	DEXPMASK	(((uint64)0x7ff00000)<<32)
#define	DMANMASK	((((uint64)0x000fffff)<<32)|((uint64)0xffffffff))

#define	FSIGNBIT	0x80000000
#define	FEXPMASK	0x7f800000
#define	FMANMASK	0x007fffff

#define	DISNAN(b)	(((b) & DEXPMASK) == DEXPMASK && ((b) & DMANMASK) != 0)
#define FISNAN(b)	(((b) & FEXPMASK) == FEXPMASK && ((b) & FMANMASK) != 0)

#define	DISPOS(b)	(((b) & DSIGNBIT) == 0)
#define	FISPOS(b)	(((b) & FSIGNBIT) == 0)

JNIEXPORT jlong JNICALL doubleToLong(jdouble);
JNIEXPORT jdouble JNICALL longToDouble(jlong);
JNIEXPORT jint JNICALL floatToInt(jfloat);
JNIEXPORT jfloat JNICALL intToFloat(jint);

#endif
