/*
 * jdebugdef.h - this is the (variable) jdebug configuration header
 * 
 * NOTE: this is automatically included from jdebug.h
 * 
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */



/*********************************************************************
 * This is the list of debug switches which can be specified in
 * the environment var DEBUG. Don't forget to add the corresponding
 * checks to "dbg_init()"
 
 
 06/13/2000 Philippe added DBG_DEFINE( vm_jit_code); for jitted code printing
                     Must be separate from  vm_jit_translate to avoid clogging info
		     
 08-08-2000 Philippe added vm_thread_deadlock_detect to separate deadlock detect from 
            vm_thread causde the latter may destroy deadlocks situations cause it prints a lot
	    of stuff 
	    
	    Can still use them both at once
	    
	    Use vm_thread to be able to send aync SIG_DUMP
	    Use vm_thread_deadlock_detect to detect deadlocks
 
 */
 
 

DBG_BEGIN_DEFINE_TOPICS

DBG_DEFINE( awt);
DBG_DEFINE( awt_evt);
DBG_DEFINE( awt_wnd);
DBG_DEFINE( awt_clr);
DBG_DEFINE( awt_gra);
DBG_DEFINE( awt_img);
DBG_DEFINE( awt_fnt);
DBG_DEFINE( awt_tlk);
DBG_DEFINE( awt_mem);
DBG_DEFINE( awt_fla);
DBG_DEFINE( awt_plg);

DBG_DEFINE( vm);
DBG_DEFINE( vm_lib);
DBG_DEFINE( vm_jit);
DBG_DEFINE( vm_jit_translate);
DBG_DEFINE( vm_jit_code);     
DBG_DEFINE( vm_code);

DBG_DEFINE( vm_thread);
DBG_DEFINE( vm_thread_sig);
DBG_DEFINE( vm_thread_deadlock_detect);


DBG_DEFINE( vm_lookup);
DBG_DEFINE( vm_class);
DBG_DEFINE( vm_class_load);
DBG_DEFINE( vm_mem);
DBG_DEFINE( vm_lock);
DBG_DEFINE( vm_verify);
DBG_DEFINE( vm_exception);
DBG_DEFINE( vm_jar);

DBG_DEFINE( vm_trace_new_array);
DBG_DEFINE( vm_trace_new_object);
DBG_DEFINE( vm_trace_new_object_stack);
DBG_DEFINE( vm_trace_gcfree_object);
DBG_DEFINE( vm_trace_alloc);
DBG_DEFINE( vm_trace_gcfree);
DBG_DEFINE( vm_trace_small_block_gc);

DBG_END_DEFINE_TOPICS

/*********************************************************************
 * This is the debug setup func, which is called via the
 * DBG_INIT() macro (just from the module that defines DEBUG_MAIN).
 * It can contain any code you want, esp if you want to setup your
 * own output destination (it has to set a file descriptor _dbg_fd)
 */

#if defined(DEBUG_SETUP)

void
dbg_setup()
{
}

/*
 * use this to close a non-standard (stderr) debug output file descriptor
 */
void
dbg_finish()
{
}

#endif /* DEBUG_SETUP */
