/* slots.c
 * Slots.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include "gtypes.h"
#include "slots.h"
#include "md.h"
#include "registers.h"
#include "gc.h"

int maxslot;
SlotInfo* basicslots;
SlotInfo* slotinfo;
SlotInfo* localinfo;
SlotInfo* tempinfo;
SlotInfo stack_limit[1];	/* Used to represent the stack limit */

extern int maxLocal;

/*
 * Initiate slots.
 */
void
initSlots(int islots)
{
	int i;
	static int lastnrslots = 0;
	int nrslots = islots;

	/* Allocate extra slots for temps */
	nrslots += MAXTEMPS;

	/* Make sure we have enough slots space */
	if (nrslots > lastnrslots) {
		basicslots = gc_realloc(basicslots, nrslots * sizeof(SlotInfo), GC_ALLOC_ENGINE);
		lastnrslots = nrslots;
	}
	/* Set 'maxslot' to the maximum slot usable (excluding returns) */
	maxslot = nrslots;

        /* Free all slots */
        for (i = 0; i < nrslots; i++) {
		basicslots[i].regno = NOREG;
		basicslots[i].modified = 0;
        }

	/* Setup various slot pointers */
	slotinfo = &basicslots[0];
	localinfo = &slotinfo[0];
	tempinfo = &localinfo[islots];

	stack_limit[0].regno = NOREG;
	stack_limit[0].modified = 0;
}
