/* seq.h
 * Pseudo instruction sequences.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __seq_hh
#define __seq_hh

struct _sequence;
struct _label_;

typedef void (*ifunc)(struct _sequence*);

#define	SEQSLOTS		5

typedef struct _sequence {
	ifunc			func;
	uint32			refed;
	uint32			lastuse;
	struct _sequence*	next;
	union {
		jvalue		value;
		struct _label_* labconst;
		struct SlotData** smask;
		struct {
			struct SlotData* slot;
			uint32		 note;
		} s;
	} u[SEQSLOTS];
} sequence;

void initSeq(void);
sequence* nextSeq(int);

extern sequence*		firstSeq;
extern sequence*		lastSeq;
extern sequence*		currSeq;

#define	ALLOCSEQNR		1024

#define	seq(S)		((S)->insn)
#define	seq_slot(S,I)	((S)->u[(I)].s.slot)
#define	seq_dst(S)	seq_slot((S), 0)
#define	seq_ret(S)	seq_slot((S), 0)

#endif
