/*
 * bitvector.h
 * Bitvector implementation
 *
 * Copyright (c) 1999 - 2001
 *      Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __bv_h
#define __bv_h

extern uint ** BV_new_array( int, int );
extern void BV_free_array( uint **, int );
extern void BV_set_all( uint *, int );
extern void BV_unset_all( uint *, int );
extern void BV_and( uint *, uint *, uint *, int );
extern void BV_or( uint *, uint *, uint *, int );
extern void BV_copy( uint *, uint *, int );
extern boolean BV_equal( uint *, uint *, int );

#define BV_words( _n ) \
	( (_n) / 32 + ((_n) % 32 != 0 ? 1 : 0) )
#define BV_new( _n ) \
        gc_malloc_fixed( (_n) * sizeof(uint) )
#define BV_free( _bv ) \
        gc_free_fixed( _bv )
#define BV_set( _bv, _ix ) \
        (_bv)[(_ix) / 32] |= 1 << (_ix) % 32
#define BV_unset( _bv, _ix ) \
        (_bv)[(_ix) / 32] &= ~(1 << (_ix) % 32)
#define BV_is_set( _bv, _ix ) \
        ( (_bv)[(_ix) / 32] & (1 << (_ix) % 32) ? true : false )
#endif
