/*
 * counters.c
 * Try to use hardware cycle counters for stats
 *
 * Copyright (c) 1999 - 2001
 *      Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

extern void CNTR_init();
extern void CNTR_begin();
extern long long CNTR_end();
extern long long CNTR_read();

#ifdef ENABLE_COUNTER
#define COUNTER( _v ) _v
#define COUNTER_accumulate( _cfg, _name ) \
	(_cfg)->env.global.time._name += CNTR_end(); \
	CNTR_begin()
#else
#define COUNTER( _v )
#define COUNTER_accumulate( _cfg, _name )
#endif
