/* 
 * defines.h
 *
 * Copyright (c) 1999 - 2001
 *	Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __defines_h
#define __defines_h

/* Instructions */
#if 0
#define	define_insn(code)	break; \
				case code : \
				fprintf( fd, "[%d]: %d\n", pc, getopcode() );
#else
#define	define_insn(code)	break; \
				case code :
#endif
#define	define_insn_alias(code)	case code :
#define	define_wide_insn(code)	define_insn(code)

/* PC */
#define	getopcode()		opcode
#define	getpc(_p)		code[pc+1+(_p)]
#define	getcode(_p)		code[(_p)]
#define	adjustpc(_p)		npc = pc + (_p)

/* Stack */
#define stack(_o)		(stack_p[-(_o)])
#define stack_long(_o)		stack(_o)
#define stack_float(_o)		stack(_o)
#define stack_double(_o)	stack(_o)
#define rstack(_o)		stack(_o)
#define rstack_ref(_o)		stack(_o)
#define rstack_long(_o)		stack(_o)
#define rstack_float(_o)	stack(_o)
#define rstack_double(_o)	stack(_o)
#define push(_o)		stack_p = &stack_p[(_o)]
#define pop(_o)			stack_p = &stack_p[-(_o)]
#define adjust_stack(_op)	stack_p = &stack_p[moveSP[(_op)]]

/* Locals */
#define local(_p)		(locals[(_p)])
#define local_float(_p)		local(_p)
#define local_long(_p)		local(_p)
#define local_double(_p)	local(_p)

/* Methods */
#define	get_method_info(_ix) \
	getMethodSignatureClass((constIndex)(_ix), class, 0, &meth_i)
#define	get_special_method_info(_ix) \
	getMethodSignatureClass((constIndex)(_ix), class, 1, &meth_i)
#define	get_interface_method_info(_ix) \
	getMethodSignatureClass((constIndex)(_ix), class, 2, &meth_i)


#define	method_name()	(meth_i.name)
#define	method_sig()	(meth_i.signature)
#define	method_idx()	(meth_i.method->idx)
#define method_method()	(meth_i.method)
#define method_class()  (meth_i.class)
#define method_classname()  (meth_i.cname)
#define	get_dispatch_table(mtable)				\
			move_ref_const(mtable, meth_i.class->dtable)

#define	method_nargs()		(meth_i.in)
#define	method_dtable_offset	(OBJECT_DTABLE_OFFSET)
#define	method_returntype()	(meth_i.rettype)

/* Fields */

#define	get_field_info(_ix) \
	getField((constIndex)(_ix), class, &fld_i)

#define	get_static_field_info(_ix) \
	getField((constIndex)(_ix), class, &fld_i)

#define field_class()		(fld_i.class)
#define field_field()		(fld_i.field)
#define field_name()		(fld_i.name)
#define field_classname()	(fld_i.cname)
#define field_sig()		(fld_i.signature)
#define field_static_data()	(fld_i.class->sdata)
#define field_static_offset()	(fld_i.field->info.addr - (void*)fld_i.class->sdata)

/* Classes */

#define current_class()		class
#define	get_class_info(_ix)	cls_i = getClass((constIndex)(_ix), class, &cname)
#define	class_object()		(cls_i)
#define	class_classname(_ix)	(WORD2UTF(class->constants.data[_ix]))

/* Objects */

#define	object_array_offset(_t)	(ARRAY_DATA_OFFSET(_t))
#define	object_array_length	(ARRAY_SIZE_OFFSET)
#define object_lock_offset      4

/* Switches */

#define	switchpair_size		8
#define	switchpair_addr		4
#define	switchtable_shift	2

/* Provide write barrier support for incremental GC */
#define GC_INCREMENTAL 1
#ifdef GC_INCREMENTAL
#define	SOFT_ADDREFERENCE(_f, _t)	 softcall_writeref(_f, _t)
#define	SOFT_ADDREFERENCE_STATIC(_f, _t) softcall_writeref_static(_f, _t)
#else
#define	SOFT_ADDREFERENCE(_f, _t)
#define	SOFT_ADDREFERENCE_STATIC(_f, _t)
#endif

/* Etc */

#define inline_constants()
#define make_align( _sz )

#endif
