/*
 * env-arm.h
 *
 * Copyright (c) 1999 - 2001
 *      Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#define SE_invert		0x80000000
#define SE_split_arg		0x20000000
#define SE_third_arg		0x40000000
#define SE_imm			0x400000
#define IMMEDIATE_BITS 		8
#define USE_SOFT_LONG 		1
#define USE_SOFT_FLOAT		1
#define USE_SOFT_DIV 		1
#define USE_SOFT_REM 		1
#define USE_SOFT_CVT_LONG	1
#define USE_RISC_LDST		1
#define INSTALL_CODE		1
#define USE_CONSTANT_TABLE      1 /* Disabling will break tableswitch/lookupswitch */
#define FRAME_ALIGNMENT		1 /* words */
#define INSERT_NOP		NULL
#define DWORD_ALIGN( _v, _a)	

#define NUM_REGS 		24
#define SCH_AUX_REGS 		4
#define USE_GDB_DISASM		1

/* FP Registers */
#define FR( _e )		(_e)->loc.reg.base - 16
#define FR_L( _e )		(_e)->loc.reg.base - 16
#define FR_H( _e )		(_e)->loc.reg.pair - 16

#define cbranch_eq_func( _f, _a )	_f##cbranch##_a
#define cbranch_ne_func( _f, _a )	_f##cbranch##_a
#define cbranch_lt_func( _f, _a )	_f##cbranch##_a
#define cbranch_ge_func( _f, _a )	_f##cbranch##_a
#define cbranch_gt_func( _f, _a )	_f##cbranch##_a
#define cbranch_le_func( _f, _a )	_f##cbranch##_a
#define cbranch_ult_func( _f, _a )	_f##cbranch##_a

