#ifndef __env_h
#define __env_h

#define CHECK_STACK_LIMIT
#define FAKE_STACK_LIMIT( _do ) _do

//#define LOG( _s )
#define LOG( _s ) if( print_dbg ){ _s; }
#define TRACE( _s )
//#define TRACE( _s ) _s

#define JIT_DBG
#define J4( _s ) _s
#define FAILED() assert( 0 )
#define OPTIMIZE_LOOPS
#define OPTIMIZE_INLINE
#define OPTIMIZE_SCHEDULE
#define OPTIMIZE_GCSE
#define OPTIMIZE_CSE
#define OPTIMIZE_CONSTANTS
#define GLOBAL_INIT_SIZE 8
#define OPTIMIZE_CSE_LOAD
#define USE_BYTECODES_DEF

// #define TGT_MIPS 1
#define TGT_SPARC 1
// #define TGT_ARM 1

#define ALIGN_VALUE( _v, _a ) (_v) = ( ((_v) + (_a) - 1) & -(_a) )
#define IS_DWORD_ALIGNED( _v )	( ((_v) & 0x7) == 0 )

#if defined( CHECK_STACK_LIMIT ) && !defined( FAKE_STACK_LIMIT )
#define ADJUST_LOCALSZ( _l ) (_l + 1)
#else
#define ADJUST_LOCALSZ( _l ) _l
#endif

#if defined(TGT_MIPS)
#include "env-mips.h"
#elif defined(TGT_SPARC)
#include "env-sparc.h"
#elif defined(TGT_ARM)
#include "env-arm.h"
#elif defined(TGT_I386)
#include "env-i386.h"
#endif

#include "config.h"
#include "config-std.h"
#include "config-math.h"
#include "config-mem.h"
#include "config-setjmp.h"
#include "gtypes.h"
#include "md.h"
#include "classMethod.h"
#include "strings.h"
#include "exception.h"
#include "linkedlist.h"
#include "defines.h"
#include "expr.h"
#include "list.h"
#include "cfg.h"
#include "regs.h"
#include "code.h"
#include "asm.h"
#include "print.h"
#include "consts.h"
#include "throw.h"
#include "lab.h"
#include "reduce.h"
#include "scanner.h"
#include "schedule.h"
#include "counters.h"
#include "jitstats.h"
#include "jitsupport.h"
#include "bitvector.h"
#include "patch.h"
#include "profile.h"
#include <errno.h>
#include "/usr/include/strings.h"

#ifdef DIRECT_CALL
#define INDIRECT_CALL_DO( _o )
#else
#define INDIRECT_CALL_DO( _o ) _o
#endif

#define WORD_SZ		4

extern int enable_inline;
extern int enable_schedule;
extern int enable_loopopt;
extern int enable_gcse;
extern int globals_limit;
extern int inline_limit;

extern inline void REG_push_block_env( cfg_info *, block_env * );
extern inline void REG_pop_block_env( cfg_info *, block_env * );

extern inline void TEMP_push_block_env( cfg_info *, block_env * );
extern inline void TEMP_pop_block_env( cfg_info *, block_env * );

extern inline void EXPR_push_block_env( cfg_info * );
extern inline void EXPR_pop_block_env( cfg_info *, expr *, boolean );

extern expr * CSE_recurse( expr *, instr_block *, instr_block *, cseFunc, int, boolean );
extern instr_block * GCSE_recurse( expr *, instr_block *, instr_block *, cseFunc, int );

extern boolean disable;
extern boolean print_dbg;

extern void finishJNIcall();

extern void BLK_backup_expr( expr *, block_env *, FILE * );
extern void METHOD_new_globals( method_env *, int, int );
#endif
