/* 
 * jitstats.c
 * Method stats for various uses
 *
 * Copyright (c) 1999 - 2001 
 *	Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __jitstats_h
#define __jitstats_h

#define SO_load			0
#define SO_store		1
#define SO_null_checked		2
#define SO_loop_must_load	3
#define SO_iterator		4

#define NUM_STATS		6

extern stats_info * STATS_new( int );
#define STATS_free( _s ) gc_free_fixed( _s );
extern void STATS_fields_coalesce( field_list *, field_list * );
extern void STATS_field_free( field_list * );
extern int STATS_field_get_offset( Field *, Hjava_lang_Class * );

extern void STATS_field_set( int, field_list *, Field *, Hjava_lang_Class * );
extern void STATS_array_set( int, field_list *, Hjava_lang_Class * );
#define STATS_local_set( _t, _s, _ix ) 	BV_set( (_s)->item[(_t)], (_ix) )

#define STATS_field_get( _t, _s, _ix ) 	BV_is_set( (_s)->item[(_t)], (_ix) )
#define STATS_array_get( _t, _s ) 	BV_is_set( (_s)->item[(_t)], 0 )
#define STATS_local_get( _t, _s, _ix ) 	BV_is_set( (_s)->item[(_t)], (_ix) )
extern void STATS_locals_coalesce( stats_info *, stats_info * );

#endif
