#ifndef __linkedlist_h
#define __linkedlist_h

typedef struct _linked_list {
	void *		next;
	void *		prev;
} linked_list;

/* Double-ly linked list */
#define DLL_REMOVE( _node, _s, _f ) \
	if ((_node)->_f.next != NULL){ \
        	((_s)(_node)->_f.next)->_f.prev = (_node)->_f.prev; \
	} \
	if ((_node)->_f.prev != NULL){ \
		((_s)(_node)->_f.prev)->_f.next = (_node)->_f.next; \
	} \
	(_node)->_f.next = NULL; \
	(_node)->_f.prev = NULL

#define DLL_INSERT_AS_NEXT( _list, _node, _s, _f ) \
	(_node)->_f.prev = (void *)(_list); \
	if( (_list)->_f.next != NULL ) \
		((_s)(_list)->_f.next)->_f.prev = (void *)(_node); \
	(_node)->_f.next = (_list)->_f.next; \
	(_list)->_f.next = (void *)(_node)

#define DLL_INSERT_AS_PREV( _list, _node, _s, _f ) \
	(_node)->_f.next = (void *)(_list); \
	if( (_list)->_f.prev != NULL ) \
		((_s)(_list)->_f.prev)->_f.next = (void *)(_node); \
	(_node)->_f.prev = (_list)->_f.prev; \
	(_list)->_f.prev = (void *)(_node)

/* Single-ly linked list */
#define SLL_PUSH( _list, _node, _f ) \
	(_node)->_f = (_list); \
        (_list) = (_node);

#define SLL_POP( _list, _node, _f ) \
        (_node) = (_list); \
	(_list) = (_node)->_f;

#endif

