/* 
 * print.c
 *
 * Copyright (c) 1999 - 2001 
 *	Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __print_h
#define __print_h

typedef void (*printFunc)(char**, instr_block*, expr*);

typedef struct _softname_info {
        void*	func;
	char*	name;
} softname_info;

#define PRINT_FUNCTION( _name ) static void print_##_name( char ** buf, instr_block * blk, expr * e ) 

extern char* op_names[];
extern void REG_print( FILE *, reg_info *, int, cfg_info * );
extern int FLAG_print( char *, instr_block *, expr * );
extern char * SLOT_print( instr_block *, expr * );
extern void EXPR_print( instr_block *, expr * );
extern void BLK_print( instr_block * );
extern void CFG_print( cfg_info * );
extern const char * CFG_print_type( int );
extern void DISASM_instruction( FILE *, instr_block *, uint8 * );
extern void DISASM_method( cfg_info * );
extern void DISASM_init( FILE * );

#endif
