#ifndef __profile_h
#define __profile_h

#define DEP_put			0x1
#define DEP_get			0x2

typedef struct _loc_info {
	Hjava_lang_Class * 	class;
	Method * 		method;
	unsigned int		line;
	void *			pc;
} loc_info;

typedef struct _epoch_info {
        unsigned int			epoch;
	loc_info *			at;
} epoch_info;

typedef struct _dep_info {
	struct _dep_info *		next;
        unsigned int			hit;
        unsigned int			delta;
        struct {
                Hjava_lang_Class * 	class;
                Field * 		field;
        } field;
	loc_info			at;
        unsigned char			type;
} dep_info;

typedef struct _profile_info {
        unsigned long long	cycle;
        unsigned int		epoch;
        dep_info *		from;
} profile_info;

extern int profileArraySize( int, int );
#define PROFILE_ALIGN( _o ) (_o) = (((_o) + 4 - 1) / 4) * 4;

extern dep_info * DEP_new( Hjava_lang_Class *, Method *, unsigned int, Hjava_lang_Class *, Field *, unsigned char );
extern void DEP_print();

extern void PROF_put( dep_info *, profile_info * );
extern void PROF_get( dep_info *, profile_info * );
extern void PROF_arrayload( dep_info *, Hjava_lang_Object *, unsigned int );
extern void PROF_arraystore( dep_info *, Hjava_lang_Object *, unsigned int );
extern void PROF_call( loc_info *, void * );
extern void PROF_return();
extern void PROF_loop_preheader( loc_info * );
extern void PROF_loop_iteration();

#ifdef PROFILE
#define PROFILE_ARRAY_SIZE( _prim_sz, _len ) profileArraySize( _prim_sz, _len )
#else
#define PROFILE_ARRAY_SIZE( _prim_sz, _len ) 0
#endif
#endif
