/*
 * jstatsdef.h - this is the (variable) jstats configuration header
 * 
 * NOTE: this is automatically included from jstats.h
 * 
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */



/*********************************************************************
 * This is the list of statistics switches which can be specified in
 * the environment var STATS. Don't forget to add the corresponding
 * checks to "stats_init()"
 */

STATS_DEFINE( gc_sizes);
STATS_DEFINE( gc_objects);

/*********************************************************************
 * This is the debug init func, which is called via the
 * STATS_INIT() macro (just from the module that defines DEBUG_MAIN).
 * It can contain any code you want, but at least it should have
 * STATS_CHECK() calls for all defined debug switches. This is also
 * where "FILE* _stats_stream" could be set (if the default stderr
 * is not appropriate)
 */

#if defined(STATS_MAIN)

static void
stats_init()
{
  STATS_CHECK( gc_sizes);
  STATS_CHECK( gc_objects);
}

#endif /* STATS_MAIN */
