/*
 * lookup.h
 * Various lookup calls for resolving objects, methods, exceptions, etc.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __lookup_h
#define __lookup_h

struct _dispatchTable;

typedef struct _callInfo {
	Hjava_lang_Class*	class;
	Method*			method;
	short			in;
	short			out;
	char*			cname;
	char*			name;
	char*			signature;
	char			rettype;
} callInfo;

typedef struct _exceptionInfo {
	uintp			handler;
	Hjava_lang_Class*	class;
	Method*			method;
} exceptionInfo;

typedef struct _fieldInfo {
	Field*			field;
	Hjava_lang_Class*	class;
	char*			cname;
	char*			name;
	char*			signature;
} fieldInfo;

JNIEXPORT int	JNICALL getMethodSignatureClass(constIndex, Hjava_lang_Class*, int, callInfo*);
JNIEXPORT int	JNICALL getField(constIndex, Hjava_lang_Class*, fieldInfo*);
JNIEXPORT Hjava_lang_Class* JNICALL getClass(constIndex, Hjava_lang_Class*, char**);

JNIEXPORT Method* JNICALL findMethod(Hjava_lang_Class*, char*, char*);
JNIEXPORT Method* JNICALL findMethodLocal(Hjava_lang_Class*, char*, char*);

JNIEXPORT uintp JNICALL findExceptionHandlerInMethod(Hjava_lang_Class*, Method*, uintp, Hjava_lang_Class*);

#endif
