/*
 * gc.c
 * The garbage collector.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

#include "config-std.h"
#include "config-mem.h"
#include "gtypes.h"
#include "gc.h"

/* Use the incremental garbage collector */
#include "gc-incremental.c"

void*
__kaffe_malloc(int sz)
{
	return ((*Kaffe_GarbageCollectorInterface._malloc)(sz, GC_ALLOC_FIXED));
}

void*
__kaffe_realloc(void* mem, int sz)
{
	return ((*Kaffe_GarbageCollectorInterface._realloc)(mem, sz, GC_ALLOC_FIXED));
}

void
__kaffe_free(void* mem)
{
	(*Kaffe_GarbageCollectorInterface._free)(mem);
}

void*
__kaffe_awt_malloc(int sz)
{
	return ((*Kaffe_GarbageCollectorInterface._malloc)(sz, GC_ALLOC_AWT));
}

void
__kaffe_awt_free(void* mem)
{
	__kaffe_free(mem);
}
