/* 
 * gc-funcs.h
 *
 * Copyright (c) 1999 - 2001
 *	Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __gc_funcs_h
#define __gc_funcs_h

extern char* gcType( struct _gcTable * );

extern void markObject(void*);
extern void markReferences(void);

extern void finalizeObject(void*);
extern void finalizeClass(void*);
extern void finalizeString(void*);

extern void walkNull(void*, uint32);
extern void walkClass(void*, uint32);
extern void walkObject(void*, uint32);
extern void walkRefArray(void*, uint32);
extern void walkJReference(void*, uint32);
extern void walkBag(void*, uint32);
extern void walkThread(void*, uint32);

struct _heap_obj;

extern void walkMemory( void * );
extern void _walkMemory( struct _heap_obj * );

#endif
