/*
 * gc.c
 * The garbage collector.
 *
 * Copyright (c) 1999 - 2001
 *	Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

#include "config-std.h"
#include "config-mem.h"
#include "gtypes.h"

#include "gc.h"

void*
__kaffe_malloc(int sz)
{
	return fixed_malloc(sz);
}

void*
__kaffe_realloc(void* mem, int sz)
{
	return fixed_realloc(mem, sz);
}

void
__kaffe_free(void* mem)
{
	fixed_free(mem);
}

void*
__kaffe_awt_malloc(int sz)
{
	return fixed_malloc(sz);
}

void
__kaffe_awt_free(void* mem)
{
	__kaffe_free(mem);
}

