/* 
 * stats.h
 * Garbage collector statistics.
 *
 * Copyright (c) 1999 - 2001
 *	Stanford University.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __stats_h
#define	__stats_h

#undef GC_STATS

typedef struct _obj_stats {
	int cnt;
	int mem;
} obj_stats;

#if defined(GC_STATS)
#define ALTER_STATS(_type, _cnt, _mem) \
{ \
	obj_stats* stats = &gc_stats[(_type) - gc_table]; \
	stats->cnt += (_cnt); \
	stats->mem += (_mem); \
}
#else
#define ALTER_STATS(_type, _cnt, _mem) 
#endif

extern obj_stats gc_stats[];
extern void gcPrintStats();

#endif
