/*
 * object.h
 * Object representation.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __object_h
#define __object_h

#include "config.h"
#include "config-std.h"
#include "gtypes.h"
#include "gc.h"

#include "java_lang_Object.h"
#include "Arrays.h"

#define	OBJECT_DATA(OBJ)	((void*)((Hjava_lang_Object*)(OBJ)+1))

/* Number of elements. */
#if 0
#define	OBJARRAY_DATA(ARRAY)	((Hjava_lang_Object**)(((HArrayOfObject*)(ARRAY))->data))
#endif

/*
 * These bizzare casts provide various offset into the object structure.
 */
#if 0
#define	ARRAY_DATA_OFFSET	((int)ARRAY_DATA(0))
#endif

#define	ARRAY_SIZE(A)		(((HArrayOfObject*)(A))->length)
#define	ARRAY_DATA(T,A)		((void*)(((T*)(A))->data))

#define	ARRAY_DATA_OFFSET(T)	((int)ARRAY_DATA(T,0))
#define	ARRAY_SIZE_OFFSET	((int)&ARRAY_SIZE(0))
#define	OBJECT_DTABLE_OFFSET	((int)&(*(Hjava_lang_Object*)0).dtable)


struct Hjava_lang_Class;

JNIEXPORT Hjava_lang_Object*	JNICALL newObject(struct Hjava_lang_Class*);
JNIEXPORT struct Hjava_lang_Class* JNICALL newClass(void);
JNIEXPORT Hjava_lang_Object*	JNICALL newArray(struct Hjava_lang_Class*, int);
JNIEXPORT Hjava_lang_Object*	JNICALL newMultiArray(struct Hjava_lang_Class*, int*);

#endif
