/*
 * patch.h
 * Patch various places to improve performance
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __patchcall_h
#define __patchcall_h
#define PS_call		0x1
#define PS_addr		0x2
#define PS_initclass	0x3
#define PS_const	0x4

typedef struct _patch_info {
	uint8		type;
	void *		where;
} patch_info;

typedef struct _patch_list {
	uint32		length;
	uint32		max;
	patch_info	patch[1];
} patch_list;

extern void addMethodPatch( Method *, void *, int );
extern void addClassPatch( Hjava_lang_Class *, void *, int );
extern void finishMethodPatches( Method *, Hjava_lang_Class *, void * );
extern void finishClassPatches( Hjava_lang_Class * c );
#endif
