/*
 * soft.h
 * Soft instruction prototypes.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __soft_h
#define	__soft_h

struct _dispatchTable;
struct Hjava_lang_Class;
struct Hjava_lang_ClassLoader;
struct Hjava_lang_Object;
struct Hjava_lang_Throwable;
struct _methodSig;
struct _slots;

JNIEXPORT void*	JNICALL _Jv_AllocObject(struct Hjava_lang_Class*);
JNIEXPORT void*	JNICALL _Jv_NewArray(jint, jint);
JNIEXPORT void*	JNICALL _Jv_NewObjectArray(jint, struct Hjava_lang_Class*);
JNIEXPORT void	JNICALL _Jv_InitClass(struct Hjava_lang_Class*);
JNIEXPORT nativecode* JNICALL soft_get_method_code (Method*);

JNIEXPORT void* JNICALL soft_lookupmethod(struct Hjava_lang_Object*, struct Hjava_lang_Class*, int);
JNIEXPORT void*	JNICALL _Jv_CheckCast(struct Hjava_lang_Class*, struct Hjava_lang_Object*);
JNIEXPORT jint	JNICALL _Jv_IsInstanceOf(struct Hjava_lang_Object*, struct Hjava_lang_Class*);

JNIEXPORT void*	JNICALL soft_lazycheckcast(char*, struct Hjava_lang_ClassLoader*, struct Hjava_lang_Object*);
JNIEXPORT jint	JNICALL soft_lazyinstanceof(struct Hjava_lang_Object*, struct Hjava_lang_ClassLoader*, char*);
JNIEXPORT void* JNICALL soft_lazylookupmethod(struct Hjava_lang_Object*, char*, char*);

void	soft_athrow(struct Hjava_lang_Throwable*);
void	soft_badarrayindex(void);
void	soft_nullpointer(void);
void	soft_divzero(void);
void	soft_nosuchclass(char*);
void	soft_nosuchmethod(char*, char*, char*);
void	soft_nosuchfield(char*, char*);
void	soft_checkarraystore(struct Hjava_lang_Object*, struct Hjava_lang_Object*);
void	soft_stackoverflow(void);

int	soft_init_precompiled(struct Hjava_lang_Class*);
void*	soft_stackoverflow_ptr;

void*	soft_get_thrown_exception(void);

jint	soft_dcmpg(jdouble, jdouble);
jint	soft_dcmpl(jdouble, jdouble);
jint	soft_fcmpg(jfloat, jfloat);
jint	soft_fcmpl(jfloat, jfloat);

jint	soft_mul(jint, jint);
jint	soft_div(jint, jint);
jint	soft_rem(jint, jint);

void*	soft_multianewarray(struct Hjava_lang_Class*, jint, struct _slots*);

jlong	soft_lmul(jlong, jlong);
jlong	soft_ldiv(jlong, jlong);
jlong	soft_lrem(jlong, jlong);
jfloat	soft_fadd(jfloat, jfloat);
jfloat	soft_fsub(jfloat, jfloat);
jfloat	soft_fmul(jfloat, jfloat);
jfloat	soft_fdiv(jfloat, jfloat);
jfloat	soft_frem(jfloat, jfloat);
jdouble	soft_faddl(jdouble, jdouble);
jdouble	soft_fsubl(jdouble, jdouble);
jdouble	soft_fmull(jdouble, jdouble);
jdouble	soft_fdivl(jdouble, jdouble);
jdouble	soft_freml(jdouble, jdouble);
jlong	soft_lshll(jlong, jint);
jlong	soft_ashrl(jlong, jint);
jlong	soft_lshrl(jlong, jint);
jint	soft_lcmp(jlong, jlong);

jlong	soft_cvtil(jint);
jfloat	soft_cvtif(jint);
jdouble	soft_cvtid(jint);
jint	soft_cvtli(jlong);
jfloat	soft_cvtlf(jlong);
jdouble	soft_cvtld(jlong);
jint	soft_cvtfi(jfloat);
jlong	soft_cvtfl(jfloat);
jdouble	soft_cvtfd(jfloat);
jint	soft_cvtdi(jdouble);
jlong	soft_cvtdl(jdouble);
jfloat	soft_cvtdf(jdouble);

void	soft_debug1(void*, void*, void*);
void	soft_debug2(void*, void*, void*);
void	soft_trace(Method*, struct Hjava_lang_Class*, void*);
void	soft_end(uint8, void* );

JNIEXPORT jint JNICALL instanceof(struct Hjava_lang_Class*, struct Hjava_lang_Class*);
JNIEXPORT jint JNICALL instanceof_class(struct Hjava_lang_Class*, struct Hjava_lang_Class*);
JNIEXPORT jint JNICALL instanceof_array(struct Hjava_lang_Class*, struct Hjava_lang_Class*);
JNIEXPORT jint JNICALL instanceof_interface(struct Hjava_lang_Class*, struct Hjava_lang_Class*);

#endif
