/*
 * support.h
 * Various support routines.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __support_h
#define	__support_h

#include <stdarg.h>
#include <native.h>

struct _methods;
struct _strconst;
struct Hjava_lang_String;
struct Hjava_lang_Class;

/* For user defined properties */
typedef struct _userProperty {
        char*                   key;
        char*                   value;
        struct _userProperty*   next;
} userProperty;

JNIEXPORT userProperty* userProperties;

JNIEXPORT int	JNICALL addNativeMethod(char*, void*);

JNIEXPORT void	JNICALL callMethodA(struct _methods*, void*, void*, jvalue*, jvalue*);
JNIEXPORT void	JNICALL callMethodV(struct _methods*, void*, void*, va_list, jvalue*);
JNIEXPORT struct _methods*	JNICALL lookupClassMethod(struct Hjava_lang_Class*, char*, char*);
JNIEXPORT struct _methods*	JNICALL lookupObjectMethod(struct Hjava_lang_Object*, char*, char*);

JNIEXPORT void JNICALL unimp(char*);

JNIEXPORT  void JNICALL kprintf(const char*, ...);

JNIEXPORT  int JNICALL callAndCatchMethodA(Method*, void*, void*, jvalue*, jvalue*);
JNIEXPORT  int JNICALL callAndCatchMethodV(Method*, void*, void*, va_list, jvalue*);

 
#endif
