/*
 * kpsos.h
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __system_psos_kpsos_h
#define __system_psos_kpsos_h

/*
 * Thread structure.
 */
typedef struct nativeThread {
	unsigned long		tid;
	void*			stackBase;
	void*			stackEnd;
	Hjava_lang_Thread*	next;
} nativeThread;

/* Convert a Java timeout to a pSOS one.
 */
#define	JAVATIMEOUT2PSOSTIMEOUT(T) \
	((unsigned long)((T)/(1000000/TICKS_PER_SEC)))

/* Convert a Java thread priority to a pSOS one
 * We use 110 (high) to 100 (low)
 */
#define	JAVA_MAXPRIO	11
#define	JAVA_MINPRIO	1
#define	JAVAPRIO2PSOSPRIO(P)	(100+JAVA_MAXPRIO-(P))

/* Convert a Java thread pointer to a pSOS one */
#define	NATIVE_THREAD(T)	((nativeThread*)unhand(T)->PrivateInfo)

#endif
