/*
 * smx.h
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __system_smx_smx_h
#define __system_smx_smx_h

#undef LOCK
#undef UNLOCK
#undef inline
#undef malloc
#undef calloc
#undef free
#undef bool
#undef fd_set

#define INCLUDE_RTIP
#define	INCLUDE_ERTFS

/* Include the standard smx defines */
#include "xsmx.h"
#include "pcconf.h"
#include "rtfsapi.h"
#include "rtip.h"
#include "socket.h"
#include "xcrt.h"
#include "java_lang_Thread.h"

/*
 * Thread structure.
 */
typedef struct nativeThread {
	TCB_PTR			      task;
	Hjava_lang_Thread     *thread;
	struct nativeThread   *next;
} nativeThread;

/* Convert a Java timeout to a SMX one.
 * Each clock tick is 1/cf.sec seconds.
 */
#define	JAVATIMEOUT2SMXTIMEOUT(T)	(((T)*cf.sec)/1000)
#define	SMXFOREVER					(-1)
#define	MAXSMXPRIORITY				(cf.max_priority)

/* Convert a Java thread priority to a SMX one
 * We use 'cf.max_priority' (high) to 0 (low)
 */
#define	JAVA_MAXPRIO	11
#define	JAVA_MINPRIO	1
#define	JAVAPRIO2SMXPRIO(P)	(byte) ((MAXSMXPRIORITY * ((P) - JAVA_MINPRIO)) / (JAVA_MAXPRIO - JAVA_MINPRIO))

/* Convert a Java thread pointer to a SMX one */
#define	NATIVE_THREAD(T)	((nativeThread*)unhand(T)->PrivateInfo)

/* this is a temporarily borrowed, unsed field from the TCB struct, which has to be
 * replaced once SMX provides a dedicated usedData TCB field */
#define TASK_SPECIFIC_DATA(_task) ((_task)->fp)

#endif
