/*
 * internal.h
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __system_threadx_internal_h
#define __system_threadx_internal_h

#include "tx_api.h"

/*
 * Thread structure.
 */
typedef struct nativeThread {
	TX_THREAD*		threadx;
	Hjava_lang_Thread*	next;
	semaphoreThread		seminfo;
} nativeThread;

/* Define the pre-emption interval, that is the maximum time a thread will
 * run before being pre-empted by a thread of equal priority.  This value
 * is defined as a number of clock ticks.
 */
#define	TIMESLICE		10

/* Convert a Java timeout to a ThreadX one.
 * Each clock tick is 10ms long.
 */
#define	JAVATIMEOUT2THREADXTIMEOUT(T)	((int)((T)/8))

/* Convert a Java thread priority to a ThreadX one
 * We use 10 (high) to 20 (low)
 */
#define	JAVA_MAXPRIO	11
#define	JAVA_MINPRIO	1
#define	JAVAPRIO2THREADXPRIO(P)	(10+JAVA_MAXPRIO-(P))

/* Convert a Java thread pointer to a ThreadX one */
#define	NATIVE_THREAD(T)	((nativeThread*)unhand(T)->PrivateInfo)

#endif
