/*
 * lock-impl.h - this is the part of the LockInterface implementation
 * we want to expose (by means of injection into the abstraction locks.h)
 *
 * Use it only for two purposes:
 *  (1) redefine generic interface function macros of locks.h in order
 *      to turn the runtime interface (completely or partly) into a
 *      compile-time interface
 *  (2) VERY RESTRICTIVE - define macros which can be used in clients to
 *      check for a certain subsystem (but JUST if there are strong reasons
 *      against using a clean interface function instead)
 *
 * Copyright (c) 1999
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __lock_impl_h
#define __lock_impl_h


/* no compiletime interface implementation, yet */

#undef Kaffe_LI_semget
#undef Kaffe_LI_semput

# define Kaffe_LI_semget(sem, timeout)			Kaffe_LockInterface.semget(sem, timeout)
# define Kaffe_LI_semput(sem)					Kaffe_LockInterface.semput(sem)

#endif /* __lock_impl_h */
