/*
 * thread-impl.h - pthread based ThreadInterface implementation
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

#ifndef __thread_internal_h
#define __thread_internal_h

#include "java_lang_Thread.h"

#define TMSG_SHORT(_msg,_nt)     \
   (_msg" %p [tid:%d, java:%p]\n", \
    _nt, _nt->tid, _nt->thread)


/*
 * 'nativeThread' is our link between native and Java thread objects.
 */
typedef struct _nativeThread {
	Hjava_lang_Thread	*thread;
	DWORD				tid;
	HANDLE				hand;

	uintp				stkbase;
	uintp				stkend;
	uintp				stkcur;
	void				(*func)(void);

	HANDLE              sem;
	HANDLE				semLock;

	struct _nativeThread *next;
} nativeThread;

#define	JAVAPRIO2WIN32PRIO(P)	(P)

JNIEXPORT int tlsIdx;
extern CRITICAL_SECTION critSec;
/*
 * This should really be as fast as possible (and a VM-public compile time
 * interface)
 */
#define	NATIVE_THREAD(_thread)	((nativeThread*)(unhand(_thread)->PrivateInfo))
#define GET_CURRENT_THREAD(_sadr)   ((nativeThread*)(TlsGetValue( tlsIdx)))


#endif /* __thread_internal_h */
