/**
 * cursors.h - defininition of standard Java cursors
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

/* some libraries have a fixed value for transparency */
#if defined(TRANSP_IDX)
#  define o TRANSP_IDX 
#else
#  define o 0
#endif

/* we keep that variable to be able to in-situ create bitmaps */
#if !defined(CURSOR_PEL_TYPE)
#  define CURSOR_PEL_TYPE unsigned char
#endif

int cursorSize = 17;

/**********************************************************************************
 * bitmap defs of Cursors
 */


CURSOR_PEL_TYPE defaultCursor[] = {
1,1,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,
1,2,1,1,o,o,o,o,o,o,o,o,o,o,o,o,o,
o,1,2,2,1,1,o,o,o,o,o,o,o,o,o,o,o,
o,1,2,2,2,2,1,1,o,o,o,o,o,o,o,o,o,
o,o,1,2,2,2,2,2,1,1,o,o,o,o,o,o,o,
o,o,1,2,2,2,2,2,2,2,1,1,o,o,o,o,o,
o,o,o,1,2,2,2,2,2,2,2,2,1,1,o,o,o,
o,o,o,1,2,2,2,2,2,2,2,2,2,2,1,o,o,
o,o,o,o,1,2,2,2,2,2,2,2,1,1,o,o,o,
o,o,o,o,1,2,2,2,2,2,1,1,o,o,o,o,o,
o,o,o,o,o,1,2,2,2,1,2,1,o,o,o,o,o,
o,o,o,o,o,1,2,2,2,1,1,2,1,o,o,o,o,
o,o,o,o,o,o,1,2,1,o,o,1,2,1,o,o,o,
o,o,o,o,o,o,1,2,1,o,o,o,1,2,1,o,o,
o,o,o,o,o,o,o,1,o,o,o,o,o,1,2,1,o,
o,o,o,o,o,o,o,o,o,o,o,o,o,o,1,o,o,
o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o
};

#define defaultCursorX 0
#define defaultCursorY 0


CURSOR_PEL_TYPE crossHairCursor[] = {
o,o,o,o,o,o,o,1,1,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,
1,2,2,2,2,2,2,2,1,2,2,2,2,2,2,2,1,
1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,1,1,o,o,o,o,o,o,o
};

#define crossHairCursorX 8
#define crossHairCursorY 8 


CURSOR_PEL_TYPE textCursor[] = {
o,o,o,o,o,1,1,1,1,1,1,1,o,o,o,o,o,
o,o,o,o,o,1,2,2,2,2,2,1,o,o,o,o,o,
o,o,o,o,o,o,1,1,2,1,1,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,1,1,2,1,1,o,o,o,o,o,o,
o,o,o,o,o,1,2,2,2,2,2,1,o,o,o,o,o,
o,o,o,o,o,1,1,1,1,1,1,1,o,o,o,o,o
};

#define textCursorX 8
#define textCursorY 8


CURSOR_PEL_TYPE waitCursor[] = {
o,o,o,1,1,1,1,1,1,1,1,1,1,1,o,o,o,
o,o,o,1,2,2,2,2,2,2,2,2,2,1,o,o,o,
o,o,o,1,2,1,1,1,1,1,1,1,2,1,o,o,o,
o,o,o,o,1,2,1,1,1,1,1,2,1,o,o,o,o,
o,o,o,o,1,2,2,2,2,2,2,2,1,o,o,o,o,
o,o,o,o,o,1,2,2,2,2,2,1,o,o,o,o,o,
o,o,o,o,o,1,2,2,2,2,2,1,o,o,o,o,o,
o,o,o,o,o,o,1,2,2,2,1,o,o,o,o,o,o,
o,o,o,o,o,o,1,2,2,2,1,o,o,o,o,o,o,
o,o,o,o,o,o,1,2,1,2,1,o,o,o,o,o,o,
o,o,o,o,o,1,2,1,2,1,2,1,o,o,o,o,o,
o,o,o,o,o,1,2,1,1,1,2,1,o,o,o,o,o,
o,o,o,o,1,2,1,1,2,1,1,2,1,o,o,o,o,
o,o,o,o,1,2,1,1,2,1,1,2,1,o,o,o,o,
o,o,o,1,2,1,1,2,2,2,1,1,2,1,o,o,o,
o,o,o,1,2,2,2,2,2,2,2,2,2,1,o,o,o,
o,o,o,1,1,1,1,1,1,1,1,1,1,1,o,o,o
};

#define waitCursorX 8
#define waitCursorY 8


CURSOR_PEL_TYPE swCursor[] = {
1,1,1,o,o,o,o,o,o,o,o,o,o,o,o,o,o,
1,2,1,o,o,o,o,o,o,o,o,o,o,o,1,o,o,
1,2,1,o,o,o,o,o,o,o,o,o,o,1,2,1,o,
1,2,1,1,o,o,o,o,o,o,o,o,1,2,1,o,o,
1,2,1,2,1,o,o,o,o,o,o,1,2,1,o,o,o,
1,2,1,2,1,o,o,o,o,o,1,2,1,o,o,o,o,
1,2,1,2,1,o,o,o,o,1,2,1,o,o,o,o,o,
1,2,1,2,1,o,o,o,1,2,1,o,o,o,o,o,o,
1,2,1,2,2,1,o,1,2,1,o,o,o,o,o,o,o,
1,2,1,2,2,1,1,2,1,o,o,o,o,o,o,o,o,
1,2,1,2,2,2,2,1,o,o,o,o,o,o,o,o,o,
1,2,1,2,2,2,2,1,1,o,o,o,o,o,o,o,o,
1,2,1,2,2,2,2,2,2,1,1,1,1,o,o,o,o,
1,2,1,2,2,2,2,2,2,2,2,2,2,1,o,o,o,
1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
};

#define swCursorX 0
#define swCursorY 15


CURSOR_PEL_TYPE seCursor[] = {
o,o,o,o,o,o,o,o,o,o,o,o,o,o,1,1,1,
o,o,1,o,o,o,o,o,o,o,o,o,o,o,1,2,1,
o,1,2,1,o,o,o,o,o,o,o,o,o,o,1,2,1,
o,o,1,2,1,o,o,o,o,o,o,o,o,1,1,2,1,
o,o,o,1,2,1,o,o,o,o,o,o,1,2,1,2,1,
o,o,o,o,1,2,1,o,o,o,o,o,1,2,1,2,1,
o,o,o,o,o,1,2,1,o,o,o,o,1,2,1,2,1,
o,o,o,o,o,o,1,2,1,o,o,o,1,2,1,2,1,
o,o,o,o,o,o,o,1,2,1,o,1,2,2,1,2,1,
o,o,o,o,o,o,o,o,1,2,1,1,2,2,1,2,1,
o,o,o,o,o,o,o,o,o,1,2,2,2,2,1,2,1,
o,o,o,o,o,o,o,o,1,1,2,2,2,2,1,2,1,
o,o,o,o,1,1,1,1,2,2,2,2,2,2,1,2,1,
o,o,o,1,2,2,2,2,2,2,2,2,2,2,1,2,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,
1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
};

#define seCursorX 15
#define seCursorY 15


CURSOR_PEL_TYPE nwCursor[] = {
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,
1,2,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,2,1,2,2,2,2,2,2,2,2,2,2,1,o,o,o,
1,2,1,2,2,2,2,2,2,1,1,1,1,o,o,o,o,
1,2,1,2,2,2,2,1,1,o,o,o,o,o,o,o,o,
1,2,1,2,2,2,2,1,o,o,o,o,o,o,o,o,o,
1,2,1,2,2,1,1,2,1,o,o,o,o,o,o,o,o,
1,2,1,2,2,1,o,1,2,1,o,o,o,o,o,o,o,
1,2,1,2,1,o,o,o,1,2,1,o,o,o,o,o,o,
1,2,1,2,1,o,o,o,o,1,2,1,o,o,o,o,o,
1,2,1,2,1,o,o,o,o,o,1,2,1,o,o,o,o,
1,2,1,2,1,o,o,o,o,o,o,1,2,1,o,o,o,
1,2,1,1,o,o,o,o,o,o,o,o,1,2,1,o,o,
1,2,1,o,o,o,o,o,o,o,o,o,o,1,2,1,o,
1,2,1,o,o,o,o,o,o,o,o,o,o,o,1,o,o,
1,1,1,o,o,o,o,o,o,o,o,o,o,o,o,o,o
};

#define nwCursorX 0
#define nwCursorY 0


CURSOR_PEL_TYPE neCursor[] = {
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,2,1,
o,o,o,1,2,2,2,2,2,2,2,2,2,2,1,2,1,
o,o,o,o,1,1,1,1,2,2,2,2,2,2,1,2,1,
o,o,o,o,o,o,o,o,1,1,2,2,2,2,1,2,1,
o,o,o,o,o,o,o,o,o,1,2,2,2,2,1,2,1,
o,o,o,o,o,o,o,o,1,2,1,1,2,2,1,2,1,
o,o,o,o,o,o,o,1,2,1,o,1,2,2,1,2,1,
o,o,o,o,o,o,1,2,1,o,o,o,1,2,1,2,1,
o,o,o,o,o,1,2,1,o,o,o,o,1,2,1,2,1,
o,o,o,o,1,2,1,o,o,o,o,o,1,2,1,2,1,
o,o,o,1,2,1,o,o,o,o,o,o,1,2,1,2,1,
o,o,1,2,1,o,o,o,o,o,o,o,o,1,1,2,1,
o,1,2,1,o,o,o,o,o,o,o,o,o,o,1,2,1,
o,o,1,o,o,o,o,o,o,o,o,o,o,o,1,2,1,
o,o,o,o,o,o,o,o,o,o,o,o,o,o,1,1,1
};

#define neCursorX 15
#define neCursorY 0


CURSOR_PEL_TYPE nCursor[] = {
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,
1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,
1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,
o,o,o,o,o,o,1,2,2,2,1,o,o,o,o,o,o,
o,o,o,o,o,1,2,2,2,2,2,1,o,o,o,o,o,
o,o,o,o,1,2,2,2,2,2,2,2,1,o,o,o,o,
o,o,o,1,2,2,2,1,2,1,2,2,2,1,o,o,o,
o,o,1,2,2,1,1,1,2,1,1,1,2,2,1,o,o,
o,1,2,1,1,o,o,1,2,1,o,o,1,1,2,1,o,
o,o,1,o,o,o,o,1,2,1,o,o,o,o,1,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,1,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o
};

#define nCursorX 8
#define nCursorY 0

CURSOR_PEL_TYPE sCursor[] = {
o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,1,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,1,o,o,o,o,1,2,1,o,o,o,o,1,o,o,
o,1,2,1,1,o,o,1,2,1,o,o,1,1,2,1,o,
o,o,1,2,2,1,1,1,2,1,1,1,2,2,1,o,o,
o,o,o,1,2,2,2,1,2,1,2,2,2,1,o,o,o,
o,o,o,o,1,2,2,2,2,2,2,2,1,o,o,o,o,
o,o,o,o,o,1,2,2,2,2,2,1,o,o,o,o,o,
o,o,o,o,o,o,1,2,2,2,1,o,o,o,o,o,o,
1,1,1,1,1,1,1,1,2,1,1,1,1,1,1,1,1,
1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,
1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1,1
};

#define sCursorX 8
#define sCursorY 15


CURSOR_PEL_TYPE wCursor[] = {
1,1,1,o,o,o,o,o,o,o,o,o,o,o,o,o,o,
1,2,1,o,o,o,o,o,1,o,o,o,o,o,o,o,o,
1,2,1,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
1,2,1,o,o,o,1,2,1,o,o,o,o,o,o,o,o,
1,2,1,o,o,1,2,2,1,o,o,o,o,o,o,o,o,
1,2,1,o,1,2,2,1,o,o,o,o,o,o,o,o,o,
1,2,1,1,2,2,2,1,o,o,o,o,o,o,o,o,o,
1,2,1,2,2,2,1,1,1,1,1,1,1,1,1,1,o,
1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,o,
1,2,1,2,2,2,1,1,1,1,1,1,1,1,1,1,o,
1,2,1,1,2,2,2,1,o,o,o,o,o,o,o,o,o,
1,2,1,o,1,2,2,1,o,o,o,o,o,o,o,o,o,
1,2,1,o,o,1,2,2,1,o,o,o,o,o,o,o,o,
1,2,1,o,o,o,1,2,1,o,o,o,o,o,o,o,o,
1,2,1,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
1,2,1,o,o,o,o,o,1,o,o,o,o,o,o,o,o,
1,1,1,o,o,o,o,o,o,o,o,o,o,o,o,o,o
};

#define wCursorX 0
#define wCursorY 8

CURSOR_PEL_TYPE eCursor[] = {
o,o,o,o,o,o,o,o,o,o,o,o,o,o,1,1,1,
o,o,o,o,o,o,o,o,1,o,o,o,o,o,1,2,1,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,1,2,1,
o,o,o,o,o,o,o,o,1,2,1,o,o,o,1,2,1,
o,o,o,o,o,o,o,o,1,2,2,1,o,o,1,2,1,
o,o,o,o,o,o,o,o,o,1,2,2,1,o,1,2,1,
o,o,o,o,o,o,o,o,o,1,2,2,2,1,1,2,1,
o,1,1,1,1,1,1,1,1,1,1,2,2,2,1,2,1,
o,1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,
o,1,1,1,1,1,1,1,1,1,1,2,2,2,1,2,1,
o,o,o,o,o,o,o,o,o,1,2,2,2,1,1,2,1,
o,o,o,o,o,o,o,o,o,1,2,2,1,o,1,2,1,
o,o,o,o,o,o,o,o,1,2,2,1,o,o,1,2,1,
o,o,o,o,o,o,o,o,1,2,1,o,o,o,1,2,1,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,1,2,1,
o,o,o,o,o,o,o,o,1,o,o,o,o,o,1,2,1,
o,o,o,o,o,o,o,o,o,o,o,o,o,o,1,1,1
};

#define eCursorX 15
#define eCursorY 8

CURSOR_PEL_TYPE handCursor[] = {
o,1,1,1,1,1,1,1,1,1,o,o,o,o,o,o,o,
1,2,2,2,2,2,2,2,2,2,1,o,o,o,o,o,o,
2,1,1,1,1,1,1,1,1,1,2,1,o,o,o,o,o,
1,2,2,2,2,2,2,2,1,1,1,2,1,o,o,o,o,
o,1,1,1,2,1,1,1,1,1,1,1,2,1,o,o,o,
o,o,o,o,1,2,2,2,1,1,1,1,2,1,o,o,o,
o,o,o,1,2,1,1,1,1,1,1,1,2,2,1,o,o,
o,o,o,o,1,2,2,2,1,1,1,2,1,1,2,1,o,
o,o,o,1,2,1,1,1,1,1,2,1,1,1,1,2,1,
o,o,o,o,1,2,2,1,1,2,1,1,1,1,1,2,1,
o,o,o,o,o,1,1,2,2,1,1,1,1,1,2,1,o,
o,o,o,o,o,o,1,2,1,1,2,1,1,2,1,o,o,
o,o,o,o,o,o,o,1,2,1,1,1,2,1,o,o,o,
o,o,o,o,o,o,o,o,1,2,1,2,1,o,o,o,o,
o,o,o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,
o,o,o,o,o,o,o,o,o,o,1,o,o,o,o,o,o,
o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o,o
};

#define handCursorX 0
#define handCursorY 1

CURSOR_PEL_TYPE moveCursor[] = {
o,o,o,o,o,o,o,o,1,o,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,1,2,2,2,1,o,o,o,o,o,o,
o,o,o,o,o,1,2,2,2,2,2,1,o,o,o,o,o,
o,o,o,o,o,o,1,1,2,1,1,o,o,o,o,o,o,
o,o,o,1,o,o,o,1,2,1,o,o,o,1,o,o,o,
o,o,1,2,1,o,o,1,2,1,o,o,1,2,1,o,o,
o,1,2,2,1,1,1,1,2,1,1,1,1,2,2,1,o,
1,2,2,2,2,2,2,2,2,2,2,2,2,2,2,2,1,
o,1,2,2,1,1,1,1,2,1,1,1,1,2,2,1,o,
o,o,1,2,1,o,o,1,2,1,o,o,1,2,1,o,o,
o,o,o,1,o,o,o,1,2,1,o,o,o,1,o,o,o,
o,o,o,o,o,o,1,1,2,1,1,o,o,o,o,o,o,
o,o,o,o,o,1,2,2,2,2,2,1,o,o,o,o,o,
o,o,o,o,o,o,1,2,2,2,1,o,o,o,o,o,o,
o,o,o,o,o,o,o,1,2,1,o,o,o,o,o,o,o,
o,o,o,o,o,o,o,o,1,o,o,o,o,o,o,o,o
};

#define moveCursorX 8
#define moveCursorY 8


#undef o

/**********************************************************************************
 * gobal vars to create Cursors
 */

unsigned int cursorColors[] = { 2, 0, 0 };

CURSOR_PEL_TYPE* cursorShapes[] = {
  defaultCursor,
  crossHairCursor,
  textCursor,
  waitCursor,
  swCursor,
  seCursor,
  nwCursor,
  neCursor,
  nCursor,
  sCursor,
  wCursor,
  eCursor,
  handCursor,
  moveCursor
};

int cursorHotSpotX[] = {
  defaultCursorX,
  crossHairCursorX,
  textCursorX,
  waitCursorX,
  swCursorX,
  seCursorX,
  nwCursorX,
  neCursorX,
  nCursorX,
  sCursorX,
  wCursorX,
  eCursorX,
  handCursorX,
  moveCursorX  
};

int cursorHotSpotY[] = {
  defaultCursorY,
  crossHairCursorY,
  textCursorY,
  waitCursorY,
  swCursorY,
  seCursorY,
  nwCursorY,
  neCursorY,
  nCursorY,
  sCursorY,
  wCursorY,
  eCursorY,
  handCursorY,
  moveCursorY  
};

