/**
 * toolkit.h - main target lib specific awt header
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * $tvt: toolkit.h,v 1.16 2001/07/23 23:03:11 samc Exp $
 */

#ifndef __toolkit_h
#define __toolkit_h

#include "fgl.h"
#include "ipl.h"

#include "config.h"
#include "config-std.h"
#include "config-mem.h"
#include "config-signal.h"

#include "../../../kaffe/kaffevm/jdebug.h"
#include "../../../kaffe/kaffevm/jmeasure.h"
#include "jfilesystem.h"
#include "jmalloc.h"
#include <jni.h>

/* to get the UNBLOCK_EXECUTE macro */
#include "jlocks.h"

#define USE_FULL_ALPHA

/* this just brings in generic types (to be used in toolkit-common-pre.h) */
#include "grlib.h"

/* this holds all common stuff not relying on target specific types
 *(outside of grlib.def)
 */
#include "../toolkit-common.h"


/*******************************************************************************
 * target lib specific types
 */

typedef struct _Image {
	CommonImage       common;

	fgl_bitmap_t      *bmp;
	fgl_monoBitmap_t  *mask;
	fgl_a8Bitmap_t *alpha;
} Image;


typedef struct _Graphics {
	CommonGraphics  common;

	fgl_color_t     bg;
	fgl_context_t   gc;
} Graphics;

#define IMAGE_TGT(_gr)  ((Image*)((_gr)->common.tgt))


typedef struct _Toolkit {
	CommonToolkit  common;

	ipl_event_t    event;

	int            nKeyCodes;
	jbyte          *keyCodes;
	int            nKeyChars;
	jchar          *keyChars;

	fgl_sprite_t   *cursors[14];

	Graphics       *lastGr;
} Toolkit;


/*******************************************************************************
 * this is the global data section
 */
#ifdef MAIN  /*****************************************************************/

Toolkit   Tk;
Toolkit   *X = &Tk;

#else        /*****************************************************************/

extern Toolkit* X;

#endif       /*****************************************************************/


/* now bring in the functions from grlib.h */
#define GRLIB_FUNCS
#include "grlib.h"

#endif
