/**
 * keytab-us.h - GRX key to Java mapping for standard US 102 keyboard
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "../vk_constants.h"

/*********************************************************************************
 * GRX key to Java keyChar  translation
 */

jchar keyChars[] = {

  /* 0x000 */    0x00,  /* Ctrl + char */
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    '\b', /* backspace */
  /*     9 */    '\t', /* tab */
  /*     a */    '\n', /* newline */
  /*     b */    0x1b, /* escape */
  /*     c */    0x00,
  /*     d */    '\n', /* enter */
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x010 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x1b, /* escape */
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x020 */    ' ',
  /*     1 */    '!',
  /*     2 */    '"',
  /*     3 */    '#',
  /*     4 */    '$',
  /*     5 */    '%',
  /*     6 */    '&',
  /*     7 */    '\'',
  /*     8 */    '(',
  /*     9 */    ')',
  /*     a */    '*',
  /*     b */    '+',
  /*     c */    ',',
  /*     d */    '-',
  /*     e */    '.',
  /*     f */    '/',

  /* 0x030 */    '0',
  /*     1 */    '1',
  /*     2 */    '2',
  /*     3 */    '3',
  /*     4 */    '4',
  /*     5 */    '5',
  /*     6 */    '6',
  /*     7 */    '7',
  /*     8 */    '8',
  /*     9 */    '9',
  /*     a */    ':',
  /*     b */    ';',
  /*     c */    '<',
  /*     d */    '=',
  /*     e */    '>',
  /*     f */    '?',

  /* 0x040 */    '@',
  /*     1 */    'A',
  /*     2 */    'B',
  /*     3 */    'C',
  /*     4 */    'D',
  /*     5 */    'E',
  /*     6 */    'F',
  /*     7 */    'G',
  /*     8 */    'H',
  /*     9 */    'I',
  /*     a */    'J',
  /*     b */    'K',
  /*     c */    'L',
  /*     d */    'M',
  /*     e */    'N',
  /*     f */    'O',

  /* 0x050 */    'P',
  /*     1 */    'Q',
  /*     2 */    'R',
  /*     3 */    'S',
  /*     4 */    'T',
  /*     5 */    'U',
  /*     6 */    'V',
  /*     7 */    'W',
  /*     8 */    'X',
  /*     9 */    'Y',
  /*     a */    'Z',
  /*     b */    '[',
  /*     c */    '\\',
  /*     d */    ']',
  /*     e */    '^',
  /*     f */    '_',

  /* 0x060 */    0x00,
  /*     1 */    'a',
  /*     2 */    'b',
  /*     3 */    'c',
  /*     4 */    'd',
  /*     5 */    'e',
  /*     6 */    'f',
  /*     7 */    'g',
  /*     8 */    'h',
  /*     9 */    'i',
  /*     a */    'j',
  /*     b */    'k',
  /*     c */    'l',
  /*     d */    'm',
  /*     e */    'n',
  /*     f */    'o',

  /* 0x070 */    'p',
  /*     1 */    'q',
  /*     2 */    'r',
  /*     3 */    's',
  /*     4 */    't',
  /*     5 */    'u',
  /*     6 */    'v',
  /*     7 */    'w',
  /*     8 */    'x',
  /*     9 */    'y',
  /*     a */    'z',
  /*     b */    '{',
  /*     c */    '|',
  /*     d */    '}',
  /*     e */    '~',
  /*     f */    0x7f, /* delete */

  /* 0x080 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x090 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x0a0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x0b0 */    '',
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x0c0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    '',
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x0d0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    '',
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    '',
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x0e0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    '',
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x0f0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    '',
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    '',
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,


  /* 0x100 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    '\t',	/* shift tab */

  /* 0x110 */    'q',
  /*     1 */    'w',
  /*     2 */    'e',
  /*     3 */    'r',
  /*     4 */    't',
  /*     5 */    'y',
  /*     6 */    'u',
  /*     7 */    'i',
  /*     8 */    'o',
  /*     9 */    'p',
  /*     a */    '(',
  /*     b */    ')',
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    'a', /* ALT + char */
  /*     f */    's',

  /* 0x120 */    'd',
  /*     1 */    'f',
  /*     2 */    'g',
  /*     3 */    'h',
  /*     4 */    'j',
  /*     5 */    'k',
  /*     6 */    'l',
  /*     7 */    ';',
  /*     8 */    '<',
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    '\\',
  /*     c */    'z',
  /*     d */    'x',
  /*     e */    'c',
  /*     f */    'v',

  /* 0x130 */    'b',
  /*     1 */    'n',
  /*     2 */    'm',
  /*     3 */    ',',
  /*     4 */    0x00,
  /*     5 */    '/',
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x140 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x150 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,  /* SHIFT + fk */
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x160 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x170 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x180 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x190 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    '\t',	/* ctrl tab */
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x1a0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    '\t',	/* alt tab */
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x1b0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x1c0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x1d0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x1e0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x1f0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00
};

int nKeyChars = sizeof(keyChars) / sizeof(keyChars[0]);


/*********************************************************************************
 * GRX key to Java keyCode (VM_xx) translation
 */
jbyte keyCodes[] =  {
  /* 0x000 */    0x00,  /* Ctrl + char */
  /*     1 */    0x01,
  /*     2 */    0x02,
  /*     3 */    0x03,
  /*     4 */    0x04,
  /*     5 */    0x05,
  /*     6 */    0x06,
  /*     7 */    0x07,
  /*     8 */    VK_BACK_SPACE,
  /*     9 */    VK_TAB,
  /*     a */    0x0a,
  /*     b */    0x0b,
  /*     c */    0x0c,
  /*     d */    VK_ENTER,
  /*     e */    0x0e,
  /*     f */    0x0f,

  /* 0x010 */    0x10,
  /*     1 */    0x11,
  /*     2 */    0x12,
  /*     3 */    0x13,
  /*     4 */    0x14,
  /*     5 */    0x15,
  /*     6 */    0x16,
  /*     7 */    0x17,
  /*     8 */    0x18,
  /*     9 */    0x19,
  /*     a */    0x1a,
  /*     b */    VK_ESCAPE,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x020 */    VK_SPACE,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    VK_MULTIPLY,
  /*     b */    VK_ADD,
  /*     c */    VK_COMMA,
  /*     d */    VK_SUBTRACT,
  /*     e */    VK_PERIOD,
  /*     f */    VK_SLASH,

  /* 0x030 */    VK_0,
  /*     1 */    VK_1,
  /*     2 */    VK_2,
  /*     3 */    VK_3,
  /*     4 */    VK_4,
  /*     5 */    VK_5,
  /*     6 */    VK_6,
  /*     7 */    VK_7,
  /*     8 */    VK_8,
  /*     9 */    VK_9,
  /*     a */    0x00,
  /*     b */    VK_SEMICOLON,
  /*     c */    0x00,
  /*     d */    VK_EQUALS,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x040 */    0x00,
  /*     1 */    VK_A,
  /*     2 */    VK_B,
  /*     3 */    VK_C,
  /*     4 */    VK_D,
  /*     5 */    VK_E,
  /*     6 */    VK_F,
  /*     7 */    VK_G,
  /*     8 */    VK_H,
  /*     9 */    VK_I,
  /*     a */    VK_J,
  /*     b */    VK_K,
  /*     c */    VK_L,
  /*     d */    VK_M,
  /*     e */    VK_N,
  /*     f */    VK_O,

  /* 0x050 */    VK_P,
  /*     1 */    VK_Q,
  /*     2 */    VK_R,
  /*     3 */    VK_S,
  /*     4 */    VK_T,
  /*     5 */    VK_U,
  /*     6 */    VK_V,
  /*     7 */    VK_W,
  /*     8 */    VK_X,
  /*     9 */    VK_Y,
  /*     a */    VK_Z,
  /*     b */    VK_OPEN_BRACKET,
  /*     c */    VK_BACK_SLASH,
  /*     d */    VK_CLOSE_BRACKET,
  /*     e */    0x00,
  /*     f */    VK_SEPARATER,

  /* 0x060 */    0x00,
  /*     1 */    VK_A,
  /*     2 */    VK_B,
  /*     3 */    VK_C,
  /*     4 */    VK_D,
  /*     5 */    VK_E,
  /*     6 */    VK_F,
  /*     7 */    VK_G,
  /*     8 */    VK_H,
  /*     9 */    VK_I,
  /*     a */    VK_J,
  /*     b */    VK_K,
  /*     c */    VK_L,
  /*     d */    VK_M,
  /*     e */    VK_N,
  /*     f */    VK_O,

  /* 0x070 */    VK_P,
  /*     1 */    VK_Q,
  /*     2 */    VK_R,
  /*     3 */    VK_S,
  /*     4 */    VK_T,
  /*     5 */    VK_U,
  /*     6 */    VK_V,
  /*     7 */    VK_W,
  /*     8 */    VK_X,
  /*     9 */    VK_Y,
  /*     a */    VK_Z,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    VK_DELETE,

  /* 0x080 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x090 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x0a0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x0b0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x0c0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x0d0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x0e0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x0f0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,


  /* 0x100 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    VK_TAB,	/* shift tab */

  /* 0x110 */    VK_Q,	/* alt + char */
  /*     1 */    VK_W,
  /*     2 */    VK_E,
  /*     3 */    VK_R,
  /*     4 */    VK_T,
  /*     5 */    VK_Y,
  /*     6 */    VK_U,
  /*     7 */    VK_I,
  /*     8 */    VK_O,
  /*     9 */    VK_P,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    VK_A,
  /*     f */    VK_S,

  /* 0x120 */    VK_D,
  /*     1 */    VK_F,
  /*     2 */    VK_G,
  /*     3 */    VK_H,
  /*     4 */    VK_J,
  /*     5 */    VK_K,
  /*     6 */    VK_L,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    VK_Z,
  /*     d */    VK_X,
  /*     e */    VK_C,
  /*     f */    VK_V,

  /* 0x130 */    VK_B,
  /*     1 */    VK_N,
  /*     2 */    VK_M,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    VK_F1,
  /*     c */    VK_F2,
  /*     d */    VK_F3,
  /*     e */    VK_F4,
  /*     f */    VK_F5,

  /* 0x140 */    VK_F6,
  /*     1 */    VK_F7,
  /*     2 */    VK_F8,
  /*     3 */    VK_F9,
  /*     4 */    VK_F10,
  /*     5 */    VK_F11,
  /*     6 */    VK_F12,
  /*     7 */    VK_HOME,
  /*     8 */    VK_UP,
  /*     9 */    VK_PAGE_UP,
  /*     a */    0x00,
  /*     b */    VK_LEFT,
  /*     c */    0x00,
  /*     d */    VK_RIGHT,
  /*     e */    0x00,
  /*     f */    VK_END,

  /* 0x150 */    VK_DOWN,
  /*     1 */    VK_PAGE_DOWN,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    VK_F1,  /* SHIFT + fk */
  /*     5 */    VK_F2,
  /*     6 */    VK_F3,
  /*     7 */    VK_F4,
  /*     8 */    VK_F5,
  /*     9 */    VK_F6,
  /*     a */    VK_F7,
  /*     b */    VK_F8,
  /*     c */    VK_F9,
  /*     d */    VK_F10,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x160 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x170 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    VK_END,
  /*     6 */    0x00,
  /*     7 */    VK_HOME,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x180 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x190 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    VK_TAB,	/* ctrl tab */
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x1a0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    VK_TAB,	/* alt tab */
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x1b0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    VK_HOME,
  /*     9 */    VK_END,
  /*     a */    VK_PAGE_UP,
  /*     b */    VK_PAGE_DOWN,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x1c0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x1d0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x1e0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00,

  /* 0x1f0 */    0x00,
  /*     1 */    0x00,
  /*     2 */    0x00,
  /*     3 */    0x00,
  /*     4 */    0x00,
  /*     5 */    0x00,
  /*     6 */    0x00,
  /*     7 */    0x00,
  /*     8 */    0x00,
  /*     9 */    0x00,
  /*     a */    0x00,
  /*     b */    0x00,
  /*     c */    0x00,
  /*     d */    0x00,
  /*     e */    0x00,
  /*     f */    0x00
};

int nKeyCodes = sizeof(keyCodes) / sizeof(keyCodes[0]);
