/**
 * clr.c - platform specific color management
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */


#include "toolkit.h"


/******************************************************************************
 * generic exported methods
 */

#define _clrGetPixelValue     EXPORT(clrGetPixelValue)
#define _clrSetSystemColors   EXPORT(clrSetSystemColors)
#define _clrGetColorModel     EXPORT(clrGetColorModel)
#define _clrBright            EXPORT(clrBright)
#define _clrDark              EXPORT(clrDark)


/******************************************************************************
 * import generic color functionality
 */
#include "../clr-common.c"

void
initColorMapping ( JNIEnv* env, Toolkit* X )
{
	_initColorMapping( env, X);
	
	/* image init stuff (we need to set pixels in bitmaps of display
	 * depth)
	 */
	if ( _(X)->colorMode == CM_PSEUDO ){
		X->pal = _(_(X)->map.pclr)->clrs;
	}
	else if ( _(X)->colorMode == CM_VGA ){
		X->pal = _(_(X)->map.vclr)->clrs;
	}
}
