/**
 * img.c - platform specific image support (MGL)
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */



#include "toolkit.h"

/******************************************************************************
 * generic (common) exported methods
 */
#define _imgCreateImage         EXPORT(imgCreateImage)
#define _imgFreeImage           EXPORT(imgFreeImage)
#define _imgCreateScreenImage   EXPORT(imgCreateScreenImage)
#define _imgCreateScaledImage   EXPORT(imgCreateScaledImage)

#define _imgSetIdxPels          EXPORT(imgSetIdxPels)
#define _imgSetRGBPels          EXPORT(imgSetRGBPels)
#define _imgComplete            EXPORT(imgComplete)

#define _imgCreateFromFile      EXPORT(imgCreateFromFile)
#define _imgCreateFromData      EXPORT(imgCreateFromData)
#define _imgProduceImage        EXPORT(imgProduceImage)
#define _imgSetFrame            EXPORT(imgSetFrame)
#define _imgGetWidth            EXPORT(imgGetWidth)
#define _imgGetHeight           EXPORT(imgGetHeight)
#define _imgGetFrameCount       EXPORT(imgGetFrameCount)
#define _imgGetLoopCount        EXPORT(imgGetLoopCount)
#define _imgGetLatency          EXPORT(imgGetLatency)
#define _imgGetNextFrame        EXPORT(imgGetNextFrame)


/******************************************************************************
 * import generic functionality
 */
#include "../img-common.c"

