/**
 * keytab-us.h - MGL key to Java mapping for standard US 102 keyboard
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "../vk_constants.h"

/* MGL scancode to Java keyCode translation */

jbyte keyCodes[] =  {
  0,             /* -                       = 0x00 */
  VK_ESCAPE,     /* KB_esc       			= 0x01 */
  VK_1,          /* KB_1					= 0x02 */
  VK_2,          /* KB_2					= 0x03 */
  VK_3,          /* KB_3					= 0x04 */
  VK_4,          /* KB_4					= 0x05 */
  VK_5,          /* KB_5					= 0x06 */
  VK_6,          /* KB_6					= 0x07 */
  VK_7,          /* KB_7					= 0x08 */
  VK_8,          /* KB_8					= 0x09 */
  VK_9,          /* KB_9					= 0x0A */
  VK_0,          /* KB_0					= 0x0B */
  VK_SUBTRACT,   /* KB_minus				= 0x0C */
  VK_EQUALS,     /* KB_equals				= 0x0D */
  VK_BACK_SPACE, /* KB_backspace			= 0x0E */
  VK_TAB,        /* KB_tab       			= 0x0F */

  VK_Q,          /* KB_Q					= 0x10 */
  VK_W,          /* KB_W					= 0x11 */
  VK_E,          /* KB_E					= 0x12 */
  VK_R,          /* KB_R					= 0x13 */
  VK_T,          /* KB_T					= 0x14 */
  VK_Y,          /* KB_Y					= 0x15 */
  VK_U,          /* KB_U					= 0x16 */
  VK_I,          /* KB_I					= 0x17 */
  VK_O,          /* KB_O					= 0x18 */
  VK_P,          /* KB_P					= 0x19 */
  VK_OPEN_BRACKET,  /* KB_leftSquareBrace	    = 0x1A */
  VK_CLOSE_BRACKET, /* KB_rightSquareBrace	    = 0x1B */
  VK_ENTER,      /* KB_enter     			= 0x1C */
  VK_CONTROL,    /* KB_leftCtrl             = 0x1D */
  VK_A,          /* KB_A					= 0x1E */
  VK_S,          /* KB_S					= 0x1F */

  VK_D,          /* KB_D					= 0x20 */
  VK_F,          /* KB_F					= 0x21 */
  VK_G,          /* KB_G					= 0x22 */
  VK_H,          /* KB_H					= 0x23 */
  VK_J,          /* KB_J					= 0x24 */
  VK_K,          /* KB_K					= 0x25 */
  VK_L,          /* KB_L					= 0x26 */
  VK_SEMICOLON,  /* KB_semicolon			= 0x27 */
  VK_QUOTE,      /* KB_apostrophe			= 0x28 */
  VK_BACK_QUOTE, /* KB_tilde     			= 0x29 */
  VK_SHIFT,      /* KB_leftShift			= 0x2A */
  VK_BACK_SLASH, /* KB_backSlash			= 0x2B */
  VK_Z,          /* KB_Z					= 0x2C */
  VK_X,          /* KB_X					= 0x2D */
  VK_C,          /* KB_C					= 0x2E */
  VK_V,          /* KB_V					= 0x2F */

  VK_B,          /* KB_B					= 0x30 */
  VK_N,          /* KB_N					= 0x31 */
  VK_M,          /* KB_M					= 0x32 */
  VK_COMMA,      /* KB_comma				= 0x33 */
  VK_PERIOD,     /* KB_period				= 0x34 */
  VK_SLASH,      /* KB_divide				= 0x35 */
  VK_SHIFT,      /* KB_rightShift           = 0x36 */
  VK_MULTIPLY,   /* KB_padTimes 			= 0x37 */
  VK_ALT,        /* KB_leftAlt              = 0x38 */
  VK_SPACE,      /* KB_space				= 0x39 */
  VK_CAPS_LOCK,  /* KB_capsLock			    = 0x3A */
  VK_F1,         /* KB_F1        			= 0x3B */
  VK_F2,         /* KB_F2        			= 0x3C */
  VK_F3,         /* KB_F3        			= 0x3D */
  VK_F4,         /* KB_F4        			= 0x3E */
  VK_F5,         /* KB_F5        			= 0x3F */

  VK_F6,         /* KB_F6        			= 0x40 */
  VK_F7,         /* KB_F7        			= 0x41 */
  VK_F8,         /* KB_F8        			= 0x42 */
  VK_F9,         /* KB_F9        			= 0x43 */
  VK_F10,        /* KB_F10       			= 0x44 */
  VK_NUM_LOCK,   /* KB_numLock			    = 0x45 */
  VK_SCROLL_LOCK,/* KB_scrollLock			= 0x46 */
  VK_HOME,       /* KB_home      			= 0x47 */
  VK_UP,         /* KB_up        			= 0x48 */
  VK_PAGE_UP,    /* KB_pageUp    			= 0x49 */
  VK_SUBTRACT,   /* KB_padMinus 			= 0x4A */
  VK_LEFT,       /* KB_left      			= 0x4B */
  0,             /* KB_padCenter    		= 0x4C */
  VK_RIGHT,      /* KB_right     			= 0x4D */
  VK_ADD,        /* KB_padPlus  			= 0x4E */
  VK_END,        /* KB_end       			= 0x4F */
  
  VK_DOWN,       /* KB_down      			= 0x50 */
  VK_PAGE_DOWN,  /* KB_pageDown  			= 0x51 */
  VK_INSERT,     /* KB_insert    			= 0x52 */
  VK_DELETE,     /* KB_delete    			= 0x53 */
  0,             /* KB_sysReq               = 0x54 */
  0,             /* -                       = 0x55 */
  0,             /* -                       = 0x56 */
  VK_F11,        /* KB_F11				    = 0x57 */
  VK_F12,        /* KB_F12       			= 0x58 */
  0,             /* -                       = 0x59 */
  0,             /* -                       = 0x5A */
  0,             /* KB_leftWindows		    = 0x5B */
  0,             /* KB_rightWindows		    = 0x5C */
  0,             /* KB_menu				    = 0x5D */
  0,             /* -                       = 0x5E */
  0,             /* -                       = 0x5F */
  
  VK_ENTER,      /* KB_padEnter			    = 0x60 */
  VK_DIVIDE,     /* KB_padDivide			= 0x61 */
  VK_LEFT,       /* KB_padLeft      		= 0x62 */
  VK_RIGHT,      /* KB_padRight     		= 0x63 */
  VK_UP,         /* KB_padUp        		= 0x64 */
  VK_DOWN,       /* KB_padDown      		= 0x65 */
  VK_INSERT,     /* KB_padInsert    		= 0x66 */
  VK_DELETE,     /* KB_padDelete    		= 0x67 */
  VK_HOME,       /* KB_padHome      		= 0x68 */
  VK_END,        /* KB_padEnd       		= 0x69 */
  VK_PAGE_UP,    /* KB_padPageUp    		= 0x6A */
  VK_PAGE_DOWN,  /* KB_padPageDown  		= 0x6B */
  VK_CONTROL,    /* KB_rightCtrl            = 0x6C */
  VK_ALT,        /* KB_rightAlt             = 0x6D */
  0,             /* -                       = 0x6E */
  0              /* -                       = 0x6F */
};

int nKeyCodes = sizeof(keyCodes) / sizeof( keyCodes[0]);
