/**
* lbl.cpp - static text
*
* Copyright (c) 1999
*      Transvirtual Technologies, Inc.  All rights reserved.
*
* See the file "license.terms" for information on usage and redistribution 
* of this file. 
*/

#include "toolkit.hpp"

class KLabel:public KWnd {
public:		
	KLabel( HWND parent, TCHAR* lbl) {
		int style = DEF_WND_STYLE | SS_LEFTNOWORDWRAP;
#if !defined(UNDER_CE)
		style |= SS_CENTERIMAGE;
#endif
		hwnd = CreateWindow( TEXT("STATIC"), lbl, style, 0, 0, 0, 0,
			parent, (HMENU)0, NULL, NULL);
		getDefWndProc(false);
	}

	void KLabel::setJustify( int adjust) {
		int style = GetWindowLong( hwnd, GWL_STYLE);
		switch( adjust) {
		case 0:	//left
			style &= ~(SS_CENTER | SS_RIGHT);
			style |= SS_LEFTNOWORDWRAP;
			break;
		case 1:	//center
			style &= ~(SS_LEFTNOWORDWRAP | SS_RIGHT);
			style |= SS_CENTER;
			break;
		case 2:	//right
			style &= ~(SS_CENTER | SS_LEFTNOWORDWRAP);
			style |= SS_RIGHT;
			break;
		}
		
		SetWindowLong( hwnd, GWL_STYLE, style);
	}
};



/*************************
*	exported functions
**************************/
#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

extern "C" {
	
	JNIEXPORT void* JNICALL
		Java_java_awt_Toolkit_lblCreateLabel ( JNIEnv* env, jclass clazz, KWnd* parent, jstring label )
	{
		return ( new KLabel( parent->hwnd, java2WinString( env, X, label) ));
	}
	
	JNIEXPORT void JNICALL
		Java_java_awt_Toolkit_lblSetText ( JNIEnv* env, jclass clazz, KLabel* wnd, jstring label)
	{
		wnd->setText( label);
	}
	
	JNIEXPORT void JNICALL
		Java_java_awt_Toolkit_lblSetJustify ( JNIEnv* env, jclass clazz, KLabel* wnd, jint adjust )
	{
		wnd->setJustify( adjust);
	}
	
}