/**
* tlk.cpp - 
*
* Copyright (c) 1999
*      Transvirtual Technologies, Inc.  All rights reserved.
*
* See the file "license.terms" for information on usage and redistribution 
* of this file. 
*/


#define MAIN

#include "toolkit.hpp"
#include "tlkprops.hpp"

void initWndInsets();

void registerClasses()
{
	WNDCLASS	wc;
	
	// generic toplevel class
#if !defined(UNDER_CE)
	wc.style = CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
#else
	wc.style = CS_HREDRAW | CS_VREDRAW;
#endif
	wc.lpfnWndProc = WndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = 0;
	wc.hIcon = APPICON;
	wc.lpszMenuName = 0;
	wc.hCursor = (HCURSOR)0;
	wc.hbrBackground = (HBRUSH)0;
	wc.lpszClassName = TEXT("window");
	
	RegisterClass ( &wc);
	
	//generic widget class ( used for canvas and panel)
#if !defined(UNDER_CE)
	wc.style = CS_OWNDC;
#else
	wc.style = 0;
#endif
	wc.hIcon = (HICON)0;
	wc.lpszClassName = TEXT("widget");
	
	RegisterClass ( &wc);
}



/*******************
* exported functions
********************/
#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

extern "C" {

JNIEXPORT jboolean JNICALL
Java_java_awt_NativeCollector_ncInit ( JNIEnv* env, jclass clazz, jstring name )
{
	X->osi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx( &(X->osi));
	
	registerClasses();
	
	X->wakeUp = CreateWindow( TEXT("window"), TEXT(""), WS_OVERLAPPEDWINDOW, 0, 0, 0, 0,
		NULL, NULL, NULL, NULL);
	X->display = GetDC( X->wakeUp);
	initWndInsets();
	return (JNI_TRUE);
}

JNIEXPORT void JNICALL
Java_java_awt_NativeCollector_ncLoop ( JNIEnv* env, jclass clazz )
{
	MSG msg;
    while ( GetMessage( &msg, NULL, 0, 0) == TRUE) {
		TranslateMessage( &msg);
		DispatchMessage( &msg);
	}
}

JNIEXPORT jint JNICALL
Java_java_awt_Toolkit_tlkProperties ( JNIEnv* env, jclass clazz )
{
	return (TLK_NATIVE_DISPATCHER_LOOP | TLK_IS_DISPATCH_EXCLUSIVE );
}
	
JNIEXPORT jboolean JNICALL
Java_java_awt_Toolkit_tlkInit ( JNIEnv* env, jclass clazz, jstring name )
{
	X->nBuf = 128;
	X->buf = (TCHAR*)AWT_MALLOC( X->nBuf * sizeof(TCHAR));
	X->lastHwnd = (HWND)-1;
	
	Tlk = clazz;
	JniEnv = env;
	
	return JNI_TRUE;
}

JNIEXPORT void JNICALL
Java_java_awt_Toolkit_tlkTerminate ( JNIEnv* env, jclass clazz )
{
	DeleteDC( X->display);
	if ( X->wakeUp ) {
		DestroyWindow( X->wakeUp);
		X->wakeUp = 0;
	}
}


JNIEXPORT jstring JNICALL
Java_java_awt_Toolkit_tlkVersion ( JNIEnv* env, jclass clazz )
{
#if !defined(UNDER_CE)
	return env->NewStringUTF( "Win32");
#else
	return env->NewStringUTF( "WinCE");
#endif
}

JNIEXPORT jint JNICALL
Java_java_awt_Toolkit_tlkGetResolution ( JNIEnv* env, jclass clazz )
{
	return GetDeviceCaps( X->display, LOGPIXELSX );
}

JNIEXPORT jint JNICALL
Java_java_awt_Toolkit_tlkGetScreenHeight ( JNIEnv* env, jclass clazz )
{
	return GetSystemMetrics( SM_CYSCREEN);
}

JNIEXPORT jint JNICALL
Java_java_awt_Toolkit_tlkGetScreenWidth ( JNIEnv* env, jclass clazz )
{
	return GetSystemMetrics( SM_CXSCREEN);
}

JNIEXPORT jint JNICALL
Java_java_awt_Toolkit_tlkGetMenubarHeight ( JNIEnv* env, jclass clazz )
{
	return GetSystemMetrics( SM_CYMENU);
}

JNIEXPORT jint JNICALL
Java_java_awt_Toolkit_tlkGetScrollbarWidth ( JNIEnv* env, jclass clazz )
{
	return GetSystemMetrics( SM_CXVSCROLL);
}

JNIEXPORT void JNICALL
Java_java_awt_Toolkit_tlkSync ( JNIEnv* env, jclass clazz )
{
}

JNIEXPORT void JNICALL
Java_java_awt_Toolkit_tlkFlush ( JNIEnv* env, jclass clazz )
{
	GFLUSH();
}

JNIEXPORT void JNICALL
Java_java_awt_Toolkit_tlkBeep ( JNIEnv* env, jclass clazz )
{
	BEEP();
}

JNIEXPORT void JNICALL
Java_java_awt_Toolkit_tlkDisplayBanner ( JNIEnv* env, jclass clazz, jstring banner )
{
}
	
}