/**
 * widget.cpp - generic widget class used for canvas and panel
 *
 * Copyright (c) 1999
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "toolkit.hpp"

	class KWidget:public KWnd {
	public:		
		KWidget( HWND parent) {
			int style = WS_CHILD | WS_VISIBLE | WS_CLIPCHILDREN;
			hwnd = CreateWindow( TEXT("widget"), NULL, style, 0, 0, 0, 0,
				parent, (HMENU)0, NULL, NULL);
			getDefWndProc( true);
		}

	bool KWidget::OnPaint( int x, int y, int width, int height){
		PAINTSTRUCT ps;
		HDC hdc;

		hdc = BeginPaint( hwnd, &ps);

		if ( ps.fErase ){
			FillRect( hdc, &ps.rcPaint, brush);
		}

		EndPaint( hwnd, &ps);

		JniEnv->CallStaticObjectMethod( PaintEvent, getPaintEvent,
			srcIdx, ps.fErase ? UPDATE : PAINT, x, y, width, height );
		return true;
	}

	};


	
	/*************************
	*	exported functions
	**************************/
#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT
extern "C" {

	JNIEXPORT void* JNICALL
		Java_java_awt_Toolkit_widgetCreateWidget ( JNIEnv* env, jclass clazz, KWnd* parent)
	{
		return (new KWidget( parent->hwnd));
	}

}