/*
 * external_native.h
 * Wrap up the calls between Kaffe and native method calls for systems
 *  which don't support shared libraries.
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#ifndef __external_native_h
#define __external_native_h

#if defined(NO_SHARED_LIBRARIES)

#define	KAFFE_LIBRARY(N)

#define	KAFFE_NATIVE(F)			extern void F();

#include "../../libraries/clib/external_wrappers.h"

#undef	KAFFE_NATIVE
#define	KAFFE_NATIVE(F)			{ #F, F },

const nativeFunction default_natives[] = {

#include "../../libraries/clib/external_wrappers.h"

	{ 0, 0 }
};

#undef	KAFFE_NATIVE
#define	KAFFE_NATIVE(F)
#undef	KAFFE_LIBRARY
#define	KAFFE_LIBRARY(N)		LIBRARYPREFIX #N LIBRARYSUFFIX,

const char* default_libraries[] = {

#include "../../libraries/clib/external_wrappers.h"

	0

};

#undef	KAFFE_NATIVE

#else /* NO_SHARED_LIBRARIES */

const nativeFunction default_natives[] = {
	{ 0, 0 }
};

const char* default_libraries[] = {
	0
};

#endif /* NO_SHARED_LIBRARIES */

#endif
