/*
 * java.io.FileDescriptor.c
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include "config-io.h"
#include "files.h"
#include "jsyscall.h"
#include "../../../kaffe/kaffevm/support.h"
#include "jni.h"

#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

/*
 * Synchronise this file descriptor with the real file system.
 */
JNIEXPORT jint JNICALL
Java_java_io_FileDescriptor_sync0(JNIEnv* env, jobject fileio, int fd)
{
#if defined(HAVE_FSYNC)
	return (fsync(fd));
#elif defined(HAVE_SYNC)
	/* Fallback on a full sync */
	sync();
#else
	/* Well we can't do anything can we? */
	return (-1);
#endif
}
