/*
 * kaffe.management.Classpath.c
 *
 * Copyright (c) 1998
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "../../../kaffe/kaffevm/classpath.h"

#include "config.h"
#include "config-std.h"
#include <jni.h>
#include "../../../kaffe/kaffevm/classpath.h"
#include "../../../kaffe/kaffevm/gtypes.h"
#include "../../../kaffe/kaffevm/support.h"

#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

 /*
 * Append a JAR/ZIP to the classpath.
 */
JNIEXPORT void JNICALL
Java_kaffe_management_Classpath_append0(JNIEnv* env, jclass cls, jstring str)
{
	char* buf = (*env)->GetStringUTFChars(env, str, 0);
	(*Kaffe_ClasspathInterface.append)(buf);
	(*env)->ReleaseStringUTFChars(env, str, buf);
}

/*
 * Prepend a JAR/ZIP to the classpath.
 */
JNIEXPORT void JNICALL
kaffe_management_Classpath_prepend0(JNIEnv* env, jclass cls, jstring str)
{
	char* buf = (*env)->GetStringUTFChars(env, str, 0);
	(*Kaffe_ClasspathInterface.prepend)(buf);
	(*env)->ReleaseStringUTFChars(env, str, buf);
}
