/*
 * java.lang.Math.c
 *
 * Copyright (c) 1996 - 2001
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include "config-math.h"
#include <jni.h>

#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_sin(JNIEnv* env, jclass math, jdouble v)
{
	return (sin(v));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_cos(JNIEnv* env, jclass math, jdouble v)
{
	return (cos(v));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_tan(JNIEnv* env, jclass math, jdouble v)
{
	return (tan(v));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_asin(JNIEnv* env, jclass math, jdouble v)
{
	return (asin(v));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_acos(JNIEnv* env, jclass math, jdouble v)
{
	return (acos(v));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_atan(JNIEnv* env, jclass math, jdouble v)
{
	return (atan(v));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_exp(JNIEnv* env, jclass math, jdouble v)
{
	return (exp(v));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_log(JNIEnv* env, jclass math, jdouble v)
{
	return (log(v));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_sqrt(JNIEnv* env, jclass math, jdouble v)
{
	return (sqrt(v));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_IEEEremainder(JNIEnv* env, jclass math, jdouble v1, jdouble v2)
{
	return (IEEERemainder(v1, v2));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_ceil(JNIEnv* env, jclass math, jdouble v)
{
	return (ceil(v));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_floor(JNIEnv* env, jclass math, jdouble v)
{
	return (floor(v));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_rint(JNIEnv* env, jclass math, jdouble v)
{
	jdouble fv;
	jdouble cv;

	fv = floor(v);
	if (v - fv < 0.5) {
		return (fv);
	}
	cv = ceil(v);
	if (cv - v < 0.5) {
		return (cv);
	}
	/* Distance is equal - pick the even one */
	if ((fv / 2) * 2 == fv) {
		return (fv);
	}
	return (cv);
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_atan2(JNIEnv* env, jclass math, jdouble v1, jdouble v2)
{
	return (atan2(v1, v2));
}

JNIEXPORT jdouble JNICALL
Java_java_lang_Math_pow(JNIEnv* env, jclass math, jdouble v1, jdouble v2)
{
	return (pow(v1, v2));
}
