/*
 * java.lang.Thread.c
 *
 * Copyright (c) 1996 - 2001
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include "../../../kaffe/kaffevm/gtypes.h"
#include <jni.h>
#include "../../../kaffe/kaffevm/threads.h"
#include "../../../kaffe/kaffevm/locks.h"
#include "../../../kaffe/kaffevm/support.h"

#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

JNIEXPORT jobject JNICALL
Java_java_lang_Thread_currentThread(JNIEnv* env, jclass thd)
{
	return (Kaffe_TI_currentJava());
}

/*
 * Yield processor to another thread of the same priority.
 */
JNIEXPORT void JNICALL
Java_java_lang_Thread_yield0(JNIEnv* env, jclass thd)
{
	Kaffe_TI_yield();
}

/*
 * Start this thread running.
 */
JNIEXPORT void JNICALL
Java_java_lang_Thread_start0(JNIEnv* env, jobject this)
{
	startThread((struct Hjava_lang_Thread*)this);
}

/*
 * Number of stack frames.
 */
JNIEXPORT jint JNICALL
Java_java_lang_Thread_countStackFrames(JNIEnv* env, jobject this)
{
	return (1);
}

/*
 * Change thread priority.
 */
JNIEXPORT void JNICALL
Java_java_lang_Thread_setPriority0(JNIEnv* env, jobject this, jint prio)
{
	setPriorityThread((struct Hjava_lang_Thread*)this, prio);
}

/*
 * Attempt to violently terminate this thread.
 */
JNIEXPORT void JNICALL
Java_java_lang_Thread_destroy0(JNIEnv* env, jobject this)
{
	destroyThread((struct Hjava_lang_Thread*)this);
}

/*
 * Finalize the thread.
 */
JNIEXPORT void JNICALL
Java_java_lang_Thread_finalize0(JNIEnv* env, jobject this)
{
	finalizeThread((struct Hjava_lang_Thread*)this);
}

/*
 * Stop a thread.
 */
JNIEXPORT void JNICALL
Java_java_lang_Thread_stop0(JNIEnv* env, jobject this, jobject exception)
{
}

/*
 * Interrupt a thread.
 */
JNIEXPORT void JNICALL
Java_java_lang_Thread_interrupt0(JNIEnv* env, jobject this)
{
	interruptThread((struct Hjava_lang_Thread*)this);
}
