/*
 * java.lang.Throwable.c
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include <jni.h>
#include "../../../kaffe/kaffevm/objects.h"
#include "../../../kaffe/kaffevm/support.h"
#include "../../../kaffe/kaffevm/engine.h"

#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

/*
 * Fill in stack trace information - don't know what thought.
 */
JNIEXPORT jobject JNICALL
Java_java_lang_Throwable_fillInStackTrace(JNIEnv* env, jobject throwable)
{
	static jfieldID backtrace;
	jobject trace;

	if (backtrace == 0) {
		backtrace = (*env)->GetFieldID(env, (*env)->GetObjectClass(env, throwable), "backtrace", "java.lang.Object");
	}

	trace = (jobject)buildStackTraceGC();
	(*env)->SetObjectField(env, throwable, backtrace, trace);

	return (throwable);
}

/*
 * Dump the stack trace to the given stream.
 */
JNIEXPORT void JNICALL
Java_java_lang_Throwable_printStackTrace0(JNIEnv* env, jobject o, jobject p)
{
	printStackTrace((struct Hjava_lang_Throwable*)o, (struct Hjava_lang_Object*)p, 0);
}
