/*
 * java.util.zip.Adler32.c
 *
 * Copyright (c) 1996, 1997
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

#include "config.h"
#include "config-std.h"
#include "config-mem.h"
#include <jni.h>
#include "../../../kaffe/kaffevm/support.h"

#if defined(HAVE_LIBZ) && defined(HAVE_ZLIB_H)
#define	IMPLEMENTED	1
#include <zlib.h>
#endif

#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

JNIEXPORT jint JNICALL
Java_java_util_zip_Adler32_update0(JNIEnv* env, jobject this, jint adler, jarray buf, jint from, jint len)
{
#if defined(IMPLEMENTED)
	int val;
	jbyte* body;

	body = (*env)->GetByteArrayElements(env, buf, 0);
	val = adler32(adler, &body[from], len);
	(*env)->ReleaseByteArrayElements(env, buf, body, JNI_ABORT);
	return (val);
#else
	unimp("java_util_zip_Adler32_update");
#endif
}

JNIEXPORT jint JNICALL
Java_java_util_zip_Adler32_update1(JNIEnv* env, jobject this, jint adler, jbyte b)
{
#if defined(IMPLEMENTED)
	return (adler32(adler, &b, sizeof(b)));
#else
	unimp("java_util_zip_Adler32_update1");
#endif
}
