/**
 * Copyright (c) 2000
 *    Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 *
 * @author P.C.Mehlitz
 */

package java.awt;

import java.awt.image.ImageConsumer;
import kaffe.awt.Defaults;
import kaffe.util.Ptr;

class NativeDataProducer
  extends NativeImageProducer
{
	byte[] data;
	int off;
	int len;

NativeDataProducer ( byte[] data, int off, int len, Image target ) {
	super( target);

	this.data = data;
	this.off = off;
	this.len = len;
}

void produce() {
	Ptr ptr;

	if ( (ptr = Toolkit.imgCreateFromData( this, data, off, len)) != null ){
		produce( ptr);
	}
	else {
		imageComplete( ImageConsumer.IMAGEERROR | ImageConsumer.IMAGEABORTED);
	}
}
}
