/**
 * Copyright (c) 2000
 *    Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 *
 * @author P.C.Mehlitz
 */

package java.awt;

import java.awt.image.ImageConsumer;
import java.awt.image.ImageObserver;
import java.io.File;
import kaffe.awt.Defaults;
import kaffe.util.Ptr;

class NativeFileProducer
  extends NativeImageProducer
{
	File file;

NativeFileProducer ( File file, Image target ) {
	super( target);

	this.file = file;
}

void produce () {
	Ptr ptr;

	if ( file.exists() &&
	     (ptr = Toolkit.imgCreateFromFile( this, file.getAbsolutePath())) != null ){
		produce( ptr);
	}
	else {
		imageComplete( ImageConsumer.IMAGEERROR | ImageConsumer.IMAGEABORTED);
	}
}
}
