/**
 * Copyright (c) 2000
 *    Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 *
 * @author P.C.Mehlitz
 */

package java.awt;

import java.awt.image.ImageConsumer;
import java.net.HttpURLConnection;
import java.net.URL;
import java.net.URLConnection;

class NativeURLProducer
  extends NativeImageProducer
{
	URL url;
	URLConnection conn;

NativeURLProducer ( URL url, Image target ) {
	super( target);

	this.url = url;
}

NativeURLProducer ( URLConnection conn ) {
	this.url = conn.getURL();
	this.conn = conn;
}

NativeURLProducer ( URLConnection conn, Image target ) {
	super( target);

	this.url = conn.getURL();
	this.conn = conn;
}

void produce () {
	try {
		if ( conn == null ){
			conn = url.openConnection();
		}

		produce( conn);
	}
	catch ( Exception x ) {
		flagProductionFailure();
	}
}

void stopProduction () {
	if ( (conn != null) && (conn instanceof HttpURLConnection) ){
		((HttpURLConnection)conn).disconnect();
		// this will cause a IOException in the next fillBuffer() 
	}
}
}
