package java.awt;

import java.applet.Applet;
import java.applet.AppletContext;
import java.applet.AudioClip;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.InetAddress;
import java.net.ServerSocket;
import java.net.Socket;
import java.net.URL;
import java.util.Enumeration;
import java.util.StringTokenizer;
import java.util.Vector;

class AppletWindow
  extends Window
  implements AppletContext
{
	Applet applet;
	long parent;
	static int port = 9456;
	static boolean log = true;

AppletWindow ( long parent, int x, int y, int width, int height ){

//System.out.println( "AppletWindow created: "
//    + parent + ", " + x + "," + y + "," + width + "," + height);

	this.parent = parent;
	setBounds( x, y, width, height);
}

void createNative () {
	nativeData = Toolkit.wndCreateEmbedded( parent,
	                                        x, y, width, height,
	                                        cursor.type, bgClr.nativeValue);
}

public Applet getApplet( String name) {
	return null;
}

public Enumeration getApplets () {
	return null;
}

static String[] getArgs ( String input ) {
	Vector v = new Vector( 5);
	StringTokenizer st = new StringTokenizer( input);
	String[] args;
	String s;
	int i, n;
	
	while ( st.hasMoreTokens() )
		v.addElement( st.nextToken());

	n = v.size();
	args = new String[n];
	
	for ( i=0; i<n; i++ )
		args[i] = (String)v.elementAt( i);

	return args;
}

public AudioClip getAudioClip( URL url) {
	return null;
}

public Image getImage( URL url) {
	return null;
}

public static void main ( String[] args ) {
	try {
		InetAddress host = InetAddress.getLocalHost();
		Socket s = new Socket( host, port);

		InputStream  cis = s.getInputStream();
		BufferedReader cir = new BufferedReader( new InputStreamReader( cis));

		if ( log ) {
			System.out.println( "Applet request server started on port: " + port);
		}

		do {
			if ( log ) {
				System.out.println( "Applet request server ready..");
			}
		} while ( processRequest( cir) );
		
		s.close();
	}
	catch ( IOException x ) {
		x.printStackTrace();		
		return;
	}
}

static boolean processRequest ( BufferedReader cir ) {
	String    input;
	String[]  args = null;

	long parent;
	int x, y, width, height;
	String cls;
	AppletWindow aw;
	Class clazz;
	Applet applet;

	try {
		input = cir.readLine();
		if ( input != null ) {
			if ( input.equals( "STOP") ){
				return false;
			}
		
			if ( log ){
				System.out.print( "Applet request: ");
				System.out.println( input);
			}

			args = getArgs( input);
			
			try {
				// <hex-parent> <x> <y> <width> <height> <applet class> [<params> ..]
				if ( args.length > 5 ) {
					parent = Long.parseLong( args[0], 16);
					x = Integer.parseInt( args[1]);
					y = Integer.parseInt( args[2]);
					width = Integer.parseInt( args[3]);
					height = Integer.parseInt( args[4]);
					cls = args[5];
					
					// that should of course use its own ClassLoader
					if ( (clazz = Class.forName( cls)) != null ){ 
						applet = (Applet) clazz.newInstance();
						aw = new AppletWindow( parent, x, y, width, height);
					
						aw.setApplet( applet);
						aw.setVisible( true);
						
						applet.start();
					}
				}
			}
			catch ( Exception exx ) {
				System.err.println( "error processing request: " + input);
				exx.printStackTrace();
			}
		}
	}
	catch ( IOException ex ) {
		System.err.println( "Applet request read error");
	}
	
	return true;
}

void setApplet ( Applet applet ) {
	if ( this.applet != null ) {
		this.applet.stop();
		remove( applet);
	}

	this.applet = applet;
	add( applet);
}

public void showDocument( URL url) {
}

public void showDocument( URL url, String target) {
}

public void showStatus( String status) {
}
}
