/**
 * ASMinBox -
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 *
 * @author P.C.Mehlitz
 */

package java.awt;

import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;

class ASMinBox
  extends Window
  implements MouseListener, MinBox
{
	RootWindow root;
	int iconSize = 32;

ASMinBox () {
	this.root = RootWindow.singleton;
	bgClr = Color.lightGray;
	page = 0xffff;

	addMouseListener( this);
	
	iconSize = ( root.width < 1024 ) ? 32 : 48;
}

String getGenericName () {
	// this is not a standard Java component, but since it's a Window, getting its
	// generic name woul alter the name count. You bet -there's an application out
	// there which relies on the numbering
		
	return "minbox";
}

public void mouseClicked ( MouseEvent evt ) {
	int idx = evt.getX() / iconSize;
	
	root.restore( (Window)root.minimized.elementAt( idx));
}

public void mouseEntered ( MouseEvent evt ) {
}

public void mouseExited ( MouseEvent evt ) {
}

public void mousePressed ( MouseEvent evt ) {
}

public void mouseReleased ( MouseEvent evt ) {
}

public void paint ( Graphics g ) {
	int i, n = root.minimized.size();
	int x, y, u, v, w, h;
	Frame c;
	Image icon;

	x = 0;
	y = 0;

	g.setColor( bgClr);
	
	for ( i=0; i<n; i++ ) {
		g.fill3DRect( x, y, iconSize, iconSize, true);
		
		c = (Frame) root.minimized.elementAt( i);
		if ( (icon = c.getIconImage()) != null ) {
			w = icon.getWidth( this);
			h = icon.getHeight( this);
			
			if ( w > 0 && h > 0 ) {
				u = x + (iconSize - w) / 2;
				v = y + (iconSize - h) / 2;
				g.drawImage( icon, u, v, this);
			}
		}
		
		x += iconSize;
	}
}

public void updateContents () {
	int n = root.minimized.size();

	if ( n == 0 ){
		setVisible( false);
	}
	else {
		setBounds( 0, root.height - iconSize, n*iconSize, iconSize);
		setVisible( true);
	}
}
}
