package java.awt;

import kaffe.awt.Defaults;

/**
 * WindowTheme - 
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 */
public class WindowTheme
{
	static Color[] clr = new Color[6];

static {
	clr = new Color[6];
	clr[0] = Defaults.WndActiveClr;
	clr[1] = Defaults.WndActiveClr.brighter();
	clr[2] = Defaults.WndActiveClr.darker();
	clr[3] = Defaults.WndInactiveClr;
	clr[4] = Defaults.WndInactiveClr.brighter();
	clr[5] = Defaults.WndInactiveClr.darker();
}

public static void frRedrawBorders ( Frame fr, Graphics g ) {
	int bw = fr.insets.left; // -1 if client area should be boxed
	int i;
	int ci = (fr.isActive) ? 0 : 3;
	int u  = 0;
	int v  = 0;
	int uw = fr.width-1;
	int vh = fr.height-1;
	
	g.setColor( clr[ci+1]);
	g.drawLine( u, v, uw-1, v);
	g.drawLine( u, v, u, vh);
	g.setColor( clr[ci+2]);
	g.drawLine( uw, v, uw, vh);
	g.drawLine( u+1, vh, uw, vh);
	
	u++; v++; uw--; vh--;
	g.setColor( clr[ci]);
	for ( i=2; i<bw; i++ ) {
		g.drawRect( u, v, uw-u, vh-v);
		u++; v++; uw--; vh--;
	}
	
	g.setColor( clr[ci+2]);
	g.drawLine( u, v, uw-1, v);
	g.drawLine( u, v, u, vh);
	g.setColor( clr[ci+1]);
	g.drawLine( uw, v, uw, vh);
	g.drawLine( u+1, vh, uw, vh);	
}

public static void frRedrawTitleBar ( Frame fr, Graphics g ) {
	int bw = fr.insets.left; // -1 if client area should be boxed
	int th = fr.insets.top - fr.insets.left; //Frame.th;
	FontMetrics fm = Defaults.WndFontMetrics;

	g.setColor( fr.isActive ? Defaults.WndActiveClr : Defaults.WndInactiveClr);
	g.fill3DRect( bw, bw, fr.width-2*bw, th, true);

	frRedrawTitleButtons( fr, g);

	g.setColor( fr.isActive ? Defaults.WndActiveTitleClr : Defaults.WndInactiveTitleClr);
	g.drawString( fr.title, th + bw + 2, bw + (th - fm.getHeight())/2 + fm.getAscent() -1);
}

public static void frRedrawTitleButtons ( Frame fr, Graphics g ) {
	int ci = fr.isActive ? 0 : 3;
	int bw = fr.insets.left;
	int th = fr.insets.top - fr.insets.left; //Frame.th;
	int u, v, uw, vh, i;

	// close button
	v = bw + (th - 6)/2;
	u = v;
	uw = u+6;
	vh = v+6;
	g.setColor( clr[ci+2]);
	g.drawLine( u, v, uw, vh);
	g.drawLine( uw, v, u, vh);
	u++; uw++;
	g.setColor( clr[ci+1]);
	g.drawLine( u, v, uw, vh);
	g.drawLine( uw, v, u, vh);

	if ( (fr.flags & fr.IS_RESIZABLE) != 0 ) {
		// max button
		u = fr.width - bw - th/2 - 2;
		v = bw + (th - 8)/2;
		g.setColor( clr[ci+2]);
		g.drawLine( u-3, v+7, u, v);
		g.drawLine( u, v, u+3, v+7);
		u++;
		g.setColor( clr[ci+1]);
		g.drawLine( u-3, v+7, u, v);
		g.drawLine( u, v, u+3, v+7);

		// min button
		u -= 14;
		g.setColor( clr[ci+2]);
		g.drawLine( u-3, v, u, v+7);
		g.drawLine( u, v+7, u+3, v);
		u++;
		g.setColor( clr[ci+1]);
		g.drawLine( u-3, v, u, v+7);
		g.drawLine( u, v+7, u+3, v);
	}
}
}
