/**
 * class CheckboxGroup - 
 *
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

package java.awt;

import java.util.Vector;

public class CheckboxGroup
  implements java.io.Serializable
{
	final private static long serialVersionUID = 3729780091441768983L;
/** @serial */
	Checkbox selectedCheckbox;
	transient Vector boxes = new Vector();

public CheckboxGroup () {
}

/**
 * @deprecated
 */
public Checkbox getCurrent() {
	return selectedCheckbox;
}

public Checkbox getSelectedCheckbox () {
	return (getCurrent());
}

/**
 * @deprecated
 */
public synchronized void setCurrent ( Checkbox box ) {
	int n = boxes.size();

	if ( selectedCheckbox == box) {
		return;
	}
	selectedCheckbox = box;

	for ( int i=0; i<n; i++) {
		Checkbox cb = (Checkbox)boxes.elementAt( i);
		if ( cb != box ){
			cb.setStateImpl( false);
		}
	}
	
	box.setStateImpl( true);
}

public synchronized void setSelectedCheckbox ( Checkbox box) {
	setCurrent(box);
}

public String toString () {
	return ( "CheckboxGroup: " + boxes.size() + " items");
}
}
