package java.awt;

import kaffe.util.Ptr;

/**
 *
 * Copyright (c) 1999
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 *
 */
public class Panel
  extends NativeContainer
{
	final private static long serialVersionUID = -2728009084054400034L;
	private static LayoutManager defaultLayout = new FlowLayout();
	static int named;

public Panel() {
	this( defaultLayout );
}

public Panel( LayoutManager layout) {
	setLayout( layout);
}

public void addNotify() {
	if ( nativeData == null ) {
		Toolkit.createNative(this);

		//native widgets are created visible
		if ( (flags & IS_VISIBLE) == 0 ) {
			Toolkit.cmnSetVisible( nativeData, false);
		}
		super.addNotify();
	}
}

void createNative() {
	nativeData = Toolkit.widgetCreateWidget( getParentData() );
}

String getGenericName () {
	// Apparently, the JDK increments the running number each time
	// *after* there was a genericName request. And yes, the stem is of course
	// not the qualified class name
	
	return "panel" + (named++);
}

public boolean isFocusTraversable () {
	// for some obscure reason, Panels are not focusTraversable by default
	return false;
}
}
