/*
 * Java core library component.
 *
 * Copyright (c) 1997, 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

package java.io;

import kaffe.io.FileIO;

public class FileDescriptor {

public static final FileDescriptor in;
public static final FileDescriptor out;
public static final FileDescriptor err;

protected int fd = -1;

static {
	System.loadLibrary("io");
	in = new FileIO(0);
	out = new FileIO(1);
	err = new FileIO(2);
}

public FileDescriptor() {
}

public boolean valid() {
	return (fd != -1);
}

public void sync() throws SyncFailedException {
	if (valid()) {
		if (sync0(fd) < 0) {
			throw new SyncFailedException("sync failed");
		}
	}
}

private native int sync0(int fd);

}
