
/*
 * Java core library component.
 *
 * Copyright (c) 1999
 *	Archie L. Cobbs.  All rights reserved.
 * Copyright (c) 1999
 *	Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 *
 * Author: Archie L. Cobbs <archie@whistle.com>
 */

package java.net;

public class URLDecoder
{

public URLDecoder() {}

public static String decode(String s) throws Exception {
    
    int pos2 = 0;
    byte b[] = new byte[s.length()];  

    for (int pos1 = 0; pos1 < s.length(); pos1++, pos2++) {
        char chr = s.charAt(pos1);
        if ((chr >= 'a' && chr <= 'z') ||
            (chr >= 'A' && chr <= 'Z') ||
            (chr >= '0' && chr <= '9') ||
            chr == '.' ||
            chr == '-' ||
            chr == '*' ||
            chr == '_') {
            b[pos2] = (byte)chr;
        }
        else if (chr == '+') {
            b[pos2] = (byte)' ';
        }
        else if (chr == '%' && pos1 + 3 <= s.length()) {
            b[pos2] = (byte)Integer.parseInt(s.substring(pos1 + 1, pos1 + 3), 16);
            pos1 += 2;
        } else {
            throw new Exception("invalid input");
        }
    }
    return new String (b, 0, pos2, "UTF8"); 
}
}

