package java.util;

/*
 * Java core library component.
 *
 * Copyright (c) 1997, 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */
public class Stack
  extends Vector
{
private static final long serialVersionUID = 1224463164541339165L;

public Stack() {
}

public boolean empty() {
	return isEmpty();
}

public synchronized Object peek() {
	int size = size() - 1;
	if (size >= 0) {
		return elementAt(size);
	}
	else {
		throw new EmptyStackException();
	}
}

public synchronized Object pop() {
	int size = size() - 1;
	if (size >= 0) {
		Object peeked = elementAt(size);
		removeElementAt(size);
		return (peeked);
	}
	else {
		throw new EmptyStackException();
	}
}

public Object push(Object item) {
	addElement(item);
	return item;
}

public synchronized int search(Object o) {
	int index = lastIndexOf(o);
	if (index == -1) {
		return -1;
	}
	return size() - index;
}
}

