/*
 * Java core library component.
 *
 * Copyright (c) 1997, 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

package java.util.zip;

public class CRC32 implements Checksum {

  static {
    System.loadLibrary("zip");
  }

  private int crc;

  public CRC32()
  {
    crc = 0;
  }

  public void update(int b)
  {
    crc = update1(crc, (byte)b);
  }

  public void update(byte b[])
  {
    update(b, 0, b.length);
  }

  public void reset()
  {
    crc = 0;
  }

  public long getValue()
  {
    return (((long)crc) & 0xFFFFFFFFL);
  }

  public void update(byte b[], int off, int len) {
    crc = update0(crc, b, off, len);
  }

  private native int update0(int crc, byte b[], int off, int len);
  private native int update1(int crc, byte val);

}
