package javax.media;

import java.net.URL;
import java.util.Vector;
import java.io.IOException;
import javax.media.Player;
import javax.media.MediaLocator;
import javax.media.protocol.DataSource;

public final class Manager {

public static Player createPlayer(URL src) throws IOException, NoPlayerException {
	return (createPlayer(new MediaLocator(src)));
}

public static Player createPlayer(MediaLocator src) throws IOException, NoPlayerException {

	String protocol = src.getURL().getProtocol();
	Vector dlist = getDataSourceList(protocol);

	int dlen = dlist.size();
	for (int i = 0; i < dlen; i++) {
		try {
			DataSource d = (DataSource)dlist.elementAt(i).getClass().newInstance();
			d.setLocator(src);
			d.connect();
			return (createPlayerInternal(d, d.getContentType(), true));
		}
		catch (Exception _) {
			/* Ignore and continue */
		}
	}
	for (int i = 0; i < dlen; i++) {
		try {
			DataSource d = (DataSource)dlist.elementAt(i).getClass().newInstance();
			d.connect();
			return (createPlayerInternal(d, "unknown", true));
		}
		catch (Exception _) {
			/* Ignore and continue */
		}
	}
	throw new NoPlayerException();
}

public static Player createPlayer(DataSource src) throws IOException, NoPlayerException {
	try {
		return (createPlayerInternal(src, src.getContentType(), false));
	}
	catch (Exception _) {
	}
	try {
		return (createPlayerInternal(src, "unknown", false));
	}
	catch (Exception _) {
	}
	throw new NoPlayerException();
}

private static Player createPlayerInternal(DataSource src, String type, boolean proxy) throws IOException, NoPlayerException {
	Vector hlist = getHandlerClassList(type);
	int hlen = hlist.size();
	for (int i = 0; i < hlen; i++) {
		try {
			MediaHandler h = (MediaHandler)hlist.elementAt(i).getClass().newInstance();
			h.setSource(src);
			if (h instanceof Player) {
				return ((Player)h);
			}
			else if (proxy && h instanceof MediaProxy) {
				return (createPlayerInternal(((MediaProxy)h).getDataSource(), type, proxy));
			}
			else {
				/* Ignore unknown types */
			}
		}
		catch (Exception _) {
			/* Ignore and continue */
		}
	}
	throw new NoPlayerException();
}

public static DataSource createDataSource(URL src) throws IOException, NoDataSourceException {
	return (createDataSource(new MediaLocator(src)));
}

public static DataSource createDataSource(MediaLocator src) throws IOException, NoDataSourceException {
	throw new kaffe.util.NotImplemented();
}

public static TimeBase getSystemTimeBase() {
	throw new kaffe.util.NotImplemented();
}

public static Vector getDataSourceList(String src) {
	throw new kaffe.util.NotImplemented();
}

public static Vector getHandlerClassList(String src) {
	throw new kaffe.util.NotImplemented();
}

}
