package javax.media;

import java.lang.String;
import java.net.URL;
import java.net.MalformedURLException;

public class MediaLocator {

private URL url;

public MediaLocator(String str) {
	try {
		this.url = new URL(str);
	}
	catch (MalformedURLException _) {
		this.url = null;
	}
}

public MediaLocator(URL url) {
	this.url = url;
}

public URL getURL() throws MalformedURLException {
	if (url == null) {
		throw new MalformedURLException();
	}
	return (url);
}

public String getRemainder() {
	String str = toString();
	int idx = str.indexOf(':');
	if (idx != -1) {
		str = str.substring(idx+1);
	}
	return (str);
}

public String toString() {
	return (toExternalForm());
}

public String toExternalForm() {
	return (url.toString());
}

}
