package kaffe.awt;

import java.awt.Component;
import java.awt.Container;
import java.awt.Point;
import java.awt.TextComponent;
import java.awt.Toolkit;
import java.awt.Window;
import java.util.Vector;
import kaffe.awt.theme.Theme;
import kaffe.awt.theme.ThemeKaffe;

public class AWT
  extends Toolkit
{
	public static ToolkitExtension extension;
	static AWT singleton;
	public static Window activeWindow;
	public static boolean themeChanged;
	public static Component mouseTgt;
	public static Component keyTgt;
	public static TextComponent lastTextComponentTgt;
	public static Vector windows;
	public static Theme theme;
	public static Point mousePos = new Point();
	public static int xMouseTgt;
	public static int yMouseTgt;
	public static Object lock = Toolkit.class;

static {
	singleton = new AWT();
	windows = new Vector();
}

protected AWT () {
	extension = getExtension();

	try {
		theme = (Theme)(Class.forName(Defaults.ThemeClass).newInstance());
	}
	catch ( Exception _) {
		theme = new ThemeKaffe();
	}

	//initial properties loaded by ImageTheme via system property <theme_properties>
	theme.load( null);
}

public static Theme getTheme() {
	return theme;
}

private static void invalidateTree( Container c) {
	int cs = c.getComponentCount();

	for ( int i=0; i<cs; i++ ) {
		Component cc = c.getComponent(i);
		if ( cc instanceof Container ) 
			invalidateTree( (Container) cc);
		else
			cc.invalidate();
	}
	
}

public static void resetDecos(Container c) {
	boolean old = themeChanged;
	themeChanged = true;
	// We invalidate the tree, then install the new decoration
	invalidateTree(c);
	extension.resetDeco(c);
	themeChanged = old;
}

public static void setTheme( Theme t, String confFile) {
	theme = t;

	if ( confFile != null ) {
		theme.load( confFile);
	}
	
	boolean old = themeChanged;
	themeChanged = true;
	int ts = windows.size();
	for ( int i=0; i<ts; i++ ) {
		Window w = (Window)windows.elementAt(i);
		resetDecos(w);
	}
	themeChanged = old;
}
}
