package kaffe.awt;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Insets;
import java.awt.LayoutManager2;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.util.Hashtable;

public class GenericLayout
  implements LayoutManager2
{
	Hashtable comptable = new Hashtable();
	GenericLayoutConstraints defaultConstraints = new GenericLayoutConstraints();

public void addLayoutComponent ( Component child, Object constraints ){
	try {
		if (constraints != null) {
			setConstraints(child, (GenericLayoutConstraints)constraints);
		}
	}
	catch (ClassCastException _) {
		throw new IllegalArgumentException("not GenericLayoutConstraints");
	}
}

public void addLayoutComponent ( String name, Component child ){
}

public float getLayoutAlignmentX ( Container parent ){
	return Component.CENTER_ALIGNMENT;
}

public float getLayoutAlignmentY ( Container parent ){
	return Component.CENTER_ALIGNMENT;
}

public void invalidateLayout ( Container parent ){
}

public void layoutContainer ( Container parent ){
	Insets in = parent.getInsets();
	int pw = AWT.extension.getWidth( parent) - in.left - in.right;
	int ph = AWT.extension.getHeight( parent) - in.top - in.bottom;
	
	Rectangle r = new Rectangle();

	int nc = parent.getComponentCount();
	
	for ( int i=0; i<nc; i++){
		Component c = parent.getComponent(i);
		if ( ! c.isVisible() ) {
			continue;
		}
		GenericLayoutConstraints cc = lookupConstraints( c);
		cc.getBounds( pw, ph, r);
		c.setBounds( in.left + r.x, in.top + r.y, r.width, r.height);
	}
}

GenericLayoutConstraints lookupConstraints(Component c) {
	GenericLayoutConstraints cons = (GenericLayoutConstraints)comptable.get(c);
	if (cons == null) {
		cons = defaultConstraints;
	}
	return (cons);
}

public Dimension maximumLayoutSize ( Container parent ){
	return Toolkit.getDefaultToolkit().getScreenSize();
}

public Dimension minimumLayoutSize ( Container parent ){
	//FIXME ( seems to be tricky due to parent-relative specs)
	return new Dimension( 50, 50);
}

public Dimension preferredLayoutSize ( Container parent ){
	//FIXME ( seems to be tricky due to parent-relative specs)
	return new Dimension( 200, 200);
}

public void removeLayoutComponent ( Component child ){
	comptable.remove( child);
}

void setConstraints( Component comp, GenericLayoutConstraints cons) {
	comptable.put(comp, (GenericLayoutConstraints)cons.clone());
}
}
