package kaffe.awt;

import java.awt.Container;
import java.awt.Rectangle;

public class GenericLayoutConstraints
  implements Cloneable
{
	int x0Abs;
	int x1Abs;
	int y0Abs;
	int y1Abs;
	int x0Rel;
	int x1Rel;
	int y0Rel;
	int y1Rel;
	int x0Anchor = WEST;
	int x1Anchor = EAST;
	int y0Anchor = NORTH;
	int y1Anchor = SOUTH;
	final public static int NORTH = 1 ;
	final public static int EAST = 2 ;
	final public static int SOUTH = 3 ;
	final public static int WEST = 4 ;

public Object clone() {
	try { 
		GenericLayoutConstraints gc = (GenericLayoutConstraints) super.clone();
		return gc;
	}
	catch ( CloneNotSupportedException e) {
		return null;
	}
}

public Rectangle getBounds( Container parent, Rectangle r) {
	int wp = AWT.extension.getWidth( parent);
	int hp = AWT.extension.getHeight( parent);

	return getBounds( wp, hp, r);
}

public Rectangle getBounds( int pWidth, int pHeight, Rectangle r) {
	int x0, x1, y0, y1;
	
	switch (x0Anchor) {
		case EAST:
			x0 = pWidth - x0Abs - (pWidth * x0Rel / 1000);
			break;
		default:
			x0 = x0Abs + (pWidth * x0Rel / 1000);
			break;
	}

	switch (y0Anchor) {
		case SOUTH:
			y0 = pHeight - y0Abs -  (pHeight * y0Rel / 1000);
			break;
		default:
			y0 = y0Abs + (pHeight * y0Rel / 1000);
			break;
	}
	
	switch (x1Anchor) {
		case EAST:
			x1 = pWidth - x1Abs - (pWidth * x1Rel / 1000);
			break;
		default:
			x1 = x1Abs + (pWidth * x1Rel / 1000);
			break;
	}
	
	switch (y1Anchor) {
		case SOUTH:
			y1 = pHeight - y1Abs - (pHeight * y1Rel / 1000);
			break;
		default:
			y1 = y1Abs + (pHeight * y1Rel / 1000);
			break;
	}
	
	r.setBounds( x0, y0, x1-x0, y1-y0);
	
	return r;
}

public void set( int x0Abs, int x0Rel, int x0Anchor, int y0Abs, int y0Rel, int y0Anchor,int x1Abs, int x1Rel, int x1Anchor, int y1Abs, int y1Rel, int y1Anchor) {
	//quite unhandy, maybe used with a GUI builder
	this.x0Abs = x0Abs;
	this.x0Rel = x0Rel;
	this.x0Anchor = x0Anchor;
	this.y0Abs = y0Abs;
	this.y0Rel = y0Rel;
	this.y0Anchor = y0Anchor;
	this.x1Abs = x1Abs;
	this.x1Rel = x1Rel;
	this.x1Anchor = x1Anchor;
	this.y1Abs = y1Abs;
	this.y1Rel = y1Rel;
	this.y1Anchor = y1Anchor;
}

public void setXCorner( int abs, int rel, int anchor) {
	x1Abs = abs;
	x1Rel = rel;
	x1Anchor = anchor;
}

public void setXOrigin( int abs, int rel, int anchor) {
	x0Abs = abs;
	x0Rel = rel;
	x0Anchor = anchor;
}

public void setYCorner( int abs, int rel, int anchor) {
	y1Abs = abs;
	y1Rel = rel;
	y1Anchor = anchor;
}

public void setYOrigin( int abs, int rel, int anchor) {
	y0Abs = abs;
	y0Rel = rel;
	y0Anchor = anchor;
}
}
