package kaffe.awt;

import java.awt.AWTEvent;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;
import java.awt.Point;
import java.awt.Window;
import kaffe.awt.theme.ComponentDeco;
import kaffe.util.Condition;
import kaffe.util.Ptr;

public interface ToolkitExtension
{
public void disableRedraw ( Component c );

public void dispatchModalUntil ( Condition cond );

public void drawBackground ( Graphics g,
                      int cx, int cy, int cw, int ch,
                      int x, int y, int w, int h,
                      int xOff, int yOff, Image img, Color clr, int fillMode );

public void drawBorder ( Graphics g,
                  int x, int y, int w, int h, int alignment,
                  Image itl, Image itm, Image itr,
                  Image iml, Image imr,
                  Image ibl, Image ibm, Image ibr );

public void drawVertString ( Graphics g, String s, int x, int y );

public void dump(String prefix, Component c);

public void enableRedraw ( Component c );

public Component getComponentUnderMouse ();

public ComponentDeco getDeco ( Component c );

public int getHeight ( Component c );

public Insets getInsets ( Component c );

public Graphics getLinkedGraphics ( Component c );

public Point getMouseLocationOnScreen ();

public Ptr getNativeData ( Object o );

public ComponentDeco getReferenceDeco ( Component c );

public Point getScreenOffset();

public int getWidth ( Component c );

public int getX ( Component c );

public int getY ( Component c );

public void paintBackground( Component c, Graphics g);

public boolean processEvents ( long timeout );

public void processPaintEvents();

public void resetDeco(Component c);

public void setDeco(Component c, ComponentDeco d);

public void setMovable ( Window wnd, boolean isMovable );

public void setOwner ( Window ownee, Window owner );

public void showCursor ( boolean showIt );

public void startRespawnEventThread ( int timeout );

public void stopAnimation (Image img);

public void stopProduction (Image img);

public void stopRespawnEventThread ();

public void temporaryRemoveAll ( Container c );

public void setScreenRotation ( int r );

public int getScreenRotation ();

public void postFakeNativeEvent (AWTEvent evt);
}
