package kaffe.awt;

import java.awt.Image;
import java.awt.Toolkit;
import java.awt.image.ImageConsumer;
import java.awt.image.ImageProducer;
import java.net.URLConnection;
import java.util.Enumeration;
import java.util.Vector;
import kaffe.net.URLConnectionWrapper;

public class URLConnectionProducer
  implements ImageProducer, URLConnectionWrapper
{
	URLConnection conn;
	ImageProducer delegatee;
	Object consumer;

public URLConnectionProducer () {
}

public URLConnectionProducer ( URLConnection conn ) {
	this.conn = conn;
}

public void addConsumer ( ImageConsumer ic ) {
	if ( consumer == null ){
		consumer = ic;
	}
	else if ( this.consumer instanceof Vector ) {
		((Vector)consumer).addElement( ic);
	}
	else {
		Vector v = new Vector(3);
		v.addElement( consumer);
		v.addElement( ic);
		consumer = v;
	}
}

public URLConnection getConnection () {
	return conn;
}

public boolean isConsumer ( ImageConsumer ic ) {
	if ( consumer instanceof ImageConsumer )
		return (consumer == ic);
	else if ( consumer instanceof Vector )
		return ((Vector)consumer).contains( ic);
	else
		return false;
}

public void removeConsumer ( ImageConsumer ic ) {
	if ( consumer == ic ){
		consumer = null;
	}
	else if ( consumer instanceof Vector ) {
		Vector v = (Vector) consumer;		
		v.removeElement( ic);
		if ( v.size() == 1 )
			consumer = v.elementAt( 0);
	}
}

public void requestTopDownLeftRightResend ( ImageConsumer consumer ){
}

public void setConnection( URLConnection conn) {
	this.conn = conn;
}

public void startProduction ( ImageConsumer ic ){

	// We don't know how to produce a native image, this is the realm of
	// java.awt. But we do know somebody who knows a real, native producer - an
	// Image created by the Toolkit. So that's what we use if some app explicitly
	// calls startPoduction

	if ( delegatee == null ){
		Image img = Toolkit.getDefaultToolkit().createImage( this);
		delegatee = img.getSource();
	}
	
	if ( ic != null ){
		addConsumer( ic);
	}
	
	if ( consumer != null ){
		if ( consumer instanceof Vector ){
			Enumeration e = ((Vector)consumer).elements();
			while (  e.hasMoreElements() ) {
				delegatee.addConsumer( (ImageConsumer) e.nextElement());
			}
		}
		else {
			delegatee.addConsumer( (ImageConsumer)consumer);
		}
	}
	
	delegatee.startProduction( null);
}
}
