package kaffe.awt;


public class VTSwitchEvent
  extends java.awt.AWTEvent
{
	long when;
	static VTSwitchEvent cache;
	static VTSwitchEventHandler handler;

	final public static int VT_REL_REQ = 601;
	final public static int VT_ACQ_REQ = 602;
        
public VTSwitchEvent ( Object source,  int id, long when ){
	super( source, id);
	
	this.when = when;
}

protected void dispatch () {
	VTSwitchEventHandler src = (VTSwitchEventHandler) source;
	if ( src != null ){
		src.processVTSwitchEvent( this);
	}
	
	// 2DO - make this configurable (like with the standard events)
	recycle();
}

static synchronized VTSwitchEvent getEvent ( int id ) {
	VTSwitchEvent e;
	long    when = System.currentTimeMillis();
	
	if ( cache == null ) {
		e = new VTSwitchEvent( handler,  id, when);
	}
	else {
		e = cache;
		cache = (VTSwitchEvent) e.next;
		e.next = null;
	
		e.id         = id;
		e.source     = handler;
		e.when       = when;
	}

	return e;
}

protected void recycle () {
	synchronized ( VTSwitchEvent.class ) {
		source = null;

		next = cache;	
		cache = this;
	}
}

public static void setHandler ( VTSwitchEventHandler h ){
	handler = h;
}

public native void ackRelease();

public native void ackAcquire();

}
