package kaffe.awt.dialogs;

import java.awt.Dialog;
import java.awt.Frame;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import kaffe.awt.AWT;

abstract public class BaseDialog
  extends Dialog
  implements ActionListener
{
	Window ownerWnd;
	Object selection;

protected BaseDialog( String title, Window owner) {
	super( (owner instanceof Frame) ? (Frame)owner : null, title, true);
	ownerWnd = owner;
}

public void actionPerformed( ActionEvent e) {
	selection = e.getSource();
	dispose();
}

abstract protected String getSelection();

public String process() {

	selection = null;
	
	if ( ownerWnd != null ) {
		//Center to owner
		int ox = AWT.extension.getX( ownerWnd);
		int oy = AWT.extension.getY( ownerWnd);
		int ow = AWT.extension.getWidth( ownerWnd);
		int oh = AWT.extension.getHeight( ownerWnd);

//		if ( ow < prefWidth ) {
//			prefWidth = ow;
//		}

		if ( ! (ownerWnd instanceof Frame) ) {
			//owner couldn't be set in the ct
			AWT.extension.setOwner( this, ownerWnd);
		}
		
		pack();

		int tw = AWT.extension.getWidth( this);
		int th = AWT.extension.getHeight( this);
		setLocation ( ox + (ow - tw) / 2, oy + (oh - th) / 2);
		
	}
	else {
		pack();
		setLocation( 0, 0);
	}

	show();
	
	return ( getSelection() );
}
}
