package kaffe.awt.dialogs;

import java.awt.Button;
import java.awt.Component;
import java.awt.Container;
import java.awt.FlowLayout;
import java.awt.Window;
import java.util.StringTokenizer;
import kaffe.awt.AWT;
import kaffe.awt.widgets.TextPane;

/**
 * generic dialog to display messages
 *
 */
public class MessageBox
  extends BaseDialog
{
	Container btnPane;
	TextPane textPane;

public MessageBox( String title, String text, String buttons, Window owner){
	super( title, owner);

	btnPane = new Container(){};
	btnPane.setLayout( new FlowLayout() );
	
	textPane = new TextPane( text);

	add( "Center", textPane);
	add( "South", btnPane);
	setButtons( buttons);
}

public static boolean confirm( String text, Window owner){
	MessageBox mb = new MessageBox( "Please confirm:", text, "Yes,No", owner);
	mb.process();
	return (mb.getSelectionIdx() == 0);
}

public String getSelection() {
	if ( selection == null ) {
		return null;
	}
	return ( ((Button)selection).getLabel() );
}

public int getSelectionIdx() {
	int cc = btnPane.getComponentCount();
	for ( int i = 0; i < cc; i++ ) {
		Component c = btnPane.getComponent( i);
		if ( c == selection ) {
			return i;
		} 
	}
	return -1;
}

public static void notify( String text, Window owner){
	MessageBox mb = new MessageBox( "Please notify:", text, "Ok", owner);
	mb.process();
}

void setButtons( String buttons) {
	StringTokenizer tk = new StringTokenizer( buttons, ",;:");
	while( tk.hasMoreTokens() ){
		String tok = tk.nextToken();
		Button btn = new Button( tok );
		btnPane.add( btn);
		btn.addActionListener( this);
	}
}

public static int yesNoCancel( String title, String text, Window owner){
	MessageBox mb = new MessageBox( title, text, "Yes,No,Cancel", owner);
	mb.process();
	return mb.getSelectionIdx();
}
}
