package kaffe.awt.dialogs;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Label;
import java.awt.TextField;
import java.awt.Window;
import kaffe.awt.widgets.TextPane;

public class PasswordPrompter
  extends BaseDialog
{
	TextPane textPane;
	TextField userEntry = new TextField(15);
	TextField passEntry = new TextField(15);

public PasswordPrompter( String title, String msg, String user, Window owner) {
	super( title, owner);

	passEntry.setEchoChar( '*');

	if ( user != null ) {
		userEntry.setText( user);
	}
	
	setLayout( new GridBagLayout() );
	GridBagConstraints gb = new GridBagConstraints();

	gb.gridwidth = gb.REMAINDER;
	gb.anchor = gb.WEST;
	gb.fill = gb.BOTH;
		
	if ( msg != null ) {
		textPane = new TextPane( msg);
		add( textPane, gb);
	}

	gb.gridwidth = 1;
	gb.fill = gb.NONE;
	add( new Label( "Username:" ), gb);
	gb.gridwidth = gb.REMAINDER;
	gb.fill = gb.BOTH;
	add( userEntry, gb);

	gb.gridwidth = 1;
	gb.fill = gb.NONE;
	add( new Label( "Password:" ), gb);
	gb.gridwidth = gb.REMAINDER;
	gb.fill = gb.BOTH;
	add( passEntry, gb);
	
	passEntry.addActionListener( this);
}

public String getPassword() {
	return passEntry.getText();
}

public String getSelection() {
	return (userEntry.getText() + "&" + passEntry.getText() );
}

public String getUsername() {
	return userEntry.getText();
}

public static String prompt( String title, String msg, String user, Window owner) {
	PasswordPrompter pp = new PasswordPrompter( title, msg, user, owner);
	return pp.process();
}
}
