package kaffe.awt.doc;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.net.URL;
import java.util.Enumeration;
import java.util.Hashtable;
import org.w3c.dom.*;

class Currency
  extends SimpleElement
{
	String country;
	java.awt.Image signImg;
	int val;
	Node model;

Currency() {
}

Currency( String country, String src, int val ) {
	this.country = country;
	this.val = val;
	setAbsImage( src);
}

public Node getParentNode() {
	return model;
}

public Dimension getPreferredSize() {
	return new Dimension( 30, 20);
}

public void paint( Graphics g) {
/*
	Dimension d = getSize();
	if ( signImg != null ) {
		int h = signImg.getHeight( this);
		int w = signImg.getWidth( this);
		g.drawImage( signImg, (d.width-w)/2, (d.height-h)/2, w, h, null);
	}
*/
}

public void set( String country, java.awt.Image signImg, int val ) {
	this.country = country;
	this.signImg = signImg;
	this.val = val;
//	repaint();
}

void setAbsImage( String src) {
	if ( src != null ) {
		try {
			URL u = new URL( src);
			signImg = Toolkit.getDefaultToolkit().getImage( u);
			//start production
			signImg.getWidth( null);
		}
		catch ( Throwable _ ) {
		}
	}
}

public void setAttributeNS(String namespaceURI, String localName, String value) {
	if ( localName.equalsIgnoreCase( "country") )
		country = value;
	else if ( localName.equalsIgnoreCase( "sign") )
		setImage( value);
	else if ( localName.equalsIgnoreCase( "value") )
		val = Integer.parseInt( value);
	else
		super.setAttributeNS( namespaceURI, localName, value);
}

void setImage( String src) {
	URL u = null;
	if ( src != null )
		u = SourceLoader.getURL( src);
	if ( u != null ) {
		signImg = Toolkit.getDefaultToolkit().getImage( u);
		//start production
		signImg.getWidth(null);
	}
}

public String toString() {
	return ( "country: " + country + " value: " + val);
}
}

public class CurrencyCalculator
  extends ElementImpl
  implements ActionListener
{
	Button[] btns = new Button[13];
	Label cSrc = new Label(" ");
	Label cDst = new Label(" ");
	Currency cFrom = new Currency("Unknown", null, 0);
	Currency cTo = new Currency("Unknown", null, 0);
	Hashtable loaded = new Hashtable();

public CurrencyCalculator() {
	initSl();
}

public void actionPerformed( ActionEvent evt) {

	Object o = evt.getSource();
	String ac = evt.getActionCommand();
	
	if ( ac.equals("Clear")) {
		cSrc.setText( " ");
		cDst.setText( " ");
	}
	else if ( ac.equals("Calc") ) {
		String s = cSrc.getText().trim();
		try {
			//get the reference amount in USD
			long ds = Integer.parseInt( s) * cFrom.val;		
			ds = 1000 * ds / cTo.val;
			s = Long.toString( ds);
			int n = s.length();
			s = s.substring( 0, n-3) + '.' + s.substring( n-3, n); 
			cDst.setText( " " + s + " ");			
		}
		catch ( NumberFormatException _ ) {
		}
	}
	else if ( o instanceof Button){
		String s = cSrc.getText().trim();
		s += evt.getActionCommand().charAt(0);
		try {
			float nv = Float.parseFloat( s);
			cSrc.setText( " " + s + " ");			
		}
		catch ( Exception _ ) {
		}
	}
	// this is from the menu ( mode switch )
	else {
		PopupMenu p = (PopupMenu)evt.getSource();
		Currency c = (Currency)loaded.get( evt.getActionCommand() );
		if ( p.getLabel().equals("from") )
			cFrom.set( c.country, c.signImg, c.val);
		else
			cTo.set( c.country, c.signImg, c.val);
	}
}

public void addNotify() {
	if ( getPeer() != null ) {
		//already addNotified
		return;
	}

	super.addNotify();

	DocumentImpl di = getDocument();
	//maybe reloaded from cache ( navBar already activated )
	if ( di.navBar != null ) {
		return;
	}
	
	PopupMenu pf = new PopupMenu("from");
	PopupMenu pt = new PopupMenu("to");
	
	for ( Enumeration e = loaded.elements(); e.hasMoreElements(); ) {
		Currency c = (Currency)e.nextElement();
		pf.add( c.country);
		pt.add( c.country);
	}
	pf.addActionListener( this);
	pt.addActionListener( this);
	
	di.addNavItem( "from", null, pf);
	di.addNavItem( "to", null, pt);
	
	if ( pf.countItems() > 0 ){
		Currency c1 = (Currency)loaded.get(pf.getItem(0).getLabel());
		cFrom.set( c1.country, c1.signImg, c1.val);
		cTo.set( c1.country, c1.signImg, c1.val);
	}
}

public Node appendChild(Node newChild) throws DOMException {
	if ( newChild instanceof Currency ) {
		Currency c = (Currency)newChild;
		c.model = this;
		loaded.put( c.country, c);
//		return newChild;
	}
	return super.appendChild( newChild);
}

public void doLayout() {
	Dimension d = getSize();

	int dw = d.width / 4;
	int dh = d.height / 6;
	
	cSrc.setBounds(0,0,3*dw,dh);
//	cFrom.setBounds(3*dw,0,dw,dh);

	cDst.setBounds(0,dh,3*dw,dh);
//	cTo.setBounds(3*dw,dh,dw,dh);
	
	btns[1].setBounds(0,2*dh,dw,dh);
	btns[2].setBounds(dw,2*dh,dw,dh);
	btns[3].setBounds(2*dw,2*dh,dw,dh);
	btns[4].setBounds(0,3*dh,dw,dh);
	btns[5].setBounds(dw,3*dh,dw,dh);
	btns[6].setBounds(2*dw,3*dh,dw,dh);
	btns[7].setBounds(0,4*dh,dw,dh);
	btns[8].setBounds(dw,4*dh,dw,dh);
	btns[9].setBounds(2*dw,4*dh,dw,dh);
	btns[10].setBounds(0,5*dh,dw,dh);
	btns[0].setBounds(dw,5*dh,dw,dh);
	btns[12].setBounds(2*dw,5*dh,dw,dh);
	
	btns[11].setBounds(3*dw,2*dh,dw,4*dh);
}

public Dimension getPreferredSize() {
	//have the entire parents size
	Dimension d = getParent().getSize();
	if ( (d.width>0) && (d.height>0) ){
		return (d);
	}
	return super.getPreferredSize();
}

public void initGbl() {

	setLayout( new GridBagLayout());
	
	for ( int i=0; i<10; i++ ) {
		btns[i] = new Button( Integer.toString( i));
		btns[i].addActionListener( this);
	}
	btns[10] = new Button( ".");
	btns[10].addActionListener( this);
	btns[11] = new Button( "Calc");
	btns[11].addActionListener( this);
	btns[12] = new Button( "Clear");
	btns[12].addActionListener( this);
	GridBagConstraints gbc = new GridBagConstraints();
	
	gbc.gridwidth = 3;
	gbc.fill = gbc.HORIZONTAL;
	add( cSrc, gbc);
	gbc.fill = gbc.NONE;
	
	gbc.gridwidth = gbc.REMAINDER;
//	add( cFrom, gbc);

	gbc.gridwidth = 3;
	gbc.fill = gbc.HORIZONTAL;
	add( cDst, gbc);
	gbc.fill = gbc.NONE;

	gbc.gridwidth = gbc.REMAINDER;
//	add( cTo, gbc);

	gbc.gridwidth = 1;
	add( btns[1], gbc);
	add( btns[2], gbc);
	add( btns[3], gbc);
	gbc.fill = gbc.VERTICAL;
	gbc.gridwidth = gbc.REMAINDER;
	gbc.gridheight = gbc.REMAINDER;
	add( btns[11], gbc);
	gbc.gridheight = 1;
	gbc.fill = gbc.NONE;
	
	gbc.gridy = 3;
	gbc.gridx = 0;
	gbc.gridwidth = 1;
	add( btns[4], gbc);
	gbc.gridx = gbc.RELATIVE;
	add( btns[5], gbc);
	add( btns[6], gbc);

	gbc.gridy = 4;
	gbc.gridx = 0;
	add( btns[7], gbc);
	gbc.gridx = gbc.RELATIVE;
	add( btns[8], gbc);
	add( btns[9], gbc);

	gbc.gridy = 5;
	gbc.gridx = 0;
	add( btns[10], gbc);
	gbc.gridx = gbc.RELATIVE;
	add( btns[0], gbc);
	add( btns[12], gbc);
}

public void initSl() {

	setLayout( null);
	
	for ( int i=0; i<10; i++ ) {
		btns[i] = new Button( Integer.toString( i));
		btns[i].addActionListener( this);
		add( btns[i]);
	}
	btns[10] = new Button( ".");
//	btns[10].addActionListener( this);
	add( btns[10]);
	btns[11] = new Button( "Calc");
	btns[11].addActionListener( this);
	add( btns[11]);
	btns[12] = new Button( "Clear");
	btns[12].addActionListener( this);
	add( btns[12]);
	
	add( cSrc);
	add( cDst);
//	add( cFrom);
//	add( cTo);
	
}

public void setFont( Font fnt) {

	for ( int i=0; i<btns.length; i++ ) {
		btns[i].setFont(fnt);
	}
	
	cSrc.setFont( fnt);
	cDst.setFont( fnt);
}
}
