package kaffe.awt.doc;

import java.awt.Font;
import java.awt.TextField;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import org.w3c.dom.*;

public class DocTextField
  extends DocWidget
{
	TextField tf;
	InputSource inputSrc;

public DocTextField() {
	this( "", null);
	tf.setColumns( 10);
}

public DocTextField( String text) {
	this( text, null);
}

public DocTextField( String text, InputSource src) {
	tf = new TextField( text);
	add( tf);
	
	inputSrc = src;
	if ( inputSrc != null ) {
		tf.addMouseListener( new MouseAdapter() {
			public void mouseClicked( MouseEvent evt) {
				inputSrc.setTarget( DocTextField.this);
			}
		});
	}
}

void insertChar( char c) {
	StringBuffer sb = new StringBuffer( tf.getText());
	int p = tf.getCaretPosition();
	sb.insert( p, c);
	
	String nc = sb.toString();
	tf.setText( nc);
	tf.setCaretPosition( nc.length() );
}

public void setAttributeNS(String namespaceURI, String localName, String value) {
	if ( localName.equalsIgnoreCase( "text") ) {
		tf.setText( value);
	}
	else {
		super.setAttributeNS( namespaceURI, localName, value);
	}
}
}
