package kaffe.awt.doc;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.FontMetrics;
import java.awt.PopupMenu;
import org.w3c.dom.*;

public class DocumentImpl
  extends SimpleElement
  implements Document
{
	Table rootTable;
	TableCell bodyCell;
	TableCell headerCell;
	Navigator navBar;

class Render
  extends Container
{
Render () {
	setLayout( new FlowLayout( FlowLayout.LEFT, 0, 0) );
}
}

public DocumentImpl() {
	this("");
}

public DocumentImpl( String name) {
	this.name = name;
	renderer = new Render();
	
	rootTable = new Table( "100%", "100%", 0, 0 );
	appendChild( rootTable);
}

public void addNavItem( String label, String cmd, PopupMenu p) {
	if ( navBar == null ) {
		setNavBar();
	}

	navBar.addActionPad( label, cmd, p);
}

public Node appendChild(Node newChild) throws DOMException {
	if ( bodyCell == null ) {
		body();
	}

	bodyCell.appendChild( newChild);
	return newChild;
}

public void body() {
	TableRow tr = new TableRow();
	rootTable.appendChild( tr );

	rootTable.appendChild( bodyCell = new TableCell( 1, 1, "100%", "100%" ));
	bodyCell.halign = TableCell.CENTER;
	
	if ( headerCell != null ) {
		FontMetrics fm = renderer.getFontMetrics( FontAttributes.titleFont);
		bodyCell.absYOffset = -fm.getHeight();
	}
}

public Attr createAttribute(String name) {
	return createAttributeNS( null, name);
}

public Attr createAttributeNS(String namespaceURI, String qualifiedName) {
	return null;
}

public CDATASection createCDATASection(String data) {
	return null;
}

public Comment createComment(String cmt) {
	return null;
}

public DocumentFragment createDocumentFragment() {
	return null;
}

public Element createElement( String tagName) {
	return createElementNS( null, tagName);
}

public Element createElementNS(String namespaceURI, String qualifiedName) {
	try {
		Class c = Class.forName( qualifiedName);
		Object o  = c.newInstance();
		if ( o instanceof SimpleNode ) {
			SimpleNode sn = (SimpleNode)o;
			sn.name = namespaceURI;
		}
		return ((Element)o);
	}
	catch ( Exception _) {
		_.printStackTrace();
		return null;
	}
}

public EntityReference createEntityReference(String name) {
	return null;
}

public ProcessingInstruction createProcessingInstruction(String target, String data) {
	return null;
}

public Text createTextNode( String text) {
	return null;
}

public DocumentType getDoctype() {
	return null;
}

public Element getDocumentElement() {
	//return dom root element
	if ( bodyCell == null )
		body();
		
	return bodyCell;
}

public NodeList getElementsByTagName(String tagname) {
	return getElementsByTagNameNS( null, tagname);
}

public NodeList getElementsByTagNameNS(String namespaceURI, String qualifiedName) {
	return null;
}

public DOMImplementation getImplementation() {
	return null;
}

public boolean hasNavBar() {
	return (navBar != null);
}

public Node importNode(Node importedNode, boolean deep) {
	return null;
}

public void setNavBar() {
	if ( headerCell == null ) {
		TableRow tr = new TableRow();
		headerCell = new TableCell( 1, 1, "100%", "0");
		navBar = new Navigator();
		navBar.setAttribute( "width" , "100%");
		headerCell.appendChild( navBar);

		if ( bodyCell != null ) {
			//HACK to ensure consistency when adding a 
			//header after the body
			rootTable.rows.insertElementAt( tr, 0);
			rootTable.add( headerCell, null, 0);
			tr.first = headerCell;
			headerCell.row = 0;
			bodyCell.row = 1;
			bodyCell.absYOffset = -navBar.getPreferredSize().height;
			rootTable.currentCell = bodyCell;
			renderer.invalidate();
			rootTable.renderer.validate();
		}
		else {
			rootTable.appendChild( tr);
			tr.appendChild( headerCell);
		}		
	}
}

public void title( String title) {
	TableRow tr = new TableRow();
	rootTable.appendChild( tr);
	tr.appendChild( headerCell = new TableCell( 1, 1, "100%", "0"));
	
	TextImpl tt = new TextImpl(title);
	tt.setFont( FontAttributes.titleFont);
	headerCell.appendChild( tt);
}
}
