package kaffe.awt.doc;

import java.awt.*;
import java.util.Stack;

public class FontAttributes
{
	String face = "Default";
	int size = 10;
	String color = "#000000";
	static Stack stack = new Stack();
	static FontAttributes current = new FontAttributes();
	boolean strong;
	boolean em;
	public static Font titleFont = new Font( "Default", Font.BOLD, 13);

protected FontAttributes() {
}

protected FontAttributes( String face, int size, String color, boolean strong, boolean em) {
	this.face = face;
	this.size = size;
	this.color = color;
	this.strong = strong;
	this.em = em;
}

public static void color( String clr) {
	current.color = clr;
}

public static void em( boolean em) {
	current.em = em;
}

public static void face( String f) {
	current.face = f;
}

public static Color getColor() {
	if ( current.color.startsWith( "#")) {
		return new Color( (int)Long.parseLong( current.color.substring(1), 16));
	}
	return Color.black;
}

public static Font getFont() {
	int attrs = current.strong ? Font.BOLD : Font.PLAIN;
	if ( current.em )
		attrs |= Font.ITALIC;
	return new Font( current.face, attrs, current.size);
}

public static void pop() {
	current = (FontAttributes)stack.pop();
}

public static void push() {
	stack.push( current);
	current = new FontAttributes( current.face, current.size, current.color, current.strong, current.em);
}

public static void size( int s) {
	current.size = s;
}

public static void strong( boolean strong) {
	current.strong = strong;
}
}
