package kaffe.awt.doc;

import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.ScrollPane;
import java.awt.Scrollbar;
import java.awt.event.AdjustmentEvent;
import java.awt.event.AdjustmentListener;

public class Frame
  extends ElementImpl
  implements AdjustmentListener
{
	DocumentImpl doc;
	Scrollbar vScroll;

public Frame ( String source) {
	this( source, true);
}

public Frame ( String source, boolean scrolling) {
	setLayout( null);
	doc = (DocumentImpl)SourceLoader.loadClass( source);
	
	if ( scrolling ) {
		vScroll = new Scrollbar( Scrollbar.VERTICAL);
		vScroll.addAdjustmentListener( this);
		add( vScroll);
	}
	
	if ( doc != null ){
		add( doc);
	}
	
	fWidth = -100;
	fHeight = -100;
}

public void adjustmentValueChanged( AdjustmentEvent e) {
	doc.setLocation( 0, -e.getValue() );
}

public void layout() {
	Dimension d = getSize();
	int sbw = (vScroll != null) ? vScroll.getPreferredSize().width : 0;
	int pos = 0;
	
	//calculate inner document dimension bound to Frame width
	doc.bodyCell.fWidth = d.width-sbw;
	doc.bodyCell.fHeight = 0;
	Dimension d1 = doc.bodyCell.getPreferredSize();

	if ( vScroll != null ) {
		pos = vScroll.getValue();
		vScroll.setBounds( d.width-sbw-1, 0, sbw, d.height-1);
		vScroll.setMaximum( d1.height);
	}

	doc.setBounds( 0, -pos, d.width-sbw-1, d1.height-1);
}
}
