package kaffe.awt.doc;

import java.awt.*;
import java.awt.image.ImageObserver;
import java.net.MalformedURLException;
import java.net.URL;
import org.w3c.dom.*;

public class Image
  extends SimpleElement
  implements ImageObserver
{
	URL src;
	String alt;
	private java.awt.Image img;

class Render
  extends Component
{
public void paint( Graphics g) {
	Dimension s = getSize();
	g.drawImage( img, 0, 0, s.width, s.height, this);
}
}

public Image() {
	renderer = new Render();
}

public boolean imageUpdate ( java.awt.Image img, int infoflags, int x, int y, int width, int height ) {
	if ( (infoflags & (ImageObserver.WIDTH | ImageObserver.HEIGHT)) > 0) {
		renderer.invalidate();
		DocumentImpl di = (DocumentImpl)getOwnerDocument();
		if ( di != null ) {
			di.renderer.validate();
		}
	}
	if ( (infoflags & (ALLBITS | ABORT | ERROR)) != 0 ) {
		return (false);
	}
	else {
		return (true);
	}
}

private void loadImage() {
	if ( img == null ) {
		img = Toolkit.getDefaultToolkit().getImage( src);

		// start production
		ImageObserver obs = this;
		int w = img.getWidth( obs);
		int h = img.getHeight( obs);
		
		if ( (w>0) && (h>0) ) {
			//seems to be synchronously produced
			fHeight = h;
			fWidth = w;
		}
	
	}
}

public void setAttributeNS(String namespaceURI, String localName, String value) {
	if ( localName.equalsIgnoreCase( "src") ) {
		src = SourceLoader.getURL( value);
		img = null;
		loadImage();
	}
	else if ( localName.equalsIgnoreCase( "alt") )
		alt = value;
	else
		super.setAttributeNS( namespaceURI, localName, value);
}
}
