package kaffe.awt.doc;

import java.awt.Component;
import java.awt.Container;
import java.util.Vector;
import org.w3c.dom.*;

public class NodeImpl
  extends Container
  implements Node, NamedNode
{
	String value;
	Vector simpleChilds;

public Node appendChild(Node newChild) throws DOMException {
	if ( newChild instanceof SimpleNode ){
		if ( simpleChilds == null )
			simpleChilds = new Vector();
		simpleChilds.addElement( newChild);
		((SimpleNode)newChild).parent = this;
	}
	else
		add( (Component)newChild);
	return newChild;
}

public Node cloneNode(boolean deep) {
	try {
		return (Node)clone();
	}
	catch ( CloneNotSupportedException _) {
		return null;
	}
}

public NamedNodeMap getAttributes() {
	return null;
}

public NodeList getChildNodes() {
	return null;
}

public Node getFirstChild() {
	int nc = getComponentCount();
	return ( (nc>0) ? (Node)getComponent(0) : null);
}

public Node getLastChild() {
	int nc = getComponentCount();
	return ( (nc>0) ? (Node)getComponent(nc-1) : null);
}

public String getLocalName() {
	return getName();
}

public String getNamespaceURI() {
	return null;
}

public Node getNextSibling() {
	return null;
}

public String getNodeName() {
	return getName();
}

public short getNodeType() {
	return 0;
}

public String getNodeValue() throws DOMException {
	return value;
}

public Document getOwnerDocument() {
	for( Node n = getParentNode(); n != null; n = n.getParentNode() ) {
		if ( n instanceof Document )
			return (Document)n;
	}
	return null;
}

public Node getParentNode() {
	return (Node)getParent();
}

public String getPrefix() {
	return null;
}

public Node getPreviousSibling() {
	return null;
}

public boolean hasChildNodes() {
	return ( getComponentCount() > 0);
}

public Node insertBefore(Node newChild, Node refChild) throws DOMException {
	int nc = getComponentCount();
	
	for ( int i=0; i<nc; i++ ) {
		Node n = (Node)getComponent( i);
		if ( n == refChild) {
			add( (Component)newChild, null, i);
			return newChild;
		}
	}
	
	return null;
}

public Node removeChild(Node oldChild) throws DOMException {
	remove( (Component)oldChild);
	return oldChild;
}

public Node replaceChild(Node newChild, Node oldChild) throws DOMException {
	int nc = getComponentCount();

	for ( int i=0; i<nc; i++ ) {
		Node n = (Node)getComponent( i);
		if ( n == oldChild) {
			remove( i);
			add( (Component)newChild, null, i);
			return newChild;
		}
	}

	return null;
}

public void setNodeValue(String nodeValue) throws DOMException {
	this.value = value;
}

public void setPrefix(String prefix) throws DOMException {
}

public boolean supports(String feature, String version) {
	return false;
}
}
