package kaffe.awt.doc;

import java.awt.Dimension;
import java.util.Hashtable;
import org.w3c.dom.*;

public class SimpleElement
  extends SimpleNode
  implements Element
{
	Hashtable attributes;
	int fWidth;
	int fHeight;

public String getAttribute(String name) {
	return getAttributeNS( null, name);
}

public String getAttributeNS(String namespaceURI, String localName) {
	return ((attributes!=null) ? (String)attributes.get( localName) : null);
}

public Attr getAttributeNode(String name) {
	return getAttributeNodeNS( null, name);
}

public Attr getAttributeNodeNS(String namespaceURI, String localName) {
	return null;
}

public NodeList getElementsByTagName(String name) {
	return getElementsByTagNameNS( null, name);
}

public NodeList getElementsByTagNameNS(String namespaceURI, String localName) {
	return null;
}

public String getTagName() {
	return null;
}

public void normalize() {
}

int preferredHeight() {
	int prefHeight = fHeight;

	if (fHeight<0) {
		Dimension dp = getNextRenderer().getSize();
		prefHeight = -fHeight*dp.height/100;
	}

	return prefHeight;		
}

int preferredWidth() {
	int prefWidth = fWidth;

	if (fWidth<0) {
		Dimension dp = getNextRenderer().getSize();
		prefWidth = -fWidth*dp.width/100;
	}

	return prefWidth;		
}

public void removeAttribute(String name) {
	removeAttributeNS( null, name);
}

public void removeAttributeNS(String namespaceURI, String localName) {
	if ( attributes != null )
		attributes.remove( localName);
}

public Attr removeAttributeNode(Attr oldAttr) {
	return null;
}

public void setAttribute(String name, String value) {
	setAttributeNS( null, name, value);
}

public void setAttributeNS(String namespaceURI, String localName, String value) {
	if ( attributes == null )
		attributes = new Hashtable();
			
	attributes.put( localName, value);
}

public Attr setAttributeNode(Attr newAttr) {
	return newAttr;
}

public Attr setAttributeNodeNS(Attr newAttr) {
	return newAttr;
}

static int sizeValue( String dim) {
	int val = 0;
	try {
		if ( (dim == null) || (dim.length() == 0) )
			val = 0;
		else if ( dim.endsWith( "%") )
			val = - Integer.parseInt( dim.substring( 0, dim.length()-1));
		else
			val = Integer.parseInt( dim);
	}
	catch ( NumberFormatException _ ) {
		val = -1;
	}
		
	return val;
}
}
