package kaffe.awt.flash;

import java.util.Vector;

class FlashImagePlayer
	implements Runnable {

private static FlashImagePlayer singleton;
private Thread tid;
private Vector images = new Vector();

private FlashImagePlayer() {
}

static FlashImagePlayer getInstance() {
	if (singleton == null) {
		singleton = new FlashImagePlayer();
	}
	return (singleton);
}

void add(FlashImage flash) {
	images.addElement(flash);
	if (tid == null) {
		tid = new Thread(this);
		tid.start();
	}
}

void remove(FlashImage flash) {
	images.removeElement(flash);
	notify();
}

public synchronized void run() {
	while (images.size() > 0) {
		// Look thought flashimages for something to do
		long timeout = Long.MAX_VALUE;
		for (int i = images.size() - 1; i >= 0; i--) {
			FlashImage fi = (FlashImage)images.elementAt(i);
			long tm = fi.handleEvents();
			if (tm > 0 && tm < timeout) {
				timeout = tm;
			}
			fi.redraw();
		}
		timeout -= System.currentTimeMillis();
		if (timeout <= 0) {
			timeout = 1;
		}

		// Sleep until we timeout or someone manually
		// wakes us
		try {
			wait(timeout);
		}
		catch (InterruptedException _) {
		}
	}
	tid = null;
}

}
