package kaffe.awt.flash;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Window;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;
import java.awt.event.KeyListener;
import java.net.URL;
import kaffe.awt.AWT;
import kaffe.awt.player.FlashPlayer;

public class FlashMenu
  extends Window
  implements ActionListener
{
	FlashPlayer player;

public FlashMenu ( String file) {
	super( null);
	player = new FlashPlayer( true, true);
	player.addActionListener( this);

	add( player);

	player.setSource( file);
	player.loadSource();
}

public FlashMenu ( URL url) {
	super( null);
	player = new FlashPlayer( true, true);
	player.addActionListener( this);

	add( player);

	player.setSource( url);
	player.loadSource();
}

public void actionPerformed( ActionEvent e) {
	switch ( e.getID() ) {
	case FlashEvent.FS_LOADED:
		synchronized( this) {
			notify();
		}
		break;
	case ActionEvent.ACTION_PERFORMED:
		player.stop();
		dispose();
		break;
	}
}

public void addActionListener( ActionListener l) {
	player.addActionListener( l);
}

public static void main( String[] args) {
	final String path = args[0]; 
	final Window w = new Window( null);
	w.setBounds( 0, 0, 500, 400);
	
	w.setVisible( true);
	
	w.addKeyListener( new KeyAdapter() {
		public void keyReleased( KeyEvent e) {
			FlashMenu fl = new FlashMenu( path );
			fl.show( w, 0, 0, 500, 400);
		}
	});
}

public void removeActionListener( ActionListener l) {
	player.removeActionListener( l);
}

public void show( Component c, int x , int y) {
	int fw = player.getFlashWidth();
	int fh = player.getFlashHeight();
	int cw = AWT.extension.getWidth( c);
	int ch = AWT.extension.getHeight( c);
	
	//constrain to component extends
	int w = ( (x + fw > cw) ? (cw - x) : fw);
	int h = ( (y + fh > ch) ? (ch - y) : fh);
	
	show( c, x, y, w, h );
}

public void show( Component c, int x , int y, int w, int h) {
	Component pc = c;
	for ( ; pc.getParent() != null; pc = pc.getParent()){
		x += AWT.extension.getX( pc);
		y += AWT.extension.getY( pc);
	}
	x += AWT.extension.getX( pc);
	y += AWT.extension.getY( pc);

	setBounds( x, y, w, h );
	setVisible( true);

	player.start();
}

public void update( Graphics g) {
	paint( g);
}
}
