/**
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

package kaffe.awt;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Enumeration;
import java.util.Properties;
import java.util.StringTokenizer;
import kaffe.awt.GoodStuff;
import kaffe.management.Classpath;

public class Desktop
{
	private Properties props;
	private GoodStuff gs;

public Desktop() {
	this("desktop.properties");
}

public Desktop(String filename) {

	// Still need this for some color modes on DOS - without it we
	// still get SEGV problems. 3rd Sept. 1998
	try {
		Class.forName("kaffe.awt.Defaults");
	}
	catch (ClassNotFoundException _) {
	}

	gs = GoodStuff.getDefaultGoodStuff();
	props = new Properties();
	try {
		props.load(new FileInputStream(filename));

		Enumeration keys = props.propertyNames();

		while (keys.hasMoreElements()) {
			String key = (String)keys.nextElement();
			String value = props.getProperty(key);

			if (key.endsWith(".jar")) {
				Classpath.add(value);
			}
			else if (key.endsWith(".application")) {
				String[] args;
				String name;
				String cmd;
				StringTokenizer tok = new StringTokenizer(value);
				int cnt = tok.countTokens();
				cmd = tok.nextToken();
				switch (cnt) {
				case 1:
					name = cmd;
					args = null;
					break;
				case 2:
					name = tok.nextToken();
					args = null;
					break;
				default:
					name = tok.nextToken();
					args = new String[cnt-2];
					for (int i = 0; i < cnt-2; i++) {
						args[i] = tok.nextToken();
					}
					break;
				}
				gs.add(name, "image.gif", cmd, args, false);
			}
			else if (key.endsWith(".applet")) {
				File f1 = new File(value + ".html");
				File f2 = new File(value + ".htm");
				File f3 = new File(value);
				if (f1.canRead()) {
					gs.add(value, "image.gif", "kaffe.applet.AppletViewer", new String[]{ f1.getAbsolutePath() }, false);
				}
				else if (f2.canRead()) {
					gs.add(value, "image.gif", "kaffe.applet.AppletViewer", new String[]{ f2.getAbsolutePath() }, false);
				}
				else if (f3.canRead()) {
					gs.add(value, "image.gif", "kaffe.applet.AppletViewer", new String[]{ f3.getAbsolutePath() }, false);
				}
			}
		}
	}
	catch (IOException _) {
	}

	gs.show();
}

/**
 * Startup the desktop.
 */
public static void main(String[] args) {
	new Desktop();
}
}
