/**
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

package kaffe.awt;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Rectangle;
import java.awt.Toolkit;
import java.lang.reflect.Method;
import java.util.Vector;
import kaffe.lang.Application;
import kaffe.lang.ApplicationException;

public class GoodStuff
{
	Vector items = new Vector( 5);
	Class appCls = getClass();
	String ControlBoxCls;
	String MinBoxCls;
	static GoodStuff singleton = new GoodStuff();

public void add ( GoodStuffItem item ){
	items.addElement( item);
}

public boolean add ( String appName, Image img, String clsName, String[] args, boolean isUnique ){
	add( new GoodStuffApp( appName, img, clsName, args, isUnique));
	return true;
}

public boolean add ( String appName, String imgSrc, String clsName, String[] args, boolean isUnique ){
	ImageDict id = ImageDict.getDefaultDict();
	String key = appName + ':' + imgSrc;
	Image img = id.putImage( key, imgSrc, clsName, null, true, false);
	add( new GoodStuffApp( appName, img, clsName, args, isUnique) );
	return true;
}

public Class getAppCls() {
	return appCls;
}

public String getControlBox () {
	if ( ControlBoxCls != null )
		return ControlBoxCls;
	else
		return System.getProperty( "user.controlbox");
}

public static GoodStuff getDefaultGoodStuff() {
	return singleton;
}

public Image getItemImage ( int idx) {
	return ((GoodStuffItem)items.elementAt( idx)).icon;
}

public String getItemLabel ( int idx) {
	return ((GoodStuffItem)items.elementAt( idx)).name;
}

public String getMinBox () {
	if ( MinBoxCls != null )
		return MinBoxCls;
	else
		return System.getProperty( "user.minbox");
}

public void setAppCls( Class c) {
	appCls = c;
}

public void setAppCls( String c) {
	try {
		appCls = Class.forName( c);
	}
	catch ( ClassNotFoundException x) {
	}
}

public void setControlBox ( String clsName ) {
	ControlBoxCls = clsName;
}

public void setMinBox ( String clsName ) {
	MinBoxCls = clsName;
}

public void show () {
	try {
		// this is a X grx workaround (indefinite select before opening X connection)
		Thread.currentThread().setPriority( Thread.MAX_PRIORITY);
		
		// we just have to trigger a static RootWindow initialize
		Class.forName( "java.awt.RootWindow");
	}
	catch ( Exception x ) {}
}

public int size () {
	return items.size();
}

public void trigger ( int i ) {
	if ( (i >= 0) && (i<items.size()) )
		((GoodStuffItem) items.elementAt( i)).trigger();
}
}

class GoodStuffApp
  extends GoodStuffItem
{
	String clsName;
	String[] args;
	boolean isUnique;
	static String[] defArgs = new String[0];

public GoodStuffApp ( String name, Image img,
	       String clsName, String[] args, boolean isUnique ) {
	super( name, img);

	this.clsName = clsName;
	this.args = (args == null) ? defArgs : args;
	this.isUnique = isUnique;
}

public void trigger() {
	try {
		Application app = new Application(clsName, args);
	}
	catch (ApplicationException e) {
		e.printStackTrace();
	}

}
}

class GoodStuffItem
{
	String name;
	Image icon;

protected GoodStuffItem ( String name, Image icon ) {
	this.name = name;
	this.icon = icon;
}

public void trigger () {
}
}
