package kaffe.awt.theme;

import java.awt.Color;
import java.awt.Component;
import java.awt.Font;
import java.awt.Graphics;
import java.awt.Insets;
import java.util.Properties;
import kaffe.awt.Defaults;

public class ComponentDeco
{
	final public static int CS_ACTIVE = 1;
	final public static int CS_CURSOR_OVER = 2;
	public Color bgClr;
	public Color fgClr;
	public Font fnt;
	public Insets insets = noInsets;
	static Insets noInsets = new Insets(0, 0, 0, 0);
	static String ATTR_FONT = "font";
	static String ATTR_FGCLR = "clrFore";
	static String ATTR_BGCLR = "clrBack";

public ComponentDeco() {
}

public ComponentDeco( Color bg, Color fg, Font f) {
	bgClr = bg;
	fgClr = fg;
	fnt = f;
}

public void addNotify( Component c) {
}

public Color getBackground() {
	return bgClr;
}

public Insets getDecoInsets() {
	return insets;
}

public Font getFont() {
	return fnt;
}

public Color getForeground() {
	return fgClr;
}

static boolean hasAttributes( Properties props, String clazz, String style) {	
	if ( Theme.getProperty(  props, clazz,  ATTR_BGCLR, style ) != null )
		return true;
	if ( Theme.getProperty(  props, clazz, ATTR_FGCLR, style ) != null )
		return true;
	if ( Theme.getProperty(  props, clazz, ATTR_FONT, style ) != null )
		return true;

	return false;
}

public boolean hasBackgroundImage() {
	return false;
}

void initAttributes( Properties props, String clazz, String style, Component c) {
	String val;
	
	if ( (val = Theme.getProperty(  props, clazz,  ATTR_BGCLR, style)) != null ) {
		try { bgClr = Color.decode(val); }
		catch ( NumberFormatException _) {}
	}
	if ( (val = Theme.getProperty( props, clazz, ATTR_FGCLR, style)) != null ) {
		try { fgClr = Color.decode(val); }
		catch ( NumberFormatException _) {}
	}
	if ( (val = Theme.getProperty( props, clazz, ATTR_FONT, style)) != null ) {
		fnt =  Font.decode( val);
	}
}

public boolean paintBackground( Component o, Component c, Graphics g, int cx, int cy, int cw, int ch, int x, int y, int w, int h, int xOff, int yOff, int state) {
	return false;
}

public void paintBorder( Component c, Graphics parentGr, int x, int y, int w, int h, int state) {
}

public void removeNotify( Component c) {
}
}
