package kaffe.awt.theme;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Properties;

public class ImageCheckboxDeco
  extends ImageComponentDeco
{
	static String IMG_CHECKED = "checked";
	static String IMG_UNCHECKED = "unchecked";
	Image imgChecked;
	Image imgUnchecked;

void initImages( Properties props, String clazz, String style, String path, Component c) {
	String val;
	Image imgs[] = new Image[2];

	super.initImages( props, clazz, style, path, c);
	
	if ( (val = Theme.getProperty( props, clazz, IMG_CHECKED, style)) != null ) {
		imgs[0] = ImageTheme.getImage( path , val, style)  ;
	}
	if ( (val = Theme.getProperty(  props, clazz, IMG_UNCHECKED, style)) != null ) {
		imgs[1] = ImageTheme.getImage( path , val, style)  ;
	}
	
	ImageTheme.trackImages( imgs);

	int mw = 0;
	if ( imgs[0] != null ) {
		imgChecked = imgs[0];
		mw = imgChecked.getWidth( null);
	}
	if ( imgs[1] != null ) {
		imgUnchecked = imgs[1];
		mw = Math.max( mw, imgUnchecked.getWidth( null));
	}

	insets.left += mw;	
}

public void paintBorder( Component c, Graphics parentGr, int x, int y, int w, int h, int state) {
	int iw, ih;
	Image img;
	
	super.paintBorder( c, parentGr, x, y, w, h, state);
		
	img = ( (state & CS_ACTIVE) > 0 ) ? imgChecked : imgUnchecked;

	if ( img != null ) {
		iw = img.getWidth( null);
		ih = img.getWidth( null);
		parentGr.drawImage( img, x + insets.left - iw, y + ( h - ih) / 2, null );
	}
}
}
