package kaffe.awt.theme;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Image;
import java.util.Properties;

public class ImageChoiceDeco
  extends ImageComponentDeco
{
	static String IMG_ACTIVE = "active";
	static String IMG_INACTIVE = "inactive";
	Image imgActive;
	Image imgInactive;

void initImages( Properties props, String clazz, String style, String path, Component c) {
	String val;
	Image imgs[] = new Image[2];

	super.initImages( props, clazz, style, path, c);
	
	if ( (val = Theme.getProperty( props, clazz, IMG_ACTIVE, style)) != null ) {
		imgs[0] = ImageTheme.getImage( path , val, style)  ;
	}
	if ( (val = Theme.getProperty(  props, clazz, IMG_INACTIVE, style)) != null ) {
		imgs[1] = ImageTheme.getImage( path , val, style)  ;
	}
	
	ImageTheme.trackImages( imgs);

	int mw = 0;
	if ( imgs[0] != null ) {
		imgActive = imgs[0];
		mw = imgActive.getWidth( null);
	}
	if ( imgs[1] != null ) {
		imgInactive = imgs[1];
		mw = Math.max( mw, imgInactive.getWidth( null));
	}

	insets.right += mw;	
}

public void paintBorder( Component c, Graphics parentGr, int x, int y, int w, int h, int state) {
	int iw, ih;
	Image img;
	
	super.paintBorder( c, parentGr, x, y, w, h, state);
		
	img = ( (state & CS_ACTIVE) > 0 ) ? imgActive : imgInactive;

	if ( img != null ) {
		iw = img.getWidth( null);
		ih = img.getWidth( null);
		parentGr.drawImage( img, x + w -  insets.right - iw, y + ( h - ih) / 2, null );
	}
}
}
