package kaffe.awt.theme;

import java.awt.*;

public class RenderDirection
{
	final public static int LR = 0;
	final public static int RL = 1;
	final public static int TB = 2;
	static int direction = LR;

public static void drawString( String s, Graphics g, int x, int y, int w, int h, int lcr) {
	FontMetrics fm = g.getFontMetrics();
	int x0, y0;
	char ca[];
	
	switch ( direction) {
	case LR:
		switch ( lcr) {
			case 0:
				x0 = x;
				break;
			case 1:
				x0 = x + (w - fm.stringWidth(s)) / 2;
				break;
			default:
				x0 = x + w - fm.stringWidth(s);
				break;
		}
		y0 = y + (h - (h-fm.getHeight()) / 2) - fm.getDescent();
		g.drawString( s, x0, y0);
		break;
	case RL:
		ca = s.toCharArray();
		switch ( lcr) {
			case 0:
				x0 = x + fm.stringWidth( s);
				break;
			case 1:
				x0 = x + w - (w - fm.stringWidth(s)) / 2;
				break;
			default:
				x0 = x + w;
				break;
		}
		y0 = y + (h - (h-fm.getHeight()) / 2) - fm.getDescent();
		for ( int i=0; i<ca.length; i++) {
			x0 -= fm.charWidth( ca[i] );
			g.drawChars ( ca, i, 1, x0, y0);
		}
		break;
	case TB:
		ca = s.toCharArray();
		switch ( lcr) {
			case 0:
				y0 = y - fm.getDescent();
				break;
			case 1:
				y0 = y + (h-ca.length*fm.getHeight()) / 2 - fm.getDescent();
				break;
			default:
				y0 = y + h - ca.length*fm.getHeight() - fm.getDescent();
				break;
		}
		for ( int i=0; i<ca.length; i++) {
			x0 = x + ( w - fm.charWidth( ca[i])) / 2;
			y0 += fm.getHeight();
			g.drawChars ( ca, i, 1, x0, y0);
		}
		break;
	}
}

public static int getDirection() {
	return direction;
}

public static boolean isHorizontal() {
	return ( direction != TB );
}

public static boolean isHorizontal( int dir ) {
	return ( dir != TB );
}

public static void setDirection( int dir) {
	direction = dir;
}
}
