package kaffe.awt.theme;

import java.awt.Color;
import java.awt.Component;
import java.awt.Graphics;
import kaffe.awt.Defaults;

public class SimpleCheckboxDeco
  extends SimpleComponentDeco
{
public SimpleCheckboxDeco() {
	super( null, Color.black, Defaults.TextFont);
	
	int d  = 2*Defaults.SysFontHeight;
	insets.left = d;
	insets.right = 0;
	insets.top = 0;
	insets.bottom = 0;
}

public void paintBorder( Component c, Graphics g, int x, int y, int w, int h, int state) {
	int d = Defaults.SysFontHeight;
	int db = Defaults.WidgetBorderWidth;
	int x0 = x + d/2;
	int y0 = y + (h-d)/2;
	
	g.setColor( ((state & CS_CURSOR_OVER) > 0) ? Defaults.BtnPointClr : Defaults.BtnClr);
	g.fill3DRect( x0, y0, d, d, true);
	
	if ( (state & CS_ACTIVE) > 0 ) {
		paintCheckMark( g, d, x0, y0);
	}
	
	super.paintBorder( c, g, x0-db, y0-db, d+2*db, d+2*db, 0);
}

void paintCheckMark( Graphics g, int ext, int x0, int y0 ) {
	int xl = x0 + 2;
	int xr = x0 + ext - 5;
	int yt = y0 + 3;
	int yb = y0 + ext - 4;

	g.setColor( Color.black);
	g.drawLine( xl, yt, xr, yb);
	g.drawLine( xl, yb, xr, yt);

	xl++; xr++;
	g.setColor( Color.white);
	g.drawLine( xl, yt, xr, yb);
	g.drawLine( xl, yb, xr, yt);
}
}
