package kaffe.awt.theme;

import java.awt.Component;
import java.util.Hashtable;
import kaffe.awt.Defaults;

public class ThemeKaffe
  extends Theme
{
public ComponentDeco getDeco( Component c, String clazz, String style) {
	String val;
	String key = getPropertyKey( clazz, style);
	ComponentDeco cd = null;

	if ( decos != null ) {  
		cd = (ComponentDeco)decos.get( key);
		if ( cd != null )
			return cd;
	}
	
	//special deco objects
	if ( c instanceof java.awt.Button) {
		cd = new SimpleButtonDeco();
	}
	else if ( c instanceof java.awt.Scrollbar) {
		cd = new SimpleScrollbarDeco();
	}
	else if ( c instanceof java.awt.Frame) {
		cd = new SimpleFrameDeco();
	}
	else if ( c instanceof java.awt.Checkbox) {
		cd = new SimpleCheckboxDeco();
	}
	else if ( c instanceof java.awt.Choice) {
		cd = new SimpleChoiceDeco();
	}
	else if ( c instanceof java.awt.Label) {
		if ( c.getClass().getName().equals( "java.awt.Choice$Selection") ){
			cd = new SimpleComponentDeco( Defaults.TextFieldBgClr, Defaults.TextFieldTxtClr, Defaults.TextFieldFont);
		}
		else {
			cd = new ComponentDeco( null, Defaults.LabelClr, Defaults.LabelFont);
		}
	}
	else if ( c instanceof java.awt.TextField){ 
		cd = new SimpleComponentDeco( Defaults.TextFieldBgClr, Defaults.TextFieldTxtClr, Defaults.TextFieldFont);
	}
	else {
		String cn = c.getClass().getName();
		if ( cn.equals( "java.awt.TextArea$TextPane") ){
			cd = new SimpleComponentDeco( Defaults.TextAreaBgClr, Defaults.TextAreaTxtClr, Defaults.TextAreaFont);
		}
		else if ( cn.equals( "java.awt.List$ListPane") ){
			cd = new SimpleComponentDeco( Defaults.ListBgClr, Defaults.ListTxtClr, Defaults.ListFont);
		}
		else {
			if ( (props == null) || (! ComponentDeco.hasAttributes( props, clazz, style) ) ){
				return nullDeco;
			}
			else {
				cd = new ComponentDeco();
			}
		}
	}	

	if ( props != null ){
		cd.initAttributes( props, clazz, style, c);
	}
	
	if ( decos == null ){
		decos = new Hashtable();
	}

	decos.put( key, cd);

	return cd;
}
}
