package kaffe.awt.theme;

import java.awt.Button;
import java.awt.Checkbox;
import java.awt.Choice;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Label;
import java.awt.List;
import java.awt.Rectangle;
import java.awt.ScrollPane;
import java.awt.Scrollbar;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.Window;
import kaffe.awt.Defaults;

public class WidgetTheme
{
	static WidgetThemeImpl theme;
	final public static int NEEDS_BORDER_UPDATE = 1;
	final public static int HAS_FOCUS = 2;
	final public static int IS_ACTIVE = 4;
	final public static int IS_POINTED = 8;
	final public static int IS_UPDATE = 16;

static {
	try {
		Class c = Class.forName( Defaults.WidgetThemeClass);
		theme = (WidgetThemeImpl)c.newInstance();
	}
	catch ( Exception _) {
		theme = new WidgetThemeKaffe();
	}
}

public static int borderInnerWidth ( Component c ) {
	return theme.borderInnerWidth( c);
}

public static int borderOuterWidth ( Component c ) {
	return theme.borderOuterWidth( c);
}

public static void borderPaint ( Component c, Graphics g, int left, int top, int right, int bottom, int width, int height, boolean focused ) {
	theme.borderPaint ( c, g,left,top, right, bottom, width, height, focused );
}

public static void borderPaintInner ( Component c, Graphics g, boolean focused ) {
	theme.borderPaintInner( c, g, focused );
}

public static void borderPaintOuter ( Component c, Graphics g, boolean focused ) {
	theme.borderPaintOuter( c, g, focused);
}

public static Rectangle btnGetDeco( Button btn) {
	return theme.btnGetDeco( btn);
}

public static void btnPaint( Button btn, Graphics g, Rectangle deco, int flags) {
	theme.btnPaint( btn, g, deco, flags);
}

public static void btnPaintBackground( Button btn, Graphics g, int x, int y, int w, int h, int flags) {
	theme.btnPaintBackground( btn, g, x, y, w, h, flags);
}

public static Dimension btnPreferredSize( Button btn, Dimension rawSize) {
	return theme.btnPreferredSize( btn, rawSize);
}

public static void btnSetDefaults(Button btn) {
	theme.btnSetDefaults(btn);
}

public static Rectangle cbGetDeco( Checkbox cb) {
	return theme.cbGetDeco( cb);
}

public static void cbPaint( Checkbox cb, Graphics g, Rectangle deco, int flags) {
	theme.cbPaint( cb, g, deco, flags);
}

public static void cbPaintBackground( Checkbox cb, Graphics g, int x, int y, int w, int h, int flags) {
	theme.cbPaintBackground( cb, g, x, y, w, h, flags);
}

public static Dimension cbPreferredSize( Checkbox cb, Dimension rawSize) {
	return theme.cbPreferredSize( cb, rawSize);
}

public static Rectangle chGetDeco( Choice ch) {
	return theme.chGetDeco( ch);
}

public static boolean chOpenPrompt( Choice cb, int x, int y) {
	return theme.chOpenPrompt( cb, x, y);
}

public static void chPaint( Choice ch, Graphics g, Rectangle deco, int flags) {
	theme.chPaint( ch, g, deco, flags);
}

public static void chPaintBackground( Choice ch, Graphics g, int x, int y, int w, int h, int flags) {
	theme.chPaintBackground( ch, g, x, y, w, h, flags);
}

public static void chPaintPopup(Choice ch, Window popup, Graphics g) {
	theme.chPaintPopup(ch, popup, g);
}

public static Dimension chPreferredSize( Choice cb, Dimension rawSize) {
	return theme.chPreferredSize( cb, rawSize);
}

public static void chSetDefaults( Choice ch) {
	theme.chSetDefaults(ch);
}

public static Rectangle chTextBounds( Choice cb) {
	return theme.chTextBounds( cb);
}

public static int getRenderState ( boolean updateBorder, boolean active, boolean focused, boolean cursorOver) {
	int flags = 0;
	
	if ( updateBorder )		flags |= NEEDS_BORDER_UPDATE;
	if ( active )			flags |= IS_ACTIVE;
	if ( focused )			flags |= HAS_FOCUS;
	if ( cursorOver )		flags |= IS_POINTED;
	
	return flags;
}

public static Rectangle lblGetDeco( Label lbl) {
	return theme.lblGetDeco( lbl);
}

public static void lblPaint(Label lbl, Graphics g, Rectangle deco, int flags ) {
	theme.lblPaint( lbl, g, deco, flags);
}

public static void lblPaintBackground(Label lbl, Graphics g, int x, int y, int w, int h, int flags) {
	theme.lblPaintBackground( lbl, g, x, y, w, h, flags);
}

public static Dimension lblPreferredSize( Label lbl, Dimension rawSize ) {
	return theme.lblPreferredSize( lbl, rawSize);
}

public static void lblSetDefaults(Label lbl) {
	theme.lblSetDefaults(lbl);
}

public static void lstPaintBackground( List lst, Graphics g, int x, int y, int w, int h, int flags) {
	theme.lstPaintBackground( lst, g, x, y, w, h, flags);
}

public static void lstSetDefaults(List lst) {
	theme.lstSetDefaults(lst);
}

public static int sbGetAdjustmentArea( Scrollbar sb, int x, int y, Rectangle trackBounds, int sliderOffset, int sliderLength) {
	return theme.sbGetAdjustmentArea( sb, x, y, trackBounds, sliderOffset, sliderLength);
}

public static Rectangle sbGetDeco( Scrollbar sb) {
	return theme.sbGetDeco( sb);
}

public static Rectangle sbGetTrackBounds( Scrollbar sb, Rectangle trackBounds ) {
	return theme.sbGetTrackBounds( sb, trackBounds);
}

public static void sbPaint( Scrollbar sb, Graphics g, Rectangle deco, int flags) {
	theme.sbPaint( sb, g, deco, flags);
}

public static void sbPaintBackground( Scrollbar sb, Graphics g, int x, int y, int w, int h, int flags) {
	theme.sbPaintBackground( sb, g, x, y, w, h, flags);
}

public static void sbPaintDecrementButton( Scrollbar sb, Graphics g, boolean active) {
	theme.sbPaintDecrementButton( sb, g, active);
}

public static void sbPaintIncrementButton( Scrollbar sb, Graphics g, boolean active) {
	theme.sbPaintIncrementButton( sb, g, active);
}

public static void sbPaintSlider( Scrollbar sb, Graphics g, Rectangle trackBounds, int sliderOffset, int sliderLength, boolean active ) { 
	theme.sbPaintSlider( sb, g, trackBounds, sliderOffset, sliderLength, active);
}

public static Dimension sbPreferredSize( Scrollbar sb, Dimension rawSize ) {
	return theme.sbPreferredSize( sb, rawSize);
}

public static void setTheme(WidgetThemeImpl thm) {
	theme = thm;
	// In an ideal world this would now force a redraw of the entire
	// screen to reflect the new theming - but we can't do this right
	// now so you better only do this before we draw anything!
}

public static void spPaintBackground ( ScrollPane sp, Graphics g, int x, int y, int w, int h, int flags) {
	theme.spPaintBackground(sp, g, x, y, w, h, flags);
}

public static Color taGetForegroundColorSelected(TextArea c, boolean selected) {
	return theme.taGetForegroundColorSelected(c, selected);
}

public static void taPaintBackground( TextArea ta, Graphics g, int x, int y, int w, int h, int flags) {
	theme.taPaintBackground( ta, g, x, y, w, h, flags);
}

public static void taSetDefaults(TextArea ta) {
	theme.taSetDefaults(ta);
}

public static Rectangle tfGetDeco( TextField tf) {
	return theme.tfGetDeco( tf);
}

public static Color tfGetForegroundColorSelected(TextField c, boolean selected) {
	return theme.tfGetForegroundColorSelected(c, selected);
}

public static Dimension tfMinimumSize( TextField tf, Dimension rawSize) {
	return theme.tfMinimumSize( tf, rawSize);
}

public static void tfPaintBackground( TextField tf, Graphics g, int x, int y, int w, int h, int flags) {
	theme.tfPaintBackground( tf, g, x, y, w, h, flags);
}

public static void tfSetDefaults(TextField tf) {
	theme.tfSetDefaults(tf);
}

public static void wdgPaintBorder ( Component c, Graphics g, Rectangle deco, int width, int height, boolean focused ) {
	theme.wdgPaintBorder(c, g, deco, width, height, focused);
}

public static void wndPaintBackground(Window wnd,  Graphics g, int x, int y, int w, int h, int flags) {
	theme.wndPaintBackground(wnd, g, x, y, w, h, flags);
}

public static void wndSetDefaults(Window wnd) {
	theme.wndSetDefaults(wnd);
}
}
