package kaffe.awt.theme;

import java.awt.Button;
import java.awt.Checkbox;
import java.awt.Choice;
import java.awt.Color;
import java.awt.Component;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Frame;
import java.awt.Graphics;
import java.awt.Label;
import java.awt.List;
import java.awt.Rectangle;
import java.awt.ScrollPane;
import java.awt.Scrollbar;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.Window;
import kaffe.awt.Defaults;

abstract public class WidgetThemeImpl
{
abstract public int borderInnerWidth ( Component c );

abstract public int borderOuterWidth ( Component c );

abstract public void borderPaint ( Component c, Graphics g, int left, int top, int right, int bottom, int width, int height, boolean focused );

abstract public void borderPaintInner ( Component c, Graphics g, boolean focused );

abstract public void borderPaintOuter ( Component c, Graphics g, boolean focused );

abstract public Rectangle btnGetDeco( Button btn);

abstract public void btnPaint(Button btn, Graphics g, Rectangle deco, int flags );

abstract public void btnPaintBackground(Button btn, Graphics g, int x, int y, int width, int height, int flags);

abstract public Dimension btnPreferredSize( Button btn, Dimension rawSize);

abstract public void btnSetDefaults(Button btn);

abstract public Rectangle cbGetDeco( Checkbox cb);

abstract public void cbPaint( Checkbox btn, Graphics g, Rectangle deco, int flags);

abstract public void cbPaintBackground( Checkbox cb, Graphics g, int x, int y, int width, int height, int flags);

abstract public Dimension cbPreferredSize( Checkbox cb, Dimension rawSize);

abstract public Rectangle chGetDeco( Choice ch);

abstract public boolean chOpenPrompt( Choice ch, int x, int y);

abstract public void chPaint( Choice ch, Graphics g, Rectangle deco, int flags);

abstract public void chPaintBackground( Choice ch, Graphics g, int x, int y, int width, int height, int flags);

abstract public void chPaintPopup(Choice ch, Window popup, Graphics g);

abstract public Dimension chPreferredSize( Choice cb, Dimension rawSize);

abstract public void chSetDefaults( Choice ch);

abstract public Rectangle chTextBounds( Choice ch);

abstract public Rectangle lblGetDeco( Label lbl);

abstract public void lblPaint( Label lbl, Graphics g, Rectangle deco, int flags );

abstract public void lblPaintBackground( Label lbl, Graphics g, int x, int y, int width, int height, int flags);

abstract public Dimension lblPreferredSize( Label lbl, Dimension rawSize );

abstract public void lblSetDefaults(Label lbl);

abstract public void lstPaintBackground( List lst, Graphics g, int x, int y, int width, int height, int flags);

abstract public void lstSetDefaults(List lst);

abstract public int sbGetAdjustmentArea( Scrollbar sb, int x, int y, Rectangle
trackBounds, int sliderOffset, int sliderLength );

abstract public Rectangle sbGetDeco( Scrollbar sb);

abstract public Rectangle sbGetTrackBounds( Scrollbar sb, Rectangle trackBounds );

abstract public void sbPaint( Scrollbar sb, Graphics g, Rectangle deco, int flags);

abstract public void sbPaintBackground( Scrollbar sb, Graphics g, int x, int y, int width, int height, int flags);

abstract public void sbPaintDecrementButton( Scrollbar sb, Graphics g, boolean active);

abstract public void sbPaintIncrementButton( Scrollbar sb, Graphics g, boolean active);

abstract public void sbPaintSlider( Scrollbar sb, Graphics g, Rectangle trackBounds, int sliderOffset, int sliderLength, boolean active );

abstract public Dimension sbPreferredSize( Scrollbar sb, Dimension rawSize );

abstract public void spPaintBackground( ScrollPane sp, Graphics g, int x, int y, int w, int h, int flags);

abstract public Color taGetForegroundColorSelected(TextArea c, boolean selected);

abstract public void taPaintBackground( TextArea ta, Graphics g, int x, int y, int width, int height, int flags);

abstract public void taSetDefaults(TextArea ta);

abstract public Rectangle tfGetDeco( TextField tf);

abstract public Color tfGetForegroundColorSelected(TextField c, boolean selected);

abstract public Dimension tfMinimumSize( TextField tf, Dimension rawSize);

abstract public void tfPaintBackground( TextField tf, Graphics g, int x, int y, int width, int height, int flags);

abstract public void tfSetDefaults(TextField tf);

abstract public void wdgPaintBorder ( Component c, Graphics g, Rectangle deco, int width, int height, boolean focused );

abstract public void wndPaintBackground(Window wnd,  Graphics g, int x, int y, int width, int height, int flags);

abstract public void wndSetDefaults(Window wnd);
}
