package kaffe.awt.widgets;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.text.SimpleDateFormat;
import java.util.Date;
import kaffe.awt.AWT;
import kaffe.util.Timer;
import kaffe.util.TimerClient;

public class ClockPane
  extends Component
  implements TimerClient
{
	SimpleDateFormat fmt;
	int interval;
	Date date = new Date();
	static SimpleDateFormat defaultFmt = new SimpleDateFormat("HH:mm:ss");

public ClockPane() {
	this( defaultFmt);
}

public ClockPane( SimpleDateFormat fmt) {
	this.fmt = fmt;
	
	interval = 59900;
	if ( fmt.toPattern().indexOf( ":ss") > -1 ) {
		interval = 900;	
	}
	
}

public void addNotify() {
	super.addNotify();
	Timer.getDefaultTimer().addClient( this, 100, interval);
}

public Dimension getPreferredSize() {
	FontMetrics fm = getFontMetrics( getFont() );
	String s = fmt.format( new Date() );

	return new Dimension( fm.stringWidth( s), fm.getHeight() );
}

public void paint( Graphics g) {
	date.setTime( System.currentTimeMillis() );
	
	String s = fmt.format( date );
	FontMetrics fm = g.getFontMetrics();
	
	int w = AWT.extension.getWidth( this);
	int h = AWT.extension.getHeight( this);
	
	int x = (w - fm.stringWidth( s)) / 2;
	int y = (h - fm.getHeight()) / 2 + fm.getAscent();

	g.clearRect( 0, 0, w, h);	
	g.drawString( s, x, y);
}

public void removeNotify() {
	Timer.getDefaultTimer().removeClient( this);
	super.removeNotify();
}

public void timerExpired( Timer t) {
	Graphics g = getGraphics();
	if ( g != null ) {
		paint( g);
		g.dispose();
	}
}
}
