package kaffe.awt.widgets;

import java.awt.Color;
import java.awt.FontMetrics;
import java.awt.Graphics;
import java.util.Vector;

public class DefaultItemRender
  implements ItemRender
{
	ItemRenderEnv renderEnv = new ItemRenderEnv();
	static DefaultItemRender instance;

private DefaultItemRender() {
}

public void drawItem( ItemRenderEnv env){
	FontMetrics fm = env.graph.getFontMetrics();
	int y = env.rect.y + (env.rect.height - fm.getHeight())/2 + fm.getAscent();
	Object item = env.items.elementAt( env.curIdx);

	String s = item.toString();	
	env.graph.drawString( s, env.rect.x, y ); 
}

public static ItemRender getInstance() {
	if ( instance == null ) {
		instance = new DefaultItemRender();
	}
	return instance;
}

public int getItemHeight( ItemRenderEnv env){
	//let ItemPane decide about it
	return 0;
}

public int getMaxWidth( ItemRenderEnv env){
	return 300;
}

public ItemRenderEnv getRenderEnv(){
	return renderEnv;
}
}
