package kaffe.awt.widgets;

import java.awt.Color;
import java.awt.Font;
import java.awt.FontMetrics;
import java.awt.Frame;
import java.awt.Image;
import java.awt.Toolkit;
import java.io.File;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Vector;

class FEntry
{
	boolean expanded;
	File file;

FEntry( File file) {
	this.file = file;
}
}

class FEntryRender
  implements ItemRender
{
	ItemRenderEnv renderEnv = new ItemRenderEnv();
	static Font fSmall = new Font( "Dialog", Font.ITALIC, 10 );
	static SimpleDateFormat fmt = new SimpleDateFormat("MM/dd/yyyy HH:mm");
	static Date date = new Date();
	static Font fMed = new Font( "Courier", Font.PLAIN, 12 );

public void drawItem( ItemRenderEnv env){
	FontMetrics fm = env.graph.getFontMetrics();
	int x0 = env.rect.x + env.xOffs;
	int y = env.rect.y + (env.rect.height - fm.getHeight())/2 + fm.getAscent();
	FEntry item = (FEntry)env.items.elementAt( env.curIdx);

	String s = item.file.getName();	
	int sl = s.length();
	if ( sl > 20 ) {
		s = s.substring( 0, 20) + "...";
	}
	if ( item.file.isDirectory() ) {
		env.graph.setColor( Color.blue);
	}
	
	env.graph.setFont( fMed);
	fm = env.graph.getFontMetrics();
	env.graph.drawString( s, x0, y );
	
	env.graph.setFont( fSmall);
	fm = env.graph.getFontMetrics();

	if ( ! item.file.isDirectory() ) {
		int iLen = (int)item.file.length();
		if ( iLen < 10000 )
			env.graph.setColor( Color.green);
		else 
			env.graph.setColor( Color.red);
			
		env.graph.setFont( fSmall);
		s = Integer.toString( iLen);
		env.graph.drawString( s, env.rect.x + 320, y );
	}

	
	env.graph.setColor( Color.yellow);
	date.setTime( item.file.lastModified() );
	s = fmt.format( date);
	env.graph.drawString( s, env.rect.x + 400, y );
	 
}

public int getItemHeight( ItemRenderEnv env){
	//let ItemPane decide about it
	return 0;
}

public int getMaxWidth( ItemRenderEnv env){
	env.itemWidth = 600;
	return env.itemWidth;
}

public ItemRenderEnv getRenderEnv(){
	return renderEnv;
}
}

public class FileBrowserTest
  implements TreeNavigator
{
public void collapse( Object o){
	((FEntry)o).expanded = false;
}

public void expand( Object o, boolean deep){
	((FEntry)o).expanded = true;
}

public Vector getChildren( Object o){
	File[] fls = ((FEntry)o).file.listFiles();
	Vector v = new Vector();
	if ( fls != null ) {
		for ( int i=0; i<fls.length; i++ ) {
			v.addElement( new FEntry( fls[i]));
		}
	}
	return v;
}

public int getLevel( Object o) {
	String s1 =  ((FEntry)o).file.getPath();
	int l1 = s1.length();
	int lvl = 0;
	
	for ( int i=0; i<l1; i++ ) {
		if ( s1.charAt(i) == File.separatorChar ) {
			lvl++;
		}
	}
	return lvl - 1;
}

public Object getParent( Object o) {
	String s = ((FEntry)o).file.getParent();
	if ( s != null ) {
		return new FEntry( new File( s));
	}	
	return null;
}

public boolean hasChildren( Object o){
	return ((FEntry)o).file.isDirectory();
}

public boolean isExpanded( Object o){
	return ((FEntry)o).expanded;
}

public static void main( String[] args) {
	Frame f = new Frame("FileBrowser on: //");
	FileBrowserTest bt = new FileBrowserTest();
	ItemRender rd = new FEntryRender();
	
	String i1 = "/home/joerg/dir.gif";
	String i2 = "/home/joerg/file.gif";
	
	Image img1 = Toolkit.getDefaultToolkit().getImage( i1);
	Image img2 = Toolkit.getDefaultToolkit().getImage( i2);

	TreeHandler th = new TreeHandler( rd, bt, img1, img2);
	
	ItemList lst = new ItemList( th);
	
	lst.setContents( new FEntry( new File("/")) );
	f.add( "Center", lst);
	f.setBounds( 100, 100, 500, 300);
	f.setVisible( true);
}
}
