package kaffe.awt.widgets;

import java.awt.Button;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import kaffe.awt.AWT;

public class ImageButton
  extends Button
{
	Image img;

public ImageButton( Image img) {
	super( null);
	this.img = img;
}

public void paint( Graphics g) {
	if ( img == null ) {
		super.paint(g);
	}
	else {
		int x0 = (AWT.extension.getWidth( this) - img.getWidth( this)) / 2;
		int y0 = (AWT.extension.getHeight( this) - img.getHeight( this)) / 2;
		g.drawImage( img, x0, y0, this);
	}
}

public Dimension preferredSize() {
	Dimension d = super.preferredSize();
	
	if ( img != null ) {
		d.width += img.getWidth( this);
		d.height += img.getHeight( this);
	}
	
	return d;
}

public void setImage( Image img) {
	this.img = img;
	if ( isShowing() )
		repaint();
}
}
