package kaffe.awt.widgets;

import java.awt.Component;
import java.awt.Frame;
import java.awt.List;
import java.util.Vector;

public class ItemList
  extends List
{
	ItemPane pane;

public ItemList( ) {
	this( DefaultItemRender.getInstance());
}

public ItemList( Object handler) {
	super();
	pane = getItemPane();
	
	if ( pane == null ) {
		//throw new ...
	}
	
	setHandler( handler);
}

public void addItem( String item, int index) {
	//override java.awt.List String interface
	insertListItem( item, index);
}

public void addListItem( Object item) {
	insertListItem( item, -1);
}

protected ItemPane getItemPane() {
	int cc = getComponentCount();
	for ( int i=0; i<cc; i++ ) {
		Component c = getComponent( i);
		if ( c instanceof ItemPane ) {
			return ((ItemPane)c);
		}
	}
	return null;
}

public Vector getListItems() {
	return pane.getItems();
}

public void insertListItem( Object item, int idx) {
	Vector v = pane.getItems();
	if ( v == null ) {
		v = new Vector();
	}
	if ( idx >= 0 ) {
		v.insertElementAt( item, idx);
	}
	else {
		v.addElement( item);
	}		
	
	pane.setContents( v);
}

public static void main( String[] args) {
	Frame f = new Frame();
	ItemList lst = new ItemList();
	
	lst.addListItem( "this");
	lst.addListItem( "is a");
	lst.addListItem( "first test");
	
	f.add( "Center", lst);
	f.setBounds( 100, 100, 300, 300);
	f.setVisible( true);
}

public void removeListItem( Object item) {
	Vector v = pane.getItems();
	if ( v != null ) {
		v.removeElement( item);
		pane.setContents( v);
	}		
}

public void setContents( Object contents) {
	pane.setContents( contents);
}

public void setHandler( Object handler) {
	if ( handler instanceof ItemRender ) {
		setItemRender( (ItemRender)handler);
	}
	if ( handler instanceof ItemProcessor ) {
		setItemProcessor( (ItemProcessor)handler);
	}
	if ( handler instanceof ItemFilter ) {
		setItemFilter( (ItemFilter)handler);
	}
}

public void setItemFilter( ItemFilter filter) {
	pane.setItemFilter( filter);
}

public void setItemProcessor( ItemProcessor proc) {
	pane.setItemProcessor( proc);
}

public void setItemRender( ItemRender render) {
	pane.setItemRender( render);
}
}
