package kaffe.awt.widgets;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Graphics;
import kaffe.awt.AWT;

public class ProgressBar
  extends Component
{
	int progress;

public ProgressBar() {
}

public Dimension getPreferredSize() {
	return new Dimension( 200, 30);
}

public void paint( Graphics g) {
	int w = AWT.extension.getWidth( this);
	int xn = w * progress / 100;
	repaintArea( g, 0, xn);
}

protected void repaintArea( Graphics g, int x0, int x1) {
	int h = AWT.extension.getHeight( this);
	
	int bw = 3;
	int fw = 9;
	int tw = bw + fw;
	
	int pb = x0 / tw;
	int nb = x1 / tw;
	
	if ( nb > pb) {
	
		nb += 1;
		
		Color c1 = getBackground();
		Color c2 = getForeground();
	
		Graphics gs = g;
		if ( gs == null ) {
			g = getGraphics();
		}
		
		if ( g != null ) {
			for ( int i=pb; i<nb; i++ ) {
				g.setColor( c1);
				g.fillRect( i*tw, 1, bw, h-2);
				g.setColor( c2);
				g.fill3DRect( i*tw+bw, 1, fw, h-2, false);
			}
						
			if ( gs == null ) {
				g.dispose();
			}
		}
	}
}

public void setProgress( int percent) {
	int w = AWT.extension.getWidth( this);
	int xp = w * progress / 100;
	int xn = w * percent / 100;
	
	repaintArea( null, xp, xn);
	progress = percent;
}
}
