package kaffe.awt.widgets;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.FontMetrics;
import java.awt.Graphics;
import kaffe.awt.AWT;

public class TextPane
  extends Component
{
	final static int TEXT_INSET = 5;
	int prefWidth = 200;
	char[] text;

public TextPane( String text) {
	this.text = text.toCharArray();
}

public Dimension getPreferredSize() {
	int maxW = prefWidth;
	int inset = TEXT_INSET;
	FontMetrics fm = this.getFontMetrics( this.getFont() );
	int lw, i, i0, y0, lastBrk=-1;
	char c;
	
	y0 = fm.getHeight() + inset;
	
	lw = inset;
	i0 = 0;
	for ( i=0; i<text.length; i++ ) {
		c = text[i];
		
		if ( c == 0x0a ) {
			lw = inset;
			i0 = i+1;
			y0 += fm.getHeight();
			lastBrk=-1; 
		}
		else {
			if ( c == 0x20 ){
				lastBrk=i;
			}
		
			lw += fm.charWidth( c );
			if ( lw > (maxW - inset) ) {
				if ( lastBrk >= 0 ){
					i = lastBrk+1;
					lastBrk = -1;

					lw = inset;
					i0 = i+1;
					y0 += fm.getHeight(); 					
				}
				else {
					// Hmm, we have to extend the width
					maxW = lw + inset;
				}
			}
		}
	}
	
	return ( new Dimension( maxW, y0 + 2*inset ));
}

public void paint( Graphics g) {
	int inset = TEXT_INSET;
	int maxW = AWT.extension.getWidth( this) - inset;
	FontMetrics fm = this.getFontMetrics( this.getFont() );
	int lw, i, i0, y0, lastBrk=-1;
	char c;
	
	y0 = fm.getHeight() + inset;
	
	lw = inset;
	i0 = 0;
	for ( i=0; i<text.length; i++ ) {
		c = text[i];
		if ( c == 0x0a ) {
			g.drawChars( text, i0, i-i0, inset, y0); 
			lw = inset;
			i0 = i+1;
			y0 += fm.getHeight();
			lastBrk = -1;
		}
		else {
			if ( c == 0x20 ){
				lastBrk = i;
			}
		
			lw += fm.charWidth( c );
			if ( lw > maxW ) {
				if ( lastBrk >= 0 ){
					i = lastBrk;
					lastBrk = -1;
			
					g.drawChars( text, i0, i-i0, inset, y0); 
					lw = inset;
					i0 = i+1;
					y0 += fm.getHeight();
				}
			}
		}
	}
	g.drawChars( text, i0, i-i0, inset, y0); 
}
}
