package kaffe.awt.widgets;

import java.awt.Color;
import java.awt.Font;
import java.awt.Frame;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.text.SimpleDateFormat;
import kaffe.awt.GenericLayout;
import kaffe.awt.GenericLayoutConstraints;

public class WidgetsTest
  extends Frame
  implements ItemListener
{
public WidgetsTest() {
	super( "WidgetsTest");
	
	setLayout( new GenericLayout() );
	GenericLayoutConstraints gc = new GenericLayoutConstraints();
	
	DatePane dp = new DatePane();
	dp.addItemListener( this);
	gc.setYCorner( 0, 300, gc.SOUTH);
	add( dp, gc);
	

	SimpleDateFormat fmt = new SimpleDateFormat( "HH:mm:ss");
	ClockPane cp = new ClockPane( fmt);
	cp.setBackground( Color.black);
	cp.setForeground( Color.green);
	cp.setFont( new Font("Dialog", Font.BOLD, 20) );
	
	gc.setYOrigin( 0, 300, gc.SOUTH);
	gc.setYCorner( 20, 0, gc.SOUTH);
	add( cp, gc);

	ProgressBar pb = new ProgressBar();
	pb.setBackground( Color.lightGray);
	pb.setForeground( Color.blue);

	gc.setYOrigin( 20, 0, gc.SOUTH);
	gc.setYCorner( 0, 0, gc.SOUTH);
	add( pb, gc);
	
	setBounds( 100, 100, 250, 250);
	setVisible( true);
	
	try {
		for ( int i=0; i<=100; i++ ) {
			pb.setProgress( i);
			Thread.sleep( 100);
		}
	}
	catch( Exception _ ) {}
}

public void itemStateChanged( ItemEvent e) {
	System.out.println( e);
}

public static void main( String[] args) {
	new WidgetsTest();
}
}
