package kaffe.io;

import java.io.FilterInputStream;
import java.io.InputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.Hashtable;

abstract public class ByteToCharFilter
	extends FilterInputStream {

static private Hashtable cache = new Hashtable();

protected String name;

protected ByteToCharFilter() {
	super(null);
}

public static ByteToCharFilter getDefault(InputStream strm) {
	ByteToCharFilter filter = getConverterInternal(ConverterAlias.encodingDefault);
	if (filter == null) {
		filter = new ByteToCharFilterDefault();
	}
	filter.in = strm;
	return (filter);
}

public static ByteToCharFilter getConverter(String enc, InputStream strm) throws UnsupportedEncodingException {
	ByteToCharFilter filter = getConverterInternal(enc);
	if (filter == null) {
		throw new UnsupportedEncodingException(enc);
	}
	filter.in = strm;
	return (filter);
}

public String toString() {
	return (name);
}

abstract public int read(char cbuf[], int off, int len) throws IOException;

private static ByteToCharFilter getConverterInternal(String enc) {
	Class cls = (Class)cache.get(enc);
	if (cls == ConverterAlias.noConverter) {
		return (null);
	}
	String encalias = ConverterAlias.alias(enc);
	String realenc = ConverterAlias.encodingRoot + ".ByteToCharFilter" + encalias;
	try {
		if (cls == null) {
			cls = Class.forName(realenc, true, null);
			cache.put(enc, cls);
		}
		ByteToCharFilter filter = (ByteToCharFilter)cls.newInstance();
		filter.name = encalias;
		return (filter);
	}
	catch (ClassNotFoundException _) {
	}
	catch (ClassCastException _) {
	}
	catch (InstantiationException _) {
	}
	catch (IllegalAccessException _) {
	}
	cache.put(enc, ConverterAlias.noConverter);
	return (null);
}

}
