package kaffe.io;

import java.io.IOException;
import java.io.CharConversionException;

class ByteToCharFilterUTF8
	extends ByteToCharFilter {

public int read(char cbuf[], int off, int len) throws IOException {
	for (int o = off; o < off+len; ) {
                int data = super.read();
                if ((data & 0x80) == 0) {
			cbuf[o++] = (char)data;
		}
		/* Hi-bit set, multi byte char */
		else if ((data & 0xE0) == 0xC0) {
			int data2 = super.read();
			if ((data2 & 0xC0) == 0x80) {
				/* Valid 2nd byte */
				int val = ((data & 0x1F) << 6) + (data2 & 0x3F);
				cbuf[o++] = (char)val;
			}
			else if (data2 == -1) {
				/* EOF */
				if (o == off) {
					return (-1);
				}
				return (o - off);
			}
			else {
				throw new CharConversionException();
			}
		}
		else if ((data & 0xF0) == 0xE0) {
			int data2 = super.read();
			if ((data2 & 0xC0) == 0x80) {
				int data3 = super.read();
				if ((data3 & 0xC0) == 0x80) {
					int val = ((data & 0x0F) << 12) + ((data2 & 0x3F) << 6) + (data3 & 0x3F);
					cbuf[o++] = (char)val;
				}
				else if (data3 == -1) {
					/* EOF */
					if (o == off) {
						return (-1);
					}
					return (o - off);
				}
				else {
					throw new CharConversionException();
				}
			}
			else if (data2 == -1) {
				/* EOF */
				if (o == off) {
					return (-1);
				}
				return (o - off);
			}
			else {
				throw new CharConversionException();
			}
		}
		else if (data == -1) {
			/* EOF */
			if (o == off) {
				return (-1);
			}
			return (o - off);
		}
		else {
			throw new CharConversionException();
		}
	}
	return (len);
}

}
