package kaffe.io;

import java.io.FilterOutputStream;
import java.io.OutputStream;
import java.io.IOException;
import java.io.UnsupportedEncodingException;
import java.util.Hashtable;

abstract public class CharToByteFilter
	extends FilterOutputStream {

static private Hashtable cache = new Hashtable();

protected String name;

protected CharToByteFilter() {
	super(null);
}

public static CharToByteFilter getDefault(OutputStream strm) {
	CharToByteFilter filter = getConverterInternal(ConverterAlias.encodingDefault);
	if (filter == null) {
		filter = new CharToByteFilterDefault();
	}
	filter.out = strm;
	return (filter);
}

public static CharToByteFilter getConverter(String enc, OutputStream strm) throws UnsupportedEncodingException {
	CharToByteFilter filter = getConverterInternal(enc);
	if (filter == null) {
		throw new UnsupportedEncodingException(enc);
	}
	filter.out = strm;
	return (filter);
}

public String toString() {
	return (name);
}

abstract public void write(char cbuf[], int off, int len) throws IOException;

private static CharToByteFilter getConverterInternal(String enc) {
	Class cls = (Class)cache.get(enc);
	if (cls == ConverterAlias.noConverter) {
		return (null);
	}
	String encalias = ConverterAlias.alias(enc);
	String realenc = ConverterAlias.encodingRoot + ".CharToByteFilter" + encalias;
	try {
		if (cls == null) {
			cls = Class.forName(realenc, true, null);
			cache.put(enc, cls);
		}
		CharToByteFilter filter = (CharToByteFilter)cls.newInstance();
		filter.name = encalias;
		return (filter);
	}
	catch (ClassNotFoundException _) {
	}
	catch (ClassCastException _) {
	}
	catch (InstantiationException _) {
	}
	catch (IllegalAccessException _) {
	}
	cache.put(enc, ConverterAlias.noConverter);
	return (null);
}

}
