package kaffe.io;

import java.io.IOException;

class CharToByteFilterUTF8
	extends CharToByteFilter {

public void write(char cbuf[], int off, int len) throws IOException {
	for (int i = 0; i < len; i++) {
                int chr = cbuf[off+i];
                if (chr >= '\u0001' && chr <= '\u007F') {
			super.write(chr);
		}
                else if (chr <= '\u07FF') {
                        super.write(0xC0 | (0x1F & (chr >> 6)));
                        super.write(0x80 | (0x3F & chr));
                }
                else {
                        super.write(0xE0 | (0x0F & (chr >> 12)));
                        super.write(0x80 | (0x3F & (chr >>  6)));
                        super.write(0x80 | (0x3F & chr));
                }
        }
}

}
