package kaffe.io;

import java.io.File;
import java.io.IOException;

public class FileName {

public static final int EXISTS = 0;
public static final int FILE = 1;
public static final int DIRECTORY = 2;
public static final int CANREAD = 3;
public static final int CANWRITE = 4;

static {
	System.loadLibrary("io");
}

private final String filename;

public FileName(String filename) {
	this.filename = filename;
}

public String getPath() {
	return (filename);
}

public boolean mkdir() {
	return (mkdir0(filename));
}

private native boolean mkdir0(String dirname);

public boolean rmdir() {
	return (rmdir0(filename));
}

private native boolean rmdir0(String dirname);

public boolean delete() {
	return (delete0(filename));
}

private native boolean delete0(String dirname);

public boolean rename(FileName to) {
	return (rename0(filename, to.getPath()));
}

private native boolean rename0(String from, String to);

public long lastModified() {
	return (lastModified0(filename));
}

private native long lastModified0(String filename);

public long length() {
	return (length0(filename));
}

private native long length0(String filename);

public boolean checkMode(int mode) {
	return (checkMode0(filename, mode));
}

private native boolean checkMode0(String filename, int mode);

public boolean createNewFile() {
        return (createNewFile0(filename));
}

private native boolean createNewFile0(String filename);

public String[] readdir() {
	return (readdir0(filename));
}

private native String[] readdir0(String filename);

public boolean isAbsolute() {
        char first = filename.charAt(0);
        if (first == File.separatorChar) {
                return (true);
        }
        else {
                // Handle C:\ style
                if (filename.length() > 3 &&
                    filename.charAt(1) == ':' &&
                    filename.charAt(2) == File.separatorChar &&
                    (first >= 'A' && first <= 'Z')) {
                        return (true);
                }
        }
        return (false);
}

}
