package kaffe.io;

import java.io.IOException;
import java.io.InputStream;
import java.net.DatagramPacket;
import java.net.DatagramSocket;

public class RtpMediaStream
  extends InputStream
{
	DatagramSocket sock;
	final public static int PACKET_LEN = 1450;
	final public static int HEADER_LEN = 12;
	byte[] sbuf;
	DatagramPacket packet;

public RtpMediaStream( DatagramSocket socket) {
	this.sock = socket;
	sbuf = new byte[PACKET_LEN];
	packet = new DatagramPacket( sbuf, PACKET_LEN);
}

public void close() throws IOException {
	sock.disconnect();
	sock.close();
}

public int read() throws IOException {
	return 0;
}

public int read(byte b[], int off, int len) throws IOException {
	if ( len < PACKET_LEN ) {
		throw new IOException("buffer too small");
	}
	//use original buffer to prevent huge copies,
	//user just has to be aware to offset the first
	//12 header bytes from the data stream

	//can't be reused for any reason ???
	packet = new DatagramPacket( b, PACKET_LEN);
	sock.receive( packet);	
	return (PACKET_LEN - HEADER_LEN);
}

public int read_2(byte b[], int off, int len) throws IOException {
	int mpl;
	
	//can't be reused for any reason ???
	packet = new DatagramPacket( sbuf, PACKET_LEN);

	sock.receive( packet);
	byte[] data = packet.getData();
	mpl = data.length - HEADER_LEN;
	
	for ( int i=0; i<mpl; i++ ) {
		b[i] = data[HEADER_LEN + i];
	}

	return mpl;
}
}
