/*
 * Java core library component.
 *
 * Copyright (c) 1997 - 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

package kaffe.io;

import java.io.OutputStream;
import java.io.IOException;

public class SplitOutputStream
  extends OutputStream {

private OutputStream prim;
private OutputStream sec;

public SplitOutputStream(OutputStream primary, OutputStream secondary) {
	prim = primary;
	sec = secondary;
}

public void close() throws IOException {
	flush();
        prim.close();
        sec.close();
}

public void flush() throws IOException {
        prim.flush();
        sec.flush();
}

public void write(byte b[]) throws IOException {
        write(b, 0, b.length);
}

public void write(byte b[], int off, int len) throws IOException {
        prim.write(b, off, len);
        sec.write(b, off, len);
}

public void write(int b) throws IOException {
        prim.write(b);
        sec.write(b);
}

}
