/*
 * Java core library component.
 *
 * Copyright (c) 1997 - 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

package kaffe.io;

import java.io.InputStream;
import java.io.OutputStream;
import java.io.Reader;
import java.io.Writer;
import java.io.IOException;

public class StreamCopier {

public static void copy(OutputStream out, InputStream in) throws IOException {
	copy(out, in, 1024);
}

public static void copy(OutputStream out, InputStream in, int size) throws IOException {
	byte[] buf = new byte[size];
	int l = 1;
	while (l > 0) {
		l = in.read(buf);
		if (l > 0) {
			out.write(buf, 0, l);
		}
	}
}

public static void copy(Writer out, Reader in) throws IOException {
	copy(out, in, 1024);
}

public static void copy(Writer out, Reader in, int size) throws IOException {
	char[] buf = new char[size];
	int l = 1;
	while (l > 0) {
		l = in.read(buf);
		if (l > 0) {
			out.write(buf, 0, l);
		}
	}
}

}
