/*
 * Java core library component.
 *
 * Copyright (c) 1997, 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

package kaffe.lang.ref;

import java.lang.ref.Reference;
import java.lang.ref.ReferenceQueue;

public class RecycleReference extends Reference {

final static private int RECYCLE = 3;	// Must match java.lang.ref.Reference

public RecycleReference() {
	super(null, null);
        type = RECYCLE;
}

public void init(Recycleable obj) {
	this.obj = obj;
}

/**
 * This method is called by the VM finds this is the only reference to
 * the object.  We can then recycle it.
 */
protected void dispatch() {
	Recycle.dispatch(this);
}

}
