package kaffe.net.www.content;

import java.io.IOException;
import java.net.ContentHandler;
import java.net.ContentHandlerFactory;
import java.net.URLConnection;
import java.util.Hashtable;

public class DefaultContentHandlerFactory
	implements ContentHandlerFactory {

private Hashtable handlers = new Hashtable();
private String base;
private ContentHandler defaultHandler;

public DefaultContentHandlerFactory() {
	this("kaffe.net.www.content.", new DefaultContentHandler());
}

public DefaultContentHandlerFactory(String base, ContentHandler def) {
	this.base = base;
	this.defaultHandler = def;
}

public ContentHandler createContentHandler(String mimetype) {
	ContentHandler hand = (ContentHandler)handlers.get(mimetype);
	if (hand != null) {
		return (hand);
	}
	try {
		String type = mimetype.replace('.', '_').replace('-', '_').replace('/', '.');
		Class cls = Class.forName(base + type);
		hand = (ContentHandler)cls.newInstance();
		handlers.put(mimetype, hand);
		return (hand);
	}
	catch (ClassNotFoundException _) {
	}
	catch (InstantiationException _) {
	}
	catch (IllegalAccessException _) {
	}
	handlers.put(mimetype, defaultHandler);
	return (defaultHandler);
}

}

class DefaultContentHandler extends ContentHandler {

public Object getContent(URLConnection urlc) throws IOException {
	return (urlc.getInputStream());
}

}
