package kaffe.tools.compiler;


/*
 * Java core library component.
 *
 * Copyright (c) 1997, 1998, 1999
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */
abstract public class Compiler
{
	final private static String prefix = "kaffe.tools.compiler.Compiler_";
	protected Exception exception;
	protected String destination;
	protected String classpath;

abstract public boolean compile(String name);

public Exception getException() {
	return (exception);
}

public static Compiler getInstance() {
	return (getInstance(System.getProperty("kaffe.compiler", "default")));
}

public static Compiler getInstance(String name) {
	try {
		Class cls = Class.forName(prefix + name);
		return ((Compiler)cls.newInstance());
	}
	catch (ClassNotFoundException _) {
	}
	catch (IllegalAccessException _) {
        }
	catch (InstantiationException _) {
        }
	return (new Compiler_default());
}

public void setClasspath(String path) {
	classpath = path;
}

public void setDestination(String dest) {
	destination = dest;
}
}
