package kaffe.tools.compiler;

import java.io.IOException;

/*
 * Java core library component.
 *
 * Copyright (c) 1997, 1998, 1999
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */
public class Compiler_javac
  extends Compiler
{
	final private static String javacpath = System.getProperty("kaffe.compiler.path", "/home/philippe/j2sdk1.3.0/bin/javac");

public boolean compile(String name) {
        String[] args;
        String cp = (classpath != null) ? classpath : System.getProperty("java.class.path", ".");
        if (destination != null) {
                args = new String[] {
				javacpath,
                                "-classpath", cp,
                                "-d", destination,
                                name };
        }
        else {
                args = new String[] {
				javacpath,
                                "-classpath", cp,
                                name };
        }
	Process app = null;
	int exitcode;
	try {
		app = Runtime.getRuntime().exec(args);
		app.waitFor();
	}
	catch (IOException e) {
	}
	catch (InterruptedException e) {
	}
	if (app == null) {
		exception = new Exception("Failed to start compiler");
	}
	else {
		int code = app.exitValue();
		if (code == 0) {
			return (true);
		}
		else {
			exception = new Exception("Exited with errorcode " + code);
		}
	}
	return (false);
}
}







