package kaffe.util;


public class DoubleLinkedObject
{
	public Object data;
	public DoubleLinkedObject prev;
	public DoubleLinkedObject next;
	static DoubleLinkedObject cache;

public DoubleLinkedObject ( Object data, DoubleLinkedObject prev, DoubleLinkedObject next ){
	this.data = data;
	this.prev = prev;
	this.next = next;
	
	if ( prev != null )
		prev.next = this;
		
	if ( next != null )
		next.prev = this;
}

static synchronized DoubleLinkedObject getInstance ( Object data,
                                 DoubleLinkedObject prev,
                                 DoubleLinkedObject next ) {
	DoubleLinkedObject inst;

	if ( cache == null ){
		inst = new DoubleLinkedObject( data, prev, next);
	}
	else {
		inst = cache;
		cache = inst.next;
		
		inst.data = data;
		inst.prev = prev;
		inst.next = next;
	}
	
	return inst;
}

public void recycle () {
	synchronized ( DoubleLinkedObject.class ) {
		data = null;
		prev = null;
		next = cache;
	
		cache = this;
	}
}
}
