package kaffe.util;


public class Queue
{
	DoubleLinkedObject head = DoubleLinkedObject.getInstance( null, null, null);
	DoubleLinkedObject last = head;
	int waiting;
	int size;

public synchronized boolean contains ( Object o ){
	DoubleLinkedObject dlo;

	for ( dlo = head.next; dlo != null; dlo = dlo.next ){
		if ( (dlo.data == o) || dlo.data.equals( o) ){
			return true;
		}
	}
	
	return false;
}

public synchronized Object get (){
	Object o;
	DoubleLinkedObject dlo;
	
	while ( (dlo = head.next) == null ){
		waiting++;
		try {
			wait();
		}
		catch ( InterruptedException x ) {}
		waiting--;
	}
	
	size--;
	
	o = dlo.data;
	dlo.data = null;
	dlo.prev = null;
		
	head.recycle();
	head = dlo;

	return o;	
}

public synchronized Object get ( long timeout ){
	Object o;
	DoubleLinkedObject dlo;
	
	if ( (dlo = head.next) == null ){
		waiting++;
		try {
			wait( timeout);
		}
		catch ( InterruptedException x ) {}
		waiting--;
		dlo = head.next;
	}
	
	if ( dlo != null ){
		size--;
	
		o = dlo.data;
		dlo.data = null;
		dlo.prev = null;
		
		head.recycle();
		head = dlo;

		return o;
	}
	else {
		return null;
	}
}

public boolean isEmpty (){
	return (size == 0);
}

public synchronized Object peek (){
	return (head.next != null) ? head.next.data : null;
}

public synchronized void put ( Object o ){
	DoubleLinkedObject dlo = DoubleLinkedObject.getInstance( o, last, null);
	last.next = dlo;
	last = dlo;
	
	size++;
	
	if ( waiting > 0 ){
		notify();
	}
}

public synchronized Object remove ( Object o ){
	Object rem;
	DoubleLinkedObject dlo;

	for ( dlo = head.next; dlo != null; dlo = dlo.next ){
		if ( (dlo.data == o) || dlo.data.equals( o) ){
			if ( dlo == last ){
				dlo.prev.next = null;
				last = dlo.prev;
			}
			else {
				dlo.prev.next = dlo.next;
				dlo.next.prev = dlo.prev;
			}

			size--;

			rem = dlo.data;
			dlo.recycle();
			
			return rem;
		}
	}
	
	return null;
}

public int size (){
	return size;
}

public int waiting(){
	return waiting;
}
}
