/**
 * FileWebHandler.java
 *
 *  If all else fails try to retrieve the file at the given filename.
 */

package com.transvirtual.net.www.protocol.ehttp.server;

import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import kaffe.io.StreamUtils;

public class FileWebHandler extends WebApplication {

private static String root;

public FileWebHandler() {
	root = getConfig("Root", "/tmp");
}

public void doGet(HttpServletRequest req, HttpServletResponse rep) throws ServletException {
	String filename = req.getPathInfo();
	File f = new File(root, filename);
	if (f.isDirectory()) {
		f = new File(f, "index.html");
	}
	if (f.canRead()) {
		filename = f.getName();
		rep.setContentType(WebMimeTypes.getContentTypeFor(filename));
		try {
			StreamUtils.writeTo(rep.getOutputStream(), new FileInputStream(f));
		}
		catch (IOException _) {
			throw new ServletException();
		}
	}
}

public boolean accepts(WebRequest req) {
	return (true);
}

}
