/**
 * ProcWebHandler.java
 */

package com.transvirtual.net.www.protocol.ehttp.server;

import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import kaffe.io.StreamUtils;

public class ProcWebHandler extends WebApplication {

private String base;
private Hashtable active = new Hashtable();

public ProcWebHandler() {
	base = getConfig("Root", "/proc");
}

public void doGet(HttpServletRequest req, HttpServletResponse rep) throws ServletException {
	String name = ((WebRequest)req).getFileNextElement();
	WebApplication app = (WebApplication)active.get(name);
	if (app == null) {
		try {
			app = WebApplication.getInstance(name);
			active.put(name, app);
		}
		catch (ClassNotFoundException _) {
			throw new ServletException();
		}
	}
	String op = req.getPathInfo();
	if (op != null && op.equals("icon.gif")) {
		app.doIcon(rep);
	}
	else {
		app.doGet(req, rep);
	}
}

/**
 * Check to see if this request is in the proc space.  If it
 * is indicate we can deal with it.
 */
public boolean accepts(WebRequest req) {
	String filename = req.getFileFirstElement();
	if (filename.equals(base)) {
		return (true);
	}
	else {
		return (false);
	}
}

}
