package com.transvirtual.net.www.protocol.ehttp.server;

import java.net.HttpURLConnection;
import java.net.URLConnection;
import java.net.URL;
import java.net.MalformedURLException;
import java.io.DataInputStream;
import java.io.IOException;
import javax.servlet.*;
import javax.servlet.http.*;
import kaffe.io.StreamUtils;

public class WebApplication extends HttpServlet {

private static String appbase;
private static String database;

private String basename;
private String fbasename;
private ClassLoader loader;

static {
	appbase = WebServer.getConfig(WebApplication.class.getName() + ".Root", "file:/tmp/webserver") + "/";
	database = WebServer.getConfig(WebApplication.class.getName() + ".DataRoot", "file:/tmp/webserver") + "/";
}

public WebApplication() {
	Class c = getClass();
	basename = c.getName();
	int i = basename.lastIndexOf('.');
	if (i != -1) {
		fbasename = basename.substring(0, i);
	}
	else {
		fbasename = basename;
	}
	fbasename = fbasename.replace('.', '/');
	loader = c.getClassLoader();
}

public void doGet(HttpServletRequest req, HttpServletResponse rep) throws ServletException {
	throw new ServletException("not found");
}

public void doPost(HttpServletRequest req, HttpServletResponse rep) throws ServletException {
	throw new ServletException("not found");
}

public void doIcon(HttpServletResponse rep) throws ServletException {
	URL u = getResource("icon.gif");
	try {
		StreamUtils.writeTo(rep.getOutputStream(), u.openStream());
		rep.setContentType("image/gif");
	}
	catch (IOException _) {
		throw new ServletException();
	}
}

public boolean accepts(WebRequest req) {
	return (false);
}

public static WebApplication getInstance(String appname) throws ClassNotFoundException {
	ClassLoader loader = new ClassLoader(){
		protected Class loadClass(String name, boolean resolve) throws ClassNotFoundException {
			if (name.startsWith("com.")) {
				try {
					URL u = getResource(name.replace('.', '/') + ".class");
					URLConnection conn = u.openConnection();
					byte[] data = new byte[Integer.parseInt(conn.getHeaderField("content-length"))];
					DataInputStream din = new DataInputStream(conn.getInputStream());
					din.readFully(data);
					din.close();
					Class cls = defineClass(null, data, 0, data.length);
					if (resolve) {
						resolveClass(cls);
					}
					return (cls);
				}
				catch (Exception e) {
				}
			}
			return (super.loadClass(name, resolve));
		}

		public URL getResource(String resname) {
			try {
				URL u = new URL(appbase + resname);
				u.openStream();
				return (u);
			}
			catch (Exception _) {
			}
			return (null);
		}
	};
	try {
		Class cls;
		try {
			cls = Class.forName(appname + ".Main", true, loader);
		}
		catch (ClassNotFoundException _) {
			cls = Class.forName(appname, true, loader);
		}
		WebApplication app = (WebApplication)cls.newInstance();
		return (app);

	}
	catch (Exception _) {
	}
	throw new ClassNotFoundException(appname);
}

public URL getResource(String resname) {
	return (loader.getResource(fbasename + '/' + resname));
}

public URL getDataResource(String resname) {
	try {
		URL u = new URL(database + resname);
		u.openStream();
		return (u);
	}
	catch (Exception _) {
	}
	return (null);
}

protected String getConfig(String key, String def) {
	return (WebServer.getConfig(basename + "." + key, def));
}

/**
 * All WebApplications have finalizer to give them a change to write
 * back any state they need to save.
 */
protected void finalize() throws Throwable {
}

}
