package com.transvirtual.net.www.protocol.ehttp.server;

import java.io.*;
import java.net.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;
import com.transvirtual.net.www.protocol.ehttp.EHttpURLConnection;

public class WebRequest implements HttpServletRequest {

private static WebRequest free;

private WebRequest next;
private String command;
private String file;
private String referer;
private InputStream in;
private int fpos;

private WebRequest() {
}

String getFileFirstElement() {
	fpos = 0;
	return (getFileNextElement());
}

String getFileNextElement() {
	if (fpos >= file.length()) {
		return (null);
	}
	int idx = file.indexOf('/', fpos + 1);
	if (idx == -1) {
		idx = file.length();
	}
	String str = file.substring(fpos, idx);
	fpos = idx + 1;
	return (str);
}

static WebRequest getInstance(EHttpURLConnection conn) {
	WebRequest req;
	synchronized (WebRequest.class) {
		if (free == null) {
			req = new WebRequest();
		}
		else {
			req = free;
			free = req.next;
			req.next = null;
		}
	}

	req.command = conn.getRequestMethod();
	req.file = conn.getURL().getFile();
	req.referer = conn.getRequestProperty("referer");
	req.fpos = 0;

	return (req);
}

public void recycle() {
	this.next = free;
	in = null;
	free = this;
}

// --------------------------------------------------------------------

public int getContentLength() {
	return (0);
}

public String getContentType() {
	return ("text/plain");
}

public String getProtocol() {
	return ("HTTP/1.1");
}

public String getScheme() {
	return ("ehttp");
}

public String getServerName() {
	return (null);
}

public int getServerPort() {
	return (0);
}

public String getRemoteAddr() {
	return (null);
}

public String getRemoteHost() {
	return (null);
}

public String getRealPath(String path) {
	return (file);
}

public ServletInputStream getInputStream() throws IOException {
	throw new kaffe.util.NotImplemented();
}

public String getParameter(String name) {
	throw new kaffe.util.NotImplemented();
}

public String[] getParameterValues(String name) {
	throw new kaffe.util.NotImplemented();
}

public Enumeration getParameterNames() {
	throw new kaffe.util.NotImplemented();
}

public Object getAttribute(String name) {
	throw new kaffe.util.NotImplemented();
}

public BufferedReader getReader() throws IOException {
	throw new kaffe.util.NotImplemented();
}

public String getCharacterEncoding() {
	return (null);
}

public Cookie[] getCookies() {
	throw new kaffe.util.NotImplemented();
}

public String getMethod() {
	return (command);
}

public String getRequestURI() {
	throw new kaffe.util.NotImplemented();
}

public String getServletPath() {
	return (file.substring(0, fpos));
}

public String getPathInfo() {
	if (fpos >= file.length()) {
		return (null);
	}
	return (file.substring(fpos));
}

public String getPathTranslated() {
	throw new kaffe.util.NotImplemented();
}

public String getQueryString() {
	throw new kaffe.util.NotImplemented();
}

public String getRemoteUser() {
	throw new kaffe.util.NotImplemented();
}

public String getAuthType() {
	throw new kaffe.util.NotImplemented();
}

public String getHeader(String key) {
	if (key.equalsIgnoreCase("referer")) {
		return (referer);
	}
	throw new kaffe.util.NotImplemented();
}

public int getIntHeader(String name) {
	String val = getHeader(name);
	try {
		return (Integer.parseInt(val));
	}
	catch (NumberFormatException _) {
		return (-1);
	}
}

public long getDateHeader(String name) {
	throw new kaffe.util.NotImplemented();
}

public Enumeration getHeaderNames() {
	throw new kaffe.util.NotImplemented();
}

public HttpSession getSession(boolean create) {
	throw new kaffe.util.NotImplemented();
}

public String getRequestedSessionId() {
	throw new kaffe.util.NotImplemented();
}

public boolean isRequestedSessionIdValid() {
	throw new kaffe.util.NotImplemented();
}

public boolean isRequestedSessionIdFromCookie() {
	throw new kaffe.util.NotImplemented();
}

public boolean isRequestedSessionIdFromUrl() {
	throw new kaffe.util.NotImplemented();
}

}
