/*
 * Java core library component.
 *
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */

package com.transvirtual.net.www.protocol.webslinger;

import java.net.URLStreamHandler;
import java.net.URLConnection;
import java.net.URL;

public class Handler extends URLStreamHandler {

protected URLConnection openConnection(URL u)
{
	return (new WebSlingerURLConnection(u));
}

/**
 * For webslingers's we don't need a hostname so it may be null - we therefore
 * replace it with "" and call the super.
 */
protected void setURL(URL u, String protocol, String host, int port, String file, String ref) {
        super.setURL(u, protocol, "", port, file, ref);
}

}
