import java.lang.ref.*;

public class Weak {
  public Weak () {
  }
  
  protected void finalize () {
        System.out.println( "Got finalized");
  }

  static void foo ( Reference wr) {
	System.gc();
	System.runFinalization();
        System.out.println( "weak ref: " + (wr.get() != null));
  }

  public static void main ( String[] args ){
        Weak  o = new Weak();
        Reference wr = new WeakReference( o);

        System.gc();
        System.out.println( "weak ref: " + (wr.get() != null));
        
	/* We put this is a loop otherwise the JIT removed the 'o = null'
	 * instruction since it knows it doesn't do anything real.  But
	 * that means we don't GC the Weak object.
	 */
	for (int i = 0; i < 1; i++) {
		o = null;
	}

        foo( wr);
  }
}

/* Expected Output:
weak ref: true
Got finalized
weak ref: false
*/
