#include <fgl.h>
#include <ft2build.h>
#include FT_FREETYPE_H

main ( int argc, char *argv[] )
{
  int error;
  int x,y,delta_y;
  int i,j,index;
  int size = 11;
  int count[256];
  FT_Library library;
  FT_Face    face;
  fgl_a8Bitmap_t a8bitmap;
  fgl_monoBitmap_t monobitmap;
  fgl_context_t *gc;

  size = atoi(argv[1]);

  
  error = FT_Init_FreeType ( &library );

  if ( error ) {
      fprintf ( stderr, "error: init error %x.\n", error );
      exit ( 0 );
  }

  error = FT_New_Face ( library, "arial.ttf", 0, &face );

  if ( error ) {
      fprintf ( stderr, "error: face error %x.\n", error );
      exit ( 0 );
  }

  error = FT_Set_Char_Size ( face, 0, size * 64, 96, 96 );
  
  if ( error ) {
      fprintf ( stderr, "error: size error %x.\n", error );
      exit ( 0 );
  }

  fgl_init( 0,0,0 );
  gc = fgl_getContext( fgl_screenBmp);
  fgl_setColor (gc, fgl_clrWhite );
  fgl_clear( gc);

  x = 10 ; y = 50 ;
  delta_y = 0;
  
  for ( i = 0 ; i < 256 ; i ++ ) count[i] = 0;
  
  for ( i = 0; i < 30000 ; i++ )
    { 
      index = FT_Get_Char_Index ( face , i);
      if ( index < 0 ) index = 0;
      error = FT_Load_Glyph ( face, index, FT_LOAD_NO_BITMAP); 

      if ( error ) {
          fprintf ( stderr, "error: glyph error %x.\n", error );
          exit ( 0 );
      }

      error = FT_Render_Glyph ( face->glyph, ft_render_mode_normal );

      if ( error ) {
          fprintf ( stderr, "error: render error %x.\n", error );
          exit ( 0 );
      }


      a8bitmap.surface = face->glyph->bitmap.buffer;
      a8bitmap.width = face->glyph->bitmap.width;
      a8bitmap.height = face->glyph->bitmap.rows;
      a8bitmap.sLength = face->glyph->bitmap.pitch;
      a8bitmap.state = 0;

      if ( index != 0 && a8bitmap.width != 0 && a8bitmap.height != 0 ) { 
    //  printf ( "i = %i, index = %i ( %i, %i )\n", i, index, a8bitmap.width, a8bitmap.height );
      for ( j = 0; j < a8bitmap.width * a8bitmap.height ; j++ ) 
        {
          count[a8bitmap.surface[j]]++;
        }
      fgl_a8BltBmp( gc, x + face->glyph->bitmap_left, y - face->glyph->bitmap_top, &a8bitmap, fgl_clrBlack );
      if ( a8bitmap.height > delta_y ) delta_y = a8bitmap.height;

      if ( x + a8bitmap.width > 1000 ) {
          y += delta_y ;
          x = 10;
      } else {
          x += a8bitmap.width + 2;
      }
      }

    }

    
  for ( i = 0 ; i < 256 ; i ++ )
    {
      printf("%i %i\n", i , count[i]);
    }

}
