#include "fgl.h"

void storeFont ( fgl_font_t* fnt, char* fname )
{
	int  i, m, so;
	int  fh;
	u8   isMsb = (__BYTE_ORDER == __BIG_ENDIAN);

	for ( i=0, m=0, so=-1; i<fnt->nGlyphs; i++ ){
		if ( (fnt->width[i]) && ((int)fnt->surfOff[i] > so) ){
			m += fnt->height[i] * MONO_SLENGTH(fnt->width[i]);
			so = fnt->surfOff[i];
		}
	}

	fh = open( fname,  O_CREAT|O_TRUNC|O_WRONLY,
			   S_IROTH | S_IRGRP | S_IRUSR | S_IWUSR);

	write( fh, &isMsb, 1);
	write( fh, &fnt->nGlyphs, sizeof(fnt->nGlyphs));
	write( fh, &fnt->uniOffset, sizeof(fnt->uniOffset));
	
	write( fh, &fnt->fontHeight, sizeof(fnt->fontHeight));
	write( fh, &fnt->ascend, sizeof(fnt->ascend));
	write( fh, &fnt->descend, sizeof(fnt->descend));	

	write( fh, (void*) fnt->surfOff, fnt->nGlyphs * sizeof(fnt->surfOff[0]));	
	write( fh, (void*) fnt->width, fnt->nGlyphs * sizeof(fnt->width[0]));
	write( fh, (void*) fnt->height, fnt->nGlyphs * sizeof(fnt->height[0]));
	write( fh, (void*) fnt->xBearing, fnt->nGlyphs * sizeof(fnt->xBearing[0]));
	write( fh, (void*) fnt->yBearing, fnt->nGlyphs * sizeof(fnt->yBearing[0]));
	write( fh, (void*) fnt->advance, fnt->nGlyphs * sizeof(fnt->advance[0]));

	write( fh, (void*) fnt->surface, m);
	close( fh);
}

int main ( int argc, char* argv[] )
{
	fgl_font_t* fnt;
	char* stem;
	int ptSize;
	char buf[128];

	if ( argc < 3 ){
		puts( "usage savefont <ttf-file stem> <ptSize>");
		return 0;
	}

	stem = argv[1];
	ptSize = atoi( argv[2]);

	sprintf( buf, "%s_%d.fnt", stem, ptSize);

	fnt = fgl_getFont( stem, ptSize);
	if ( fnt ){
		storeFont( fnt, buf);
	}
	fgl_disposeFont( fnt);

	return 1;
}
