/* -*- mode: C; mode: fold -*- */ 

#include "fgl.h"

#include <sys/timeb.h>
#include <unistd.h>
#include <stdio.h>
#include <math.h>
#include <string.h>

float test1 ( fgl_context_t *gc ) /*{{{*/
{

  /* tests speed of overflowing the piple with
     draw line requests. */

  int x, y, i;
  struct timeb start,end;
  

  ftime(&start);
  for ( i = 0 ; i < 1000 ; i ++ ) {
    x = i % 100;
    y = (i + 50) % 100;
    
	fgl_setColor( gc, fgl_clrRed);
	fgl_drawLine( gc, x, y+0, x+100, y+200);

	fgl_setColor( gc, fgl_clrGreen);
	fgl_drawLine( gc, x, y, x+200, y+100);

	fgl_setColor( gc, fgl_clrBlue);
	fgl_drawLine( gc, x, y+200, x+200, y+100);

	fgl_setColor( gc, fgl_clrYellow);
	fgl_drawLine( gc, x, y+200, x+100, y);

  }

  ftime(&end);
  return end.time - start.time + (end.millitm - start.millitm)/1000.0;

}
/*}}}*/

float test2 ( fgl_context_t *gc ) /*{{{*/
{

  /* tests speed of overflowing the piple with
     fill rectangle requests. */


  int x, y, i;
  struct timeb start,end;
  

  ftime(&start);
  for ( i = 0 ; i < 1000 ; i ++ ) {
    x = 100 + i % 100;
    y = 100 + (i + 50) % 100;
    
	fgl_setColor( gc, fgl_clrRed);
	fgl_fillRect( gc, x, y, x+250, y+250);

	fgl_setColor( gc, fgl_clrGreen);
	fgl_fillRect( gc, x, y, x+200, y+200);

	fgl_setColor( gc, fgl_clrBlue);
	fgl_fillRect( gc, x, y, x+150, y+150);

	fgl_setColor( gc, fgl_clrYellow);
	fgl_fillRect( gc, x, y, x+100, y+100);
  }

  ftime(&end);
  return end.time - start.time + (end.millitm - start.millitm)/1000.0;

}
/*}}}*/

u32 spd_cmap[] = { /*{{{*/
	0x000000,
	0xffff00,
	0xff0000
};

fgl_color_t spd_data[] = {
	1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
	1,2,1,1,0,0,0,0,0,0,0,0,0,0,0,0,0,
	0,1,2,2,1,1,0,0,0,0,0,0,0,0,0,0,0,
	0,1,2,2,2,2,1,1,0,0,0,0,0,0,0,0,0,
	0,0,1,2,2,2,2,2,1,1,0,0,0,0,0,0,0,
	0,0,1,2,2,2,2,2,2,2,1,1,0,0,0,0,0,
	0,0,0,1,2,2,2,2,2,2,2,2,1,1,0,0,0,
	0,0,0,1,2,2,2,2,2,2,2,2,2,2,1,0,0,
	0,0,0,0,1,2,2,2,2,2,2,2,1,1,0,0,0,
	0,0,0,0,1,2,2,2,2,2,1,1,0,0,0,0,0,
	0,0,0,0,0,1,2,2,2,1,2,1,0,0,0,0,0,
	0,0,0,0,0,1,2,2,2,1,1,2,1,0,0,0,0,
	0,0,0,0,0,0,1,2,1,0,0,1,2,1,0,0,0,
	0,0,0,0,0,0,1,2,1,0,0,0,1,2,1,0,0,
	0,0,0,0,0,0,0,1,0,0,0,0,0,1,2,1,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0,
	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0
};

fgl_spriteData_t spd = {
	17, 17,                                   /* width, height */
	0, 0,                                     /* xhot, yhot */
	3, 0,                                     /* nColors, transp */
	spd_cmap,
	spd_data
};
/*}}}*/

float test3 ( fgl_context_t *gc ) /*{{{*/
{

  /* tests speed of overflowing the piple with
     transparent blt requests. */

	fgl_sprite_t *sp = fgl_createSprite( &spd );
	int ox, oy, i;
	struct timeb start,end;

	fgl_setColor( gc, fgl_clrBlue);
	fgl_fillRect( gc, 100+20, 100+80, 100+280, 100+120);

	ftime(&start);
	for ( i = 0 ; i < 1000 ; i ++ ) {
	  ox = 100 + i % 100;
	  oy = 100 + (i + 50) % 100;

	  fgl_moveSprite( gc, sp, ox+30, oy+100);
	  fgl_showSprite( gc, sp);
	  
	  
	  fgl_hideSprite(gc, sp);
	  fgl_setColor( gc, fgl_clrGreen);
	  fgl_fillRect( gc, ox+20, oy+80, ox+280, oy+120);
	  fgl_showSprite(gc, sp);
	
  }

  ftime(&end);
  return end.time - start.time + (end.millitm - start.millitm)/1000.0;

       
}
/*}}}*/

float test4 ( fgl_context_t *gc ) /*{{{*/
{

  /* tests speed of overflowing the piple with
     mono blt requests (font blt). */

  fgl_font_t *fnt = fgl_getFont( "arial", 11);
  char       *text1, *text2;
  int        x, y, i;
  struct timeb start,end;
  

  fgl_setFont( gc, fnt);
  fgl_setColor( gc, fgl_clrYellow);
  
  text1 = "Don't stare at me, gonzo (iii)";
  text2 = "Gotcha!";
  
  ftime(&start);
  for ( i = 0 ; i < 1000 ; i ++ ) {
    x = 100 + i % 100;
    y = 100 + (i + 50) % 100;


    fgl_drawText( gc, x, y, text1, -1);
    y += fnt->fontHeight;
    fgl_drawText( gc, x, y, text2, -1);
    
  }

  ftime(&end);
  fgl_disposeFont( fnt);

  return end.time - start.time + (end.millitm - start.millitm)/1000.0;

}
/*}}}*/

int main ( int argc, char* argv[] ) /*{{{*/
{   
	int i=1, stop=0;
	int busy = 0;
	fgl_context_t *gc;
	int ox,oy,c;
	int os = 1;
	float time;
	ox = 0;
	oy = 0;

	if ( argc >= 1 ){
	  /* chech all the arguments */
	  /* -t test number          */
	  /* -x x offset             */
	  /* -y y offset             */
	  for(c = 1;c<argc;c++) {
	 
	    if(strcmp(argv[c],"-h")==0) {
	      fprintf(stderr,"usage: tfgl001 <-x x_offset> <-y y_offset> <-t test>\n");
	      fprintf(stderr,"               <-s speed> <-h>\n");
	      exit(0);
	    }
	    if(strcmp(argv[c],"-t")==0) {i = atoi( argv[c+1]); stop = 1;}
	    if(strcmp(argv[c],"-x")==0) ox = atoi( argv[c+1]);
	    if(strcmp(argv[c],"-y")==0) oy = atoi( argv[c+1]);
	    if(strcmp(argv[c],"-s")==0) os = atoi( argv[c+1]);
	    if(strcmp(argv[c],"-b")==0) busy = 1;
	  }
		
	}

	if ( !fgl_init( 0, 0, 0) ){
		puts( "aborting..");
		return 1;
	}

	gc = fgl_getContext( fgl_screenBmp);

	time = 0;

	do {
		fgl_setColor( gc, fgl_clrBlack);
		fgl_clear( gc);

		switch ( i ) {
		case 1:  time += test1( gc ); break;
		case 2:  time += test2( gc ); break;
		case 3:  time += test3( gc ); break;
		case 4:  time += test4( gc ); break;
		default: stop = 1;
		}
		i++;
	} while ( !stop );

	fgl_terminate();

	fprintf(stderr,"total time %f\n", time);

	return 1;
}
/*}}}*/
