/*
 * a4bmp.h - fgl module to handle monochrome bitmaps (depth 1)
 * 
 * Copyright (c) 2000, 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "COPYING" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 */

#ifndef FGL_A4BMP_H_INCLUDED
#define FGL_A4BMP_H_INCLUDED

/* general includes */
#include "libfgl.h"
#include <fgl.h>

/* module specific includes */
#include "rot.h"
#include "draw.h"

extern u8 _a4Bits[2];

static inline
void _fgl_setPixelA4 ( fgl_a4Bitmap_t* bmp, u32 x, u32 y, u8 pixel )
{
	u8 *p;
          {
            SET_ROTATION( bmp );
            POINT_ROTATE( rot, (fgl_bitmap_t *)bmp, x, y );
          }
        p = bmp->surface + (y * bmp->sLength) + (x / 2);
        *p |= _a4Bits[x % 2];
}

static inline
u8 _fgl_getPixelA4 ( fgl_a4Bitmap_t* bmp, u32 x, u32 y ) 
{
	u8 *p;
        {
          SET_ROTATION( bmp );
          POINT_ROTATE( rot, (fgl_bitmap_t *)bmp, x, y );
        }
	p = bmp->surface + (y * bmp->sLength) + (x / 2);
	return (*p & _a4Bits[x % 2]) ;
}

static inline
void _fgl_disposeA4Bitmap ( fgl_a4Bitmap_t* bmp ) 
{       
        FGL_FREE( bmp->surface);
	FGL_FREE( bmp);
}

#endif /* FGL_A4BMP_H_INCLUDED */
