/*
 * cmap_p8_256.c - fgl module for pixelvalue/RGB mapping
 *                 (8bpp PseudoColors with equal distributed 
 *                  6x6x6 "web safe" color cube)
 * 
 * Copyright (c) 2000
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 * 
 * 09/01/00  Peter Mehlitz
 *
 * $tvt: cmap_p8.c,v 1.2 2001/11/20 00:33:51 damian Exp $
 */

#include "cmap_p8.h"

fgl_color_t fgl_clrBlack;
fgl_color_t fgl_clrWhite;
fgl_color_t fgl_clrRed;
fgl_color_t fgl_clrGreen;
fgl_color_t fgl_clrBlue;
fgl_color_t fgl_clrYellow;
fgl_color_t fgl_clrCyan;
fgl_color_t fgl_clrGray;
fgl_color_t fgl_clrLightGray;
fgl_color_t fgl_clrOrange;

u8 rgbCube[12][12][12];

fgl_cmap_t* fglCmap;
fgl_cmap_t* oldCmap;

u8 a6[] = { 0, 51, 102, 153, 204, 255 };

fgl_color_t fgl_getPixelValue ( u32 argb )
{
  return _fgl_getPixelValue (argb);
}

void fgl_getRgbValues ( fgl_color_t pix, u32* r, u32* g, u32* b ) 
{
  _fgl_getRgbValues ( pix, r, g, b );
}

fgl_color_t fgl_modPixelValue ( fgl_color_t pix, int mod )
{
	return _fgl_modPixelValue ( pix, mod );
}

fgl_color_t fgl_blendPixelValues ( u32 alphar, u32 alphag, u32 alphab, fgl_color_t d, fgl_color_t s )
{
        return _fgl_blendPixelValues ( alphar, d, s );
}


/***************************************************************************
 * external colormap setup, called from init_XX module
 */

static int addPaletteEntry ( fgl_cmap_t* map, u8 r, u8 g, u8 b )
{
  return _addPaletteEntry ( map, r, g, b );
}

static void restoreOldCmap ()
{
	if ( oldCmap ){
		fgl_setHWCmap( oldCmap);
	}
}

int fgl_initRgbCmap ( int nReq, u32* rgbReq, int saveOld )
{
  return _fgl_initRgbCmap ( nReq, rgbReq, saveOld);
}

fgl_cmap_t* fgl_getCmap ()
{
	return fglCmap;
}

