/*
 * cmap_t565.c - fgl module for pixelvalue/RGB mapping (16 bpp 565 TrueColor)
 * 
 * Copyright (c) 2000, 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "COPYING" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 */

#include "cmap_t565.h"

fgl_color_t fgl_clrBlack;
fgl_color_t fgl_clrWhite;
fgl_color_t fgl_clrRed;
fgl_color_t fgl_clrGreen;
fgl_color_t fgl_clrBlue;
fgl_color_t fgl_clrYellow;
fgl_color_t fgl_clrCyan;
fgl_color_t fgl_clrGray;
fgl_color_t fgl_clrLightGray;
fgl_color_t fgl_clrOrange;

/*
 * these are our public APIs for RGB<->pixVal conversion
 */

fgl_color_t fgl_getPixelValue ( u32 argb ) /*{{{*/
{
  return _fgl_getPixelValue ( argb );
}
/*}}}*/

void fgl_getRgbValues ( fgl_color_t pix, u32* r, u32* g, u32* b ) 
{
  _fgl_getRgbValues ( pix, r, g, b );
}

/*
 * This is here because we can't simply increase/dicrease channel values
 * in a seriously restricted colorspace (VGA, 4-bit grayscale etc.)
 */

fgl_color_t fgl_modPixelValue( fgl_color_t pix, int mod ) 
{
  return _fgl_modPixelValue( pix, mod );
} 

fgl_color_t fgl_blendPixelValues ( u32 alphar, u32 alphag, u32 alphab, fgl_color_t d, fgl_color_t s ) 
{
  return _fgl_blendPixelValues ( alphar, alphag, alphab, d, s );
}

int fgl_initRgbCmap ( int nReq, u32* rgbReq, int saveOld )
{
  return _fgl_initRgbCmap ( nReq, rgbReq, saveOld );
}

fgl_cmap_t* fgl_getCmap () 
{
  return 0;
}

