/* -*- mode: C; mode: fold -*- */
/*
 * cntx.c - fgl module to handle graphics context objects
 *          (attribute containers for color, fonts, clipping)
 * 
 * Copyright (c) 2000, 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "COPYING" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 */

#ifndef FGL_CNTX_C_INCLUDED
#define FGL_CNTX_C_INCLUDED

#include "cntx.h"

u8 fgl_getClipCode ( fgl_context_t *ctx, i32 x, i32 y ) 
{
	return _fgl_getClipCode ( ctx, x, y );
}

void fgl_setClip ( fgl_context_t *ctx, i32 x0, i32 y0, i32 x1, i32 y1 ) 
{
        _fgl_setClip ( ctx, x0, y0, x1, y1 );
}

void fgl_setBmp ( fgl_context_t *ctx, fgl_bitmap_t *bmp ) 
{
        _fgl_setBmp ( ctx, bmp );
}

fgl_context_t* fgl_getContext( fgl_bitmap_t *bmp ) 
{
        return _fgl_getContext( bmp );
}

void fgl_setFont ( fgl_context_t* ctx, fgl_font_t* fnt ) 
{
        _fgl_setFont ( ctx, fnt );
}

void fgl_setColor ( fgl_context_t* ctx, fgl_color_t clr ) 
{
        _fgl_setColor ( ctx, clr );
}

void fgl_setAlpha ( fgl_context_t* ctx, u8 alpha ) 
{
	_fgl_setAlphas ( ctx, alpha, alpha, alpha );
}
	
void fgl_setAlphas ( fgl_context_t* ctx, u8 alphar, u8 alphag, u8 alphab ) 
{
	_fgl_setAlphas ( ctx, alphar, alphag, alphab );
}
	
void fgl_setXorMode ( fgl_context_t* ctx, fgl_color_t xclr ) 
{
        _fgl_setXorMode ( ctx, xclr );
}

void fgl_setPaintMode ( fgl_context_t* ctx ) 
{
        _fgl_setPaintMode ( ctx );
}

#endif /* FGL_CNTX_C_INCLUDED */
