/*
 *  * feng.h - fgl header file for support of an arbitrary
 *             font engine
 * 
 * Copyright (c) 2000, 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "COPYING" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 */

#include "libfgl.h"
#include <fgl.h>

#include "rot.h"

/*
 * binary font file state flags ( included for bacward compability )
 */
#define IS_FILEMSB   0x001
#define IS_ANTIALIAS 0x002
#define IS_ROTATED   0x004


inline
fgl_font_t* allocFont ( u16 nGlyphs ) 
{
  fgl_font_t *fnt = 0;
  u32        arr32Size = sizeof(u32) * nGlyphs;
  u32        arr8Size = sizeof(u8) * nGlyphs;

  fnt = FGL_CALLOC( 1, sizeof(fgl_font_t) + 5*arr8Size + arr32Size);

  fnt->surfOff  = (u32*)((u8*)fnt + sizeof(fgl_font_t));
  fnt->width    = (i8*) ((u8*)(fnt->surfOff)  + arr32Size);
  fnt->height   = (i8*) ((u8*)(fnt->width)    + arr8Size);
  fnt->xBearing = (i8*) ((u8*)(fnt->height)   + arr8Size);
  fnt->yBearing = (i8*) ((u8*)(fnt->xBearing) + arr8Size);
  fnt->advance  = (i8*) ((u8*)(fnt->yBearing) + arr8Size);

  fnt->nGlyphs = nGlyphs;

  return fnt;
}
