/*
 * font. - fgl module for generic font handling (load/unload
 *          display, metrics)
 * 
 * Copyright (c) 2000, 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "COPYING" for information on usage and redistribution 
 * of this file. 
 * 
 * 01/01/00  Peter Mehlitz
 */

#ifndef FGL_FONT_H_INCLUDED
#define FGL_FONT_H_INCLUDED

/* general includes */
#include "libfgl.h"
#include <fgl.h>

/* module specific includes */
#include "draw.h"
#include "rot.h"

inline
static
char*
font_strdup(const char* str)
{
	char* s;
        if (str == NULL) {
                return (NULL);
        }
        s = (char *)FGL_MALLOC(strlen(str) + 1);
        if (s != 0) {
                strcpy(s, str);
        }
        return (s);
}

#endif /* FGL_FONT_H_INCLUDED */
