/*
 * libfgl.h - define library compile environment.
 * 
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "COPYING" for information on usage and redistribution 
 * of this file. 
 *
 * 07/18/01 Damian Kowalewski
 */

#ifndef LIBFGL
#define LIBFGL

/* all the config stuff should go into here */
#include <fgl.h>
#include "config.h"
#include FGLD_MODULE
#include "heap_posix.h"

/* internal definitions that should not be accesible outside
 * the library
 */
#define MAX_PATH 256
#define MAX_NAME 64
#define AAF_8 0x20


extern fgl_sprite_t               *fgl_cursor;
extern u8                         _fgl_redrawCursor;
extern u8                         _fgl_inCursorOp;

extern fgl_fontEntry_t            *_fgl_fontCache;
extern int                        _fgl_fontInitialized;
extern fgl_fontEntry_t            *_fgl_setCache;
extern int                        _fgl_setInitialized;
extern fgl_font_t                 *fgl_defaultFont;

extern int                        _fgl_setCount;
extern char                       **_fgl_setName;

extern char *fntDir;

extern fgl_bitmap_t               _fgl_screenBmpObject;
extern fgl_bitmap_t               *fgl_screenBmp;
extern fgl_context_t              _fgl_screenCtxObject;
extern fgl_context_t              *fgl_screenCtx;

/* functions from module feng */
fgl_font_t* fgl_loadFont ( char* fname, u8 ptSize );

extern u8 _monoBits[8];

#endif
