/*
 * locale.c - fgl module to handle locale specific information 
 * 
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "COPYING" for information on usage and redistribution 
 * of this file. 
 * 
 * 08/31/01 Damian Kowalewski
 */

#include "locale.h"

int fgl_setLocale (char *locale)
{
  FILE *fp;
  char path[MAX_PATH];
  char setname[10][64];
  int count = 0, i;
 
  if ( !_fgl_fontInitialized && !(_fgl_fontInitialized = fgl_initFontEngine()) )
    {
      warnx("font initialization failed\n");
      return 0;
    }

  sprintf (path, "%s/%s.loc",fntDir,locale);
  fp = fopen ( path, "r");

  if ( fp == NULL )
    {
      return 0;
    }

  count = fscanf (fp,"%s %s %s %s %s %s %s %s %s %s", setname[0], setname[1], setname[2],
      setname[3], setname[4], setname[5], setname[6], setname[7], setname[8],
      setname[9]);

  if ( count <= 0 )
    {
      return 0;
    }
 
  _fgl_setCount = count;
  _fgl_setName = (char **) FGL_MALLOC ( count * sizeof(char *)); 
  for (i = 0; i < count ; i++ ) 
    {
      _fgl_setName[i] = strdup(setname[i]);
      fprintf(stderr,"extension (%i) read: %s\n",i,setname[i]);
    }
  _fgl_setInitialized = 1;
  
  return (count);
}

