#!/bin/sh

echo
echo ">>> making pocketlinux "

. .pocketlinuxrc

echo
echo PATH=$PATH

unset CLASSPATH

# add lib directory 
CLASSPATH=$CLASSPATH:$POCKETLINUX_LIB

# add the source directory
CLASSPATH=$CLASSPATH:$POCKETLINUX_SRC

# add the kaffe classes 
CLASSPATH=$CLASSPATH:$KAFFE_CLASSES

export CLASSPATH
echo
echo CLASSPATH=$CLASSPATH

echo
echo ">>> removing existing class files in $POCKETLINUX_LIB"
rm -rf $POCKETLINUX_LIB/*

if [ ! -d $POCKETLINUX_LIB ] ; then
   mkdir $POCKETLINUX_LIB
fi

cd $POCKETLINUX_SRC

echo
echo ">>> compiling all classes in $POCKETLINUX_PACKAGE"
echo

echo
# compile the Default awt settings
echo compiling Defaults.java
$JAVA_COMPILER -d $POCKETLINUX_LIB Defaults.java

# compile all the java classes in the pocketlinux package
#find $POCKETLINUX_PACKAGE -name '*.java' -exec echo "compiling " {} \; -exec $JAVA_COMPILER -d $POCKETLINUX_LIB {} \;
find $POCKETLINUX_PACKAGE -name '*.java' | xargs $JAVA_COMPILER -d $POCKETLINUX_LIB 

echo 
echo ">>> copying gifs to classpath "

if [ ! -d $POCKETLINUX_LIB/$POCKETLINUX_PACKAGE/thirdparty/missile/images ] ; then
   mkdir $POCKETLINUX_LIB/$POCKETLINUX_PACKAGE/thirdparty/missile/images
fi
cp $POCKETLINUX_PACKAGE/thirdparty/missile/images/*.gif $POCKETLINUX_LIB/$POCKETLINUX_PACKAGE/thirdparty/missile/images

if [ ! -d $POCKETLINUX_LIB/$POCKETLINUX_PACKAGE/device/helioemu ] ; then
   mkdir $POCKETLINUX_LIB/$POCKETLINUX_PACKAGE/device/helioemu
fi
cp $POCKETLINUX_PACKAGE/device/helioemu/*.gif $POCKETLINUX_LIB/$POCKETLINUX_PACKAGE/device/helioemu/

if [ ! -d $POCKETLINUX_LIB/$POCKETLINUX_PACKAGE/device/ipaqemu ] ; then
   mkdir $POCKETLINUX_LIB/$POCKETLINUX_PACKAGE/device/ipaqemu
fi
cp $POCKETLINUX_PACKAGE/device/ipaqemu/*.gif $POCKETLINUX_LIB/$POCKETLINUX_PACKAGE/device/ipaqemu/

echo
echo ">>> done!! "
echo
