package com.pocketlinux.awt.theme;

import java.awt.*;
import java.awt.event.*;
import kaffe.awt.AWT;
import kaffe.awt.theme.ScrollbarDeco;

public class Deco4I
  extends StyleComponentDeco
  implements ScrollbarDeco
{
	final private static String[] filenamesH = new String[]{
	"horzarrowleft.gif",
	"horzjewel.gif",
	"horzrail.gif",
	"horzarrowright.gif",
};
	final private static String[] filenamesV = new String[]{
	"vertarrowup.gif",
	"vertjewel.gif",
	"vertrail.gif",
	"vertarrowdown.gif",
};
	private int[] imgExts;
	private int cmnWidth;
	private int ori;

public Deco4I(Style style, String widgetname, int ori) {
	super(style, widgetname, (ori == Scrollbar.HORIZONTAL ? filenamesH : filenamesV));
	this.ori = ori;
}

public int getAdjustmentCode( Scrollbar s, int offs, int len, int jOffs, int jLen) {
	if ( offs < imgExts[0] )
		return AdjustmentEvent.UNIT_DECREMENT;
	else if ( offs > len - imgExts[3] )
		return AdjustmentEvent.UNIT_INCREMENT;
	else if ( offs < jOffs )
		return AdjustmentEvent.BLOCK_DECREMENT;
	else if ( offs > jOffs + jLen )
		return AdjustmentEvent.BLOCK_INCREMENT;

	return AdjustmentEvent.TRACK;
}

public int getJewelExtent( Scrollbar s, int w, int pgInc, int range) {
	return imgExts[1];
}

public Dimension getPreferredSize( Scrollbar s) {
	if ( s.getOrientation() == Scrollbar.VERTICAL )
		return new Dimension( cmnWidth, 1);
	return new Dimension( 1, cmnWidth);
}

public Rectangle getRailArea( Scrollbar s, Rectangle r) {
	if ( s.getOrientation() == s.HORIZONTAL ) {
		r.x += imgExts[0];
		r.width -= imgExts[0] + imgExts[3];
	}
	else {
		r.y += imgExts[0];
		r.height -= imgExts[0] + imgExts[3];
	}
	return r;
}

public void paintArrows( Scrollbar s, Graphics g, int w, int h, int state) {
	if ( s.getOrientation() == s.HORIZONTAL ) {
		g.drawImage( images[0], 0, 0, null);
		g.drawImage( images[3], w-imgExts[3], 0, null);
	}
	else {
		g.drawImage( images[0], 0, 0, null);
		g.drawImage( images[3], 0, h-imgExts[3],  null);
	}
}

public boolean paintBackground( Component c, Component p, Graphics g, int cx, int cy, int cw, int ch, int x, int y, int w, int h, int xOff, int yOff, int state) {
	return (true);
}

public void paintJewel( Scrollbar s, Graphics g, int x, int y, int w, int h, boolean tracking) {
	g.drawImage( images[1], x, y, null);
}

public void paintRail( Scrollbar s, Graphics g, int x, int y, int w, int h) {
	if ( s.getOrientation() == s.VERTICAL ) {
		AWT.extension.drawBackground( g, 0, 0, AWT.extension.getWidth(s), 
								AWT.extension.getHeight(s),
								x, y, w, h, 0, imgExts[0], 
								images[2], null, Theme.FILL_TILE);
	}
	else {
		AWT.extension.drawBackground( g, 0, 0, AWT.extension.getWidth(s), 
								AWT.extension.getHeight(s), x, y, w, h, imgExts[0], 0, 
								images[2], null, Theme.FILL_TILE);
	}
}

public void reload() {
	super.reload();
	setImages(ori);
}

private void setImages(int orientation) {
	imgExts = new int[images.length];

	for ( int i=0; i<images.length; i++ ) {
		if ( orientation == Scrollbar.VERTICAL ) {
			imgExts[i] = images[i].getHeight( null);
			cmnWidth = Math.max( cmnWidth, images[i].getWidth( null));
		}
		else {
			imgExts[i] = images[i].getWidth( null);
			cmnWidth = Math.max( cmnWidth, images[i].getHeight( null));
		}
	} 
}
}
