package com.pocketlinux.awt.theme;

import java.awt.Component;
import java.awt.Graphics;
import java.awt.Image;
import java.awt.Insets;
import kaffe.awt.*;

public class Deco9I
  extends StyleComponentDeco
{
	final private static String[] filenames = new String[]{
	"topleft.gif",
	"topmiddle.gif",
	"topright.gif",
	"middleleft.gif",
	"middlemiddle.gif",
	"middleright.gif",
	"bottomleft.gif",
	"bottommiddle.gif",
	"bottomright.gif",
};

public Deco9I(Style style, String widgetname) {
	super(style, widgetname, filenames);
}

public boolean hasBackgroundImage() {
	return (true);
}

public boolean paintBackground( Component c, Component p, Graphics g, int cx, int cy, int cw, int ch, int x, int y, int w, int h, int xOff, int yOff, int state) {
	if (doBorder(c, p, x, y, w, h)) {
		AWT.extension.drawBorder( g, x, y, w, h, Theme.ALIGN_OUTER, images[0], images[1], images[2], images[3], images[5], images[6], images[7], images[8] );
	}
	Image img = null;
	if (p instanceof BackgroundImage) {
		img = ((BackgroundImage)p).getBackgroundImage();
                if (img != null && !Theme.toolkit.prepareImage(img, -1, -1, null)) {
			img = null;
		}
	}
	if (img == null) {
		img = images[4];
	}
	AWT.extension.drawBackground( g, cx, cy, cw, ch, x, y, w, h, xOff, yOff, img, null, Theme.FILL_TILE);
	return true;
}

public void reload() {
	super.reload();
	insets.top = images[1].getHeight(null);
	insets.left = images[3].getWidth(null);
	insets.bottom = images[7].getHeight(null);
	insets.right = images[5].getWidth(null);
}
}
