package com.pocketlinux.awt.theme;

import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Graphics;
import java.awt.Point;
import java.awt.Window;
import kaffe.awt.AWT;
import kaffe.awt.theme.ComponentDeco;
import kaffe.media.TVCtrl;

public class SpecialDecoFactory
{
	static Object[] decos = new Object[] {
	"background:url(tv:)", com.pocketlinux.awt.theme.TVDeco.class,
};

public static ComponentDeco getDeco( String style) {
	for (int i = 0; i < decos.length; i += 2) {
		if (style.equals(decos[i])) {
			try {
				return ((ComponentDeco)((Class)decos[i+1]).newInstance());
			}
			catch (Exception _) {
			}
		}
	}
	return (null);
}
}

class TVDeco
  extends ComponentDeco
{
	final static int RUNNING = 0x01;
	int flags;

TVDeco() {
	bgClr = Color.blue;

	//int chroma = 0xfff8;
      	int chroma = ( (((bgClr.getRed() << 3) & 0xff) << 11) |
				(((bgClr.getGreen() << 2) & 0xff) << 5) |
				(((bgClr.getBlue() << 3) & 0xff)) );
				                          
	TVCtrl.getDefault().setChromaKey( chroma );
}

public void addNotify( Component c) {
}

public boolean paintBackground( Component o, Component c, Graphics g, int cx, int cy, int cw, int ch, int x, int y, int w, int h, int xOff, int yOff, int state) {
	//though bgClr is properly set bg painting will be overridden by parent deco
	//in Component.paintBackground(). Let's clear and mark as done.
	g.clearRect( x, y, w, h);
	start(c);
	return true;
}

public void removeNotify( Component c) {
	//no need for hardware chroma to stop while layouting 
}

private void start( Component c) {
	Container p = null;
	for ( p = c.getParent(); (p != null) && (p.getParent() != null); p = p.getParent() );
	if ( (p == null) || !(p instanceof Window) ){
		return;
	}
	
	if ( c.isShowing() && ((flags & RUNNING) == 0) ) {
		updateScreen( c);
		TVCtrl.getDefault().setPreview( 1);
		flags |= RUNNING;
	}
}

private void stop() {
	if (( flags & RUNNING) != 0 ) {
		TVCtrl.getDefault().setPreview( 0);
		flags &= ~RUNNING;
	}
}

private void updateScreen( Component c) {
	Point p = c.getLocationOnScreen();
	int w = AWT.extension.getWidth( c);
	int h = AWT.extension.getHeight( c);
	
	TVCtrl.getDefault().setBounds( p.x, p.y, w, h);
}
}
