package com.pocketlinux.awt.theme;

import kaffe.awt.*;
import kaffe.awt.theme.*;
import java.awt.Scrollbar;
import java.awt.Font;
import java.awt.Color;

public class Style {

Theme theme;
String stylename;
StyleComponentDeco tran;
StyleComponentDeco border;
StyleComponentDeco btn;
StyleComponentDeco win;
StyleComponentDeco sbh;
StyleComponentDeco sbv;
StyleComponentDeco ch;
StyleComponentDeco pull;

public Color fg;
public Color bg;
public String fname;
public int fsize;
public int fstyle;
public Font fnt;

Style(Theme theme, String name) {
	this.theme = theme;
	stylename = name;
	tran = new DecoTran(this, false, false);
	border = new DecoTran(this, false, true);
	btn = new Deco9I(this, "btn");
	if (name.equals("default")) {
		win = new Deco1I(this, "win");
	}
	else {
		win = new Deco9I(this, "win");
	}
	sbh = new Deco4I(this, "bar", Scrollbar.HORIZONTAL);
	sbv = new Deco4I(this, "bar", Scrollbar.VERTICAL);
	ch = new Deco11I(this, "btn");
	pull = new Deco9PI(this, "pulldown");
}

/**
 * This constructor makes a style which has nothing but deco objects which
 * don't draw anything, but pretend they do.
 * This is used for table header rows.
 */
Style(Theme theme) {
	tran = new DecoTran(this, true, false);
	border = tran;
	btn = tran;
	win = tran;
	sbh = tran;
	sbv = tran;
	ch = tran;
	pull = tran;
}

void reload() {
	//tran.reload(); Not necessary
	//border.reload(); Not necessary
	btn.reload();
	win.reload();
	sbh.reload();
	sbv.reload();
	ch.reload();
	pull.reload();

	fg = Color.black;
	bg = null;
	fname = "Default";
	fstyle = Font.PLAIN;
	fsize = 9;
}

void setProperty(String property, String value) {
	if (property.equalsIgnoreCase("font-face")) {
		fname = value;
	}
	else if (property.equalsIgnoreCase("font-size")) {
		try {
			fsize = Integer.parseInt(value);
		}
		catch (NumberFormatException _) {
			fsize = 9;
		}
	}
	else if (property.equalsIgnoreCase("font-weight")) {
		if (value.equalsIgnoreCase("plain")) {
			fstyle = Font.PLAIN;
		}
		else if (value.equalsIgnoreCase("bold")) {
			fstyle = Font.BOLD;
		}
		else if (value.equalsIgnoreCase("italic")) {
			fstyle = Font.ITALIC;
		}
		else if (value.equalsIgnoreCase("bolditalic")) {
			fstyle = Font.BOLD | Font.ITALIC;
		}
	}
	else if (property.equalsIgnoreCase("font-color")) {
		fg = Color.getColor(value, Color.black);
	}
}

void finish() {
	fnt = new Font(fname, fstyle, fsize);
	tran.fgClr = fg;
	tran.bgClr = bg;
	tran.fnt = fnt;
	border.fgClr = fg;
	border.bgClr = bg;
	border.fnt = fnt;
	btn.fgClr = fg;
	btn.bgClr = bg;
	btn.fnt = fnt;
	win.fgClr = fg;
	win.bgClr = bg;
	win.fnt = fnt;
	ch.fgClr = fg;
	ch.bgClr = bg;
	ch.fnt = fnt;
	pull.fgClr = fg;
	pull.bgClr = bg;
	pull.fnt = fnt;
}

public String toString() {
	return ("[Style: " + stylename + "]");
}

}
