dnl Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
dnl See the file "license.terms" for details.
dnl
dnl $tvt: fgl.m4,v 1.5 2001/06/15 03:06:50 samc Exp $

dnl -------------------------------------------------------------------------
dnl TVT_FGL - setup paths to FGL config files
dnl -------------------------------------------------------------------------
AC_DEFUN([TVT_FGL],
[
  AC_MSG_CHECKING(for FGL)
  AC_ARG_WITH(fglconfdir, [  --with-fglconfdir=DIR   fgl configuration dir])
  if test $with_fglconfdir; then
    if test -d "$with_fglconfdir"; then
      fglconfdir=$with_fglconfdir
      AC_SUBST(fglconfdir)
      AC_MSG_RESULT($fglconfdir)
    else
      AC_MSG_RESULT(no)
      AC_MSG_ERROR(fgl configuration dir 'with-fglconfdir=$with_fglconfdir' not found)
    fi
  else
    dnl If no option given then look for IPL in in the parent directories.
    abssrcdir=`pwd`/$srcdir
    fglconfdir=""
    if test -d "$abssrcdir/../fgl/config"; then
      fglconfdir="$abssrcdir/../fgl/config"
    elif test -d "$abssrcdir/../../fgl/config"; then
      fglconfdir="$abssrcdir/../../fgl/config"
    fi
    if test "$fglconfdir" != ""; then
      AC_SUBST(fglconfdir)
      AC_MSG_RESULT($fglconfdir)
    else
      AC_MSG_RESULT(no)
    fi
  fi
])

dnl -------------------------------------------------------------------------
dnl TVT_FGL_FONTS - setup paths FGL fonts
dnl -------------------------------------------------------------------------
AC_DEFUN([TVT_FGL_FONTS],
[
  AC_ARG_WITH(fontdir,[  --with-fontdir=PATH     specify where to find fonts])
  if test $with_fontdir; then
    if test -d "$with_fontdir"; then
      echo "fgl font dir: " $with_fontdir
      fglfontdir=$with_fontdir
    else
      AC_MSG_ERROR(fgl font dir 'with-fontdir=$with_fontdir' not found) 
    fi
  else
    dnl If no options given then assume FGL in in the parent directory
    fglfontdir=$srcdir/../fgl/fonts
  fi
  AC_SUBST(fglfontdir)
])
