/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: PackagingSubsystem.java,v 1.10 2001/11/16 00:23:00 samc Exp $
 */
package org.xoe.core;

import java.net.URL;
import java.io.IOException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import org.xoe.core.packages.PackageManager;
import org.xoe.core.util.Logger;
import org.xoe.core.util.DOMUtils;
import org.xoe.core.util.XMLWriter;
import org.xoe.core.xpath.XPath;

public class PackagingSubsystem
  implements ISubsystem
{
  public void initSubsystem (Document configDoc)
    throws Exception
  {
    String archPackage = "stash:/packages/architecture-native_" + Engine.getSystemArch () + "_0.1.xoe";
    try
      {
        PackageManager.installPackage (new URL (archPackage));
      }
    catch (IOException e)
      {
        Logger.log (this, "error loading required package: " + archPackage);
        throw e;
      }

    if (configDoc != null)
      {
	NodeList nl = XPath.findNodes(configDoc, "package-servers/server");

	for (int i = 0; i < nl.getLength (); i++)
	  {
	    Element pserver = (Element) nl.item (i);
	    String type = pserver.getAttribute ("type");
	    String url = DOMUtils.getAssignedValue (pserver);

	    if (type == null || url == null)
	      {
		Logger.log (this, "ignoring unrecognized package server declaration: " + XMLWriter.getXML (pserver));
		continue;		
	      }

	    PackageManager.addPackageServer (type, url);
	  }
      }

    PackageManager.addPackageServer ("SIMPLE", "stash:/packages");
  }
}
