/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: IContentTypeResolver.java,v 1.1 2001/10/21 04:11:58 colin Exp $
 */
package org.xoe.core.content;

import java.io.InputStream;
import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;

import org.xoe.core.services.IService;


public interface IContentTypeResolver 
  extends IService
{
  public static final String INTERFACE = IContentTypeResolver.class.getName ();
  public static final String FUNCTIONALITY = "contentTypeResolver";

  // Return content-type information for the resource.
  // If this resolver does not know anything about the
  // resource, return null.
  //
  // 'mimetype' is an optional guess or null.
  public ContentType resolveStream (InputStream in, String mimetype)
    throws IOException;

  public ContentType resolveStream (InputStream in, ContentType type)
    throws IOException;

  public ContentType resolveSuffix(String suffix);
}
