/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: IDocumentBuilder.java,v 1.4 2001/12/18 06:06:15 colin Exp $
 */
package org.xoe.core.content;

import java.io.IOException;

import org.xoe.core.dom.XDocument;
import org.xoe.core.services.IService;


/**
 *  This interface defines a XOE Service for building XML Documents from raw 
 *  content.
 */
public interface IDocumentBuilder 
  extends IService
{
  /**
   *  The IService interface implemented by this service.
   */
  public static final String INTERFACE = IDocumentBuilder.class.getName ();

  /**
   * Returns the XML Document referred to by <code>content</code>.
   *
   * @param content the data to use for building the document
   *
   * @exception IOException if an I/O error occurs
   *
   * @return the XML Document referred to by <code>content</code>.
   */
  public XDocument getDocument (ContentElement content)
    throws IOException;
}
