/* 
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *
 * $tvt: lnk.java,v 1.3 2001/11/05 22:42:35 samc Exp $
 */
package org.xoe.core.content.text;

import java.io.IOException;
import java.net.URL;

import org.xoe.core.content.ContentCache;
import org.xoe.core.content.ContentElement;
import org.xoe.core.content.IDocumentBuilder;
import org.xoe.core.dom.XDocument;
import org.xoe.core.util.Logger;
import org.xoe.core.xpath.XPath;
import org.xoe.core.xpath.XPathParser;


public class lnk 
  extends xml
{
  /**
   * the xpath used to find the lnk src, relative to the document node
   */
  private static final XPath LNK_SRC_PATH = XPathParser.singleton.parse ("lnk/@src");

  // -------------------------------------------------------------------------
  // org.xoe.core.services.IService

  public String[] getFeatures (String func)
  {
    if (func.equals (FUNCTION_CONTENT_HANDLER))
      {
	return (new String[]{
                              FEATURE_EXTENSION, EXTENSION_LNK,
                              FEATURE_MIMETYPE, MIMETYPE_TEXT_VND_TVT_LNK
	  		    });
      }
    return (null);
  }


  // -------------------------------------------------------------------------
  // org.xoe.core.content.IDocumentBuilder

  public XDocument getDocument (ContentElement content)
    throws IOException
  {
    content = getRedirectedContent (content);
    if (content == null)
      {
        return (null);
      }

    IDocumentBuilder db = (IDocumentBuilder)content.getType ().getService (IDocumentBuilder.INTERFACE);
    if (db == null)
      {
	Logger.log (this, "getDocument: no document builder service found for " + content.getURL ());
        return (null);
      }

    return (db.getDocument (content));
  }


  // -------------------------------------------------------------------------
  // internals

  private ContentElement getRedirectedContent (ContentElement content)
    throws IOException
  {
    XDocument d = super.getDocument (content);
    String lnkSrc = XPath.findString (d, LNK_SRC_PATH);
    return (ContentCache.fetch (lnkSrc));
  }
}
