/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: xml.java,v 1.1 2001/10/21 04:11:58 colin Exp $
 */
package org.xoe.core.content.text;

import java.io.IOException;

import org.w3c.dom.Document;

import org.xoe.core.content.ContentElement;
import org.xoe.core.content.ContentType;
import org.xoe.core.content.IDocumentBuilder;
import org.xoe.core.dom.XDocument;
import org.xoe.core.dom.DOMlet;


public class xml 
  implements IDocumentBuilder
{
  // -------------------------------------------------------------------------
  // org.xoe.core.services.IService

  public void init (Document configDoc)
  { // No configuration necessary
  }

  public String[] getFunctionalities ()
  {
    return (new String[] { FUNCTION_CONTENT_HANDLER });
  }

  public String[] getInterfaces (String func)
  {
    if (func.equals (FUNCTION_CONTENT_HANDLER))
      {
	return (new String[] { IDocumentBuilder.INTERFACE });
      }

    return (null);
  }

  public String[] getFeatures (String func)
  {
    if (func.equals (FUNCTION_CONTENT_HANDLER))
      {
	return (new String[]{
                             FEATURE_MIMETYPE, MIMETYPE_TEXT_XML,
                             FEATURE_MIMETYPE, MIMETYPE_TEXT_XML_DTD,
			     FEATURE_EXTENSION, EXTENSION_XML,
			     FEATURE_EXTENSION, EXTENSION_DTD,
			     FEATURE_EXTENSION, EXTENSION_XHTML,
			     FEATURE_DOCTYPE_NAME_NS, DOCTYPE_NAME_NS_XHTML,
	  		    });
      }

    return (null);
  }

  public String[] getInformation ()
  {
    return (null);
  }


  // -------------------------------------------------------------------------
  // org.xoe.core.content.IDocumentBuilder

  public XDocument getDocument (ContentElement content)
    throws IOException
  {
    return DOMlet.create (content.getInputStream (), 
                          content.getURL (), 
                          content.getContentLength ());
  }
}
