/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: Device.java,v 1.10 2001/11/17 02:23:42 samc Exp $
 */
package org.xoe.core.device;

import java.io.IOException;
import javax.sound.sampled.AudioFormat;

import org.xoe.core.services.ServiceLocator;
import org.xoe.core.util.Logger;

/**
 * static helper funstion for access device related services.
 */
public class Device
{
  static IAudio audio = null;
  static INetwork network = null;

  private Device () {}

  /**
   * Set intensity of the backlight.
   */
  public static void setBacklight (int intensity)
  {
  }

  /**
   * Play a short sound, at 44100 KHz 16bit stereo.
   */
  public static void beep (byte[] buffer, int offset, int len)
  {
    AudioFormat format = new AudioFormat (44100, 16, 2, false, false);
    beep (buffer, offset, len, format);
  }

  /**
   * Play a short sound, at in the given format.
   */
  public static void beep (byte[] buffer, int offset, int len, AudioFormat format)
  {
    getAudio ();
    if (audio != null)
      {
        try
          {
            audio.setFormat (format);
            audio.write (buffer, offset, len);
          }
        catch (IOException e)
          {
            Logger.log (Device.class, e);
          }
      }
  }

  /**
   * Look for an IAudio service.
   */
  public static IAudio getAudio ()
  {
    if (audio == null)
      {
        audio = (IAudio) ServiceLocator.findImplementor (IAudio.class.getName ());
        if (audio != null)
          {
            Logger.log (Device.class, "got audio");
          }
        else
          {
            Logger.log (Device.class, "failed to get audio");
          }
      }
    return audio;
  }

  /**
   * Look for an INetwork service.
   */
  public static INetwork getNetwork ()
  {
    if (network == null)
      {
        network = (INetwork) ServiceLocator.findImplementor (INetwork.class.getName ());
        if (network != null)
          {
            Logger.log (Device.class, "got network");
          }
        else
          {
            Logger.log (Device.class, "failed to get network");
          }
      }
    return network;
  }
}
