/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: IAudio.java,v 1.6 2001/11/21 02:52:41 samc Exp $
 */
package org.xoe.core.device;

import java.io.IOException;
import javax.sound.sampled.AudioFormat;

import org.xoe.core.services.IService;

/**
 * Java interface for controling audio playback on devices.
 */
public interface IAudio
  extends IService
{
  /**
   * open audio device.
   */
  public void open () throws IOException;

  /**
   * close audio device.
   */
  public void close ();

  /**
   * write audio data to the speakers.
   */
  public int write (byte[] data) throws IOException;
  public int write (byte[] data, int offset, int length) throws IOException;

  /**
   * read audio data from the microphone.
   */
  public int read (byte[] data) throws IOException;

  /**
   * set the audio format.
   */
  public void setFormat (AudioFormat format) throws IOException;

  /**
   * set the output volume.
   */
  public void setVolume (int percentage);

  /**
   * get the output volume.
   */
  public int getVolume ();
}
