/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: IStorage.java,v 1.6 2001/11/09 20:06:41 samc Exp $
 */
package org.xoe.core.device;

import java.io.IOException;

import org.xoe.core.services.IService;

/**
 * Java interface for control storage devices.
 * This will be integrated with the stash RSN.
 */
public interface IStorage
  extends IService
{
  /**
   * device discovery.
   */
  public String[] getStorageDevices () throws IOException;

  /**
   * format the device.
   */
  public void format (String deviceName) throws IOException;

  /**
   * get the size of the device.
   */
  public long getSize (String deviceName) throws IOException;

  /**
   * get the device mount point.
   * Here is where we might want to return a StashDirectory.
   */
  public String getMountPoint (String deviceName) throws IOException;
}
