/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: ISystem.java,v 1.2 2001/11/10 01:05:32 samc Exp $
 */
package org.xoe.core.device;

import java.io.IOException;

import org.xoe.core.services.IService;

/**
 * Some things that java.land.System won't do for you like
 * reporting the physical RAM size and setting the system
 * clock.
 */
public interface ISystem
  extends IService
{
  /**
   * RAM usage
   */
  public long getTotalRAM () throws IOException;
  public long getUnusedRAM () throws IOException;

  /**
   * System clock
   */
  public void setTimeMillis (long time) throws IOException;
}
