/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: SimpleNodeList.java,v 1.1 2001/10/21 03:56:01 colin Exp $
 */
package org.xoe.core.dom;

import java.util.Enumeration;
import java.util.Vector;

import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


public class SimpleNodeList
  extends Vector
  implements NodeList, NodeConsumer
{
  private boolean many;

  public SimpleNodeList () 
  {
    this (true);
  }

  public SimpleNodeList (boolean many) 
  {
    this.many = many;
  }

  public Node item (int i)
  {
    return ((Node)elementAt (i));
  }
    
  public int getLength ()
  {
    return (size ());
  }

  public void appendChild (Node node)
  {
    super.addElement (node);
  }

  public boolean consume (Node node)
  {
    super.addElement (node);
    return (many);
  }

  public String toString ()
  {
    StringBuffer sb = new StringBuffer ();
    sb.append ("{ ");
    Enumeration e = elements ();
    while (e.hasMoreElements ())
      {
        sb.append (e.nextElement ());
        sb.append (",  ");
      }
    sb.append ("}");
    return (sb.toString ());
  }
}
