/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: XEntity.java,v 1.1 2001/10/21 03:56:01 colin Exp $
 */
package org.xoe.core.dom;

import org.w3c.dom.Entity;
import org.w3c.dom.Node;


public class XEntity
  extends XNode
  implements Entity
{
  private String publicId;
  private String systemId;
  private String notationName;
  
  // ----------------------------------------------------------------------------
  // member methods
  
  public String getPublicId ()
  {
    return publicId;
  }
  
  public String getSystemId ()
  {
    return systemId;
  }
  
  public String getNotationName ()
  {
    return notationName;
  }


  public String getNodeName ()
  {
    return getNotationName ();
  }


  // ----------------------------------------------------------------------------
  // org.w3c.dom.Node Interface

  public short getNodeType ()
  {
    return ENTITY_NODE;
  }

  public Node cloneNode(boolean deep)
  {
    XEntity nnode = (XEntity)super.cloneNode (deep);
    nnode.publicId = this.publicId;
    nnode.systemId = this.systemId;
    nnode.notationName = this.notationName;
    return (nnode);
  }


  // ----------------------------------------------------------------------------
  // org.xoe.core.dom.Cacheable 

  public void reset ()
  {
    super.reset();
    publicId = null;
    systemId = null;
    notationName = null;
  }

}
