/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: XEntityResolver.java,v 1.2 2001/11/15 19:24:50 tim Exp $
 */
package org.xoe.core.dom;

import java.util.Hashtable;
import java.util.StringTokenizer;

import org.xoe.core.Constants;


public class XEntityResolver 
  implements EntityResolver, Constants, Cloneable
{
  private Hashtable entities;

  public void addEntity (String name, String value)
  {
    if (entities == null)
      {
        entities = new Hashtable ();
      }
    entities.put (name, value);
  }

  public String getValue (String name)
  {
    if (entities != null)
      {
	return (String)entities.get (name);
      }
    return null;
  }

  public String toString ()
  {
    if (entities != null)
      {
	return entities.toString ();
      }
    return "{}";
  }

  public Object clone ()
  {
    //this works because the data in the hashtable are strings
    XEntityResolver newresolve = new XEntityResolver ();
    newresolve.entities = (Hashtable)this.entities.clone();
    return (newresolve);
  }


  // -------------------------------------------------------------------------
  // entification!

  public static String entify (String text, EntityResolver resolver)
  {
    if (text == null) 
      {
	return (null);
      }

    // Quick check for entities - if none don't do anything
    if (text.indexOf (AMPERSAND_SYMBOL) == -1) 
      {
	return (text);
      }

    StringBuffer outBuf = new StringBuffer ();
    StringTokenizer st = new StringTokenizer (text, AMPERSAND_SYMBOL_STRING, true);
    while (st.hasMoreTokens ())
      
      {
	String currToken = st.nextToken ();
	if (currToken.equals (AMPERSAND_SYMBOL_STRING) && st.hasMoreTokens ())
	  {
	    currToken=st.nextToken ();

	    int scIdx = currToken.indexOf (';');
	    if (scIdx >= 0)
	      {
		String name = currToken.substring (0, scIdx);

		// if the name has spaces, it is invalid
		if (name.indexOf (" ") == -1)
		  {
		    // check the default entityr resolver first, then try the one 
		    // passed in
		    String value = DefaultEntityResolver.getInstance ().getValue (name);
		    if (value != null)
		      {
			outBuf.append (value);
			currToken = currToken.substring (scIdx+1);
		      }
		    else
		      {
			value = resolver.getValue (name);
			if (value != null)
			  {
			    outBuf.append (value);
			    currToken = currToken.substring (scIdx+1);
			  }
			else
			  {
			    outBuf.append (AMPERSAND_SYMBOL);
			  }
		      }
		  }
		else
		  {
		    outBuf.append (AMPERSAND_SYMBOL);
		  }
	      }
	    else
	      {
		outBuf.append (AMPERSAND_SYMBOL);
	      }
	  }

	outBuf.append (currToken);
      }

    return outBuf.toString ();
  }

}
