/* 
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *
 * $tvt: XLink.java,v 1.3 2001/11/05 22:42:35 samc Exp $
 */
package org.xoe.core.dom;

import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


public class XLink
  extends XElement
{
  public static final String XLINK_NAMESPACE = "http://www.w3.org/1999/xlink";

  public static final String XLINK_TYPE    = "type";
  public static final String XLINK_HREF    = "href";
  public static final String XLINK_ROLE    = "role";
  public static final String XLINK_ARCROLE = "arcrole";
  public static final String XLINK_TITLE   = "title";
  public static final String XLINK_SHOW    = "show";
  public static final String XLINK_ACTUATE = "actuate";
  public static final String XLINK_LABEL   = "label";
  public static final String XLINK_FROM    = "from";
  public static final String XLINK_TO      = "to";

  private static final String DEFAULT_SHOW_ATTR = "replace";

  public static String getType (Element e) 
  {
    return e.getAttributeNS (XLINK_NAMESPACE, XLINK_TYPE);
  }

  public static String getHref (Element e)
  {
    return e.getAttributeNS (XLINK_NAMESPACE, XLINK_HREF);
  }

  public static String getShow (Element e)
  {
    String show = e.getAttributeNS (XLINK_NAMESPACE, XLINK_SHOW);
    if (show == null) 
      {
        return (DEFAULT_SHOW_ATTR);        
      }
    return (show.intern ());
  }
  
}
