/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: XNodeCache.java,v 1.2 2001/11/14 22:59:42 samc Exp $
 */
package org.xoe.core.dom;

public class XNodeCache 
  extends Cache 
{
  static XNodeCache defCache = getXNodeCache (XElement.class);

  public static XNodeCache getXNodeCache (Class cls) 
  {
    return (getXNodeCache (cls, defCache));
  }

  public static XNodeCache getXNodeCache (String name) 
  {
    return (getXNodeCache (name, defCache));
  }

  public static XNodeCache getXNodeCache (Class cls, XNodeCache def) 
  {
    return ((XNodeCache) getCache (cls, XNodeCache.class, def));
  }

  public static XNodeCache getXNodeCache (String name, XNodeCache def) 
  {
    return ((XNodeCache) getCache (name, XNodeCache.class, def));
  }

  /**
   * Get a free node.
   */
  public XNode getFreeNode () 
  {
    XNode node = (XNode) get ();
    node.cache = this;
    return (node);
  }

  /**
   * Create an alias to a node cache (for tags)
   */
  public static void addXNodeCacheAlias (String tag, String cname) 
  {
    caches.put (tag, getXNodeCache (cname));
  }

  public static void addXNodeCacheAlias (String tag, String cname, Object provider) 
  {
    caches.put (tag, getXNodeCache (cname), provider);
  }

  public static void addClassToCache (String name, Class cls) 
  {
    Cache cache = new XNodeCache ();
    cache.clazz = cls;
    caches.put (name, cache);
  }

  public static void addClassToCache (String name, Class cls, Object provider) 
  {
    Cache cache = new XNodeCache ();
    cache.clazz = cls;
    caches.put (name, cache, provider);
  }

  public static void removeCache (String name) 
  {
    caches.remove (name);
  }

  public static void removeCache (String name, Object provider) 
  {
    caches.remove (name, provider);
  }

  public static void removeProvider (Object provider)
  {
    caches.removeProvider (provider);
  }
}
