/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: XProcessingInstruction.java,v 1.1 2001/10/21 03:56:01 colin Exp $
 */
package org.xoe.core.dom;

import org.w3c.dom.ProcessingInstruction;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;


public  class XProcessingInstruction
  extends XNode
  implements  ProcessingInstruction
{
  String target;
  String data;

  public NodeList getChildNodes () 
  {
    return (EmptyNodeList.getInstance ());
  }
    
  public Node getFirstChild ()
  {
    return (null);
  }
    
  public Node getLastChild ()
  {
    return (null);
  }
    
  public Node replaceChild (Node newChild, Node oldChild) 
    throws DOMException
  {
    return (null);
  }
    

  public Node removeChild (Node oldChild) 
    throws DOMException
  {
    return (null);
  }
    
  public Node appendChild (Node newChild ) 
    throws DOMException
  {
    return (null);
  }
    
  public void setData (String data) 
    throws DOMException
  {
    this.data = data;
  }

  public String getData () 
    throws DOMException
  {
    return (data);
  }

  public void setTarget (String target) 
    throws DOMException
  {
    this.target = target;
  }

  public String getTarget () 
    throws DOMException
  {
    return (target);
  }

  public String getNodeValue () 
  {
    return (getData ());
  }

  public void setNodeValue (String nodeValue)
  {
    setData (nodeValue);
  }

  public void reset ()
  {
    super.reset ();
    target = null;
    data = null;
  }

  public NamedNodeMap getAttributes () 
  {
    return (null);
  }

  public String getNodeName () 
  {
    return (getTarget ());
  }

  public short getNodeType ()
  {
    return (Node.PROCESSING_INSTRUCTION_NODE);
  }

  public Node cloneNode(boolean deep)
  {
    XProcessingInstruction nnode = (XProcessingInstruction)super.cloneNode (deep);
    nnode.target = this.target;
    nnode.data = this.data;
    return (nnode);
  }
}

