/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: XText.java,v 1.1 2001/10/21 03:56:01 colin Exp $
 */
package org.xoe.core.dom;

import java.io.IOException;
import java.io.Writer;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;


public class XText
  extends XCharacterData
  implements Text
{
  static final String TEXT_NODE_NAME= "#text";

  protected XText () 
  {
  }
  
  protected XText (Document owner) 
  {
    this.owner = owner;
  }
  
  void setValues (Document owner, String data)
  {
    this.owner = owner;
    setData (data);
  }

  public void setData (String data) 
    throws DOMException
  {
    EntityResolver resolver = (EntityResolver)getOwnerDocument ();
  
    // !!HACK!! _owner should never be null, but we need
    // this workaround until we owner support is complete.
   
    if (resolver == null)
      {
	resolver = DefaultEntityResolver.getInstance ();
      }

    super.setData (XEntityResolver.entify (data, resolver));
  }

  public short getNodeType () 
  {
    return (short) Node.TEXT_NODE;
  }

  public String getNodeName () 
  {
    return TEXT_NODE_NAME;
  }

  // -------------------------------------------------------------------------
  // org.w3c.dom.Text 

  /**
   *
   * @param param1 <description>
   * @return <description>
   * @exception org.w3c.dom.DOMException <description>
   */
  public Text splitText (int param1) 
    throws DOMException
  { 
    XText newText;

    if (param1<0 || param1>this.text.length)
      {  
	throw new DOMException ((short)1, "INDEX_SIZE_ERR");
      }  


    // split the text into text1 and text2

    char[] text1 = new char[param1];
    char[] text2 = new char[this.text.length-(param1)];  
    System.arraycopy (this.text, 0,  text1, 0, text1.length);
    System.arraycopy (this.text, param1, text2 , 0, text2.length);

    // assign the first half of the split text to this text node

    this.text = text1;

    // create a new text node with the first half of the split text

    newText = (XText)this.getOwnerDocument ().createTextNode (new String (text2));

    // insert the new text node after this text node if this node has a parent

    if (this.parent!=null)
      {
	newText.parent = this.parent;
	newText.nextchild = this.nextchild;
	this.nextchild = newText;
	if (this == parent.getLastChild ()) 
	  {
	    ((ParentNode)this.parent).tail = newText;
	  }
      }

    return (newText);
  }

}
