/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: ClassInstallerData.java,v 1.1 2001/10/22 20:19:04 colin Exp $
 */ 
package org.xoe.core.packages;

import java.util.Vector;


public class ClassInstallerData
{
  private XoeClassLoader m_classLoader = null;
  private Vector m_links = new Vector ();
  private Vector m_reverseLinks = new Vector ();
  
  protected ClassInstallerData (XoeClassLoader classLoader)
  {
    m_classLoader = classLoader;
  }
  
  protected void linkTo (ClassInstallerData other)
  {
    if (!m_links.contains (other))
      {
	this.m_classLoader.addClassLoader (other.m_classLoader);
	other.m_reverseLinks.addElement (this);
	this.m_links.addElement (other);
      }
  }
  
  protected void unlink ()
  {
    while (m_links.size () > 0)
      {
	ClassInstallerData other = (ClassInstallerData) this.m_links.elementAt (0);
	other.m_reverseLinks.removeElement (this);
	this.m_classLoader.removeClassLoader (other.m_classLoader);
	this.m_links.removeElement (other);
      }

    while (m_reverseLinks.size () > 0)
      {
	ClassInstallerData other = (ClassInstallerData) this.m_reverseLinks.elementAt (0);
	this.m_reverseLinks.removeElement (other);
	other.m_classLoader.removeClassLoader (this.m_classLoader);
	other.m_links.removeElement (this);
      }
  }
  
  public XoeClassLoader getClassLoader ()
  {
    return m_classLoader;
  }
}
