/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: InstallException.java,v 1.3 2001/12/13 23:51:18 erik Exp $
 */
package org.xoe.core.packages;

/**
 * Used to indicate an error while installing a package. Can be used
 * to wrap non-packaging specific Throwables.
 */
public class InstallException 
  extends PackageException
{
  public InstallException (Throwable t, XoePackage p, String detail)
  {
    this (t, "Failed to install package " + p + ": " + detail);
  }

  public InstallException (XoePackage p, String detail)
  {
    this (null, p, detail);
  }

  public InstallException (Throwable t, String msg)
  {
    super (t, msg);
  }

  public InstallException (String msg)
  {
    this ((Throwable)null, msg);
  }
}
