/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: PackageUtils.java,v 1.1 2001/10/22 20:19:04 colin Exp $
 */
package org.xoe.core.packages;

import java.lang.reflect.Array;
import java.util.Date;
import java.util.Enumeration;
import java.util.GregorianCalendar;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Vector;


public class PackageUtils
{
  public static GregorianCalendar parseExpiration (String expString) 
    throws ExpirationVerifierException
  {
    
    if (expString == null)
      {
	throw new ExpirationVerifierException ("Expiration String is NULL");
      }
    StringTokenizer st = new StringTokenizer (expString);
    int number = 3;  //make it three minutes by default
    int unit = GregorianCalendar.MINUTE;
    if (st.countTokens () != 2)
      {
        throw new ExpirationVerifierException ("don't understand <expiresIn>" + expString + "</expiresIn>");
      }
    else
      {
        number = Integer.parseInt (st.nextToken ());
        String strUnit = st.nextToken ().toLowerCase ();
        if (strUnit.equals ("ms") || strUnit.startsWith ("milliseconds"))
          {
            unit = GregorianCalendar.MILLISECOND;
          }
        else if (strUnit.startsWith ("s"))
          {
            unit = GregorianCalendar.SECOND;
          }
        else if (strUnit.startsWith ("min"))
          {
            unit = GregorianCalendar.MINUTE;
          }
        else if (strUnit.startsWith ("h"))
          {
            unit = GregorianCalendar.HOUR_OF_DAY;
          }
        else if (strUnit.startsWith ("d"))
          {
            unit = GregorianCalendar.DATE;
          }
        else if (strUnit.startsWith ("w"))
          {
            unit = GregorianCalendar.WEEK_OF_YEAR;
          }
        else
          {
            throw new ExpirationVerifierException ("don't understand <expiresIn>" + expString + "</expiresIn>");
          }
      }

    GregorianCalendar cal = new GregorianCalendar ();
    cal.setTime (new Date ());
    cal.add (unit, number);	
    return cal;
  }

  public static Object getValues (Vector v)
  {
    Object o[] = new Object [v.size ()];

    if (o.length == 0) return null;

    int i = 0;
    for (Enumeration e = v.elements (); e.hasMoreElements (); i++)
      {
	o[i] = e.nextElement ();
      }

    Object ret = Array.newInstance (o[0].getClass (), o.length);
    System.arraycopy (o, 0, ret, 0, o.length);

    return ret;
  }

  public static Object getValues (Hashtable ht)
  {
    Object o[] = new Object [ht.size ()];

    if (o.length == 0) return null;

    int i = 0;
    for (Enumeration e = ht.elements (); e.hasMoreElements (); i++)
      {
	o[i] = e.nextElement ();
      }

    Object ret = Array.newInstance (o[0].getClass (), o.length);
    System.arraycopy (o, 0, ret, 0, o.length);

    return ret;
  }
}
