/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: ResourceInstallerData.java,v 1.2 2001/12/15 01:03:48 erik Exp $
 */
package org.xoe.core.packages;

import java.net.URL;
import java.util.Vector;

public class ResourceInstallerData
{
  URL m_workingDirectory = null;
  Vector m_shortcuts = null;

  protected ResourceInstallerData (URL workingDirectory)
  {
    m_workingDirectory = workingDirectory;
  }

  // pass in the url of the .lnk file
  protected void addShortcut (URL url)
  {
    if (m_shortcuts == null)
      {
	m_shortcuts = new Vector();
      }

    m_shortcuts.addElement (url);
  }

  public URL[] getShortcuts()
  {
    return (URL[])(m_shortcuts != null ?
		   m_shortcuts.toArray(new URL[m_shortcuts.size()])
		   : new URL[0]);
							     
  }

  public URL getWorkingDirectory ()
  {
    return m_workingDirectory;
  }
}
