/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: DefaultURLStreamHandlerFactory.java,v 1.1 2001/10/21 04:10:52 colin Exp $
 */ 
package org.xoe.core.protocol;

import java.net.URLStreamHandler;
import java.net.URLStreamHandlerFactory;

import org.xoe.core.services.ServiceLocator;
import org.xoe.core.services.SimpleServiceQuery;


public class DefaultURLStreamHandlerFactory 
  implements URLStreamHandlerFactory 
{
  public URLStreamHandler createURLStreamHandler (String protocol) 
  {
    SimpleServiceQuery query = new SimpleServiceQuery (IProtocolHandlerFactory.FUNCTIONALITY, 
                                                       IProtocolHandlerFactory.INTERFACE);
    query.addFeature (IProtocolHandlerFactory.FEATURE, protocol);
    IProtocolHandlerFactory fac = (IProtocolHandlerFactory) ServiceLocator.findService (query);

    if (fac != null) 
      {
	return (fac.newInstance ());
      }
    else 
      {
	// Can't use MalformedURLException because this method doesn't declare
	// that.  But can't return null or the VM will use the default
	// factory.
	throw new IllegalArgumentException("unknown protocol: " + protocol);
	// return (null);
      }
  }
}
