/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: Jar.java,v 1.1 2001/10/21 04:10:52 colin Exp $
 */ 
package org.xoe.core.protocol;

import java.io.IOException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;

import kaffe.net.www.protocol.zip.Handler;

import org.w3c.dom.Document;


public class Jar
  extends Handler
  implements IProtocolHandlerFactory
{
  // -------------------------------------------------------------------------

  protected URLConnection openConnection (URL u)
    throws IOException
  {
    return (new JarURLConnection (u));
  }


  // -------------------------------------------------------------------------
  // org.xoe.core.protocol.IProtocolHandler

  public URLStreamHandler newInstance () 
  {
    return (this);
  }


  // -------------------------------------------------------------------------
  // org.xoe.core.services.IService

  public void init (Document configDoc)
  { // No configuration necessary
  }

  public String[] getFunctionalities ()
  {
    return (new String[] { IProtocolHandlerFactory.FUNCTIONALITY });
  }

  public String[] getInterfaces (String func)
  {
    if (func.equals (IProtocolHandlerFactory.FUNCTIONALITY))
      {
	return (new String[] { IProtocolHandlerFactory.INTERFACE });
      }
    
    return null;
  }

  public String[] getFeatures (String func)
  {
    if (func.equals (IProtocolHandlerFactory.FUNCTIONALITY))
      {
	return (new String[] { IProtocolHandlerFactory.FEATURE, "jar", 
			       IProtocolHandlerFactory.FEATURE, "zip" });
      }
    
    return null;
  }

  public String[] getInformation ()
  {
    return null;
  }

}
