/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: StashHandler.java,v 1.1 2001/10/21 04:10:52 colin Exp $
 */ 
package org.xoe.core.protocol;

import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;

import kaffe.net.www.protocol.file.Handler;

import org.w3c.dom.Document;

import org.xoe.core.content.Stash;
import org.xoe.core.util.Logger;


/**
 *  StashHandler.java is the handler for the <i>stash</i> protocol.  
 */
public class StashHandler
  extends Handler
  implements IProtocolHandlerFactory
{
  // -------------------------------------------------------------------------
  // kaffe.net.www.protocol.file.Hander

  protected URLConnection openConnection (URL u)
  {
    return (new StashURLConnection (u));
  }

  // -------------------------------------------------------------------------
  // org.xoe.core.protocol.IProtocolHandler

  public URLStreamHandler newInstance () 
  {
    return (this);
  }

  public void init (Document configDoc)
  { // No configuration necessary
  }

  public String[] getFunctionalities ()
  {
    String[] ret = { IProtocolHandlerFactory.FUNCTIONALITY };
    return ret;
  }

  public String[] getInterfaces (String func)
  {
    if ( func.equals ( IProtocolHandlerFactory.FUNCTIONALITY ) )
      {
	String[] ret = { IProtocolHandlerFactory.INTERFACE };
	return ret;
      }
    
    return null;
  }

  public String[] getFeatures (String func)
  {
    if (func.equals (IProtocolHandlerFactory.FUNCTIONALITY))
      {
	String[] ret = { IProtocolHandlerFactory.FEATURE, "stash" };
	return ret;
      }
    return null;
  }

  private static String getPathPrefix ()
  {
    StringBuffer sb = new StringBuffer (Stash.getPath ());
    return sb.toString ();
  }
  
  public String[] getInformation ()
  {
    return null;
  }
}
