/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: StashURLConnection.java,v 1.2 2001/10/24 20:52:26 samc Exp $
 */ 
package org.xoe.core.protocol;

import java.io.InputStream;
import java.io.IOException;
import java.net.URL;

import kaffe.net.www.protocol.BasicURLConnection;

import org.xoe.core.content.ContentElement;
import org.xoe.core.content.Stash;


/**
 * StashURLConnection - PocketLinux URL handler.
 */
public class StashURLConnection
  extends BasicURLConnection
{
  // -------------------------------------------------------------------------
  // constructors

  public StashURLConnection (URL url) 
  {
    super (url);
  }

  protected String getURLPrefix ()
  {
    return ("stash:");
  }

  public InputStream getInputStream () 
    throws IOException 
  {
    URL url = getURL ();
    ContentElement content = Stash.fetch (url);
    if (content == null)
      {
        throw new IOException ("content not found in stash: " + url.getFile ());
      }
    return content.getInputStream ();
  }

  public void connect () 
    throws IOException 
  {
    connected = true;
  }
}
