/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: IService.java,v 1.1 2001/10/20 19:45:07 colin Exp $
 */
package org.xoe.core.services;

import org.xoe.core.Constants;

import org.w3c.dom.Document;


/**
 * Top-level interface for all XOE services.
 */
public interface IService
  extends Constants
{
  /**
   * Services can be configued with a DOM Document.
   * configDoc may be null.
   */
  public void init (Document configDoc) throws Exception;

  /**
   * Functionalities are Strings that can be used to differentiate 
   * between different kinds of IServices.
   * This function must return all the Functionalities implemented by
   * the IService.  
   * This function may return null.
   */
  public String[] getFunctionalities ();

  /**
   * Returns the String names of all the Java interfaces that the 
   * IService implements for the given functionality.
   * This function may return null.
   */
  public String[] getInterfaces (String functionality);

  /**
   * This function may return null.
   */
  public String[] getFeatures (String functionality);

  /**
   * Returns extra meta-information about the service as an array of
   * Strings.
   * This function may return null.
   */
  public String[] getInformation ();
}
