package org.xoe.core.util;

public class Wildcard
{
  // by default, '?' is enabled
  public static boolean match (String str, String pattern)
  {
    return match (str, pattern, true);
  }

  public static boolean match (String str, String pattern, boolean qmark)
  {
    if (pattern.length () == 0)
      {
	if (str.length () == 0)
	  {
	    return true;
	  }
	else
	  {
	    return false;
	  }
      }

    if (str.length () == 0)
      { // this could be unrolled for optimization
	if (pattern.charAt (0) == '*')
	  {
	    return match (str, pattern.substring (1), qmark);
	  }
	else
	  {
	    return false;
	  }
      }

    if (pattern.charAt (0) == '*')
      {
	// first try to eat a character
	// (the next recursion will likewise try to eat either 1 or 0
	//  characters. In this way, the '*' may eat from 0 to str.length ()
	//  characters)
	if ( match (str.substring (1), pattern, qmark))
	  {
	    return true;
	  }
	// then try without eating a character
	else if (match (str, pattern.substring (1), qmark))
	  {
	    return true;
	  }
	else
	  {
	    return false;
	  }
      }
    else if (pattern.charAt (0) == '?' && qmark)
      {
	return match (str.substring (1), pattern.substring (1), qmark);
      }
    else if (pattern.charAt (0) == str.charAt (0))
      {
	return match (str.substring (1), pattern.substring (1), qmark);
      }
    else
      {
	return false;
      }
  }
}
