/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: CustomFunctionProvider.java,v 1.1 2001/10/21 04:44:20 colin Exp $
 */
package org.xoe.core.xpath;

import java.io.IOException;

import org.w3c.dom.NodeList;

import org.xoe.core.content.ContentElement;
import org.xoe.core.util.Logger;
import org.xoe.core.util.XMLWriter;


public class CustomFunctionProvider
  implements FunctionProvider
{
  public static final String FUNCTION_DOCTYPE_NAME_NS_EQUALS = "doctype_name_ns-equals";

  // boolean doctype_name_ns-equals(ContentElement content, string doctypeNameNS)
  // returns true if content element is of the type doctypeNameNS
  class doctypeNameNS_equals 
    extends XPathFunction
  {
    public doctypeNameNS_equals ()
    {
      expected = 2;
      name = FUNCTION_DOCTYPE_NAME_NS_EQUALS;
    }

    public Object applyN (Object[] args)
    {
      if (args[0] instanceof NodeList 
          && ((NodeList)args[0]).item (0) instanceof ContentElement)
        {
          try
            {
	      ContentElement content = (ContentElement) ((NodeList)args[0]).item (0);
	      String doctypeNameNS = XPath.stringValue (args[1]);

	      return (doctypeNameNS.equals (content.getType ().getXMLDoctypeNameNS ()) ? Boolean.TRUE : Boolean.FALSE);
            }
          catch (IOException ioe)
            {
              Logger.log (this, "doctype_name_ns-equals");
              Logger.log (this, ioe);
            }
        }
      
      return (Boolean.FALSE);
    }
  }

  public XPathFunction getFunction (String fname)
  {
    if (FUNCTION_DOCTYPE_NAME_NS_EQUALS.equals (fname))
      {
        return (new doctypeNameNS_equals ());
      }
 
    return (null);
  }
}
