#!/usr/bin/perl -wi -n

#  Converts blah( to blah ( 

# It handles quoted strings that don't extend over mutliple lines, but
# tries to fix the spacing in comments too.

# Usage: spaces.pl <files to convert>

# eg:
# $find . -name \*.java | xargs scripts/spaces.pl
#
# To be on the safe side you could say
# $./spaces.pl < test.java > spaces.out
# $diff spaces.out test.java

$q=0;
s/  (?<=[^\\]) \" | ([^\s(]) \(  /   # " or  (
	  if ( $&  eq '"')
	    { 
	      $q++; $&;     # increment quote counter
	    }
	  elsif ($q%2 == 0)
	    { 
	      "$1 ("        # add space only if we've seen an even number of " chars
	    }
	  else
	    { 
	      $&            # inside quotes, don't change anything
	    }
      /gex;  # allow white spaces for better readability and evaluate the rhs as an expression
print $_;
