package com.pocketlinux.packages;

import com.pocketlinux.content.Stash;
import org.xoe.test.Test;
import org.xoe.test.AssertionFailedException;
import java.io.IOException;
import java.net.URL;
import java.util.Vector;


public class ResourceInstallerTest extends Test
{
  private static final String SHORTCUT_PACKAGE = "shortcut-test";

  protected void test()
    throws AssertionFailedException
  {
    // if we fail, we still want to clean up the content-types we install
    // so that they don't interfer with other tests
    try
      { 
	// <Setup>
	installPackage(SHORTCUT_PACKAGE);

	ASSERT(Stash.fetch(new URL("stash:/home/default/apps/A_Shortcut.lnk")) != null,
	       "Stash.fetch(new URL(\"stash:/home/default/apps/A_Shortcut.lnk\")) != null");
	uninstallPackage(SHORTCUT_PACKAGE);
	ASSERT(Stash.fetch(new URL("stash:/home/default/apps/A_Shortcut.lnk")) == null,
	       "Stash.fetch(new URL(\"stash:/home/default/apps/A_Shortcut.lnk\")) == null");
      }
    catch(IOException ex)
      {
	report(ex);
	ASSERT(false, "Unexpected Exception");
      }
  }
}
