package com.pocketlinux.util;

import org.xoe.test.Test;
import org.xoe.test.AssertionFailedException;

public class ProviderHashtableTest extends Test
{
  protected void test()
    throws AssertionFailedException
  {
    ProviderHashtable h = new ProviderHashtable ();
    String[] keys = {"k0", "k1", "k2", "k3", "k4"};
    String[] providers = {"p0", "p1", "p2", "p3", "p4"};
    String[] values = {"v0", "v1", "v2", "v3", "v4"};

    h.put (keys[0], values[0]);
    ASSERT (h.get (keys[0]) == values[0], "h.get (keys[0]) == values[0]");

    h.put (keys[0], values[1], providers[0]);
    ASSERT (h.get (keys[0]) == values[1], "h.get (keys[0]) == values[1]");

    h.put (keys[0], values[2], providers[1]);
    ASSERT (h.get (keys[0]) == values[2], "h.get (keys[0]) == values[2]");

    h.put (keys[0], values[3], providers[0]);
    ASSERT (h.get (keys[0]) == values[3], "h.get (keys[0]) == values[3]");

    h.put (keys[0], values[4], providers[2]);
    ASSERT (h.get (keys[0]) == values[4], "h.get (keys[0]) == values[4]");

    h.put (keys[1], values[0], providers[0]);
    ASSERT (h.get (keys[1]) == values[0], "h.get (keys[1]) == values[0]");

    h.put (keys[1], values[1], providers[1]);
    ASSERT (h.get (keys[1]) == values[1], "h.get (keys[1]) == values[1]");

    h.remove (keys[0], providers[0]);
    ASSERT (h.get (keys[0]) == values[4], "h.get (keys[0]) == values[4]");

    h.removeProvider (providers[1]);
    ASSERT (h.get (keys[0]) == values[4], "h.get (keys[0]) == values[4]");
    ASSERT (h.get (keys[1]) == values[0], "h.get (keys[0]) == values[4]");

    h.put (keys[0], values[2], providers[1]);
    ASSERT (h.get (keys[0]) == values[2], "h.get (keys[0]) == values[2]");

    h.put (keys[0], values[1], providers[3]);
    ASSERT (h.get (keys[0]) == values[1], "h.get (keys[0]) == values[1]");

    h.setOverridingProvider(providers[2]);
    ASSERT (h.get (keys[0]) == values[4], "h.get (keys[0]) == values[4]");
    ASSERT (h.get (keys[1]) == values[0], "h.get (keys[1]) == values[0]");

    h.setOverridingProvider(providers[1]);
    ASSERT (h.get (keys[0]) == values[2], "h.get (keys[0]) == values[2]");
    ASSERT (h.get (keys[1]) == values[0], "h.get (keys[1]) == values[0]");
    
    h.setOverridingProvider(providers[2]);
    ASSERT (h.get (keys[0]) == values[4], "h.get (keys[0]) == values[4]");
    ASSERT (h.get (keys[1]) == values[0], "h.get (keys[1]) == values[0]");

    h.setOverridingProvider(null);
    ASSERT (h.get (keys[0]) == values[1], "h.get (keys[0]) == values[1]");
    ASSERT (h.get (keys[1]) == values[0], "h.get (keys[1]) == values[0]");
  }
}
