/**
 * IAuth - common interface to access authentication objects
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 *
 * @author P.C.Mehlitz
 * @see AuthProcess
 * @see AuthFactory
 */

package org.xoe.auth;

public interface IAuth
{
	public boolean authenticate ( String user, String pw );
	
	public boolean changeAuthentication ( String user, String pw, String newPw );

	public int getError ();

	public String getErrorMessage ( int err );
}
