/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: Calibrate.java,v 1.3 2001/11/15 20:47:49 damian Exp $
 */ 
package org.xoe.controls.screen;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.Graphics;
import java.io.IOException;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.xoe.core.device.IScreen;
import org.xoe.core.dom.DOMlet;
import org.xoe.core.dom.XDocument;
import org.xoe.core.services.IService;
import org.xoe.core.services.ServiceLocator;
import org.xoe.core.util.Logger;
import org.xoe.servlet.XoeServlet;


public class Calibrate 
  extends XoeServlet
{
  class CalibrateScreen
    extends Component
    implements MouseListener
  {
    Dimension size;
    CalibrateScreen (Dimension d)
    {
      size = new Dimension (d);
      addMouseListener (this);
    }

    public Dimension getPreferredSize ()
    {
      return size;
    }

    public void paint (Graphics g)
    {
      g.setColor (Color.white);
      g.fillRect (0, 0, size.width, size.height); 
    }

    // mouse listener interface

    public void mouseClicked (MouseEvent evt)
    {
      close ();
    }

    public void mouseEntered (MouseEvent evt)
    {
    }

    public void mouseExited (MouseEvent evt)
    {
    }

    public void mousePressed (MouseEvent evt)
    {
    }

    public void mouseReleased (MouseEvent evt)
    {
    }

  }

  Container screen;
  Container window;

  public void doGet (HttpServletRequest req, HttpServletResponse res) 
    throws ServletException, IOException
  {
    String path = req.getPathInfo ();

    if ("".equals (path) || "again".equals (path))
      {
        res.getWriter ().print (getRelativeDocument ("index.xhtml"));
      }
    if ("continue".equals (path))
      {
        IScreen is = (IScreen) ServiceLocator.findImplementor (IScreen.INTERFACE);
        screen = is.getScreen ();
        window = screen.getParent ();
        window.removeAll ();
        window.add (new CalibrateScreen (window.getSize ()), BorderLayout.CENTER);
        window.invalidate ();
        window.validate ();
        res.getWriter ().print (getRelativeDocument ("done.xhtml"));
      }
  }

  public void close ()
  {
    if (window != null)
      {
        window.removeAll ();
        window.add (screen, BorderLayout.CENTER);
        screen.repaint ();
      }
  }
  
}
