/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: Power.java,v 1.1 2001/11/16 02:50:21 samc Exp $
 */
package org.xoe.controlpanel;

import java.io.IOException;
import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.xoe.core.device.IPower;
import org.xoe.core.services.ServiceLocator;
import org.xoe.core.util.Logger;
import org.xoe.core.util.XMLWriter;
import org.xoe.core.util.DOMUtils;
import org.xoe.display.dom.xhtml.Dialog;

class Power
{
  static void updateInfo (Document doc)
  {
    IPower power = (IPower) ServiceLocator.findImplementor (IPower.class.getName ());
    if (power == null)
      {
        Dialog.note ("no IPower service found");
        return;
      }
    Element elem = doc.getElementById ("batterystatus");
    if (power.hasExternalPower ())
      {
        DOMUtils.setTextContent (elem, "charging"); 
      }
    else
      {
        DOMUtils.setTextContent (elem, "discharging"); 
      }
    elem = doc.getElementById ("batteryremaining");
    long time = power.getBatteryTimeRemaining ();
    if (time == -1)
      {
        DOMUtils.setTextContent (elem, "---"); 
      }
    else
      {
        DOMUtils.setTextContent (elem, Long.toString (time)); 
      }
  }

  static void setBacklight (Document doc)
  {
    IPower power = (IPower) ServiceLocator.findImplementor (IPower.class.getName ());
    if (power == null)
      {
        Dialog.note ("no IPower service found");
        return;
      }
    Element elem = doc.getElementById ("brightness");
    power.setBacklight (Integer.parseInt (elem.getAttribute ("value")));
  }
}
