/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: Storage.java,v 1.2 2001/12/12 21:12:33 simon Exp $
 */
package org.xoe.controlpanel;

import java.io.IOException;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.xoe.core.device.Device;
import org.xoe.core.device.IStorage;
import org.xoe.core.services.ServiceLocator;
import org.xoe.core.util.Logger;
import org.xoe.core.util.XMLWriter;
import org.xoe.core.util.DOMUtils;
import org.xoe.display.dom.xhtml.Dialog;

class Storage
{
  static void updateInfo (Document doc)
  {
    IStorage storage = (IStorage) ServiceLocator.findImplementor (IStorage.class.getName ());
    if (storage == null)
      {
        Dialog.note ("no storage implementation found");
        return;
      }
    Element table = doc.getElementById ("table");
    String[] devices;
    try
      {
        devices = storage.getStorageDevices ();
      }
    catch (IOException e)
      {
        Dialog.note ("error finding storage devices<br/>" + e);
        return;
      }
    Element tr;
    Element td;
    for (int i = 0; i < devices.length; i++)
      {
        tr = doc.createElement ("tr");

        td = doc.createElement ("td");
        DOMUtils.setTextContent (td, devices[i]);
        tr.appendChild (td);

        td = doc.createElement ("td");
        try
          {
            DOMUtils.setTextContent (td, Long.toString (storage.getSize (devices[i])/1024/1024) + "Mb");
          }
        catch (IOException e) 
          {
            Dialog.note ("error reading size of storage device<br/>" + e);
          }
        tr.appendChild (td);

        table.appendChild (tr);
      }
  }
}
