/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: SystemInfo.java,v 1.4 2001/11/10 00:30:31 samc Exp $
 */
package org.xoe.controlpanel;

import java.io.IOException;
import java.util.Properties;

import org.w3c.dom.Document;
import org.w3c.dom.Element;

import org.xoe.core.util.Logger;
import org.xoe.core.util.DOMUtils;
import org.xoe.core.device.ISystem;
import org.xoe.core.services.ServiceLocator;
import org.xoe.display.dom.xhtml.Dialog;

class SystemInfo
{
  static void updateInfo (Document doc)
  {
    Element elem;
    ISystem system = (ISystem) ServiceLocator.findImplementor (ISystem.class.getName ());
    if (system != null)
      {
        elem = doc.getElementById ("memory");
        try
          {
            DOMUtils.setTextContent (elem, Long.toString (system.getTotalRAM ()/1024) + " M.");
          }
        catch (IOException e)
          {
            Logger.log (SystemInfo.class, e);
            Dialog.note ("error reading RAM information<br/>" + e);
          }
      }
    else
      {
        Dialog.note ("no ISystem implementation found<br/>unable to display RAM information");
      }
    Properties properties = System.getProperties ();
    elem = doc.getElementById ("osname");
    DOMUtils.setTextContent (elem, System.getProperty ("os.name"));
    elem = doc.getElementById ("osversion");
    DOMUtils.setTextContent (elem, System.getProperty ("os.version"));
    elem = doc.getElementById ("arch");
    DOMUtils.setTextContent (elem, System.getProperty ("os.arch"));
  }
}
