/* 
 * JNI interface to libmad.
 * Resampling code taken directly from madplay (http://mad.sourceforce.net/).
 *
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: Audio.c,v 1.6 2001/12/14 19:52:43 ben Exp $
 */
#include <jni.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/soundcard.h>

static jfieldID fdID;

JNIEXPORT void JNICALL
Java_org_xoe_device_LinuxAudio_setVolume0 (JNIEnv* env, jclass class, jobject jfd, jint percentage)
{
  
  int fd = (*env)->GetIntField (env, jfd, fdID);

  int vol = percentage & 0xFF;

  if (vol < 0) 
    {
      vol = 0;
    }
  else if (vol > 100) 
    {
      vol = 100;
    }
  
  /*right stereo channel*/
  vol |= 256*vol;
  
  ioctl(fd, SOUND_MIXER_WRITE_PCM, &vol);

}

JNIEXPORT jint JNICALL
Java_org_xoe_device_LinuxAudio_getVolume (JNIEnv* env, jclass class, jint percentage)
{
  return 0;
}

/**
 * FindClass is slow so cache results 
 */
JNIEXPORT void JNICALL
Java_org_xoe_device_LinuxAudio_init0 (JNIEnv* env, jclass class)
{
  fdID = (*env)->GetFieldID(env, (*env)->FindClass (env, "java.io.FileDescriptor"), "fd", "I");
}

/**
 * Set the dsp output format.
 * [FIXME] right now we just force AFMT_S16_LE.
 */
JNIEXPORT jboolean JNICALL
Java_org_xoe_device_LinuxAudio_setFormat0 (JNIEnv* env, jobject clazz, jobject jfd, jint sampleSize, jint channels, jint rate)
{
  int fd;
  int format = AFMT_S16_LE;
/*
  int frag;
  int nrfrags = 32;
  int fragsize = 8192;
*/
  int fl;
  int rtn;
  int off = 0;

  fd = (*env)->GetIntField (env, jfd, fdID);

  rtn  = ioctl (fd, SNDCTL_DSP_SETFMT  , &format);
  rtn |= ioctl (fd, SNDCTL_DSP_CHANNELS, &channels);
  rtn |= ioctl (fd, SNDCTL_DSP_SPEED   , &rate);

/*
  frag = (nrfrags << 16)|fragsize;
  ioctl (fd, SNDCTL_DSP_SETFRAGMENT, &frag);
*/

  /* For the moment we make this blocking - IPAQ FIX */
  fl = fcntl (fd, F_GETFL, 0);
  rtn |= fcntl (fd, F_SETFL, fl & ~(O_NONBLOCK|O_ASYNC));
  rtn |= ioctl (fd, FIOASYNC, &off);
  rtn |= fcntl (fd, F_SETOWN, 0);
  return (rtn < 0) ? JNI_FALSE : JNI_TRUE;
}
