/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: LinuxSystem.java,v 1.1 2001/11/09 20:49:06 samc Exp $
 */
package org.xoe.device;

import java.io.IOException;
import java.io.StreamTokenizer;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.Vector;

import org.xoe.core.device.ISystem;

/**
 * Linux implementation of IStorage.
 */
public class LinuxSystem
  implements ISystem
{
  private static final String[] INTERFACES = { ISystem.class.getName () };

  // ---------------------------------------------------------------------
  // IService

  public String[] getInterfaces (String func) { return INTERFACES; }
  public String[] getFeatures (String func)   { return null;       }
  public String[] getFunctionalities ()       { return null;       }
  public String[] getInformation ()           { return null;       }
  public void init (org.w3c.dom.Document configDoc) {}

  // ---------------------------------------------------------------------
  // ISystem

  public long getTotalRAM ()
    throws IOException
  {
    FileInputStream fis = new FileInputStream ("/proc/meminfo");
    StreamTokenizer tok = new StreamTokenizer (new InputStreamReader (fis));
    while (tok.nextToken () != StreamTokenizer.TT_EOF)
      {
        // skip first line
        if (tok.lineno () < 2)
          {
            continue;
          }
        // skip the first two tokens (Mem:)
        tok.nextToken ();
        tok.nextToken ();
        if (tok.ttype != StreamTokenizer.TT_NUMBER)
          {
            throw new IOException ("error parsing /proc/meminfo: expected number: " + tok);
          }
        break;
      }
    return (int) (tok.nval/1024);
  }

  public long getUnusedRAM ()
  {
    return -1;
  }

  public void setTimeMillis (long time)
    throws IOException
  {
    if (!setTimeMillis0 (time))
      {
        throw new IOException ("error: setting system clock");
      }
  }

  private native boolean setTimeMillis0 (long time);
}
