/* 
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "license.terms" for details.
 *
 * $tvt: html.java,v 1.11 2001/11/08 22:11:24 suraj Exp $ 
 */
package org.xoe.content.text;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;
import java.net.URL;

import org.w3c.dom.Document;

import org.xoe.core.content.ContentElement;
import org.xoe.core.content.IDocumentBuilder;
import org.xoe.core.dom.DOMlet;
import org.xoe.core.dom.XDocument;
import org.xoe.core.util.Logger;
import org.xoe.core.util.XMLWriter;
import org.xoe.display.dom.IViewableDocumentBuilder;


/**
 * HTML document building service based on a customised
 * version of the w3c's tidy code.
 */
public class html
  implements IViewableDocumentBuilder, IDocumentBuilder
{
  private static boolean initialised = false;
  // -------------------------------------------------------------------------
  // org.xoe.core.services.IService

  public void init (Document configDoc)
  { 
    if (!initialised)
      {
        initialised = true;
        init0 ();
      }
  }

  public String[] getFunctionalities ()
  {
    String[] ret = { "contenthandler" };
    return ret;
  }

  public String[] getInterfaces (String func)
  {
    if (func.equals ("contenthandler"))
      {
	String[] ret = { IViewableDocumentBuilder.INTERFACE,
	                 IDocumentBuilder.INTERFACE };
	return ret;
      }
    return null;
  }

  public String[] getFeatures (String func)
  {
    if (func.equals ("contenthandler"))
      {
	return new String[]{ "mimetype", "text/html",
			     "extension", "html",
			     "extension", "htm",
			     "extension", "chtml",
			     "doctype", "http://www.w3.org/1999/xhtml^html"
                           };
      }
    return null;
  }

  public String[] getInformation ()
  {
    return null;
  }


  // -------------------------------------------------------------------------
  // org.xoe.display.dom.IViewableDocumentBuilder

  public XDocument getViewableDocument (ContentElement content)
    throws IOException
  {
    InputStream i = content.getInputStream (); // cache content, and let the ContentElement get it's redirected URL
    return (buildPage (content.getURL (), i));
  }


  // -------------------------------------------------------------------------
  // org.xoe.core.content.IDocumentBuilder

  public XDocument getDocument (ContentElement content)
    throws IOException
  {
    return (getViewableDocument (content));
  }


  // -------------------------------------------------------------------------
  // internals
  
  private XDocument buildPage (URL origURL, InputStream in)
    throws IOException
  {
    if (in == null) 
      {
	return (null);
      }
    ByteArrayOutputStream out = new ByteArrayOutputStream ();
    synchronized (this) 
      {
	parse0(in, out);
      }
    return (DOMlet.create (out.toString ("UTF8").toCharArray (), origURL));
  }

  private native static void init0 ();

  private native static void parse0 (InputStream in, OutputStream out);

}
