/* 
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: Html.java,v 1.14 2001/10/29 23:20:02 suraj Exp $ 
 */
package org.xoe.parser.html;


//import com.pocketlinux.engine.PLConstants;
import org.xoe.core.content.ContentElement;
import org.xoe.core.content.IDocumentBuilder;
import org.xoe.core.dom.DOMlet;
import org.xoe.core.dom.XDocument;
import org.xoe.core.util.Logger;


import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.lang.reflect.Method;
import java.lang.reflect.InvocationTargetException;
import java.net.ContentHandler;
import java.net.URL;
import java.net.URLConnection;

import org.w3c.dom.Document;

import org.xoe.display.dom.IViewableDocumentBuilder;


public class Html
  extends ContentHandler 
	implements /*PLConstants, */IViewableDocumentBuilder, IDocumentBuilder
{
  private MlEngine engine;

  // -------------------------------------------------------------------------
  // constructors

  public Html ()
  {
    engine = new MlEngine();
  }


  // -------------------------------------------------------------------------
  // com.pocketlinux.services.IService

  public void init (Document configDoc)
  {
    // No configuration necessary
  }

  public String[] getFunctionalities ()
  {
    return new String[] { "contenthandler" };
  }

  public String[] getInterfaces (String func)
  {
    if (func.equals ("contenthandler"))
      {
        return new String[] { IViewableDocumentBuilder.INTERFACE, IDocumentBuilder.INTERFACE };
      }
    return null;
  }

  public String[] getFeatures (String func)
  {
    if (func.equals ("contenthandler"))
      {
        return new String[] {
	  "mimetype", "text/html",
	  "extension", "html",
	  "extension", "htm",
	  "extension", "chtml",
	  "doctype", "http://www.w3.org/1999/xhtml^html"
       };
     }
    return null;
  }

  public String[] getInformation ()
  {
   return null;
  }


  // -------------------------------------------------------------------------
  // java.net.ContentHandler

  public Object getContent (URLConnection conn)
    throws IOException
  {
    URL origURL = conn.getURL ();

    // Make sure we have the real location (after indirection)
    String location = conn.getHeaderField ("location");
    if (location != null)
      {
	origURL = new URL (location);
      }
    return (buildPage (origURL, conn.getInputStream ()));
  }

  // -------------------------------------------------------------------------
  // org.xoe.display.dom.IViewableDocumentBuilder

  public XDocument getViewableDocument (ContentElement content)
    throws IOException
  {
    return buildPage (content.getURL (), content.getInputStream ());
  }

  // -------------------------------------------------------------------------
  // com.pocketlinux.content.IDocumentBuilder

  public XDocument getDocument (ContentElement content)
    throws IOException
  {
    return (getViewableDocument (content));
  }

  private XDocument buildPage (URL origURL, InputStream in)
    throws IOException
  {
    long start = System.currentTimeMillis ();
    XDocument doc = (XDocument) engine.createDocument( origURL, in);
    Logger.log(this, "parsing and DOM tree building " + (System.currentTimeMillis () - start) + "ms");
    return doc;
  }
}











