/* 
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: MlEngine.java,v 1.14 2001/10/24 20:21:33 philippe Exp $ 
 */
package org.xoe.parser.html;


import org.xoe.core.util.Logger;

import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

final public class MlEngine
{
  static int DocClassName_sequence = 0;

  //The packaging system ensures that the native lib is loaded
	     	
  static
  { 
    try
      {
        System.loadLibrary("xs");
      }
    catch (Error e)
      {
        Logger.log (MlEngine.class, "Failed to load xs library.  Assuming package manager has done so already");
      }
  }
	

  /**
   * returns success or failure
   */
  native private static boolean compile (InputStream is, String[] cmda, URL url, Object[] domtree);

  /**
   * current xoe interface
   */
  public Object createDocument (URL url, InputStream is)
  {
    Object doc = null;
    String dcname = getDocClassName (url);
        
    try
      {
	if (is == null)
	  {
	    Logger.log (this, "null inputstream");
	    return null;
	  }
	doc = createDocumentViaBC (is, dcname, url);
	is.close ();
      }
    catch (IOException ex)
      {
	Logger.log (this, ex);
      }

    return doc;
  }

  private Object createDocumentViaBC ( InputStream is, String clsName, URL url)
  {
    Object domtree[] = new Object[1]; // circumvent the lack of reference params
    try
      {
	      //String[] cmda = new String[] { "xs", clsName };
	      String[] cmda = new String[] { "xs", "-p" };

        //useless if don't rewind inputstream I'm sure
	//for (int i = 0; i < 10/* max tries */; i++)
	//{
	//try
	//      { 
		if (!compile (is, cmda, url, domtree))
		  {
		    Logger.log(this, "page compilation failed");
		    return null;
		  }
		//break;
		// }
		//catch(NullPointerException e)
		//{
		//Logger.log(this, e);
		//}
		//}
      }
    catch (Exception ex)
      {
        Logger.log(this, ex);
      }
    return domtree[0];
  }

  private String getDocClassName( URL url )
  {
    String  s = url.toExternalForm();
    int i0 = s.lastIndexOf('/');
    if (i0 < 0)
      {
	i0 = 0;
      }
    else
      {
	i0++;
      }

    int i1 = s.lastIndexOf('.');
    if (i1 < 0)
      {
	i1 = s.length() - 1;
      }

    try
      {
	return s.substring( i0, i1);
      }
    catch (StringIndexOutOfBoundsException e)
      {
	return "document_" + DocClassName_sequence++;
      }
  }
}













