package org.xoe.protocol.http;

import org.xoe.core.dom.XDocument;
import org.xoe.core.content.DocumentCache;
import org.xoe.core.protocol.IProtocolHandlerFactory;
import org.xoe.core.services.IService;
import org.xoe.core.xpath.XPath;

import java.net.URL;
import java.net.URLConnection;
import java.net.URLStreamHandler;


import org.w3c.dom.Document;

public class Handler
	extends kaffe.net.www.protocol.http.Handler
	implements IProtocolHandlerFactory, IService 
{
  private static final String PROXY_LOCATION = "xoe:user/xoe:proxy";

  public void init (Document configDoc)
  { // No configuration necessary
  }

  public String[] getFunctionalities ()
  {
    return new String[] { IProtocolHandlerFactory.FUNCTIONALITY };
  }

  public String[] getInterfaces (String func)
  {
    if (func.equals (IProtocolHandlerFactory.FUNCTIONALITY))
      {
        return new String[] { IProtocolHandlerFactory.INTERFACE };
      }
    
    return (null);
  }

  public String[] getFeatures (String func)
  {
    if (func.equals (IProtocolHandlerFactory.FUNCTIONALITY))
      {
        String[] ret = { IProtocolHandlerFactory.FEATURE, "http" };
        return (ret);
      }
    
    return (null);
  }

  public String[] getInformation ()
  {
    return (null);
  }


  public URLStreamHandler newInstance () 
  {
    XDocument userSettings = DocumentCache.fetchDocument ("stash:/data/settings/user.xml");
    if (userSettings != null)
      {
        String proxy = XPath.findString (userSettings, PROXY_LOCATION);
        if (proxy != null && proxy.length () > 0) 
          {
            int i = proxy.indexOf (':');
            int port = -1;
            if (i > -1) 
              {
                port = Integer.parseInt (proxy.substring (i+1));
                proxy = proxy.substring (0, i);
              }

            // needs to distinguish between com.pl.protocol... and kaffe.net.www.protocol...
            kaffe.net.www.protocol.http.HttpURLConnection.setProxy (proxy, port);
          }          
      }
    return (this);
  }

  protected URLConnection openConnection (URL u) 
  {
    // this is a com.pl.protocol.http.HttpURLConnection!
    return (new HttpURLConnection (u));
  }
}
