package org.xoe.protocol.http;

import org.xoe.core.services.IService;
import java.net.URL;

public interface ICookieService
  extends IService
{
  public static final String INTERFACE = "org.xoe.protocol.http.ICookieService";
  public static final String FUNCTION = "cookieservice";

  // Get all cookies that should be sent to a particular URL
  public Cookie[] getCookies(URL url);

  // Get all cookies in the jar
  public Cookie[] getCookies();

  // Get the cookie for a particular URL, with a particular name
  public Cookie getCookie(URL url, String name);

  // Put a cookie
  public void putCookie(Cookie cookie) throws BadCookieException;

  public void flushSessionCookies();
}
