/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: Main.java,v 1.1 2001/11/13 01:58:58 damian Exp $
 */ 
package org.xoe.controls.keyboard;

import java.io.IOException;
import java.util.Enumeration;
import java.util.Hashtable;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.xoe.core.dom.DOMlet;
import org.xoe.core.dom.XDocument;
import org.xoe.core.services.IService;
import org.xoe.core.services.ServiceLocator;
import org.xoe.services.IVirtualInput;
import org.xoe.servlet.XoeServlet;


public class Main
  extends XoeServlet
{
  private Hashtable ht = new Hashtable ();
  
  public void doGet (HttpServletRequest req, HttpServletResponse res) 
    throws ServletException, IOException
  {
    String path = req.getPathInfo ();

    if ("".equals (path))
      {
        display (res);
      }
    else if ("changekeyboard".equals (path))
      {
        String locale   = req.getParameter ("locale");
        String language = req.getParameter ("language");
        String query = locale+"-"+language;

        IVirtualInput set = (IVirtualInput) ht.get (query);

        if (set != null)
          {
            IVirtualInput vi;
            Enumeration enu = ht.elements ();
            while (enu.hasMoreElements ())
              { 
                vi = (IVirtualInput) enu.nextElement ();
                vi.detach ();
              }
            set.attach ();
          }
        display (res); 
      }
    else if ("refresh".equals (path))
      {
        display (res);
      }
  }

  private void display (HttpServletResponse res)
    throws IOException
  {
    ht.clear ();
    IService[] is = ServiceLocator.findImplementors (IVirtualInput.INTERFACE);

    String view = "<?xml version=\"1.0\"?>\n" +
      "<!DOCTYPE html PUBLIC \"-//TVT//DTD XOEVIEW 1.0//EN\" " +
      "\"http://www.xoe.org/DTD/xoe-view.dtd\">\n" + 
      "<?xoe-localize \"primary.dtd\"?>\n\n" +
      "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n" +
      "  <body>\n" +
      "    <table xoe:style=\"window\" width=\"100%\" height=\"100%\">\n" +
      "      <tr>\n" +
      "        <td xoe:style=\"display\" colspan=\"2\" >\n" +
      "          <p><b>Keyboard Setup</b></p>\n" +
      "          <p>Choose virtual keyboard</p>\n" +
      "        </td>\n" +
      "      </tr>\n" +
      "      <tr height=\"100%\" >\n" +
      "        <td>\n";
    if (is.length > 0 ) 
      {
        view +=  "          <p><b>Following Virtual Keyboards are installed:</b></p>\n" +
          "          <ul>\n";
        for (int i = 0; i < is.length; i++)
          { 
            String locale   = ((IVirtualInput)is[i]).getInputLocale();
            String language = ((IVirtualInput)is[i]).getInputLanguage();

            ht.put (locale + "-" + language, ((IVirtualInput)is[i]));

            view += "<li><a href=\"changekeyboard?locale=" + locale + "&language=" + language + "\" >" +
              "Locale (" + locale + ") Language (" + language + ")</a>";
            if (((IVirtualInput)is[i]).isAttached ())
              {
                view += " [Attached]";
              }
            view += "</li>\n";
          }
        view +=  "          </ul>\n";
      }
    else
      {
        view +=  "          <p><b>No Virtual Keyboards are installed</b></p>\n";
      }

    view +=       "        </td>\n" +
      "      </tr>\n" +
      "      <tr>\n" +
      "        <td = align=\"right\" >\n" +
      "          <form method=\"GET\" action=\"refresh\" >\n" +
      "            <input type=\"submit\" value=\"Refresh\" />\n" +
      "          </form>\n" +
      "        </td>\n" +
      "      </tr>\n" +
      "    </table>\n" +
      "  </body>\n" + 
      "</html>\n";

    res.setContentType ("text/html");
    XDocument xdoc = DOMlet.create (view.toCharArray (), "index.xhtml");
    res.getWriter ().print (xdoc);
  }  
}
