/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: ICodec.java,v 1.3 2001/11/17 02:24:09 samc Exp $
 */ 
package org.xoe.audio;

import org.xoe.core.services.IService;

import java.io.IOException;
import java.io.InputStream;

import javax.sound.sampled.AudioFormat;

public interface ICodec
  extends IService
{
  //public ICodec (InputStream in);

  /**
   * Send an event to any codec event listener.
   */
  public void codecEvent (String name, Object value);

  /**
   * Add an code listener.
   */
  public void addCodecListener (CodecListener listener);

  /**
   * Remove a codec listener.
   */
  public void removeCodecListener (CodecListener listener);

  public AudioFormat.Encoding[] getInputFormats ();
  public AudioFormat.Encoding[] getOutputFormats ();
  public void     openCodec ();
  public int      readCodec (byte[] buf, int offset, int length) throws IOException;
  public void     closeCodec ();
}
