/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: SoundStreamEvent.java,v 1.4 2001/12/14 19:48:02 ben Exp $
 */ 
package org.xoe.audio;

import javax.sound.sampled.Line;
import javax.sound.sampled.LineEvent;
import javax.sound.sampled.AudioSystem;

public class SoundStreamEvent 
  extends LineEvent
{

  public static class Type
    extends LineEvent.Type
  {
    public static final Type DATA         = new Type ("data");
    public static final Type LOADING      = new Type ("loading");
    public static final Type TYPE         = new Type ("type");
    public static final Type COMMENTS     = new Type ("comments");
    public static final Type TIME         = new Type ("time");
    public static final Type VOLUME         = new Type ("volume");

    protected Type (String name)
    {
      super (name);
    }
  }

  byte data[];
  int offset;
  int length;

  public SoundStreamEvent (Line line, byte data[])
  {
    this (line, data, 0, data.length);
  }

  public SoundStreamEvent (Line line, byte data[], int offset, int length)
  {
    super (line, Type.DATA, AudioSystem.NOT_SPECIFIED);

    this.data = data;
    this.offset = offset;
    this.length = length;
  }

  public byte[] getData ()
  {
    return data;
  }

  public int getOffset ()
  {
    return offset;
  }

  public int getLength ()
  {
    return length;
  }
}
