package org.xoe.audio;


import javax.sound.sampled.FloatControl;
import org.xoe.core.device.Device;
import org.xoe.core.device.IAudio;
import java.io.IOException;

public class XoeControl
	extends FloatControl
{

  static final float MIN = 0;
  static final float MAX = 256;
  static final float PRECISION = 1; 
  static final float INITIAL = 100;

  static IAudio audio;



  public XoeControl()
    {
      super((FloatControl.Type)new Type( "volume" ), MIN,
	    MAX, PRECISION, 1, INITIAL, "dB" );

      audio = Device.getAudio ();
    }


  public void setVolume (int newValue)
  {
    try
      {
	//this is actually a percentage, so we must convert the level to a percentage
	//based on the max value
	float newFloat = (float)newValue;
	float fraction = (newFloat / this.MAX);
	fraction = (fraction * 100);
	int percentage =  (int)fraction;
	audio.setVolume (percentage);
      }
    catch (IOException ioe)
      {
	ioe.printStackTrace ();
      }
  }



  public static class Type
    extends FloatControl.Type
  {

    public static final Type VOLUME = new Type ("VOLUME");
    String xoeControlType;

    protected Type (String type)
    {
      super (type);
      this.xoeControlType = type;
    }


  }


}
