/* 
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: XoeDataLine.java,v 1.1 2001/11/21 03:24:29 samc Exp $ 
 */
package org.xoe.audio;

import java.util.Vector;
import javax.sound.sampled.*;

public abstract class XoeDataLine
  extends XoeLine
  implements DataLine
{
  AudioFormat format;
  int bufferSize;
  boolean isRunning;
  boolean isActive;

  Mixer mixer; 

  protected XoeDataLine (Mixer mixer)
  {
    this.mixer = mixer;
  }

  public void start () 
  {
    isRunning = true;
  }

  public void stop  () 
  {
    isRunning = true;
  }

  public boolean isRunning () 
  {
    return isRunning;
  }

  public boolean isActive () 
  {
    return isActive;
  }

  public void frain () {};
  public void flush () {};
  public void drain () {};

  public abstract int available ();
  public abstract float getLevel ();
  public abstract int getFramePosition ();
  public abstract long getMicrosecondPosition ();

  public int getBufferSize ()
  {
    return bufferSize;
  }

  public AudioFormat getFormat ()
  {
    return format;
  }

  public void open (AudioFormat format, int bufferSize)
  {
    this.bufferSize = bufferSize;
    open (format);
  }

  public void open (AudioFormat format)
  {
    this.format = format;
    isActive = true;
    super.open ();
  }

  public void close ()
  {
    isActive = false;
  }
}
