/* 
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: XoeLine.java,v 1.2 2001/12/14 19:48:02 ben Exp $ 
 */
package org.xoe.audio;

import java.util.Vector;
import javax.sound.sampled.Line;
import javax.sound.sampled.AudioSystem;
import javax.sound.sampled.LineEvent;
import javax.sound.sampled.LineListener;
import javax.sound.sampled.Control;

public class XoeLine
  implements Line
{
  Vector listeners = new Vector ();
  static boolean isOpen;
  static final Line.Info XOE_LINE      = new Line.Info (XoeLine.class);
  static final Control[] EMPTY_CONTROL = new Control[0];
  static final XoeControl[] XOE_CONTROLS = new XoeControl[1];


  public Control[] getControls () 
  {
    XOE_CONTROLS[0] = new XoeControl ();
    //return EMPTY_CONTROL;
    return XOE_CONTROLS;
  }

  public boolean isControlSupported (Control.Type control) 
  {

    if (control == XoeControl.Type.VOLUME)
      {
	return true;
      }
    else
      {
	return false;
      }
  }

  public Control getControl (Control.Type control) 
  {
    if (control == XoeControl.Type.VOLUME)
      {
	return XOE_CONTROLS[0];
      }
    else
      {
	return null;
      }
  }

  public void open () 
  {
    isOpen = true;
  }

  public void close () 
  {
    isOpen = false;
  }

  public boolean isOpen () 
  {
    return isOpen;
  }

  public Line.Info getLineInfo () 
  { 
    return XOE_LINE; 
  }

  public synchronized void addLineListener (LineListener sl)
  {
    listeners.addElement (sl);
    sl.update (new LineEvent (this, LineEvent.Type.OPEN, AudioSystem.NOT_SPECIFIED)); 
  }

  public synchronized void removeLineListener (LineListener sl)
  {
    listeners.removeElement (sl);
    sl.update (new LineEvent (this, LineEvent.Type.CLOSE, AudioSystem.NOT_SPECIFIED));
  }
}
