/* 
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: XoeMixer.java,v 1.1 2001/11/21 01:25:49 samc Exp $ 
 */
package org.xoe.audio;

import javax.sound.sampled.Mixer;
import javax.sound.sampled.Line;
import javax.sound.sampled.LineUnavailableException;

public class XoeMixer
  extends XoeLine
  implements Mixer
{
  public static class Info
    extends Mixer.Info
  {
    public static final Info XOE_MIXER = new Info ("xoe mixer", 
                                                   "Transvirtual Technologies, Inc.",
                                                   "mixer based on xoe services",
                                                   "$Revision: 1.1 $");

    Info (String name, String vendor, String desc, String version)
    {
      super (name, vendor, desc, version);
    }
  }

  private Line[] sources;
  private Line[] targets;

  //--------------------------------------------------
  // javax.sound.sampled.Line
  
  public void open  () {}
  public void close () {}
  public Line.Info getLineInfo () { return null; }

  //--------------------------------------------------
  // javax.sound.sampled.Mixer
  
  public Mixer.Info getMixerInfo () 
  { 
    return Info.XOE_MIXER; 
  }

  public Line.Info[] getSourceLineInfo ()
  {
    return new Line.Info[0];
  }

  public Line.Info[] getTargetLineInfo ()
  {
    return new Line.Info[0];
  }

  public Line.Info[] getSourceLineInfo (Line.Info info)
  {
    return new Line.Info[0];
  }

  public Line.Info[] getTargetLineInfo (Line.Info info)
  {
    return new Line.Info[0];
  }

  public boolean isLineSupported (Line.Info info)
  {
    return false;
  }

  public Line getLine (Line.Info info) 
    throws LineUnavailableException
  {
    throw new LineUnavailableException ("not implemented");
  }

  public int getMaxLines (Line.Info info)
  {
    return 1;
  }

  public Line[] getSourceLines ()
  {
    return sources;
  }    

  public Line[] getTargetLines ()
  {
    return targets;
  }    

  public void synchronize (Line[] lines, boolean maintainSync)
  {
    throw new IllegalArgumentException ("Synchronization not Supported");
  }

  public void unsynchronize (Line[] lines)
  {
    throw new IllegalArgumentException ("Synchronization not Supported");
  }

  public boolean isSynchronizationSupported (Line[] lines, boolean maintainSync)
  {
    return false;
  }
}
