/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: OggCodec.java,v 1.4 2001/11/17 02:24:09 samc Exp $
 */ 
package org.xoe.audio.codec;

import org.xoe.audio.Codec;

import java.io.InputStream;
import java.io.IOException;
import javax.sound.sampled.AudioFormat;

public class OggCodec
  extends Codec 
{
  // ---------------------------------------------------------------------
  // IService

  public String[] getInterfaces (String func) { return INTERFACES; }
  public String[] getFeatures (String func)   { return null;       }
  public String[] getFunctionalities ()       { return null;       }
  public String[] getInformation ()           { return null;       }
  public void init (org.w3c.dom.Document configDoc) {}

  static String[] iform = new String[] { "audio/x-ogg" };

  private Object internal;
  private byte[] rawdata = new byte[1024];

  public static class OggEncoding
    extends AudioFormat.Encoding
  {
    public static AudioFormat.Encoding OGG = new OggEncoding ("OGG");
    OggEncoding (String name)
    {
      super (name);
    }
  }

  static 
  {
    init0 ();
  }

  public OggCodec () 
  {
  }

  public void openCodec () 
  {
    internal = openCodec0();
  }

  public int readCodec (byte[] buf, int offset, int length) 
  {
    return (readCodec0 (buf, offset, length, internal));
  }

  public void closeCodec () 
  {
    closeCodec0 (internal);
    internal = null;
  }

  public AudioFormat.Encoding[] getInputFormats () 
  {
    return new AudioFormat.Encoding[] { OggEncoding.OGG };
  }

  public AudioFormat.Encoding[] getOutputFormats () 
  {
    return new AudioFormat.Encoding[] { AudioFormat.Encoding.PCM_UNSIGNED };
  }

  private int readDownstream(int len) throws IOException 
  {
    if (len > rawdata.length) 
      {
        rawdata = new byte[len];
      }
    return in.read (rawdata);
  }

  private static native void init0 ();
  private native Object openCodec0 ();
  private native int readCodec0 (byte[] buf, int offset, int length, Object internal);
  private native void closeCodec0 (Object internal);
}
