/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: UlawCodec.java,v 1.5 2001/11/21 01:25:49 samc Exp $
 */ 
package org.xoe.audio.codec;

import org.xoe.audio.Codec;
import org.xoe.audio.ICodec;
import org.xoe.audio.CodecListener;

import java.io.InputStream;
import java.io.IOException;
import javax.sound.sampled.AudioFormat;

public class UlawCodec
  extends Codec 
{
  // ---------------------------------------------------------------------
  // IService

  public String[] getInterfaces (String func) { return INTERFACES; }
  public String[] getFeatures (String func)   { return null;       }
  public String[] getFunctionalities ()       { return null;       }
  public String[] getInformation ()           { return null;       }
  public void init (org.w3c.dom.Document configDoc) {}

  static String[] iform = new String[] { "audio/x-au", "audio/basic" };
  static String[] oform = new String[] { "audio/x-pcm" };

  private byte[] rawdata = new byte[16384];
  private int rawlen;

  static private int[] ulawdsp = new int[] {
     3,    7,   11,   15,   19,   23,   27,   31,
    35,   39,   43,   47,   51,   55,   59,   63,
    66,   68,   70,   72,   74,   76,   78,   80,
    82,   84,   86,   88,   90,   92,   94,   96,
    98,   99,  100,  101,  102,  103,  104,  105,
   106,  107,  108,  109,  110,  111,  112,  113,
   113,  114,  114,  115,  115,  116,  116,  117,
   117,  118,  118,  119,  119,  120,  120,  121,
   121,  121,  122,  122,  122,  122,  123,  123,
   123,  123,  124,  124,  124,  124,  125,  125,
   125,  125,  125,  125,  126,  126,  126,  126,
   126,  126,  126,  126,  127,  127,  127,  127,
   127,  127,  127,  127,  127,  127,  127,  127,
   128,  128,  128,  128,  128,  128,  128,  128,
   128,  128,  128,  128,  128,  128,  128,  128,
   128,  128,  128,  128,  128,  128,  128,  128,
   253,  249,  245,  241,  237,  233,  229,  225,
   221,  217,  213,  209,  205,  201,  197,  193,
   190,  188,  186,  184,  182,  180,  178,  176,
   174,  172,  170,  168,  166,  164,  162,  160,
   158,  157,  156,  155,  154,  153,  152,  151,
   150,  149,  148,  147,  146,  145,  144,  143,
   143,  142,  142,  141,  141,  140,  140,  139,
   139,  138,  138,  137,  137,  136,  136,  135,
   135,  135,  134,  134,  134,  134,  133,  133,
   133,  133,  132,  132,  132,  132,  131,  131,
   131,  131,  131,  131,  130,  130,  130,  130,
   130,  130,  130,  130,  129,  129,  129,  129,
   129,  129,  129,  129,  129,  129,  129,  129,
   128,  128,  128,  128,  128,  128,  128,  128,
   128,  128,  128,  128,  128,  128,  128,  128,
   128,  128,  128,  128,  128,  128,  128,  128,
  };

  public UlawCodec () {}

  // ---------------------------------------------------------------------
  // ICodec

  public void openCodec () {}

  public int readCodec (byte[] buf, int offset, int length) throws IOException 
  {
    int r = in.read (buf, offset, length);
    if (r > 0) 
      {
        int len = offset + r;
        for (int i = offset; i < len; i++) 
          {
            buf[i] = (byte)ulawdsp[buf[i] & 0xFF];
          }
      }
    return (r);
  }

  public void closeCodec () {}

  public AudioFormat.Encoding[] getInputFormats () 
  {
    return new AudioFormat.Encoding[] { AudioFormat.Encoding.ULAW };
  }

  public AudioFormat.Encoding[] getOutputFormats () 
  {
    return new AudioFormat.Encoding[] { AudioFormat.Encoding.PCM_UNSIGNED };
  }

  /**
   * As soon as we add a codec listener we inform it that this is a mono
   * codec only.
   */
  public synchronized void addCodecListener (CodecListener listener) 
  {
    super.addCodecListener (listener);
  }
}
