/* 
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "license.terms" for details.
 *
 * $tvt: euc.c,v 1.1 2001/11/22 04:00:08 samc Exp $ 
 */
#include <jni.h>
#include <string.h>
#include <canna/RK.h>

#include "euc.h"

int
euc2ushort (char *src, int srclen, Ushort *dest, int destlen)
{
  register int i, j;
  register unsigned ec;

  for (i = 0, j = 0 ; i < srclen && j + 1 < destlen ; i++)
    {
      ec = (unsigned)(unsigned char)src[i];
      if (ec & 0x80) 
        {
          switch (ec) 
            {
            case 0x8e: /* SS2 */
              dest[j++] = (Ushort)(0x80 | ((unsigned)src[++i] & 0x7f));
              break;
            case 0x8f: /* SS3 */
              dest[j++] = (Ushort)(0x8000
                  | (((unsigned)src[i + 1] & 0x7f) << 8)
                  | ((unsigned)src[i + 2] & 0x7f));
              i += 2;
              break;
            default:
              dest[j++] = (Ushort)(0x8080 | (((unsigned)src[i] & 0x7f) << 8)
                  | ((unsigned)src[i + 1] & 0x7f));
              i++;
              break;
            }
        }
      else
        {
          dest[j++] = (Ushort)ec;
        }
    }
  dest[j] = (wchar_t)0;
  return j;
}

int
ushortstrlen (Ushort *ws)
{            
  register Ushort *p = ws;
  while (*p) { p++; }
  return p - ws;
} 

int
ushort2euc(Ushort *src, int srclen, char *dest, int destlen)
{
  register int i, j;
  register Ushort wc;

  for (i = 0, j = 0 ; i < srclen && j + 2 < destlen ; i++)
    {
      wc = src[i];
      switch (wc & 0x8080)
        {
        case 0:
          /* ASCII */
          dest[j++] = (unsigned char)((unsigned)wc & 0x7f);
          break;
        case 0x0080:
          /*  */
          dest[j++] = (char)0x8e; /* SS2 */
          dest[j++] = (unsigned char)(((unsigned)wc & 0x7f) | 0x80);
          break;
        case 0x8000:
          /*  */
          dest[j++] = (char)0x8f; /* SS3 */
          dest[j++] = (unsigned char)((((unsigned)wc & 0x7f00) >> 8) | 0x80);
          dest[j++] = (unsigned char)(((unsigned)wc & 0x7f) | 0x80);
          break;
        case 0x8080:
          /*  */
          dest[j++] = (unsigned char)((((unsigned)wc & 0x7f00) >> 8) | 0x80);
          dest[j++] = (unsigned char)(((unsigned)wc & 0x7f) | 0x80);
          break;
        }
    }
  dest[j] = (unsigned char)0;
  return j;
}

