#include "libsslio.h"

#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

void throwSSLException(JNIEnv* env, char* msg)
{
  jclass clazz = (*env)->FindClass(env, "com/transvirtual/protocol/ssl/SslException");
  (*env)->ThrowNew(env, clazz, msg);
}

void throwSSLRuntimeException(JNIEnv* env, char* msg)
{
  jclass clazz = (*env)->FindClass(env, "com/transvirtual/protocol/ssl/SslRuntimeException");

  (*env)->ThrowNew(env, clazz, msg);
}

jstring ASN1_TIME_to_jstring(JNIEnv* env, ASN1_TIME *a)
{
  BIO *bio;
  char *buffer;
  jstring ret;

  if(NULL == (bio = BIO_new(BIO_s_mem())))
    {
    }
  else if(!ASN1_TIME_print(bio, a))
    {
    }
  else if(!BIO_write(bio, "\0", 1))
    {
    }
  else if(!BIO_get_mem_data(bio, &buffer))
    {
    }
  else
    {
      ret = (*env)->NewStringUTF(env, buffer);
    }

  if(ret == NULL && !(*env)->ExceptionOccurred(env))
    {
      throwSSLRuntimeException(env, "failure in ASN1_TIME_to_jstring");
    }

  if(bio != NULL)
    {
      BIO_free(bio);
    }

  return ret;
}

char *BIO_get_mem_string(BIO *bio, char *buffer, int blen)
{
  char *temp;
  int slen;

  if(!(slen = BIO_get_mem_data(bio, &temp)))
    {
      return NULL;
    }
  else
    {
      strncpy (buffer, temp, slen < blen ? slen : blen);
      buffer[slen < blen ? slen : blen - 1] = 0;
    }
  
  return buffer;
}
