package com.transvirtual.protocol.https;

import java.io.IOException;
import java.util.Vector;

public class HostNameMismatchException
  extends IOException
{
  private static String buildMsg (String host, Vector patterns)
  {
    if (patterns.size () == 1)
      {
	return "While contacting HTTPS host '" + host + "' received a "
	  + "certificate valid for the host '" + patterns.elementAt (0) + "'.";
      }

    StringBuffer msg = new StringBuffer ("While contacting HTTPS host '" + host +
					 "' received a certificate valid for the hosts:\n");
    for (int i = 0; i < patterns.size (); i ++)
      {
	msg.append (patterns.elementAt (i));
	if (i + 1 != patterns.size ())
	  {
	    msg.append ("\n");
	  }
      }

    return msg.toString ();
  }

  public HostNameMismatchException (String host, Vector patterns)
  {
    super (buildMsg (host, patterns));
  }

  public HostNameMismatchException (String host, String pattern)
  {
    super ("While contacting HTTPS host '" + host + "' received a "
	   + "certificate valid for the host '" + pattern + "'.");
  }
}
