package com.transvirtual.protocol.ssl;

import kaffe.util.Ptr;

public class X509CertificateChain
{
  private Ptr m_internal = null;
  private int m_size = 0;
  private X509Certificate[] m_certs = null;

  public String toString()
  {
    return "{ X509CertificateChain[" + m_size + "] " + super.toString() + " }";
  }

  protected void finalize()
  {
    freeCertChain0(m_internal);
  }

  protected X509CertificateChain(Ptr internal, int size)
  {
    m_internal = internal;
    m_size = size;
    m_certs = new X509Certificate[m_size];
  }

  public X509Certificate item(int i)
  {
    if(i >= m_size)
      {
	throw new ArrayIndexOutOfBoundsException();
      }
    if(m_certs[i] == null)
      {
	m_certs[i] = item0(m_internal, i);
      }

    return m_certs[i];
  }

  public int length()
  {
    return m_size;
  }

  private native X509Certificate item0(Ptr internal, int i);
  private native void freeCertChain0(Ptr internal);
}
