package com.transvirtual.protocol.ssl;

import kaffe.util.Ptr;

public class X509Extension
{
  // The internal X509_EXTENSION object
  private Ptr m_internal = null;

  // A pointer to the cert is used to make sure the cert is not released
  // before the extension is. This allows us to avoid actually copying the
  // underlying extension data structure.
  private X509Certificate m_cert = null;

  protected X509Extension (X509Certificate cert, Ptr internal)
  {
    m_cert = cert;
    m_internal = internal;
  }

  public boolean isCritical ()
  {
    return isCritical0 (m_internal);
  }

  public int getID ()
  {
    return getID0 (m_internal);
  }

  public String getShortName ()
  {
    return id2SN (getID ());
  }

  public String getLongName ()
  {
    return id2LN (getID ());
  }

  public static String getShortName (int id)
  {
    return id2SN (id);
  }

  public static String getLongName (int id)
  {
    return id2LN (id);
  }

  public String toString ()
  {
    return toString0 (m_internal);
  }

  private static native String id2SN (int id);
  private static native String id2LN (int id);
  private native int getID0 (Ptr internal);
  private native boolean isCritical0 (Ptr internal);
  private native String toString0 (Ptr internal);
}
