/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: MP3Codec.java,v 1.7 2001/11/17 02:24:19 samc Exp $
 */ 
package org.xoe.audio.codec;

import java.io.InputStream;
import java.io.IOException;
import javax.sound.sampled.AudioFormat;

import org.xoe.audio.Codec;
import org.xoe.core.util.Logger;

public class MP3Codec
  extends Codec 
{
  // ---------------------------------------------------------------------
  // IService

  public String[] getInterfaces (String func) { return INTERFACES; }
  public String[] getFeatures (String func)   { return null;       }
  public String[] getFunctionalities ()       { return null;       }
  public String[] getInformation ()           { return null;       }
  public void init (org.w3c.dom.Document configDoc) {}

  private Object internal;
  private byte[] rawdata = new byte[16384];
  private int rawlen;

  public MP3Codec () {}

  public void openCodec ()
  {
    openCodec (new AudioFormat (44100, 16, 2, false, false));
  }

  public void openCodec (AudioFormat format) 
  {
    internal = openCodec0 ((int) format.getSampleRate (), format.getChannels ());
  }

  public int readCodec (byte[] buf, int offset, int length) throws IOException 
  {
    int len = decodeCodec0 (buf, offset, length, internal, null, 0);
    if (len <= 0) 
      {
        /* codec needs more data */
        int rawlen;
        for (rawlen = 0; rawlen < rawdata.length; rawlen++)
          {
            int data = in.read ();
            if (data == -1) break;
            rawdata[rawlen] = (byte) data;
          }
        if (rawlen > 0) 
          {
            len = decodeCodec0(buf, offset, length, internal, rawdata, rawlen);
          }
      }
    return (len);
  }

  public void closeCodec () 
  {
    closeCodec0 (internal);
    internal = null;
  }

  public AudioFormat.Encoding[] getInputFormats () 
  {
    return new AudioFormat.Encoding[] {};
  }

  public AudioFormat.Encoding[] getOutputFormats () 
  {
    return new AudioFormat.Encoding[] {};
  }

  private void callbackstr (String name, String value) 
  {
    codecEvent (name, value);
  }

  private void callbackint (String name, int value) 
  {
    codecEvent (name, new Integer (value));
  }

  private native Object openCodec0    (int freq, int channels);
  private native int decodeCodec0  (byte[] out, int offset, int length, Object internal, byte[] in, int inlength);
  private native void closeCodec0  (Object internal);
}
