package org.xoe.mime;


import java.io.InputStream;
import java.io.ByteArrayInputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.Reader;
import java.io.IOException;


/**
 * BodyPart class 
 *
 */
public class BodyPart extends Entity
{
  Multipart parent = null;

  public BodyPart()
  {
  }

  /**
    * Creates a BodyPart object from a string
    *
    */
  public BodyPart( String bodyString ) throws IOException
  {
    InputStream istream = (InputStream)new ByteArrayInputStream( bodyString.getBytes() );
    BufferedReader buffReader =  new BufferedReader( (Reader)new InputStreamReader( istream ) ); 
    buffReader = this.parseHeader( buffReader );


    int bodLength = new Integer( this.getHeader( "Content-Length" ) ).intValue();
    System.err.println( "BodyPart(): body length = [" + bodLength  + "]" );
    char[] bod = new char[ bodLength ];	    
    int bodRead = buffReader.read( bod, 0, bodLength );
    System.err.println( "BodyPart(): body read = [" + bodRead  + "]" );	 
    /*   
    while( bodRead < bodLength )
      {
	System.err.println( "BodyPart(): reading from index [" + bodRead + "] length [" + (bodLength-bodRead) + "]" );
	bodRead += buffReader.read( bod, bodRead, bodLength - bodRead );
	System.err.println( "BodyPart(): body read = [" + bodRead  + "]" ); 
      }
    */
    this.setBody( new String( bod ) );
      
  }

  /**
    * @returns Multipart the parent owner of this BodyPart
    */
  public Multipart getParent ()
  {
    return parent;
  }

  /**
    * @param Multipart the parent owner of this BodyPart
    */
  public void setParent (Multipart parent)
  {
    this.parent = parent;
  }

}
