package org.xoe.packagemanager;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.Hashtable;
import java.util.Vector;
import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import org.xoe.core.Constants;
import org.xoe.core.content.DocumentCache;
import org.xoe.core.content.Stash;
import org.xoe.core.dom.Callback;
import org.xoe.core.dom.DOMlet;
import org.xoe.core.dom.XDocument;
import org.xoe.core.packages.InstallOption;
import org.xoe.core.packages.PackageDescription;
import org.xoe.core.packages.PackageManager;
import org.xoe.core.packages.PackageQuery;
import org.xoe.core.packages.SearchResults;
import org.xoe.core.util.Logger;
import org.xoe.core.util.DOMUtils;
import org.xoe.core.util.XMLWriter;

import org.xoe.display.dom.DocumentViewer;
import org.xoe.display.dom.ViewElement;
import org.xoe.display.dom.xhtml.Select;
import org.xoe.servlet.XoeServlet;

public class MessageBox
{
  private XDocument m_doc = null;
  private DocumentViewer m_viewer = null;
  private URL m_wd = Stash.getWorkingDirectory (InstalledPackageDetail.class);


  public MessageBox (DocumentViewer viewer, String msg, String[] buttons, Callback cb)
  {
    this (viewer, null, msg, buttons, cb);
  }

  public MessageBox (DocumentViewer viewer, String title, String msg, String[] buttons, Callback cb)
  {
    m_viewer = viewer;
    try
      {
	m_doc = DocumentCache.fetchDocument ( new URL (m_wd, "message.xhtml") );
      }
    catch (MalformedURLException ex)
      {
	Logger.log (this, ex);
      }

    Element sumEl = m_doc.getElementById ("summary");
    
    DOMUtils.setTextContent (sumEl, title == null ? "" : title);

    Element msgEl = m_doc.getElementById ("message");
    
    DOMUtils.setTextContent (msgEl, msg);

    NodeList nl = DOMUtils.getElementsById (m_doc, "btn");
    for (int i = 0; i < nl.getLength () - buttons.length; i++)
      {
	Node btn = nl.item (i);
	btn.getParentNode ().removeChild (btn);
      }

    nl = DOMUtils.getElementsById (m_doc, "btn");
    for (int i = 0; i < buttons.length; i++)
      {
	Element btn = (Element)nl.item (i);
	btn.setAttribute ("name", buttons [i]);
	btn.setAttribute ("onclick", buttons [i]);
      }

    m_doc.setCallback ("onclick", cb);
  }

  public XDocument getDocument ()
  {
    return m_doc;
  }
}
