package org.xoe.packagemanager;

import java.net.MalformedURLException;
import java.net.URL;
import java.util.Hashtable;
import java.util.Vector;
import javax.servlet.http.HttpServletRequest;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.w3c.dom.Text;

import org.xoe.core.Constants;
import org.xoe.core.content.DocumentCache;
import org.xoe.core.content.Stash;
import org.xoe.core.dom.Callback;
import org.xoe.core.dom.DOMlet;
import org.xoe.core.dom.XDocument;
import org.xoe.core.packages.InstallOption;
import org.xoe.core.packages.PackageDescription;
import org.xoe.core.packages.PackageManager;
import org.xoe.core.packages.PackageQuery;
import org.xoe.core.packages.SearchResults;
import org.xoe.core.packages.UninstallablePackage;
import org.xoe.core.util.Logger;
import org.xoe.core.util.DOMUtils;
import org.xoe.core.util.XMLWriter;

import org.xoe.display.dom.DocumentViewer;
import org.xoe.display.dom.ViewElement;
import org.xoe.display.dom.xhtml.Select;
import org.xoe.servlet.XoeServlet;

public class UnavailablePackages
{
  private XDocument m_doc = null;
  private DocumentViewer m_viewer = null;
  private URL m_wd = Stash.getWorkingDirectory (InstalledPackageDetail.class);
  private UninstallablePackage[] m_pkgs = null;
  private SearchResults m_results = null;

  public UnavailablePackages (DocumentViewer viewer, UninstallablePackage[] pkgs)
  {
    m_viewer = viewer;
    try
      {
	m_doc = DocumentCache.fetchDocument ( new URL (m_wd, "unavailable.xhtml") );
      }
    catch (MalformedURLException ex)
      {
	Logger.log (this, ex);
      }

    Element details = m_doc.getElementById ( "details");
    Element name = m_doc.getElementById ( "name");
    Element reason = m_doc.getElementById ( "reason");
    Node parent = details.getParentNode ();
    parent.removeChild (details);
    m_pkgs = pkgs;
    for (int i = 0; i < m_pkgs.length; i++)
      {
	DOMUtils.setTextContent ( name, m_pkgs [i].getTargetPackage ().getPackageURI () );
	DOMUtils.setTextContent ( reason, m_pkgs [i].getReasonString ());
	parent.appendChild (details.cloneNode (true));
      }

    Logger.log (this, XMLWriter.getXML (m_doc));
  }

  public XDocument getDocument ()
  {
    return m_doc;
  }
}
