/* 
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: PackageQueryResponseCache.java,v 1.3 2001/10/26 02:48:26 erik Exp $ 
 */
package org.xoe.packages;

import java.util.Hashtable;

import java.lang.ref.SoftReference;
import java.util.Hashtable;

import org.xoe.core.packages.IPackageQuery;

class PackageQueryResponseCache
{
  private Hashtable m_hash = new Hashtable();

  public PackageQueryResponse get(IPackageQuery q)
  {
    SoftReference ref = (SoftReference)m_hash.get(q.toXPath());
    if(ref != null)
      {
	PackageQueryResponse resp = (PackageQueryResponse)ref.get();
	if(resp != null && !resp.isExpired())
	  {
	    return resp;
	  }
	else
	  {
	    m_hash.remove(q.toXPath());
	  }
      }
    return null;
  }

  public void put(IPackageQuery q, PackageQueryResponse resp)
  {
    m_hash.put(q.toXPath(), new SoftReference(resp));
  }

}
