/* 
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: SoapPackageServerFactory.java,v 1.4 2001/10/26 02:48:26 erik Exp $ 
 */
package org.xoe.packages;

import org.w3c.dom.Document;

import org.xoe.core.packages.IPackageServerFactory;
import org.xoe.core.packages.IPackageQueryHandler;

public class SoapPackageServerFactory implements IPackageServerFactory
{
  public static final String SOAP_SERVER_TYPE = "SOAP";

  public void init (Document configDoc)
  { // No configuration necessary
  }

  public String[] getFunctionalities()
  {
    return new String[] {IPackageServerFactory.FUNCTIONALITY};
  }

  public String[] getInterfaces(String func)
  {
    if(func.equals(IPackageServerFactory.FUNCTIONALITY))
    {
      return new String[] {IPackageServerFactory.INTERFACE};
    }
    return new String[0];
  }

  public String[] getFeatures(String func)
  {
    if(func.equals(IPackageServerFactory.FUNCTIONALITY))
    {
      return new String[] {IPackageServerFactory.TYPE_FEATURE, this.SOAP_SERVER_TYPE};
    }
    return new String[0];
  }

  public String[] getInformation()
  {
    return new String[0];
  }

  public IPackageQueryHandler getServer(String type, String url)
  {
    return new SoapPackageServer(url);
  }
}
