/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: pdf.java,v 1.7 2001/10/31 21:19:25 samc Exp $
 */ 
package org.xoe.content.application;

import org.xoe.core.content.ContentCache;
import org.xoe.core.content.ContentElement;
import org.xoe.core.content.ContentType;
import org.xoe.core.dom.XDocument;
import org.xoe.core.services.ServiceLocator;

import java.io.IOException;
import java.net.URLEncoder;

import org.w3c.dom.Document;

import org.xoe.display.dom.IViewableDocumentBuilder;
import org.xoe.services.IWebBrowser;

public class pdf 
  implements IViewableDocumentBuilder
{
  public static final String EXTENSION_PDF = "pdf";
  public static final String MIMETYPE_APPLICATION_PDF = "application/pdf";

  private static final String CONVERT_STRING = 
    "http://access.adobe.com/perl/convertPDF.pl?url=";

  public void init (Document configDoc)
  { // No configuration necessary
  }

  public String[] getFunctionalities ()
  {
    return new String [] { FUNCTION_CONTENT_HANDLER };
  }

  public String[] getInterfaces (String func)
  {
    if (func.equals (FUNCTION_CONTENT_HANDLER))
      {
        return new String [] { IViewableDocumentBuilder.INTERFACE };
      }

    return null;
  }

  public String[] getFeatures (String func)
  {
    if (func.equals (FUNCTION_CONTENT_HANDLER))
      {
        return new String[] { FEATURE_MIMETYPE, MIMETYPE_APPLICATION_PDF,
			      FEATURE_EXTENSION, EXTENSION_PDF };
      }

    return null;
  }

  public String[] getInformation ()
  {
    return null;
  }

  public XDocument getViewableDocument (ContentElement content)
    throws IOException
  {
    IWebBrowser browser = (IWebBrowser) ServiceLocator.findImplementor (IWebBrowser.INTERFACE);
    return browser.getWebPage (CONVERT_STRING + 
	    URLEncoder.encode (content.getURL ().toExternalForm ()));
  }
}
