package org.xoe.plugins.mplayer;

import java.io.FileOutputStream;
import java.io.File;
import java.util.zip.ZipInputStream;
import java.util.zip.ZipOutputStream;
import java.util.zip.ZipEntry;

import org.xoe.core.packages.InstallScript;
import org.xoe.core.packages.XoePackage;
import org.xoe.core.packages.XoeClassLoader;

import org.xoe.core.services.ServiceLocator;                                                                 

public class ExecInstaller
  implements InstallScript
{
   public static boolean postinstall = false;
   public static boolean preuninstall = false;

   static final String execPath = "/tmp";
   
   private void makeExecutable( String pathName)
     {
	try 
	  {
	     String[] args = { "chmod", "a+x", pathName};
	     Runtime.getRuntime().exec( args);
	  }
	catch ( Exception _)
	  {
	  }
	
     }

   private void installExec( XoePackage pkg, String inName, String outName, boolean exec) 
     {
	String outPath = execPath + "/" + outName;
	
	try
	  {
	     ZipInputStream zi = pkg.getZipInputStream();
	     for ( ZipEntry ze = zi.getNextEntry(); ze != null; ze = zi.getNextEntry() )
	       {
   		  String zName = ze.getName();

		  if ( inName.equals( zName ))
		    {
		       int bLen = 4096;
		       byte[] buf = new byte[bLen];
		       
		       FileOutputStream fo = new FileOutputStream( outPath);
		       for ( int br = zi.read( buf, 0, bLen); br > -1; br = zi.read( buf, 0, bLen) ) 
			 {
			    fo.write( buf, 0, br); 
			 }

		       fo.close();
		       
		       System.err.println( "installed netscape plugin: " + outPath);
		       
		       break;
		    }
	       }
	     zi.close();
	     
	     if ( exec )
	       {
		  makeExecutable( outPath);
	       }
	     
	  }
	catch ( Exception _ ) 
	  {
	  }
     }
   
   private void uninstallExec( String name)
     {
	File fExec = new File( execPath, name);
	fExec.delete();
	
     }
   
   public void postInstall()
     {	
	XoePackage pkg = ((XoeClassLoader)this.getClass().getClassLoader()).getPackage();

	installExec( pkg, "mplayer", "mplayer", true); 
	installExec( pkg, "libmplayer.sox", "libmplayer.so", true);
	installExec( pkg, "resources/codecs.conf", "codecs.conf", false);

	postinstall = true;
     }
   
   public void preUninstall()
     {
	uninstallExec( "mplayer");
	uninstallExec( "libmplayer.so");
	uninstallExec( "codecs.conf");
	
	preuninstall = true;
     }
   
}
