/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: IntegerSoapParameter.java,v 1.6 2001/11/16 21:04:59 ben Exp $
 */ 
package org.xoe.soap;

import org.w3c.dom.Element;

import org.xoe.core.util.DOMUtils;


public class IntegerSoapParameter 
  implements SoapParameter
{
  Integer paramObj;
  private static final String TYPE_INT = "xsd:int";

  public void setParameter (Object obj)
  {
    paramObj = (Integer) obj;
  }

  public void generate (SoapDocument soapDocument)
  {
    Element c1 = soapDocument.createElementNS (null, soapDocument.generateParamName());
    c1.setAttribute ("xsi:type", TYPE_INT);
    if (soapDocument.getMethodElementEncodingStyle () != null)
      {
	c1.setAttribute (SoapConstants.ATTRIBUTE_PREFIX + SoapConstants.COLON + SoapConstants.ENCODING_STYLE, 
                         SoapConstants.STANDARD_ENCODING_STYLE_URL);
      }
    DOMUtils.setTextContent (c1, paramObj.intValue () + "");
    soapDocument.getCurrentMethodElement ().appendChild (c1);
  }
}
