/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: SoapParameter.java,v 1.3 2001/12/06 00:01:51 ben Exp $
 */ 
package org.xoe.soap;


/**
 * The SoapParameter interface represents a parameter object that is passed to a remote method 
 * accessible by a SOAP Server.  The formatting required to handle specific objects 
 * are handled by the implementor of this interface.
 *
 */
public interface SoapParameter
{

  /**
   * Sets the parameter object
   *
   */
  public void setParameter( Object obj );


  /**
   * Generates the parameter xml inside the given SoapDocument
   *
   */
  public void generate( SoapDocument soapDocument );
}
