/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: StringSoapParameter.java,v 1.5 2001/11/16 21:04:59 ben Exp $
 */ 
package org.xoe.soap;

import org.w3c.dom.Element;

import org.xoe.core.util.DOMUtils;


public class StringSoapParameter 
  implements SoapParameter
{
  private String paramObj;
  private static final String TYPE_STRING = "xsd:string";
  
  public void setParameter (Object obj)
  {
    paramObj = (String)obj;
  }

  public void generate (SoapDocument soapDocument)
  {
    Element c1 = soapDocument.createElementNS (null, soapDocument.generateParamName());
    c1.setAttribute ("xsi:type", TYPE_STRING);
    if (soapDocument.getMethodElementEncodingStyle () != SoapConstants.STANDARD_ENCODING_STYLE_URL)
      {
	c1.setAttribute (SoapConstants.ATTRIBUTE_PREFIX + SoapConstants.COLON + SoapConstants.ENCODING_STYLE , 
			 SoapConstants.STANDARD_ENCODING_STYLE_URL);
      }
    
    DOMUtils.setTextContent (c1, paramObj);
    soapDocument.getCurrentMethodElement().appendChild (c1);    
  }
}
