/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: VectorSoapParameter.java,v 1.8 2001/11/16 21:04:59 ben Exp $
 */ 
package org.xoe.soap;

import java.util.Vector;
import java.io.FileInputStream;
import org.w3c.dom.Element;

import org.xoe.core.content.ContentElement;
import org.xoe.core.util.DOMUtils;
import org.xoe.mime.Util;


public class VectorSoapParameter 
  implements SoapParameter
{
  Vector paramObj;
  private static final String TYPE_VECTOR = "xsv:Vector";

  public void setParameter (Object obj)
  {
    paramObj = (Vector) obj;
  }

  public void generate (SoapDocument soapDocument)
  {
    Element c1 = soapDocument.createElementNS (null, soapDocument.generateParamName());
    c1.setAttribute ("xsi:type", TYPE_VECTOR);
    c1.setAttribute ("xmlns:xsv", "http://xml.apache.org/xml-soap");

    if (soapDocument.getMethodElementEncodingStyle () != SoapConstants.STANDARD_ENCODING_STYLE_URL)
      {
	c1.setAttribute (SoapConstants.ATTRIBUTE_PREFIX + SoapConstants.COLON + SoapConstants.ENCODING_STYLE,  
                         SoapConstants.STANDARD_ENCODING_STYLE_URL);
      }

    for (int i = 0; i < paramObj.size (); i++)
      {
	Object obj = paramObj.elementAt (i);
    
	if (obj instanceof ContentElement)
	  {	   
	    Element item = soapDocument.createElementNS (null, "item");	
	    String attachmentID = Util.generateCID ();
	    item.setAttribute ("href", "cid:" + attachmentID); //another bit of soap voodoo!
	    soapDocument.getMimeAttachments ().put (attachmentID, obj);
	    soapDocument.getMimeKeys ().push (attachmentID);	    
	    c1.appendChild (item);	    
	  }
	else if (obj instanceof String)
	  {
	    Element item = soapDocument.createElementNS (null, "item");
	    item.setAttribute ("xsi:type", "xsd:string");
	    DOMUtils.setTextContent (item, (String) obj);
	    c1.appendChild (item);
	  }
	else
	  {
	    //throw an exception???
	  }

      }
    soapDocument.getCurrentMethodElement().appendChild( c1 );

  }

}
