/* 
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  All rights reserved.
 * See the file "COPYING" for details.
 *
 * $tvt: Main.java,v 1.6 2001/10/23 00:20:45 samc Exp $ 
 */
package org.xoe.calculator;

import java.io.IOException;
import java.util.Hashtable;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.xoe.core.dom.XDocument;
import org.xoe.core.services.IService;
import org.xoe.core.services.ServiceFactory;
import org.xoe.core.xpath.XPath;

import org.xoe.servlet.XoeServlet;
import org.xoe.servlet.XoeServletRequest;
import org.xoe.servlet.XoeServletResponse;

import org.w3c.dom.Element;


public class Main
  extends XoeServlet
  implements ServiceFactory
{

  private double lastValue; // the result of the last operation
  private double memory;    // the value in memory 
  private char operation = '+'; // the last operation key pressed
  boolean decimal = false;
  String value = "";
  char lastCh;
  Element display;

  protected void doGet (HttpServletRequest req, HttpServletResponse res) 
    throws ServletException, IOException
  {
    res.setContentType ("text/html");
    String path = req.getPathInfo ();
    String displayString = null;
    if ("".equals (path))
      {
	XDocument doc = getRelativeDocument ("index.xhtml");
	display = (Element)XPath.findFirstNode (doc, "//*[@name='display']");
	value = "";
	res.getWriter ().print (doc);
      } 
    else if ("form".equals (path))
      {
	String key = req.getParameter ("key");
	org.xoe.core.util.Logger.log (this, " key = " + key);
	char ch = key.charAt (0);
	switch (ch) 
	  {
	  case '.':
	    if (decimal)
	      {
		break;
	      }
	    decimal = true;
	  case '0':
	  case '1':
	  case '2':
	  case '3':
	  case '4':
	  case '5':
	  case '6':
	  case '7':
	  case '8':
	  case '9':
	    value += key;
	    displayString = value;
	    break;
	  case '=':
	  case '+':
	  case 'X':
	  case '/':
	  case '-':
	    lastValue = compute (value, lastValue, operation);
	    value = "";
	    displayString = toString (lastValue);
	    operation= key.charAt (0);
	    break;
	  case 'C':
	    decimal = false;  
	    if (!key.equals ("CE"))
	      {
		lastValue = 0;
		operation = '+';
	      }
	    displayString = "0";
	    value = "";
	    break;
	  case 'M':
	    if (key.equals ("M+")) 
	      {
		memory = compute (value, memory, '+');
		value = "";
		ch = 'm';
	      }
	    else 
	      {
		if (lastCh == 'M') 
		  {
		    memory = 0;
		    displayString = "0";
		  }
		else 
		  {
		    lastValue = memory;
		    displayString = toString (lastValue);
		  }
	      }
	    decimal = false; 
	    value = "";
	    break;
	  }
	lastCh = ch;
	if (displayString != null)
	  {
	    display.setAttribute("value", displayString);
	  }
      }
  }

  
  double compute (String strVal, double oldValue, char op) 
  {
    double value = 0;
    if (!strVal.equals (""))
      {
	value = Double.valueOf (strVal).doubleValue ();
      }
    switch (op) 
      {
      case '+':
	return oldValue + value;
      case '-':
	return oldValue - value;
      case 'X':
	return oldValue * value;
      case '/':
	return oldValue / value;
      case '=':
	return strVal.equals ("") ? oldValue : value;
      }
    return 0;
  }

  String toString (double d)
  {
    String ret = Double.toString (d);
    if (ret.endsWith (".0"))
      {
	ret = ret.substring (0, ret.length () - 2);
      }
    return ret;
  }

  public IService newInstance () 
  {
    return  new Main ();
  }

}
