/**
 *  
 */
package org.xoe.calendar;

import java.util.Calendar;
import java.util.Date;


public final class CurrentDate 
{
    private static final String daysOfweek[] = new String[] {"","Sunday",
            "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"};

    private static final String monthnames[] = new String[] {
              "&jan;", "&feb;", "&mar;", "&apr;", "&may;", "&jun;",
              "&jul;", "&aug;", "&sep;", "&oct;", "&nov;", "&dec;" };

    protected static Calendar when;

    static
    {
      when = Calendar.getInstance ();
    }

    public static final Calendar getCalendar ()
    {
      return (when);
    }   

    public static final int getYear ()
    {
      return when.get (Calendar.YEAR);
    }

    public static final int getMonth ()
    {
      return when.get (Calendar.MONTH);
    }

    public static final int getDayOfMonth ()
    {
      return when.get (Calendar.DATE);
    }

    public static final int getDayOfWeek ()
    {
      return when.get (Calendar.DAY_OF_WEEK);
    }

    public static final String getDayOfWeekAsString ()
    {
      return daysOfweek[when.get (Calendar.DAY_OF_WEEK)];
    }

    public static final void setCurrentDayOfWeek (int dayOfWeek)
    {
      when.add (Calendar.DATE,  dayOfWeek - when.get (Calendar.DAY_OF_WEEK));
    }

    public static final void setCurrentDayOfWeek (String dayOfweekname)
    {
      when.add (Calendar.DATE, getDayOfWeekIndex (dayOfweekname) - when.get (Calendar.DAY_OF_WEEK));
    }

    private static final int getDayOfWeekIndex (String name)
    {
      for (int i = 0; i < daysOfweek.length; i++)
        {
	  if (daysOfweek[i].equals (name))
            {
	      return i;
            }
        }

      return (-1);
    }


    public static final String getMonthAsString ()
    {
      return monthnames[when.get (when.MONTH)];
    }

    public static final String getMonthasString (int month)
    {
      return monthnames[month];
    }

    public static final Date getDate () 
    {
      return when.getTime ();
    }


    public static final void setDate (Date date)
    {
      when.setTime (date);
    }

    private static final int getMonthIndex (String name)
    {
      for (int i = 0; i < monthnames.length; i++)
        {
	  if (monthnames[i].equals (name))
            {
	      return (i);
            }
        }

      return (-1);
    }

    public static final void setMonth (String m)
    {
      setMonth (getMonthIndex (m));
    }

    public static final void setLastMonth ()
    {
      // fix for library bug
      if (when.get (Calendar.MONTH) == 0)
        {  
	  when.add (Calendar.YEAR, -1);
	  when.set (Calendar.MONTH, 11);
        }
      else
        {
	  when.add(Calendar.MONTH, -1);
        }
    }

    public static final void setNextMonth ()
    {
      when.add (Calendar.MONTH, 1);
    }

    public static final void setLastWeek ()
    {
      when.add (Calendar.DATE, -7);
    }

    public static final void setNextWeek ()
    {
      when.add (Calendar.DATE, 7);
    }

    public static final void setLastYear ()
    {
      when.add (Calendar.YEAR, -1);
    }

    public static final void setNextYear ()
    {
      when.add (Calendar.YEAR, 1);
    }

    public static final void setMonth (int month)
    {
      when.set (when.get (Calendar.YEAR), month, when.get (Calendar.DATE));
    }

    public static final int getNumberOfDaysInMonth (int year, int month)
    {
      Calendar cal = Calendar.getInstance ();
      cal.set (Calendar.YEAR, year);
      cal.set (Calendar.MONTH, month);

      int diff = -1;

      cal.set (Calendar.DATE, 27);

      while (cal.get(Calendar.MONTH) == month)
      {
	cal.add (Calendar.DATE, 1);
	diff++;
      }

      return (27 + diff);
    }

    public static final int getWeekOfYear ()
    {
      return when.get (Calendar.WEEK_OF_YEAR);
    }

    public static final int getHourOfDay ()
    {
      return when.get (Calendar.HOUR_OF_DAY);
    }

    public static final int getMinute ()
    {
      return when.get (Calendar.MINUTE);
    }

}  // DateUTil

