/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: XoeMemo.java,v 1.6 2001/10/27 00:10:15 samc Exp $
 */
package org.xoe.core.apps;

import org.xoe.core.dom.XDocument;
import org.xoe.core.content.DocumentCache;
import org.xoe.core.util.Logger;
import org.xoe.core.xpath.XPath;

import org.xoe.core.util.DOMUtils;
import org.xoe.servlet.*;
import org.xoe.display.dom.xhtml.*;

import java.io.*;
import java.net.*;
import javax.servlet.*;
import javax.servlet.http.*;

import org.w3c.dom.Node;
import org.w3c.dom.Element;

class XoeMemo 
  extends XoeServlet
{
  Node currentNode = null;

  protected void doGet (HttpServletRequest req, HttpServletResponse res)
    throws ServletException, IOException
  {
    XDocument doc;
   
    res.setContentType ("text/html");
    String path = req.getPathInfo();
    Logger.log(this, "doGet path = " + path);

    if ("CANCEL".equals (path))
      {
	//right now cancel just goes back to the original page without saving.  if we need
	//it to do something different later, we should fill this part in.
	path="";
      }
    
    if ("".equals (path))
      {
	//default view is to just load stash:/data/memoPad/select.xhtml

	doc = getRelativeDocument ("select.xhtml");
	doc.expandUsingXPathAttributes ();
	res.getWriter ().print (doc);
      }
    if ("VIEW".equals (path))
      {
	//when a memo is selected from the menu, we open up view.xhtml and display it.
	//we then find the text of the memo that was selected and load it into the
	//text area that's in view.xhtml.  currentNode points to the node in
	//memos.xml that we're editing so we know were to save the stuff to.

	DocSelect select = (DocSelect) req.getAttribute(XoeServletRequest.NODE);
	doc = getRelativeDocument ("view.xhtml");
	currentNode = select.getSelected ().item (0);
	currentNode = XPath.findFirstNode (currentNode, "notes");
        DocTextArea text = (DocTextArea) XPath.findFirstNode (doc, "//textarea");
	text.setText (DOMUtils.getAssignedValue (currentNode));
	res.getWriter ().print (doc);
      }
    if ("SAVE".equals (path))
      {
	//set the text we just edited into memos.xml
	String note=req.getParameter ("message");
	DOMUtils.setAssignedValue (currentNode, note);

	try 
	  {
	    //put the new memos.xml back into the stash.

	    DocumentCache.putDocument ((XDocument) currentNode.getOwnerDocument ());
	    doc = getRelativeDocument ("select.xhtml");
	    doc.expandUsingXPathAttributes ();
     

	    //load the startup page again

	    res.getWriter ().print (doc);
	  }
	catch (MalformedURLException mue)
	  {
	    Logger.log (this, mue);
	  }
      }
    if ("NEW".equals (path))
      {
        //load up new view page.  this is exactly the same as view.xhtml except  
        //saving has a path of SAVENEW instead of save.

        doc = getRelativeDocument ("new.xhtml");
        doc.expandUsingXPathAttributes ();
        res.getWriter().print(doc);
      }
    if ("SAVENEW".equals (path))
      {
        int n;
        Element add;
        String note = req.getParameter ("message");
        doc = getRelativeDocument ("memos.xml");
        doc.expandUsingXPathAttributes ();
        currentNode = XPath.findFirstNode(doc, "memos");
        add = doc.createElement ("memo");
        add.setAttribute ("xmlns", "http://xoe.org/ns/2001/memos");

        // add a new memo to memos.xml

        currentNode.appendChild (add);
        currentNode = add;
        add = doc.createElement ("name");

        //add the name element to the new memo.  name is the first line of the message
        //by default.  if there is no line breaks, it's the same as the message itself.

        currentNode.appendChild (add);
        n = note.indexOf('\n');
        if (n != -1)
          {
            DOMUtils.setAssignedValue (add, note.substring (0, n));
          }
        else 
          {
            DOMUtils.setAssignedValue (add, note);
          }
        add = doc.createElement ("notes");

        //add the notes element to the memo element.  this is where the text is stored.

        currentNode.appendChild (add);
        DOMUtils.setAssignedValue (add, note);

        //put memos.xml  back into the stash. and go back to the startup screen
        log ( "memos.xml = " + ((XDocument) currentNode.getOwnerDocument()) . getURL ());
        DocumentCache.putDocument ((XDocument) currentNode.getOwnerDocument ());
        doc = getRelativeDocument ("select.xhtml");
        doc.expandUsingXPathAttributes ();
        res.getWriter ().print (doc);
      }

  }
}
