package org.xoe.themes;

import com.pocketlinux.awt.theme.Theme;

import java.io.IOException;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import kaffe.awt.AWT;

import org.w3c.dom.Element;
import org.w3c.dom.NodeList;

import org.xoe.core.content.DocumentCache;
import org.xoe.core.dom.XDocument;
import org.xoe.core.util.Logger;
import org.xoe.core.xpath.XPath;
import org.xoe.servlet.XoeServlet;
import org.xoe.servlet.XoeServletRequest;


public class Main
  extends XoeServlet 
{
  private static final String SELECT_VIEW = "select.xhtml";
  private static final String SELECT_PATH = "SELECT";

  protected void doGet (HttpServletRequest req, HttpServletResponse res)
    throws ServletException, IOException
  {
    XDocument doc;
    res.setContentType (MIMETYPE_TEXT_HTML);
    String path = req.getPathInfo();

    if (SELECT_PATH.equals (path))
      {
	String theme = req.getParameter ("theme");
	if (theme != null)
	  {
            doc = DocumentCache.fetchDocument ("stash:/themes/themelist.xml");
            if (doc == null)
              {
                throw new ServletException ("themelist not found");
              }

            Element e = (Element)XPath.findFirstNode (doc,"themes/theme[@name='" + theme + "']");
            if (e == null)
              {
                throw new ServletException ("no theme element found for : " + theme);
              }

	    String src = e.getAttribute ("src");

            // load the theme here using src
	  }
      }

    if (SELECT_PATH.equals (path) || "".equals (path))
      {
	doc = getRelativeDocument (SELECT_VIEW);
	if (doc == null)
	  {
	    Logger.log(this, SELECT_VIEW + " not found"); 
	  }
	doc.expandUsingXPathAttributes ();
	res.getWriter ().print (doc);
      }
  }

}
