package org.xoe.web; 

import java.awt.Dimension;
import java.io.IOException;
import java.net.URL;
import java.net.URLEncoder;

import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import org.xoe.core.content.ContentElement;
import org.xoe.core.content.ContentType;
import org.xoe.core.content.DocumentCache;
import org.xoe.core.content.IDocumentBuilder;
import org.xoe.core.content.Stash;
import org.xoe.core.dom.Callback;
import org.xoe.core.dom.EntityResolver;
import org.xoe.core.dom.Loadable;
import org.xoe.core.dom.XDocument;
import org.xoe.core.services.IService;
import org.xoe.core.services.ServiceFactory;
import org.xoe.core.services.ServiceLocator;
import org.xoe.core.util.DOMUtils;
import org.xoe.core.util.Logger;
import org.xoe.core.util.XMLWriter;
import org.xoe.core.xpath.XPath;
import org.xoe.core.xpath.XPathContext;
import org.xoe.core.xpath.XPathParser;
import org.xoe.display.dom.DocumentViewer;
import org.xoe.display.dom.IEditableDocumentBuilder;
import org.xoe.display.dom.IViewableDocumentBuilder;
import org.xoe.display.dom.xhtml.Dialog;
import org.xoe.servlet.XoeServlet;

class Categories
  extends XoeServlet
{  
  
  public Categories (Bookmarks mainPage)
  {
    super (mainPage);
    this.mainPage = mainPage;
  }

  public void init (Document configDoc) 
    throws Exception
  {
    super.init (configDoc);
  }
  
  Bookmarks mainPage;
  protected void doGet (HttpServletRequest req, HttpServletResponse res)
    throws ServletException, IOException
  {
    setTitleDocument (null);
    XDocument dataDoc = mainPage.dataDoc;
    Element docRoot = dataDoc.getDocumentElement ();
    String path = req.getPathInfo ();
    Logger.log (this, "path = " + path);
    grabDataFromScreen (docRoot);

    if (req.getParameter ("addnew") != null)
      {
	docRoot.appendChild (dataDoc.createElementNS (null, "category"));
      }

    if (req.getParameter ("delete") != null)
      {
	NodeList delete = XPath.findNodes (docRoot, "category[ count(link) = 0 ]");
	for (int i=0; i < delete.getLength (); i++)
	  {
	    docRoot.removeChild (delete.item(i));
	  }
      }

    if (req.getParameter ("revert") != null)
      {
	mainPage.dataDoc = DocumentCache.fetchDocument (dataDoc.getURL ());
	dataDoc = mainPage.dataDoc;
      }

    if ("".equals (path) || "categories".equals (path) || "redraw".equals (path))
      {
	XDocument doc = getRelativeDocument ("edit-categories.xhtml");
	DOMUtils.expandUsingRepeat (doc, dataDoc, null);
	res.getWriter ().print (doc);
	createCallbacks ();
      }
    else if ("save".equals (path))
      {
	DocumentCache.putDocument (dataDoc);
      }
    else if ("bookmarks".equals (path))
      {
	mainPage.service (req, res);
      }
  }

  void grabDataFromScreen (Element docElement)
  {
    Document disp = getDisplayedDocument ();
    if (disp != null && docElement != null)
      {
	NodeList names = XPath.findNodes (disp, "//*[@type = 'category-name']");
	NodeList categories = XPath.findNodes (docElement, "category");
	int length = names.getLength (); // all the lengths should be the same
	for (int i = 0; i < length ; i++)
	  {
	    Element category = (Element) categories.item (i);
	    category.setAttributeNS (null, "name", ((Element) names.item(i)).getAttributeNS (null, "value"));
	  }
      }
  }

}
