/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: TagPatterns.java,v 1.2 2001/12/07 21:10:02 damian Exp $
 */
package org.xoe.input.virtual;

class TagPatterns 
{
  final static public int SYMBOLS = 0;
  final static public int NUMBERS = 1;
  final static public int UPPERCASE = 2;
  final static public int LOWERCASE = 3;
  final static public int COMMON = 4;

  final static byte NORTH = (byte)0;
  final static byte EAST = (byte)1;
  final static byte SOUTH = (byte)2;
  final static byte WEST = (byte)3;

/*****************************************************************************

static byte[][] patternsLower = new byte[][]{
 new byte[]{ (byte)'a', NORTH, EAST, SOUTH, EAST }, // 0x119
 new byte[]{ (byte)'a', NORTH, EAST, SOUTH, EAST, SOUTH }, // 0x466
 new byte[]{ (byte)'a', NORTH, EAST, NORTH, SOUTH, EAST, SOUTH }, // 0x1126
 new byte[]{ (byte)'a', NORTH, EAST, NORTH, SOUTH, EAST }, // 0x449
 new byte[]{ (byte)'b', SOUTH, SOUTH, EAST, NORTH, EAST, WEST }, // 0x1a47
 new byte[]{ (byte)'b', SOUTH, EAST, SOUTH, NORTH, WEST, SOUTH, WEST }, // 0x663b
 new byte[]{ (byte)'b', NORTH, EAST, NORTH, SOUTH, EAST, WEST, EAST, SOUTH, WEST }, // 0x449db
 new byte[]{ (byte)'b', NORTH, EAST, NORTH, SOUTH, EAST, WEST, EAST, SOUTH, WEST, SOUTH, NORTH }, // 0x449db8
 new byte[]{ (byte)'b', SOUTH, SOUTH, EAST, NORTH, EAST, WEST, NORTH, SOUTH, WEST }, // 0x691cb
 new byte[]{ (byte)'b', SOUTH, EAST, SOUTH, NORTH, EAST, WEST, SOUTH }, // 0x661e
 new byte[]{ (byte)'b', SOUTH, SOUTH, EAST, NORTH, WEST, SOUTH }, // 0x1a4e
 new byte[]{ (byte)'b', SOUTH, SOUTH, EAST, NORTH, EAST, WEST, SOUTH }, // 0x691e
 new byte[]{ (byte)'b', SOUTH, EAST, SOUTH, NORTH, EAST, WEST, NORTH, SOUTH, WEST }, // 0x661cb
 new byte[]{ (byte)'b', SOUTH, EAST, NORTH, WEST, SOUTH }, // 0x64e
 new byte[]{ (byte)'b', NORTH, EAST, NORTH, SOUTH, WEST, EAST, SOUTH, WEST }, // 0x112db
 new byte[]{ (byte)'b', NORTH, EAST, SOUTH, EAST, WEST, EAST, SOUTH, WEST, SOUTH }, // 0x4676e
 new byte[]{ (byte)'b', NORTH, EAST, SOUTH, EAST, WEST, EAST, SOUTH, WEST }, // 0x119db
 new byte[]{ (byte)'b', NORTH, EAST, SOUTH, WEST, EAST, SOUTH, WEST }, // 0x46db
 new byte[]{ (byte)'b', NORTH, EAST, NORTH, EAST, SOUTH, WEST, EAST, SOUTH, WEST }, // 0x446db
 new byte[]{ (byte)'b', NORTH, EAST, SOUTH, WEST, NORTH, EAST, SOUTH, WEST }, // 0x11b1b
 new byte[]{ (byte)'b', NORTH, NORTH, EAST, SOUTH, EAST, WEST, SOUTH, EAST, SOUTH, WEST }, // 0x10679b
 new byte[]{ (byte)'b', NORTH, NORTH, EAST, SOUTH, EAST, WEST, EAST, SOUTH, WEST }, // 0x419db
 new byte[]{ (byte)'b', NORTH, EAST, SOUTH, WEST, EAST, SOUTH, WEST, SOUTH }, // 0x11b6e
 new byte[]{ (byte)'b', NORTH, NORTH, EAST, SOUTH, WEST, EAST, SOUTH, WEST }, // 0x106db
 new byte[]{ (byte)'c', WEST, SOUTH, EAST, EAST }, // 0x1e5
 new byte[]{ (byte)'c', WEST, NORTH, SOUTH, WEST, EAST, SOUTH, NORTH, EAST }, // 0x1cb61
 new byte[]{ (byte)'c', WEST, SOUTH, WEST, EAST, SOUTH, EAST }, // 0x1ed9
 new byte[]{ (byte)'c', WEST, SOUTH, WEST, EAST, SOUTH }, // 0x7b6
 new byte[]{ (byte)'c', WEST, SOUTH, EAST }, // 0x79
 new byte[]{ (byte)'c', WEST, SOUTH, EAST, SOUTH }, // 0x1e6
 new byte[]{ (byte)'d', WEST, SOUTH, NORTH, EAST },
 new byte[]{ (byte)'d', WEST, SOUTH, NORTH, EAST, NORTH },
 new byte[]{ (byte)'d', WEST, SOUTH, NORTH, EAST, NORTH, SOUTH },
 new byte[]{ (byte)'d', WEST, SOUTH, NORTH, EAST, SOUTH },
 new byte[]{ (byte)'d', WEST, SOUTH, EAST, NORTH, SOUTH },
 new byte[]{ (byte)'d', WEST, NORTH, SOUTH, EAST, NORTH, EAST, NORTH }, // 0x7244
 new byte[]{ (byte)'d', WEST, NORTH, SOUTH, WEST, EAST, NORTH, NORTH }, // 0x72d0
 new byte[]{ (byte)'d', NORTH, EAST, SOUTH, EAST, WEST }, // 0x467
 new byte[]{ (byte)'d', NORTH, NORTH, EAST, SOUTH, EAST, SOUTH, WEST }, // 0x419b
 new byte[]{ (byte)'d', NORTH, WEST, SOUTH, WEST, EAST, NORTH, NORTH }, // 0x4ed0
 new byte[]{ (byte)'d', WEST, SOUTH, EAST, SOUTH, NORTH, EAST }, // 0x1e61
 new byte[]{ (byte)'d', WEST, SOUTH, EAST, NORTH, NORTH }, // 0x790
 new byte[]{ (byte)'d', WEST, NORTH, SOUTH, EAST, NORTH, EAST }, // 0x1c91
 new byte[]{ (byte)'d', NORTH, WEST, SOUTH, WEST, EAST, NORTH }, // 0x13b4
 new byte[]{ (byte)'d', NORTH, WEST, SOUTH, EAST, NORTH, EAST, NORTH }, // 0x4e44
 new byte[]{ (byte)'d', NORTH, NORTH, EAST, SOUTH, EAST, SOUTH, WEST, SOUTH }, // 0x1066e
 new byte[]{ (byte)'d', NORTH, EAST, SOUTH, WEST, SOUTH }, // 0x46e
 new byte[]{ (byte)'d', NORTH, NORTH, EAST, EAST, SOUTH, WEST, SOUTH }, // 0x416e
 new byte[]{ (byte)'d', NORTH, EAST, SOUTH, EAST, WEST, SOUTH }, // 0x119e
 new byte[]{ (byte)'d', NORTH, NORTH, EAST, SOUTH, EAST, WEST, SOUTH, WEST }, // 0x1067b
 new byte[]{ (byte)'d', NORTH, NORTH, EAST, SOUTH, EAST, WEST, SOUTH }, // 0x419e
 new byte[]{ (byte)'d', NORTH, EAST, NORTH, SOUTH, EAST, WEST, SOUTH }, // 0x449e
 new byte[]{ (byte)'d', NORTH, EAST, NORTH, SOUTH, EAST, WEST, SOUTH, WEST }, // 0x1127b
 new byte[]{ (byte)'e', EAST, NORTH, WEST, NORTH, SOUTH, WEST, EAST }, // 0x532d
 new byte[]{ (byte)'e', SOUTH, EAST, NORTH, WEST, SOUTH, WEST, EAST, SOUTH }, // 0x193b6
 new byte[]{ (byte)'e', SOUTH, EAST, NORTH, EAST, WEST, NORTH, SOUTH, WEST, EAST, SOUTH }, // 0x191cb6
 new byte[]{ (byte)'e', EAST, SOUTH, NORTH, EAST, WEST, SOUTH, EAST, SOUTH }, // 0x161e6
 new byte[]{ (byte)'e', SOUTH, EAST, NORTH, WEST, SOUTH, WEST, EAST, SOUTH, NORTH }, // 0x64ed8
 new byte[]{ (byte)'e', SOUTH, EAST, NORTH, EAST, WEST, SOUTH, EAST, SOUTH }, // 0x191e6
 new byte[]{ (byte)'e', EAST, SOUTH, NORTH, EAST, WEST, NORTH, SOUTH, WEST, EAST }, // 0x5872d
 new byte[]{ (byte)'e', EAST, SOUTH, NORTH, WEST, SOUTH, WEST, EAST, SOUTH }, // 0x163b6
 new byte[]{ (byte)'e', EAST, NORTH, WEST, NORTH, SOUTH, WEST, EAST, SOUTH }, // 0x14cb6
 new byte[]{ (byte)'e', EAST, NORTH, WEST, SOUTH, EAST }, // 0x539
 new byte[]{ (byte)'e', EAST, NORTH, WEST, SOUTH, EAST, SOUTH }, // 0x14e6
 new byte[]{ (byte)'f', WEST, SOUTH, SOUTH }, // 0x7a
 new byte[]{ (byte)'f', WEST, SOUTH }, // 0x1e
 new byte[]{ (byte)'g', WEST, NORTH, SOUTH, EAST, NORTH, SOUTH, WEST, NORTH, WEST }, // 0x724b3
 new byte[]{ (byte)'g', NORTH, WEST, SOUTH, WEST, EAST, NORTH, SOUTH, WEST, NORTH, WEST }, // 0x13b4b3
 new byte[]{ (byte)'g', WEST, SOUTH, EAST, NORTH, SOUTH, EAST, WEST, NORTH }, // 0x1e49c
 new byte[]{ (byte)'g', WEST, NORTH, SOUTH, WEST, EAST, NORTH, SOUTH, WEST, SOUTH, NORTH, WEST }, // 0x72d2e3
 new byte[]{ (byte)'g', NORTH, WEST, SOUTH, EAST, NORTH, SOUTH, WEST, NORTH }, // 0x1392c
 new byte[]{ (byte)'g', WEST, SOUTH, EAST, NORTH, SOUTH, WEST, SOUTH, NORTH, WEST }, // 0x792e3
 new byte[]{ (byte)'g', WEST, NORTH, SOUTH, WEST, EAST, NORTH, SOUTH, WEST, NORTH }, // 0x72d2c
 new byte[]{ (byte)'g', NORTH, WEST, SOUTH, WEST, EAST, NORTH, SOUTH, WEST, NORTH }, // 0x4ed2c
 new byte[]{ (byte)'g', WEST, NORTH, SOUTH, EAST, NORTH, EAST, SOUTH, WEST, NORTH }, // 0x7246c
 new byte[]{ (byte)'g', NORTH, WEST, SOUTH, WEST, EAST, NORTH, SOUTH, SOUTH, WEST, NORTH }, // 0x13b4ac
 new byte[]{ (byte)'g', NORTH, WEST, SOUTH, EAST, NORTH, EAST, SOUTH, EAST, WEST, SOUTH, NORTH, WEST }, // 0x13919e3
 new byte[]{ (byte)'g', WEST, SOUTH, EAST, NORTH, SOUTH, WEST }, // 0x1e4b
 new byte[]{ (byte)'g', WEST, SOUTH, EAST, NORTH, SOUTH, SOUTH, WEST, NORTH }, // 0x1e4ac
 new byte[]{ (byte)'g', NORTH, WEST, SOUTH, EAST, NORTH, SOUTH, WEST, NORTH, WEST }, // 0x4e4b3
 new byte[]{ (byte)'g', WEST, SOUTH, EAST, NORTH, SOUTH, EAST, WEST }, // 0x7927
 new byte[]{ (byte)'g', WEST, SOUTH, SOUTH, EAST, SOUTH, NORTH, EAST, WEST, SOUTH }, // 0x7a61e
 new byte[]{ (byte)'g', WEST, SOUTH, SOUTH, EAST, SOUTH, NORTH, WEST, SOUTH, WEST }, // 0x7a63b
 new byte[]{ (byte)'g', WEST, SOUTH, EAST, SOUTH, NORTH, WEST }, // 0x1e63
 new byte[]{ (byte)'g', WEST, SOUTH, EAST, NORTH, WEST, SOUTH }, // 0x1e4e
 new byte[]{ (byte)'g', NORTH, WEST, SOUTH, EAST, NORTH, EAST, SOUTH, WEST, NORTH }, // 0x4e46c
 new byte[]{ (byte)'g', WEST, SOUTH, EAST, NORTH, SOUTH, WEST, NORTH }, // 0x792c
 new byte[]{ (byte)'g', NORTH, WEST, SOUTH, EAST, NORTH, EAST, SOUTH, EAST, WEST, NORTH }, // 0x13919c
 new byte[]{ (byte)'g', WEST, SOUTH, EAST, NORTH, SOUTH, WEST, NORTH, WEST }, // 0x1e4b3
 new byte[]{ (byte)'g', WEST, SOUTH, EAST, NORTH, SOUTH, EAST, WEST, SOUTH, NORTH, WEST }, // 0x1e49e3
 new byte[]{ (byte)'h', SOUTH, NORTH, EAST, SOUTH }, // 0x186
 new byte[]{ (byte)'h', SOUTH, SOUTH, NORTH, EAST, SOUTH }, // 0x686
 new byte[]{ (byte)'h', SOUTH, WEST, NORTH, EAST, SOUTH }, // 0x6c6
 new byte[]{ (byte)'h', SOUTH, SOUTH, NORTH, EAST, SOUTH, EAST }, // 0x1a19
 new byte[]{ (byte)'h', SOUTH, NORTH, EAST, SOUTH, EAST }, // 0x619
 new byte[]{ (byte)'i', SOUTH }, // 0x6
 new byte[]{ (byte)'i', SOUTH, EAST, SOUTH }, // 0x66
 new byte[]{ (byte)'i', SOUTH, WEST, SOUTH }, // 0x6e
 new byte[]{ (byte)'i', SOUTH, SOUTH }, // 0x1a
 new byte[]{ (byte)'j', SOUTH, SOUTH, WEST }, // 0x6b
 new byte[]{ (byte)'j', SOUTH, WEST, NORTH }, // 0x6c
 new byte[]{ (byte)'j', SOUTH, WEST, SOUTH, NORTH }, // 0x1b8
 new byte[]{ (byte)'j', SOUTH, SOUTH, WEST, NORTH }, // 0x1ac
 new byte[]{ (byte)'j', SOUTH, SOUTH, WEST, NORTH, WEST }, // 0x6b3
 new byte[]{ (byte)'j', SOUTH, WEST, NORTH, WEST }, // 0x1b3
 new byte[]{ (byte)'j', SOUTH, WEST, SOUTH, NORTH, WEST }, // 0x6e3
 new byte[]{ (byte)'k', SOUTH, WEST, NORTH, SOUTH, EAST }, //
 new byte[]{ (byte)'k', SOUTH, WEST, NORTH, WEST, EAST, SOUTH, EAST }, // 0x6cd9
 new byte[]{ (byte)'k', SOUTH, WEST, EAST, SOUTH }, // 0x1b6
 new byte[]{ (byte)'k', SOUTH, WEST, NORTH, WEST, EAST, SOUTH }, // 0x1b36
 new byte[]{ (byte)'k', SOUTH, WEST, NORTH, EAST, SOUTH, EAST }, // 0x1b19
 new byte[]{ (byte)'l', SOUTH, EAST }, // 0x19
 new byte[]{ (byte)'l', SOUTH, SOUTH, EAST, EAST }, // 0x1a5
 new byte[]{ (byte)'l', SOUTH, SOUTH, EAST }, // 0x69
 new byte[]{ (byte)'m', NORTH, SOUTH, EAST, NORTH, EAST, SOUTH }, //
 new byte[]{ (byte)'m', NORTH, EAST, SOUTH, EAST, NORTH, EAST, SOUTH, EAST }, // 0x11919
 new byte[]{ (byte)'m', NORTH, NORTH, EAST, SOUTH, EAST, SOUTH, NORTH, EAST, SOUTH }, // 0x41986
 new byte[]{ (byte)'m', NORTH, NORTH, EAST, SOUTH, EAST, NORTH, EAST, SOUTH, EAST, SOUTH }, // 0x106466
 new byte[]{ (byte)'m', NORTH, EAST, SOUTH, EAST, NORTH, EAST, SOUTH }, // 0x4646
 new byte[]{ (byte)'m', NORTH, EAST, NORTH, SOUTH, EAST, NORTH, EAST, SOUTH, EAST, SOUTH }, // 0x112466
 new byte[]{ (byte)'m', NORTH, EAST, SOUTH, EAST, SOUTH, NORTH, EAST, SOUTH, SOUTH, EAST }, // 0x119869
 new byte[]{ (byte)'m', NORTH, EAST, NORTH, SOUTH, EAST, NORTH, EAST, SOUTH }, // 0x11246
 new byte[]{ (byte)'m', NORTH, EAST, SOUTH, EAST, NORTH, EAST, SOUTH, SOUTH }, // 0x1191a
 new byte[]{ (byte)'n', NORTH, EAST, SOUTH, EAST, NORTH, NORTH }, // 0x1190
 new byte[]{ (byte)'n', NORTH, EAST, SOUTH, EAST, SOUTH, NORTH, EAST }, // 0x4661
 new byte[]{ (byte)'n', NORTH, SOUTH, EAST, NORTH }, // 0x124
 new byte[]{ (byte)'n', NORTH, EAST, SOUTH, EAST, NORTH, EAST }, // 0x1191
 new byte[]{ (byte)'n', NORTH, EAST, SOUTH, NORTH, EAST }, // 0x461
 new byte[]{ (byte)'n', NORTH, EAST, NORTH, SOUTH, EAST, SOUTH, NORTH, EAST }, // 0x11261
 new byte[]{ (byte)'n', NORTH, NORTH, EAST, SOUTH, EAST, SOUTH, NORTH, EAST }, // 0x10661
 new byte[]{ (byte)'n', NORTH, EAST, SOUTH, SOUTH, NORTH }, // 0x468
 new byte[]{ (byte)'n', NORTH, NORTH, EAST, SOUTH, EAST, NORTH, EAST }, // 0x4191
 new byte[]{ (byte)'n', NORTH, SOUTH, EAST, SOUTH, NORTH, EAST }, // 0x1261
 new byte[]{ (byte)'n', NORTH, NORTH, SOUTH, EAST, SOUTH, NORTH, EAST, NORTH }, // 0x10984
 new byte[]{ (byte)'n', NORTH, SOUTH, EAST, SOUTH, NORTH, EAST, NORTH }, // 0x4984
 new byte[]{ (byte)'n', NORTH, EAST, SOUTH, EAST, SOUTH, NORTH, NORTH }, // 0x4660
 new byte[]{ (byte)'n', NORTH, EAST, SOUTH, EAST, SOUTH, NORTH, EAST, NORTH }, // 0x11984
 new byte[]{ (byte)'n', NORTH, EAST, NORTH, SOUTH, EAST, NORTH }, // 0x1124
 new byte[]{ (byte)'n', NORTH, NORTH, EAST, SOUTH, EAST, NORTH, NORTH }, // 0x4190
 new byte[]{ (byte)'n', NORTH, NORTH, EAST, SOUTH, EAST, SOUTH, NORTH, EAST, NORTH }, // 0x41984
 new byte[]{ (byte)'n', NORTH, EAST, SOUTH, SOUTH, NORTH, NORTH }, // 0x11a0
 new byte[]{ (byte)'n', NORTH, EAST, SOUTH, EAST, NORTH }, // 0x464
 new byte[]{ (byte)'n', NORTH, EAST, SOUTH, EAST, SOUTH, NORTH }, // 0x1198
 new byte[]{ (byte)'n', NORTH, NORTH, EAST, SOUTH, EAST, SOUTH, NORTH }, // 0x4198
 new byte[]{ (byte)'n', NORTH, NORTH, EAST, SOUTH, EAST, NORTH }, // 0x1064
 new byte[]{ (byte)'n', NORTH, NORTH, SOUTH, EAST, SOUTH, NORTH, NORTH }, // 0x4260
 new byte[]{ (byte)'n', NORTH, NORTH, SOUTH, EAST, NORTH }, // 0x424
 new byte[]{ (byte)'n', NORTH, NORTH, EAST, SOUTH, EAST, SOUTH, NORTH, NORTH }, // 0x10660
 new byte[]{ (byte)'n', NORTH, NORTH, SOUTH, EAST, SOUTH, NORTH }, // 0x1098
 new byte[]{ (byte)'o', WEST, SOUTH, EAST, SOUTH, NORTH, EAST, WEST }, // 0x7987
 new byte[]{ (byte)'o', WEST, SOUTH, EAST, SOUTH, NORTH, EAST, NORTH, WEST }, // 0x1e613
 new byte[]{ (byte)'o', WEST, SOUTH, EAST, SOUTH, NORTH, EAST, WEST, NORTH }, // 0x1e61c
 new byte[]{ (byte)'o', SOUTH, WEST, EAST, NORTH,  WEST }, //
 new byte[]{ (byte)'o', WEST, SOUTH, EAST, NORTH,  WEST }, //
 new byte[]{ (byte)'o', WEST, SOUTH, SOUTH, EAST, NORTH, NORTH,  WEST }, //
 new byte[]{ (byte)'o', WEST, SOUTH, EAST, NORTH }, //
 new byte[]{ (byte)'o', SOUTH, WEST, EAST, NORTH,  WEST, SOUTH }, //
 new byte[]{ (byte)'p', NORTH, NORTH, EAST, SOUTH, WEST }, // 0x41b
 new byte[]{ (byte)'p', NORTH, NORTH, EAST, SOUTH, EAST, WEST }, // 0x1067
 new byte[]{ (byte)'p', NORTH, EAST, NORTH, SOUTH, EAST, WEST }, // 0x1127
 new byte[]{ (byte)'p', NORTH, EAST, NORTH, SOUTH, WEST }, // 0x44b
 new byte[]{ (byte)'p', NORTH, EAST, SOUTH, WEST }, // 0x11b
 new byte[]{ (byte)'q', WEST, EAST, SOUTH, NORTH, EAST },
 new byte[]{ (byte)'q', WEST, EAST, SOUTH, WEST, SOUTH, NORTH, EAST },
 new byte[]{ (byte)'q', WEST, EAST, SOUTH, WEST, NORTH, EAST, NORTH },
 new byte[]{ (byte)'q', WEST, SOUTH, EAST, NORTH, SOUTH, WEST, EAST, NORTH },
 new byte[]{ (byte)'q', WEST, SOUTH, EAST, NORTH, SOUTH, WEST, NORTH, EAST },
 new byte[]{ (byte)'q', WEST, SOUTH, EAST, NORTH, SOUTH, EAST, NORTH },
 new byte[]{ (byte)'q', WEST, SOUTH, EAST, SOUTH, WEST, NORTH, EAST },
 new byte[]{ (byte)'q', WEST, SOUTH, NORTH, EAST, SOUTH, WEST, NORTH, EAST },
 new byte[]{ (byte)'q', WEST, SOUTH, EAST, SOUTH, WEST, SOUTH, NORTH, EAST }, // 0x1e6e1
 new byte[]{ (byte)'q', WEST, NORTH, SOUTH, EAST, SOUTH, NORTH, EAST }, // 0x7261
 new byte[]{ (byte)'q', NORTH, WEST, SOUTH, EAST, NORTH, EAST, SOUTH, EAST, NORTH, EAST }, // 0x139191
 new byte[]{ (byte)'q', NORTH, WEST, SOUTH, WEST, EAST, NORTH, SOUTH, EAST, NORTH, EAST }, // 0x13b491
 new byte[]{ (byte)'q', NORTH, WEST, SOUTH, EAST, NORTH, EAST, SOUTH, NORTH, EAST }, // 0x4e461
 new byte[]{ (byte)'q', NORTH, WEST, SOUTH, EAST, NORTH, EAST, SOUTH, WEST, EAST, NORTH }, // 0x1391b4
 new byte[]{ (byte)'q', NORTH, WEST, SOUTH, WEST, EAST, NORTH, SOUTH, WEST, EAST, NORTH }, // 0x13b4b4
 new byte[]{ (byte)'q', NORTH, WEST, SOUTH, WEST, EAST, SOUTH, NORTH, EAST, SOUTH, NORTH, EAST }, // 0x4ed861
 new byte[]{ (byte)'q', WEST, NORTH, SOUTH, EAST, NORTH, EAST, SOUTH, NORTH, EAST }, // 0x72461
 new byte[]{ (byte)'q', NORTH, WEST, SOUTH, WEST, EAST, NORTH, SOUTH, NORTH, EAST }, // 0x4ed21
 new byte[]{ (byte)'q', NORTH, WEST, SOUTH, WEST, EAST, NORTH, SOUTH, WEST, NORTH, EAST }, // 0x13b4b1
 new byte[]{ (byte)'q', NORTH, WEST, SOUTH, EAST, NORTH, EAST, SOUTH, SOUTH, NORTH, EAST }, // 0x1391a1
 new byte[]{ (byte)'q', WEST, SOUTH, EAST, NORTH, SOUTH, WEST, SOUTH, NORTH, EAST }, // 0x792e1
 new byte[]{ (byte)'q', WEST, SOUTH, EAST, NORTH, SOUTH, SOUTH, NORTH, EAST }, // 0x1e4a1
 new byte[]{ (byte)'q', WEST, SOUTH, EAST, NORTH, SOUTH, EAST, NORTH, EAST }, // 0x1e491
 new byte[]{ (byte)'q', WEST, NORTH, SOUTH, WEST, EAST, NORTH, SOUTH, NORTH, EAST }, // 0x72d21
 new byte[]{ (byte)'q', WEST, SOUTH, EAST, NORTH, SOUTH, NORTH, EAST }, // 0x7921
 new byte[]{ (byte)'r', NORTH, NORTH, EAST }, // 0x41
 new byte[]{ (byte)'r', NORTH, EAST, NORTH, SOUTH, EAST, WEST, SOUTH, EAST, SOUTH }, // 0x449e6
 new byte[]{ (byte)'r', NORTH, EAST, SOUTH, WEST, SOUTH, EAST, SOUTH }, // 0x46e6
 new byte[]{ (byte)'r', NORTH, EAST, SOUTH, WEST, EAST, SOUTH }, // 0x11b6
 new byte[]{ (byte)'r', NORTH, WEST, EAST, SOUTH, WEST, SOUTH, EAST, SOUTH }, // 0x136e6
 new byte[]{ (byte)'r', NORTH, EAST, NORTH, EAST, SOUTH, WEST, EAST, SOUTH }, // 0x111b6
 new byte[]{ (byte)'r', NORTH, EAST, NORTH, SOUTH, WEST, EAST, SOUTH }, // 0x44b6
 new byte[]{ (byte)'r', NORTH, EAST, SOUTH, EAST, WEST, EAST, SOUTH }, // 0x4676
 new byte[]{ (byte)'r', NORTH, NORTH, EAST, SOUTH, WEST, EAST, SOUTH }, // 0x41b6
 new byte[]{ (byte)'r', NORTH, EAST, SOUTH, EAST, WEST, SOUTH, EAST, SOUTH }, // 0x119e6
 new byte[]{ (byte)'r', NORTH, EAST }, // 0x11
 new byte[]{ (byte)'r', NORTH, EAST, EAST }, // 0x45
 new byte[]{ (byte)'s', NORTH, WEST, SOUTH, EAST, WEST }, // 0x4e7
 new byte[]{ (byte)'s', WEST, SOUTH, EAST, SOUTH, WEST, SOUTH }, // 0x1e6e
 new byte[]{ (byte)'s', WEST, NORTH, SOUTH, EAST, WEST, NORTH }, // 0x1c9c
 new byte[]{ (byte)'s', NORTH, WEST, SOUTH, EAST, SOUTH, WEST, SOUTH, NORTH }, // 0x139b8
 new byte[]{ (byte)'s', NORTH, WEST, SOUTH, EAST, WEST, NORTH }, // 0x139c
 new byte[]{ (byte)'s', WEST, NORTH, SOUTH, WEST, EAST, SOUTH, WEST, SOUTH, NORTH, WEST }, // 0x1cb6e3
 new byte[]{ (byte)'s', WEST, NORTH, SOUTH, EAST, WEST }, // 0x727
 new byte[]{ (byte)'s', WEST, SOUTH, EAST, SOUTH, WEST, NORTH }, // 0x1e6c
 new byte[]{ (byte)'s', WEST, NORTH, SOUTH, WEST, EAST, SOUTH, WEST, NORTH }, // 0x1cb6c
 new byte[]{ (byte)'s', WEST, SOUTH, EAST, SOUTH, WEST }, // 0x79b
 new byte[]{ (byte)'t', EAST, EAST, SOUTH, SOUTH }, // 0x15a
 new byte[]{ (byte)'t', EAST, EAST, SOUTH, WEST, SOUTH }, // 0x56e
 new byte[]{ (byte)'t', EAST, SOUTH, SOUTH }, // 0x5a
 new byte[]{ (byte)'t', EAST, SOUTH }, // 0x16
 new byte[]{ (byte)'u', SOUTH, EAST, SOUTH, NORTH, EAST, SOUTH, EAST }, // 0x6619
 new byte[]{ (byte)'u', SOUTH, EAST, NORTH, EAST, SOUTH, EAST }, // 0x1919
 new byte[]{ (byte)'u', SOUTH, EAST, NORTH, EAST, SOUTH }, // 0x646
 new byte[]{ (byte)'u', SOUTH, EAST, SOUTH, NORTH, EAST }, // 0x661
 new byte[]{ (byte)'v', SOUTH, EAST, NORTH }, // 0x64
 new byte[]{ (byte)'v', SOUTH, EAST, SOUTH, NORTH, EAST, NORTH }, // 0x1984
 new byte[]{ (byte)'v', SOUTH, EAST, NORTH, EAST }, // 0x191
 new byte[]{ (byte)'v', SOUTH, EAST, NORTH, EAST, NORTH }, // 0x644
 new byte[]{ (byte)'w', SOUTH, SOUTH, EAST, NORTH, EAST, SOUTH, EAST, SOUTH, NORTH, EAST }, // 0x1a4661
 new byte[]{ (byte)'w', SOUTH, EAST, SOUTH, NORTH, EAST, SOUTH, EAST, NORTH, EAST }, // 0x66191
 new byte[]{ (byte)'w', SOUTH, EAST, NORTH, EAST, SOUTH, EAST, NORTH, EAST }, // 0x19191
 new byte[]{ (byte)'w', SOUTH, EAST, NORTH, SOUTH, EAST, NORTH, EAST }, // 0x6491
 new byte[]{ (byte)'w', SOUTH, EAST, NORTH, EAST, SOUTH, EAST, NORTH, EAST, NORTH }, // 0x64644
 new byte[]{ (byte)'w', SOUTH, EAST, NORTH, EAST, SOUTH, NORTH, EAST }, //
 new byte[]{ (byte)'w', SOUTH, NORTH, EAST, SOUTH, EAST, NORTH, EAST }, //
 new byte[]{ (byte)'x', SOUTH, EAST, NORTH, WEST, SOUTH, WEST }, //
 new byte[]{ (byte)'x', SOUTH, EAST, NORTH, EAST, WEST, SOUTH, WEST }, // 0x647b
 new byte[]{ (byte)'x', SOUTH, EAST, EAST, NORTH, WEST, SOUTH, WEST }, // 0x653b
 new byte[]{ (byte)'x', SOUTH, EAST, NORTH, EAST, WEST, SOUTH }, // 0x191e
 new byte[]{ (byte)'x', SOUTH, EAST, NORTH, WEST, SOUTH, WEST }, // 0x193b
 new byte[]{ (byte)'x', SOUTH, EAST, NORTH, SOUTH, WEST, SOUTH }, //
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, SOUTH, WEST }, //
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, SOUTH, WEST, NORTH }, //
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, EAST, SOUTH, WEST }, //
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, EAST, SOUTH, WEST, SOUTH }, //
 new byte[]{ (byte)'y', SOUTH, NORTH, EAST, SOUTH, WEST }, //
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, EAST, SOUTH, EAST, WEST, NORTH }, // 0x1919c
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, EAST, SOUTH, EAST, SOUTH, WEST, NORTH }, // 0x6466c
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, SOUTH, SOUTH, WEST, NORTH, WEST }, // 0x192b3
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, SOUTH, WEST, NORTH, WEST }, // 0x64b3
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, EAST, SOUTH, EAST, WEST, SOUTH, NORTH, WEST }, // 0x1919e3
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, EAST, SOUTH, WEST }, // 0x191b
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, EAST, SOUTH, WEST, NORTH, WEST }, // 0x191b3
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, EAST, SOUTH, WEST, SOUTH, NORTH }, // 0x191b8
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, EAST, SOUTH, WEST, NORTH }, // 0x646c
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, SOUTH, WEST, NORTH }, // 0x192c
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, EAST, SOUTH, SOUTH, WEST, NORTH, WEST }, // 0x646b3
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, EAST, SOUTH, SOUTH, WEST, NORTH }, // 0x191ac
 new byte[]{ (byte)'y', SOUTH, EAST, NORTH, EAST, SOUTH, WEST, SOUTH, NORTH, WEST }, // 0x646e3
 new byte[]{ (byte)'z', EAST, EAST, SOUTH, WEST, SOUTH, WEST, EAST, SOUTH }, // 0x15bb6
 new byte[]{ (byte)'z', EAST, SOUTH, WEST, SOUTH, EAST, SOUTH }, // 0x16e6
 new byte[]{ (byte)'z', EAST, SOUTH, WEST, SOUTH, WEST, EAST, SOUTH, EAST }, // 0x16ed9
 new byte[]{ (byte)'z', EAST, SOUTH, WEST, SOUTH, EAST, EAST }, // 0x16e5
 new byte[]{ (byte)'z', EAST, SOUTH, WEST, SOUTH, WEST, EAST, EAST }, // 0x5bb5
 new byte[]{ (byte)'z', EAST, EAST, SOUTH, WEST, SOUTH, EAST, SOUTH }, // 0x56e6
 new byte[]{ (byte)'z', EAST, EAST, SOUTH, WEST, SOUTH, WEST, EAST }, // 0x56ed
 new byte[]{ (byte)'z', EAST, EAST, SOUTH, WEST, SOUTH, WEST, EAST, EAST }, // 0x15bb5
 new byte[]{ (byte)'z', EAST, EAST, SOUTH, WEST, SOUTH, WEST, EAST, SOUTH, EAST }, // 0x56ed9
 new byte[]{ (byte)'z', EAST, SOUTH, WEST, SOUTH, WEST, EAST }, // 0x16ed
 new byte[]{ (byte)'z', EAST, SOUTH, WEST, SOUTH, EAST }, // 0x5b9
 new byte[]{ (byte)'z', EAST, SOUTH, WEST, EAST }, //
};

 *****************************************************************************/

static private char recognizeLowercase(int val) {
	switch (val) {
	case 0x119:	return 'a';
	case 0x466:	return 'a';
	case 0x1126:	return 'a';
	case 0x449:	return 'a';
	case 0x1a47:	return 'b';
	case 0x663b:	return 'b';
	case 0x449db:	return 'b';
	case 0x449db8:	return 'b';
	case 0x691cb:	return 'b';
	case 0x661e:	return 'b';
	case 0x1a4e:	return 'b';
	case 0x691e:	return 'b';
	case 0x661cb:	return 'b';
	case 0x64e:	return 'b';
	case 0x112db:	return 'b';
	case 0x4676e:	return 'b';
	case 0x119db:	return 'b';
	case 0x46db:	return 'b';
	case 0x446db:	return 'b';
	case 0x11b1b:	return 'b';
	case 0x10679b:	return 'b';
	case 0x419db:	return 'b';
	case 0x11b6e:	return 'b';
	case 0x106db:	return 'b';
	case 0x1e5:	return 'c';
	case 0x1cb61:	return 'c';
	case 0x1ed9:	return 'c';
	case 0x7b6:	return 'c';
	case 0x79:	return 'c';
	case 0x1e6:	return 'c';
	case 0x7244:	return 'd';
	case 0x72d0:	return 'd';
	case 0x467:	return 'd';
	case 0x419b:	return 'd';
	case 0x4ed0:	return 'd';
	case 0x1e61:	return 'd';
	case 0x790:	return 'd';
	case 0x1c91:	return 'd';
	case 0x13b4:	return 'd';
	case 0x4e44:	return 'd';
	case 0x1066e:	return 'd';
	case 0x46e:	return 'd';
	case 0x416e:	return 'd';
	case 0x119e:	return 'd';
	case 0x1067b:	return 'd';
	case 0x419e:	return 'd';
	case 0x449e:	return 'd';
	case 0x1127b:	return 'd';
        case 0x1e1:     return 'd';
        case 0x784:     return 'd';
        case 0x1e12:    return 'd';
        case 0x786:     return 'd';
        case 0x792:     return 'd';
	case 0x532d:	return 'e';
	case 0x193b6:	return 'e';
	case 0x191cb6:	return 'e';
	case 0x161e6:	return 'e';
	case 0x64ed8:	return 'e';
	case 0x191e6:	return 'e';
	case 0x5872d:	return 'e';
	case 0x163b6:	return 'e';
	case 0x14cb6:	return 'e';
	case 0x539:	return 'e';
	case 0x14e6:	return 'e';
	case 0x7a:	return 'f';
	case 0x1e:	return 'f';
	case 0x724b3:	return 'g';
	case 0x13b4b3:	return 'g';
	case 0x1e49c:	return 'g';
	case 0x72d2e3:	return 'g';
	case 0x1392c:	return 'g';
	case 0x792e3:	return 'g';
	case 0x72d2c:	return 'g';
	case 0x4ed2c:	return 'g';
	case 0x7246c:	return 'g';
	case 0x13b4ac:	return 'g';
	case 0x13919e3:	return 'g';
	case 0x1e4b:	return 'g';
	case 0x1e4ac:	return 'g';
	case 0x4e4b3:	return 'g';
	case 0x7927:	return 'g';
	case 0x7a61e:	return 'g';
	case 0x7a63b:	return 'g';
	case 0x1e63:	return 'g';
	case 0x1e4e:	return 'g';
	case 0x4e46c:	return 'g';
	case 0x792c:	return 'g';
	case 0x13919c:	return 'g';
	case 0x1e4b3:	return 'g';
	case 0x1e49e3:	return 'g';
	case 0x186:	return 'h';
	case 0x686:	return 'h';
	case 0x6c6:	return 'h';
	case 0x1a19:	return 'h';
	case 0x619:	return 'h';
	case 0x6:	return 'i';
	case 0x66:	return 'i';
	case 0x6e:	return 'i';
	case 0x1a:	return 'i';
	case 0x6b:	return 'j';
	case 0x6c:	return 'j';
	case 0x1b8:	return 'j';
	case 0x1ac:	return 'j';
	case 0x6b3:	return 'j';
	case 0x1b3:	return 'j';
	case 0x6e3:	return 'j';
	case 0x6cd9:	return 'k';
	case 0x1b6:	return 'k';
	case 0x1b36:	return 'k';
	case 0x1b19:	return 'k';
        case 0x6c9:     return 'k';
	case 0x19:	return 'l';
	case 0x1a5:	return 'l';
	case 0x69:	return 'l';
	case 0x11919:	return 'm';
	case 0x41986:	return 'm';
	case 0x106466:	return 'm';
	case 0x4646:	return 'm';
	case 0x112466:	return 'm';
	case 0x119869:	return 'm';
	case 0x11246:	return 'm';
	case 0x1191a:	return 'm';
        case 0x1246:    return 'm';
	case 0x1190:	return 'n';
	case 0x4661:	return 'n';
	case 0x124:	return 'n';
	case 0x1191:	return 'n';
	case 0x461:	return 'n';
	case 0x11261:	return 'n';
	case 0x10661:	return 'n';
	case 0x468:	return 'n';
	case 0x4191:	return 'n';
	case 0x1261:	return 'n';
	case 0x10984:	return 'n';
	case 0x4984:	return 'n';
	case 0x4660:	return 'n';
	case 0x11984:	return 'n';
	case 0x1124:	return 'n';
	case 0x4190:	return 'n';
	case 0x41984:	return 'n';
	case 0x11a0:	return 'n';
	case 0x464:	return 'n';
	case 0x1198:	return 'n';
	case 0x4198:	return 'n';
	case 0x1064:	return 'n';
	case 0x4260:	return 'n';
	case 0x424:	return 'n';
	case 0x10660:	return 'n';
	case 0x1098:	return 'n';
	case -0x7987:	return 'o';
	case -0x1e613:	return 'o';
	case -0x1e61c:	return 'o';
        case -0x6d3:    return 'o';
        case -0x793:    return 'o';
        case -0x7a43:   return 'o';
        case -0x1e4:    return 'o';
        case -0x1b4e:   return 'o';
	case 0x41b:	return 'p';
	case 0x1067:	return 'p';
	case 0x1127:	return 'p';
	case 0x44b:	return 'p';
	case 0x11b:	return 'p';
	case 0x1e6e1:	return 'q';
	case 0x7261:	return 'q';
	case 0x139191:	return 'q';
	case 0x13b491:	return 'q';
	case 0x4e461:	return 'q';
	case 0x1391b4:	return 'q';
	case 0x13b4b4:	return 'q';
	case 0x4ed861:	return 'q';
	case 0x72461:	return 'q';
	case 0x4ed21:	return 'q';
	case 0x13b4b1:	return 'q';
	case 0x1391a1:	return 'q';
	case 0x792e1:	return 'q';
	case 0x1e4a1:	return 'q';
	case 0x1e491:	return 'q';
	case 0x72d21:	return 'q';
	case 0x7921:	return 'q';
        case 0x761:     return 'q';
        case 0x76e1:    return 'q';
        case 0x76c4:    return 'q';
        case 0x1e4b4:   return 'q';
        case 0x1e4b1:   return 'q';
        case 0x7924:    return 'q';
        case 0x79b1:    return 'q';
        case 0x1e1b1:   return 'q';
	case 0x41:	return 'r';
	case 0x449e6:	return 'r';
	case 0x46e6:	return 'r';
	case 0x11b6:	return 'r';
	case 0x136e6:	return 'r';
	case 0x111b6:	return 'r';
	case 0x44b6:	return 'r';
	case 0x4676:	return 'r';
	case 0x41b6:	return 'r';
	case 0x119e6:	return 'r';
	case 0x11:	return 'r';
	case 0x45:	return 'r';
	case 0x4e7:	return 's';
	case 0x1e6e:	return 's';
	case 0x1c9c:	return 's';
	case 0x139b8:	return 's';
	case 0x139c:	return 's';
	case 0x1cb6e3:	return 's';
	case 0x727:	return 's';
	case 0x1e6c:	return 's';
	case 0x1cb6c:	return 's';
	case 0x79b:	return 's';
	case 0x15a:	return 't';
	case 0x56e:	return 't';
	case 0x5a:	return 't';
	case 0x16:	return 't';
	case 0x6619:	return 'u';
	case 0x1919:	return 'u';
	case 0x646:	return 'u';
	case 0x661:	return 'u';
	case 0x64:	return 'v';
	case 0x1984:	return 'v';
	case 0x191:	return 'v';
	case 0x644:	return 'v';
	case 0x1a4661:	return 'w';
	case 0x66191:	return 'w';
	case 0x19191:	return 'w';
	case 0x6491:	return 'w';
	case 0x64644:	return 'w';
        case 0x6461:    return 'w';
        case 0x6191:    return 'w';
	case 0x647b:	return 'x';
	case 0x653b:	return 'x';
	case 0x191e:	return 'x';
	case 0x193b:	return 'x';
        case 0x192e:    return 'x';
	case 0x1919c:	return 'y';
	case 0x6466c:	return 'y';
	case 0x192b3:	return 'y';
	case 0x64b3:	return 'y';
	case 0x1919e3:	return 'y';
	case 0x191b3:	return 'y';
	case 0x191b8:	return 'y';
	case 0x646c:	return 'y';
	case 0x646b3:	return 'y';
	case 0x191ac:	return 'y';
	case 0x646e3:	return 'y';
        case 0x64b:     return 'y';
        case 0x192c:    return 'y';
        case 0x191b:    return 'y';
        case 0x646e:    return 'y';
        case 0x61b:     return 'y';
        case 0x16d:     return 'z';
	case 0x15bb6:	return 'z';
	case 0x16e6:	return 'z';
	case 0x16ed9:	return 'z';
	case 0x16e5:	return 'z';
	case 0x5bb5:	return 'z';
	case 0x56e6:	return 'z';
	case 0x56ed:	return 'z';
	case 0x15bb5:	return 'z';
	case 0x56ed9:	return 'z';
	case 0x16ed:	return 'z';
	case 0x5b9:	return 'z';
	default:	return 0;
	}
}

/*****************************************************************************

static byte[][] patternsNumbers = new byte[][]{
 new byte[]{ (byte)'0', WEST, SOUTH, EAST, NORTH, WEST }, // 0x793
 new byte[]{ (byte)'0', WEST, SOUTH, SOUTH, EAST, SOUTH, NORTH, EAST, WEST, NORTH }, // 0x7a61c
 new byte[]{ (byte)'0', WEST, SOUTH, SOUTH, EAST, NORTH, WEST, NORTH }, // 0x7a4c
 new byte[]{ (byte)'0', WEST, SOUTH, EAST, SOUTH, NORTH, EAST, NORTH, WEST, NORTH }, // 0x7984c
 new byte[]{ (byte)'0', WEST, SOUTH, EAST, SOUTH, NORTH, EAST, WEST, NORTH }, // 0x1e61c
 new byte[]{ (byte)'0', SOUTH, WEST, EAST, NORTH, WEST }, //
 new byte[]{ (byte)'0', SOUTH, WEST, EAST, NORTH, WEST, SOUTH }, //
 new byte[]{ (byte)'1', SOUTH }, // 0x6
 new byte[]{ (byte)'1', SOUTH, SOUTH }, // 0x1a
 new byte[]{ (byte)'2', EAST, SOUTH, WEST, EAST }, //
 new byte[]{ (byte)'2', EAST, SOUTH, WEST, SOUTH, EAST }, // 0x5b9
 new byte[]{ (byte)'2', NORTH, EAST, SOUTH, WEST, SOUTH, EAST }, // 0x11b9
 new byte[]{ (byte)'2', NORTH, EAST, SOUTH, WEST, EAST }, // 0x46d
 new byte[]{ (byte)'3', EAST, WEST, SOUTH, EAST, SOUTH, WEST },
 new byte[]{ (byte)'3', EAST, SOUTH, WEST, SOUTH, EAST, SOUTH, WEST },
 new byte[]{ (byte)'3', NORTH, EAST, SOUTH, WEST, EAST, SOUTH, WEST },
 new byte[]{ (byte)'3', EAST, SOUTH, WEST, EAST, SOUTH, WEST }, //
 new byte[]{ (byte)'3', EAST, SOUTH, WEST, SOUTH, EAST, SOUTH, WEST }, //
 new byte[]{ (byte)'3', EAST, SOUTH, WEST, SOUTH, EAST, SOUTH, WEST, NORTH }, // 0x16e6c
 new byte[]{ (byte)'3', NORTH, EAST, SOUTH, WEST, EAST, SOUTH, WEST, NORTH }, // 0x11b6c
 new byte[]{ (byte)'3', EAST, SOUTH, WEST, EAST, SOUTH, WEST, SOUTH }, // 0x5b6e
 new byte[]{ (byte)'3', NORTH, EAST, SOUTH, EAST, WEST, SOUTH, EAST, SOUTH, WEST, SOUTH }, // 0x119e6e
 new byte[]{ (byte)'3', EAST, NORTH, SOUTH, WEST, EAST, SOUTH, WEST }, // 0x52db
 new byte[]{ (byte)'3', EAST, NORTH, SOUTH, WEST, EAST, SOUTH, WEST, SOUTH }, // 0x14b6e
 new byte[]{ (byte)'3', EAST, SOUTH, WEST, SOUTH, EAST, SOUTH, WEST }, // 0x5b9b
 new byte[]{ (byte)'3', EAST, SOUTH, WEST, SOUTH, EAST, SOUTH, WEST, SOUTH }, // 0x16e6e
 new byte[]{ (byte)'4', NORTH, SOUTH, WEST, EAST }, // 0x12d
 new byte[]{ (byte)'4', NORTH, WEST, SOUTH, WEST, EAST, EAST }, // 0x13b5
 new byte[]{ (byte)'4', NORTH, NORTH, SOUTH, WEST, EAST }, // 0x42d
 new byte[]{ (byte)'4', NORTH, SOUTH, WEST, EAST, EAST }, // 0x4b5
 new byte[]{ (byte)'5', WEST, SOUTH, NORTH, EAST, SOUTH, WEST }, // 0x1e1b
 new byte[]{ (byte)'5', WEST, SOUTH, EAST, SOUTH, WEST, SOUTH }, // 0x1e6e
 new byte[]{ (byte)'5', WEST, SOUTH, EAST, SOUTH, WEST }, // 0x79b
 new byte[]{ (byte)'6', SOUTH, EAST, NORTH, WEST, SOUTH, WEST, NORTH },
 new byte[]{ (byte)'6', SOUTH, WEST, NORTH, EAST, WEST, SOUTH, NORTH },
 new byte[]{ (byte)'6', SOUTH, WEST, SOUTH, EAST, NORTH, WEST, SOUTH, NORTH },
 new byte[]{ (byte)'6', SOUTH, WEST, SOUTH, EAST, NORTH, SOUTH, WEST, NORTH },
 new byte[]{ (byte)'6', SOUTH, EAST, NORTH, SOUTH, WEST, NORTH },
 new byte[]{ (byte)'6', WEST, SOUTH, NORTH, SOUTH, WEST, NORTH },
 new byte[]{ (byte)'6', WEST, SOUTH, WEST, EAST, NORTH, SOUTH, WEST, NORTH },
 new byte[]{ (byte)'6', WEST, SOUTH, EAST, NORTH, WEST, NORTH },
 new byte[]{ (byte)'6', SOUTH, WEST, EAST, WEST, NORTH }, //
 new byte[]{ (byte)'6', SOUTH, WEST, EAST, NORTH, WEST, SOUTH, NORTH }, //
 new byte[]{ (byte)'6', SOUTH, WEST, EAST, NORTH, WEST, NORTH }, //
 new byte[]{ (byte)'6', SOUTH, WEST, SOUTH, EAST, NORTH, WEST, NORTH }, //
 new byte[]{ (byte)'6', WEST, SOUTH, EAST, NORTH, WEST, NORTH }, //
 new byte[]{ (byte)'6', WEST, SOUTH, SOUTH, EAST, SOUTH, NORTH, EAST, WEST, NORTH }, // 0x1e987
 new byte[]{ (byte)'6', WEST, SOUTH, SOUTH, EAST, NORTH, WEST, SOUTH, NORTH }, // 0x7a4e
 new byte[]{ (byte)'6', WEST, SOUTH, SOUTH, EAST, NORTH, WEST, NORTH }, // 0x1e93
 new byte[]{ (byte)'6', WEST, SOUTH, EAST, SOUTH, NORTH, WEST, NORTH }, // 0x1e63
 new byte[]{ (byte)'6', WEST, SOUTH, EAST, SOUTH, NORTH, WEST, SOUTH, WEST, NORTH }, // 0x1e63b
 new byte[]{ (byte)'6', WEST, SOUTH, EAST, SOUTH, NORTH, EAST, WEST, NORTH, SOUTH, WEST, NORTH }, // 0x1e61cb
 new byte[]{ (byte)'6', WEST, SOUTH, EAST, NORTH, WEST, SOUTH, NORTH }, // 0x1e4e
 new byte[]{ (byte)'6', WEST, SOUTH, SOUTH, EAST, SOUTH, NORTH, EAST, WEST, SOUTH, NORTH }, // 0x7a61e
 new byte[]{ (byte)'6', WEST, SOUTH, EAST, SOUTH, NORTH, WEST, SOUTH, NORTH }, // 0x798e
 new byte[]{ (byte)'6', WEST, SOUTH, EAST, SOUTH, NORTH, EAST, WEST, SOUTH, NORTH }, // 0x1e61e
 new byte[]{ (byte)'6', WEST, SOUTH, EAST, NORTH, WEST, NORTH, SOUTH, WEST, NORTH }, // 0x1e4cb
 new byte[]{ (byte)'6', WEST, SOUTH, SOUTH, EAST, SOUTH, NORTH, EAST, WEST, NORTH, SOUTH, NORTH }, // 0x1e9872
 new byte[]{ (byte)'6', WEST, SOUTH, EAST, SOUTH, NORTH, EAST, WEST, NORTH }, // 0x7987
 new byte[]{ (byte)'6', WEST, SOUTH, SOUTH, EAST, NORTH, WEST, NORTH, SOUTH, NORTH }, // 0x1e932
 new byte[]{ (byte)'7', EAST, SOUTH, WEST },
 new byte[]{ (byte)'7', EAST, SOUTH, WEST, SOUTH }, // 0x16e
 new byte[]{ (byte)'8', WEST, WEST, SOUTH, EAST, WEST, NORTH, EAST, NORTH, WEST }, //
 new byte[]{ (byte)'8', SOUTH, WEST, EAST, SOUTH, WEST, NORTH, EAST, NORTH },
 new byte[]{ (byte)'8', WEST, SOUTH, EAST, SOUTH, WEST, NORTH, EAST, NORTH, WEST }, // 0x79b13
 new byte[]{ (byte)'8', WEST, SOUTH, EAST, SOUTH, WEST, NORTH, EAST, NORTH }, // 0x1e6c4
 new byte[]{ (byte)'8', WEST, SOUTH, EAST, SOUTH, WEST, NORTH, EAST, NORTH, WEST, NORTH }, // 0x1e6c4c
 new byte[]{ (byte)'9', WEST, SOUTH, NORTH, EAST, SOUTH },
 new byte[]{ (byte)'9', WEST, SOUTH, EAST, NORTH, SOUTH },
 new byte[]{ (byte)'9', NORTH, WEST, SOUTH, WEST, EAST, NORTH, SOUTH }, // 0x4ed2
 new byte[]{ (byte)'9', WEST, NORTH, SOUTH, WEST, EAST, NORTH, SOUTH }, // 0x72d2
 new byte[]{ (byte)'9', WEST, NORTH, SOUTH, EAST, NORTH, SOUTH }, // 0x1c92
 new byte[]{ (byte)'9', NORTH, WEST, SOUTH, EAST, NORTH, EAST, SOUTH }, // 0x4e46
 new byte[]{ (byte)'9', WEST, SOUTH, EAST, NORTH, SOUTH, SOUTH }, // 0x1e4a
 new byte[]{ (byte)'9', WEST, NORTH, SOUTH, EAST, NORTH, EAST, SOUTH }, // 0x7246
 new byte[]{ (byte)'9', WEST, SOUTH, EAST, NORTH, SOUTH }, // 0x792
 new byte[]{ (byte)'9', WEST, SOUTH, EAST, SOUTH, NORTH, EAST, SOUTH }, // 0x7986
 new byte[]{ (byte)'9', WEST, EAST, SOUTH },
};

 *****************************************************************************/

static private char recognizeNumbers(int val) {
	switch (val) {
        case -0x793:    return '0';
	case -0x7a61c:	return '0';
	case -0x7a4c:	return '0';
	case -0x7984c:	return '0';
	case -0x1e61c:	return '0';
        case -0x6d3:    return '0';
        case -0x1b4e:   return '0';
	case 0x6:	return '1';
	case 0x1a:	return '1';
        case 0x16d:     return '2';
	case 0x5b9:	return '2';
	case 0x11b9:	return '2';
	case 0x46d:	return '2';
        case 0x16db:    return '3';
        case 0x5b9b:    return '3';
	case 0x16e6c:	return '3';
	case 0x11b6c:	return '3';
	case 0x5b6e:	return '3';
	case 0x119e6e:	return '3';
	case 0x52db:	return '3';
	case 0x14b6e:	return '3';
	case 0x16e6e:	return '3';
        case 0x179b:    return '3';
        case 0x46db:    return '3';
	case 0x12d:	return '4';
	case 0x13b5:	return '4';
	case 0x42d:	return '4';
	case 0x4b5:	return '4';
	case 0x1e1b:	return '5';
	case 0x1e6e:	return '5';
	case 0x79b:	return '5';
        case 0x193b:    return '6';
        case 0x1b1e:    return '6';
        case 0x6e4e:    return '6';
        case 0x6e4b:    return '6';
        case 0x64b:     return '6';
        case 0x78b:     return '6';
        case 0x7b4b:    return '6';
        case 0x793:     return '6';
	case 0x1e987:	return '6';
	case 0x7a4e:	return '6';
	case 0x1e93:	return '6';
	case 0x1e63:	return '6';
	case 0x1e63b:	return '6';
	case 0x1e61cb:	return '6';
        case 0x1b7:     return '6';
        case 0x1b93:    return '6';
	case 0x1e4e:	return '6';
	case 0x7a61e:	return '6';
	case 0x798e:	return '6';
	case 0x1e61e:	return '6';
	case 0x1e4cb:	return '6';
	case 0x1e9872:	return '6';
	case 0x7987:	return '6';
	case 0x1e932:	return '6';
	case 0x16e:	return '7';
        case 0x5b:      return '7';
	case 0x79b13:	return '8';
	case 0x1e6c4:	return '8';
	case 0x1e6c4c:	return '8';
	case 0x7e713:   return '8';
        case 0x1b6c4:   return '8';
        case 0x786:     return '9';
        case 0x792:     return '9';
        case 0x76:      return '9';
	case 0x4ed2:	return '9';
	case 0x72d2:	return '9';
	case 0x1c92:	return '9';
	case 0x4e46:	return '9';
	case 0x1e4a:	return '9';
	case 0x7246:	return '9';
	case 0x7986:	return '9';
	default:	return 0;
	}
}

/*****************************************************************************

static byte[][] patternsSymbols = new byte[0][];

 *****************************************************************************/

static private char recognizeSymbols(int val) {
	return (0);
}

/*****************************************************************************

static byte[][] patternsCommon = new byte[][]{
 new byte[]{ (byte)' ', EAST },
 new byte[]{ (byte)' ', EAST, EAST },
 new byte[]{ (byte)' ', EAST, SOUTH },
 new byte[]{ (byte)'\b', WEST, NORTH }, //
 new byte[]{ (byte)'\b', WEST, SOUTH }, //
 new byte[]{ (byte)'\b', WEST },
 new byte[]{ (byte)'\b', WEST, WEST },
 new byte[]{ (byte)'\n', SOUTH, WEST, SOUTH, WEST }, // 0x1bb
 new byte[]{ (byte)'\n', SOUTH, WEST }, // 0x1b
 new byte[]{ (byte)'\n', SOUTH, SOUTH, WEST }, // 0x6b
 new byte[]{ (byte)'\n', SOUTH, WEST, WEST }, // 0x6f
 new byte[]{ (byte)'\n', SOUTH, SOUTH, WEST, WEST }, // 0x1af
};

 *****************************************************************************/

static private char recognizeCommon(int val) {
	switch (val) {
	case 0x15:	return ' ';
	case 0x5:	return ' ';
	case 0x7:	return '\b';
	case 0x1f:	return '\b';
        case 0x1c:      return '\b';
        case 0x1e:      return '\b';
        case 0x1bb:     return '\n';
        case 0x1b:      return '\n';
        case 0x6b:      return '\n';
        case 0x6f:      return '\n';
        case 0x1af:     return '\n';
	default:	return 0;
	}
}

/*****************************************************************************

static byte[][][] patterns = new byte[][][]{
	patternsSymbols,
	patternsNumbers,
	patternsLower,
	patternsLower,	// Upper same as lower
	patternsCommon,
};

 *****************************************************************************/

  static public char recognizeCharacter (int val, int type) 
  {
    switch (type)
      {
      case SYMBOLS:
        return (recognizeSymbols(val));
      case NUMBERS:
        return (recognizeNumbers(val));
      case LOWERCASE:
        return (recognizeLowercase(val));
      case UPPERCASE:
        char key = recognizeLowercase(val);
        if (key != 0) 
          {
            key = Character.toUpperCase(key);
          }
        return (key);
      case COMMON:
        return (recognizeCommon(val));
      default:
        return (0);
      }
  }
}
