package org.xoe.input.virtual;

/**
 * Filter interface for implementing filters used by VirtualKeyboard.
 *
 */
 
public interface VirtualFilter {

        /**
         * Sets the VirtualKeyboard using this in stance
         * @param vi            VirtualKeyboard instance using this filter
         * @return: void
         * @author: Damian Kowalewski
         */
        public void setKeyboard (VirtualKeyboard vi);
        
        /**
         * Checks and processes a character. If no more processing is needed returns
         * true otherwise returns flase.
         *
         * @param mode          current mode of the keyboard
         * @param ch            character to be processed
         * @return: boolean
         * @author: Damian Kowalewski
         */
        public boolean processChar (int mode, char ch);
}
