/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: VirtualHolder.java,v 1.2 2001/12/07 21:10:02 damian Exp $
 */
package org.xoe.input.virtual; 

import java.awt.Container;
import java.awt.Component;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;

class VirtualHolder
  extends Container 
{
  VirtualHolder() {}

  public void layout() 
  {
    //Dimension s = getPreferredSize();
    Dimension s = getSize();
    if (getComponentCount() >= 1) 
      {
        Component c = getComponent(0);
        Dimension cs = c.getPreferredSize();
        c.setBounds((s.width - cs.width) / 2, (s.height - cs.height) / 2 , cs.width, cs.height);
      }
  }

  public void paint (Graphics g) 
  {
    Dimension s = getSize();
    g.setColor(Color.black);
    g.fillRect(0, 0, s.width, s.height);
    super.paint(g);
  }

  public Dimension preferredSize () 
  {
    if (getComponentCount() >= 1) 
      {
        return (getComponent(0).getPreferredSize());
      }
    else 
      {
        return (new Dimension(0, 0));
      }
  }
}
