/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: Main.java,v 1.2 2001/11/04 14:13:30 jim Exp $
 */
package org.xoe.shell;

import java.awt.Container;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URL;
import java.net.URLEncoder;
import java.util.Hashtable;

import org.w3c.dom.Element;
import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import org.xoe.core.Engine;
import org.xoe.core.IShell;
import org.xoe.core.content.ContentCache;
import org.xoe.core.content.ContentElement;
import org.xoe.core.content.DocumentCache;
import org.xoe.core.content.IDocumentBuilder;
import org.xoe.core.content.Stash;
import org.xoe.core.content.StashException;
import org.xoe.core.device.IScreen;
import org.xoe.core.device.Device;
import org.xoe.core.services.ServiceLocator;
import org.xoe.core.util.Logger;
import org.xoe.core.util.DOMUtils;
import org.xoe.display.dom.DocumentViewer;
import org.xoe.display.dom.IViewableDocumentBuilder;
import org.xoe.display.dom.Render;


public class Main
  implements IShell
{
  private final static String [] funcs = new String [] { IShell.FUNCTION_SHELL };
  private final static String [] ifaces = new String [] { IShell.INTERFACE };
  private final static int COLS = 4;

  private Document maindoc;
  private Hashtable apps = new Hashtable ();



  // -------------------------------------------------------------------------
  // org.xoe.core.IShell

  public void start ()
  {
    ContentElement thing;
    try
      {
	thing = Stash.fetch ("stash:/home/default/apps/WebBrowser.lnk");
      }
    catch (StashException e)
      {
	e.printStackTrace ();
	return;
      }

    ContentElement elem;
    IViewableDocumentBuilder builder;
    Document view;
    try {
      elem = ContentCache.fetch (thing.getURL ().toString ());
      builder = (IViewableDocumentBuilder)elem.getType ().getService (IViewableDocumentBuilder.INTERFACE);
      view = builder.getViewableDocument (elem);
    }
    catch (IOException e)
      {
	e.printStackTrace ();
	return;
      }

    IScreen screen = (IScreen) ServiceLocator.findImplementor (IScreen.INTERFACE);
    if (screen == null)
      {
	Logger.log (this, "*** ERROR *** No screen found");
	System.exit (1);
      }
    Container win = screen.getScreen ();
    Render render = new Render ();
    win.add (render);
    render.setDocument (view);
    win.validate ();
    win.repaint ();
  }

  public void init (Document configDoc)
    throws Exception
  {
  }

  public String[] getFunctionalities ()
  {
    return (funcs);
  }

  public String[] getInterfaces (String functionality)
  {
    return (ifaces);
  }

  public String[] getFeatures (String functionality)
  {
    return null;
  }

  public String[] getInformation ()
  {
    return null;
  }

}
  
