/**
 * npservice.c - Netscape plugin mime description lookup
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution
 * of this file.
 */                                                                
                          
#include <dlfcn.h>
#include <jni.h>

typedef char* (*mime_func)(void);

/********************
 * helper funcs
 *********************/
 
static int
lookup_mime( char* pathname, char* mime) {
  void* handle;
  char* mime_func_name = "NP_GetMIMEDescription";
  mime_func func;
   
  handle = dlopen( pathname, RTLD_LAZY);
 
  if ( handle == 0 ) {
    return 0;
  }
 
  func = (mime_func)dlsym( handle, mime_func_name);      

  if ( (func != NULL) && (dlerror() == NULL) ) {
    strcpy( mime, (*func)() );
    dlclose( handle);
    return 1;
  }
 
  dlclose( handle);
  return 0;
}                                                                           

                                          
/******************************************************
 * exported funcs
 ******************************************************/
 

JNIEXPORT jstring JNICALL
Java_org_xoe_display_dom_plugin_NPService_getMimeDescription( JNIEnv *env, jclass clazz, jstring lib)
{
   jobject mimestr;
   jbyte *libpath;
   char  mime[255];
   
   libpath = (jbyte*)(*env)->GetStringUTFChars( env, lib, 0);
   
   if ( lookup_mime( libpath, mime) ) {
      mimestr =  (*env)->NewStringUTF( env, mime);	
   }
   else {
      mimestr = NULL;
   }
   
   (*env)->ReleaseStringUTFChars( env, lib, libpath);
   
   return mimestr;
}

