/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: NPServiceBase.java,v 1.2 2001/12/09 00:22:22 joerg Exp $
 */

package org.xoe.display.dom.plugin;

import java.io.IOException;
import java.util.StringTokenizer;


import org.w3c.dom.Document;   

import org.xoe.core.Constants;

import org.xoe.core.content.ContentElement;
import org.xoe.core.content.ContentType;
import org.xoe.core.content.DocumentCache;
import org.xoe.core.content.Stash;

import org.xoe.core.dom.XDocument;
import org.xoe.core.services.IService;
   
import org.xoe.display.dom.IViewableDocumentBuilder;
import org.xoe.display.dom.ViewElement;   
import org.xoe.display.dom.xhtml.Embed;

public abstract class NPServiceBase
    implements INPService, IViewableDocumentBuilder
{
   
  // ids on elements (used for bindings)
  public static final String PLAYER     = "PLAYER";

  // org.xoe.core.content.IViewableDocumentBuilder

  public XDocument getViewableDocument (ContentElement content)
    throws IOException
  {
    ContentType type = content.getType ();
    String docURI = Stash.getWorkingDirectory (this).toString () + "play.xhtml";
    XDocument doc = DocumentCache.fetchDocument (docURI);

    play (content, doc);

    return doc;
  }


  public static Class getDefaultPluginClass()
  {
     return PPlayer.class;
  }
   
  // org.xoe.core.services.IService

  public void init (Document configDoc)
  { // No configuration necessary
  }

  public String[] getFunctionalities()
  {
    return new String[] { INPService.FUNCTIONALITY, 
			  FUNCTION_CONTENT_HANDLER };
  }

  public String[] getInterfaces(String func)
  {
     return new String[] { INPService.INTERFACE, 
			   IViewableDocumentBuilder.INTERFACE };
   }

  public abstract String[] getFeatures (String func);

  public String[] getInformation ()
  {
    return new String[0];
  }

  
  // INPService

  public abstract String getLibrary();
  
   
  public Class getPluginClass()
  {
     return PPlayer.class;
  }


  // NPServiceBase

  private void play (ContentElement content, Document doc)
  {
    String uri = content.getURL().toString();

    ViewElement player = ((Embed) doc.getElementById (PLAYER)).getPlugin();
    player.setAttributeNS ( null, "src", uri );

    player.start();
  }
   
}
