package org.xoe.display.dom.xhtml;

import org.xoe.core.Constants;
import org.xoe.core.dom.XAttr;
import org.xoe.core.dom.XElement;
import org.xoe.core.dom.XDocument;
import org.xoe.core.dom.XNode;
import org.xoe.core.dom.SimpleNodeList;

import java.awt.Component;
import java.util.Observable;
import java.util.Observer;

import org.w3c.dom.*;

import org.xoe.core.services.SimpleServiceQuery;
import org.xoe.core.services.ServiceLocator;

import org.xoe.display.dom.plugin.INPService;
import org.xoe.display.dom.plugin.NPServiceBase;

import org.xoe.display.dom.ViewElement;
import org.xoe.display.dom.LayoutCursor;

public class Embed
  extends ViewElement
  implements Observer
{
  private ViewElement embed;

  public Node cloneNode (boolean deep) 
  {
    Embed nnode = (Embed) super.cloneNode (deep);
    nnode.embed = null;
    return nnode;
  }

  void createPlugin( String mimeType ) {
    Class plgCls = null;
    SimpleServiceQuery q = new SimpleServiceQuery (FUNCTION_CONTENT_HANDLER);
 
    q.addFeature (FEATURE_MIMETYPE, mimeType);
 
    INPService plg = (INPService) ServiceLocator.findService (q);

    //System.err.println( "service for: " + mimeType + " is: " + plg);

    if ( plg != null ) 
      {
	 plgCls = plg.getPluginClass();
      }

     if ( plgCls == null )
       {
	 plgCls = NPServiceBase.getDefaultPluginClass();
       }
     
     XDocument doc = (XDocument)getOwnerDocument ();
     embed = (ViewElement)doc.createElementNS (null, mimeType, plgCls);
      
     NamedNodeMap attrs = this.getAttributes ();
     for (int j = 0; j < attrs.getLength (); j++)
       {
	  Attr a = (Attr)attrs.item (j);
	  embed.setAttributeNS (null, a.getName (), a.getValue ());
       }
           
     appendChild( embed);
  }

  public void setAttributeNS (String namespaceURI, String localName, String value) 
  {
    if ("type".equalsIgnoreCase (localName) ||
	"data".equalsIgnoreCase (localName)) 
	{
	    createPlugin (value);
	}
    
    if (embed != null) 
	{
	    embed.setAttributeNS (namespaceURI, localName, value);
	}
    
    super.setAttributeNS(namespaceURI, localName, value);
  }

  public void setPlugin (ViewElement plugin) 
  {
    embed = plugin;
  }
  
  public ViewElement getPlugin () 
  {
    return (embed);
  }

  public void update (Observable obs, Object args) 
  {
    if (embed == null) 
      {
      }
    else if ("start".equals(args)) 
      {
	embed.start ();
      }
    else if ("stop".equals(args)) 
      {
	embed.stop ();
      }
  }

}
