package org.xoe.content.text;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.IOException;
import java.io.StringWriter;
import java.net.URL;

import org.w3c.dom.Document;
import org.w3c.dom.Node;

import org.xoe.core.content.ContentElement;
import org.xoe.core.dom.DOMlet;
import org.xoe.core.dom.XDocument;
import org.xoe.core.util.DOMUtils;
import org.xoe.core.util.Logger;
import org.xoe.core.xpath.XPath;
import org.xoe.display.dom.IViewableDocumentBuilder;


public class plain 
  implements IViewableDocumentBuilder
{
  public void init (Document configDoc)
  { // No configuration necessary
  }

  public String[] getFunctionalities ()
  {
    String[] ret = { "contenthandler" };
    return ret;
  }

  public String[] getInterfaces (String func)
  {
    if (func.equals ("contenthandler"))
      {
	String[] ret = { IViewableDocumentBuilder.INTERFACE };
	return ret;
      }
    return null;
  }

  public String[] getFeatures (String func)
  {
    if (func.equals ("contenthandler"))
      {
	return new String[]{ "mimetype", "text/plain" };
      }
    return null;
  }

  public String[] getInformation ()
  {
    return null;
  }

  public XDocument getViewableDocument (ContentElement content) 
    throws IOException
  {
    // get the src url
    URL src = content.getURL ();

    String s = "<html xmlns=\""  
               + XHTML_NAMESPACE 
               + "\"><head><title>" 
               + src 
               + "</title></head><body><pre></pre></body></html>";
    char[] c = s.toCharArray ();
    DOMlet wrapperView = DOMlet.create (c, src);

    BufferedReader in = new BufferedReader (new InputStreamReader (content.getInputStream ()));
    StringWriter sw = new StringWriter (); 
 
    try
      {
	while (in.ready ())
	  {
	    sw.write (in.readLine ());
            sw.write ("\n");
	  }

	// get the pre tag
	Node pre = XPath.findFirstNode (wrapperView, "xhtml:html/xhtml:body/xhtml:pre");
	DOMUtils.setTextContent (pre, sw.toString ());
      }
    finally
      {
	in.close ();
	sw.close ();    
      }

    return (wrapperView);
  }
}
