/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "license.terms" for details.
 *
 * $tvt: xhtml.java,v 1.1 2001/10/22 22:51:14 colin Exp $
 */
package org.xoe.content.text;

import java.io.IOException;

import org.w3c.dom.Document;

import org.xoe.core.content.ContentElement;
import org.xoe.core.content.IDocumentBuilder;
import org.xoe.core.dom.XDocument;
import org.xoe.display.dom.IViewableDocumentBuilder;


public class xhtml 
  implements IViewableDocumentBuilder
{
  // -------------------------------------------------------------------------
  // org.xoe.core.services.IService

  public void init (Document configDoc)
  { // No configuration necessary
  }

  public String[] getFunctionalities ()
  {
    return (new String[] { FUNCTION_CONTENT_HANDLER });
  }

  public String[] getInterfaces (String func)
  {
    if (func.equals (FUNCTION_CONTENT_HANDLER))
      {
	return (new String[] { IViewableDocumentBuilder.INTERFACE });
      }

    return (null);
  }

  public String[] getFeatures (String func)
  {
    if (func.equals (FUNCTION_CONTENT_HANDLER))
      {
	return (new String[] {
			       FEATURE_EXTENSION, EXTENSION_XHTML,
			       FEATURE_DOCTYPE_NAME_NS, DOCTYPE_NAME_NS_XHTML
	  		     });
      }

    return (null);
  }

  public String[] getInformation ()
  {
    return (null);
  }


  // -------------------------------------------------------------------------
  // org.xoe.display.dom.IViewableDocumentBuilder

  public XDocument getViewableDocument (ContentElement content)
    throws IOException
  {
    // get the document builder service and build the xml document
    IDocumentBuilder db = (IDocumentBuilder)content.getType ().getService (IDocumentBuilder.INTERFACE);
    if (db == null)
      {
        return (null);
      }

    return (db.getDocument (content));
  }
}
