/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.
 * All rights reserved.  See the file "license.terms" for details.
 *
 * $tvt: Clipboard.java,v 1.1 2001/10/22 22:51:13 colin Exp $
 */
package org.xoe.display.dom;

import java.awt.TextComponent;
import java.awt.Toolkit;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.awt.event.ActionEvent;

import org.w3c.dom.Document;

import org.xoe.services.IClipboard;


public class Clipboard
 implements IClipboard
{

  //----------------------------------------------------------------------------
  // IClipboard

  public void cut ()
  {
    TextComponent t =  kaffe.awt.AWT.lastTextComponentTgt;
    copyToClipboard (t);
    replaceSelectionWith (t, null);
  }

  public void copy ()
  {
    TextComponent t =  kaffe.awt.AWT.lastTextComponentTgt;
    copyToClipboard (t);
  }

  public void paste ()
  {
    TextComponent t =  kaffe.awt.AWT.lastTextComponentTgt;
    pasteFromClipboard (t);
  }

  public void selectAll ()
  {
    TextComponent t =  kaffe.awt.AWT.lastTextComponentTgt;
    t.selectAll ();
  }

  //----------------------------------------------------------------------------
  // IService
  
    public String[] getFunctionalities ()
  {
    return new String[] { IClipboard.FUNCTIONALITY };
  }

  public String[] getInterfaces (String func)
  {
    if (func.equals (IClipboard.FUNCTIONALITY))
      {
        return (new String[] { IClipboard.INTERFACE });
      }
    return (null);
  }

  public String[] getFeatures (String func)
  {
    return (null);
  }

  public String[] getInformation ()
  {
    return (null);
  }


  public void init (Document doc)
  {
  }

  void pasteFromClipboard (TextComponent t) 
  {
    java.awt.datatransfer.Clipboard cb = Toolkit.getDefaultToolkit().getSystemClipboard();
    Transferable tf = cb.getContents( this);
    
    if ( tf != null )
      {
	try 
	  {
	    String s = (String) tf.getTransferData( DataFlavor.stringFlavor);
	    replaceSelectionWith(t, s);
	  }
	catch ( Exception x ) {}
      }
  }


  void copyToClipboard (TextComponent t) 
  {
    java.awt.datatransfer.Clipboard cb = Toolkit.getDefaultToolkit().getSystemClipboard();
    String sel = t.getSelectedText();
    if ( (sel != null) && (sel.length() > 0) ) 
      {
	StringSelection ss = new StringSelection( sel);
	cb.setContents( ss, ss);
      }
  }

  public void replaceSelectionWith (TextComponent t, String s)
  {
    if (s == null)
      {
	s = "";
      }
    String src = t.getText ();
    int start = t.getSelectionStart ();
    int end = t.getSelectionEnd ();

    src = src.substring (0, start) + s + src.substring (end);
    t.setText (src);
    t.setSelectionStart (start);
    t.setSelectionEnd (start + s.length ());
  }

}

