/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: Anchor.java,v 1.9 2001/12/05 21:15:05 joerg Exp $
 */ 
package org.xoe.display.dom.xhtml;

import java.awt.Color;
import java.awt.Cursor;
import java.awt.event.MouseEvent;

import org.w3c.dom.Document;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;

import org.xoe.core.dom.Callback;
import org.xoe.core.dom.SingleNodeList;
import org.xoe.display.dom.LayoutCursor;
import org.xoe.display.dom.ViewElement;


public class Anchor
  extends ViewElement
{
  static final Cursor anchorCursor = new Cursor (Cursor.HAND_CURSOR);
  
	
  private SingleNodeList anchor;
  
  /**
   * used for local reference positioning ( <a name="ref"> ) until implemented
   * an element positioning abstraction layer to speed up rendering/scrolling
   * for large documents
   */
  public int refPosY;
  
  public void layout (LayoutCursor cur) 
  {
    Color ofgclr = cur.fgclr;
    Anchor oanchor = (Anchor)cur.anchor; 
    if (cur.isPhase3 ())
    { 
      refPosY = cur.y; 
      anchor = new SingleNodeList (getOwnerDocument ().createTextNode (getAttribute ("href")));
    }

    cur.anchor = this;
    cur.fgclr = cur.anchorclr;

    layoutChildren (cur);

    cur.fgclr = ofgclr;
    cur.anchor = oanchor;
  }

  public void mouseClicked (MouseEvent evt) 
  {
    invoke(HREF_ATTR);
  }

  public Node cloneNode (boolean deep) 
  {
    Anchor cloned = (Anchor)super.cloneNode (deep);
    if (anchor != null)
      {
        cloned.anchor = new SingleNodeList (anchor.item(0));
      }
    return cloned;
  } 
}










