/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: Backdrop.java,v 1.6 2001/10/25 17:11:03 philippe Exp $
 */ 
package org.xoe.display.dom.xhtml;

import com.pocketlinux.awt.theme.BackgroundImage;

import java.awt.Component;
import java.awt.Container;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;

import kaffe.awt.AWT;
import kaffe.awt.theme.Theme;

import org.xoe.display.dom.ImageFactory;
import org.xoe.display.dom.ImageHolder;
import org.xoe.display.dom.LayoutCursor;
import org.xoe.display.dom.ViewElement;


public class Backdrop
  extends ViewElement implements ImageHolder
{
  private LayoutCursor cur = new LayoutCursor ();
  private Container pane = new LayoutCursor.DummyContainer ();
  private Image backgroundImg;

  class Render
    extends Container
    implements BackgroundImage
  {
    public Image getBackgroundImage ()
    {
      return (backgroundImg);
    }

    public void paint (Graphics g)
    {
      AWT.extension.paintBackground (this, g);
      super.paint (g);
    }
  }

  public void layout(LayoutCursor ocur)
  {
    ocur.newline ();
    cur.set(ocur, this);
    cur.useProxyVis (); // Necessary to handle centering, etc.

    layoutChildren (cur);
    cur.finish ();
    int width = cur.width;
    if (cur.maxwidth > width)
      {
	width = cur.maxwidth;
      }
    int height = cur.height;
    if (cur.y > height)
      {
	height = cur.y;
      }
    ocur.setBounds (getVis (), width, height);
    ocur.move (width, height);
  }

  protected void makeVis ()
  {
    vis = new Render ();
  }

  public void imageDeliver (String url, Image nimg)
  {
    if (backgroundImg != nimg)
      {
	backgroundImg = nimg;
	if (vis != null)
	  {
	    vis.repaint ();
	  }
      }
  }

  public void setBackground (String img)
  {
    setBackground ((Color)null);
    ImageFactory.getImage (img, this);
  }

  public void setBackground (Color clr)
  {
    backgroundImg = null;
    getVis ().setBackground (clr);
    redraw(false);
  }
}
