/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: HRule.java,v 1.4 2001/10/22 22:18:42 colin Exp $
 */ 
package org.xoe.display.dom.xhtml;

import kaffe.awt.*;

import java.awt.*;

import org.w3c.dom.Node;

import org.xoe.display.dom.LayoutCursor;
import org.xoe.display.dom.ViewElement;


public class HRule
	extends ViewElement
{
  final static private int RHEIGHT = 8;
  final static private int RINDENT = 4;

  private int width;

  class Render extends Component 
  {

    public void paint (Graphics g) 
    {
      g.drawRect (RINDENT, RHEIGHT/2-1, AWT.extension.getWidth (this)-RINDENT*2, 2);
    }
    
  }

  public HRule () 
  {
    setPreferredWidth (-100);
  }

  public Node cloneNode  (boolean deep)
  {
    HRule nnode = (HRule)super.cloneNode (deep);
    nnode.width = width;
    return nnode;
  }


  public void layout (LayoutCursor cur) 
  {
    cur.newline ();
    switch (cur.phase) 
      {
      case LayoutCursor.PHASE1:
	width = 1;
	if (preferredWidth > width) 
	  {
	    width = preferredWidth;
	  }
	break;

      case LayoutCursor.PHASE2:
	width = getPreferredWidth (cur.width);
	break;

      case LayoutCursor.PHASE3:
	cur.addVis (this);
	cur.setLocation (vis);
	vis.setSize (width, RHEIGHT);
	break;
      }
    cur.move (width, RHEIGHT);
    cur.newline ();
  }
  
  protected void makeVis () 
  {
    vis = new Render ();
  }
}
