/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: Header.java,v 1.7 2001/11/02 00:13:16 suraj Exp $
 */ 
package org.xoe.display.dom.xhtml;

import java.awt.Component;
import java.awt.Graphics;

import kaffe.awt.AWT;

import org.w3c.dom.Node;

import org.xoe.core.dom.XDocument;
import org.xoe.display.dom.LayoutCursor;
import org.xoe.display.dom.ViewElement;

import java.net.MalformedURLException;
import java.net.URL;

public class Header
  extends ViewElement 
{
  String base;
  
  public void layout (LayoutCursor cur) 
  {
    if (cur.isPhase3()) 
     {
        String tag = getLocalName ();

	if ("base".equalsIgnoreCase (tag) && base != null) 
	  {
	    URL base_url = null;
    
            try
              {
	        base_url = new java.net.URL(base);
              }
            catch (MalformedURLException e1)
              {
	        //suppose base is of form /dir instead of full new url
                try
                  {
                    base_url = new java.net.URL(((XDocument)this.getOwnerDocument ()).getURL(), base);
                  }
                catch (MalformedURLException e2)
                  {
		    //let it be null, will have no effect
                  }

              }    

            ((XDocument)this.getOwnerDocument ()).setBaseURL (base_url);
           
	    base = null;

	  }

      }

  }
  
  public Node cloneNode (boolean deep)
  {
    Header nnode = (Header)super.cloneNode (deep);
    nnode.base = base;
    return nnode;
  }

	
  public void setAttributeNS (String namespaceURI, String qualifiedName, String value)
  {
    String localName = getLocalName (qualifiedName);
    if (localName.equalsIgnoreCase ("href"))  
      {
        base = value;
      }
  }

}


