/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: Itemize.java,v 1.5 2001/11/02 00:13:16 suraj Exp $
 */ 
package org.xoe.display.dom.xhtml;

import org.w3c.dom.Node;

import org.xoe.core.util.Logger;
import org.xoe.display.dom.LayoutCursor;
import org.xoe.display.dom.ViewElement;


public class Itemize
  extends ViewElement 
{
  
  final static char DISC = 'd';
  final static char CIRCLE = 'c';
  final static char SQUARE = 's';
  
  int start = 1;
  int count;
  char type = '1';
  
  public void layout (LayoutCursor cur) 
  {
    cur.listlevel++;
    count = start - 1;
    cur.newline ();
    layoutChildren (cur);
    cur.newline ();
    cur.listlevel--;
  }

  public Node cloneNode (boolean deep)
  {
    Itemize nnode = (Itemize)super.cloneNode (deep);
    nnode.start = start;
    nnode.count = count;
    nnode.type = type;
    return nnode;
  }
  public void setAttributeNS (String namespace, String qualifiedName, String value) 
  {
    String localName = getLocalName (qualifiedName);
    if ("type".equalsIgnoreCase (localName)) 
      {
	char ch = value.charAt (0);
	switch (ch) 
	  {
	  case 'A':
	  case 'a':
	  case '1':
	    type = ch;
	    break;
	  case 'I':
	  case 'i':
	    // Not yet supported - use numbers
	    type = '1';
	    break;
	  default:
	    if ("disc".equalsIgnoreCase (value)) 
	      {
		type = DISC;
	      }
	    else if ("circle".equalsIgnoreCase (value)) 
	      {
		type = CIRCLE;
	      }
	    else if ("square".equalsIgnoreCase (value)) 
	      {
		type = SQUARE;
	      }
	    else {
	      type = '1';
	    }
	    break;
	  }
      }
    else if ("start".equalsIgnoreCase (localName)) 
      {
	try {
	  start = Integer.parseInt (value);
	}
	catch (NumberFormatException nfe) 
	  {
	    Logger.log(this, nfe);
	  }
	}
    super.setAttributeNS(namespace, qualifiedName, value);
  }
}
