/*
 * Copyright (c) 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *  
 * $tvt: TableRow.java,v 1.4 2001/11/02 00:13:16 suraj Exp $
 */ 
package org.xoe.display.dom.xhtml;

import java.awt.Dimension;
import java.awt.Color;

import org.w3c.dom.*;

import org.xoe.display.dom.LayoutCursor;
import org.xoe.display.dom.ViewElement;


public class TableRow
  extends ViewElement 
{
  
  Color bgcolor;
  int align = LayoutCursor.NONE;
  int valign = LayoutCursor.NONE;

  public TableRow () 
  {
  }

 
  public void setAttributeNS (String namespaceURI, String qualifiedName, String value)
  {
    String localName = getLocalName (qualifiedName);
    if ("bgcolor".equalsIgnoreCase (localName)) 
      {
	bgcolor = Emphasis.getColor (value, null);
      }
    else if ("align".equalsIgnoreCase (localName)) 
      {
	align = Emphasis.getAlign (value, align);
      }
    else if ("valign".equalsIgnoreCase (localName)) 
      {
	valign = Emphasis.getAlign (value, valign);
      }
    super.setAttributeNS (namespaceURI, qualifiedName, value);
  }

  public String toString () 
  {
    return (getClass ().getName ());
  }

  public Node cloneNode (boolean deep) 
  {
    TableRow nnode = (TableRow)super.cloneNode (deep);
    nnode.bgcolor = bgcolor;
    nnode.align = align;
    nnode.valign = valign;
    return nnode;
  }
}
