package org.xoe.display.dom;

import com.pocketlinux.awt.theme.BackgroundImage;

import java.awt.Container;
import java.awt.Color;
import java.awt.Image;
import java.net.URL;

import kaffe.awt.AWT;

import org.w3c.dom.Node;

import org.xoe.display.dom.FloatViewElement;
import org.xoe.display.dom.LayoutCursor;


public class ScrollPane
  extends FloatViewElement
{
  public class Render
    extends java.awt.ScrollPane implements Cloneable 
  {
    
    public Render (int policy) 
    {
      super  (policy);
    }
  }

  int align = LayoutCursor.NONE;
  Render render;
  Container pane;
  int wadjust;
  int hadjust;
  int maxwidth;
  LayoutCursor cur = new LayoutCursor ();
  int policy = java.awt.ScrollPane.SCROLLBARS_AS_NEEDED;
  
  public ScrollPane () 
  {
    setPreferredWidth(-100);
    setPreferredHeight(-100);
  }

  public Node cloneNode (boolean deep) 
  {
    ScrollPane nnode = (ScrollPane)super.cloneNode (deep);
    nnode.render = null;
    nnode.pane = null;
    nnode.wadjust = wadjust;
    nnode.hadjust = hadjust;
    nnode.maxwidth = maxwidth;
    nnode.cur = new LayoutCursor ();
    nnode.policy = policy;
    return nnode;
  }

  public void layout (LayoutCursor ocur) 
  {
    int cwidth = 1;
    int cheight = 1;
    
    switch (ocur.phase) 
      {
      case LayoutCursor.PHASE1:
	if (preferredWidth > cwidth)
	  {
	    cwidth = preferredWidth;
	  }
	else if (getPreferredWidth(ocur.width) == -1)
	  {
	    layout2 (ocur);
	    cwidth = cur.maxwidth;
	  }
	break;
      case LayoutCursor.PHASE2:
	if (preferredHeight > cheight)
	  {
	    cheight = preferredHeight;
	  }
	else if (getPreferredHeight(ocur.height) == -1)
	  {
	    layout2 (ocur);
	    cwidth = cur.maxwidth;
	    cheight = cur.y;
	  }
	break;
      case LayoutCursor.PHASE3:
	layout2 (ocur);
	cwidth = cur.width;
	cheight = cur.height;
	break;
      }
    
    switch (align) 
      {
      case LayoutCursor.LEFT:
      case LayoutCursor.RIGHT:
	ocur.flow(this, align, cwidth, cwidth, cheight);
	break;
	
      case LayoutCursor.TOP:
      case LayoutCursor.BOTTOM:
	ocur.valign = align;
	// Fall though
      case LayoutCursor.NONE:
      default:
	ocur.newline(cwidth);
	if (cur.isPhase3 ()) 
	  {
	    ocur.addVis(this);
	    ocur.setLocation(vis);
	    vis.setSize(cwidth, cheight);
	  }
	ocur.move(cwidth, cheight);
	break;
      }
  }

  private void layout2(LayoutCursor ocur)
  {
    int cwidth = getPreferredWidth(ocur.width);
    int cheight = getPreferredHeight(ocur.height);
    cur.set(ocur, this);
    cur.vis = pane;
    cur.useProxyVis ();
    cur.setArea(0, 0, cwidth == -1 ? ocur.width : cwidth, cheight == -1 ? ocur.height : cheight);
    cur.phase = LayoutCursor.PHASE1;
    layout3();
    cur.setArea(0, 0, cwidth == -1 ? (ocur.width < cur.maxlinewidth ? ocur.width : cur.maxlinewidth) : cwidth, cheight == -1 ? ocur.height : cheight);
    cur.phase = LayoutCursor.PHASE2;
    layout3();
    cur.setArea(0, 0, cwidth == -1 ? (ocur.width < cur.maxlinewidth ? ocur.width : cur.maxlinewidth) : cwidth, cheight == -1 ? (ocur.height < cur.y ? ocur.height : cur.y) : cheight);
    cur.phase = LayoutCursor.PHASE3;
    layout3();
  }

  private void layout3() 
  {
    // If we're fixing the layout, we should align the contents as
    // appropriate
//System.out.println(this + " -> PHASE " + cur.phase + " start");
    switch (cur.phase) 
      {
      case LayoutCursor.PHASE1:
      default:
	wadjust = 0;
	hadjust = 0;
	layoutChildren (cur);
	cur.finish ();
	break;
      case LayoutCursor.PHASE2:
	layoutChildren (cur);
	cur.finish ();
	if (cur.maxwidth > cur.width) 
	  {
	    // Too wide - we add a scrollbar
	    hadjust = render.getHScrollbarHeight ();
	    cur.height -= hadjust;
	  }
	if (cur.y > cur.height) 
	  {
	    // Too long - we add a scrollbar and recompute
	    wadjust = render.getVScrollbarWidth();
	    cur.width -= wadjust;
	    cur.reset ();
	    layoutChildren (cur);
	    cur.finish ();
	    if (cur.maxwidth > cur.width) 
	      {
		hadjust = render.getHScrollbarHeight();
	      }
	  }
	maxwidth = cur.maxwidth;
	break;

      case LayoutCursor.PHASE3:
	int ow = cur.width;
	cur.width -= wadjust;
	if (maxwidth > cur.width) 
	  {
	    cur.width = maxwidth;
	  }
	cur.height -= hadjust;

	pane.removeAll ();
	layoutChildren (cur);
	cur.finish ();
	int cw = cur.maxwidth;
	int ch = cur.y;
	cur.width = ow;
	cur.height += hadjust;
	if (cw < cur.width) 
	  {
	    cw = cur.width;
	  }
	if (ch < cur.height) 
	  {
	    ch = cur.height;
	  }
	pane.setSize(cw, ch);
	render.add (pane);
	break;
      }
//System.out.println(this + " -> PHASE " + cur.phase + " end");
  }

  public void setAttributeNS (String namespaceURI, String qualifiedName, String value) {
    String localName = getLocalName (qualifiedName);
    if ("scrolling".equalsIgnoreCase (localName)) 
      {
	if ("no".equalsIgnoreCase (value)) 
	  {
	    policy = java.awt.ScrollPane.SCROLLBARS_NEVER;
	  }
	else if ("yes".equalsIgnoreCase (value)) 
	  {
	    policy = java.awt.ScrollPane.SCROLLBARS_ALWAYS;
	  }
	else if ("auto".equalsIgnoreCase (value)) 
	  {
	    policy = java.awt.ScrollPane.SCROLLBARS_AS_NEEDED;
	  }
      }
    else if (localName.equalsIgnoreCase ("align")) 
      {
	if ("left".equalsIgnoreCase (value))
	  {
	    align = LayoutCursor.LEFT;
	  }
	else if ("right".equalsIgnoreCase (value))
	  {
	    align = LayoutCursor.RIGHT;
	  }
	else if ("center".equalsIgnoreCase (value))
	  {
	    align = LayoutCursor.CENTER;
	  }
      }
    super.setAttributeNS (namespaceURI, qualifiedName, value);
  }

  protected void makeVis () 
  {
    render = new Render (policy);
    pane = new LayoutCursor.DummyContainer ();
    vis = render;
  }

  public void setPosition (int x, int y) 
  {
    if (render != null)
      {
	render.setScrollPosition (x, y);
      }
     
  }
   
  public void resetPosition ()
  {
    if (render != null)
      {
	render.setScrollPosition (0, 0);
      }
  }
}
