package com.pocketlinux.xs;

import com.pocketlinux.awt.Viewable;
import com.pocketlinux.awt.ViewElement;
import com.pocketlinux.awt.DocFrame;
import com.pocketlinux.awt.DocScrollPane;
import com.pocketlinux.awt.IBrowser;
import com.pocketlinux.awt.LayoutCursor;
import com.pocketlinux.awt.XHTMLRender;
import com.pocketlinux.device.Device;
import com.pocketlinux.dom.BaseDocument;
import com.pocketlinux.dom.BaseElement;
import com.pocketlinux.dom.DocumentCache;
import java.awt.*;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Observer;
import kaffe.awt.AWT;
import kaffe.xs.XsArray;
import kaffe.xs.XsEngine;
import kaffe.xs.XsObject;
import kaffe.xs.XsString;
import org.w3c.dom.Node;

public class TopView
  extends DocFrame
  implements IBrowser
{
	final private static String CLASSNAME = "com.pocketlinux.xs.TopView";
	LayoutCursor cur = new LayoutCursor();
	protected static TopView instance;
	DOM0Adaptor context;

public void loadTheme (String theme) {
}

public static XsObject _revalidate( XsObject xThis, XsArray args ) {
	getInstance().redraw(true);
	return xThis;
}

private void dispatchSelect( Viewable v) {
	Node sel = v.getFirstSelected();
	if ( sel != null ) {
		String ref = sel.getNodeValue();
		if ( ref.startsWith( "javascript:") ) {
			String script = ref.substring( 11);
			//System.out.println( "interpreting: " + script);
			try {
				XsEngine.interpret( XsObject.top, XsObject.top, script);	
			}
			catch ( Throwable _ ) {
			}
		}
		else {
			DOM0Adaptor doc = (DOM0Adaptor)v.getOwnerDocument();
			doc.getRoot().xsGet("location").xsPut("href", new XsString( ref));
		}
	}
}

public void setContainer(Container x) {
}

public DOM0Adaptor getContext() {
	return context;
}

public static TopView getInstance() {
	if ( instance == null ) {
		instance = new TopView();
		browser = instance;
	}
	return instance;
}

public String getTitle( ) {
	if (context != null) {
		Node n = context.findFirstNode("//title");
		if (n != null) {
			return (n.getFirstChild().getNodeValue());
		}
	}
	return (context.getURL().toString());
}

public static void main( String[] args ) {
	if ( args.length < 2 ) {
		System.out.println( "usage: TopView <Stash> <pageURL>");
		return;
	}

	if ( Device.initOK( args) ) {
		Frame fr = new Frame();

		fr.add( TopView.getInstance().getCVis());
		TopView.getInstance().setSrc( args[1] );

		fr.setTitle( TopView.getInstance().getTitle() );

		Insets in = fr.getInsets();
		fr.setBounds( 0, 0, 640 + in.left + in.right, 480 + in.top + in.bottom);
		fr.setVisible( true);
	}
}

protected void makeVis() {
	// vis = new Render();
	vis = new XHTMLRender();
}

public void redraw() {
}

public void setSrc( String loc) {
	if ( loc != null ) {
		if ( ! loc.startsWith( "http:")) {
			if ( loc.startsWith( "www") ) 
			  {
			    loc = "http://" + loc;
			  }
			else if ( ! loc.startsWith( "stash:" )) 
			  {
			    loc = "stash:" + loc;
			  }
		}

		try {
			setSrc( new URL( loc));
		}
		catch ( MalformedURLException _) {
		}
	}
}

public void setSrc( URL url) {
	context = (DOM0Adaptor)DocumentCache.fetchDocument(url);
	XsObject root = context.getRoot();
	((XHTMLRender)getVis()).setDocument(context);
	XsObject.top = root;
	root.xsPut( "update_browser", root.defFunc("revalidate") );
}

public void setTitle( String title) {
	for ( Component c = vis; c != null; c = c.getParent() ) {
		if ( c instanceof Frame ) {
			((Frame)c).setTitle( title);
		}
	}
}

public DocScrollPane getFrame(String name) {
	return (null);
}

public void addObserver(Observer obs) {
}

public void removeObserver(Observer obs) {
}

public void dispatchCommand(String command, Node arg) {
	if ( SELECT.equalsIgnoreCase(command) ) {
		dispatchSelect( (Viewable)arg);
	}
}

}
