/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *
 * $tvt: DOM0Attrs.java,v 1.16 2001/09/10 16:48:06 philippe Exp $
 */
package kaffe.xs;

import java.awt.Component;
import java.awt.Frame;
import java.awt.Point;
import java.awt.ScrollPane;
import java.net.URL;
import java.util.Vector;
import kaffe.awt.AWT;


class AttrDocument
  extends XsObject
{

static String[] methods = { "close", "open", "write", "writeln"};

AttrDocument( XsObject doc, XsString loc) {
	init( doc, loc);
}

public static XsObject _captureEvents ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _close ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _contextual ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _getSelection ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _handleEvent ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _open ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _releaseEvents ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _routeEvent ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _write ( XsObject xThis, XsArray args ){

	//System.out.println( args.xsGet( 0));
	/*   
problem with yahoo.com

	if(args.count == 0)
		return _undefined;  //what to do??
 
        String src = args.elements[0].toString();
               
        XsEngine e = new XsEngine();
        
	e.createWriteGeneratedDocument(src);
	*/
        return _undefined;
}

public static XsObject _writeln ( XsObject xThis, XsArray args ){
	System.out.println( args.xsGet( 0));
	return _undefined;
}

static XsObject init( XsObject doc, XsString loc) {
	doc.xsPut( "URL", loc);
	doc.xsPut( "all", new XsArray() );
	
	for ( int i = 0; i < methods.length; i++ ) { 
		doc.xsPut( methods[i], XsFunc.getFunc(methods[i], AttrDocument.class));
	}

        
       
/************* props *******************
	alinkColor;
	anchors;
	applets;
	bgColor;
	classes;
	cookie;
	domain;
	embeds;
	fgColor;
	formName;
	forms;
	height;
	ids;
	images;
	lastModified;
	layers;
	linkColor;
	links;
	plugins;
	referrer;
	tags;
	title;
	URL;
	vlinkColor;
	width;
****************************************/
	
	return doc;
}
	/*
public XsObject xsPut( String key, XsObject val) {
	if ( key.equals( "location")) {
		return DOM0Attrs.location_object.xsPut(key, val);              
	}
        else{
	        return super.xsPut( key, val);
        }
	}*/
	


}











class AttrHistory
  extends XsObject
{
	static String[] methods = { "go", "back", "forward"};

AttrHistory( XsObject doc, XsString loc) {
	init( this, loc);
}

public static XsObject _back ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _forward ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _go ( XsObject xThis, XsArray args ){
	return _undefined;
}

static XsObject init( XsObject doc, XsString loc) {

	for ( int i = 0; i < methods.length; i++ ) { 
		doc.xsPut( methods[i], XsFunc.getFunc(methods[i], AttrHistory.class));
	}

	/************ properties *************
	current;
	length;
	next;
	previous;
	***************************************/

	return doc;
}
}












class AttrLocation
  extends XsObject
{
	static String[] methods = {"reload", "replace"};
	XsObject doc;

AttrLocation( XsObject doc, XsString loc) {
	this.doc = doc;
	init( this, loc);
}

public static XsObject _reload ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _replace ( XsObject xThis, XsArray args ){
	return _undefined;
}

URL getURL( String rel) {
	try {
		XsObject su = super.xsGet( "href");
		if ( su != _undefined ) {
			URL ub = new URL( su.toString() );
			if ( rel != null )
				ub =  new URL( ub, rel );
			return ub;
		}
	}
	catch ( Exception _ ) {
	}

	return null;

}

static XsObject init( XsObject doc, XsString loc) {
	doc.xsPut( "href", loc);
	
	for ( int i = 0; i < methods.length; i++ ) { 
		doc.xsPut( methods[i], XsFunc.getFunc(methods[i], AttrLocation.class));
	}

/************* props *******************
	hash;
	host;
	hostname;
#	href;
	pathname;
	port;
	protocol;
	search;
****************************************/
	
	return doc;
}

public XsObject xsGet( String key) {
	URL url = getURL(null);
	if ( url != null ) {
		if ( key.equals( "pathname")) {
			return new XsString( url.getFile() );
		}
		else if ( key.equals( "protocol")) { 
			return new XsString( url.getProtocol() );
		}
	}
	return super.xsGet( key);
}

public XsObject xsPut( String key, XsObject val) {
	//System.out.println("In location's xsPut, key is " + key + " val is " + val);

	if ( key.equals( "href")) {
		URL u1 =  getURL( val.toString()) ;
		if ( u1 != null ) {
			XsString us = new XsString( u1.toString() );
			XsObject dv = xsGet( "doc_view");
			if ( dv != XsObject._undefined ) {
				dv.xsPut( "doc_open", us);
			}	
			return super.xsPut( key, us );
		}
	}
       
	return super.xsPut( key, val);
}
}





class AttrNavigator
  extends XsObject
{
AttrNavigator( ) {
	init( this);
}

public static XsObject _javaEnabled ( XsObject xThis, XsArray args ){
	return xTrue;
}

public static XsObject _preference ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _savePreferences ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _taintEnabled ( XsObject xThis, XsArray args ){
	return xFalse;
}

private static void init ( XsObject proto) {
	proto.xsPut( "mimeTypes", new XsArray() );
	proto.xsPut( "plugins", new XsArray() );	
			
    	proto.xsPut( "appCodeName", new XsString("XoeRider") );
	proto.xsPut( "appName", new XsString("XoeRider") );
	proto.xsPut( "appVersion", new XsString("XoeWebTV") );
	proto.xsPut( "language", new XsString("english") );
	proto.xsPut( "platform", new XsString("all") );
	proto.xsPut( "userAgent", new XsString("XoeRider") );
	
}

}






class AttrWindow
  extends XsObject
{
	static String[] methods = { "print", "setTimeout", "clearTimeout", "setInterval", "clearInterval", 
			      "stop", "scroll", "scrollTo", "scrollBy", "focus", "resizeTo", "resizeBy",
			      "forward", "back"};

AttrWindow ( XsObject doc, XsString loc) {
	init( doc, loc);
}

public static XsObject _alert ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _atob ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _back ( XsObject xThis, XsArray args ){
	return AttrHistory._back( xThis, args);
}

public static XsObject _blur ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _btoa ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _captureEvent ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _clearInterval ( XsObject xThis, XsArray args ){
	XsTimeout.deschedule( xThis, args);
	return xThis;
}

public static XsObject _clearTimeout ( XsObject xThis, XsArray args ){
	XsTimeout.deschedule( xThis, args);
	return xThis;
}

public static XsObject _close ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _confirm ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _disableExternalCapture ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _enableExternalCapture ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _find ( XsObject xThis, XsArray args ){
	//find a String in the current window
	return _undefined;
}

public static XsObject _focus ( XsObject xThis, XsArray args ){
	XsObject redir = xThis.xsGet( "doc_view");
	if ( redir != _undefined ) {
		Component c = xThis.getAWTComponent( false);;
		c.requestFocus(); 
	}
	return _undefined;
}

public static XsObject _forward ( XsObject xThis, XsArray args ){
	return AttrHistory._forward( xThis, args);
}

public static XsObject _handleEvent ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _home ( XsObject xThis, XsArray args ){
	//switch to user's home page
	return _undefined;
}

public static XsObject _moveBy ( XsObject xThis, XsArray args ){
	//only for top window / document
	if ( top == xThis ) {
		XsObject redir = xThis.xsGet( "doc_view");
		if ( redir != _undefined ) {
			Component c = redir.getAWTComponent( true);
			int x = AWT.extension.getX( c) + ((XsNumber)args.xsGet(0)).getIntValue();
			int y = AWT.extension.getY( c) + ((XsNumber)args.xsGet(1)).getIntValue();
			c.setLocation( x, y ); 
		}
	}
	return _undefined;
}

public static XsObject _moveTo ( XsObject xThis, XsArray args ){
	//only for top window / document
	if ( top == xThis ) {
		XsObject redir = xThis.xsGet( "doc_view");
		if ( redir != _undefined ) {
			Component c = redir.getAWTComponent( true);
			int x = ((XsNumber)args.xsGet(0)).getIntValue();
			int y = ((XsNumber)args.xsGet(1)).getIntValue();
			c.setLocation( x, y ); 
		}
	}
	return _undefined;
}

public static XsObject _open ( XsObject xThis, XsArray args ){
	//this seems to be about opening a new frame / browser window
	return _undefined;
}

public static XsObject _print ( XsObject xThis, XsArray args ){
	int i = 0;

	if ( args.count > 0 ){
		while ( true ){
			System.out.print( args.elements[i]);
			i++;
			if ( i == args.count ){
				System.out.println();
				break;
			}
			else {
				System.out.print(' ');
			}
		}
	}

	return _undefined;
}

public static XsObject _prompt ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _releaseEvents ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _resizeBy ( XsObject xThis, XsArray args ){
	//only for top window / document
	if ( top == xThis ) {
		XsObject redir = xThis.xsGet( "doc_view");
		if ( redir != _undefined ) {
			Component c = xThis.getAWTComponent( true);;
			int w = AWT.extension.getWidth( c) + ((XsNumber)args.xsGet(0)).getIntValue();
			int h = AWT.extension.getHeight( c) + ((XsNumber)args.xsGet(1)).getIntValue();
			c.setSize( w, h ); 
		}
	}
	return _undefined;
}

public static XsObject _resizeTo ( XsObject xThis, XsArray args ){
	//only for top window / document
	if ( top == xThis ) {
		XsObject redir = xThis.xsGet( "doc_view");
		if ( redir != _undefined ) {
			Component c = xThis.getAWTComponent( true);
			int w = ((XsNumber)args.xsGet(0)).getIntValue();
			int h = ((XsNumber)args.xsGet(1)).getIntValue();
			c.setSize( w, h ); 
		}
	}
	
	return _undefined;
}

public static XsObject _routeEvent ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _scroll ( XsObject xThis, XsArray args ){
	return _scrollTo( xThis, args);
}

public static XsObject _scrollBy ( XsObject xThis, XsArray args ){
	XsObject redir = xThis.xsGet( "doc_view");
	if ( redir != _undefined ) {
		ScrollPane p = (ScrollPane)redir.getAWTComponent(false);
		Point pp = p.getScrollPosition();
		int x = pp.x + ((XsNumber)args.xsGet(0)).getIntValue();
		int y = pp.y + ((XsNumber)args.xsGet(1)).getIntValue();
		p.setScrollPosition(x, y); 
	}
	return _undefined;
}

public static XsObject _scrollTo ( XsObject xThis, XsArray args ){
	XsObject redir = xThis.xsGet( "doc_view");
	if ( redir != _undefined ) {
		ScrollPane p = (ScrollPane)redir.getAWTComponent( false);
		int x = ((XsNumber)args.xsGet(0)).getIntValue();
		int y = ((XsNumber)args.xsGet(1)).getIntValue();
		p.setScrollPosition(x, y); 
	}
	return _undefined;
}

public static XsObject _setHotKeys ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _setInterval ( XsObject xThis, XsArray args ){
	return XsTimeout.schedule( xThis, args, true);
}

public static XsObject _setResizable ( XsObject xThis, XsArray args ){
	//only for top window / document
	if ( top == xThis ) {
		XsObject redir = xThis.xsGet( "doc_view");
		if ( redir != _undefined ) {
			Component c = redir.getAWTComponent( true);;
			if ( c instanceof Frame ) {
				((Frame)c).setResizable( (args.xsGet( 0) == xTrue) ? true : false);
			}
		}
	}
	return _undefined;
}

public static XsObject _setTimeout ( XsObject xThis, XsArray args ){
	return XsTimeout.schedule( xThis, args, false);
}

public static XsObject _setZOptions ( XsObject xThis, XsArray args ){
	return _undefined;
}

public static XsObject _stop ( XsObject xThis, XsArray args ){
	//stop current download
	return _undefined;
}

static XsObject  init ( XsObject doc, XsString loc) {
	doc.xsPut("frames", new XsArray() );
	doc.xsPut("closed", xFalse);

	for ( int i = 0; i < methods.length; i++ ) { 
		doc.xsPut( methods[i], XsFunc.getFunc(methods[i], AttrWindow.class));
	}

        doc.xsPut("navigator", DOM0Attrs.navigator_object);
        //doc.xsPut("location", DOM0Attrs.location_object);


/************* props *******************
	crypto;
	defaultStatus;
#	document;
#	frames;
	history;
	innerHeight;
	innerWidth;
	length;
	location;
	locationbar;
	menubar;
	name;
	offscreenBuffering;
	opener;
	outerHeight;
	outerWidth;
	pageXOffset;
	pageYOffset;
	parent;
	personalbar;
	screenX;
	screenY;
	scrollbars;
#	self;
	status;
	statusbar;
	toolbar;
#	top;
#	window;
****************************************/

	return doc;
}
	/*
public XsObject xsPut( String key, XsObject val) {
	System.out.println("HERE HERE HERE");
        if ( key.equals( "location")) {
		return DOM0Attrs.location_object.xsPut("href", val);              
	}
        else{
	        return super.xsPut( key, val);
        }

}
	*/

}


//must make this reentrant

public class DOM0Attrs
{
	static AttrNavigator navigator_object; 

        //static AttrLocation  location_object; 
	
        //static XsObject doc; 

public static void init( XsObject doc, XsString loc) {
	
        //DOM0Attrs.doc = doc; 

        doc.xsPut( "self", doc);
	
	doc.xsPut( "history", new AttrHistory( doc, loc));
	
        doc.xsPut( "location",  /*location_object =  */new AttrLocation( doc, loc));

        doc.xsPut( "navigator", navigator_object = new AttrNavigator());

        
        doc.xsPut( "window", AttrWindow.init( doc, loc));
        doc.xsPut( "document", AttrDocument.init( doc, loc));
}
}








