/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *
 * $tvt: XsFunc.java,v 1.41 2001/08/14 17:03:07 philippe Exp $
 */
package kaffe.xs;

import java.lang.reflect.Method;
import java.io.*;
import java.util.Hashtable;
import java.util.StringTokenizer;
import java.util.Properties;

public class XsFunc
  extends XsObject
{
	Method mth;
	XsFunc next;
	Class ctorClass;
        public boolean anonymous = false;  // public for debugging
	static XsFunc cache;
        private static long anonymous_sequence = 0;
        private static XsEngine anonymous_function_compiler; 
	static Class[] argTypes = { XsObject.class, XsArray.class };
	static Object[] argObj = new Object[2];
	public static XsArray noArgs = new XsArray(0);
	static XsString typeStrFunc = new XsString("function");

        protected static XsObject function__proto__;

        protected static XsFunc _prototype;
 
static{
        function__proto__ = new XsObject();

        XsPropertyAttributes propattrs;
        XsFunc func;
        
        function__proto__.xsPut( "apply", func = (XsFunc) XsFunc.getFunc("apply", XsFunc.class));
        
        func.xsPut("length", new XsNumber(2)); 
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)function__proto__.properties_attributes.get("apply"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        
        function__proto__.xsPut( "call", func = (XsFunc) XsFunc.getFunc("call", XsFunc.class));
        func.xsPut("length", new XsNumber(1)); 
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)function__proto__.properties_attributes.get("call"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        function__proto__.xsPut( "HasInstance", func = (XsFunc) XsFunc.getFunc("HasInstance", XsFunc.class));
        func.xsPut("length", new XsNumber(1)); 
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)function__proto__.properties_attributes.get("HasInstance"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       




        _prototype = (XsFunc) XsFunc.getFunc("Prototype", XsFunc.class);
}



public XsFunc() {
	//System.err.println("Called");
        //this(null, (Class) null, false);
}
	
XsFunc ( Method mth, Class  c, boolean anonym ) {
	this.mth = mth;
        __proto__ = new XsObject();
        
        __proto__.xsPut("constructor", this);
        __proto__.__proto__ = function__proto__;
        ctorClass = c;
        anonymous = anonym;
}

XsFunc ( Method mth) {
        this(mth, (Class)null, false);
}

//ctx not used ?!?!	
XsFunc ( Method mth, XsObject ctx, boolean anonym ) {
        this.mth = mth;
	__proto__ = new XsObject();
        
        __proto__.xsPut("constructor", this);
        __proto__.__proto__ = function__proto__;
        ctorClass = XsObject.class; // don't put ctx.getClass(), but what is ctx for then???
        anonymous = anonym;
}

public static XsObject _apply ( XsObject xThis, XsArray args ){
	XsObject o;
        XsObject call_args;
        //System.out.println("In apply");
        if(args.count == 0){
		return _undefined;
        }
        else if(args.count == 1){
                o = args.elements[0];
                call_args = noArgs;  
        }
        else{
                o = args.elements[0];
                call_args =  args.elements[1];
        }
        //System.out.println("call_args are " + call_args); 
 
        if(o == _null || o == _undefined){
		o = XsObject.global;
        }        

        if(call_args == _null || call_args == _undefined){
		call_args = noArgs;
        }
        
        if(!(xThis instanceof XsFunc)){
		System.err.println("TypeError: " + o + ".apply is not a function");
                return _undefined; 
        }
        else if(!(call_args instanceof XsArray)){
		System.err.println("TypeError: second argument to apply must be an array");
                return _undefined; 
        }
	else{//System.out.println("In apply before invopke");
                //must apply on copy
		return ((XsFunc)xThis).invoke(o, (XsArray)((XsArray)call_args).clone());
        }  
}

public static XsObject _call ( XsObject xThis, XsArray args ){
	XsObject o = null;
	//System.out.println("In call " );
        if(args.count == 0){
		return _undefined;
        }
        else if(args.count >= 1){
                o = args.elements[0];
        }
        
        if(o == _null || o == _undefined){
		o = XsObject.global;
        }

        if(!(xThis instanceof XsFunc)){
		System.err.println("TypeError: " + o + ".apply is not a function");
                return _undefined; 
        }
        else{
                //must act on copy
                XsArray callArgs = (XsArray)args.clone();

                System.arraycopy(callArgs.elements, 1, callArgs.elements, 0, callArgs.count - 1);
                
                callArgs.count--;

                //System.out.println("call_args are " + callArgs); 

                return ((XsFunc)xThis).invoke(o, callArgs);
        }  
}

public static XsObject _Prototype ( XsObject xThis, XsArray args ){
        return _undefined;
}

//not tested
public static XsObject _HasInstance ( XsObject xThis, XsArray args ){
	if(args.count == 0){
		return _undefined;
        } 
        else{
		XsObject v = args.elements[0];
                if(!XsNumber.isObject(v)){
			return xFalse;
                }
                else{
                        XsObject o = ((XsFunc)xThis).__proto__;
                        if(!XsNumber.isObject(o)){
				System.err.println("TypeError: " + o + " is not an object");
                                return _undefined;
                        }
                        else{
			        do{
					v = v.xsGet("prototype");
				        if(v == _undefined){
						return xFalse;
                                        }        
                                        else if(v == o){
						return xTrue;
                                        }  
			        }	
                                while(true);
                         }
                }
        }
}

//must synchronize on function unique naming
public /*synchronized */ final static XsObject __Function ( XsObject xThis, XsArray args ){
	
        XsObject obj;
        String out_args[] = null;

	if(args.count == 0){
		obj =  FunctionCreator(null, "");
        }
        else if(args.count == 1){ // body only
                String s;

                XsObject arg_0 = args.elements[0];  
 
                if(!(arg_0 instanceof XsString)){
			s = arg_0.xsGet("toString").invoke(arg_0).toString();
                }
                else{
			s = arg_0.toString();
                }
 
                obj =  FunctionCreator(null, s);
        }
        else{
                XsObject arg_i; 
        
                out_args = new String[args.count - 1];
               
                /* 
                   The following deals with this idiosyncracy from Ecma specs:

                   NOTE It is permissible but not necessary to have one argument for each formal parameter to be 
                   specified. For example, all three of the following expressions produce the same result: 
                   
                   new Function("a", "b", "c", "return a+b+c") 
                   new Function("a, b, c", "return a+b+c") 
                   new Function("a,b", "c", "return a+b+c")

		*/  

                for(int i = 0, j = 0; i < args.count - 1; i++){
                        arg_i = args.elements[i];
                        
                        String s; 

                        if(!(arg_i instanceof XsString)){
				s = out_args[j] = arg_i.xsGet("toString").invoke(arg_i).toString();
			}
			else{
				s = out_args[j] = arg_i.toString();
			}
			
                        StringTokenizer st = new StringTokenizer(s, ",");
                        
                        int count = st.countTokens();

                        if(count == 1){
				j++;
                                st.nextToken();
                        }
                        else if(count >= 2){
                                int len = out_args.length;
				String temp[] = new String[len + count - 1];
                                System.arraycopy(out_args, 0, temp, 0, len);
                                out_args = temp;
                        }
                        
                        while(st.hasMoreTokens()){
				out_args[j++] = st.nextToken();
			}
		}
 
                arg_i = args.elements[args.count - 1];
                
                if(!(arg_i instanceof XsString)){
                        obj =  FunctionCreator(out_args, arg_i.xsGet("toString").invoke(arg_i).toString());
		}
		else{ 
                        obj =  FunctionCreator(out_args, arg_i.toString());
		}              
        } 

        try{          
                ((XsFunc)xThis).mth =  obj.getClass().getMethod("_AnonymousFunction_" + (anonymous_sequence - 1), 
                                                                XsFunc.argTypes
                                                               );           
        }
	catch ( NoSuchMethodException x ) {
                System.err.println("Internal error: " + x);
		return _undefined;
	}
	

        if(obj == null); // means got a compile error, ex: new Function(5) or new Function("return 8 ** 9;");
	
        ((XsFunc)xThis).ctorClass = obj.getClass();

	((XsFunc)xThis).anonymous = true; 

        ((XsFunc)xThis).xsPut((Object)"length", new XsNumber((out_args == null) ? 0 : out_args.length));

	((XsPropertyAttributes)((XsFunc)xThis).properties_attributes.get("length")).DontEnum = true;

        //not tested
        ((XsFunc)xThis).__proto__ = function__proto__;
        
        ((XsFunc)xThis).xsPut("constructor", XsObject._Function);

        return xThis;
}

public final static XsObject ___Function ( XsObject xThis, XsArray args ){
	return __Function (xThis, args);
}

//no need to synchronize since always called from _Function
public final static XsObject FunctionCreator (String args[], String body){

        String compiler_args[] = new String[5];
        
        compiler_args[0] =  "xs";
        compiler_args[1] =  "-s";
        compiler_args[2] =  "-f";
        compiler_args[3] =  "AnonymousFunction_" + anonymous_sequence++;
         
        if(anonymous_function_compiler == null)
		anonymous_function_compiler = new XsEngine(); 
        
        if(args == null){
                return  anonymous_function_compiler
                              .createFunction(
                                               new StringBufferInputStream("function " + compiler_args[3] +
		                                                           " (){" + body + "}"
                                                                          )
					       ,
                                               compiler_args
                                              );
        } 
	else{
	        String out_args = args[0];
                for(int i = 1; i < args.length; i++)
			out_args += "," + args[i];

		// System.out.println("out_args are " + out_args);
		// System.out.println("body is " + body);

		return  anonymous_function_compiler
                               .createFunction(
                                               new StringBufferInputStream("function " + compiler_args[3] +
		                                                           " (" + out_args + "){" + body + "}"
                                                                          )
 					       ,
                                               compiler_args
                                              );
	}                                                    
}

//only here for dealing with calling the prototype
//check these call for bad arguments or caller
public XsObject call ( Object key ) {
        //System.out.println("In call ( Object key )  before xsGet " + key); 
       
        XsObject o = xsGet(key);
         


	//        System.out.println("In call " + o);        
        if(o == _undefined){
                System.err.println("ReferenceError: " + key + " is not defined");
                return _undefined;
        }
        else if(!(o instanceof XsFunc)){
                if(key.equals("prototype")){
			return _prototype.invoke(this);
                }
		else{
			System.err.println("TypeError: " + key + " is not a function");
			return _undefined;
                } 
        }
        else{   //System.out.println("call ( Object key )");

 
                return o.invoke( this);

        }
}

//ctx needed because anonymous functions have no other reference to the calling context
public XsObject callCtor (XsObject ctx) {
        
	XsObject ret_obj;
	
	try {
		ret_obj = (XsObject)ctorClass.newInstance();
	}
	catch ( Exception x ){
		ret_obj = new XsObject();
	}

	argObj[0] = ret_obj;

      	if(anonymous){
		argObj[1] = XsArray.pushs(ctx);
	}
	else{
		argObj[1] = noArgs;
	} 
	//System.out.println("In CallCtor " + mth + " ret_obj.xsGet(constructor) =" + ret_obj.xsGet("constructor"));
      	try {   
                Object ret_val;

                xsPut((Object)"arguments", (XsArray)argObj[1]); //does this work for anonymous funcs??

                XsPropertyAttributes pa =  (XsPropertyAttributes) properties_attributes.get("arguments");
                pa.DontEnum = true;
                pa.DontDelete = true;
                   
		//System.err.println("HEY");
                //constructors can have values other than the created object!
		if((ret_val = mth.invoke( null, argObj )) != _undefined  &&  ret_val != ret_obj){
			ret_obj = (XsObject) ret_val;
                        //System.err.println("HEY A");
                }
                else {  //System.err.println("HEY B");
                        if(!(ret_obj instanceof XsString) &&
                           !(ret_obj instanceof XsNumber) &&
                           !(ret_obj instanceof XsArray)  &&
			   !(ret_obj instanceof XsDate)   &&
			   __proto__.xsGet("constructor") != XsObject._Object/* &&
			   __proto__.xsGet("constructor") != XsObject._Array*/
                          ){
				//System.out.println( ret_obj.__proto__ == __proto__);

                            ret_obj.__proto__ = __proto__;
                        }

                        if(__proto__.xsGet("constructor") == XsObject._Object){
                                //System.out.println("RAMBO");
				ret_obj.__proto__.xsPut("constructor", XsObject._Object);
                        } 
                        
                        
                }  

	}
	catch ( Exception x ) {
           System.err.println("Internal Error: " + x);
        }

        xsRemove("arguments");

        //System.out.println("At end of CallCtor for method " + mth);

	return ret_obj;
}

public XsObject callCtor (XsObject ctx,  XsArray args ) {
	XsObject ret_obj;
	//System.out.println("In CallCtor ");
        try {
		ret_obj = (XsObject)ctorClass.newInstance();
	}
	catch ( Exception x ){
		ret_obj = new XsObject();
	}
        
       
	argObj[0] = ret_obj;
	
        if(anonymous){
		argObj[1] = args.push(ctx);
	}
	else{
		argObj[1] = args;
	} 
	//System.out.println("In CallCtor " + mth);
        try {
                Object ret_val;

                xsPut((Object)"arguments", (XsArray)argObj[1]); 
                
                XsPropertyAttributes pa =  (XsPropertyAttributes) properties_attributes.get("arguments");
                pa.DontEnum = true;
                pa.DontDelete = true;
	        
                if((ret_val = mth.invoke( null, argObj )) != _undefined &&  ret_val != ret_obj){
                        //System.out.println("HERE");
			ret_obj = (XsObject) ret_val;
                }
                else{ //is this really an else ???  
                        //System.out.println("it is " + ret_obj.xsGet("constructor"));

                        if(!(ret_obj instanceof XsString) &&
                           !(ret_obj instanceof XsNumber) &&
                           !(ret_obj instanceof XsArray)  &&
                           !(ret_obj instanceof XsDate)   &&
                           __proto__.xsGet("constructor") != XsObject._Object /* &&
			   __proto__.xsGet("constructor") != XsObject._Array*/
			   ){
				//System.out.print("RAMBO");
                             ret_obj.__proto__ = __proto__; //objects created from the same constructors share the same prototype           
			}

                        if(__proto__.xsGet("constructor") == XsObject._Object){
                                //System.out.println("RAMBO");
				ret_obj.__proto__.xsPut("constructor", XsObject._Object);
                        } 

                } 
        }
	catch ( Exception xx ) {
		System.err.println("Internal Error: " + xx); 
        }
	
        xsRemove("arguments");

	args.dispose();
        //System.out.println("At end of CallCtor " + (ret_obj.__proto__ == XsArray.array__proto__));
        //System.out.println("At end of CallCtor " + ret_obj);
	//System.out.println("xsGet is " + ret_obj.xsGet("charAt"));
        return ret_obj;
}

static XsObject getCtor ( String mthName, Class clazz ){
	try {
		Method mth = clazz.getMethod( ("_" + mthName), argTypes);
		XsFunc xf = new XsFunc( mth);//, global, false);
		xf.ctorClass = clazz;
                return xf;
	}
	catch ( NoSuchMethodException x ) {
		System.err.println("Internal Error: could not get method " + mthName);
		return _undefined;
	}
}

static XsObject getFunc ( String mthName, Class c ){
	try {
		Method mth = c.getMethod( ("_" + mthName), argTypes);
		return new XsFunc( mth, c, false);		
	}
	catch ( NoSuchMethodException x ) {
                
		System.err.println("Internal Error: could not get method " + mthName);
		return _undefined;
	}
}
//not used ??? + rework constrcutors in consequence
	/*
static XsObject getAnonymousFunc ( String mthName, Class c ){
	try {
		Method mth = c.getMethod( ("_" + mthName), argTypes);
		return new XsFunc( mth, c, true);		
	}
	catch ( NoSuchMethodException x ) {
		x.printStackTrace();
		return _undefined;
	}
	}*/

static XsObject getFunc ( String mthName, XsObject o ){
	try {
		Method mth = o.getClass().getMethod( ("_" + mthName), argTypes);
		return new XsFunc( mth, o, false);		
	}
	catch ( NoSuchMethodException x ) {
		System.err.println("Internal Error: could not get method " + mthName);
		return _undefined;
	}
}
//not used ???
	/*
static XsObject getAnonymousFunc ( String mthName, XsObject o ){
	try {
		Method mth = o.getClass().getMethod( ("_" + mthName), argTypes);
		return new XsFunc( mth, o, true);		
	}
	catch ( NoSuchMethodException x ) {
		x.printStackTrace();
		return _undefined;
	}
	}*/

//must not call dispose on noArgs!!
public XsObject invoke ( XsObject xThis ) {
        
        XsObject ret;

	argObj[0] = xThis;

        if(anonymous /*|| mth == XsObject.eval.mth*/){
		argObj[1] = new XsArray(0).push(xThis);
        }
        else{
		argObj[1] = noArgs;
        }
        //System.out.println("In invoke " + mth);


	try {

		xsPut((Object)"arguments", (XsArray)argObj[1]); 
               
	        XsPropertyAttributes pa =  (XsPropertyAttributes) properties_attributes.get("arguments");
                pa.DontEnum = true;
                pa.DontDelete = true;

                ret = (XsObject) mth.invoke( null, argObj );

                
                //System.out.println("In invoke after invokation  ret = " + ret);
	}
	catch ( Exception x ) {
		//System.out.println("In invoke got exception " + x);
                 ret = _undefined;
                 
	}
	
        xsRemove("arguments");

	//System.out.println("at end of Invoke ret = " + ret);
	return ret;
         
}

public XsObject invoke ( XsObject xThis, XsArray args ) {
	XsObject ret;

	argObj[0] = xThis;

        if(anonymous /*|| mth == XsObject.eval.mth*/){
                argObj[1] = args.push(xThis);
        }
        else{
		argObj[1] = args;
        }
        
        try {   
                xsPut((Object)"arguments", (XsArray)argObj[1]); 
	        
                XsPropertyAttributes pa =  (XsPropertyAttributes) properties_attributes.get("arguments");
                pa.DontEnum = true;
                pa.DontDelete = true;
               
                //System.out.println("In invoke mth = " + mth + " xTHis = " + xThis + "args are " + args);
		ret = (XsObject) mth.invoke( null, argObj );
                
                //System.out.println("In invoke after invokation  ret = " + ret);
	}
	catch ( Exception x ) {
		//System.out.println("In invoke got exception " + x);
                 ret = _undefined;
                 
	}

	xsRemove("arguments");
        
        args.dispose();
	//System.out.println("at end of Invoke ret = " + ret);
	return ret;
}

public XsObject plus ( String s ){
	return new XsString(toString() + s);
}

public XsObject plus ( XsObject x ){
	  XsObject p;

          if(!(x instanceof XsDate)){
		  p = XsObject.getPrimitiveFromObject(x);
	  }
	  else{
		  p = XsObject.getPrimitiveFromDate(x);
	  }
         

          if(p instanceof XsString){
		  return plus(p.toString());
          }
          else if(p instanceof XsNumber){
		  if ( ((XsNumber)p).type == XsNumber.TYPE_INT ){
			  return plus(((XsNumber)p).ival);
		  }
		  else {
			  return plus(((XsNumber)p).dval);
		  }
          }
          else{   
                  //try toString
                  XsObject func;

                  if(!(x instanceof XsDate)){
			  func = x.xsGet("toString");
		  }
		  else{
			  func = x.xsGet("valueOf");
		  }     
                  

                  //check exceptions on invoke ??

                  if(!(func instanceof XsFunc)){
			  return xFalse;
                  }                                  	
	          else{   
			  return plus(func.invoke(x));
	         }
          } 
}

public XsObject plus ( double d ){
	return new XsString(toString() + d);  
}

public XsObject plus ( int i ){
        return new XsString(toString() + i);
}

public XsObject toBoolean(){
        return xTrue;
}

public String toString() {
        String mth_name = mth.getName();
        String class_name = mth.getDeclaringClass().getName();
        String method_name;

        if(anonymous){
		method_name = "anonymous";
        }
        else{
		method_name = mth_name.substring(1);
        }

        //reload everytime since may be modified dynamically
        Properties gp = new Properties();
	
        try {
		gp.load( new FileInputStream("xs.function_bodies") );
	}
	catch ( IOException ioe) {
		System.err.println( "Internal Error: " + ioe);
	}

	String body = gp.getProperty(class_name + "/" + mth_name);

        if(body == null){
                //might be, for example, __Array, but could also be failureto find it. To improve.
		return "function " + method_name.substring(method_name.lastIndexOf("_") + 1) + "(){\n    [native code]\n}"; //like js
        }
        else{
                return "function " + method_name + body;
        }
}

public XsObject valueOf() {
        return new XsString(toString());
}

public XsObject xsGet ( String skey ){

	if ( skey.equals( "prototype") ){
                
                if(this ==  XsObject._Boolean){
			return xFalse;
                }
                else if(this == XsObject._Number){
			return new XsNumber(0);
                }
                else if(this == XsObject._Date){
			return XsNumber.NaN;
                }
                else if(this == XsObject._Array){
			//redo??
                        return new XsArray(0);
                }
                else if(this == XsObject._String){
			//redo??
                        return new XsString("");
                }
                else if(this == XsObject._Function){
			//redo??
                        return new XsString("function Function() {\n}\n");
                }
                else{
			return __proto__;
                } 
	}
	else {
		return super.xsGet( skey);
	}
}

public XsString xsGetType () {
	return typeStrFunc;
}

public XsObject xsPut ( String key, XsObject val ) {
        //System.out.println("HERE key is " + key + " val is " + val);
	if ( key.equals("prototype") || key.equals("__proto__")){
		//had to do ReadOnly this way because of circularity problems
                if(__proto__.xsGet("constructor") != XsObject._Object &&
                   __proto__.xsGet("constructor") != XsObject._Function &&
                   __proto__.xsGet("constructor") != XsObject._Array    &&
                   __proto__.xsGet("constructor") != XsObject._String   &&
                   __proto__.xsGet("constructor") != XsObject._Boolean  &&
                   __proto__.xsGet("constructor") != XsObject._Number   &&
                   __proto__.xsGet("constructor") != XsObject._Date
                   
                  ){ 
			__proto__ = val;
		}
	}
	else {
		super.xsPut( key, val);
	}
	
	return val;
}
	
}// class 









