/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *
 * $tvt: XsNumber.java,v 1.39 2001/08/14 17:03:07 philippe Exp $
 */
package kaffe.xs;

import java.util.StringTokenizer;
import java.text.NumberFormat;

final 
public class XsNumber
  extends XsObject
{

        /* some fields made public for testing purposes */
	int ival;
	double dval;
	int type;
        boolean isObject = false;
	final static int TYPE_INT = 1;
	final static int TYPE_FLOAT = 2;
	final static XsString typeStr = new XsString("number");
	public final static XsNumber NaN = new XsNumber(Double.NaN);
	public final static XsNumber MAX_VALUE = new XsNumber( Double.MAX_VALUE);
	public final static XsNumber MIN_VALUE = new XsNumber( Double.MIN_VALUE);
	public final static XsNumber POSITIVE_INFINITY = new XsNumber( Double.POSITIVE_INFINITY);
	public final static XsNumber NEGATIVE_INFINITY = new XsNumber( Double.NEGATIVE_INFINITY);
 
        protected static XsObject number__proto__; 
      

static {
	number__proto__ = new XsObject();

	XsPropertyAttributes propattrs;
        XsFunc func;

        //methods

        number__proto__.xsPut("toString", func = (XsFunc) XsFunc.getFunc("toString", XsNumber.class));
        
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)number__proto__.properties_attributes.get("toString"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
     



        number__proto__.xsPut("toLocaleString", func = (XsFunc) XsFunc.getFunc("toLocaleString", XsNumber.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)number__proto__.properties_attributes.get("toLocaleString"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        number__proto__.xsPut("toFixed", func = (XsFunc) XsFunc.getFunc("toFixed", XsNumber.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)number__proto__.properties_attributes.get("toFixed"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
     



        number__proto__.xsPut("toExponential", func = (XsFunc) XsFunc.getFunc("toExponential", XsNumber.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)number__proto__.properties_attributes.get("toExponential"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
     


        number__proto__.xsPut("toPrecision", func = (XsFunc) XsFunc.getFunc("toPrecision", XsNumber.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)number__proto__.properties_attributes.get("toPrecision"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      


        //fields

        number__proto__.xsPut("MAX_VALUE", MAX_VALUE);
        propattrs = ((XsPropertyAttributes)number__proto__.properties_attributes.get("MAX_VALUE"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true; 

        number__proto__.xsPut("MIN_VALUE", MIN_VALUE);
        propattrs = ((XsPropertyAttributes)number__proto__.properties_attributes.get("MIN_VALUE"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true; 

        number__proto__.xsPut("POSITIVE_INFINITY", POSITIVE_INFINITY);
        propattrs = ((XsPropertyAttributes)number__proto__.properties_attributes.get("POSITIVE_INFINITY"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true; 

        number__proto__.xsPut("NEGATIVE_INFINITY", NEGATIVE_INFINITY);
        propattrs = ((XsPropertyAttributes)number__proto__.properties_attributes.get("NEGATIVE_INFINITY"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true; 

        number__proto__.xsPut("NaN", NaN);
        propattrs = ((XsPropertyAttributes)number__proto__.properties_attributes.get("NaN"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true; 
        
        number__proto__.__proto__ = XsFunc.function__proto__;

        //patch proto assignment
        NaN.__proto__ = number__proto__;
	MAX_VALUE.__proto__ = number__proto__; 
	MIN_VALUE.__proto__ = number__proto__; 
	POSITIVE_INFINITY.__proto__ = number__proto__;  
	NEGATIVE_INFINITY.__proto__ = number__proto__;
}

public XsNumber ( XsNumber xn ){
	ival = xn.ival;
	dval = xn.dval;
	type = xn.type;
        __proto__ = number__proto__;
}

public XsNumber ( double val ){
	dval = val;
	type = TYPE_FLOAT;
        __proto__ = number__proto__;
        //System.out.println("In constructor for " + val + " proto is " + __proto__);
}

public XsNumber ( int val ){
	ival = val;
	type = TYPE_INT;
        __proto__ = number__proto__;
}

public XsNumber ( Integer val ){
	ival = val.intValue();
	type = TYPE_INT;
        __proto__ = number__proto__;
}

public XsNumber (){
	__proto__ = number__proto__;
}

public static XsObject __Number ( XsObject xThis, XsArray args ){

	XsNumber xn = (XsNumber) xThis;
 	
	if(args.count == 0){
		xn.ival = 0;
                xn.type = TYPE_INT;
        }
        else{
		XsNumber x = getNumberFromObject(args.elements[0]);
                if(x.type == TYPE_INT){
			xn.ival = x.ival;
                        xn.type = TYPE_INT;
                }
                else{
                        xn.dval = x.dval;
                        xn.type = TYPE_FLOAT;
                }
        }

        xn.isObject = true;

        return xThis; 
}

public static XsNumber getNumberFromObject(XsObject x){
        //System.out.println("In getNumberFromObject: " + x);    

        if(x == null){
		return NaN; 
        }
        else if (x instanceof XsNumber){
		return (XsNumber) x;
        }
        else if(x instanceof XsArray){
                  
             	XsArray array = (XsArray)x;
                                 
                if(array.count == 0)
			return new XsNumber(0);
                else if(array.count == 1) //recursive
			return getNumberFromObject(array.xsGet(0));
                else
                        return NaN;
        }
        else if (x instanceof XsString){
                
                String str = x.toString();
                       
                if(str.equals("") || str.equals("0"))
			return new XsNumber(0.0);
                        
                try {
			if ( XsNumber.assumedFloat( str) ){
				return new XsNumber(Double.parseDouble(str));
			}
			else {  //parseInt does not understand 0x etc
      				return new XsNumber(Integer.decode(str));
			}
		}
		catch ( NumberFormatException e ) {
                        //System.out.println("HERE JOE " + str);
                        return XsString.isInfinity(str);
		}
        }
        else if (x instanceof XsFunc){
                return NaN;
        }
        else{
		//System.out.println("And here " + x);
                if(x == xTrue){
			return new XsNumber(1);
                }
                else if(x == xFalse){
			return new XsNumber(0.0);
                }
                else if(x == _null){
			return new XsNumber(0.0);
                }
                else if(x == _undefined){
			return NaN;
                }
                else{   
                        XsObject ret;
       
                        int[] n_iter = new int[1];
			//           System.out.println("toString is " + x.xsGet("toString").invoke(x));
                        //check for valueOf 
                        XsObject func = x.xsGet("valueOf", n_iter);
                        
                        //check exceptions on invoke ??

                        if(func instanceof XsFunc && n_iter[0] == 2){
                                ret = func.invoke(x);
                                //reuse ret 
                                if(isObject(ret)){
					ret = NaN;
                                }
                                else{
					ret = getNumberFromObject(ret);
                                }
				//      System.out.println("Onject ret is " + ret);
                                if(ret == NaN){
                                        //check for toString
					func  = x.xsGet("toString", n_iter);
					if(func instanceof XsFunc && n_iter[0] == 2){
						ret = func.invoke(x);
                                                if(isObject(ret)){
							return NaN;
						}
						return getNumberFromObject(ret);
					}
					else{
						return NaN;
					}
                                }
                                else{
					return (XsNumber)ret;
                                }
                        }
                        else{
                                //check for toString
                                func  = x.xsGet("toString", n_iter);
                                if(func instanceof XsFunc && n_iter[0] == 2){
				        ret = func.invoke(x);
                                        if(isObject(ret)){
						return NaN;
					}
                                        return getNumberFromObject(ret);
                                }
                                else{
					return NaN;
                                }  
                        }
                }
        }
}

public static final boolean isObject(XsObject x){
        //maybe need some contructor checks for criterion??
	if(x instanceof XsNumber ||
           x instanceof XsString ||
           x instanceof XsArray  ||
           x instanceof XsFunc   ||
           x == xTrue            || 
           x == xFalse           ||
           x == _null            ||
           x == _undefined
	   ){
		return false;
        }
        else{
		return true;

        }          
}

public static XsObject _isFinite(XsObject xThis, XsArray args){
                
	if(args.count == 0)
		return xFalse;
	XsNumber x =  getNumberFromObject(args.elements[0]);

        if(x == NaN)
		return xFalse;

        if(x.type == TYPE_INT)
		return Double.isInfinite((double)x.ival) ? xFalse : xTrue;
        else
                return Double.isInfinite(x.dval) ? xFalse : xTrue;
}

public static XsObject _isNaN(XsObject xThis, XsArray args){
                
	if(args.count == 0){
		return xFalse;
        }

	XsNumber x =  getNumberFromObject(args.elements[0]);
        
        return (x == NaN) ? xTrue : xFalse;  
}
	
public static XsObject _parseInt(XsObject xThis, XsArray args){
                
	if(args.count == 0)
		return NaN;
	else{

		XsNumber x = getNumberFromObject(args.elements[0]);
 
                //System.out.println("Number is " + x);

                XsObject arg = args.elements[0];

                XsNumber result; 

                if (x == NaN || x.type == TYPE_FLOAT || arg == XsObject.xFalse ||
                    arg == XsObject.xTrue || arg == XsObject._null || args.count > 1)
                {
			
			int radix;

                        String s;
 
                        if(!(arg instanceof XsString)){
				s = arg.xsGet("toString").invoke(arg).toString();
                        }
                        else{
				s = arg.toString();
                        }

                        char string[] = new char[s.length()];
                        int len = s.length();
                        s.getChars(0, len, string, 0); 


                        StringBuffer sb = new StringBuffer();

                        if(args.count >= 2){
				XsNumber number = getNumberFromObject(args.elements[1]);
                                if(number == NaN){
				        radix = 10;
                                }
                                else{
					radix = number.getIntValue();
                                        if(radix == 0){
						radix = 10;
                                        }
                                }
                        } 
                        else{ 
                                radix = 10;
                        }

                        char char_at; 

                        boolean at_beg = true;  
                        boolean neg = false;   
                        boolean got_sign = false;   
                        boolean got_digit = false;                      
  
                        for(int i = 0; i < len; i++){
				if(Character.isDigit(char_at = string[i])){
                                        //System.out.println("char_at is " + char_at);   
					if(at_beg){
						if(char_at == '0'){
                                                        radix = 8;
                                                        //System.out.println("HERE i=" + i + " len = " + len + " " + string[i + 1]);
                                                        if(i + 1 < len && !(string[i + 1] == 'x' || 
                                                                            string[i + 1] == 'X'
                                                                           )
                                                          ){
                                                        	at_beg = false;
							}
                                                        
                                                        if(string[i + 1] == '-' || 
                                                           string[i + 1] == '+'){
                                                                //System.out.println("HERE");
								sb.append(char_at);
                                                        }
                                                        //System.out.println("HERE");
                                                }
                                                else{   
                                                        at_beg = false;
                                                        sb.append(char_at);
                                                }
					} 
                                        else{   
                                                at_beg = false;
						sb.append(char_at);
                                        }
                                        got_digit = true;
                                 }
				 else if(at_beg && char_at != ' '){
                                        if(char_at == 'x' || char_at == 'X'){
						radix = 16;
                                        }
                                        else if(char_at == '-'){
                                                if(got_sign){
							return NaN;
                                                }
                                                else{   
							neg = true;
                                                        got_sign = true;
                                                } 
                                        }
                                        else if(char_at == '+'){ 
                                                if(got_sign){
							return NaN;
                                                }
                                                else{   
							neg = true;
                                                        got_sign = true;
                                                } 
                                        }
                                        else{   
                                                sb.append(char_at);
                                        }
				 }
                                 else if(char_at == ' '){
					 if(!at_beg){
						 break;
                                         }
                                 } 
                                 else if(char_at != '.'){ 
					if((char_at == '-' || char_at == '+') && !at_beg){
						break;
					}
                                        if(!got_digit){
						sb.append(char_at);
                                        }
                                        else{
						try{    
                                                        char temp[] = new char[1];
                                                        temp[0] = char_at;
							Integer.parseInt(new String(temp), radix);
                                                        //not executed if failed
                                                        sb.append(char_at);
                                                }
	                                        catch ( NumberFormatException e ) {
					        }
                                        }
				 } 
			 	 else{
					 break;
				 }
				 
				//System.out.println("char_at is " + char_at);
                         }
			//System.out.println("string is " + sb);       
			 try{    
				 // don't care if base is 0, 1, > 36 or < 0, Java returns base 10 in these cases 
                                 int ret = Integer.parseInt(sb.toString(), radix);
                                        
                                 if(neg){
					 ret *= -1;
		                 }
				        
                                 return new XsNumber(ret);
                         }
	                 catch ( NumberFormatException e ) {
				 return NaN;
	                 }                                                         
                }
                else{  //System.out.println("RAMVBO");
			return x;
                }
	} 
}

public static XsObject _parseFloat(XsObject xThis, XsArray args){
        if(args.count == 0)
		return NaN;
	else{

		XsNumber x = getNumberFromObject(args.elements[0]);
 
                XsObject arg = args.elements[0];

                XsNumber result; 

                if (x == NaN || arg == XsObject.xFalse || arg == XsObject.xTrue || arg == XsObject._null){
			
			String s;
 
                        if(!(arg instanceof XsString)){
				s = arg.xsGet("toString").invoke(arg).toString();
                        }
                        else{
				s = arg.toString();
                        }

                        char string[] = new char[s.length()];
                        int len = s.length();
                        s.getChars(0, len, string, 0); 
 
                        StringBuffer sb = new StringBuffer();

                        char char_at; 

                        boolean at_beg = true;  
                        boolean neg = false;   
                        boolean got_sign = false;   
                        boolean got_digit = false;
                        boolean got_decimal_point = false;                      
  
                        for(int i = 0; i < len; i++){
				if(Character.isDigit(char_at = string[i])){
                                        at_beg = false;
					sb.append(char_at);
                                        got_digit = true;
                                 }
				 else if(at_beg && char_at != ' '){
                                        if(char_at == '-'){
                                                if(got_sign){
							return NaN;
                                                }
                                                else{   
							neg = true;
                                                        got_sign = true;
                                                } 
                                        }
                                        else if(char_at == '+'){ 
                                                if(got_sign){
							return NaN;
                                                }
                                                else{   
							neg = true;
                                                        got_sign = true;
                                                } 
                                        }
                                        else{   
                                                sb.append(char_at);
                                        }
				 }
                                 else if(char_at == ' '){
					 if(!at_beg){
						 break;
                                         }
                                 } 
                                 else if(char_at == '.'){
					 if(!got_decimal_point){
						 got_decimal_point = true;
                                                 sb.append(char_at);
                                         }
                                         else{
						 return NaN;
                                         }
				 } 
			 	 else{
					 break;
				 }
			 }
			  
			 try{    
				 
                                 double ret = Double.parseDouble(sb.toString());
                                        
                                 if(neg){
					 ret *= -1;
		                 }
				        
                                 return new XsNumber(ret);
                         }
	                 catch ( NumberFormatException e ) {
				 return NaN;
	                 }                                                         
                }
                else{  
			return x;
                }
	}     
}
	
public static XsObject _toString ( XsObject xThis, XsArray args ){
        //returns XsString       
	if(!(xThis instanceof XsNumber)){
		System.err.println(xThis + ".toString is not a function");
                return _undefined;
        }
	  
        if(args.count == 0){
		return new XsString(((XsNumber)xThis).toString());
        }
        else{
                if(args.elements[0] == XsObject._undefined){
			return new XsString(((XsNumber)xThis).toString()); 
                }    
     
                XsNumber number = (XsNumber)xThis;
                
                XsNumber base =  (XsNumber)args.elements[0];
		
                // don't care if base is 0, 1, > 36 or < 0, Java returns base 10 in these cases 
       
		int value;

		if ( number.type == TYPE_INT ){
			value = number.ival;
		}
		else {
			value = (int) number.dval;
		}
                //replace toString by decode???
                if(base.type == TYPE_INT){	
			return new XsString(Integer.toString(value, base.ival));
		}
		else{
			return new XsString(Integer.toString(value, (int)base.dval));
		}
       }
}

public static XsObject _toLocaleString ( XsObject xThis, XsArray args ){
	return _toString(xThis, args);
}
//not exact, review after 1.5
public static XsObject _toFixed(XsObject xThis, XsArray args){
                
        int fractionDigits; 

	if(args.count == 0 || args.elements[0] == _undefined){
		fractionDigits = 0;
        } 
	else{
		XsNumber xn =  getNumberFromObject(args.elements[0]);
                if(xn == NaN){
			fractionDigits = 0;	
                }
                else if(xn.type == TYPE_INT){
			fractionDigits = xn.ival;
                }
                else{
                        fractionDigits = (int)xn.dval;
                }
            
                if(fractionDigits < 0 || fractionDigits > 20){
			System.err.println("RangeError: fractiondigits must be greater than 0 and larger than 20");
			return _undefined;	
                }
        }	

        if(xThis == NaN){
		return new XsString("NaN");
        }


        NumberFormat nf = NumberFormat.getInstance();
        nf.setMaximumFractionDigits(fractionDigits);
        
        if(((XsNumber)xThis).type == TYPE_INT){
		return new XsString(nf.format(((XsNumber)xThis).ival));
        }
        else{
		return new XsString(nf.format(((XsNumber)xThis).dval));
        }
}

//do after 1.5
public static XsObject _toExponential(XsObject xThis, XsArray args){
        System.err.println("toExponential not yet implemented");
        return _undefined;
}

//do after 1.5
public static XsObject _toPrecision(XsObject xThis, XsArray args){
        System.err.println("toPrecision not yet implemented");
        return _undefined;
}

public XsObject and ( String s ){
	int i;
	double d;
	
	try {
		if ( assumedFloat( s) ){
			d = Double.parseDouble(s);
			if ( type == TYPE_INT ){
				return new XsNumber( ival & (int)d);
			}
			else {
				return new XsNumber( (int)dval & (int)d);
			}
		}
		else {
			i = Integer.decode(s).intValue();
			if ( type == TYPE_INT ){
				return new XsNumber( ival & i);
			}
			else {
				return new XsNumber( (int)dval & i);
			}
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}
}

public XsObject and ( XsObject x ){
       	XsNumber xn = getNumberFromObject(x);
        if(xn != XsNumber.NaN){
		if ( xn.type == TYPE_INT ){
			return and(xn.ival);
		}
		else {
			return and(xn.dval);
		}
        }
        else
		return new XsNumber(0.0);
}

public XsObject and ( double d ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival & (int)d);
	}
	else {
		return new XsNumber( (int)dval & (int)d);
	}
}

public XsObject and ( int i ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival & i);
	}
	else {
		return new XsNumber( (int)dval & i);
	}
}

static boolean assumedFloat ( String s ){
	// dull and simple, for now
	return (s.indexOf('.') > -1 && s.indexOf('E') == -1);
}

public XsObject dec() {
	if ( type == TYPE_INT ){
		ival--;
	}
	else {
		dval--;
	}
	return new XsNumber(this);
}

public XsObject div ( String s ){
	int i;
	double d;
	
	try {
		if ( assumedFloat( s) ){
			d = Double.parseDouble(s);
			if ( type == TYPE_INT ){
				return new XsNumber( ival / d);
			}
			else {
				return new XsNumber( dval / d);
			}
		}
		else {
			i = Integer.decode(s).intValue();
			if ( type == TYPE_INT ){
				return new XsNumber( (double)ival / (double)i);
			}
			else {
				return new XsNumber( dval / i);
			}
		}
	}
	catch ( NumberFormatException x ) {
		if(s.equals(""))
			return XsNumber.POSITIVE_INFINITY;
                else
                        return XsNumber.NaN;
	}
}

public XsObject div ( XsObject x ){
        XsNumber xn = getNumberFromObject(x); 
        
        if ( type == TYPE_INT ){
		if ( xn.type == TYPE_INT ){
			return new XsNumber( (double)ival / (double)xn.ival);
		}
		else {
			return new XsNumber( ival / xn.dval);
		}
	}
	else {
		if ( xn.type == TYPE_INT ){
			return new XsNumber( dval / xn.ival);
		}
		else {
			return new XsNumber( dval / xn.dval);
	        }
        }

	
}

public XsObject div ( double d ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival / d);
	}
	else {
		return new XsNumber( dval / d);
	}
}

public XsObject div ( int i ){
	if ( type == TYPE_INT ){
		return new XsNumber( (double)ival / (double)i);
	}
	else {
		return new XsNumber( dval / i);
	}
}

public XsObject eq ( String s ) {
        int si = 0;
	double sd = 0.0;
	int stype;
	

        try {
		if ( XsNumber.assumedFloat(s) ){
			sd = Double.parseDouble(s);
			stype = XsNumber.TYPE_FLOAT;
		}
		else {
			si = Integer.decode(s).intValue();
			stype = XsNumber.TYPE_INT;
                }
	}
	catch ( NumberFormatException xx ) {
                return xFalse;
	}

        if ( stype == TYPE_INT ){
		return eq(si);
	}
	else {
		return eq(sd);		
	}
}

public XsObject eq ( XsObject x ) {
        if ( x instanceof XsNumber ){
		XsNumber xn = (XsNumber) x;	

       		if ( type == TYPE_INT ){
			if ( xn.type == TYPE_INT ){
				return (ival == xn.ival) ? xTrue : xFalse;
			}
			else {
				return ((double)ival == xn.dval) ? xTrue : xFalse;
			}
		}
		else {
                        if ( xn.type == TYPE_INT ){
				return (dval == (double) xn.ival) ? xTrue : xFalse;
			}
			else {
				return (dval == xn.dval) ? xTrue : xFalse;
			}
		}
	}
	else if ( x instanceof XsString ){
		return eq(x.toString());
	}
	else if(x == xTrue){
		if ( type == TYPE_INT ){
			return (ival == 1) ? xTrue : xFalse; 
                }
		else {
                        return (dval == 1.0) ? xTrue : xFalse; 
                }
        }
        else if(x == xFalse){
		if ( type == TYPE_INT ){
			return (ival == 0) ? xTrue : xFalse; 
                }
		else {
                        return (dval == 0.0) ? xTrue : xFalse; 
                }
        }
        else{
                XsObject p = XsObject.getPrimitiveFromObject(x);

                if(p instanceof XsString){
                        return eq(p.toString());
                }
                else if(p instanceof XsNumber){
			if ( ((XsNumber)p).type == XsNumber.TYPE_INT ){
				return eq(((XsNumber)p).ival);
		        }
			else {
				return eq(((XsNumber)p).dval);
			}
                }
                else{   
                        //try toString
                       
                         XsObject func = x.xsGet("toString");

                        //check exceptions on invoke ??

                        if(!(func instanceof XsFunc)){
				return xFalse;
                        }                                  	
	                else{   
				return eq(func.invoke(x));
	                }
                }
        }
}

public XsObject eq ( double d ) {
	if ( type == TYPE_INT ){
		return ((double)ival == d) ? xTrue : xFalse;
	}
	else {
		return (dval == d) ? xTrue : xFalse;
	}
}

public XsObject eq ( int i ) {
	if ( type == TYPE_INT ){
		return (ival == i) ? xTrue : xFalse;
	}
	else {
		return (dval == (double)i) ? xTrue : xFalse;
	}
}

public XsObject ge ( String s ) {
        int si = 0;
	double sd = 0.0;
	int stype;
	
        try {
		if ( XsNumber.assumedFloat(s) ){
			sd = Double.parseDouble(s);
			stype = XsNumber.TYPE_FLOAT;
		}
		else {
			si = Integer.decode(s).intValue();
			stype = XsNumber.TYPE_INT;
                }
	}
	catch ( NumberFormatException xx ) {
                return xFalse;
	}

        if ( stype == TYPE_INT ){
		return ge(si);
	}
	else {
		return ge(sd);		
	}
}

public XsObject ge ( XsObject x ) {
	if ( x instanceof XsNumber ){
		XsNumber xn = (XsNumber) x;	

		if ( xn.type == TYPE_INT ){
			return ge(xn.ival);
		}
		else {
		        return ge(xn.dval);
	        }
	}
        else if(x instanceof XsString){
                return ge(x.toString());
        }
        else{   
                XsObject p = XsObject.getPrimitiveFromObject(x);

                if(p instanceof XsString){
                        return ge(p.toString());
                }
                else if(p instanceof XsNumber){
			if ( ((XsNumber)p).type == XsNumber.TYPE_INT ){
				return ge(((XsNumber)p).ival);
		        }
			else {
				return ge(((XsNumber)p).dval);
			}
                }
                else if(p == xTrue){
		        return ge(1);
                }
	        else if(p == xFalse || p == _undefined || p == _null){
		        return ge(0);
	        }
                else{   
                        //try toString
                       
                         XsObject func = x.xsGet("toString");

                        //check exceptions on invoke ??

                        if(!(func instanceof XsFunc)){
				return xFalse;
                        }                                  	
	                else{   
				return ge(func.invoke(x));
	                }
                } 
       }
}

public XsObject ge ( double d ) {
	if ( type == TYPE_INT ){
		return ((double)ival >= d) ? xTrue : xFalse;
	}
	else {
		return (dval >= d) ? xTrue : xFalse;
	}
}

public XsObject ge ( int i ) {
	if ( type == TYPE_INT ){
		return (ival >= i) ? xTrue : xFalse;
	}
	else {
		return (dval >= (double)i) ? xTrue : xFalse;
	}
}

public int getIntValue() {
	if ( type == TYPE_INT ){
		return ival;
	}
	else {
		return (int)dval;
	}
}

public XsString getType() {
	return typeStr;
}

public XsObject gt ( String s ) {
        int si = 0;
	double sd = 0.0;
	int stype;
	
        try {
		if ( XsNumber.assumedFloat(s) ){
			sd = Double.parseDouble(s);
			stype = XsNumber.TYPE_FLOAT;
		}
		else {
			si = Integer.decode(s).intValue();
			stype = XsNumber.TYPE_INT;
                }
	}
	catch ( NumberFormatException xx ) {
                return xFalse;
	}

        if ( stype == TYPE_INT ){
		return gt(si);
	}
	else {
		return gt(sd);		
	}
}

public XsObject gt ( XsObject x ) {
	if ( x instanceof XsNumber ){
		XsNumber xn = (XsNumber) x;	

		if ( xn.type == TYPE_INT ){
			return gt(xn.ival);
		}
		else {
		        return gt(xn.dval);
	        }
	}
        else if(x instanceof XsString){
                return gt(x.toString());
        }
        else{
                XsObject p = XsObject.getPrimitiveFromObject(x);

                if(p instanceof XsString){
                        return gt(p.toString());
                }
                else if(p instanceof XsNumber){
			if ( ((XsNumber)p).type == XsNumber.TYPE_INT ){
				return gt(((XsNumber)p).ival);
		        }
			else {
				return gt(((XsNumber)p).dval);
			}
                }
                else if(p == xTrue){
		        return gt(1);
                }
	        else if(p == xFalse || p == _undefined || p == _null){
		        return gt(0);
	        }
                else{   
                        //try toString
                       
                         XsObject func = x.xsGet("toString");

                        //check exceptions on invoke ??

                        if(!(func instanceof XsFunc)){
				return xFalse;
                        }                                  	
	                else{   
				return gt(func.invoke(x));
	                }
                }
	}
}

public XsObject gt ( double d ) {
	if ( type == TYPE_INT ){
		return ((double)ival > d) ? xTrue : xFalse;
	}
	else {
		return (dval > d) ? xTrue : xFalse;
	}
}

public XsObject gt ( int i ) {
	if ( type == TYPE_INT ){
		return (ival > i) ? xTrue : xFalse;
	}
	else {
		return (dval > (double)i) ? xTrue : xFalse;
	}
}

public XsObject inc() {
	if ( type == TYPE_INT ){
		ival++;
	}
	else {
		dval++;
	}
	return new XsNumber(this);
}

public XsObject le ( String s ) {
        int si = 0;
	double sd = 0.0;
	int stype;
	
        try {
		if ( XsNumber.assumedFloat(s) ){
			sd = Double.parseDouble(s);
			stype = XsNumber.TYPE_FLOAT;
		}
		else {
			si = Integer.decode(s).intValue();
			stype = XsNumber.TYPE_INT;
                }
	}
	catch ( NumberFormatException xx ) {
                return xFalse;
	}

        if ( stype == TYPE_INT ){
		return le(si);
	}
	else {
		return le(sd);		
	}
}

public XsObject le ( XsObject x ) {
	if ( x instanceof XsNumber ){
		XsNumber xn = (XsNumber) x;	

		if ( xn.type == TYPE_INT ){
			return le(xn.ival);
		}
		else {
		        return le(xn.dval);
	        }
	}
        else if(x instanceof XsString){
                return le(x.toString());
        }
        else{
                XsObject p = XsObject.getPrimitiveFromObject(x);

                if(p instanceof XsString){
                        return le(p.toString());
                }
                else if(p instanceof XsNumber){
			if ( ((XsNumber)p).type == XsNumber.TYPE_INT ){
				return le(((XsNumber)p).ival);
		        }
			else {
				return le(((XsNumber)p).dval);
			}
                }
                else if(p == xTrue){
		        return le(1);
                }
	        else if(p == xFalse || p == _undefined || p == _null){
		        return le(0);
	        }
                else{   
                        //try toString
                       
                         XsObject func = x.xsGet("toString");

                        //check exceptions on invoke ??

                        if(!(func instanceof XsFunc)){
				return xFalse;
                        }                                  	
	                else{   
				return le(func.invoke(x));
	                }
                }                  
        }
}

public XsObject le ( double d ) {
	if ( type == TYPE_INT ){
		return ((double)ival <= d) ? xTrue : xFalse;
	}
	else {
		return (dval <= d) ? xTrue : xFalse;
	}
}

public XsObject le ( int i ) {
	if ( type == TYPE_INT ){
		return (ival <= i) ? xTrue : xFalse;
	}
	else {
		return (dval <= i) ? xTrue : xFalse;
	}
}

public XsObject lt ( String s ) {
        int si = 0;
	double sd = 0.0;
	int stype;
	
        try {
		if ( XsNumber.assumedFloat(s) ){
			sd = Double.parseDouble(s);
			stype = XsNumber.TYPE_FLOAT;
		}
		else {
			si = Integer.decode(s).intValue();
			stype = XsNumber.TYPE_INT;
                }
	}
	catch ( NumberFormatException xx ) {
                return xFalse;
	}

        if ( stype == TYPE_INT ){
		return lt(si);
	}
	else {
		return lt(sd);		
	}
}

public XsObject lt ( XsObject x ) {
	if ( x instanceof XsNumber ){
		XsNumber xn = (XsNumber) x;	

		if ( xn.type == TYPE_INT ){
			return lt(xn.ival);
		}
		else {
		        return lt(xn.dval);
	        }
	}
        else if(x instanceof XsString){
                return lt(x.toString());
        }
        else{
                XsObject p = XsObject.getPrimitiveFromObject(x);

                if(p instanceof XsString){
                        return lt(p.toString());
                }
                else if(p instanceof XsNumber){
			if ( ((XsNumber)p).type == XsNumber.TYPE_INT ){
				return lt(((XsNumber)p).ival);
		        }
			else {
				return lt(((XsNumber)p).dval);
			}
                }
                else if(p == xTrue){
		        return lt(1);
                }
	        else if(p == xFalse || p == _undefined || p == _null){
		        return lt(0);
	        }
                else{   
                        //try toString
                       
                         XsObject func = x.xsGet("toString");

                        //check exceptions on invoke ??

                        if(!(func instanceof XsFunc)){
				return xFalse;
                        }                                  	
	                else{   
				return lt(func.invoke(x));
	                }
                } 
        }
}

public XsObject lt ( double d ) {
	if ( type == TYPE_INT ){
		return ((double)ival < d) ? xTrue : xFalse;
	}
	else {
		return (dval < d) ? xTrue : xFalse;
	}
}

public XsObject lt ( int i ) {
	if ( type == TYPE_INT ){
		return (ival < i) ? xTrue : xFalse;
	}
	else {
		return (dval < (double)i) ? xTrue : xFalse;
	}
}

public XsObject minus ( String s ){
	int i;
	double d;
	
	try {
		if ( assumedFloat( s) ){
			d = Double.parseDouble(s);
			if ( type == TYPE_INT ){
				return new XsNumber( ival - d);
			}
			else {
				return new XsNumber( dval - d);
			}
		}
		else {
			i = Integer.decode(s).intValue();
			if ( type == TYPE_INT ){
				return new XsNumber( ival - i);
			}
			else {
				return new XsNumber( dval - i);
			}
		}
	}
	catch ( NumberFormatException x ) {
		if(s.equals(""))
			return new XsNumber(this);
                else
                        return XsNumber.NaN;
	}
}

public XsObject minus ( XsObject x ){
        XsNumber xn = getNumberFromObject(x); 
        
        if ( type == TYPE_INT ){
		if ( xn.type == TYPE_INT ){
			return new XsNumber( ival - xn.ival);
		}
		else {
			return new XsNumber( ival - xn.dval);
		}
	}
	else {
		if ( xn.type == TYPE_INT ){
			return new XsNumber( dval - xn.ival);
		}
		else {
			return new XsNumber( dval - xn.dval);
	        }
        }
}

public XsObject minus ( double d ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival - d);
	}
	else {
		return new XsNumber( dval - d);
	}
}

public XsObject minus ( int i ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival - i);
	}
	else {
		return new XsNumber( dval - i);
	}
}

public XsObject mod ( String s ){
	int i;
	double d;
	
	try {
		if ( assumedFloat( s) ){
			d = Double.parseDouble(s);
			if ( type == TYPE_INT ){
				return new XsNumber( ival % d);
			}
			else {
				return new XsNumber( dval % d);
			}
		}
		else {
			i = Integer.decode(s).intValue();
			if ( type == TYPE_INT ){
				return new XsNumber( ival % i);
			}
			else {
				return new XsNumber( dval % i);
			}
		}
	}
	catch ( NumberFormatException x ) {
		return XsNumber.NaN;
	}
}

public XsObject mod ( XsObject x ){
        XsNumber xn = getNumberFromObject(x); 
        
        if ( type == TYPE_INT ){
		if ( xn.type == TYPE_INT ){
			return new XsNumber( ival % xn.ival);
		}
		else {
			return new XsNumber( ival % xn.dval);
		}
	}
	else {
		if ( xn.type == TYPE_INT ){
			return new XsNumber( dval % xn.ival);
		}
		else {
			return new XsNumber( dval % xn.dval);
	        }
        }
}

public XsObject mod ( double d ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival % d);
	}
	else {
		return new XsNumber( dval % d);
	}
}

public XsObject mod ( int i ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival % i);
	}
	else {
		return new XsNumber( dval % i);
	}
}

public XsObject mul ( String s ){
	int i;
	double d;
	
	try {
		if ( assumedFloat( s) ){
			d = Double.parseDouble(s);
			if ( type == TYPE_INT ){
				return new XsNumber( ival * d);
			}
			else {
				return new XsNumber( dval * d);
			}
		}
		else {
			i = Integer.decode(s).intValue();
			if ( type == TYPE_INT ){
				return new XsNumber( ival * i);
			}
			else {
				return new XsNumber( dval * i);
			}
		}
	}
	catch ( NumberFormatException x ) {
		if(s.equals(""))
			return new XsNumber(0.0);
                else
                        return XsNumber.NaN;
	}
}

public XsObject mul ( XsObject x ){
        //System.out.println("In XsNumber.mul");
        XsNumber xn = getNumberFromObject(x); 
	//System.out.println("after getNumberFromObject");    
        if ( type == TYPE_INT ){
		if ( xn.type == TYPE_INT ){
			return new XsNumber( ival * xn.ival);
		}
		else {
			return new XsNumber( ival * xn.dval);
		}
	}
	else {
		if ( xn.type == TYPE_INT ){
			return new XsNumber( dval * xn.ival);
		}
		else {
			return new XsNumber( dval * xn.dval);
	        }
        }    
}

public XsObject mul ( double d ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival * d);
	}
	else {
		return new XsNumber( dval * d);
	}
}

public XsObject mul ( int i ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival * i);
	}
	else {
		return new XsNumber( dval * i);
	}
}

public XsObject neg ( ) {
        if ( type == TYPE_INT ){
		return new XsNumber( -ival );
	}
	else {
		return new XsNumber( -dval );
	}
}

public XsObject not ( ) {
	if ( type == TYPE_INT ){
		return new XsNumber(~ival);
	}
	else {
		return new XsNumber(~(int)dval);
	}
}

public XsObject or  ( String s ){
	int i;
	double d;
	
	try {
		if ( assumedFloat( s) ){
			d = Double.parseDouble(s);
			if ( type == TYPE_INT ){
				return new XsNumber( ival | (int)d);
			}
			else {
				return new XsNumber( (int)dval | (int)d);
			}
		}
		else {
			i = Integer.decode(s).intValue();
			if ( type == TYPE_INT ){
				return new XsNumber( ival | i);
			}
			else {
				return new XsNumber( (int)dval | i);
			}
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}
}

public XsObject or  ( XsObject x ){
       	XsNumber xn = getNumberFromObject(x);
        if(xn != XsNumber.NaN){
		if ( xn.type == TYPE_INT ){
			return or(xn.ival);
		}
		else {
			return or(xn.dval);
		}
        }
        else
		return new XsNumber(0.0);
}

public XsObject or  ( double d ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival | (int)d);
	}
	else {
		return new XsNumber( (int)dval | (int)d);
	}
}

public XsObject or  ( int i ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival | i);
	}
	else {
		return new XsNumber( (int)dval | i);
	}
}

public XsObject plus ( String s ){
	return new XsString( toString() + s);
}

public XsObject plus ( XsObject x ){
        //replace lots of stuff with getNumberFromObject ???? 
        if(x == xTrue){
		return plus(1);
        }
        else if(x == xFalse || x == _null){
		return plus(0);
        } 
        else if(x == _undefined){
		return plus(NaN);
        }
	else if ( x instanceof XsNumber ){
		XsNumber xn = (XsNumber) x;	

		if ( type == TYPE_INT ){
			if ( xn.type == TYPE_INT ){
				return new XsNumber( ival + xn.ival);
			}
			else {
				return new XsNumber( (double)ival + xn.dval);
			}
		}
		else {
			if ( xn.type == TYPE_INT ){
				return new XsNumber( dval + (double)xn.ival);
			}
			else {
				return new XsNumber( dval + xn.dval);
			}
		}
	}
	else if ( x instanceof XsString ){
	    return plus(x.toString());
	}
	else if ( x instanceof XsArray ){
		return plus(x.toString());      
        }
        else if ( x instanceof XsFunc ){
		return plus(x.toString());      
        }
        else if ( x instanceof XsObject ){
		XsObject p; 

                if(!(x instanceof XsDate)){
			p = XsObject.getPrimitiveFromObject(x);
		}
		else{
		        p = XsObject.getPrimitiveFromDate(x);
		}                

                if(p instanceof XsString){
                        return plus(p.toString());
                }
                else if(p instanceof XsNumber){
			if ( ((XsNumber)p).type == XsNumber.TYPE_INT ){
				return plus(((XsNumber)p).ival);
		        }
			else {
				return plus(((XsNumber)p).dval);
			}
                }
                if(p == xTrue){
			return plus(1);
		}
		else if(p == xFalse || p == _null){
			return plus(0);
		} 
		else if(p == _undefined){
			return plus(NaN);
		}        
                else{   
                        //try toString
                        XsObject func;

                        if(!(x instanceof XsDate)){
				func = x.xsGet("toString");
			}
			else{
				func = x.xsGet("valueOf");
			}

                        //check exceptions on invoke ??

                        if(!(func instanceof XsFunc)){
				return XsNumber.NaN;
                        }                                  	
	                else{   
				return plus(func.invoke(x));
	                }
                }
        }
        else{
                return XsNumber.NaN;
        }
}

public XsObject plus ( double d ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival + d);
	}
	else {
		return new XsNumber( dval + d);
	}
}

public XsObject plus ( int i ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival + i);
	}
	else {
		return new XsNumber( dval + i);
	}
}

public XsObject postDec() {
	XsNumber old = new XsNumber(this);

	if ( type == TYPE_INT ){
		ival--;
	}
	else {
		dval--;
	}
	return old;
}

public XsObject postInc() {
	XsNumber old = new XsNumber(this);

	if ( type == TYPE_INT ){
		ival++;
	}
	else {
		dval++;
	}
	return old;
}

public void set ( int i ){
	type = TYPE_INT;
	ival = i;
}

public XsObject seq ( String s ) {
        return xFalse;
}

public XsObject seq ( XsObject x ) {
         if ( x instanceof XsNumber ){
		XsNumber xn = (XsNumber) x;	

		if ( type == TYPE_INT ){
			if ( xn.type == TYPE_INT ){
				return (ival == xn.ival) ? xTrue : xFalse;
			}
			else {
				return ((double)ival == xn.dval) ? xTrue : xFalse;
			}
		}
		else {
			if ( xn.type == TYPE_INT ){
				return (dval == (double) xn.ival) ? xTrue : xFalse;
			}
			else {
				return (dval == xn.dval) ? xTrue : xFalse;
			}
		}
	}
	else
		return xFalse;
}

public XsObject seq ( double d ) {
	return eq(d);
}

public XsObject seq ( int i ) {
	return eq(i);
}

public XsObject shl  ( String s ){
	int i;
	double d;
	
	try {
		if ( assumedFloat( s) ){
			d = Double.parseDouble(s);
			if ( type == TYPE_INT ){
				return new XsNumber( ival << (int)d);
			}
			else {
				return new XsNumber( (int)dval << (int)d);
			}
		}
		else {
			i = Integer.decode(s).intValue();
			if ( type == TYPE_INT ){
				return new XsNumber( ival << i);
			}
			else {
				return new XsNumber( (int)dval << i);
			}
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}
}

public XsObject shl  ( XsObject x ){
       	XsNumber xn = getNumberFromObject(x);
        if(xn != XsNumber.NaN){
		if ( xn.type == TYPE_INT ){
			return shl(xn.ival);
		}
		else {
			return shl(xn.dval);
		}
        }
        else
		return new XsNumber(0.0);
}

public XsObject shl  ( double d ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival << (int)d);
	}
	else {
		return new XsNumber( (int)dval << (int)d);
	}
}

public XsObject shl ( int i ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival <<  i);
	}
	else {
		return new XsNumber( (int)dval << i);
	}
}

public XsObject shr  ( String s ){
	int i;
	double d;
	
	try {
		if ( assumedFloat( s) ){
			d = Double.parseDouble(s);
			if ( type == TYPE_INT ){
				return new XsNumber( ival >> (int)d);
			}
			else {
				return new XsNumber( (int)dval >> (int)d);
			}
		}
		else {
			i = Integer.decode(s).intValue();
			if ( type == TYPE_INT ){
				return new XsNumber( ival >> i);
			}
			else {
				return new XsNumber( (int)dval >> i);
			}
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}
}

public XsObject shr  ( XsObject x ){
       	XsNumber xn = getNumberFromObject(x);
        if(xn != XsNumber.NaN){
		if ( xn.type == TYPE_INT ){
			return shr(xn.ival);
		}
		else {
			return shr(xn.dval);
		}
        }
        else
		return new XsNumber(0.0);
}

public XsObject shr  ( double d ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival >> (int)d);
	}
	else {
		return new XsNumber( (int)dval >> (int)d);
	}
}

public XsObject shr ( int i ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival >>  i);
	}
	else {
		return new XsNumber( (int)dval >> i);
	}
}

public XsObject toBoolean(){
        //System.out.println("Luke");

        if ( type == TYPE_INT ){
		return (ival == 0) ? xFalse : xTrue;
	}
	else {
		if(dval == 0.0 || this == NaN)
			return xFalse;
                else
                        return xTrue;
	}
}

public String toString() {
	if ( type == TYPE_INT ){
		return Integer.toString(ival);
	}
	else {
		return Double.toString(dval);
	}
}

public XsObject ushr  ( String s ){
	int i;
	double d;
	
	try {
		if ( assumedFloat( s) ){
			d = Double.parseDouble(s);
			if ( type == TYPE_INT ){
				return new XsNumber( ival >>> (int)d);
			}
			else {
				return new XsNumber( (int)dval >>> (int)d);
			}
		}
		else {
			i = Integer.decode(s).intValue();
			if ( type == TYPE_INT ){
				return new XsNumber( ival >>> i);
			}
			else {
				return new XsNumber( (int)dval >>> i);
			}
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}
}

public XsObject ushr  ( XsObject x ){
       	XsNumber xn = getNumberFromObject(x);
        if(xn != XsNumber.NaN){
		if ( xn.type == TYPE_INT ){
			return ushr(xn.ival);
		}
		else {
			return ushr(xn.dval);
		}
        }
        else
		return new XsNumber(0.0);
}

public XsObject ushr  ( double d ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival >>> (int)d);
	}
	else {
		return new XsNumber( (int)dval >>> (int)d);
	}
}

public XsObject ushr ( int i ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival >>>  i);
	}
	else {
		return new XsNumber( (int)dval >>> i);
	}
}

public XsObject valueOf (){
        //bug: returns a primitive, not an object
	return new XsNumber(this); 
}

public XsObject xor  ( String s ){
	int i;
	double d;
	
	try {
		if ( assumedFloat( s) ){
			d = Double.parseDouble(s);
			if ( type == TYPE_INT ){
				return new XsNumber( ival ^ (int)d);
			}
			else {
				return new XsNumber( (int)dval ^ (int)d);
			}
		}
		else {
			i = Integer.decode(s).intValue();
			if ( type == TYPE_INT ){
				return new XsNumber( ival ^ i);
			}
			else {
				return new XsNumber( (int)dval ^ i);
			}
		}
	}
	catch ( NumberFormatException x ) {
		return new XsNumber(0.0);
	}
}

public XsObject xor  ( XsObject x ){
       	XsNumber xn = getNumberFromObject(x);
        if(xn != XsNumber.NaN){
		if ( xn.type == TYPE_INT ){
			return xor(xn.ival);
		}
		else {
			return xor(xn.dval);
		}
        }
        else
		return new XsNumber(0.0);
}

public XsObject xor  ( double d ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival ^ (int)d);
	}
	else {
		return new XsNumber( (int)dval ^ (int)d);
	}
}

public XsObject xor  ( int i ){
	if ( type == TYPE_INT ){
		return new XsNumber( ival ^ i);
	}
	else {
		return new XsNumber( (int)dval ^ i);
	}
}

public XsObject xsGet ( String key ) {
	
	/*  if(key.equals( "prototype") ){
      		return number__proto__; 
	}
        else{*/
		return super.xsGet(key);
		// }

}

public XsString xsGetType () {
        if(isObject)
		return typeStrObj;
        else
                return typeStr;
}

	//not sure about this one yet
public XsObject xsPut ( String key, XsObject val ) {
	if ( key.equals("prototype") ){
                if(canPut(key)){ 
			number__proto__ = val;
                }
	}
	else {
		super.xsPut( key, val);
	}
	
	return val;
}





}//class




































































































