/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *
 * $tvt: XsTimeout.java,v 1.8 2001/07/17 02:13:00 samc Exp $
 */
package kaffe.xs;

import java.util.Vector;
import kaffe.util.Timer;
import kaffe.util.TimerClient;

public class XsTimeout
  implements TimerClient
{
	boolean repeat;
	String script;
	XsObject context;
	static Vector activeTimers;
	int id;

public XsTimeout( XsObject context, XsArray args, boolean repeat ) {
	this.repeat = repeat;
	this.context = context;
	
	if ( args.count > 1 ) {
		script = args.elements[0].toString();
		if ( args.elements[1] instanceof XsNumber ) {
			int val = ((XsNumber)args.elements[1]).getIntValue();
			Timer.getDefaultTimer().addClient( this, val, repeat ? val : 0);
			id = activeTimers.size();
		}
	}
}

static boolean deschedule( XsObject context, XsArray args) {
	int id = -1;
	
	if ( args.count > 0 ) {
		if ( args.elements[0] instanceof XsNumber ) {
			id = ((XsNumber)args.elements[0]).getIntValue();
		}
	}
	
	if ( id > -1 ) {
		for ( int i=0; i<activeTimers.size(); i++ ) {
			XsTimeout xt = (XsTimeout)activeTimers.elementAt( i);
			if ( xt.id == id ) {
				Timer.getDefaultTimer().removeClient( xt);
				activeTimers.removeElement( xt);
				return true;
			}
		}
	}
	
	return false;
}

static XsNumber schedule( XsObject context, XsArray args, boolean repeat) {
	if ( activeTimers == null ) {
		activeTimers = new Vector();
	}
	
	XsTimeout xt = new XsTimeout( context, args, repeat);
	activeTimers.addElement( xt);
	return new XsNumber( xt.id );	
}

public void timerExpired( Timer t) {
	

	try {
		XsEngine.interpret( context, context, script);
		if ( ! repeat ) {
			activeTimers.removeElement( this);
		}
	}
	catch ( Exception _ ) {
	}
}

public String toString() {
	return "[XsTimeout]: " + script;
}
}





