/*
 * Coding traversal utilities.
 * Separate file needed because of sorcerer buffer overflow problems.
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * @author Philippe Laporte 
 *
 * $tvt: coder_util.c,v 1.15 2001/09/10 16:39:29 philippe Exp $
 */

#include "xs_config.h"

#ifdef KAFFELIB
#include "util.h"
#endif

//extern int maxstacklimit; 

/**
 * for op= generation, so that have less code (not more speed), in the compiler itself
 */
char* OpAssignText (ANTLRTokenType ttype)                                          
{
  switch (ttype) {
    case USHR_ASSIGN:    return "ushr";
    case SHR_ASSIGN:     return "shr";
    case SHL_ASSIGN:     return "shl";
    case MINUS_ASSIGN:   return "minus";
    case PLUS_ASSIGN:    return "plus";
    case MOD_ASSIGN:     return "mod";
    case MUL_ASSIGN:     return "mul";
    case DIV_ASSIGN:     return "div";
    case OR_ASSIGN:      return "or";
    case AND_ASSIGN:     return "and";
    case XOR_ASSIGN:     return "xor";
    default:             return "";
  }  
} 
  
void preOpAssign (AST* _t, 
                  bool &id_was_local_or_global,
                  AST* &id,
                  ANTLRTokenType &type_was)
{
  if (_t->type() == ID) {

      if(_t->local_or_global == GLOBAL || curCallStackRequired){
          code_aload(2); // _def is always offset 2, in any context
          id_was_local_or_global = GLOBAL;
      }
      else {
          id = _t; 
          id_was_local_or_global = LOCAL;
      }

      type_was = ID;  
  }
  else if (_t->type() == DOT) {
      type_was = DOT;			     	     
  }
  else if (_t->type() == LBRACK) {
      type_was = LBRACK;
  }
}






void inOpAssign (bool id_was_local_or_global,
                 AST* id,
                 ANTLRTokenType type_was,
                 char* id_text)
{
  if (type_was == ID) {

      if (id_was_local_or_global == GLOBAL || curCallStackRequired) {
         /*
	  char* classname;
          if(!strcmp(id_text, "top")){
              classname= "kaffe/xs/XsObject";
          }
          else{
              classname = clsName;
          }
          char* temp = (char*) calloc(strlen(classname) + strlen("/ Lkaffe/xs/XsObject;") + strlen(id_text) + 1,
              sizeof(char));
          sprintf(temp, "%s/%s Lkaffe/xs/XsObject;", classname, id_text);

          code_getstatic(temp, true);
	  */
	  
	  if(!strcmp(id_text, "top")){
	      char* temp = (char*) calloc(STRLEN("kaffe/xs/XsObject/ Lkaffe/xs/XsObject;") + 
					  strlen(id_text) + 
					  1
					  ,
                                          sizeof(char)
					 );
              sprintf(temp, "kaffe/xs/XsObject/%s Lkaffe/xs/XsObject;",  id_text);

              code_getstatic(temp, true);
	  }
	  else{
	      code_aload(2);
	      code_ldc_string(id_text, false);
	      code_invokevirtual("kaffe/xs/XsObject/xsGet(Ljava/lang/String;)Lkaffe/xs/XsObject;", 1, false);
	  }
      }
      else {
          code_aload(id->offset);
      }
  }
}






void postOpAssign(bool id_was_local_or_global,
                  AST* id,
                  ANTLRTokenType type_was,
                  AST* op,
                  char* id_text)
{
  char* op_text = OpAssignText((ANTLRTokenType)op->type());
  char* temp1; 
  char* pre;
  char* post;

  pre = "kaffe/xs/XsObject/";

  post = "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;";

  if (type_was == ID) {

      temp1 = (char*) calloc( STRLEN("kaffe/xs/XsObject/(Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;") + 1 + 5,
                              sizeof(char));
      sprintf(temp1, "%s%s%s", pre, op_text, post);

      if (id_was_local_or_global == GLOBAL || curCallStackRequired) {
          code_invokevirtual_toBeFreed(temp1, 1, false);
          //problem here, needed to have Def and not _def
          code_invokevirtual("kaffe/xs/XsObject/xsPut(Ljava/lang/String;Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;", 2, false);  
	  
	  /*		 
					               
          code_dup();

          char* classname;
          if (!strcmp(id_text, "top")) {
              classname= "kaffe/xs/XsObject";
          }
          else {
              classname = clsName;
          }

          char* temp2 = (char*) calloc(strlen(classname) + strlen("/ Lkaffe/xs/XsObject;") + strlen(id_text) + 1,
              sizeof(char));
          sprintf(temp2, "%s/%s Lkaffe/xs/XsObject;", classname, id_text);

          code_putstatic(temp2, true);
	  */
	  
	  
	  if (!strcmp(id_text, "top")) {
	      code_dup();
	      char* temp2 = (char*) calloc(strlen(clsName) + STRLEN("/ Lkaffe/xs/XsObject;") + strlen(id_text) + 1,
                                           sizeof(char));
              sprintf(temp2, "%s/%s Lkaffe/xs/XsObject;", clsName, id_text);

              code_putstatic(temp2, true);
	  }
	 
      }
      else {
          code_invokevirtual_toBeFreed(temp1, 1, false);
          code_dup();
          code_astore(id->offset);
      }
  }
  else if (type_was == DOT) {
      temp1 = (char*) calloc(STRLEN("kaffe/xs/XsObject/(Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;") + 1 + 5 + 6,
                             sizeof(char));
      sprintf(temp1, "%s%sAssign%s", pre, op_text, post);

      code_invokevirtual_toBeFreed(temp1, 1, false);  
  }
  else if (type_was == LBRACK) {
      temp1 = (char*) calloc(STRLEN("kaffe/xs/XsObject/(Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;") + 1 + 5 + 6,
                             sizeof(char));
      sprintf(temp1, "%s%sAssign%s", pre, op_text, post);

      code_invokevirtual_toBeFreed(temp1, 1, false);
  }
}






/**
 * for switch generation
 */
void clone_and_insert_condition (CODE* condition, CODE* condition_end) 
{
  CODE* temp;

  if (currentcode == NULL) {

      CODE *new_code;
      new_code = NEW(CODE);
      memcpy(new_code, condition, sizeof(*temp)); //replace by sizeof CODE? or comes down to the same thing?

      currentcode = new_code;
      currenttail = new_code;

      for (temp = condition->next; temp != condition_end; temp = temp->next) {
          CODE *new_code;
          new_code = NEW(CODE);
          memcpy(new_code, temp, sizeof(*temp));
          currenttail->next = new_code;
          currenttail = new_code;
      } 
  }
  else {
      for (temp = condition; temp != condition_end; temp = temp->next) {
          CODE *new_code;
          new_code = NEW(CODE);
          memcpy(new_code, temp, sizeof(*temp));
          currenttail->next = new_code;
          currenttail = new_code;
      }
  }

  //do NOT free condition
}








/**
 * for event handler generation
 */
void produce_AnonymousClass (CODE* tail_before_script, char* event_name)
{
  CODE* tail_before_script_next = NULL;

  CODE* tail_after_script_next;
  
  
  //check that not NULL. If NULL, there is no script
  if(tail_before_script->next != NULL){
      tail_before_script_next = tail_before_script->next;
  }

  //produce anonymous class instanciation and setEventAttribute code

  code_aload(3);  


  tail_after_script_next = currenttail;

  code_ldc_string(event_name, false);

  char* classname = (char*) calloc(strlen(clsName) + 4 /* max length of sequence number. make more correct*/ + 1,
                                   sizeof(char));

  sprintf(classname, "%s$%d", clsName, event_handler_sequence++); 				       

  code_new(classname, true);

#ifdef KAFFELIB
  schedule_for_deletion(StrDup(classname));
#endif
	      			       
  code_dup();
  code_aload(0);

  //no null checks 

  code_aload(1);

  char* initname = (char*) calloc(strlen(classname) + 
                                  STRLEN("/<init>(L") +
                                  strlen(clsName) +
                                  STRLEN(";Lkaffe/xs/XsObject;)V") +
                                  1 
                                  ,
                                  sizeof(char));

  sprintf(initname, "%s/<init>(L%s;Lkaffe/xs/XsObject;)V", classname, clsName);

  code_invokespecial(initname, 1, true, true);

  code_invokeinterface("kaffe/xs/DocumentFactory/setEventAttribute(Ljava/lang/String;Lkaffe/xs/XsObject;)V", 2, true, false);

  #ifdef DEBUG
  fprintf(stderr, "setEventAttribute, attribute %s\n", event_name);
  #endif


  //generate anonymous class

  //bug if use classname
  char* jasmin_filename = (char*) calloc(strlen(classname) + 1 + 2, sizeof(char));
  strcpy(jasmin_filename, classname);

  emitFILE = fopen(strcat(jasmin_filename, ".j"), "w"); 

  fprintf(emitFILE,".class %s\n\n", classname);
  fprintf(emitFILE,".super kaffe/xs/XsObject\n\n");

  fprintf(emitFILE,".field private final this$0 L%s;\n", clsName);
  fprintf(emitFILE,".field private final val$_def Lkaffe/xs/XsObject;\n\n");

  //init

  fprintf(emitFILE,".method <init>(L%s;Lkaffe/xs/XsObject;)V\n", clsName);

  fprintf(emitFILE,"  .limit stack 2\n");
  fprintf(emitFILE,"  .limit locals 3\n");

  fprintf(emitFILE,"  aload_0\n");
  fprintf(emitFILE,"  invokespecial kaffe/xs/XsObject/<init>()V\n");

  fprintf(emitFILE,"  aload_0\n");
  fprintf(emitFILE,"  aload_2\n");
  fprintf(emitFILE,"  putfield %s/val$_def Lkaffe/xs/XsObject;\n", classname);

  fprintf(emitFILE,"  aload_0\n");
  fprintf(emitFILE,"  aload_1\n");
  fprintf(emitFILE,"  putfield %s/this$0 L%s;\n", classname, clsName);

  fprintf(emitFILE,"  aload_0\n");
  fprintf(emitFILE,"  aload_1\n");
  fprintf(emitFILE,"  invokespecial %s/constructor$0(L%s;)V\n", classname, clsName);

  fprintf(emitFILE,"  return\n");
  fprintf(emitFILE,".end method\n\n");

  //contructor

  fprintf(emitFILE,".method private final constructor$0(L%s;)V\n", clsName);
  fprintf(emitFILE,"  .limit stack 0\n");
  fprintf(emitFILE,"  .limit locals 2\n");
  fprintf(emitFILE,"  return\n");
  fprintf(emitFILE,".end method\n\n");

  //invoke

  fprintf(emitFILE,".method public invoke(Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;\n");

  if (tail_before_script_next != NULL) {  //if there is some script

      /* getting _def:

         replace 

         aload 2 

         by

         aload_0
         getfield MyObject$2/val$_def Lkaffe/xs/XsObject;

       */


      //prepare getField string
      //make the following more efficient
      char* get_field = (char*) calloc(strlen(classname) +
                                       STRLEN("/val$_def Lkaffe/xs/XsObject;")  +
                                       1 
                                       ,
                                       sizeof(char)
                                      );

      sprintf(get_field, "%s/val$_def Lkaffe/xs/XsObject;", classname); 


      CODE** temp;
      CODE** prev  = NULL;

      for(temp = &tail_before_script_next ; *temp != tail_after_script_next; temp = &((*temp)->next)){

          if((*temp)->kind == aloadCK &&  (*temp)->val.aloadC == 2){
              replaceNoFree(temp, 1, makeCODEaload(0,makeCODEgetfield(StrDup(get_field), NULL, true)));
          }

          prev = temp;
      }					        	       

      free(get_field);

      //mark end
      (*prev)->next = NULL;

      //find stack limit
      /*  limitCODE(tail_before_script_next);

      //printed code stack limit is 1
      if(maxstacklimit < 1){
      maxstacklimit = 1;
      }

	          */
	      
      fprintf(emitFILE,"  .limit stack 35\n"); 

					   
      //finally emit code
      emitCODE(tail_before_script_next);

      freeCODE(tail_before_script_next);


  } // if some code there
  else {
      fprintf(emitFILE,"  .limit stack 1\n");
  }


  fprintf(emitFILE,"  .limit locals 2\n");

  fprintf(emitFILE,"  aload_1\n");
  fprintf(emitFILE,"  areturn\n");
  fprintf(emitFILE,".end method\n\n");

  fclose(emitFILE);

  //assemble

#ifdef KAFFELIB

#include <jni.h>
  //needed??			 
#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

  jclass jasminMain; 
  jmethodID assemble;

  jasminMain = Genv->FindClass("jasmin.Main"); CheckException();
  
  assemble =  Genv->GetStaticMethodID(jasminMain, "assemble", "(Ljava/lang/String;Ljava/lang/String;Z)V"); CheckException();
  
  Genv->CallStaticVoidMethod(jasminMain, assemble, NULL, Genv->NewStringUTF(jasmin_filename), (jboolean) false); CheckException();

#else

  char* command = (char*) calloc(STRLEN("kaffe jasmin.Main ") + strlen(jasmin_filename) + 1 + 2, sizeof(char));
  sprintf(command, "kaffe jasmin.Main '%s'", jasmin_filename);
  system(command);
  free(command);

#endif	 

  //delete the jasmin file
  unlink(jasmin_filename);

  free(jasmin_filename);		       

  //patch the main code sequence so that it skips the handler code	
  tail_before_script->next = tail_after_script_next;
}  

  
  
  
    
inline 
void code_bin_op(char* op, AST* node){
       
        char* call = (char*) calloc(19 /* kaffe/xs/XsObject/ */  +
	                            strlen(op)  +
	                            1 /* ( */ +
				    19 /* Lkaffe/xs/XsObject; longest */ + 
				    20 /* )Lkaffe/xs/XsObject; */ +
				    1
				   ,
                                    sizeof(char)
				   );
				   
	int op_type = node->type();			   

        if((op_type == INT_CONST || op_type == OCT_CONST || op_type == HEX_CONST) && node->raw){
	        sprintf(call, "kaffe/xs/XsObject/%s(I)Lkaffe/xs/XsObject;", op);
	        code_invokevirtual_toBeFreed(call, 1, false);
	}
	else if((op_type == EXP_CONST || op_type == FLT_CONST) && node->raw){
	        sprintf(call, "kaffe/xs/XsObject/%s(D)Lkaffe/xs/XsObject;", op); 
	        code_invokevirtual_toBeFreed(call, 1, false);
	}
	else if(op_type == STRING_CONST && node->raw){
	        sprintf(call, "kaffe/xs/XsObject/%s(Ljava/lang/String;)Lkaffe/xs/XsObject;", op);
	        code_invokevirtual_toBeFreed(call, 1, false);
	}
	else{
	        sprintf(call, "kaffe/xs/XsObject/%s(Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;", op);
	        code_invokevirtual_toBeFreed(call, 1, false);
	}
}


			 
//returns NULL if no \ found
//not sure if this breaks \u etc 						                            
char* escape_backslash(char* in){
	          
        int len = strlen(in);
		  
        char* out = (char*) calloc(2 * len /* worst case all are \ */ + 1, sizeof(char));
		  
        int i,j;
		 
        for(i = 0,j = 0; i < len; i++){
	                
	        if(in[i] == '\\' && in[i + 1] != '\"' /*" are already backslashed */){
			  
	                out[j] = '\\';
			
	                out[j + 1] = '\\';
			
	                j+=2;
                }
	        else{
			out[j] = in[i];
				  
		        j++;
                }
	}
		  
        
	if(j == i){
                free(out);
                return NULL;
        }
        else{
                return out;
        }
}
      
	  
