/*
 * Code emission
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 *
 * @author Philippe Laporte 
 *
 * $tvt: emit.c,v 1.12 2001/09/17 22:48:14 philippe Exp $
 */

#include <stdio.h>
#include <string.h>

//#include "emit.h"
#include "optimize.h"


extern char* clsName;
extern char* baseName;
extern char* factoryName;

extern bool scriptOnly;

extern TOPLEVEL reset;

extern LABEL *currentlabels;


AST** function_handles;
int max_function_handles;
int nfunctions;


void initFunctionHandles (){
        function_handles = (AST**) calloc(10, sizeof(AST*));
	nfunctions = 0;
	max_function_handles = 10;
}

void growFunctionHandles (){
        int newMaxHandles = max_function_handles + 10;
	AST** newHandles = (AST**) calloc(newMaxHandles,sizeof(AST*));
	memcpy( newHandles, function_handles, max_function_handles*sizeof(AST*));
	free( function_handles);
	function_handles = newHandles;
	max_function_handles = newMaxHandles;
}

void deleteFunctionHandles (){
        free( function_handles);
}



/*

AST** field_handles;
int max_field_handles;
int nfields;

void initFieldHandles (){
        field_handles = (AST**) calloc(10, sizeof(AST*));
	max_function_handles = 10;
        nfields = 0;
}

void growFieldHandles (){
        int newMaxHandles = max_field_handles + 10;
	AST** newHandles = (AST**) calloc(newMaxHandles,sizeof(AST*));
	memcpy( newHandles, field_handles, max_field_handles*sizeof(AST*));
	free( field_handles);
	field_handles = newHandles;
	max_field_handles = newMaxHandles;
}

void deleteFieldHandles (){
        free( field_handles);
}



//get rid of ?
inline int nodecmp(AST* node1, AST* node2){
        return strcmp(node1->getText(), node2->getText());
}

void addFieldHandle(AST* node){

        if(inEventScript){
	    return;
	}			   

        if(nfields == max_field_handles)
	    growFieldHandles();
	
        //no duplicates		   
	for(int i = 0; i < nfields; i++){
	    if(!nodecmp(field_handles[i], node))
	        return;   
	}
	
	
        field_handles[nfields++] = node;
}


*/




FILE *emitFILE;

LABEL *emitlabels;



// STACK LIMIT computation **************************************
/*

CODE *dest(int label)
{ return emitlabels[label].position;
}


int maxstacklimit;


typedef struct nodeinfo{
	                    CODE * nextNode;     // next vertice going along this edge 
			   int stackheight;     // stack height at that point(after edge) 
} EdgeInfo;



void DFS_VISIT(CODE* c, int stackheight);
int getEdges(CODE *c, int stackheight, EdgeInfo* edgeinfo);



int limitCODE(CODE* c)
{

 CODE* p;
 maxstacklimit = 0;
 for(p =c; p != NULL; p = p->next) // since every node is reachable, this is not really needed 
	if(!p->visited)
		DFS_VISIT(c, 0);
		
}



void DFS_VISIT(CODE* c, int stackheight)
{ 
 EdgeInfo edges[2]; // 2 edges max out of a node -> 2 for ifeq etc
 int numedges ; // number of outgoing edges 
 int i;

 c->visited = 1;
 numedges = getEdges(c, stackheight, edges);
 

 for(i = 0; i < numedges; i++){
   if(edges[i].stackheight > maxstacklimit)
	   maxstacklimit = edges[i].stackheight;
   if(edges[i].nextNode)	   
       if(!edges[i].nextNode->visited)    
           DFS_VISIT(edges[i].nextNode, edges[i].stackheight);
 }

 c->visited = 2;

}


//MAKE ALL INSTRUCTIONS ARE HERE: examplee: athrow
// return array of  EdgeInfo as output param for two possible edges (0, 1 or 2)
int getEdges(CODE *c, int stackheight, EdgeInfo* edgeinfo){ 
 
    if (c!=NULL){

     switch(c->kind) { 
      /* case i2cCK:
                         edgeinfo[0].nextNode = next(c);
		                 edgeinfo[0].stackheight = stackheight;
                         return  1;*//*

       case newCK:
                         edgeinfo[0].nextNode = next(c);
		         edgeinfo[0].stackheight = stackheight + 1;
                         return  1;

       case instanceofCK:
                         edgeinfo[0].nextNode = next(c);
		                 edgeinfo[0].stackheight = stackheight;
                         return  1;

       case checkcastCK:
                         edgeinfo[0].nextNode = next(c);
		                 edgeinfo[0].stackheight = stackheight;
                         return  1;
/*
       case imulCK:
                         edgeinfo[0].nextNode = next(c);
		                 edgeinfo[0].stackheight = stackheight - 1;
                         return  1;
       case inegCK:
                         edgeinfo[0].nextNode = next(c);
		                 edgeinfo[0].stackheight = stackheight;
                         return  1;

       case iremCK:
                         edgeinfo[0].nextNode = next(c);
		                 edgeinfo[0].stackheight = stackheight - 1;
                         return  1;

       case isubCK:
                         edgeinfo[0].nextNode = next(c);
		                 edgeinfo[0].stackheight = stackheight - 1;
                         return  1;

       case idivCK:
                         edgeinfo[0].nextNode = next(c);
		                 edgeinfo[0].stackheight = stackheight - 1;
                         return  1;

       case iaddCK:
                         edgeinfo[0].nextNode = next(c);
		                 edgeinfo[0].stackheight = stackheight - 1;
                         return  1;

       case iincCK:
                         edgeinfo[0].nextNode = next(c);
		                 edgeinfo[0].stackheight = stackheight;
                         return  1;*//*

       case labelCK:
                         edgeinfo[0].nextNode = next(c);
		         edgeinfo[0].stackheight = stackheight;
                         return  1;

       case gotoCK:      edgeinfo[0].nextNode = dest(c->val.gotoC);
		         edgeinfo[0].stackheight = stackheight;
                         return  1;
		                 
            			             
       case ifeqCK:      edgeinfo[0].nextNode = dest(c->val.ifeqC);
		         edgeinfo[0].stackheight = stackheight - 1;
			 
                         edgeinfo[1].nextNode = next(c);
		         edgeinfo[1].stackheight = stackheight - 1;
                         return  2;

           /* 
       case ifneCK:
                         edgeinfo[0].nextNode = dest(c->val.ifneC);
		                 edgeinfo[0].stackheight = stackheight - 1;
                         edgeinfo[1].nextNode = next(c);
		                 edgeinfo[1].stackheight = stackheight - 1;
                         return  2;

*//*
       case if_acmpeqCK: edgeinfo[0].nextNode = dest(c->val.if_acmpeqC);
		         edgeinfo[0].stackheight = stackheight - 2;
			 
                         edgeinfo[1].nextNode = next(c);
		         edgeinfo[1].stackheight = stackheight - 2;
                         return  2;

       case if_acmpneCK:
                         edgeinfo[0].nextNode = dest(c->val.if_acmpneC);
		         edgeinfo[0].stackheight = stackheight - 2;
			 
                         edgeinfo[1].nextNode = next(c);
		         edgeinfo[1].stackheight = stackheight - 2;
                         return  2;

  /*     case ifnullCK:
                         edgeinfo[0].nextNode = dest(c->val.ifnullC);
		                 edgeinfo[0].stackheight = stackheight - 1;
                         edgeinfo[1].nextNode = next(c);
		                 edgeinfo[1].stackheight = stackheight - 1;
                         return  2;

       case ifnonnullCK:
                         edgeinfo[0].nextNode = dest(c->val.ifnonnullC);
		                 edgeinfo[0].stackheight = stackheight - 1;
                         edgeinfo[1].nextNode = next(c);
		                 edgeinfo[1].stackheight = stackheight - 1;
                         return  2;

       case if_icmpeqCK:
                         edgeinfo[0].nextNode = dest(c->val.if_icmpeqC);
		                 edgeinfo[0].stackheight = stackheight - 2;
                         edgeinfo[1].nextNode = next(c);
		                 edgeinfo[1].stackheight = stackheight - 2;
                         return  2;

       case if_icmpgtCK:
                         edgeinfo[0].nextNode = dest(c->val.if_icmpgtC);
		                 edgeinfo[0].stackheight = stackheight - 2;
                         edgeinfo[1].nextNode = next(c);
		                 edgeinfo[1].stackheight = stackheight - 2;
                         return  2;

       case if_icmpltCK:
                         edgeinfo[0].nextNode = dest(c->val.if_icmpltC);
		                 edgeinfo[0].stackheight = stackheight - 2;
                         edgeinfo[1].nextNode = next(c);
		                 edgeinfo[1].stackheight = stackheight - 2;
                         return  2;

       case if_icmpleCK:
                         edgeinfo[0].nextNode = dest(c->val.if_icmpleC);
		                 edgeinfo[0].stackheight = stackheight - 2;
                         edgeinfo[1].nextNode = next(c);
		                 edgeinfo[1].stackheight = stackheight - 2;
                         return  2;

       case if_icmpgeCK:
                         edgeinfo[0].nextNode = dest(c->val.if_icmpgeC);
		                 edgeinfo[0].stackheight = stackheight - 2;
                         edgeinfo[1].nextNode = next(c);
		                 edgeinfo[1].stackheight = stackheight - 2;
                         return  2;

       case if_icmpneCK:
                         edgeinfo[0].nextNode = dest(c->val.if_icmpneC);
		                 edgeinfo[0].stackheight = stackheight - 2;
                         edgeinfo[1].nextNode = next(c);
		                 edgeinfo[1].stackheight = stackheight - 2;
                         return  2;

       case ireturnCK:
                         return  0;// return from this trace, can use since all traces return 
   *//*    
       case areturnCK:
                            return  0;
       case returnCK:
                            return  0;
       case aloadCK:
                            edgeinfo[0].nextNode = next(c);
		            edgeinfo[0].stackheight = stackheight + 1;
                            return  1;

       case astoreCK:
                            edgeinfo[0].nextNode = next(c);
		            edgeinfo[0].stackheight = stackheight - 1;
                            return  1;
  /*     case iloadCK:
                            edgeinfo[0].nextNode = next(c);
		                    edgeinfo[0].stackheight = stackheight + 1;
                            return  1;
       case istoreCK:
                            edgeinfo[0].nextNode = next(c);
		                    edgeinfo[0].stackheight = stackheight - 1;
                            return  1;
    */ /*  
       case dupCK:
                            edgeinfo[0].nextNode = next(c);
		            edgeinfo[0].stackheight = stackheight + 1;
                            return  1;
       case popCK:
                            edgeinfo[0].nextNode = next(c);
		            edgeinfo[0].stackheight = stackheight - 1;
                            return  1;
   /*    case swapCK:
                            edgeinfo[0].nextNode = next(c);
		                    edgeinfo[0].stackheight = stackheight;
                            return  1;
   */  /*  
       case ldc_intCK:
                            edgeinfo[0].nextNode = next(c);
		            edgeinfo[0].stackheight = stackheight + 1;
                            return  1;
       case ldc_stringCK:
                            edgeinfo[0].nextNode = next(c);
		            edgeinfo[0].stackheight = stackheight + 1;
                            return  1;
    /*   case aconst_nullCK:
                            edgeinfo[0].nextNode = next(c);
		                    edgeinfo[0].stackheight = stackheight + 1;
                            return  1;*//*
       case getfieldCK:
                            edgeinfo[0].nextNode = next(c);
		            edgeinfo[0].stackheight = stackheight;
                            return  1;*//*
       case putfieldCK:
                            edgeinfo[0].nextNode = next(c);
		                    edgeinfo[0].stackheight = stackheight - 2;
                            return  1;
       case getstaticCK:    edgeinfo[0].nextNode = next(c);
		            edgeinfo[0].stackheight = stackheight + 1;
                            return  1;

       case putstaticCK:    edgeinfo[0].nextNode = next(c);
		            edgeinfo[0].stackheight = stackheight - 1;
                            return  1;
                           			    
       case invokevirtualCK: edgeinfo[0].nextNode = next(c);
		             edgeinfo[0].stackheight = stackheight 
			                               - c->val.invokevirtualC.nargs - 1 
						       + (c->val.invokevirtualC.isVoid) ? 0 : 1;
                             return  1;
		                    
       case invokespecialCK: edgeinfo[0].nextNode = next(c);
		             edgeinfo[0].stackheight = stackheight 
			                               - c->val.invokespecialC.nargs - 1 
						       + (c->val.invokespecialC.isVoid) ? 0 : 1;
                             return  1;
			     
       case invokestaticCK:  edgeinfo[0].nextNode = next(c);
		             edgeinfo[0].stackheight = stackheight 
			                               - c->val.invokestaticC.nargs  
						       + (c->val.invokestaticC.isVoid) ? 0 : 1;
                             return  1;
			     
       case invokeinterfaceCK: edgeinfo[0].nextNode = next(c);
		               edgeinfo[0].stackheight = stackheight 
			                                 - c->val.invokeinterfaceC.nargs - 1 
							 + (c->val.invokeinterfaceC.isVoid) ? 0 : 1;
                               return  1;
             
      			       
			       
       default: printf("NO CASE MATHCES\n");
                return 0;			       
     }
   
  }
  else{
	   printf("ERROR IN STACK LIMIT:  NULL");
	  
	   return 0;
	  
  }

}

*/



void emitLABEL(int label)
{ 
  //printf("In emitLabel, label is %d, emitlabels is %p, name is %s\n", label, emitlabels, emitlabels[label].name);
  fprintf(emitFILE,"%s_%i",emitlabels[label].name,label);
}

void localmem(char *opcode, int offset)
{ 
  if (offset >=0 && offset <=3) {
     fprintf(emitFILE,"%s_%i",opcode,offset);
  } else {
     fprintf(emitFILE,"%s %i",opcode,offset);
  }
}

void emitCODE(CODE *c)
{ 
  if (c!=NULL) {
     if(c->kind != labelCK)
       fprintf(emitFILE,"  ");
     switch(c->kind) {
     /*  case i2cCK:
            fprintf(emitFILE,"i2c");
            break;*/
       case newCK:
            fprintf(emitFILE,"new %s",c->val.newC);
            break;
       case instanceofCK:
            fprintf(emitFILE,"instanceof %s",c->val.instanceofC);
            break;
       case checkcastCK:
            fprintf(emitFILE,"checkcast %s",c->val.checkcastC);
            break;
 /*      case imulCK:
            fprintf(emitFILE,"imul");
            break;
       case inegCK:
            fprintf(emitFILE,"ineg");
            break;
       case iremCK:
            fprintf(emitFILE,"irem");
            break;
       case isubCK:
            fprintf(emitFILE,"isub");
            break;
       case idivCK:
            fprintf(emitFILE,"idiv");
            break;
       case iaddCK:
            fprintf(emitFILE,"iadd");
            break;
       case iincCK:
            fprintf(emitFILE,"iinc %i %i", c->val.iincC.offset, c->val.iincC.amount);
            break;*/
       case labelCK:
            emitLABEL(c->val.labelC);
            fprintf(emitFILE,":");
            break;
       case gotoCK:
            fprintf(emitFILE,"goto ");
            emitLABEL(c->val.gotoC);
            break;
       case ifeqCK:
            fprintf(emitFILE,"ifeq ");
            emitLABEL(c->val.ifeqC);
            break;
     /*  case ifneCK:
            fprintf(emitFILE,"ifne ");
            emitLABEL(c->val.ifneC);
            break;*/
       case if_acmpeqCK:
            fprintf(emitFILE,"if_acmpeq ");
            emitLABEL(c->val.if_acmpeqC);
            break;
       case if_acmpneCK:
            fprintf(emitFILE,"if_acmpne ");
            emitLABEL(c->val.if_acmpneC);
            break;
      /* case ifnullCK:
            fprintf(emitFILE,"ifnull ");
            emitLABEL(c->val.ifnullC);
            break;
       case ifnonnullCK:
            fprintf(emitFILE,"ifnonnull ");
            emitLABEL(c->val.ifnonnullC);
            break;
       case if_icmpeqCK:
            fprintf(emitFILE,"if_icmpeq ");
            emitLABEL(c->val.if_icmpeqC);
            break;
       case if_icmpgtCK:
            fprintf(emitFILE,"if_icmpgt ");
            emitLABEL(c->val.if_icmpgtC);
            break;
       case if_icmpltCK:
            fprintf(emitFILE,"if_icmplt ");
            emitLABEL(c->val.if_icmpltC);
            break;
       case if_icmpleCK:
            fprintf(emitFILE,"if_icmple ");
            emitLABEL(c->val.if_icmpleC);
            break;
       case if_icmpgeCK:
            fprintf(emitFILE,"if_icmpge ");
            emitLABEL(c->val.if_icmpgeC);
            break;
       case if_icmpneCK:
            fprintf(emitFILE,"if_icmpne ");
            emitLABEL(c->val.if_icmpneC);
            break;
       case ireturnCK:
            fprintf(emitFILE,"ireturn");
            break;*/
       case areturnCK:
            fprintf(emitFILE,"areturn");
            break;
       case returnCK:
            fprintf(emitFILE,"return");
            break;
       case aloadCK:
            localmem("aload",c->val.aloadC);
            break;
       case astoreCK:
            localmem("astore",c->val.astoreC);
            break;
      /* case iloadCK:
            localmem("iload",c->val.iloadC);
            break;
       case istoreCK:
            localmem("istore",c->val.istoreC);
            break;*/
       case dupCK:
            fprintf(emitFILE,"dup");
            break;
       case popCK:
            fprintf(emitFILE,"pop");
            break;
      /* case swapCK:
            fprintf(emitFILE,"swap");
            break;*/
       case ldc_intCK:
            if (c->val.ldc_intC >= 0 && c->val.ldc_intC <= 5) {
               fprintf(emitFILE,"iconst_%i",c->val.ldc_intC);
            } else {
               fprintf(emitFILE,"ldc %i",c->val.ldc_intC);
            }
            break;
       case ldc_floatCK:
            fprintf(emitFILE,"ldc2_w %f",c->val.ldc_floatC);
            break;
       case ldc_stringCK:
            fprintf(emitFILE,"ldc \"%s\"",c->val.ldc_stringC);
            break;
      /* case aconst_nullCK:
            fprintf(emitFILE,"aconst_null");
            break;*/
       case getfieldCK:
            fprintf(emitFILE,"getfield %s",c->val.getfieldC);
            break;
       case putfieldCK:
            fprintf(emitFILE,"putfield %s",c->val.putfieldC);
            break;
       case getstaticCK:
            fprintf(emitFILE,"getstatic %s",c->val.getstaticC);
            break;
       case putstaticCK:
            fprintf(emitFILE,"putstatic %s",c->val.putstaticC);
            break;
       case invokevirtualCK:
            fprintf(emitFILE,"invokevirtual %s",c->val.invokevirtualC.text);
            break;
       case invokespecialCK:
            fprintf(emitFILE,"invokespecial %s",c->val.invokespecialC.text);
            break;
       case invokestaticCK:
            fprintf(emitFILE,"invokestatic %s",c->val.invokestaticC.text);
            break;
       case invokeinterfaceCK:
            fprintf(emitFILE,"invokeinterface %s %d",c->val.invokeinterfaceC.text,c->val.invokeinterfaceC.nargs + 1);
            break;
       case athrowCK:
            fprintf(emitFILE,"athrow");
            break;
	    
       default: printf("DEFAULT hit in emitCODE. kind is %d\n", c->kind);	    
 	    
     }
     //put this into each call ???, -> saves a call
     fprintf(emitFILE,"\n");
     
     emitCODE(c->next);
  }
}




void emitCONSTRUCTOR(){ 

        fprintf(emitFILE,".method public <init>()V\n");
        
	fprintf(emitFILE,"  .limit locals 1\n");
	fprintf(emitFILE,"  .limit stack 1\n\n");
	 
	fprintf(emitFILE,"  aload_0\n");
        fprintf(emitFILE,"  invokespecial kaffe/xs/XsObject/<init>()V\n");
	
	fprintf(emitFILE,"  aload_0\n"); 
	fprintf(emitFILE,"  putstatic %s/Def L%s;\n", clsName, clsName);
	
	if(scriptOnly){
                fprintf(emitFILE,"  aload_0\n");
	        fprintf(emitFILE,"  invokevirtual %s/reset()V\n", clsName);
	}
	
	fprintf(emitFILE,"  return\n");
	
	fprintf(emitFILE,".end method\n\n\n");
}

void emitMAIN(){ 

        fprintf(emitFILE,".method public static main([Ljava/lang/String;)V\n");
        
	fprintf(emitFILE,"  .limit locals 1\n");
	fprintf(emitFILE,"  .limit stack 1\n\n");
	 
	fprintf(emitFILE,"  new %s\n", clsName);
        fprintf(emitFILE,"  invokespecial %s/<init>()V\n", clsName);
	fprintf(emitFILE,"  return\n"); 
	
	fprintf(emitFILE,".end method\n\n\n");
}

void emitRESET(){
 
        //first peephole-optimize the code, must do before stack limit computation
//	printf("reset.labels = %p\n", reset.labels);
	
	currentlabels = reset.labels;
        optiCODE(&reset.opcodes);
	
	
        fprintf(emitFILE,".method public reset()V\n");
	fprintf(emitFILE,"  .limit locals %i\n", reset.localslimit + 1); 
 
        emitlabels = reset.labels;
	
//	printf("reset.labels = %p\n", reset.labels);
        
/*	//find stack limit
	limitCODE(reset.opcodes);
	
	//printed code stack limit is 4. REVIEW this value
	if(maxstacklimit < 4){
	    maxstacklimit = 4;
	}
        */
	

	fprintf(emitFILE,"  .limit stack %i\n\n", /*maxstacklimit*/35);
	
	
	
	
	//intializations

	/*
	add to global, not to per document object ??
	*/	
			
	//put "this" on call stack
	fprintf(emitFILE,"  getstatic kaffe/xs/XsObject/callStack Ljava/util/Stack;\n");
	
	//fprintf(emitFILE,"  getstatic %s/Def L%s;\n", clsName, clsName);
	fprintf(emitFILE,"  aload_0\n");
	//multithreading? must fetch every time ?
	fprintf(emitFILE,"  dup\n");
	
	fprintf(emitFILE,"  dup\n");	
	
	fprintf(emitFILE,"  astore_1\n");
	
	fprintf(emitFILE,"  astore_2\n");
	
	fprintf(emitFILE,"  invokevirtual java/util/Stack/push(Ljava/lang/Object;)Ljava/lang/Object;\n");
	
	//to satisfy jdk. Kaffe bug???
	fprintf(emitFILE,"  checkcast kaffe/xs/XsObject\n");
	
	//should this be aasigning parent to Stack.peek() ???
	fprintf(emitFILE,"  getstatic kaffe/xs/XsObject/global Lkaffe/xs/XsObject;\n");
       	
        fprintf(emitFILE,"  putfield kaffe/xs/XsObject/parent Lkaffe/xs/XsObject;\n");

		
        if(!scriptOnly){
            fprintf(emitFILE,"  aload_0\n");
	    fprintf(emitFILE,"  invokevirtual kaffe/xs/XsObject/getDocumentFactory()Lkaffe/xs/DocumentFactory;\n");
           
	    #ifdef KAFFELIB
	      fprintf(emitFILE,"  dup\n");    
	    #endif
	    
	    fprintf(emitFILE,"  astore_3\n");
	    
	    #ifdef KAFFELIB
	      fprintf(emitFILE,"  putstatic kaffe/xs/XsEngine/curDocumentFactory Lkaffe/xs/DocumentFactory;\n");
	    #endif 
	}
	
        //declare functions
	//improvement: dup the result of getstatic MyObject/Def LMyObject; nargs - 1 times ???
	for(int i = 0; i < nfunctions; i++){
	 
	        AST* function = function_handles[i];
		
		char* function_name = ((AST*)function->down())->getText();
                
		fprintf(emitFILE,"  aload_2\n");
		//fprintf(emitFILE,"  getstatic MyObject/Def LMyObject;\n");
	        fprintf(emitFILE,"  ldc \"%s\"\n", function_name);
		if (function->nargs >= 0 && function->nargs <= 5) {
                        fprintf(emitFILE,"  iconst_%i\n", function->nargs);
                } 
		else{
                        fprintf(emitFILE,"  ldc %i\n", function->nargs);
                }

	     //   fprintf(emitFILE,"  invokevirtual kaffe/xs/XsObject/defFunc(Ljava/lang/String;I)Lkaffe/xs/XsObject;\n");
	        //fprintf(emitFILE,"  putstatic %s/%s Lkaffe/xs/XsObject;\n", clsName, function_name);
	     // fprintf(emitFILE,"  pop\n");
	     
	     fprintf(emitFILE,"  invokevirtual kaffe/xs/XsObject/defFunc(Ljava/lang/String;I)V\n");
	
        }
    
     // printf("reset.labels = %p\n", reset.labels);
	
	emitCODE(reset.opcodes);
	
	freeCODE(reset.opcodes);
	
	free(reset.labels);

        if(!scriptOnly){
            fprintf(emitFILE,"  aload_3\n");
	    fprintf(emitFILE,"  invokeinterface kaffe/xs/DocumentFactory/finish()V 1\n"); 
        }

        fprintf(emitFILE,"  return\n");
	
        fprintf(emitFILE,".end method\n\n\n");  
}   


void emitFUNCTIONS(){ 

        for(int i = 0; i < nfunctions; i++){
	 
	        AST* function = function_handles[i];
		
		//first peephole-optimize the code
	//	printf("function->labels = %p\n", function->labels);
	
	
 	        currentlabels = function->labels;
                optiCODE(&function->opcodes);
		
	
                fprintf(emitFILE,".method public static _%s(Lkaffe/xs/XsObject;Lkaffe/xs/XsArray;)Lkaffe/xs/XsObject;\n", 
		                 ((AST*)function->down())->getText()
		       );
		       
	
                fprintf(emitFILE,"  .limit locals %i\n", function->localslimit + 1);
		
                emitlabels = function->labels;
		
		
		
	/*	//find stack limit
	        limitCODE(function->opcodes);
	
	        //printed code stack limit 
	        int hardcodedlimit;
		if(function->localslimit - function->nargs > 2){
		    hardcodedlimit = function->localslimit - function->nargs;
	        }
		else{
		    hardcodedlimit = 2; //review this value!!!
		}
	
	
	        if(maxstacklimit < hardcodedlimit){
	            maxstacklimit = hardcodedlimit;
	        }

		*/
		fprintf(emitFILE,"  .limit stack %i\n\n", /*maxstacklimit*/35);
                
		//TEST
		//function->CallStackRequired = true;
		
		//_def assignment
		
		if(!functionOnly){
                    
		    if(!function->CallStackRequired){
		        fprintf(emitFILE,"  getstatic %s/Def L%s;\n", clsName, clsName); 
			fprintf(emitFILE,"  astore_2\n"); 
		    }
		    else{
		       		    
		        //get Call Stack
		        fprintf(emitFILE,"  getstatic kaffe/xs/XsObject/callStack Ljava/util/Stack;\n");
		       
		        fprintf(emitFILE,"  dup\n");
		    
		        //get parent and put it at bottom for later
			fprintf(emitFILE,"  invokevirtual java/util/Stack/peek()Ljava/lang/Object;\n");
			
			fprintf(emitFILE,"  swap\n");
		    
		        //make new context
		        fprintf(emitFILE,"  new kaffe/xs/XsObject\n");
                        fprintf(emitFILE,"  dup\n");
                        fprintf(emitFILE,"  invokespecial kaffe/xs/XsObject/<init>()V\n");   
		    
		        //push onto stack
		        fprintf(emitFILE,"  invokevirtual java/util/Stack/push(Ljava/lang/Object;)Ljava/lang/Object;\n");
		    
		        fprintf(emitFILE,"  checkcast kaffe/xs/XsObject\n");
		    
		        //save aside for local _def
		        fprintf(emitFILE,"  dup\n");
		        fprintf(emitFILE,"  astore_2\n");
		    
		        //make the parent link
		        fprintf(emitFILE,"  swap\n");
		        
			fprintf(emitFILE,"  checkcast kaffe/xs/XsObject\n");	        
		        
			fprintf(emitFILE,"  putfield kaffe/xs/XsObject/parent Lkaffe/xs/XsObject;\n");
		    }		                          
                }
                else{
			    
                    fprintf(emitFILE,"  aload_1\n");
		    fprintf(emitFILE,"  dup\n");
		    fprintf(emitFILE,"  getfield kaffe/xs/XsArray/elements [Lkaffe/xs/XsObject;\n");
		    fprintf(emitFILE,"  swap\n");
		    fprintf(emitFILE,"  getfield kaffe/xs/XsArray/count I\n");
		    fprintf(emitFILE,"  iconst_1\n");
		    fprintf(emitFILE,"  isub\n");
                    fprintf(emitFILE,"  aaload\n");
		    
		    //save aside for local _def
		    fprintf(emitFILE,"  astore_2\n");
		}
		
		
		
		
		//must assign undefined to all locals (not formals)
	        //since must have def before use 

		if(!function->CallStackRequired){
		
		    //can optimize this, say if have var a= 4; 
	            if((function->localslimit - function->nargs) != 2)
		        fprintf(emitFILE,"  getstatic kaffe/xs/XsObject/_undefined Lkaffe/xs/XsObject;\n");
		    
		    int j;
		
                    for(j = 3; j < (function->localslimit - function->nargs); j++){
		        fprintf(emitFILE,"  dup\n");
		    }    
		
		    for(j = 2; j < (function->localslimit - function->nargs); j++){
		        localmem("  astore", j + 1);
		        fprintf(emitFILE,"\n");
		    }
		
	        }
		else{ // callStackRequired
		     
		    int nlocals;
		    
		    char** locals = getAllLocalVars(function->localsym, &nlocals);
		    
		    if( nlocals != 0){ 
		    
		        fprintf(emitFILE,"  getstatic kaffe/xs/XsObject/_undefined Lkaffe/xs/XsObject;\n");		
								
		        for(i = 0; i < nlocals; i++){
		            fprintf(emitFILE,"  aload_2\n");
			    fprintf(emitFILE,"  swap\n");
			    fprintf(emitFILE,"  ldc \"%s\"\n", locals[i]);
			    fprintf(emitFILE,"  swap\n");
			    fprintf(emitFILE,"  invokevirtual  kaffe/xs/XsObject/defProperty(Ljava/lang/String;Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;\n");
                        }
		
		        fprintf(emitFILE,"  pop\n");
		    } 
		
		    free(locals);
		    
		    		  		
		}// if callStackRequired
		
		
		
		//actual argument assignment switch
		//watch out: make sure no label names conflict with "real" switches
		if(function->nargs != 0){
		
		        fprintf(emitFILE,"  aload_1\n");
			
                        fprintf(emitFILE,"  getfield kaffe/xs/XsArray/count I\n");
			
			if(functionOnly){
			    fprintf(emitFILE,"  iconst_1\n");
		            fprintf(emitFILE,"  isub\n");
			}
			
			fprintf(emitFILE,"  tableswitch 0 %d\n", function->nargs - 1);
		        int j;
		        
			for(j = 0; j < function->nargs; j++)
		                fprintf(emitFILE,"             case%d\n", j);
		
		        fprintf(emitFILE,"    default: case%d\n", j);
		
		
		        //improve: use dups
		        int arg;
			
			AST* formal_start = (AST*) function->down()->right();
		        AST* formal;
			
                        for(arg = 0; arg < function->nargs; arg++){
			
			      fprintf(emitFILE,"case%d:\n", arg);   
                                          
			      formal = formal_start;		  
					  
                              for(j = 0; j < arg; j++, formal = (AST*) formal->right()){
			              if(function->CallStackRequired){
				              fprintf(emitFILE,"  aload_2\n");
			                      fprintf(emitFILE,"  ldc \"%s\"\n", formal->getText()); 
				      }
				      
			              fprintf(emitFILE,"  aload_1\n");
			              fprintf(emitFILE,"  getfield kaffe/xs/XsArray/elements [Lkaffe/xs/XsObject;\n");
			              if (j >= 0 && j <= 5) {
                                              fprintf(emitFILE,"  iconst_%i\n", j);
                                      } 
		                      else{
                                              fprintf(emitFILE,"  ldc %i\n", j);
                                      }
                                      fprintf(emitFILE,"  aaload\n");
				      
				      
				      if(function->CallStackRequired){
				              fprintf(emitFILE,"  invokevirtual  kaffe/xs/XsObject/defProperty(Ljava/lang/String;Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;\n");
				      }
				      else{
				              localmem("  astore", formal->offset);
				              fprintf(emitFILE,"\n");
			              }
			      } 
                                      
			      for(; j < function->nargs; j++, formal = (AST*) formal->right()){
			              if(function->CallStackRequired){
				              fprintf(emitFILE,"  aload_2\n");
			                      fprintf(emitFILE,"  ldc \"%s\"\n", formal->getText()); 
				      }

				      fprintf(emitFILE,"  getstatic kaffe/xs/XsObject/_undefined Lkaffe/xs/XsObject;\n");
			              
				      if(function->CallStackRequired){  
				              fprintf(emitFILE,"  invokevirtual  kaffe/xs/XsObject/defProperty(Ljava/lang/String;Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;\n");       
				      } 
				      else{
				              localmem("  astore", formal->offset);
				              fprintf(emitFILE,"\n");
				      }
		              }
			      
			      fprintf(emitFILE,"  goto caseEnd\n");
			 }
                                        
                         fprintf(emitFILE,"case%d:\n", arg);                  
                                
			 formal = formal_start;		
						        
                         for(arg = 0; arg < function->nargs; arg++, formal = (AST*) formal->right()){
			         if(function->CallStackRequired){
				              fprintf(emitFILE,"  aload_2\n");
			                      fprintf(emitFILE,"  ldc \"%s\"\n", formal->getText()); 
				 }
 			 
			         fprintf(emitFILE,"  aload_1\n");
			         fprintf(emitFILE,"  getfield kaffe/xs/XsArray/elements [Lkaffe/xs/XsObject;\n");
			         if (j >= 0 && j <= 5) {
                                         fprintf(emitFILE,"  iconst_%i\n", arg);
                                 } 
		                 else{
                                         fprintf(emitFILE,"  ldc %i\n", arg);
                                 }
                                 fprintf(emitFILE,"  aaload\n");
				      
				      
				 if(function->CallStackRequired){  
				         fprintf(emitFILE,"  invokevirtual  kaffe/xs/XsObject/defProperty(Ljava/lang/String;Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;\n");       
				 } 
				 else{
				         localmem("  astore", formal->offset);
				         fprintf(emitFILE,"\n");
				 }
		         }
			 
                                           
                         fprintf(emitFILE,"caseEnd:\n");
		
		
		}//if(function->nargs != 0)

		
		
		//emit main code
		emitCODE(function->opcodes);
		
		freeCODE(function->opcodes);
		
		free(function->labels);
		
		
	        if(function->CallStackRequired){
		        //pop the context from the call stack
						
			fprintf(emitFILE,"  getstatic kaffe/xs/XsObject/callStack Ljava/util/Stack;\n");
		        fprintf(emitFILE,"  invokevirtual java/util/Stack/pop()Ljava/lang/Object;\n");
		        fprintf(emitFILE,"  pop\n");
			
			//assume value was left on stack before coming here
		        fprintf(emitFILE,"  areturn\n");
		}		                          

										                
		fprintf(emitFILE,".end method\n\n\n");
	}
}
/*
void emitStaticFields(void){
   
   int i;
   /*
   for(i = 0; i < nfields; i++){
       fprintf(emitFILE, ".field static %s Lkaffe/xs/XsObject;\n", field_handles[i]->getText());
   }
   *//*
 //  printf("nfunctions = %d\n", nfunctions);
 
 /*  
   for(i = 0; i < nfunctions; i++){
	 
       AST* function = function_handles[i];
		
       fprintf(emitFILE, ".field static %s Lkaffe/xs/XsObject;\n", ((AST*)function->down())->getText());
   }
*//*
}
*/


/*
void emitStaticInit(void){

    int i; 

    fprintf(emitFILE,".method static final <clinit>()V\n");
        
    fprintf(emitFILE,"  .limit locals 0\n"); 
    fprintf(emitFILE,"  .limit stack %d\n\n", nfields);
	 
    //first accumulate enough undefined, then assign them
    
    fprintf(emitFILE,"  getstatic kaffe/xs/XsObject/_undefined Lkaffe/xs/XsObject;\n"); 
          
    for(i = 1; i < nfields; i++){
        fprintf(emitFILE,"  dup\n"); 
    }
    
       
    for(i = 0; i < nfields; i++){
	fprintf(emitFILE,"  putstatic %s/%s Lkaffe/xs/XsObject;\n", clsName, field_handles[i]->getText()); 
    }
    
       
    fprintf(emitFILE,"  return\n");
    
    fprintf(emitFILE,".end method\n");
}
*/

void emitDocument(void){
 
   char* filename = (char*) calloc(strlen(clsName) + 1 + 2, sizeof(char));
   strcpy(filename, clsName);
   
   emitFILE = fopen(strcat(filename, ".j"), "w");
   
   free(filename);
   
   
   if(!emitFILE){
       fail("Could not open file for jasmin output");
   }    
  
   
  // emitFILE = stdout;
  
   
   fprintf(emitFILE,".class public %s\n\n", clsName);
   
   fprintf(emitFILE,".super %s\n\n", baseName);
   
   if(!functionOnly){
   
       fprintf(emitFILE,".field static Def L%s;\n\n", clsName);
   
   /*
       if(/*nfields != 0 ||*//* nfunctions != 0*//*){
           emitStaticFields();
           fprintf(emitFILE, "\n");
       }
       */
       
      /* if(nfields != 0){
           emitStaticInit();
       }
      
       fprintf(emitFILE, "\n");
   */
 
       emitCONSTRUCTOR();
       
       #ifndef KAFFELIB
       
         if(scriptOnly){
             emitMAIN();
         }
       
       #endif
       
       
       emitRESET();
       
      // printf("emitRESET complete\n");
       
   }    
     
   emitFUNCTIONS();
   
  // printf("emitFUNCTIONS complete\n");
   
   fclose(emitFILE);
  
}



