/*
 * Label lookup. A simple stack
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * @author Philippe Laporte 
 *
 * $tvt: labels.h,v 1.2 2001/07/14 01:51:42 samc Exp $
 */

#ifndef _LABELS_H_INCLUDED
#define _LABELS_H_INCLUDED

#include "symtab.h"


#ifdef __cplusplus
extern "C" {
#endif

void initLabels ();
void growLabels ();
void deleteLabels ();
bool addLabel ( char* sym, AST* node);
void addUnLabeled(AST* node);
void removeLabel ();
bool isLabelDefined(char* sym);	
AST* getLabelNode(char* sym);
AST* getFirstLabelNode();

#ifdef __cplusplus
}
#endif

#endif /* _LABELS_H_INCLUDED */
