/*
 * Peephole patterns optimization module
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 *
 * @author Philippe Laporte 
 *
 * $tvt: optimize.c,v 1.6 2001/09/17 22:48:14 philippe Exp $
 */

#include <stdlib.h>
#include <stdio.h>

#include "optimize.h"
//#include "util.h"

/*
bool is_i2c(CODE *c)
{ if (c==NULL) return 0;
  return c->kind==i2cCK;
}
*/
inline bool is_new(CODE *c, char **arg)
{ if (c==NULL) return false;
  if (c->kind == newCK) {
     (*arg) = c->val.newC;
     return true;
  } else {
     return false;
  }
}
/*
bool is_instanceof(CODE *c, char **arg)
{ if (c==NULL) return 0;
  if (c->kind == instanceofCK) {
     (*arg) = c->val.instanceofC;
     return 1;
  } else {
     return 0;
  }
}

bool is_checkcast(CODE *c, char **arg)
{ if (c==NULL) return 0;
  if (c->kind == checkcastCK) {
     (*arg) = c->val.checkcastC;
     return 1;
  } else {
     return 0;
  }
}

bool is_imul(CODE *c)
{ if (c==NULL) return 0;
  return c->kind==imulCK;
}

bool is_ineg(CODE *c)
{ if (c==NULL) return 0;
  return c->kind==inegCK;
}

bool is_irem(CODE *c)
{ if (c==NULL) return 0;
  return c->kind==iremCK;
}

bool is_isub(CODE *c)
{ if (c==NULL) return 0;
  return c->kind==isubCK;
}

bool is_idiv(CODE *c)
{ if (c==NULL) return 0;
  return c->kind==idivCK;
}

bool is_iadd(CODE *c)
{ if (c==NULL) return 0;
  return c->kind==iaddCK;
}

bool is_iinc(CODE *c, int *offset, int *amount)
{ if (c==NULL) return 0;
  if (c->kind == iincCK) {
     (*offset) = c->val.iincC.offset;
     (*amount) = c->val.iincC.amount;
     return 1;
  } else {
     return 0;
  }
}
*/
inline bool is_label(CODE *c, int *label)
{ if (c==NULL) return false;
  if (c->kind == labelCK) {
     (*label) = c->val.labelC;
     return true;
  } else {
     return false;
  }
}

inline bool is_goto(CODE *c, int *label)
{ if (c==NULL) return false;
  if (c->kind == gotoCK) {
     (*label) = c->val.gotoC;
     return true;
  } else {
     return false;
  }
}

inline bool is_ifeq(CODE *c, int *label)
{ if (c==NULL) return false;
  if (c->kind == ifeqCK) {
     (*label) = c->val.ifeqC;
     return true;
  } else {
     return false;
  }
}
/*
inline bool is_ifne(CODE *c, int *label)
{ if (c==NULL) return false;
  if (c->kind == ifneCK) {
     (*label) = c->val.ifneC;
     return true;
  } else {
     return false;
  }
}
*/
inline bool is_if_acmpeq(CODE *c, int *label)
{ if (c==NULL) return false;
  if (c->kind == if_acmpeqCK) {
     (*label) = c->val.if_acmpeqC;
     return true;
  } else {
     return false;
  }
}

inline bool is_if_acmpne(CODE *c, int *label)
{ if (c==NULL) return false;
  if (c->kind == if_acmpneCK) {
     (*label) = c->val.if_acmpneC;
     return true;
  } else {
     return false;
  }
}
/*
bool is_ifnull(CODE *c, int *label)
{ if (c==NULL) return 0;
  if (c->kind == ifnullCK) {
     (*label) = c->val.ifnullC;
     return 1;
  } else {
     return 0;
  }
}

bool is_ifnonnull(CODE *c, int *label)
{ if (c==NULL) return 0;
  if (c->kind == ifnonnullCK) {
     (*label) = c->val.ifnonnullC;
     return 1;
  } else {
     return 0;
  }
}

bool is_if_icmpeq(CODE *c, int *label)
{ if (c==NULL) return 0;
  if (c->kind == if_icmpeqCK) {
     (*label) = c->val.if_icmpeqC;
     return 1;
  } else {
     return 0;
  }
}

bool is_if_icmpgt(CODE *c, int *label)
{ if (c==NULL) return 0;
  if (c->kind == if_icmpgtCK) {
     (*label) = c->val.if_icmpgtC;
     return 1;
  } else {
     return 0;
  }
}

bool is_if_icmplt(CODE *c, int *label)
{ if (c==NULL) return 0;
  if (c->kind == if_icmpltCK) {
     (*label) = c->val.if_icmpltC;
     return 1;
  } else {
     return 0;
  }
}

bool is_if_icmple(CODE *c, int *label)
{ if (c==NULL) return 0;
  if (c->kind == if_icmpleCK) {
     (*label) = c->val.if_icmpleC;
     return 1;
  } else {
     return 0;
  }
}

bool is_if_icmpge(CODE *c, int *label)
{ if (c==NULL) return 0;
  if (c->kind == if_icmpgeCK) {
     (*label) = c->val.if_icmpgeC;
     return 1;
  } else {
     return 0;
  }
}

bool is_if_icmpne(CODE *c, int *label)
{ if (c==NULL) return 0;
  if (c->kind == if_icmpneCK) {
     (*label) = c->val.if_icmpneC;
     return 1;
  } else {
     return 0;
  }
}

bool is_ireturn(CODE *c)
{ if (c==NULL) return 0;
  return c->kind==ireturnCK;
}
*/

inline bool is_areturn(CODE *c)
{ if (c==NULL) return false;
  return c->kind==areturnCK;
}

inline bool is_return(CODE *c)
{ if (c==NULL) return false;
  return c->kind==returnCK;
}

inline bool is_aload(CODE *c, int *arg)
{ if (c==NULL) return false;
  if (c->kind == aloadCK) {
     (*arg) = c->val.aloadC;
     return true;
  } else {
     return false;
  }
}

inline bool is_astore(CODE *c, int *arg)
{ if (c==NULL) return false;
  if (c->kind == astoreCK) {
     (*arg) = c->val.astoreC;
     return true;
  } else {
     return false;
  }
}
/*
bool is_iload(CODE *c, int *arg)
{ if (c==NULL) return 0;
  if (c->kind == iloadCK) {
     (*arg) = c->val.iloadC;
     return 1;
  } else {
     return 0;
  }
}

bool is_istore(CODE *c, int *arg)
{ if (c==NULL) return 0;
  if (c->kind == istoreCK) {
     (*arg) = c->val.istoreC;
     return 1;
  } else {
     return 0;
  }
}
*/
inline bool is_dup(CODE *c)
{ if (c==NULL) return false;
  return c->kind==dupCK;
}

inline bool is_pop(CODE *c)
{ if (c==NULL) return false;
  return c->kind==popCK;
}
/*
bool is_swap(CODE *c)
{ if (c==NULL) return 0;
  return c->kind==swapCK;
}
*/
inline bool is_ldc_int(CODE *c, int *arg)
{ if (c==NULL) return false;
  if (c->kind == ldc_intCK) {
     (*arg) = c->val.ldc_intC;
     return true;
  } else {
     return false;
  }
}

inline bool is_ldc_string(CODE *c, char **arg, bool* toBeFreed)
{ if (c==NULL) return false;
  if (c->kind == ldc_stringCK) {
     (*arg) = c->val.ldc_stringC;
     *toBeFreed = c->toBeFreed;
     return true;
  } else {
     return false;
  }
}
/*
inline bool is_aconst_null(CODE *c)
{ if (c==NULL) return false;
  return c->kind==aconst_nullCK;
}
*/
inline bool is_getfield(CODE *c, char **arg)
{ if (c==NULL) return false;
  if (c->kind == getfieldCK) {
     (*arg) = c->val.getfieldC;
     return true;
  } else {
     return false;
  }
}
/*
inline bool is_putfield(CODE *c, char **arg)
{ if (c==NULL) return false;
  if (c->kind == putfieldCK) {
     (*arg) = c->val.putfieldC;
     return true;
  } else {
     return false;
  }
}
*/
inline bool is_getstatic(CODE *c, char **arg)
{ if (c==NULL) return false;
  if (c->kind == getstaticCK) {
     (*arg) = c->val.getstaticC;
     return true;
  } else {
     return false;
  }
}

inline bool is_putstatic(CODE *c, char **arg, bool* toBeFreed)
{ if (c==NULL) return false;
  if (c->kind == putstaticCK) {
     (*arg) = c->val.putstaticC;
     *toBeFreed = c->toBeFreed;
     return true;
  } else {
     return false;
  }
}


inline bool is_invokevirtual(CODE *c, char **arg)
{ if (c==NULL) return false;
  if (c->kind == invokevirtualCK) {
     (*arg) = c->val.invokevirtualC.text;
     return true;
  } else {
     return false;
  }
}

inline bool is_invokespecial(CODE *c, char **arg)
{ if (c==NULL) return false;
  if (c->kind == invokespecialCK) {
     (*arg) = c->val.invokespecialC.text;
     return true;
  } else {
     return false;
  }
}

inline bool is_invokestatic(CODE *c, char **arg)
{ if (c==NULL) return false;
  if (c->kind == invokestaticCK) {
     (*arg) = c->val.invokestaticC.text;
     return true;
  } else {
     return false;
  }
}

inline bool is_invokeinterface(CODE *c, char **arg)
{ if (c==NULL) return false;
  if (c->kind == invokeinterfaceCK) {
     (*arg) = c->val.invokeinterfaceC.text;
     return true;
  } else {
     return false;
  }
}



inline bool is_empty(CODE *c)
{ return c==NULL;
}

inline bool is_simplepush(CODE *c)
{ if (c==NULL) return false;
  return (c->kind==aloadCK) /*|| (c->kind==iloadCK)*/ || (c->kind==ldc_intCK) || 
         (c->kind==ldc_stringCK)/* || (c->kind==aconst_nullCK)*/;
}


inline bool uses_label(CODE *c, int *label)
{ if (c==NULL) return false;
  return is_goto(c,label) || is_ifeq(c,label) /*|| is_ifne(c,label) */|| 
         is_if_acmpeq(c,label) || is_if_acmpne(c,label)/* || 
         is_ifnull(c,label) || is_ifnonnull(c,label) ||
         is_if_icmpeq(c,label) || is_if_icmpgt(c,label) || 
         is_if_icmplt(c,label) || is_if_icmple(c,label) || 
         is_if_icmpge(c,label) || is_if_icmpne(c,label)*/;
}






extern LABEL *currentlabels; //use the same as for coding



CODE *next(CODE *c)
{ if (c==NULL) return NULL;
  return c->next;
}




CODE *destination(int label)
{ return currentlabels[label].position;
}

int copylabel(int label)
{ currentlabels[label].sources++;
  return label;
}

void droplabel(int label)
{ currentlabels[label].sources--;
}

bool deadlabel(int label)
{ return currentlabels[label].sources==0;
}

bool uniquelabel(int label)
{ return currentlabels[label].sources==1;
}





int replace(CODE **c, int k, CODE *r)
{ CODE *p;
  int i;
  p = *c;
  for (i=0; i<k; i++) p=p->next;
  if (r==NULL) {
     *c = p;
  } else {
     *c = r;
     CODE* prev;
     while (r->next!=NULL){
     
      prev = r;
      
      r=r->next;
      
      switch(prev->kind){
      
      	case newCK:          if(prev->toBeFreed){
	                         free(prev->val.newC);
                             }
                             break; 
			     
			     
	case checkcastCK:    if(prev->toBeFreed){
	                         free(prev->val.checkcastC);
                             }
                             break; 			     
			     
			     
	case ldc_stringCK:   if(prev->toBeFreed){
	                         free(prev->val.ldc_stringC);
			     }	 
			     break;
		     
    
        case getfieldCK:     if(prev->toBeFreed){
	                         free(prev->val.getfieldC);
			     }	 
			     break;
    
        case putfieldCK:     if(prev->toBeFreed){
	                         free(prev->val.putfieldC);
			     }	 
                             break;
			     
        case getstaticCK:    if(prev->toBeFreed){
	                         free(prev->val.getstaticC);
                             }
			     break;
			     
        case putstaticCK:    if(prev->toBeFreed){
	                         free(prev->val.putstaticC);
                             }
                             break; 
			     
        case invokevirtualCK:if(prev->toBeFreed){
	                         free(prev->val.invokevirtualC.text);
			     }	 
                             break;
			     
        case invokespecialCK:if(prev->toBeFreed){
	                         free(prev->val.invokespecialC.text);
                             }
			     break;
			     
	case invokestaticCK: if(prev->toBeFreed){
	                         free(prev->val.invokestaticC.text);
			     }	 
                             break;
			     
        case invokeinterfaceCK:if(prev->toBeFreed){
	                         free(prev->val.invokeinterfaceC.text);
                               }
			       break;

      
      }
      
      free(prev);
      
     }
     
     
     
     
     r->next = p;
  
  }
  return 1;
}


//review use of this, see if can free
int replaceNoFree(CODE **c, int k, CODE *r)
{ CODE *p;
  int i;
  p = *c;
  for (i=0; i<k; i++) p=p->next;
  if (r==NULL) {
     *c = p;
  } else {
     *c = r;
     while (r->next!=NULL)r=r->next;
     r->next = p;
  }
  return 1;
}




/*simple function that checks if a CODE is a conditional branch*/
/* code that calls is not used
bool is_branch_op(CODE *c, int *lbl)
{  
  if(is_empty(c)) return false;
 /* if (is_ifeq(c,lbl)) return 1;
  if (is_ifne(c,lbl)) return 1;
  if (is_ifnull(c,lbl)) return 1;
  if (is_ifnonnull(c,lbl)) return 1;
  if (is_if_icmpeq(c,lbl)) return 1;
  if (is_if_icmpne(c,lbl)) return 1;
  if (is_if_icmpgt(c,lbl)) return 1;
  if (is_if_icmplt(c,lbl)) return 1;
  if (is_if_icmple(c,lbl)) return 1;
  if (is_if_icmpge(c,lbl)) return 1;*//*
    if (is_if_acmpeq(c,lbl)) return true;
  if (is_if_acmpne(c,lbl)) return true;
  return false;
}
*/

/*simple function that takes a branch in a code and returns
its opposite*/
/* code that calls is not used
CODE* opp_branch_op(CODE *c,int lbl, CODE *next)
{  
  int l;
  if(is_empty(c)) return NULL;
 /* if (is_ifeq(c,&l)) return makeCODEifne(lbl,next);
  if (is_ifne(c,&l)) return makeCODEifeq(lbl,next);
  if (is_ifnull(c,&l)) return makeCODEifnonnull(lbl,next);
  if (is_ifnonnull(c,&l)) return makeCODEifnull(lbl,next);
    if (is_if_icmpeq(c,&l)) return makeCODEif_icmpne(lbl,next);
  if (is_if_icmpne(c,&l)) return makeCODEif_icmpeq(lbl,next);
  if (is_if_icmpgt(c,&l)) return makeCODEif_icmple(lbl,next);
    if (is_if_icmplt(c,&l)) return makeCODEif_icmpge(lbl,next);
  if (is_if_icmple(c,&l)) return makeCODEif_icmpgt(lbl,next);
  if (is_if_icmpge(c,&l)) return makeCODEif_icmplt(lbl,next);*//*
    if (is_if_acmpeq(c,&l)) return makeCODEif_acmpne(lbl,next);
  if (is_if_acmpne(c,&l)) return makeCODEif_acmpeq(lbl,next);
  return next;
}
*/




// PATTERNS **********************


//put out becasue of weirdness in replace
/*
int simplify_put_get(CODE **c)
{ //make it work for put/getfield too??

  char* s1, *s2;
  bool toBeFreed;
  if ( is_putstatic(*c, &s1, &toBeFreed) &&
       is_getstatic(next(*c), &s2)  &&
       !strcmp(s1, s2)
     ) {
     return replace(c,2,makeCODEdup(makeCODEputstatic(StrDup(s1), NULL, true)));
  }
  return 0;
}
*/
//occurs when producing for/in if have ex for(a in f)
int remove_useless_get(CODE **c)
{ char* s;
  if ((is_getstatic(*c, &s) || is_getfield(*c, &s)) &&
      is_pop(next(*c)) ) {
     return replace(c,2,NULL);
  }
  return 0;
}


/*
int simplify_multiplication_right(CODE **c)
{ int x,k;
  if (is_iload(*c,&x) && 
      is_ldc_int(next(*c),&k) && 
      is_imul(next(next(*c)))) {
     if (k==0) return replace(c,3,makeCODEldc_int(0,NULL));
     else if (k==1) return replace(c,3,makeCODEiload(x,NULL));
     else if (k==2) return replace(c,3,makeCODEiload(x,
                                       makeCODEdup(
                                       makeCODEiadd(NULL))));
     return 0;
  }
  return 0;
}
*/

int simplify_astore(CODE **c)
{ int x;
  if (is_dup(*c) &&
      is_astore(next(*c),&x) &&
      is_pop(next(next(*c)))) {
     return replace(c,3,makeCODEastore(x,NULL));
  }
  return 0;
}

int simplify_putstatic(CODE **c)
{ char* x;
  bool toBeFreed;
  if (is_dup(*c) &&
      is_putstatic(next(*c),&x, &toBeFreed) &&
      is_pop(next(next(*c)))) {
     return replace(c,3,makeCODEputstatic(x,NULL,toBeFreed));
  }
  return 0;
}

/*
int positive_increment(CODE **c)
{ int x,y,k;
  if (is_iload(*c,&x) &&
      is_ldc_int(next(*c),&k) &&
      is_iadd(next(next(*c))) &&
      is_istore(next(next(next(*c))),&y) &&
      x==y && 0<=k && k<=127) {
     return replace(c,4,makeCODEiinc(x,k,NULL));
  }
  return 0;
}
*/
int simplify_goto_goto(CODE **c)
{ int l1,l2;
  if (is_goto(*c,&l1) && is_goto(next(destination(l1)),&l2) && l1>l2) {
     droplabel(l1);
     copylabel(l2);
     return replace(c,1,makeCODEgoto(l2,NULL));
  }
  return 0;
}

/*this little function here does one of 2 things, it checks if we have
a jump (anything that jumps to a label) and then checks if that target
label is followed directly by a label, if so, we change the jump so
it would go directly to the second label. Quite clear that it works
without harming the code.
The second thing all it does is to check if it's a jump to a label that is
followed by a goto jump which is SURE to happen as it's a goto, right?... so we
directly replace the first jump's destination by the second jump's destination,
also as safe, of course we always have to be careful about dropping the first
label and incrementing the incoming jumps to the second label*/
/*
int simplify_goto(CODE **c)
{ int l1,l2;
  if (uses_label(*c,&l1) &&
    (is_label(next(destination(l1)),&l2) || is_goto(next(destination(l1)),&l2))) {

    if (is_goto(next(destination(l1)),&l2)) {
      if (l2>l1) return 0;
    }

   droplabel(l1);
   copylabel(l2);
   if (is_goto(*c,&l1)) return replace(c,1,makeCODEgoto(l2,NULL));
   if (is_ifeq(*c,&l1)) return replace(c,1,makeCODEifeq(l2,NULL));
  /* if (is_ifne(*c,&l1)) return replace(c,1,makeCODEifne(l2,NULL));
   if (is_ifnull(*c,&l1)) return replace(c,1,makeCODEifnull(l2,NULL));
   if (is_ifnonnull(*c,&l1)) return replace(c,1,makeCODEifnonnull(l2,NULL));
   if (is_if_icmpeq(*c,&l1)) return replace(c,1,makeCODEif_icmpeq(l2,NULL));
   if (is_if_icmpne(*c,&l1)) return replace(c,1,makeCODEif_icmpne(l2,NULL));
   if (is_if_icmpgt(*c,&l1)) return replace(c,1,makeCODEif_icmpgt(l2,NULL));
   if (is_if_icmplt(*c,&l1)) return replace(c,1,makeCODEif_icmplt(l2,NULL));
   if (is_if_icmpge(*c,&l1)) return replace(c,1,makeCODEif_icmpge(l2,NULL));
   if (is_if_icmple(*c,&l1)) return replace(c,1,makeCODEif_icmple(l2,NULL));
  *//* if (is_if_acmpeq(*c,&l1)) return replace(c,1,makeCODEif_acmpeq(l2,NULL));
   if (is_if_acmpne(*c,&l1)) return replace(c,1,makeCODEif_acmpne(l2,NULL));
  }
  return 0;
}
*/


/* removes dead code like dead labels which affects the code in
no way whatsoever!*/
int remove_useless_code(CODE **c)
{ int lbl;
  if (is_label(*c,&lbl)) {
    if (deadlabel(lbl)) return replace(c,1,NULL);
  }
  return 0;
}

/* this function checks if any goto statement is going to a label that is
followed directly by an exit method (either end of method or a return code)
thus it can replace this goto directly by a return statement
if the goto function is going to an end of code that has no return at its bottom
it is replaced with a simple return. this also does not harm the code, as a goto
is sure to go to a return, we're simply doing that goto at compiletime*/
int goto_end(CODE **c)
{  
  int lbl;
  if (is_goto(*c,&lbl) &&
    (is_empty(destination(lbl)->next) /*||
     is_ireturn(destination(lbl)->next)*/ ||
     is_areturn(destination(lbl)->next) || 
     is_return(destination(lbl)->next))) {
    droplabel(lbl);

   // if (is_ireturn(destination(lbl)->next)) return replace(c,1,makeCODEireturn(NULL));
    if (is_areturn(destination(lbl)->next)) return replace(c,1,makeCODEareturn(NULL));
    if (is_return(destination(lbl)->next) || is_empty(destination(lbl)->next))
      return replace(c,1,makeCODEreturn(NULL));
  }
  return 0;
}

/* if the same thing happens to be loaded twice and stored in 2 other objects after each
load, then we replace that by a simple load once then dup then store twice, ie
  
  load something
  store it
  load that same thing
  store it

becomes
  
  load something
  dup it
  store it
  store it

and 
  
  load something
  load same thing

becomes

  load something
  dup it

  quite straight forward and obvious to be harmless to the code
*/

/* see comment below 
int simplify_2_loads(CODE **c)
{
  int i,j;
  char *str1,*str2;
  bool toBeFreed;
/*
  if (is_iload(*c,&i) && is_iload(next(*c),&j) && (i==j)) {
    return replace(c,2,makeCODEiload(i,makeCODEdup(NULL)));
  }

  if (is_iload(*c,&i) &&
    (is_istore(next(*c),&j) ||
     is_astore(next(*c),&j)) &&
    is_iload(next(next(*c)),&j) &&
    (i==j)) {
      replace(&(((*c)->next)->next),1,NULL);
      return replace(c,1,makeCODEiload(i,makeCODEdup(NULL)));
  }
*//*
  if (is_aload(*c,&i) && is_aload(next(*c),&j) && (i==j)) {
    return replace(c,2,makeCODEaload(i,makeCODEdup(NULL)));
  }

  if (is_aload(*c,&i) &&
    (/*is_istore(next(*c),&j) ||*//*
     is_astore(next(*c),&j)) &&
    is_aload(next(next(*c)),&j) &&
    (i==j)) {
      replace(&(((*c)->next)->next),1,NULL);
      return replace(c,1,makeCODEaload(i,makeCODEdup(NULL)));
  }

  if (is_ldc_int(*c,&i) && is_ldc_int(next(*c),&j) && (i==j)) {
    return replace(c,2,makeCODEldc_int(i,makeCODEdup(NULL)));
  }

  if (is_ldc_int(*c,&i) &&
    (/*is_istore(next(*c),&j) ||*//*
     is_astore(next(*c),&j)) &&
    is_ldc_int(next(next(*c)),&j) &&
    (i==j)) {
      replace(&(((*c)->next)->next),1,NULL);
      return replace(c,1,makeCODEldc_int(i,makeCODEdup(NULL)));
  }

  if (is_ldc_string(*c,&str1, &toBeFreed) && is_ldc_string(next(*c),&str2, &toBeFreed) && (strcmp(str1,str2)==0)) {
    return replace(c,2,makeCODEldc_string(str2,makeCODEdup(NULL),toBeFreed));
  }

  if (is_ldc_string(*c,&str1, &toBeFreed) &&
    (/*is_istore(next(*c),&j) ||*//*
     is_astore(next(*c),&j)) &&
    is_ldc_string(next(next(*c)),&str2, &toBeFreed) &&
    (strcmp(str1,str2)==0)) {
      replace(&(((*c)->next)->next),1,NULL);
      return replace(c,1,makeCODEldc_string(str2,makeCODEdup(NULL),toBeFreed));
  }
  /*
  if (is_aconst_null(*c) && is_aconst_null(next(*c))) {
    return replace(c,2,makeCODEaconst_null(makeCODEdup(NULL)));
  }

  if (is_aconst_null(*c) &&
    (is_istore(next(*c),&j) ||
     is_astore(next(*c),&j)) &&
    is_aconst_null(next(next(*c)))) {
      replace(&(((*c)->next)->next),1,NULL);
      return replace(c,1,makeCODEaconst_null(makeCODEdup(NULL)));
  }*//*
  return 0;
}

*/

/*this function gets rid of anything after a return statement
if that part of the code cannot be reached from anywhere else,
ie if there are no incoming jumps into that part of code that falls
under the return code. in javac this is actually returned as a
compile error, all this
does is to check for that code and see if there are any live labels
there, if not, then it cuts the code off.
ie

  return
  some code1
  label:
  some code2

would become

  return
  label:
  some code2

  since some code1 cannot be reached as the only label
  after return is After it, then we can safely delete it...

*/
int cleanup_after_return_goto(CODE **c)
{
  int lbl, n,l;
  CODE *t;
  t=next(*c);
  n=0;
  if(is_return(*c) /*|| is_ireturn(*c)*/ || is_areturn(*c) || is_goto(*c,&l)) {
    while (t!=NULL) {
      if (is_label(t,&lbl)) {
        if (!deadlabel(lbl)) return n;
      } else if (uses_label(t,&lbl)) droplabel(lbl);
      n=1;
      t=t->next;
      (*c)->next = t;
    }
  }
  return 0;
}



/*this simplifies any jump that is going to a goto jump, so we make
the jump go directly to the goto's destination*/
/*
int simplify_if_goto(CODE **c)
{
  int l1,l2,L1;
  if (is_branch_op(*c,&l1) &&
    is_goto(next(*c),&l2) &&
    is_label(next(next(*c)),&L1) &&
    (L1==l1) && uniquelabel(L1))
    return replace(c,3,opp_branch_op(*c,l2,NULL));
  return 0;
}
*/

// DRIVER ******************************



typedef int(*OPTI)(CODE **);

 
OPTI optimization[] =     {/*simplify_multiplication_right,*/
                           simplify_astore,
			   simplify_putstatic,
                           /*positive_increment,*/
                           simplify_goto_goto/*, bugs on "for(;;);"
			   simplify_goto*/,/*
			   simplify_2_loads, bugs on vipengine.js*/
                           cleanup_after_return_goto,/*
                           goto_end, 
			   
			     bugs on
			     if(!8)print("HI");
                             if(!0)print("HEY");

			   
			   
			                     */
			   remove_useless_get/*,
			   simplify_put_get      weird in replace*/,
                           remove_useless_code/*, bugs on vipengine.js
			   simplify_if_goto*/
                          };

			  			  
#define OPTS sizeof(optimization) / sizeof(OPTI)



int optiCHANGE;


void optiCODEtraverse(CODE **c)
{ int i, change;
  change = 1;
  if (*c!=NULL) {
     while (change) {
       change = 0;
       for (i=0; i<OPTS; i++) {
           change = change | optimization[i](c);
       }
       optiCHANGE = optiCHANGE || change;
     }
     if (*c!=NULL) optiCODEtraverse(&((*c)->next));
  }
} 



void optiCODE(CODE **c)
{ optiCHANGE = 1;
  while (optiCHANGE) {
    optiCHANGE = 0;
    optiCODEtraverse(c);
  }
}






