/*
 * Resource utilities
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 *
 * @author Philippe Laporte 
 *
 * $tvt: resource.c,v 1.1 2001/07/11 21:12:57 philippe Exp $
 */



#include <stdio.h>
#include <string.h>

#include "resource.h"
#include "vars.h"

TOPLEVEL reset;

extern bool local_or_global_re;

int label;
int offset;
int localslimit;

int nextlabel()
{ 
  if (local_or_global_re == LOCAL) {  // in function
      // printf("LOCAL label now is %d\n", label + 1);
      return label++;

  }
  else { //printf("GLOBAL reset.label now is %d\n", reset.labelcount + 1);
      return reset.labelcount++;
  }    
}

int nextoffset()
{ 
  if (local_or_global_re == LOCAL) { 
      offset++;
      //next line not needed ? etc ????
      if (offset > localslimit) localslimit = offset;
     // fprintf(stderr,"offset is %d\n", offset);
      return offset;
  }
  else {
      reset.offset++;
      //used mainly in with stmts
      if (reset.offset > reset.localslimit) reset.localslimit = reset.offset;
      return reset.offset;
  }
}

int currentoffset()
{ 
  if (local_or_global_re == LOCAL) { 
      return offset;
  }
  else {
      return reset.offset;
  }
}

void SetCurrentOffset(int offset_in)
{ 
  if (local_or_global_re == LOCAL) { 
      offset = offset_in;
  }
  else {
      reset.offset = offset_in;
  }
}
