/*
 * Symbol management
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * @author Peter Mehlitz
 * @author Philippe Laporte 
 * 
 * $tvt: symtab.h,v 1.2 2001/07/14 01:51:42 samc Exp $
 */

#ifndef _SYMTAB_H_INCLUDED
#define _SYMTAB_H_INCLUDED


#include "util.h"  // StrDup used in symtab.c

//#include "Resourcer.h"  // problems if put AST.h instead
#include "tokens.h"
#include "AST.h"

typedef struct symtab* symtab_tPtr;

typedef struct symtab {

	char** sym;
	char*  type;
	AST** node;
	
        //char* static_type;
        int    count;
	int    thresh;
	int    len;
	int    isCopy;
	
	symtab_tPtr next;
	
} symtab_t;


#define T_PROP 1       // any property
#define T_FUNC 2
#define T_DNUM 3
#define T_DSTR 4
#define T_DOBJ 5
#define T_DBOO 6
#define T_DARR 7


symtab_t* st_create ( int len, int isCopy );
void st_reset ( symtab_t* t );
void st_delete ( symtab_t* t );
void st_add ( symtab_t* t, char* sym, char type, AST* node );
int st_contains ( symtab_t* t, char* sym );
AST* st_contains_get_ast_node ( symtab_t* t, char* sym );
//void st_remove ( symtab_t* t, char* sym );

#endif /* _SYMTAB_H_INCLUDED */
