/*
 * variable management
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * @author Peter Mehlitz
 * @author Philippe Laporte 
 * 
 * $tvt: vars.h,v 1.5 2001/09/13 17:05:40 philippe Exp $
 */

#ifndef _VARS_H_INCLUDED
#define _VARS_H_INCLUDED

#include "symtab.h"


#ifdef __cplusplus
extern "C" {
#endif

extern int maxhandles;
extern int n_symtab_handles;
extern symtab_t** handles;

extern symtab_t* current;

void initVars ();
void growHandles ();
void deleteVars ();
int varLevelt ( char* sym, int*type );
void addVar ( char* sym, int type, AST* node);
void addVarTable (symtab_t* t,  char* sym, int type, AST* node);
//void removeVar ( char* sym );
void incLevel ();
void decLevel ();
//cache the level value instead??
int getLevel();
int varLevel ( char* sym );
int isVar ( char* sym );
bool isVarAtLevel(char* sym);
int getOffsetVar(char* sym);
char** getAllLocalVars(symtab_t*, int*);



#ifdef __cplusplus
}
#endif

#endif /* _VARS_H_INCLUDED */
