//ML_ONLY_START


/*
 * Scanner, parser, AST building and interpreter
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * @author Philippe Laporte
 * @author Peter Mehlitz
 *  
 * $tvt: xs.g,v 1.62 2001/10/26 22:48:09 philippe Exp $ 
 */



// all Script ambiguities are well-understood (complete this with "and XML" )


#header                                                                 
<<

#include "util.h"

#include "ht.h"
  

#include <stdarg.h>
#include <DLexerBase.h>
  
extern char  sconstDelim;
extern bool  enterScript;
extern bool  inEventScript;
extern bool  inAttribute;
extern bool  wasTextMode;
//extern bool  isHtml;

//to take out of ml_only

//ML_ONLY_END

extern int   n_symtab_handles;

extern bool  scriptOnly;
extern bool  functionOnly;




extern char* clsName;
extern char* baseName;
extern char* factoryName;


//ML_ONLY_START

extern int levelLabels;


 


//ML_ONLY_END

extern DLGState saved_state;

extern bool NoLineTerminatorHere;

extern bool  writegenerated;

extern TOPLEVEL reset;
extern int label;



#include "Coder.h"

//ML_ONLY_START



#ifdef KAFFELIB  //if used as a kaffe jni lib


#include <jni.h>

#undef JNIEXPORT
#define JNIEXPORT NATIVE_EXPORT

extern jobject SrcInputStream;

#include <setjmp.h>
extern jmp_buf jmpbuffer;


#else  //if used as a stand-alone process

#define jobject void*
#define jarray void*
#define jclass void*
#define jmethodID int
#define jfieldID int
#define jdouble double
#define jstring char*
#define jsize int

#endif

//ML_ONLY_END
//char* getEntityValue(char* entity);

//extern DLGStringInput* entityvalue;

extern char* parent_tag;
extern bool parent_tag_set_in_this_run;

extern bool inFunctionBody;
    
extern FILE* bodies_file;     

//extern bool convertToTXT_WORD;

//ML_ONLY_START

//#include "constants.h"
extern bool didReplace;
extern char* previous;


#if defined KAFFELIB && defined ML_ONLY 

extern bool prettyPrint;
extern char* prettyPrintFileName;
extern FILE* prettyPrintFile;


#endif


>>


<<
/* globals, includes etc. */   

					                                          
#include <stdlib.h>

typedef ANTLRCommonToken ANTLRToken;

#include "DLGLexer.h"

/*
#include "AST.h"
typedef AST SORAST;*/

#include "Resourcer.h"

//ML_ONLY_END

#include "Coder.h"


#include "vars.h"
#include "labels.h"



extern symtab_t* current;

bool  scriptOnly;    // this is only a scripT, don't parse XML when true
bool  functionOnly;  // only generating a function, ex: Function contructors

//ML_ONLY_START



bool  enterScript;
char  sconstDelim;
bool  inEventScript;
bool  inAttribute;
bool  wasTextMode;

//bool  isHtml;        // are we parsing html?


//ML_ONLY_END

char* clsName     = "MyObject";
char* baseName    = "kaffe/xs/XsObject";
//useless??
char* factoryName = "DocumentFactory";

//ML_ONLY_START

#ifdef KAFFELIB

//for scripT tags wityh a src attribute
jobject SrcInputStream = NULL;

//whether the page has scripT
bool hasScript = false;

#endif


//ML_ONLY_END

bool  writeGenerated; // generated by a call to document.write

//for external scripT file processing
DLGState saved_state;


//Virtual semicolon management
bool NoLineTerminatorHere = false;  



//input streams for entity name-value substitution
//DLGStringInput* entityvalue;


//put #ifdef KAFFELIB ??? here 
//for document_write validity checks
char* parent_tag = NULL;

bool parent_tag_set_in_this_run = false;

//to know if a function requires to use the call stack mechanism when it is called
//ie does it need to add itself to the scope chain
//write HERE the criteria 
bool CallStackRequired = false;


bool inFunctionBody = false;

	       
FILE* bodies_file; //function bodies       

//for when get " or ' within text
//bool convertToTXT_WORD = false;

//ML_ONLY_START

jobject documenT;  // root of DOM tree

jobject documentFactory;

//for entity substitution within string: did not get something like &;
bool didReplace = false;
//text that got substituted
char* previous;



//testing purposes
#if defined KAFFELIB && defined ML_ONLY

bool prettyPrint = false;
char* prettyPrintFileName = NULL;
FILE* prettyPrintFile = NULL;


#endif



#define PCDATAWORD_BUFFER_LENGTH 40

char pcdataword_buf[PCDATAWORD_BUFFER_LENGTH + 1]; 


/* main function and other auxiliaries (avoid the 4000 limit) */
#include "main.c"


>>




/******************************************************************************
 * Lexer part
 */




/* XML part */                                                          

#lexclass START /********************************************************/



#token  "[\ \t]+"                  << skip(); >>
#token  "[\r\n]"                   << skip(); newline(); 
                                      //printf("NEWLINE in START ch is G%cG line is now %d\n", ch, line()); 
                                   >>
#token  "\<!\-\-"                  << //printf("HERE");
                                      skip(); mode(XML_COMMENT_MODE); 
				   >>

 
#token  XML_END_OPEN   "\</"
#token  XML_OPEN       "\<"         
#token  XML_META_OPEN  "\<?"
#token  XML_DTD_OPEN   "\<!"       
  
#token  SCRIPT_TAG     "[sS][cC][rR][iI][pP][tT]"    << 
                                                       // printf("got script start tag\n"); 
                                                        enterScript = true; 
					             >>


#token  ONCLICK        "[oO][nN][cC][lL][iI][cC][kK]"  // << mode(SCRIPT_MODE); >>    
#token  ONLOAD         "[oO][nN][lL][oO][aA][dD]"      // << mode(SCRIPT_MODE); >>
#token  ONMOUSEOVER    "[oO][nN][mM][oO][uU][sS][eE][oO][vV][eE][rR]"   // << mode(SCRIPT_MODE); >>
#token  ONMOUSEOUT     "[oO][nN][mM][oO][uU][sS][eE][oO][uU][tT]"       // << mode(SCRIPT_MODE); >>

#tokclass EVENT_ATTR { ONCLICK ONLOAD ONMOUSEOVER ONMOUSEOUT } 

//diff with attr: disallows /
#token  XML_TAG        "~[\=\<\>\"\'\ \t\r\n]+"  //was this one before saw fo\nnt on craigslist.org
                                                   //but does not work since can have <img\nsrc

                                                
						   
//#token  XML_TAG        "~[\=\<\>\"\'\ ]+" 	//taking out / works because of validChildNode etc, but not taking out > !!!					
						
 

#token  DQUOTE         "[\"\']"    << 

//printf("HERE LEILAinEventScript = %d, inAttribute = %d\n", inEventScript, inAttribute);
                                      
                                      
				      
                                      if ( inEventScript ){
				          if ( ch == '\'' ) {
                                              replchar( '\"');
                                          }
                                      
                                          sconstDelim = ch;
//ML_ONLY_END					  
				          if(docType == &htmlDocType){
					      mode(SCRIPT_MODE);
					  }
					  else{
					    //  printf("HERE RAMBO\n");
//ML_ONLY_START					    
					    
					      mode(XML_EVENT_MODE);
//ML_ONLY_END					      
					      
					  }
					  
//ML_ONLY_START					  
			              }
                                      else if ( inAttribute ) {
				          if ( ch == '\'' ) {
                                              replchar( '\"');
                                          }
                                      
                                          sconstDelim = ch;
				          //printf("In attribute\n");
                                          mode(XML_STRING_MODE); more();
                                      }
				    /*  else{
				          convertToTXT_WORD = true;
				      }*/
                                   >>
  
#token  ASSIGN         "\="        //<< printf("GOT ASSIGN\n"); >>

       
#token  XML_ELEM_CLOSE "/\>"       << //printf("RAMBO\n");
                                      enterScript = false;
                                      mode( TEXT_MODE);
                                   >>
#token  XML_CLOSE      "\>"        << if ( enterScript ) {
                                        //enterScript = false;
				//	printf("BEFORE CHANGING MODE\n");
					
#ifndef ML_ONLY 					
                                        mode( SCRIPT_MODE);
#else
                                       // mode( ML_ONLY_TEXT_MODE);
				       mode( ML_ONLY_SCRIPT_MODE);
#endif										
                                      }
                                      else {
				        
                                        mode( TEXT_MODE);
                                      }
				      
				     // printf("GOT XML_CLOSE\n");
                                   >>

#token XML_META_CLOSE "?\>"







#lexclass XML_EVENT_MODE /************************************************/


#token  DQUOTE "\""                << mode(START); 
                                    // printf("HERE GOT DQUOTE\n"); 
                                   >>

#token XML_EVENT_HANDLER "~[\"]*"









#lexclass TEXT_MODE /************************************************/


#token TXT_BLANK  "[\ \t]+"          
#token TXT_NL     "[\r\n]"          << newline(); 
                                      // printf("NEWLINE in TEXT ch is G%cG line is now %d\n", ch, line());   
                                    >>
				    
#token TXT_WORD   "~[\ \t\r\n\<\&\;\0x81-\0xfe]+"  /*<< 
                                           printf("text is %s\n", lextext()); 
					  char* tex = lextext();
					  for (int i = 0; i < strlen(tex); i++){
					          printf("character %d is %d\n", i, tex[i]);
					      }	

 
                                       >> */
				       
#token TXT_WORD_NEEDS_CONVERSION "[\0x81-\0xfe]+"  //<< printf("Got that\n"); >>				       


#token TXT_AMP    "\&"
#token TXT_SEMI   "\;"


#token  "\<!\-\-"                   << 
                                       skip(); 
                                       wasTextMode=true; 
				       mode(XML_COMMENT_MODE);
				    >>
  
  
/* thin ice, but the most intuitive solution - we have to get back
 * into START mode, but must not gobble the '<', so we simply rely
 * on DlgLexer to use the same token ID if we name the beast like in
 * the START automaton
 */
 
#token  XML_END_OPEN   "\</"       << mode(START); >>
#token  XML_OPEN       "\<"        << mode(START); >>
#token  XML_META_OPEN  "\<?"       << mode(START); >>
#token  XML_DTD_OPEN   "\<!"       << mode(START); >> 

#token  TEOF "@"

#tokclass TXT_SKIP {
  TXT_BLANK 
  TXT_NL
}





#lexclass ML_ONLY_TEXT_MODE //************************************************


#token TXT_BLANK  "[\ \t]+"          
#token TXT_NL     "[\r\n]"          << newline(); 
                                      // printf("NEWLINE in TEXT ch is G%cG line is now %d\n", ch, line());   
                                    >>
				    
#token TXT_WORD   "~[\ \t\r\n\<\"\'\0x81-\0xfe]+" //notice the \"

#token TXT_WORD_NEEDS_CONVERSION "[\0x81-\0xfe]+"

#token  "\<!\-\-"                   << 
                                       skip(); 
                                       wasTextMode=true; 
				       mode(XML_COMMENT_MODE);
				    >>
  
   
#token  XML_END_OPEN   "\</"       << mode(START); >>
#token  XML_OPEN       "\<"        << mode(START); >>
#token  XML_META_OPEN  "\<?"       << mode(START); >>
#token  XML_DTD_OPEN   "\<!"       << mode(START); >> 

#token  TEOF "@"

#tokclass TXT_SKIP {
  TXT_BLANK 
  TXT_NL
}

#token  "\""                       << 
                                      sconstDelim = ch; 
				      more();
                                      mode(ML_ONLY_C_STRING_MODE);
                                   >>
  
#token "\'"                        << 
                                      sconstDelim = ch; 
				      more();
                                      mode(ML_ONLY_C_STRING_MODE);
                                   >>
				   


#lexclass ML_ONLY_SCRIPT_MODE //************************************************

#token  SCRIPT_END "\</[\ \t\r\n]*[sS][cC][rR][iI][pP][tT]\>"   << enterScript = false;
                                                       // printf("Got script end\n"); 
                                                        mode(ML_ONLY_TEXT_MODE); 
							
					              >>


#token TXT_BLANK  "[\ \t]+"          
#token TXT_NL     "[\r\n]"          << newline(); 
                                      // printf("NEWLINE in TEXT ch is G%cG line is now %d\n", ch, line());   
                                    >>
				    
				    
#token TXT_WORD   "~[\ \t\r\n\<\"\'\0x81-\0xfe]+" //notice the \"

#token TXT_WORD_NEEDS_CONVERSION "[\0x81-\0xfe]+"

#token TXT_LT     "\<"             // << printf("GOT <\n"); >>


#token  "\<!\-\-"                   << 
                                       skip(); 
                                       wasTextMode=true; 
				       mode(XML_COMMENT_MODE);
				    >>
  
#token  TEOF "@"


#tokclass TXT_SKIP {
  TXT_BLANK 
  TXT_NL
}


#token  "\""                       << //printf("BEG OF quot\n");
                                      sconstDelim = ch; 
				      more();
                                      mode(ML_ONLY_C_STRING_MODE);
                                   >>

    
#token "\'"                        << //printf("BEG OF apos\n");
                                      sconstDelim = ch; 
				      more();
                                      mode(ML_ONLY_C_STRING_MODE);
                                   >>





//collapse with C_STRING_MODE???
#lexclass   ML_ONLY_C_STRING_MODE /**********************************************/

#token  C_STRING "[\"\'\n\r]"      << if (ch == sconstDelim){
                                       // printf("GOT C_STRING %s\n", lextext());
                                        //mode(ML_ONLY_TEXT_MODE);
					mode(ML_ONLY_SCRIPT_MODE);
			              }
				      else {
                                        if (ch == '\"'){
                                          replstr("\\\"");
                                        }  
                                        else if(ch == '\n'){
					  //should this be an error ???
                                          replchar(' '); //should really be nothing, find a way
                                        }
                                        more();                                      
                                      }
				   >>

#token  "~[\"\'\n\r]+"           << more(); >>
  

/* this went with a corresponding part in the parser, which is gone. 

#lexclass XML_ENTITY_MODE /***************************************


#token TXT_BLANK  "[\ \t]+"
#token TXT_NL     "[\r\n]"            << newline(); >>


#token STRING_END "@"                 <<
                                         restoreState(&saved_state);
                                         delete entityvalue;
                                         skip();
                                         mode(TEXT_MODE);
                                      >>



#token ENTITY "&~[\ \\\r\n\t;]*;"     <<
                                         skip();

                                         entityvalue->DLGStringReset(getEntityValue(lextext()));
                                      >>

  
#token TXT_WORD "~[\ \t\r\n&]+"  
                                        


*/






#lexclass XML_COMMENT_MODE /*****************************************/

                                   /* this is a regexpr weirdo - we need to recognize
                                    * '-->' and skip all other '-', but unfortunately
                                    * this is a prefix of the longer regexpr, and dlg for
                                    * some reason isn't looking for the longest match (PM)
                                    */
				    
#token "\-+{\>}"                   << 
                                      if ( (*_endexpr == '>') && (_begexpr[1] == '-') ){
				      //  printf("got comment in XML_COMMENT_MODE %s, line %d\n", lextext(), line());
				      
                                        if ( wasTextMode ){
					 #ifndef ML_ONLY
                                          mode(TEXT_MODE);
					 #else
					   if(enterScript){
					       mode(ML_ONLY_SCRIPT_MODE);
					   }
					   else{
					       mode(ML_ONLY_TEXT_MODE);
					   }
					 #endif  
					  wasTextMode=false;
                                        }
                                        else {
                                          mode(START);
                                        }
				      }
				      
                                      skip();
				   >>
				   
#token "[\r\n]"                    << skip(); newline(); 
                                    //  printf("NEWLINE in XML_COMMENT ch is G%cG line is now %d\n", ch, line()); 
                                   >>

#token "~[\-\r\n]"                 << skip(); >>




#lexclass XML_STRING_MODE /****************************************/

#token  XML_STRING "[\"\']"        << 
                                     // printf("Got STRING %s |%s |%s\n", lextext(), begexpr(), endexpr());
                                      if ( ch == sconstDelim ){
                                        if ( ch == '\'' ){
                                          replchar('\"'); 
                                        }
					mode(START);
                                      }
                                      else {
				        if(ch == '\"'){
					  replstr("\\\"");
					}
					more();
                                      }
                                   >>
				   
				   
				   
				   
#token TXT_AMP "&"                 <<
                                      //printf("Got TXT_AMP %s |%s |%s\n", lextext(), begexpr(), endexpr());
                                      replchar('\0'); 
				      more(); 
				      // printf("Got TXT_AMP %s |%s |%s\n", lextext(), begexpr(), endexpr()); 
                                      mode(XML_ENTITY_MODE);
				   >>


#token  "~[\"\'\\&]+"             << 
                                      //printf("Got THAT |%s|%s|%s\n", lextext(), begexpr(), endexpr());
                                      more(); 
				   >>
				   
//prompted by nasdaq.com 
/* messes up news.bbc.co.uk
also had #token  "~[\"\'\\&\>]+" above

#token  XML_CLOSE      "\>"        << if ( enterScript ) {
                                        enterScript = false;
					
#ifndef ML_ONLY 					
                                        mode( SCRIPT_MODE);
#else
                                        mode( ML_ONLY_TEXT_MODE);
#endif										
                                      }
                                      else {
				        
                                        mode( TEXT_MODE);
                                      }
				      
				     // printf("GOT XML_CLOSE\n");
                                   >>
*/  
  

	                  
#token  "\\\""                     << replstr ("\\\""); more (); >>
#token  "\\~[]"                    << replchar (ch); more (); >> 



  
#lexclass XML_ENTITY_MODE //**************************************

  
  
#token  "~[\;\ \"\']+"             <<
                                   //   printf("Got some %s |%s |%s\n", lextext(), begexpr(), endexpr());
                                      if ( docType->expand ){
				          //only solution since can't backtrack
				          previous = StrDup(begexpr());
					  
					  char* temp = (*docType->expand)(begexpr());
					  
					  #ifndef ML_ONLY 
					  if(*temp == '\"'){
					      //not tested with other fixes around for ex "&;"
					      temp = "\\\"";
					  }
					  #endif
					  
					 // printf("TEMP is %s, previous is %s\n", temp, previous);
				          replstr(temp);
					  didReplace = true;
				      }
				      
				      more(); 
				    //  printf("Got some %s |%s |%s\n", lextext(), begexpr(), endexpr());
				   >>     
  
#token TXT_SEMI "\;"               << 
                                    //  printf("Got entity %s |%s |%s\n", lextext(), begexpr(), endexpr());
                                      
				      if(!didReplace){
				          replstr("&;");
				      }
				      else{
				          replchar('\0');
					  didReplace = false;
				      }
				      
				      more();
				      
				      mode(XML_STRING_MODE);
                                   >>

  
    
      
#token  "[\ ]"                     << //printf("Got space %s |%s |%s\n", lextext(), begexpr(), endexpr());
                                    //  printf("previous was %s\n", previous);
				  
				      //review this code: innefficencies with handling of previous??				       
												      				      
				      if(didReplace){
				          char* temp = (char*) calloc(1 +
					                              strlen(previous) +
								      1 +
								      1
								      ,
								      sizeof(char)
								     );
					  strcpy(temp, "&");
					  strcat(temp, previous);
					  strcat(temp, " ");
					  
					  char* s = temp;
					  
					  //replstr without nextpos = _begexpr;
					  register DLGChar *l= &_lextext[_bufsize -1];
					  
                                          nextpos -= strlen(previous) + 1;

	                                  while ((nextpos <= l) && (*(nextpos++) = *(s++)))
					      ;
		  		          // correct for NULL at end of string 
		                          nextpos--;
        
	                                  if ((nextpos <= l) && (*(--s) == 0)){
		                              bufovf = 0;
	                                  }else{
	                                      bufovf = 1;
	                                  }
	                                  *(nextpos) = '\0';
	                                  _endexpr = nextpos - 1;

				
					  free(temp);
				
					  didReplace = false;
				      }
				      else{
				           replstr("& ");
			              }
				      
				      
				      more();
				      mode(XML_STRING_MODE);
                                   >>
      
	
	    
#token  XML_STRING "[\"\']"        << //printf("HERE");
                                      //printf("Got STRING %s |%s |%s\n", lextext(), begexpr(), endexpr());
                                      if ( ch == sconstDelim ){
				      
				        if(didReplace){
				          char* temp = (char*) calloc(1 +
					                              strlen(previous) +
								      1 +
								      1 
								      ,
								      sizeof(char)
								     );
					  strcpy(temp, "&");
					  strcat(temp, previous);
					  
					  strcat(temp, "\"");
					  
					  char* s = temp;  
                                         
                                         
					  
					  //replstr without nextpos = _begexpr;
					  register DLGChar *l= &_lextext[_bufsize -1];
					  
                                          nextpos -= strlen(previous) + 1;

	                                  while ((nextpos <= l) && (*(nextpos++) = *(s++)))
					      ;
		  		          // correct for NULL at end of string 
		                          nextpos--;
        
	                                  if ((nextpos <= l) && (*(--s) == 0)){
		                              bufovf = 0;
	                                  }else{
	                                      bufovf = 1;
	                                  }
	                                  *(nextpos) = '\0';
	                                  _endexpr = nextpos - 1;


					  free(temp); 
					 				
					  didReplace = false;
				        }
				        else{
					  replstr("&\"");
					}
				        
                                        mode(START);
                                      }
                                      else {
				        if(ch == '\"'){
					  replstr("\\\"");
					}
					more();
                                      }
                                   >>
  

//ML_ONLY_END





/* script part */                                                      
  
#lexclass SCRIPT_MODE /**************************************************/

#token  "[\ \t\0x0C\0x0B]+"        << skip(); >>

#token  NEWLINE "[\r\n]"           <<
                                      if(!NoLineTerminatorHere){
                                        skip();
				      }	
                                     
                                      newline(); 
				      
				      if(inFunctionBody){
                                          fprintf(bodies_file, "\\n");
                                      }	
				      
				      //printf("NEWLINE in SCRIPT ch is G%cG line is now %d\n", ch, line()); 
                                   >>
                                   
#token  TEOF "@"                   << 
                                      #ifdef KAFFELIB
                                        if(SrcInputStream != NULL){
                                          restoreState(&saved_state);
                                          skip();
                                        } 
                                      #endif            
                                   >>
                                   

#token  "//~[\n]*"                 << // single line comment does not include NEWLINE


                                      
                                      skip();
				      
                                      /*
				      
				       craigslist.org has:
				       //--> </SCRIPT> !!!!!!
				       
				      */
				      				      
				      //check if script end was in the comment!!!
				      //the folowing does not work since the parser does not get SCRIPT_END
				      char* lextexT = lextext();
				      
				      int len = strlen(lextexT); 
				      				      
				      int i;
				      
				      for(i = 0; i < len; i++){
				          if(!strncasecmp(lextexT + i, "script", 6)){
					      i += 6;
					      for(; i < len; i++){
                                                  if(!strncasecmp(lextexT + i, ">", 1)){  
					              mode( START);
						  }    
					      }    
					      	
					  }
                                      } 
                                   >>   

#token  "\<!\-\-~[\n]*"            << skip(); >>   // same for this one 
  
#token  "/\*"                      << skip(); mode(C_COMMENT_MODE); >>
  




/* C comment mode */                                                   

#lexclass   C_COMMENT_MODE /*********************************************/

#token  "\*/"                      << skip(); mode (SCRIPT_MODE);  >>
#token  "[\r\n]"                   << skip(); newline();
                                    //  printf("NEWLINE in C_COMMENT ch is G%cG line is now %d\n", ch, line());   
                                   >>
#token  "~[]"                      << skip(); >>





#lexclass SCRIPT_MODE /**************************************************/
  

/* non-op symbols */                                                    
  
/* this brings us back into XML mode */
#token  SCRIPT_END "\</[\ \t\r\n]*[sS][cC][rR][iI][pP][tT]\>"   << 
                                                        enterScript = false;
                                                        mode( TEXT_MODE); 
							
					             >>

#token  JAVA_START "\<java\>"
#token  JAVA_END   "\</java\>"
  
#token  DOT       "\."   
#token  LBRACK    "\["
#token  RBRACK    "\]"
#token  LBRACE    "\{"
#token  RBRACE    "\}"
#token  LPAREN    "\("
#token  RPAREN    "\)"
#token  SC        "\;"  
#token  COMMA     "\,"
#token  COLON     "\:"

#tokclass SYMBOL {
  DOT LBRACK LBRACE LPAREN RBRACK RBRACE RPAREN SC COMMA
}

#tokclass BRACE {
  LBRACE RBRACE
}



/* operators */                                                         
#token  STRICT_EQUAL "\=\=\="
#token  EQUAL        "\=\="
#token  ASSIGN       "\="
#token  STRICT_NOTEQUAL "!\=\="
#token  NOT_EQUAL    "!\="
#token  LOG_NOT      "!"
#token  USHR_ASSIGN  "\>\>\>\="
#token  USHR         "\>\>\>"
#token  SHR_ASSIGN   "\>\>\="
#token  SHR          "\>\>"
#token  GE           "\>\="
#token  GT           "\>"
#token  SHL_ASSIGN   "\<\<\="
#token  SHL          "\<\<"
#token  LE           "\<\="
#token  TLT          "\<"                 // beware of the LT(k) function
#token  MINUS_ASSIGN "\-\="
#token  DEC          "\-\-"
#token  MINUS        "\-"
#token  PLUS_ASSIGN  "\+\="
#token  INC          "\+\+"
#token  PLUS         "\+"
#token  MOD_ASSIGN   "%\="
#token  MOD          "%"
#token  MUL_ASSIGN   "\*\="
#token  MUL          "\*"
#token  DIV_ASSIGN   "\/\="
#token  DIV          "\/"
#token  OR_ASSIGN    "\|\="
#token  LOG_OR       "\|\|"
#token  OR           "\|"
#token  AND_ASSIGN   "&\="
#token  LOG_AND      "&&"
#token  AND          "&"
#token  XOR_ASSIGN   "^\="
#token  XOR          "^"
#token  COND         "\?"
#token  NOT          "\~"

#tokclass OPERATOR {
  STRICT_EQUAL EQUAL ASSIGN STRICT_NOTEQUAL NOT_EQUAL NOT GE GT LE TLT
  MINUS_ASSIGN DEC MINUS PLUS_ASSIGN INC PLUS MOD_ASSIGN MOD MUL_ASSIGN MUL
  DIV_ASSIGN DIV OR_ASSIGN LOG_OR OR AND_ASSIGN LOG_AND AND XOR_ASSIGN XOR
  USHR_ASSIGN USHR SHR_ASSIGN SHR SHL_ASSIGN SHL COND LOG_NOT
}



/* keywords */                                                          
#token  IF         "if"
#token  ELSE       "else"
#token  FOR        "for"
#token  IN         "in"
#token  WHILE      "while"
#token  CONTINUE   "continue"
#token  RETURN     "return"
#token  DO         "do"
#token  BREAK      "break"
#token  SWITCH     "switch"
#token  CASE       "case"
#token  DEFAULT    "default"
#token  WITH       "with"
#token  VAR        "var"
#token  FUNCTION   "function"
#token  TRY        "try"
#token  THROW      "throw"
#token  CATCH      "catch"
#token  FINALLY    "finally"
#token  NEW        "new"
#token  DELETE     "delete"
#token  VOID       "void"
#token  TYPEOF     "typeof"
#token  INSTANCEOF "instanceof"
#token  TNULL      "null"
#token  TTRUE      "true"
#token  TFALSE     "false"
#token  TTHIS      "this"



#token UNDEF  //dummmy for putting return undefined; to return; check out for identifiers with same name ?


// future keywords
/*
#token "abstract"
#token "enum"
#token "int"
#token "short"
#token "boolean"
#token "export"
#token "interface"
#token "static"
#token "byte"
#token "extends"
#token "long"
#token "super"
#token "char"
#token "final"
#token "native"
#token "synchronized"
#token "class"
#token "float"
#token "package"
#token "throws"
#token "const"
#token "goto" 
#token "private"
#token "transient"
#token "debugger"
#token "implements"
#token "protected"
#token "volatile"
#token "double"
#token "import"
#token "public"
*/

#tokclass KEYWORD {
  IF ELSE FOR IN WHILE CONTINUE RETURN 
  DO BREAK SWITCH CASE DEFAULT WITH VAR FUNCTION
  TRY THROW CATCH FINALLY NEW DELETE VOID TYPEOF INSTANCEOF
  TTHIS TNULL TTRUE TFALSE
}




/*
// String 

// fields 

// methods 
#token FROMCHARCODE   "String.fromCharCode"


#tokclass STRING_STATIC_METHODS{
  FROMCHARCODE
}



// Converters 

// methods 
#token OBJECT   "Object"
#token BOOLEAN  "Boolean"
#token STRING   "String"
#token NUMBER   "Number"

#tokclass CONVERTER_STATIC_METHODS{
  OBJECT BOOLEAN STRING  NUMBER
}

*/




/* identifier*/                                                         

#token  ID           "[a-zA-Z_\$][a-zA-Z0-9_\$]*"



/* num literals */                                                      

/* had ambiguity in sorcerer between MINUS expr and MINUS expr expr*/

#token  EXP_CONST    "{[0-9]*}\.[0-9]+[eE]{[\+\-]}[0-9]+"
#token  FLT_CONST    "{[0-9]*}\.[0-9]+"
#token  INT_CONST    "[0-9]+"
#token  HEX_CONST    "0[xX][0-9a-fA-F]+"
#token  OCT_CONST    "0[0-7]*"

#tokclass NUM_CONST { INT_CONST HEX_CONST FLT_CONST EXP_CONST OCT_CONST}

#tokclass INTEGER_CONST { INT_CONST HEX_CONST OCT_CONST}
#tokclass REAL_CONST { FLT_CONST EXP_CONST }

/* string literal mode */                                               

// again, the token name unification trick (START mode)
#token  DQUOTE "\""                << if ( inEventScript ) {
                                          mode(START);
                                      }
                                      else {
                                        sconstDelim = ch; more();
                                        mode(C_STRING_MODE);
                                      }
                                   >>
  
#token "\'"                        << sconstDelim = ch; more();
                                      mode(C_STRING_MODE);
                                   >>
  
  
 
  
#lexclass   C_STRING_MODE /**********************************************/

#token  STRING_CONST "[\"\'\n\r]"  << if (ch == sconstDelim){
                                        mode(SCRIPT_MODE);
                                      }
                                      else {
                                        if (ch == '\"'){
                                          replstr("\\\"");
                                        }  
                                        else if(ch == '\n'){
					  //should this be an error ???
                                          replchar(' '); //should really be nothing, find a way
                                        }
                                        more();                                      
                                      }
                                   >>
                   
#token  "\\\""                     << replstr ("\\\""); more (); >>
#token  "\\'"                      << replchar ('\'');  more (); >>
#token  "\\\\"                     << replstr ("\\\\"); more (); >>
#token  "\\b"                      << replstr ("\\b");  more (); >>
#token  "\\f"                      << replstr ("\\f");  more (); >>
#token  "\\n"                      << replstr ("\\n");  more (); >> 
#token  "\\r"                      << replstr ("\\r");  more (); >>
#token  "\\t"                      << replstr ("\\t");  more (); >>
#token  "\\v"                      << replstr ("\\v");  more (); >>  
#token  "\\~[]"                    << replchar (ch);    more (); >> 

#token  "~[\"\'\\\n\r]+"           << more(); >>
  

  
#lexclass SCRIPT_MODE /**************************************************/
  


/* token classes */                                                     

#tokclass MULTIPLICATIVE_OP { MUL DIV MOD }

#tokclass ADDITIVE_OP { PLUS MINUS }

#tokclass SHIFT_OP { SHL SHR USHR }

#tokclass RELATIONAL_OP { TLT LE GT GE INSTANCEOF}

#tokclass EQUALITY_OP { EQUAL NOT_EQUAL STRICT_EQUAL STRICT_NOTEQUAL }

#tokclass UNARY_OP { INC DEC NOT LOG_NOT VOID TYPEOF}

//#tokclass UNARY_OP_LEFTSIDE { INC DEC }

//#tokclass UNARY_OP_UNARY {  NOT LOG_NOT VOID TYPEOF}

#tokclass ASSIGNMENT_OP { ASSIGN MUL_ASSIGN DIV_ASSIGN MOD_ASSIGN PLUS_ASSIGN MINUS_ASSIGN SHL_ASSIGN SHR_ASSIGN USHR_ASSIGN AND_ASSIGN XOR_ASSIGN OR_ASSIGN }

#tokclass INCREMENT_OP { INC DEC }

#tokclass CONST { NUM_CONST STRING_CONST }

#tokclass VAR_END {SC COMMA }
  




/******************************************************************************
 * parser
 */


//ML_ONLY_START  

  
class Parser {

<< 
  private:
  
          bool validNextNode ( char* tag ){
	      	      
           //   printf("Tag is %s, LT(2)->type() is %d, LT(2)->getText() is %s\n", tag, LT(2)->getType(), LT(2)->getText());
             
	     
	     
	     
	     
	   	      
	     //printf("docType->validChildNode = %p\n", docType->validChildNode);
             //printf("docType->validEndNode = %p\n", docType->validEndNode);
	      
	      //in need of a scanning solution to this
	      char* first;
	      char* second;
	      
	      int len = strlen(tag);
	      
	      bool firstToFree = false, secondToFree = false;
	      
	      if(tag[ len - 1 ] == '/'){
	          first = (char*) calloc(len - 1 + 1, sizeof(char));
		  strncpy(first, tag, len - 1);
		  first[len - 1] = '\0';
                  firstToFree = true;
	      }
	      else{
	          first = tag;
	      }
	      
	      
	      second = LT(2)->getText();
	      len = strlen(second);
	      if(second[ len - 1 ] == '/'){
	          second = (char*) calloc(len - 1 + 1, sizeof(char));
		  strncpy(second, LT(2)->getText(), len - 1);
		  second[len - 1] = '\0';
		  secondToFree = true;
	      }
	     
	    //  printf("Type is %d\n", LT(1)->getType());
	     
              switch ( LT(1)->getType() ){
	      
	         // short ret_val;
		 
		  
	      
                  case XML_OPEN:
		            
//ML_ONLY_END  
		  
		                if(!strcasecmp("script", second) && !parent_tag_set_in_this_run){
				   // printf("setting parent_tag to %s\n", tag);
		                    parent_tag = StrDup(tag); //LEAK HERE, fix some time
				    parent_tag_set_in_this_run = true;
				}
				
//ML_ONLY_START
		               
                                if ( docType->validChildNode && !(*docType->validChildNode)(first, second) ){
                                   //   if(!strcasecmp(tag, "br"))
				    printf("### XML_OPEN bail %s -> %s\n", first, second);
				    goto RETURNFALSE;
                                }
                                break;
				
				
                  case XML_END_OPEN:
                                    //printf("    test <%s>:</%s>\n", tag,LT(2)->getText());
                                    if ( docType->validEndNode && !(*docType->validEndNode)(first, second) ){
                                     //  if(!strcasecmp(tag, "br")) 
				        printf("###  XML_END_OPEN bail %s -> end %s\n", first, second);
                                        goto RETURNFALSE;
                                    }
                                    break;
				  
				      
                 
		  
		  
		  case TXT_AMP: 
		  case TXT_SEMI:
#ifdef ML_ONLY		  
		  case TXT_LT:
		  case C_STRING:
#endif		  
		  case TXT_WORD_NEEDS_CONVERSION:
		  
		  case TXT_WORD:               
                                if ( docType->validChildNode && !(*docType->validChildNode)(first,"_text_") ){
                                  // if(!strcasecmp(tag, "br")) 
				    printf("### TXT_WORD bail %s -> _text_\n", first);
                                    goto RETURNFALSE;
                                }
				
				break;
			
				
		  case  XML_META_OPEN:    
		  case  XML_DTD_OPEN: 				
		                          break;
				
		  		  
		  default:      if(LT(1)->getType() != TEOF){
		                    fprintf(stderr, "Hit default in validNextNode\n");
				    fprintf(stderr, "LT(1)->type() is %d, LT(1)->getText() is %s\n", LT(1)->getType(), LT(1)->getText()); 				
                                } 
	      }
    
              
	      if(firstToFree){
	          free(first);
	      } 
	      if(secondToFree){
	          free(second);
	      } 
 	 
    
              return true;
	      
	      
	      RETURNFALSE:
	      
	              if(firstToFree){
	                  free(first);
	              } 
	              if(secondToFree){
	                  free(second);
	              } 
               
	              return false;
          }
	  
	  
//ML_ONLY_END 
	  
	  //returns NULL if no " found
	  char* escape_double_quotes(char* in){
	          
		  int len = strlen(in);
		  
		  char* out = (char*) calloc(2 * len /* worst case all are " */ + 1, sizeof(char));
		  
		  int i,j;
		 
		  for(i = 0,j = 0; i < len; i++){
	                
			  if(in[i] == '\"'){
			  
			          out[j] = '\\';
				  
				  out[j + 1] = '\"';
			
				  j+=2;
		          }
			  else{
			  
				  out[j] = in[i];
				  
				  j++;
			  }
	          }
		  
		  if(j == i){
		          free(out);
		          return NULL;
		  }
		  else{
		          return out;
		  }
	  }
	  
	  
//ML_ONLY_START 	  

 	 
  public:
          void* operator new(size_t size){
	      return (void*) malloc(size);
          }
	
          void operator delete(void* p, size_t size){
	      free(p);   
          }

>>




/******************************************************************************
 * Parser part A - XML
 */
 

//global exception handler: Means "for all" not "in case math none, at bottom of call stack"
//so don't put here, put in highedst node!


  
document                                                                
:                                <<
				     int initLevel;
				     
				     #if defined KAFFELIB && !defined ML_ONLY
			               if(writeGenerated){
				           //get handle from current class
					   //temporary solution, totally not-reentrant right now
					   jclass xsEngine = Genv->FindClass("kaffe.xs.XsEngine"); CheckException();
					
					   jfieldID curDocumentFactoryID = Genv->GetStaticFieldID(xsEngine, "curDocumentFactory", "Lkaffe/xs/DocumentFactory;"); CheckException();   
					
					   jobject curDocumentFactory = Genv->GetStaticObjectField(xsEngine, curDocumentFactoryID);  CheckException();
					  					   
					   jclass documentFactory = Genv->GetObjectClass(curDocumentFactory); CheckException(); 
					   jmethodID getCurrentLevel = Genv->GetMethodID (documentFactory, "getCurrentLevel", "()I"); CheckException();
		
					   initLevel = Genv->CallIntMethod(curDocumentFactory, getCurrentLevel); CheckException();  
				       }
				       else{
				           initLevel = 0;
				       }
				     #else
				       initLevel = 0;
				     #endif   
				>>

  (TXT_SKIP!)*                   //eat garbage at beginning of file        
  
			           
  ( node [initLevel] )*
 
;

         
node                                                                    
  [int nodeLevel] > [char* txt_skip_at_beg]
:                  
                               <<
			           $txt_skip_at_beg = NULL;	                       
			       >> 				             
                                            
  (
    XML_OPEN^
    ( scripTNode
    | genericNode [nodeLevel] > [$txt_skip_at_beg]
    )
  )
 |( XML_META_OPEN//^ 
    metaNode )
 |( XML_DTD_OPEN//^ 
    dtdNode )
;



genericNode                                                             
  [int nodelevel] > [char* txt_skip_at_beg] 
:                                  
                                   << char* tag; 
                                      bool pre=false; 
                                     
				      $txt_skip_at_beg = NULL;
                                       
				      char* temp; 
                                      char* prefix;
                                   >>

  a:XML_TAG^                       << tag = $a->getText();
                                      
				       //  pushTag(tag);
				      
				      
				     
                                      pre = (strcasecmp( tag, "pre") == 0);
                                     
				     /*
				      if(!strcasecmp( tag, "base")){
				        printf("GOT BASE\n");
				      }
                                   */
                                                                               
				      //TODO: commented out isHtml tests here and there must be fixed with writeGenerated
                                      
				      if ( !strcasecmp( tag, "html") 
				         #ifndef ML_ONLY
					 || writeGenerated
					 #endif
					 ){ 
				          // isHtml = true; //redundant: merge mechanism with DocType
					//  printf("HERE\n");
					  setDocType("html");
		                      }
				      
				      //hack for those who don't have html tags
				      //take out since only doing hml for now and will need to redesign anyhow
				    
				      /*
				      So go with file extension????  
				      if(docType == &genericDocType && nodelevel > 0){
				          setDocType("html");
				      }
				      */
				       
				      //this test only to be done on the first tag encountered ??????? !!!! 
				      #if defined KAFFELIB && !defined ML_ONLY
				        if(writeGenerated){
					    if(!(*docType->validChildNode)(parent_tag, tag)){
					        longjmp(jmpbuffer, 1);
					    }
					}		 	 
				      #endif
				      					                                           
                                      #a->nodelevel = nodelevel;
				      
				      //in need of a scanning soution to this
				      //check for / since might be in due to reg exp form
				      
				      if( tag[ strlen(tag) - 1 ] == '/'){
				        // printf("LUKE\n");
				         char* newTag = (char*) calloc(strlen(tag) - 1 + 1, sizeof(char));
				         strncpy(newTag, tag, strlen(tag) - 1);
					 newTag[strlen(tag) - 1]  = '\0';
				         $a->setText(newTag);
					 free(newTag);
					 
				         consume();
			                 consume();
						         
					 while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					     consume();
					 }
                                        // popTag();
					 return NULL/*NORMAL*/; 
				      }	
	     
				   >>
  (
   attr 
  
  )*                             
  ( DQUOTE!             // eat garbage, prompted by slashdot.org
  )*
  (
      ( 
       XML_ELEM_CLOSE! (b:TXT_SKIP!   << if(/*$b->getType() == TXT_BLANK ||*/ pre){ 
       
                                             if($txt_skip_at_beg == NULL){
					         $txt_skip_at_beg = (char *) calloc(1, sizeof(char));   
				                 $txt_skip_at_beg[0] = '\0';
                                             }
					 
					     prefix = $b->getText();
		    
                                             temp = (char*) calloc(strlen($txt_skip_at_beg) +  
						                   strlen(prefix) + 
			                                           1
						                   , 
							           sizeof(char)
							          );
							   
				             strcpy(temp, $txt_skip_at_beg);			   
				             strcat(temp, prefix);
				      
				             free($txt_skip_at_beg);
				        				       				      
				             $txt_skip_at_beg = temp;
					 }
                                      	// printf("Got TXT_SKIP at beg G%sG\n", $txt_skip_at_beg);			      
				      >>
       
              
                       )*   
      )    
       
    
    | 
      ( XML_CLOSE! 
      
       (c:TXT_SKIP!                   << if(/*$c->getType() == TXT_BLANK ||*/ pre){ 
       
                                             if($txt_skip_at_beg == NULL){
					         $txt_skip_at_beg = (char *) calloc(1, sizeof(char));   
				                 $txt_skip_at_beg[0] = '\0';
                                             }
					 
					     prefix = $c->getText();
		    
                                             temp = (char*) calloc(strlen($txt_skip_at_beg) +  
						                   strlen(prefix) + 
			                                           1
						                   , 
							           sizeof(char)
							          );
							   
				             strcpy(temp, $txt_skip_at_beg);			   
				             strcat(temp, prefix);
				      
				             free($txt_skip_at_beg);
				        				       				      
				             $txt_skip_at_beg = temp;
					 }
					 
                                      //	 printf("Got TXT_SKIP at beg G%sG\n", $txt_skip_at_beg);			      
				      >>  
       
       )*        
                                      << 					  
					  					  
										   
					  if ( !validNextNode(tag) ){
					           enqueueTag(tag);
						 //  printf("HERE\n");
						  // popTag();
						   return NULL/*UNWINDING*/;
					  }
					  else if(!strcasecmp(tag, "br")){  //prompted by http://www.slashdot.org
					     // popTag();
					    // printf("HERE\n");
					      return NULL;
					  }
                                          

					 
                                       >>
				       
         (   pcData[$txt_skip_at_beg, pre, nodelevel+1]  
	 
	                               << 
				          if($txt_skip_at_beg != NULL){
	                                      free($txt_skip_at_beg);
					      $txt_skip_at_beg = NULL;
	                                  }
					  
					  
                                          if ( !validNextNode(tag) ){
					     
					   					    
					    if(LT(1)->getType() == XML_END_OPEN){
					        #ifdef KAFFELIB
					        if(!strcasecmp(LT(2)->getText(), "font") &&
					           strcasecmp(tag, "font") &&
						   strcmp(GurlString, "slashdot.org") 
						  ){
						   //new for http://www.lineo.com/cgi-bin/rightnow           
							      
					           //assume has form </font>
					
					           consumeUntilToken(XML_CLOSE);
							      
					           consume();
						              
					           while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					               consume();
					           }
							     							   
					        }
					        //trying out, search results for bbc
					        else 
						#endif
						if(!strcasecmp(LT(2)->getText(), "span") &&
						        strcasecmp(tag, "span")){
							       
						   consumeUntilToken(XML_CLOSE);
						   consume();
						   while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					               consume();
					           }
							     
                                                }
                                         
                                                else{
						   // popTag();
						    return NULL;
						}

                                             }
					     else{
					        // popTag();
					         return NULL;
					     } 
		 
									 
											 		 
                                          }
					 
                                       >>
           | node [nodelevel+1] > [$txt_skip_at_beg]     
	                               
				       << 
					     //  printf("$txt_skip_at_beg is G%sG\n", $txt_skip_at_beg);										      
															      
					        // printf("HERE tag is %s\n", tag);
						
						
						/*
						 if(!strcasecmp(tag, "a")){
						 
						   // #0->preorder();
						   int i = 4;
						 
						 }
					      */
					        int col;
					
					        if (  !validNextNode(tag) ){
						   if(LT(1)->getType() == XML_END_OPEN){
						       if(!findTagInTagQueue(LT(2)->getText())/* &&
						          
						          onStack(LT(2)->getText()) &&
							  ((col = tagIndex( LT(2)->getText())) >= 0) &&
							  isStructNode(col)
							                         
							  
							  
							  
							  */
							  ){
							  /*
							  printf("HERE\n");							      
							      consumeUntilToken(XML_CLOSE);
						              consume();
						              while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                          consume();
					                      }
							      
							   */   
						           //go through all tags like this?? NO
						          
						         //  printf("GurlString is %s\n", GurlString);
							 //  printf("is it a substring? %d\n",substring(GurlString, "yahoo")); 
						       
						           //hack for slashdot.org. rewrite more generally
							   #ifdef KAFFELIB
					                   if(!substring(GurlString, "yahoo") && 
							      !strcasecmp(LT(2)->getText(), "font") &&
						              strcasecmp(tag, "font")){
						             // printf("RAMBO %d\n", $a->getLine());
							      
						              //assume has form </font>
					
						              consumeUntilToken(XML_CLOSE);
							      
						              consume();
						             // printf("1 is %s, 2 is %s\n", LT(1)->getText(),LT(2)->getText()); 
							      
							      while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                          consume();
					                      }
							      
							      //take out the return NORMAL for http://news.bbc.co.uk/
						              #ifdef KAFFELIB	      
							      if(!strcmp(GurlString, "slashdot.org") &&
							         !strcmp(GurlFile, "/")
							        ){
								 // popTag();	      
							          return $txt_skip_at_beg;
							      }
							      #endif
							   
							   }
							   else 
							   #endif
							   if(!strcasecmp(LT(2)->getText(), "center") &&
						              strcasecmp(tag, "center")
							      ){
						              //for slashdot
						              //assume has form </center>
							      #ifdef KAFFELIB
							      //added this check for http://shopping.yahoo.com/
							      if(!strcmp(GurlString, "slashdot.org")){
							      #endif

					                      consumeUntilToken(XML_CLOSE);
						              consume();
						              while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                          consume();
					                      }
							      #ifdef KAFFELIB
							      }
							      else{
							          enqueueTag(tag);
								 // popTag();
							          return $txt_skip_at_beg;
							      }
							      #endif
							      
						           }
							   else if(!strcasecmp(LT(2)->getText(), "a") &&
						              strcasecmp(tag, "a")){
						              
							      // prompted by http://www.yahoo.com/s/1955
							       
						              //assume has form </a>
					
						              consumeUntilToken(XML_CLOSE);
						              consume();
						              while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                          consume();
					                      }
							      
                                                           }
							   #ifdef KAFFELIB 
							   
							   else if(!substring(GurlString, "osdn") &&
							           !strcasecmp(LT(2)->getText(), "tr") &&
						                   strcasecmp(tag, "tr") 
							           ){
						              // prompted by http://auctions.yahoo.com/
							      //removed for osdn.com 
							      
						              //assume has form </tr>
					                      
						              consumeUntilToken(XML_CLOSE);
						              consume();
						              while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                          consume();
					                      }
							      
                                                           }
							   #endif
							   // prompted by http://www.yahoo.com/ on 09/25/01 
							   // but then broke news.bbc.co.uk
							   
							   else if(!strcasecmp(LT(2)->getText(), "small") &&
						              strcasecmp(tag, "small")){
						              // prompted by http://www.yahoo.com/ on 09/25/01
						              //assume has form </small>
					                     // if(!strcmp(GurlString, "www.yahoo.com")){
						                  consumeUntilToken(XML_CLOSE);
						                  consume();
						                  while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                              consume();
					                          }
							     // }
                                                           }
							   else if(!strcasecmp(LT(2)->getText(), "li") &&
						              strcasecmp(tag, "li")){
							       // prompted by http://www.amazon.com/o/dt/upda-1.0-pocketpc/subst/aa/upda/directory.html/107-6570798-4682127
						              
						              //assume has form </li>
					                     
						              consumeUntilToken(XML_CLOSE);
						              consume();
						              while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                          consume();
					                      }
							     
                                                           }
                                                           else if(!strcasecmp(LT(2)->getText(), "div") &&
						              strcasecmp(tag, "div")){
							       
						            //  printf("HERE A\n");
						              
					                      //for cnn.com
						              consumeUntilToken(XML_CLOSE);
						              consume();
						              while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                          consume();
					                      }
							     
                                                           }
							   else if(!strcasecmp(LT(2)->getText(), "select") &&
						              strcasecmp(tag, "select")){
							       
						            
						              
					                      //for craigslist.org
						              consumeUntilToken(XML_CLOSE);
						              consume();
						              while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                          consume();
					                      }
							     
                                                           }
							   else if(!strcasecmp(LT(2)->getText(), "form") &&
						              strcasecmp(tag, "form")){
							       
						            
						              
					                      //for http://www.cnn.com/WEATHER/
						              consumeUntilToken(XML_CLOSE);
						              consume();
						              while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                          consume();
					                      }
							     
                                                           }/* messes slashdot.org
							   else if(!strcasecmp(LT(2)->getText(), "td") &&
						              strcasecmp(tag, "td")){
							       
						            
						              
					                      //for craigslist.org
						              consumeUntilToken(XML_CLOSE);
						              consume();
						              while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                          consume();
					                      }
							     
                                                           }*/
							   else if(!strcasecmp(LT(2)->getText(), "span") &&
						              strcasecmp(tag, "span")){
							       
						              
						              //for amazon.com
					                      
						              consumeUntilToken(XML_CLOSE);
						              consume();
						              while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                          consume();
					                      }
							     
                                                           }//end tag of an unknown tag
							   else if( tagIndex(LT(2)->getText()) < 0){
							      
					                     // printf("RAMBO\n");
						              consumeUntilToken(XML_CLOSE);
						              consume();
						              while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                          consume();
					                      }
							     							     
                                                           }
                                                             
                                                           else{
							       enqueueTag(tag);
							      // popTag();
							       return $txt_skip_at_beg;
							   }
							  
							 							  
	                                               }
						     

						      
					           }
						   else{//printf("RAMBO C\n");
						     //  popTag();
				                       return $txt_skip_at_beg;
						   }
					        } // hacks hacks hacks
						else if(LT(1)->getType() == XML_END_OPEN ){ 
						   if(!strcasecmp(LT(2)->getText(), "p") &&
						      strcasecmp(tag, "p")){
						    //  printf("HERE B\n");
						      //assume has form </p>
						      //prompted by slashdot.org
						      consumeUntilToken(XML_CLOSE);
						      consume();
						      while(set_el(LT(1)->getType(), TXT_SKIP_set)){
					                  consume();
					              }
						      
						     

						   }
						  
                                                   
						   
						}

						
									     			     
					
						
				      >>
           | (  XML_END_OPEN!           /* we accept mixed-in end-tags for (overlapping) HTML */
                f:XML_TAG!
                {
	         XML_CLOSE!             // saw </font on craigslist.org
	        } 
	        (d:TXT_SKIP!          << if($d->getType() == TXT_BLANK){ //prompted by news.bbc.co.uk
		
                                             if($txt_skip_at_beg == NULL){
					 
					         $txt_skip_at_beg = (char *) calloc(1, sizeof(char));   
				                 $txt_skip_at_beg[0] = '\0';
                                             }
					 
					     prefix = $d->getText();
		    
                                             temp = (char*) calloc(strlen($txt_skip_at_beg) +  
						                   strlen(prefix) + 
			                                           1
						                   , 
							           sizeof(char)
							          );
							   
				             strcpy(temp, $txt_skip_at_beg);			   
				             strcat(temp, prefix);
				      
				             free($txt_skip_at_beg);
				        				       				      
				             $txt_skip_at_beg= temp;
					 }
                                      	 //printf("Got TXT_SKIP at beg G%sG\n", txt_skip_at_beg);			      
				      >> 
		
		
		
		
		)* 
	     	                      << 
	                                 	       
	                                  //experimental 
	                                  if(!findTagInTagQueue($f->getText())){
					      if (!strcasecmp( tag, $f->getText())){
					         // popTag();
	                                          return $txt_skip_at_beg;
                                              }
				          }
					  else{
					      //test prompted by www.osdn.com
					      if(strcasecmp($f->getText(), "p")){
					         // popTag();
					          return $txt_skip_at_beg;
					      }
					  } 
				       >>
            )  
         )*
	 
      )
  )
  
  
  << 
  // popTag();
  
  >>
;




//revise, some useless computation  
pcData                                                                  
  [char* prefix, 
   bool conserveSpace, 
   int nodelevel]
:                                  
                                   << char* sep=0; 
				   
				      #define STRING_BUF_SIZE 200
				   
				      //try to avoid allocs all over the place
				      char buf[STRING_BUF_SIZE + 1];
				      int buf_len = 0;
				      bool buf_copied_over = false;
                                      
				      //realloc does not work (does it ever?)
				      
                                      char* whole_string = NULL;				      
				      char* temp;
				      				      
				      char* ret; 
				   
				      bool containsEntities = false; 
				      bool containsEntitiesDummy;
				    
				     // printf("Here prefix is G%sG\n", prefix);
				     
				    //  printf("Conserve space is %d\n", conserveSpace); 
				    
				      if(prefix != NULL){
				          
				          whole_string = (char*) calloc(strlen(prefix) +  
						                        1
						                        , 
							                sizeof(char)
							               );
							   
				          strcpy(whole_string, prefix);
					  
					  
					  
					  strcpy(buf, prefix);
					  
			              }
				      else{
				         
				        //  whole_string = (char *) calloc(1, sizeof(char)); //dummy assignment  
				        //  whole_string[0] = '\0';
			                 
					 
					  buf[0] = '\0';
				      }
				      
				   >>
				   
  pcDataWord! [0, &containsEntitiesDummy] > [ret]          
                                   
				   <<
				    //  printf("ret is %s\n", ret);
				    
				      int len = strlen(ret);
				      
				      if((buf_len += len) <= STRING_BUF_SIZE){
				          strcat(buf, ret);
			              }
				      else{
				         
				          if(whole_string != NULL){
					      temp = (char*) calloc(strlen(whole_string) +  
						                    len + 
			                                            1
						                    , 
							            sizeof(char)
							           );		   		   
				              strcpy(temp, whole_string);
					  }
					  else{
					      temp = (char*) calloc(len + 
			                                            1
						                    , 
							            sizeof(char)
							           );
					  }
					  
					  
					  			   
				          strcat(temp, ret);
				      
				          if(whole_string){			   
                                              free(whole_string);
				          }
				       				          
					  whole_string = temp;
					  
					  buf_copied_over = true;
                                      }
				      
				      //testing
				      
				      if(ret != pcdataword_buf){
				       // printf("freeing ret\n");
					free(ret);
                                      }
				      

				      
				      containsEntities |= containsEntitiesDummy;
				   >>  
				   
  (                                //to fix: losing multiple spaces
    b:TXT_BLANK!                   << sep = ( (conserveSpace) ? $b->getText() : (char*)" "); >>
  | c:TXT_NL!                      << sep = ( (conserveSpace) ? $c->getText()/*(char*)"\n" */: (char*)" ");   >>
  
  | pcDataWord! [sep, &containsEntitiesDummy] > [ret]      
  
                                   << 
				     // printf("ret is %s\n", ret);
				   
				      sep = NULL; 
                                     
				      int len = strlen(ret);
				      
				      if((buf_len += len) <= STRING_BUF_SIZE){
				          strcat(buf, ret);
			              }
				      else{
				          if(!buf_copied_over){
					      whole_string  = (char*) calloc(buf_len + 
			                                                     1
						                             , 
							                     sizeof(char)
							                   );
							   
				              strcpy(whole_string, buf);			   
				          				      
				              buf_copied_over = true;
					  }
				       
				          temp = (char*) calloc(strlen(whole_string) +  
						                len + 
			                                        1
						                , 
							        sizeof(char)
							       );
							   
				          strcpy(temp, whole_string);			   
				          strcat(temp, ret);
				      
				          if(whole_string){			   
                                              free(whole_string);
				          }
				       
				        				      
				          whole_string = temp;
                                      }
				      
				      
				      //testing
				      
				      if(ret != pcdataword_buf){
				       // printf("freeing ret\n");
					free(ret);
                                      }
				     
				   //   printf("whole_string is %s\n", buf);	
				      
				      containsEntities |= containsEntitiesDummy;				   
				   >>
  )*

                                   <<
				      if(sep != NULL){ // space leftover at end of text
				      
				          int len = strlen(sep);
				      
				          if((buf_len += len) <= STRING_BUF_SIZE){
				              strcat(buf, sep);
				          }
				          else{
				              if(!buf_copied_over){
					          whole_string  = (char*) calloc(buf_len + 
			                                                         1
						                                 , 
							                         sizeof(char)
							                       );
							   
				                  strcpy(whole_string, buf);			   
				          				      
				                  buf_copied_over = true; 
					  
					      }
				       
				              temp = (char*) calloc(strlen(whole_string) +  
						                    len + 
			                                            1
						                    , 
							            sizeof(char)
							            );
							   
				              strcpy(temp, whole_string);			   
				              strcat(temp, sep);
				      
				              if(whole_string){			   
                                                  free(whole_string);
				              }
				       
				            				      
				              whole_string = temp;
                                          }
				      }
				   
				   
				      if(!buf_copied_over){
				      
				          #0 = new AST(TXT_WORD, buf);
				//	  printf("In pcData, BUF got strlen = %d\n", strlen(buf));
				      }
				      else{
				   
				          #0 = new AST(TXT_WORD, whole_string);
				   //    printf("In pcData, WHOLE_STRING got strlen = %d\n", strlen(whole_string));
				         // free(whole_string);
				      }
				      
				      
				      if(whole_string != NULL){ //not equivalent to if(!buf_copied_over)
				          free(whole_string);
				      }				      
				      
				      ((AST*)#0)->nodelevel = nodelevel;
				      
				      ((AST*)#0)->containsEntities = containsEntities;
				   >>
;





//revise, some useless computation

pcDataWord!                                                              
  [char* prefix, bool* containsEntities] > [char* text]
:                                 
                                   << 
				      bool mightBeEntity=false; 
				      char* val=0; 
				      bool semiSeen=false; 

                                        
				      char* temp;
				      
                                      $text = (char *) calloc(1,sizeof(char)); //dummy assignment
				      $text[0] = '\0';
				     //$text = "";
				      
				      *containsEntities = false;
				      
				      bool use_pcdataword_buf = true;
				   >>
      
  { TXT_AMP                        <<// printf("A\n");
  
                                      //cache type in local
				      int type = LT(2)->getType();
				      
                                      if( type != TXT_WORD && type !=  TXT_WORD_NEEDS_CONVERSION &&
					  type !=  TXT_LT && type !=  C_STRING ){
					  
					  
				          consume();
													  
				          if ( prefix ){
				              if(strlen(prefix) <= PCDATAWORD_BUFFER_LENGTH){ 
					          strcpy(pcdataword_buf, prefix);
					          strcat(pcdataword_buf, "&");
					          return pcdataword_buf;
					      }
					      else{
					          $text = (char *) calloc(strlen(prefix) + 1 + 1, sizeof(char));
					          strcpy($text, prefix);
				                  strcat($text, "&");
					          return $text;
					      }
			                  }
					  else{
					      pcdataword_buf[0] = '&';
					      pcdataword_buf[0] = '\0';
					      return pcdataword_buf;
					  }
					  
					  
				      }
				      else{
				      
				          mightBeEntity = true;
				      }
                                   >>
  }

  
  ( 
   (
     a:TXT_WORD                     << 
                                     // printf("B\n");				       
				      //temporary solution only
				      #ifndef ML_ONLY  
				      
				      //had weird bug when trying to do this within DFA
				      //a DFA solution will be much fater than rescanning each string
				      char* escaped;

				      //try to save "some" computing
				      if((escaped = escape_double_quotes($a->getText())) != NULL){
                                          $a->setText(escaped);
				          free(escaped);
				      }
				      
				      #endif
				   >>
    |
   
     b:TXT_WORD_NEEDS_CONVERSION   << *containsEntities = true;  //used in an altered sense
     
                                     // printf("B\n");
				   >>
     
    |
     c:TXT_LT                     // << printf("B\n"); >>   
    |
     d:C_STRING                   // << printf("B\n"); >>
   
    ) 				    
     
    { TXT_SEMI                     <<// printf("C\n"); 
    
                                      semiSeen = true;
                                      //assume: entity references are made up of ascii letters
                                      if ( mightBeEntity && docType->expand ) {
				      
				          val = (*docType->expand)($a->getText());
					  
					  *containsEntities = true;
					  
					  #ifndef ML_ONLY  
				          if(*val == '\"'){
					      val = "\\\"";
					  }
					  #endif
					  
					  
			              }
				      
				      use_pcdataword_buf = false;
                                   >>
    }
                                   <<// printf("D\n"); 
				   
				   
				      if ( prefix ) { 
				    
				        //  printf("Here prefix is G%sG\n", prefix);
				          temp = (char*) calloc(strlen($text) +  
						                strlen(prefix) + 
			                                        1
						                , 
							        sizeof(char)
							        );
					  /*			
					  //is this order wrong?? probably
					  		   
				          strcpy(temp, $text);			   
				          strcat(temp, prefix);
					  */
					  
					  strcpy(temp, prefix);			   
				          strcat(temp, $text);
					  
					 			   
                                          if($text){
					      free($text);
					  } 
				          $text = temp;
					  
					//  use_pcdataword_buf = false;
 
                                      }
				      
                                      if ( val ) {
                                        
                                          // 2DO - this has to be recursively parsed, but how do we
                                          // resync parser and scanner? (PM)
					  
                                          temp = (char*) calloc(strlen($text) +  
						                strlen(val) + 
			                                        1
						                , 
							        sizeof(char)
							        );
							   
				          strcpy(temp, $text);			   
				          strcat(temp, val);			   
                                          if($text){
					      free($text);
					  } 
				          $text = temp;
					  
					  use_pcdataword_buf = false;
				          
                                      }
                                      else {
                                        if ( mightBeEntity ){ 
					
					   
					   temp = (char*) calloc(strlen($text) +  
						                 1 + 
			                                         1
						                 , 
							         sizeof(char)
							        );
							   
				           strcpy(temp, $text);			   
				           strcat(temp, "&"); 			   
                                           if($text){
					       free($text);
					   } 
				           $text = temp;
					   
					   use_pcdataword_buf = false;
 
					 
					}
					
					char* texT;
					
					if($a != NULL){
					    texT = $a->getText();
					}
					else if($b != NULL){
					    texT = $b->getText();
					  //  printf("TEXT is %s\n", texT);
					}
					else if($c != NULL){
					    texT = $c->getText();
					}
					else{
					    texT = $d->getText();
					}
					 
					
					
					
					if(!use_pcdataword_buf && ( strlen($text) + strlen(texT) 
					                            < PCDATAWORD_BUFFER_LENGTH  )
					  ){
					
					    temp = (char*) calloc(strlen($text) +  
						                  strlen(texT) + 
			                                          1
						                  , 
							          sizeof(char)
							         );
							   
				            strcpy(temp, $text);			   
				            strcat(temp, texT); 			   
                                            if($text){
					        free($text);
					    } 
					    
				            $text = temp;
					    
					}
					else{
							
					    
					    strcpy(pcdataword_buf, $text);
					    strcat(pcdataword_buf, texT);
					    
					    if($text){
					        free($text);
					    } 

					    $text = pcdataword_buf;
					}
					
					
					
                                       
                                        if ( semiSeen ){ 
					    temp = (char*) calloc(strlen($text) +  
						                  1 + 
			                                          1
						                  , 
							          sizeof(char)
							         );
							   
				            strcpy(temp, $text);			   
				            strcat(temp, ";"); 			   
                                            if($text){
					        free($text);
					    } 
				            $text = temp;
					 
					}
					else if(mightBeEntity){
					    //weird: should be $text + 1 
					    val = (*docType->expand)($text + 2);
					    if(strcmp(val, $text + 2)){
					    
					      *containsEntities = true;
					      
					      pcdataword_buf[0] = val[0];
					      pcdataword_buf[1] = '\0';
					    
					      $text = pcdataword_buf;
					    }
					}
                                      }
                                   >>
  )                               
 | 
  TXT_SEMI                       <<   //printf("E\n");
  
                                      if ( prefix ) { 
				        
                                        temp = (char*) calloc(strlen($text) +  
						              strlen(prefix) + 
			                                      1
						              , 
							      sizeof(char)
							     );
					/*		   
				        strcpy(temp, $text);			   
				        strcat(temp, prefix); 			   
                                        */
					strcpy(temp, prefix);			   
				        strcat(temp, $text);

					
					
					if($text){
					    free($text);
					} 
				        $text = temp;
				      }
				      else{
				         temp = (char*) calloc(strlen($text) +  
						              1 + 
			                                      1
						              , 
							      sizeof(char)
							     );
							   
				         strcpy(temp, $text);			   
				         strcat(temp, ";"); 			   
                                         if($text){
					     free($text);
					 } 
				         $text = temp;
			              }		  
				   >>
  				   
				   
;





attr
   //[int nodelevel]
:                                  
                                   // 2DO - we probably should turn EVENT_TAG into a
                                   // semantic predicate, and move it to docType (PM)
				   
   (                               << inEventScript = true; >>
    
    (EVENT_ATTR ASSIGN DQUOTE)?
    
      EVENT_ATTR^                  <<// inEventScript = true;  
                                          
                                      
                                   >>
      ASSIGN!                      
      DQUOTE!
      (
        XML_EVENT_HANDLER
       |
        script
      )                            << inEventScript = false; 
                              
			           >>
      DQUOTE!
     |
     
      EVENT_ATTR^                  << 
                                      //needed ???
                                      inEventScript = true;  
                                      //still need to go to script mode
                                   >>
      ASSIGN!                      
     //do same as for with quotes when done with setFocus problem
      script                       << inEventScript = false; 
                              
			           >>
   )
  |( c:XML_TAG^                   // << #c->nodelevel =  nodelevel; >> 
      { ASSIGN!                    << inAttribute = true; 
                                     
                                   >>
        {  d:XML_STRING             
         | 
	   (
	    e:XML_TAG              

	    (ASSIGN!               // yes, attribute values can have = in them. Watch out when ends in a = 
	     {f:XML_TAG!           <<
	                             // printf("tag is %s\n", $f->getText());   
	                        
	                              char* temp = (char*) calloc(strlen($e->getText()) + 
				                                  strlen($f->getText()) + 
								  1 + // =
								  1   
								  ,
				                                  sizeof(char)
								 );
				      strcpy(temp, $e->getText());
				      strcat(temp, "=");
				      strcat(temp, $f->getText());
				      $e->setText(temp);
				      free(temp); 
				      
				     // printf("overall tag is now %s\n", $e->getText()); 
				        
	     	                   >>
	     }			   
	    )* 
	   
	   )
			                // << printf("got attribute %s\n", $e->getText()); >> 
        }                          << inAttribute = false; 
	                             
	                           >>
      }
                                   
    )
;

 


   
scripTNode                                                              
:                                  << 
                                      char* src;
				      
				      #if defined KAFFELIB && ! defined ML_ONLY
                                     	char* filename;				
                                        bool external_source = false;
					                                      
				      #endif
                                   >>
   SCRIPT_TAG^                     << 
                                      #if defined KAFFELIB && ! defined ML_ONLY
                                      
				        hasScript = true; 
				      
				      #endif 
				   >> 
   ( b:XML_TAG                     << 
                                      #if defined KAFFELIB && ! defined ML_ONLY
				      
                                        if(!strcasecmp($b->getText(), "src")){
                                          external_source = true; 
                                        }
					
                                      #endif
                                   >>
     ASSIGN!                       << inAttribute = true; >>
    
     ( 
       c:XML_STRING                << src = $c->getText(); >>
      |
       d:XML_TAG                   << src = $d->getText(); >>
     )   
      		                   << 
				      #if defined KAFFELIB && ! defined ML_ONLY 
				      
				        if(external_source){
					
					  if($c != NULL){
					      filename =  (char*) calloc(strlen(src) - 1, sizeof(char));
                                              strcpy(filename, src + 1);
                                              filename[strlen(src) - 2] = '\0';
					  }
					  else{
					      filename = src;
					  }
                                                                                                                                                          
                                          jclass xsengine = Genv->FindClass("kaffe.xs.XsEngine"); CheckException();
                                          jmethodID getRelative = Genv->GetStaticMethodID(xsengine, "getRelative",
                                                                                        "(Ljava/lang/String;)Ljava/io/InputStream;"); CheckException();
                                          SrcInputStream = Genv->CallStaticObjectMethod(xsengine, getRelative, Genv->NewStringUTF(filename));       
                                          CheckException();  // take out if put in commented out code                                  
                                          
					    
                                          if(SrcInputStream == NULL){
                                              warn("could not fetch file specified by src attribute, ignored");
                                          }
                                        
                                          /*
                                          jthrowable e;
                                          if(e = Genv->ExceptionOccurred()){
                                            printf("Exception Occurred\n");
                                            jclass malformedurlE =  Genv->FindClass("java.net.MalformedURLException"); CheckException();
                                          
                                            jclass IOE =  Genv->FindClass("java.io.IOException"); CheckException();

                                          
                                            if(Genv->IsInstanceOf(e, malformedurlE))
                                              warn("src attribute file not found, ignored"); // correct action ?
                                            else if(Genv->IsInstanceOf(e, IOE))
                                              warn("network error, src attribute ignored");
                                            
                                            SrcInputStream = NULL;  //already true, take out    
                                          }
                                          */
                                        }
					
                                      #endif
                                      
                                      inAttribute = false;
                                   >>
    
   )*
   XML_CLOSE!                       << 
                                      #if defined KAFFELIB && ! defined ML_ONLY
				      
				        if(SrcInputStream != NULL){
                                          scanner->saveState(&saved_state);
                                          DLGJavaInputStream isinput(Genv, SrcInputStream); 
                                          scanner->setInputStream(&isinput);
                                        }
					
                                      #endif
                                   >>
                                     
                                      
   script                          <<
                                      #if defined KAFFELIB && ! defined ML_ONLY
				      
                                        if(SrcInputStream != NULL){
                                          SrcInputStream = NULL;
                                        }
                                        if(external_source && $d == NULL){
                                          free(filename);
                                        }
					
                                      #endif    
                                   >>

   {                               //made this optional since some sites have  //--></SCRIPT> !!!!!!
    SCRIPT_END!                    
   }
   (TXT_SKIP!)*                                  
;




metaNode!                                                                
:
   XML_TAG//^
   ( XML_TAG
     ASSIGN//!
     DQUOTE//!       // if ever allow unquoted attr val, recheck the XML_TAG pattern, about exclusion/inclusion of ?
     XML_TAG
     DQUOTE//!
   )*
   XML_META_CLOSE//!
;



   
dtdNode!                                                                 
:
   a:XML_TAG//^                      
                                   << inAttribute = true; 
                                     // printf("GOT TAG %s\n", $a->getText());
                                   >>
   (
    ( c:XML_TAG                     // << printf("GOT TAG %s\n", $c->getText()); >> 
      {
       ASSIGN//!
       XML_STRING
      }
     | 
      XML_STRING                 
    )*
    //all the following prompted by mapquest.com
   |                             
    (ASSIGN//!
     XML_STRING
    ) 
   )                                
   XML_CLOSE//! 
   (TXT_SKIP//!
   )*                              << inAttribute = false; /* goes up one line ?? */ >>
;







//ML_ONLY_END








/******************************************************************************
 * Parser part B - XoeScript
*/


script                                                                  
:                                  << 
                                     out_attr_t r = oNONE; 
				     
				      
				     
				     #ifdef KAFFELIB
                                     
				         hasScript = true; 
				     
				     #endif
                                   >>                             
    //leave function ambuiguity in -> more efficient (when have nested functions)
    ( function 
    | statement [iNONE] > [r]      
    )*
;
//exception reached top, bail out ?

exception catch MismatchedToken : << fprintf(stderr, "Parsing exception: MismatchedToken at line %d\n", scanner->line()); >>
          catch NoViableAlt :     << fprintf(stderr, "Parsing exception: NoViableAlt at line %d\n", scanner->line()); >>
          default :               << fprintf(stderr, "Parsing exception at line %d\n", scanner->line()); >>



     
      
        
function                                                                
                                      
:                                  << out_attr_t r = oNONE; 
                                      
                                   >>
    
    functioN:FUNCTION^             
    f:ID                           << 
                                      char* id = $f->getText(); 
    
                                      addVar(id, T_FUNC, #functioN); 
				     // printf("GOT fucntion ID %s\n", $f->getText());
				      incLevel();
				   
				      if(getLevel() > 1){ //if nested
				          CallStackRequired = true;
				      }
				      //but how about locals for nested functions
				      /*else{
				          CallStackRequired = false; //reset value 
				      }*/
					    
				      #functioN->localsym = current;
				      
				      #functioN->nargs = 0;
				      
				      
				      fprintf(bodies_file, "%s/_%s = ", clsName, id); 
    

				      inFunctionBody = true;
				      
				   >>
    LPAREN!
    { a:ID                         << 
                                      addVar($a->getText(), T_PROP, #a);
				      #a->level = 1;
				      #a->formal = true;
				      #functioN->nargs = 1;
                                   >>
      ( COMMA!
        b:ID                       << 
	                              //what about multiple formal declarations?  
	                              addVar($b->getText(), T_PROP, #b);
				      #b->level = 1;
				      #b->formal = true;
				      #functioN->nargs++;
                                   >>
      )*                           
    }
    RPAREN!                        <<  
                                      //create a dummy node, to help symbol management
                                      AST* args_node = new AST(ID, "arguments");
				      args_node->offset = 1;
				      args_node->level = 1;
                                      addVar("arguments",/*T_DARR*/T_PROP, args_node);
				   >>
				   
    block [iNONE] > [r]				   
				   
                                   << 
				      //printf("LT(1) = %s\n", LT(1)->getText());
				   
				      //must backtrack the bodies_file by one token
                                        					
			              if(LT(1)->getType() == NEWLINE){
					  fseek(bodies_file,  (-1 * (2 + 1)) * sizeof(char) , SEEK_CUR);
			              }
			              else if(LT(1)->getType() != TEOF){
					  int len = strlen(LT(1)->getText());
					  
					  fseek(bodies_file,  (-1 * (len + 1)) * sizeof(char) , SEEK_CUR);
				          
					  for(int i = 0; i < len; i++){
					     fprintf(bodies_file, " "); 
					  }   
				      }
					
			              fprintf(bodies_file, "\n");				
								      
				      inFunctionBody = false;
				   
				   
				   
				      // printf("function 0 r = %d\n", r);
                                      if( !otest(r,oRET) ){
                                        //function does not statically pessimistically return
                                        
					((AST*) #0)->return_undef_required = true;
                                      }
				      else{
				        //needed ??
                                        ((AST*) #0)->return_undef_required = false;                                  
                                      }
				      
				      //but how about locals for nested functions
				      //disabled becasue of bug in
				      // http://i.cnn.net/cnn/virtual/2000/code/main.js
				      //to be fixed after implementing fully
				    //  #functioN->CallStackRequired = CallStackRequired;
				       
				      if(getLevel() == 1){
				           CallStackRequired = false;
                                      }                                     
                                       
				      //TEST
				      // #functioN->CallStackRequired = true;
				        
				       
				      decLevel();
				  >>
;

exception catch NoViableAlt:
          catch MismatchedToken : <<  
	                             
	      
                                    // printf("function 1 r = %d\n", r);
                                      //does the following ever get executed
                                     if(LT(1)->getType() == RBRACE){
                                       
				       int len = strlen(LT(1)->getText());
				       
				       fseek(bodies_file,  (-1 * (len + 1)) * sizeof(char) , SEEK_CUR);
				       
				       for(int i = 0; i < len; i++){
					     fprintf(bodies_file, " "); 
				       }
				        					
			               fprintf(bodies_file, "\n");
				       				
								      
				       inFunctionBody = false;
                                       
                                       
                                       if( !otest(r,oRET) ){
                                         //function does not statically pessimistically return
                                         ((AST*) #0)->return_undef_required = true;
                                       }
                                       else{
                                         ((AST*) #0)->return_undef_required = false;                                  
                                       }
                                       
				    //   #functioN->CallStackRequired = CallStackRequired;
				       
				       if(getLevel() == 1){
				           CallStackRequired = false;
                                       }                                     
                                       decLevel();
				       
				       
				       consume();
                                      			                                      
                                     } 
				    /* else{
				         *$_retsignal = $_signal;
				       }*/	 
                                  >>




block                                                                  
  [in_attr_t ia] > [out_attr_t oa]
  
:                                  << $oa = oNONE;>>
  
    LBRACE^                         //???? related to IF ELSE  indicate that it is a block, otherwise ambiguity if put one in if else                       
    ( statement [ia] > [$oa]       
    )*
    RBRACE                         // must indicate end of statemnt list since next one is also a stmt
;  
exception catch NoViableAlt:
          catch MismatchedToken :  << // printf("block \n");
                                      if(LT(1)->getType() == RBRACE){
                                        consume();
                                      }  
                                   >>
				   



statement                                                               
  [in_attr_t ia] > [out_attr_t oa]

:                                  << $oa = oNONE; >>

    SC^                            
|   ifStatement [ia] > [$oa]       
|   forStatement [ia] > [$oa]
|   whileStatement [ia] > [$oa]
|   doWhileStatement [ia] > [$oa]
|   breakStatement [ia] > [$oa]
|   continueStatement [ia] > [$oa]
|   switchStatement [ia] > [$oa]
|   withStatement [ia] > [$oa]
|   returnStatement [ia] > [$oa]
|   block [ia] > [$oa]
|   tryStatement [ia] > [$oa]
|   throwStatement [ia] > [$oa]
//|   javaSection
|   (ID COLON)? labeledStatement [ia] > [$oa]
|   varOrExprStatement [ia] > [$oa]
//|   function
;
exception catch NoViableAlt :
          catch MismatchedToken : <<               
                                    				    
				   // printf("stmt \n");
				    
				    if(LT(1)->getType() == RBRACE)
                                      *$_retsignal = $_signal;
                                    else{
                                      if(LT(1)->getType() != TEOF){
				        
					consume();
					warn("Syntax error, stmt ignored");
					
                                      }
				      
				      #0 = new AST(SC, ";");
				    } 
				    
				  >>



ifStatement                                                             
  [in_attr_t ia] > [out_attr_t oa]

:                                  << out_attr_t r1 = oNONE, r2 = oNONE; cond_attr_t ca = cNONE; // unused in static comp
                                      $oa=oNONE; 
				      ia = iunlabeled(ia);
                                   >>

    IF^                              
    condition > [ca]               
    statement [ia] > [r1]          
    { ELSE                         
      statement [ia] > [r2]            
    }                              << 
                                      if( otest(r1,oRET) && otest(r2,oRET) ){
                                          $oa = oadd($oa,oRET); 
                                      }
				   >>
;


whileStatement                                                          
  [in_attr_t ia] > [out_attr_t oa]

:                                  << cond_attr_t ca; out_attr_t r;
                                      $oa=oNONE;
                                   >> 
    
    whilE:WHILE^                   << 
                                      if(!itest(ia, iLBL)){
                                            addUnLabeled(#whilE); 
                                      }
					
				      ia = iunlabeled(ia);
				   >>
    condition > [ca]               
    statement [iloop(ia)] > [r]    <<
                                      
                                      if ( ctest(ca,cNEVER) ){
                                        //setPos(pos); // roll back
                                        warn("while will never execute, ignored");
                                      }
                                      else if ( ctest(ca,cALWAYS) ){
                                        if ( otest(r,oRET) ){
                                          $oa = oadd($oa,oRET);
                                        }
                                      }
                                   >>
;


doWhileStatement                                                       
  [in_attr_t ia] > [out_attr_t oa]

:                                  << cond_attr_t ca = cNONE; $oa=oNONE; >>
    
    dO:DO^                         << 
                                      if(!itest(ia, iLBL)){
                                            addUnLabeled(#dO); 
                                      }
					
				      ia = iunlabeled(ia);
				   >>     
    statement [iloop(ia)] > [$oa]   
    WHILE!                          
    condition > [ca]
    SC!                             
;


switchStatement                                                         
  [in_attr_t ia] > [out_attr_t oa]

:                                  << bool hasDefault=false;
                                      out_attr_t r = oNONE; $oa=oNONE;
                                      int all_return = 1;
                                      int ncases = 0;
                                   >>
   
    switcH:SWITCH^                 << 
                                      if(!itest(ia, iLBL)){
                                            addUnLabeled(#switcH); 
                                      }
					
				      ia = iunlabeled(ia);
				   >>                      
    condExpression
    
    LBRACE!                        
     
    ( CASE! c:CONST COLON!           
      ( statement [icase(ia)] > [r]
                                   
      )*                           << 
                                      if ( otest(r,oRET)){ 
                                        all_return &= 1;
                                         
                                      }
                                      else if ( !otest(r,oCNT) && !otest(r, oBRK) ) { 
                                        all_return &= 1;  //status depends on the next one
                                        
                                      } 
                                      else if(otest(r, oCNT)){ // but then break qualifies if has a label!
                                        all_return &= 0;
                                                                            
                                      }
                                      else{
                                        all_return &= 0;
                                        
                                      }
				      
				      ncases++;
      
                                   >>
    )*
    { DEFAULT COLON!               <<  hasDefault=true; >>
      ( statement [icase($ia)] > [r]
                                   
      )*                           << 
      
                                      if ( otest(r,oRET)){ 
                                        all_return &= 1; 
                                        
                                      }
                                      else if(otest(r, oCNT)){ // but then break qualifies if has a label!
                                        all_return &= 0;
                                                                           
                                      }
                                      else{
                                        all_return &= 0;
                                        
                                      }
				      
				      ncases++;
                                   >>
    }                              
    RBRACE!                         << 
                                      if ( hasDefault ){
                                        if(all_return){
                                          $oa = oadd($oa,oRET);
                                        }
                                      }
				      
				     // #switcH->nlabels = ncases - 1;
				     // #switcH->label_numbers = (int*) calloc(#switcH->nlabels, sizeof(int));
                                   >>
;


breakStatement                                                          
  [in_attr_t ia]  > [out_attr_t oa]

:                                  << AST* label;
            
	                              $oa = oNONE;
				      
				      NoLineTerminatorHere = true;
				      
                                      if (!itest($ia,iBRK)){
                                        warn("break not allowed here, ignored");
                                        consumeUntilToken(SC); consume();
					
                                        delete #0;
					
					#0 = new AST(SC, ";");
					
					return $oa;
                                      }
				      
				   >>
				   
  
    b:BREAK^                       << #b->labelThere = false; >>
    { a:ID!                        << if(!(label = getLabelNode($a->getText()))){
                                        warn("label %s not found, ignored", $a->getText());
				      }
                                      else {
                                        #b->link = label;
					#b->labelThere = true;
                                      }
				   >>
    }                              <<
                                      if(!#b->labelThere){
				        #b->link = getFirstLabelNode();
					
					if(#b->link->type() == SWITCH){
					    //zap it virtually
					    #b->ignore = true;
					} 
				      }
				   >> 
    SC!                             
                                   
;


continueStatement                                                       
  [in_attr_t ia]  > [out_attr_t oa]

:                                  << 
                                      AST* label;
				      
				      $oa = oNONE;
                                      
				      NoLineTerminatorHere = true;
				      
				      if (!itest($ia,iCNT)){
                                        warn("continue not allowed here, ignored");
                                        consumeUntilToken(SC); consume();
					
					delete #0;
																				                                        
					#0 = new AST(SC, ";");                                        
					
					return $oa;
                                      }
				   >>
				   
 
    b:CONTINUE^                    << #b->labelThere = false; >>       
    { a:ID!                        << if(!(label = getLabelNode($a->getText()))){
                                        warn("label %s not found, ignored", $a->getText());
				      }
                                      else {
                                        #b->link = label;
					#b->labelThere = true;
                                      }
				   >>
    }                              <<
                                      if(!#b->labelThere){
				        #b->link = getFirstLabelNode();
				      }
				   >> 

    SC!                             
                                   
;




//fix  in dyn comp, when doing full implement of , operator etc
withStatement                                                           
  [in_attr_t ia]  > [out_attr_t oa]

:                                  << $oa = oNONE; 
                                       ia = iunlabeled(ia); 
                                   >>

    WITH^                          << CallStackRequired = true; >>    
    LPAREN!   
    expression                     
    RPAREN!
    statement [ia] > [$oa]         
;




//check out the closeParen(); thing maybe necessary in !hasExpr
returnStatement                                                        
  [in_attr_t ia]  > [out_attr_t oa]

:                                   << $oa = oNONE; 
                                       NoLineTerminatorHere = true;
				    >>  

    RETURN^                         
    { exp:expression                   
    }                              
    SC!                             << if (#exp == 0){
                                         if (getLevel() > 0){
                                           // all but toplevel returns must have a value
                                           AST* temp = new AST(UNDEF, "undefined");
	 
	                                   #0->setDown(temp);
                                         }
                                       }
				       else{
				         if (getLevel() == 0){
					   warn("return value not allowed, ignored");
					   #0->setDown(NULL);
					 }
				       }
                                      
                                       $oa = oadd($oa,oRET);
                                    >>
;
exception catch NoViableAlt :
          catch MismatchedToken : <<  // printf("In return\n");   
	           
                                      
			 	       if (LT(1)->getType() == RBRACE || 
				           LT(1)->getType() == DQUOTE /* event handlers*/){
				       //  printf("RBRACE exp: %p\n", #exp);
                                       						 
					 if (#exp == 0){
                                             if (getLevel() > 0){
                                                 // all but toplevel returns must have a value
                                                 AST* temp = new AST(UNDEF, "undefined");
	 
	                                         #0->setDown(temp);
                                             }
                                         }
				         else{
				             if (getLevel() == 0){
					         warn("return value not allowed, ignored");
					         #0->setDown(NULL);
					     }
				         }

					                                         
					 $oa = oadd($oa,oRET);
                                       }
                                       else{
				         *$_retsignal = $_signal;
				       }	 				       
			          >>





forStatement                                                            
  [in_attr_t ia]  > [out_attr_t oa]
  
:                                    << out_attr_t r; cond_attr_t ca = cNONE; $oa=oNONE;>>

 foR:FOR^                            << 
                                        if(!itest(ia, iLBL)){
                                            addUnLabeled(#foR); 
                                        }
					
					ia = iunlabeled(ia);
				     >>                          
 LPAREN!
  
 (
   (variablesOrExpression IN)?
  
   forin
 
  |
   
   forinit
                        
 ) 
 
 RPAREN!
 statement[iloop(ia)] > [r]              << /*                                                                            
                                      if ( ctest(ca,cNEVER) ){
                                       // set_sbuf(before);
                                       // setPos(pos); // roll back
                                      }
                                      else if ( ctest(ca,cALWAYS) ){
                                        if ( otest(r,oRET) ){ 
                                          $oa = oadd($oa,oRET); 
                                        }
                                       // mergeb(blocals, bfor);
                                      //  mergeb(before,blocals);
                                       // set_sbuf(before);
                                      }
                                      else{
                                       // mergeb(blocals, bfor);
                                       // mergeb(before,blocals);
                                       // set_sbuf(before);
                                      }
                                      */
                                   >> 
 
;  



forin
:
  variablesOrExpression   //not exact, see grammar
  IN^                         
  expression
;




forinit!
:                                  <<// bool conditionThere = false; // replace by testing a pointer
                                      
                                      /*
				      $ca=cNONE;
                                      
                                      if ( LT(2)->getType() == SC ){
                                        if ( LT(1)->getType() == TTRUE ){
                                          $ca = cadd($ca,cALWAYS);
                                        }
                                        else if ( LT(1)->getType() == TFALSE ){
                                          $ca = cadd($ca,cNEVER);
                                        }
                                      }
                                      else if(LT(1)->getType() == SC) 
                                        $ca = cadd($ca,cALWAYS);
				      
				      */
                                   >>     

  {var:variablesOrExpression       
  }                              
   
  
  sc1:SC                              
  { exp1:expression             
  }             
  sc2:SC                         
  { exp2:expression 
  }                              << if(#var == NULL){
				      if(#exp1 == NULL){
				        #0 = #(#[SC, ";"], #[SC, ";"], #[SC, ";"], #exp2);
				      }
				      else{
				        #0 = #(#[SC, ";"], #[SC, ";"], #exp1, #[SC, ";"], #exp2);
				      }
				    }
				    else{
				      if(#exp1 == NULL){
				        #0 = #(#[SC, ";"], #var, #[SC, ";"], #[SC, ";"], #exp2);
				      }
				      else{
				        #0 = #(#[SC, ";"], #var, #[SC, ";"], #exp1, #[SC, ";"], #exp2);
				      } 
				    } 
				 >>
 


;




tryStatement                                                            
  [in_attr_t ia]  > [out_attr_t oa]

:                                  << out_attr_t r; char* xid; $oa = oNONE; ia = iunlabeled(ia);>>
    TRY^                            
    LBRACE!                         
    ( statement [ia] > [$oa] 
    )*
    RBRACE!                         
    ( CATCH                        
      LPAREN! a:ID RPAREN!         << xid = $a->getText();
                                      
                                   >>
      LBRACE!                       
      ( statement [ia] > [r]
      )*
      RBRACE!                       
    )*
    { FINALLY                      
      LBRACE!                       
      ( statement [ia] > [r]       << if ( isDeadEnd(r) ){
                                        // finally always gets executed, unreachable
                                        $oa = oadd($oa,r);
                                      }
                                   >>
      )*
      RBRACE!                       
    }
;

// mUST somehow make sure exception is of proper type
throwStatement                                                         
  [in_attr_t ia]  > [out_attr_t oa]

:                                  << $oa = oNONE; 
                                      NoLineTerminatorHere = true;
				   >>
    THROW^                          
    expression
    SC!                             
;



condition                                                              
  > [cond_attr_t ca]

:                                  << $ca=cNONE; >>
    LPAREN!                        << 
                                      // TODO: too trivial, push this down to expr
                                      if ( LT(3)->getType() == RPAREN ){
                                        if ( LT(2)->getType() == TTRUE ){
                                          $ca = cadd($ca,cALWAYS);
                                        }
                                        else if ( LT(2)->getType() == TFALSE ){
                                          $ca = cadd($ca,cNEVER);
                                        }
                                      }
                                      
                                   >>
    expression
    RPAREN!                         
;

    
labeledStatement                                                        
  [in_attr_t ia] > [out_attr_t oa]
:                                  <<  $oa = oNONE; 
                                       ANTLRTokenType tt;
				       bool label_added = false;
				   >>
   a:ID 
   COLON^                          << tt = LT(2)->getType();
                                      // for now we ignore all non-loop contruct labels
                                      if ( (tt==FOR) || (tt==WHILE) || (tt==DO) ){
                                        if(!addLabel($a->getText(), #a)){
                                          warn("Duplicate label, ignored"); // what to do to patch? take the closest def of label instead?
                                        }
					else{
					  label_added = true;
					}
				      }
                                      else{
                                        warn("Label %s ignored", $a->getText());
                                      }
                                   >>
/*stmt:*/statement[ilabeled(ia)] > [$oa] << 
                                          if(label_added){
                                              removeLabel();
					  }
					  
				        //  #0 =  #stmt;  //when taking away labeledStmt in tree parser
					>>                            
;

   
varOrExprStatement                                                      
  [in_attr_t ia]  > [out_attr_t oa]

:                                   << $oa = oNONE; >>    
   
   var:variablesOrExpression  SC^                                                              
                                    
  
;

exception catch NoViableAlt:
          catch MismatchedToken :   << // printf("In varOrExprStatement\n LT(-1) = %d, LT(0) = %d, LT(1) = %d\n", 
	                               //                         LT(-1)->getType(),LT(0)->getType(),LT(1)->getType() ); 
	  
	  
		                    //   printf("In varOrExprStatement\n");
	
				      			      
                                      /* 
				       if (LT(1)->getType() == RBRACE){
                                         *$_retsignal = $_signal;
                                       }
                                       else{
                                         //consume();
                                         //closeParen(); out(";"); 
                                       }
				       */
				     // delete #var; 
				      // #var->tfree();
				      
				      
				       
				       //patch AST
				       #0 = #(#[SC, ";"], #var);
				       
				       				       
                                    >>




variablesOrExpression                                                   
:      
   ( VAR^
     variable
      ( COMMA!                      
        variable
      )*
    )
|   expression

;
exception catch NoViableAlt:
          catch MismatchedToken :   << 
	                                // maybe have different handlers for expression and for VAR etc
	  
	                                //resetPos at beg of stmt
					
	                             //   printf("In variablesOrExpression \n");
					
				//	warn("Syntax error, stmt ignored");
	                               // printf("In variablesOrExpression LT(1)->getType() = %d", LT(1)->getType() ); 
	  
		                        /* try to manage such things as
					  var a, b, *u, g;
					   so that still get g
					  */ 
				
	                                // not certain this is usefull yet
                                        consumeUntil(VAR_END_set);
					consume();
                                    >>




variable                                                                
:                                  << char* id; >>

    a:ID                           << id = $a->getText();
    
                                      int curlevel;
                                      
				      if ( (curlevel = getLevel()) == 0 ){     // global var
				       
					#a->level = 0; //assign to this in previous test ??
				      
                                        if(!isVarAtLevel(id)){
					  addVarTable(reset.localsym, id, T_PROP, #a);
					 // addFieldHandle(#a);
					}
					else{
					  #a->ignore_decl = true;
					  #a->local_or_global = GLOBAL;
					}
					
				      }
                                      else {                 // in function
				      
				        #a->level = curlevel;
				      
                                        if(!isVarAtLevel(id)){
                                          addVar(id,T_PROP, #a);
					}
					else{
					  #a->ignore_decl = true;
					  #a->local_or_global = LOCAL;
					}
					
                                      }

                                   >>
				   
    { ASSIGN^                      << #a->nextIsAssignOp = true; >>            
      assignmentExpression 
    }

;



//tree incorrect when have COMMA
expression                          				                                        
:                                 
                                  /* the follolwing fails on
                                        function f(){
                                          if(8)
                                            return 5;
                                          else
                                            return ;
                                        }
                                     
				     don't remember what this wanted to fix

                                  <<  
                                      bool saved_NoLineTerminatorHere =  NoLineTerminatorHere; 
                                      NoLineTerminatorHere = false;
				  >>        
				  */           
   assignmentExpression                   
   ( COMMA^                         
     assignmentExpression
   )*                            // <<  NoLineTerminatorHere = saved_NoLineTerminatorHere; >>
  
;


assignmentExpression                                                  
:                                    
   condExpression                     
     
   {ASSIGNMENT_OP^             
    assignmentExpression          
   }                                       
; 


condExpression                                                          
:  
   
   logOrExpression 
   { COND^                          
     assignmentExpression
     COLON!                         
     condExpression                // this should be assignmentExpression, but first fix ambiguity
   }
 
;



logOrExpression                                                         
:// need expression evaluator
   logAndExpression                
   ( LOG_OR^                      
     logAndExpression              
   )*
;


logAndExpression                                                        
:// need expression evaluator
   bitOrExpression                
   ( LOG_AND^                     
     bitOrExpression               
   )*
;


bitOrExpression                                                         
:
   bitXorExpression
   ( OR^                          
     bitXorExpression              
   )*
;


bitXorExpression                                                        
:
   bitAndExpression
   ( XOR^                         
     bitAndExpression              
   )*
;

   
bitAndExpression                                                       
:
   equalExpression
   ( AND^                         
     equalExpression               
   )*
;


equalExpression                                                         
: 
   relationalExpression
   ( EQUALITY_OP^                 
     relationalExpression         
   )*
; 


relationalExpression                                                   
:
   shiftExpression
   ( RELATIONAL_OP^               
     shiftExpression               
   )*
;


shiftExpression                                                         
:
   addExpression
   ( SHIFT_OP^                  
     addExpression                 
   )*
;


addExpression                                                           
:                                  
   multExpression
   ( ADDITIVE_OP^                             
     multExpression                
   )*                              
; 


multExpression                                                          
:
   a:unaryExpression
   ( MULTIPLICATIVE_OP^          
     b:unaryExpression                /* this does not work yet, try again later
     
                                        <<  #0->preorder();
                                           if(((AST*)#0->down())->type() == #b->type()){
                                                 
                                        
                                                printf("Same type\n");
						printf("prior text down is %s\n", ((AST*)#0->down())->getText());
				                char* temp = (char*) calloc(10, sizeof(char));
						sprintf(temp, "%d", atoi(((AST*)#0->down())->getText())
						*
						atoi(#b->getText())
                                                );
						
						#0->setDown(new AST(INT_CONST, temp));
					
						
						
						
						
						printf("after text down is %s\n", ((AST*)#0->down())->getText());
					  }				
						
				          #0->preorder();
		                       >>  */            
   )*
;




unaryExpression                                                        
: 
    ((MINUS^ | PLUS^)                         
     memberExpression[false]       
    ) 
   
     
      
|  

   ( memberExpression[false]        <<  
                                       // printf("Next token is %d, then %d\n", LT(0)->getType(), LT(1)->getType()); 
                                        //this does not work
				/*	if(set_el(LT(2)->getType(), INCREMENT_OP_set)){
					  NoLineTerminatorHere = true; //maybe need to signal it before
					}*/
			             >>
      { inc:INCREMENT_OP^            << #inc->pre_or_post = POST; >>     
      }
    )
    
  |  (TYPEOF LPAREN)?                //netscape addition
     TYPEOF^                         
     LPAREN!
     unaryExpression
     RPAREN!                         
         
  | ( op:UNARY_OP^                   <<  
                                        #op->pre_or_post = PRE; // meaningless for other than ++ and --
                                     >>  
      unaryExpression              
    )
  | ( DELETE^                        // need expression evaluator ???
      unaryExpression )            
  
;



memberExpression
  [bool isMember]
:
  //store a boolean, nextIsPut ? do in this pass look at source to source
                                   << bool callHasArgs = false; >>

   primaryExpression[isMember]                                            
   
   ( lbrack:LBRACK^                << #lbrack->array_kind = ARRAY_REFERENCE; >>
     assignmentExpression          //should be expression, when dealt with commas                               
     RBRACK!                       << 
                                      if (set_el(LT(2)->getType(), ASSIGNMENT_OP_set)){
				        #lbrack->nextIsAssignOp = true;
				      }  
     
                                   >> 

   )*                                 
   { (DOT ID)?                     //ambiguity: a.(8) versus a.b
     DOT^                           
     memberExpression[true]           
   }
   { 
     lparen:LPAREN^                          
     { assignmentExpression        << callHasArgs = true; >>  
       ( COMMA!                      
         assignmentExpression        
       )* 
     }
     RPAREN!                       << #lparen->callHasArgs = callHasArgs; >>
   }
;




callArguments                                                           
:                                  << bool callHasArgs = false; >>

   lparen:LPAREN^                          
 
   { assignmentExpression          << callHasArgs = true; >>       
     ( COMMA!                      
       assignmentExpression        
     )* 
   }
   RPAREN!                         << #lparen->callHasArgs = callHasArgs; >>    
;





primaryExpression                                                       
  [bool isMember]
:                                  << char* id; int lvl; int vtype; 
                                      //only IDs allowed on the left hand-side 
                                      //but (a) = 4; is OK!!!
                                      /*if(LT(1)->getType() != ID 
                                             && ( isAssignOp(LT(2)->getType()) ||
                                                   LT(2)->getType() == LPAREN  )){
                                          warn("parse error, left-value required");
                                        }*/
					
				      bool callHasArgs = false;
				      
				      bool ignoreAllArgs = false;
                                   >>
                                   
   ( LPAREN!                        
     expression
     RPAREN!                        
   )                               
    
| objectLiteral

| arrayLiteral

| NUM_CONST                   
  
| b:ID                            << 

                                      id = $b->getText(); 
				      
				      lvl = varLevelt(id, &vtype);

                                      #b->isMember = isMember; 

                                      int curlevel;
				      /*
				      if(!strcmp(id, "CNNcookieDate")){
				      int i = 6;
				      
				      }
*/
                                      if (set_el(LT(2)->getType(), ASSIGNMENT_OP_set)){
				      
				        #b->nextIsAssignOp = true;
					
                                        // property/var assignment
                                        if (!isMember ) {
                                          if ( lvl < 0 ){ // not yet def
                                            if ( (curlevel = getLevel()) ==0 ) {
                                              // define it as top variable
                                              addVarTable(reset.localsym, id, T_PROP, #b);
					      #b->level = 0;
					     
                                            }
                                            else{
                                              //addVar(id, T_PROP, #b);
					      #b->level = curlevel;
					    }
                                          }
                                          else { // a var
                                            if ( (curlevel = getLevel()) == 0 ){
                                              #b->local_or_global = GLOBAL;
					      #b->ignore_decl = true; 
					      #b->level = 0;
					      
                                            }
                                            else {
                                              #b->local_or_global = LOCAL;
					      #b->level = curlevel;
                                            }
                                          }
                                        }
                                        else { // a prop
                                            
					}
                                      }
                                      else if ( LT(2)->getType() == LPAREN ){ 
                                                        // a call
							
					if(!strcmp(id, "eval") ||
					   !strcmp(id, "call") 
					  )
				        {
					     CallStackRequired = true;
					}
					
					
					//lack of support for reg exps	
					//problem: try out yahoo.com/s/1955			
					if(!strcmp(id, "replace") ||
					   !strcmp(id, "match")   ||
					   !strcmp(id, "split")/*&&
					   isMember*/
					  )
				        { // printf("HERE\n");
					   ignoreAllArgs = true;
					}	
					
							
								
                                        if ( !isMember ){
					 //is the following still valid ??
					 //all calls now go through call so can setup call stack, function properties, etc
					 
				            #b->level = getLevel();
					    
					  
					}
                                        else {
                                         
                                        }
                                      }
                                      else {
				     
				       				        
                                        // just a ref, no assignment
                                        if (!isMember){ 
					 
					  if ( lvl < 0 ){ // not yet def
					 
                                            if ( (curlevel = getLevel()) == 0 ) {
                                              // define it as top variable
                                              addVarTable(reset.localsym, id, T_PROP, #b);
					      #b->level = 0;
					     // addFieldHandle(#b);
					    }
					    else{
					     // addVar(id, T_PROP, #b);
					      #b->level = curlevel;
					    //  addFieldHandle(#b);
					    }
					    
					  }
					  else{
					  
					     
					    if ( (curlevel = getLevel()) == 0){
					  
					      #b->level = 0;
					      
					      if(!strcmp(id, "top") || 
					         !strcmp(id, "window") || 
						 !strcmp(id, "parent") || 
						 !strcmp(id, "document") || 
						 !strcmp(id, "frames")  ||
						 !strcmp(id, "navigator")
					        )
					      {
					       	#b->ignore_decl = true;
						#b->local_or_global = GLOBAL;
					      } 	
						  
		                            }
					    else{
					   
					      #b->level = curlevel;
					      #b->local_or_global = LOCAL;
					    }
					    															 					 					 
														                                           
					  } 
					    
					      
						  
                                        }
                                        else {
                                          
                                        }
                                      }
				      
				      
				      
                                   >>
    {lparen:LPAREN^                <<
                                      if( ignoreAllArgs){
				        // printf("HI HERE LT(1) = %d, LT(2) = %s\n", LT(1)->getType(), LT(2)->getText());
				         //temporary solution
					 consumeUntilToken(RPAREN);
					//  printf("HI HERE LT(1) = %d, LT(2) = %s\n", LT(1)->getType(), LT(2)->getText());
				      
				      }  	  
    
	                           >>           
 
     { assignmentExpression        << callHasArgs = true; >>    
       ( COMMA!                      
         assignmentExpression        
       )* 
     }
     RPAREN!                       << 
                                      #lparen->callHasArgs = callHasArgs; 
				   >>
    }				   


    exception catch NoViableAlt:
              catch MismatchedToken : << //printf("in ID type is %d, next is %d, then %d\n",LT(0)->getType(),
	                                 //LT(1)->getType(),LT(2)->getType()
					 
					// );
	                                if(LT(0) && LT(0)->getType() == COMMA){ // ex: f(8,)
				            consumeUntilToken(RPAREN);
					    consume();
			                    return;
				        }
				        else{
				            *$_retsignal = $_signal;
				        }	                           
				      >>
				   

| STRING_CONST                 
| TFALSE                       
| TTRUE                        
| TNULL                        
| g:TTHIS                          <<
                                      if(getLevel() == 0){
				          #g->local_or_global = GLOBAL;
				      }
				      else{
				          #g->local_or_global = LOCAL;
				      }
				   >>		                     
				   
| NEW^
  constructor
  

//| functionEXP    

;
                                         



constructor                                                             
:                                  << char* id = NULL; >>
    (  TTHIS                       
     | a:ID                        << id = $a->getText();
     
                                      if ( isVar(id) ) {
				      
                                        if(!strcmp(id, "Object"))
                                          id = "_Object";
                                        else if(!strcmp(id, "Array"))
                                          id = "_Array";
                                        else if(!strcmp(id, "Date"))
                                          id = "_Date";
                                        else if(!strcmp(id, "Boolean"))
                                          id = "_Boolean";
                                        else if(!strcmp(id, "String"))
                                          id = "_String";
					else if(!strcmp(id, "Number"))
                                          id = "_Number";
					else if(!strcmp(id, "Function"))
                                          id = "_Function";  
					
					//this test unnecessary??    
					if(id != NULL){  
                                          #a->setText(id);
					}
					
				      }
				    >>
    // had static prop here				    
    )
    ( DOT! 
      c:ID                     
    
    )*
    //argument list is optional
    { callArguments          
    }                              
                                   
;



objectLiteral                                                           
: 
                                  << bool hasLiteral = false; >>                                  
    lbrace:LBRACE^                         
    { a:ID COLON!                 << hasLiteral = true; >>                 
      assignmentExpression        
      ( COMMA!                      
        b:ID COLON!                 
        assignmentExpression 
      )*                           
    }                                 
    RBRACE!                       << #lbrace->hasLiteral = hasLiteral; >>                        
;




arrayLiteral:                                                          

                                   << bool hasLiteral = false; 
				      int item_number = 0;
				   >> 
   ( lbrack:LBRACK^                << #lbrack->array_kind = ARRAY_LITERAL; >>
   
     { {a:assignmentExpression     << hasLiteral = true; 
                                      #a->item_number = item_number;
                                   >>
       }                           << item_number++; >>
       
       ( COMMA!                    
         {b:assignmentExpression   << hasLiteral = true;
	                              #b->item_number = item_number;  
	                           >>
	 }                         << item_number++; >>     
       )*                          
     }
     RBRACK!                       << 
                                      #lbrack->hasLiteral = hasLiteral; 
                                      #lbrack->item_flags = (bool*) calloc(item_number, sizeof(bool));
				      #lbrack->n_items = item_number;
                                   >>
   )
;



/*
functionEXP:
                                    << out_attr_t oa; >>
 
 //named
 function                           << CallStackRequired = true; >>                    

|  
  //anonymous 

  FUNCTION                          << CallStackRequired = true; >>      
  LPAREN
  { ID                              
    ( COMMA
      ID                              
    )*                           
  }
  RPAREN                       				   
  block [iNONE] > [oa]
;

*/







//Interpreter ********************************************************
                                                                        

//try to have global handles so don't need to get them again and again




call! > [jobject ret]
:

(functionCall > [$ret]

|
 constructorCall > [$ret]
)

{SC}

;
/*
exception default :               << #ifdef KAFFELIB
	                             longjmp(jmpbuffer, 1); //return with failure
				     #endif
				  >> 
*/

tweakedExpression! > [jobject object]
:  <<
     #ifdef KAFFELIB 

     jclass xsobjectclass = Genv->GetObjectClass(Gcontext); CheckException();
     
     jmethodID mid = Genv->GetMethodID(xsobjectclass, "xsGet",  
                                       "(Ljava/lang/Object;)Lkaffe/xs/XsObject;"); CheckException();
                                       
     #endif                                    
   >>

// member expression
((ID|TTHIS) DOT)?

   ( id:ID                <<#ifdef KAFFELIB
                            $object =  Genv->CallObjectMethod(Gcontext, mid, Genv->NewStringUTF($id->getText())); CheckException();
                            #endif
                          >> 
    | 
     TTHIS                <<#ifdef KAFFELIB 
                            $object = GxThis;
                            #endif
                          >> 
   )
   (
     DOT
     dottedid:ID          <<#ifdef KAFFELIB
                            $object = Genv->CallObjectMethod($object, mid, Genv->NewStringUTF($dottedid->getText())); CheckException();
                            #endif
                          >> 
   )*

|  constructorCall > [$object]

|  (ID (DOT ID)* LPAREN)?

   functionCall > [$object]

|  primaryExpressionE > [$object] 

;


constructorCall! > [jobject object]
:  
  << 
     jobject temp;
     #ifdef KAFFELIB
     jclass clazz = Genv->FindClass("kaffe.xs.XsArray"); CheckException();
     
     jmethodID push = Genv->GetMethodID(clazz, "push", "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsArray;"); CheckException();

     jmethodID pushs =  Genv->GetStaticMethodID(clazz, "pushs", "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsArray;"); CheckException();

     jobject xsarray =  NULL;
     #endif
     
  >>

  NEW
  id:ID                           
  LPAREN                     
  {
   addExpressionE > [temp]       <<#ifdef KAFFELIB
                                   xsarray = Genv->CallStaticObjectMethod(clazz, pushs,  temp); CheckException();
                                   #endif
                                 >> 
   ( COMMA                 
     addExpressionE > [temp]     <<#ifdef KAFFELIB  
                                   xsarray = Genv->CallObjectMethod(xsarray, push, temp); CheckException();
                                   #endif
                                 >> 
     )*
   }
   RPAREN 

   << 
   
      #ifdef KAFFELIB
      jclass xthis = Genv->GetObjectClass(GxThis); CheckException();
    
      jmethodID xsGet = Genv->GetMethodID(xthis, "xsGet", "(Ljava/lang/String;)Lkaffe/xs/XsObject;"); CheckException();
      
      jobject handle = Genv->CallObjectMethod(GxThis, xsGet, Genv->NewStringUTF($id->getText())); CheckException();

      
      jclass xsfunc =  Genv->FindClass("kaffe.xs.XsFunc"); CheckException();

      jmethodID callCtor;
      

      if(xsarray != NULL){ // some arguments

        callCtor = Genv->GetMethodID(xsfunc, "callCtor", "(Lkaffe/xs/XsObject;Lkaffe/xs/XsArray;)Lkaffe/xs/XsObject;"); CheckException();
 
        $object = Genv->CallObjectMethod(handle, callCtor, Gcontext, xsarray); //CheckException();
       
       
        /* putting this one in causes a weird bug, investigate 
	
           on input
	   var a = eval('new Function("return 6;")');
	  
	   same when have arguments, below
	  
           CheckException(); 
	   
	*/
       
      }
      else{
      
        callCtor = Genv->GetMethodID(xsfunc, "callCtor", "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;"); CheckException();

        $object = Genv->CallObjectMethod(handle, callCtor, Gcontext); //CheckException();
       
      }
      #endif
   >>
;





addExpressionE! > [jobject object]
:
   <<
     jobject returned;
    
     jclass returnedclass;
     jmethodID mid;
   >>


   multExpressionE  > [returned]    <<   $object = returned; >>  
   (
    op:ADDITIVE_OP
    multExpressionE > [returned]    <<   #ifdef KAFFELIB
                                         returnedclass = Genv->GetObjectClass($object); CheckException();

                                         ANTLRTokenType op_type = op->getType();
                      
                                         if(op_type == PLUS){
                                                mid = Genv->GetMethodID(returnedclass, "plus", 
                                                                        "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;"); CheckException();
                                         }
                                         else if(op_type == MINUS){
                                                mid = Genv->GetMethodID(returnedclass, "minus", 
                                                                        "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;"); CheckException();
                                         }

                                         $object = Genv->CallObjectMethod($object, mid, returned); CheckException();
                                      
                                         #endif
                                    >>   
   )*

;






multExpressionE! > [jobject object]
:
   <<
     jobject returned;
    
     jclass returnedclass;
     jmethodID mid;

   >>


   tweakedExpression  > [returned]    << $object = returned; >>  
   (
    op:MULTIPLICATIVE_OP
    tweakedExpression > [returned]    << 
                                         #ifdef KAFFELIB
                                         returnedclass = Genv->GetObjectClass($object); CheckException();

                                         ANTLRTokenType op_type = op->getType();
                      
                                         if(op_type == MUL){
                                                mid = Genv->GetMethodID(returnedclass, "mul", 
                                                                        "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;"); CheckException();
                                         }
                                         else if(op_type == DIV){
                                                mid = Genv->GetMethodID(returnedclass, "div", 
                                                                        "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;"); CheckException();
                                         }
                                         else if(op_type == MOD){
                                                mid = Genv->GetMethodID(returnedclass, "mod", 
                                                                        "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsObject;"); CheckException();
                                         }
                                        
                                         $object = Genv->CallObjectMethod($object, mid, returned); CheckException();
                                         #endif 
                                      >>   
   )*

;




functionCall! > [jobject ret]
:   <<
       jobject temp;
       #ifdef KAFFELIB
       
       jclass clazz = Genv->FindClass("kaffe.xs.XsArray"); CheckException();

       jmethodID push = Genv->GetMethodID(clazz, "push", "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsArray;"); CheckException();

       jmethodID pushs =  Genv->GetStaticMethodID(clazz, "pushs", "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsArray;"); CheckException();
       #endif
       jobject xsarray =  NULL;
       
       int nids = 0;
       int max_ids = 2;
       char** ids = (char**) calloc(max_ids, sizeof(char*)); 
       
       bool hasTop = false;
       
    >>
 
    a:ID                           << if(!strcmp("top", $a->getText()))
                                        hasTop = true;
                                      ids[nids++] = StrDup($a->getText()); 
				     // printf("HERE 0\n");
                                   >>
    (DOT 
     b:ID                          << if(nids == max_ids){
                                        // grow array 
                                        int newMaxIds = max_ids + 10;
                                        char** new_ids = (char**) calloc(newMaxIds, sizeof(char*));
                                        memcpy( new_ids, ids, max_ids * sizeof(char*));
                                        free(ids);
                                        ids = new_ids;
                                        max_ids = newMaxIds;
                                      }
                                        
                                      ids[nids++] = StrDup($b->getText());
                                   >>
    )*
    LPAREN                         
    {
     addExpressionE > [temp]       <<#ifdef KAFFELIB
                                     xsarray = Genv->CallStaticObjectMethod(clazz, pushs,  temp); CheckException();
                                     #endif
                                    >> 
     ( COMMA                 
       addExpressionE > [temp]     <<#ifdef KAFFELIB                                         
                                     xsarray = Genv->CallObjectMethod(xsarray, push, temp); CheckException();
                                     #endif
                                   >> 
     )*
    }
    RPAREN 
                            
    <<
      #ifdef KAFFELIB
      int i; 
  // printf("HERE 1\n");
      jclass xsobjectclass = Genv->FindClass("kaffe.xs.XsObject"); CheckException();
      
      jmethodID xsget = Genv->GetMethodID(xsobjectclass, "xsGet", "(Ljava/lang/String;)Lkaffe/xs/XsObject;"); CheckException();

      jobject caller;
      
      if(!hasTop){
        caller = Gcontext;
      
        for(i = 0; i < nids - 1; i++){
          caller = Genv->CallObjectMethod(caller, xsget, Genv->NewStringUTF(ids[i])); CheckException();
        }
      }
      else{//printf("HERE 2\n");
        jfieldID topID = Genv->GetStaticFieldID(xsobjectclass, "top", "Lkaffe/xs/XsObject;"); CheckException();
        // printf("HERE 3\n");
        caller = Genv->GetStaticObjectField(xsobjectclass, topID); CheckException();
       // printf("HERE 4\n");
        for(i = 1; i < nids - 1; i++){
          caller = Genv->CallObjectMethod(caller, xsget, Genv->NewStringUTF(ids[i])); CheckException();
        }
//	printf("HERE 5\n");
      }                 
                        
      if(xsarray != NULL) // some arguments
        $ret = Genv->CallObjectMethod(caller, Gmethod_args, Genv->NewStringUTF(ids[nids - 1]), xsarray); 
      else
        $ret = Genv->CallObjectMethod(caller, Gmethod_no_args, Genv->NewStringUTF(ids[nids - 1])); 
      
      CheckException(); 
       
     // printf("HERE 6\n");
     
      //release strings                                    
      for(i = 0; i < nids; i++)
        free(ids[i]);
	
      free(ids); 	
      
     // printf("HERE 7\n");
      
      #endif    
    >>
         
;    
 


primaryExpressionE! > [jobject object]
:                                 
    <<
      jclass clazz;
      jmethodID  CtorId;
      jfieldID   fieldID;
    >>
  

    ( LPAREN                    
      addExpressionE > [$object]
      RPAREN 
    )                  

|   arrayLiteralE  > [$object]

|   num:NUM_CONST
                 
                  <<  #ifdef KAFFELIB
                      clazz = Genv->FindClass("kaffe.xs.XsNumber"); CheckException();

                      if($num->getType() == INT_CONST){ 
                        CtorId = Genv->GetMethodID(clazz, "<init>", "(I)V"); CheckException();
                        $object = Genv->NewObject(clazz, CtorId, (jint) atoi($num->getText())); CheckException();
                      }
                      else{
                        //this does not work
                        jdouble number =  (jdouble) atof($num->getText()); 
                      
                        CtorId = Genv->GetMethodID( clazz, "<init>", "(D)V"); CheckException();

                      //  printf("Value is %f\n",  number);

                        $object = Genv->NewObject( clazz, CtorId, number); CheckException();
 
                       // printf("Got object\n");
                      }
                      #endif
                  >> 

//indexed array
|  ( ID LBRACK)? 
 arrayName:ID
           LBRACK
           index:INT_CONST
           RBRACK            << jobject array; 
                                #ifdef KAFFELIB   
                                jclass xsobjectclass = Genv->GetObjectClass(Gcontext); CheckException();
                                jmethodID mid = Genv->GetMethodID(xsobjectclass, "xsGet",  
                                                         "(Ljava/lang/Object;)Lkaffe/xs/XsObject;"); CheckException();
                                //might miss an exception here
                                array =  Genv->CallObjectMethod(Gcontext, mid, Genv->NewStringUTF($arrayName->getText())); CheckException();
                                 
                                jclass xsarrayC = Genv->FindClass("kaffe.xs.XsArray"); CheckException();
                                 
                               
                                mid =  Genv->GetMethodID(xsarrayC, "xsGet", "(I)Lkaffe/xs/XsObject;"); CheckException(); 

                                $object =  Genv->CallObjectMethod(array, mid, (jint) atoi($index->getText())); CheckException();
                                #endif
                             >>


|       id:ID     <<  #ifdef KAFFELIB 
                      jclass xsobjectclass = Genv->GetObjectClass(Gcontext); CheckException();
                      jmethodID mid = Genv->GetMethodID(xsobjectclass, "xsGet",  
                                                         "(Ljava/lang/Object;)Lkaffe/xs/XsObject;"); CheckException();
                           
                      
                      $object =  Genv->CallObjectMethod(Gcontext, mid, Genv->NewStringUTF($id->getText())); CheckException();
                      #endif
                  >>                   

|       string:STRING_CONST <<
                              //strip '' or ""
                              char* temp =  (char*) calloc(strlen($string->getText()) + 1, sizeof(char));
                              strcpy(temp, $string->getText());
                              temp[strlen($string->getText()) - 1] = '\0';
                              $string->setText(temp + 1);
			      
			      //put in when can test it
			      //free (temp);
                              
                              #ifdef KAFFELIB
                              clazz = Genv->FindClass( "kaffe.xs.XsString"); CheckException(); 

                              CtorId = Genv->GetMethodID( clazz, "<init>", "(Ljava/lang/String;)V"); CheckException();

                              $object = Genv->NewObject( clazz, CtorId, Genv->NewStringUTF($string->getText())); CheckException(); 
                              #endif
                            >>
|       TFALSE              << #ifdef KAFFELIB
                               clazz = Genv->FindClass( "kaffe.xs.XsObject"); CheckException();
                               fieldID =  Genv->GetStaticFieldID(clazz, "xFalse", "Lkaffe/xs/XsObject;"); CheckException(); 
                               $object =  Genv->GetStaticObjectField(clazz, fieldID); CheckException();
                               #endif
                            >>      
|       TTRUE               << #ifdef KAFFELIB
                               clazz = Genv->FindClass( "kaffe.xs.XsObject"); CheckException();
                               fieldID =  Genv->GetStaticFieldID(clazz, "xTrue", "Lkaffe/xs/XsObject;"); CheckException(); 
                               $object =  Genv->GetStaticObjectField(clazz, fieldID); CheckException();
                               #endif
                            >>            
//|     TNULL                     
|       TTHIS               << #ifdef KAFFELIB
                               $object = GxThis; 
                               #endif
                            >>


                                  
;




arrayLiteralE! > [jobject object]
:
    <<#ifdef KAFFELIB
      jobject xsarray =  NULL;
       
      jclass xsarrayC = Genv->FindClass("kaffe.xs.XsArray"); CheckException();

      jfieldID ArrayID =  Genv->GetStaticFieldID(xsarrayC, "Array", "Lkaffe/xs/XsFunc;"); CheckException();
                                           
      jobject Array =  Genv->GetStaticObjectField(xsarrayC, ArrayID); CheckException();
       
      jclass xsfuncC = Genv->FindClass("kaffe.xs.XsFunc"); CheckException();
     
      jmethodID callCtor_args = Genv->GetMethodID(xsfuncC, "callCtor", "(Lkaffe/xs/XsArray;)Lkaffe/xs/XsObject;"); CheckException();
      jmethodID callCtor_no_args = Genv->GetMethodID(xsfuncC, "callCtor", "()Lkaffe/xs/XsObject;"); CheckException();
  
      jmethodID push = Genv->GetMethodID(xsarrayC, "push", "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsArray;"); CheckException();
      jmethodID pushs =  Genv->GetStaticMethodID(xsarrayC, "pushs", "(Lkaffe/xs/XsObject;)Lkaffe/xs/XsArray;"); CheckException();
      #endif
      jobject temp; 
    >> 

  
     
    LBRACK                   
    { addExpressionE  > [temp]     <<#ifdef KAFFELIB 
                                     xsarray = Genv->CallStaticObjectMethod(xsarrayC, pushs,  temp); CheckException();
                                     #endif
                                    >>
      ( COMMA                  
        addExpressionE > [temp]    <<#ifdef KAFFELIB
                                     xsarray = Genv->CallObjectMethod(xsarray, push, temp); CheckException();
                                     #endif
                                   >> 
      )*                      
    }
    RBRACK                    
    
    <<#ifdef KAFFELIB 
      if(xsarray != NULL){
         $object = Genv->CallObjectMethod(Array, callCtor_args, xsarray); CheckException();    
      }
      else{
         $object = Genv->CallObjectMethod(Array, callCtor_no_args); CheckException();
      }
      #endif
    >>



;






/******************************************************************************
 * Parser part C - Java inserts (just simple literal copy for now)
 */
/*
javaSection                                                             
:                                  << char* sym; int dontBreak=0; int sep=0; >>
  JAVA_START                       
  (
      a:KEYWORD                    << out("%s", $a->getText()); sep=1;>>
    | b:ID                         << if ( sep ){  out(" "); }
                                      out("%s", $b->getText()); sep=1;
                                   >>
    | c:STRING_CONST               << //allow XoeScript strings within Java
                                      char * temp = NULL;
                                      if($c->getText()[0] == '\''){
                                        temp =  (char*) calloc(strlen($c->getText()) + 1, sizeof(char));
                                        strcpy(temp, $c->getText());
                                        temp[strlen($c->getText()) -1] = '\"';
                                        temp[0] = '\"';
                                        $c->setText(temp);
                                      }

                                      out("%s", $c->getText());
                   
                                      if(temp != NULL){ free(temp); }
                                   >>
    | d:NUM_CONST                  << out("%s", $d->getText()); >>
    | e:OPERATOR                   << out("%s", $e->getText()); sep = 0; >>
    | f:SYMBOL                     << sym = $f->getText(); sep = 0;
                                      if ( *sym == '{' ) {
                                        incInd();
                                        lout("{"); ln();
                                      }
                                      else if ( *sym == '}' ){
                                        decInd();
                                        out("}"); ln();
                                      }
                                      else if ( *sym == ';' ){
                                        out(";");
                                        if ( !dontBreak ) ln();
                                      }
                                      else {
                                        if ( *sym == '(' ){
                                          dontBreak=1;
                                        }
                                        else if ( *sym == ')' ){
                                          dontBreak=0;
                                        }
                                        out("%s", sym);
                                      }
                                   >>
  )*
  JAVA_END                         << out("//--------- end Java"); ln(); >>
;
*/


//ML_ONLY_START

}

//ML_ONLY_END
