/*
 * create parent-child table for HTML checks
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * @author Peter Mehlitz
 * @author Philippe Laporte
 * 
 * $tvt: create_ht_pc.c,v 1.31 2001/10/24 20:24:44 philippe Exp $
 */

#include "ht.h"
#include "bmatrix.h"

/*
 * this function is used to generate the parent-child map of HTML tags
 * (we don't need it in the compiler)
 */
 
 
void createPCmatrix ()                                                 /*{{{*/
{
	bit_matrix_t* a = createBitMatrix(105, 105); 


	setRowBits(a, HTML_A, 49, 
		   HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6, HTML_BR, HTML_SPACER, HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT
		   , HTML_NOBR // prompted by www.cbc.ca
		   , HTML_STYLE
		   , HTML_COMMENT,HTML_BASEFONT
		   );
		   
	setRowBits(a,HTML_ABBR, 49, 
	           HTML_BR, HTML_SPACER,HTML_WBR, HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,
		   HTML_STYLE,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   , HTML_COMMENT,HTML_BASEFONT
		   );
		   
	setRowBits(a,HTML_ACRONYM, 49, 
	           HTML_BR, HTML_SPACER,HTML_WBR,HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, 
		   HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,
		   HTML_STYLE,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   , HTML_COMMENT,HTML_BASEFONT
		   );
	setRowBits(a,HTML_ADDRESS, 71, 
	           HTML_HR, HTML_ILAYER, HTML_MARQUEE,HTML_BGSOUND, HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, HTML_NOBR,
		   HTML_STYLE, HTML_COMMENT
		   );
		   
	setRowBits(a, HTML_APPLET,  73, 
	           HTML_PARAM, HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND,HTML_ADDRESS, HTML_ISINDEX, HTML_BASEFONT, 
		   HTML_BLOCKQUOTE, HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EM, HTML_SAMP, HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, HTML_NOBR,
		   HTML_STYLE
		   , HTML_COMMENT
		   );
	setRowBits(a,HTML_AREA, 1, HTML_SCRIPT);
	setRowBits(a,HTML_B, 51, 
	           HTML_BR,HTML_SPACER,HTML_WBR, 
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,
		   HTML_INPUT  //prompted by yahoo.com/s/1955
		  // , HTML_B // prompted by www.cnn.com
		   , HTML_TABLE // prompted by www.cnn.com
		   , HTML_STYLE,HTML_BASEFONT
		   , HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   , HTML_NOBR //prompted by some place on yahoo.com
		   );
	setRowBits(a,HTML_BASE, 1, HTML_SCRIPT);
	setRowBits(a,HTML_BASEFONT, 72, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND,HTML_ADDRESS, HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U , HTML_SCRIPT, HTML_NOBR,
		   HTML_STYLE
		   , HTML_COMMENT
		   );
		   
	setRowBits(a,HTML_BDO, 50, HTML_BR,HTML_SPACER, HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, HTML_NOBR,
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
		   
	setRowBits(a,HTML_BGSOUND, 1, HTML_SCRIPT);
	   
		   
	setRowBits(a,HTML_BIG, 50, HTML_BR,HTML_SPACER,HTML_WBR, 
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, HTML_NOBR,
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
	setRowBits(a,HTML_BLINK, 50, HTML_BR,HTML_SPACER, HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN,HTML_NOBR, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
	   
	setRowBits(a,HTML_BLOCKQUOTE,  71, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND,HTML_ADDRESS, HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, HTML_NOBR,
		   HTML_STYLE, HTML_COMMENT
		   );
		   
	setRowBits(a,HTML_BODY, 73, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND,HTML_ADDRESS, HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, HTML_NOBR
		   ,HTML_LINK  //prompted by news.bbc.co.uk
		   ,HTML_STYLE , HTML_COMMENT
		   );
		   
	setRowBits(a,HTML_BR,1 
	          //   HTML_TEXT_  // prompted by yahoo.com (the taking out)
		   ,  HTML_SCRIPT  //probalby should take out as well 
	          // , HTML_A // prompted by yahoo.com
		  // , HTML_TABLE // prompted by yahoo.com
		  
		   );
		   
	setRowBits(a,HTML_BUTTON, 72, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, HTML_NOBR,
		   HTML_STYLE, HTML_COMMENT);
		   
	setRowBits(a,HTML_CAPTION, 80, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, 
		   HTML_SELECT, HTML_INPUT, HTML_BUTTON, HTML_TEXTAREA, HTML_LABEL, HTML_FIELDSET, 
		   HTML_LEGEND, HTML_NOBR
		   , HTML_LI 
		   , HTML_ADDRESS  
		   , HTML_STYLE 
		   , HTML_COMMENT
		   );
		   
	setRowBits(a,HTML_CENTER, 73, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, HTML_NOBR
		   , HTML_INPUT //prompted by slashdot.org
		   , HTML_STYLE , HTML_COMMENT
		   );
	setRowBits(a,HTML_CITE, 49, HTML_BR, HTML_SPACER, HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE , HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
	setRowBits(a,HTML_CODE, 49, HTML_BR,HTML_SPACER, HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE , HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
		   
	setRowBits(a,HTML_COL, 1, HTML_SCRIPT);
	
	setRowBits(a,HTML_COLGROUP, 2, HTML_COL , HTML_SCRIPT);
	
	setRowBits(a,HTML_COMMENT, 103, 0,1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,16,17,18,19,
	                              20,21,22,23,24,25,26,27,28,29,30,31,32,33,34,35,36,37,38,39,
				      40,41,42,43,44,45,46,47,48,49,50,51,52,53,54,55,56,57,58,59,
				      60,61,62,63,64,65,66,67,68,69,70,71,72,73,74,75,76,77,78,79,
				      80,81,82,83,84,85,86,87,88,89,90,91,92,93,94,95,96,97,98,99,
				      100,101,102);
	
		
	setRowBits(a,HTML_DD, 64, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_SCRIPT, HTML_NOBR,
		   HTML_STYLE , HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
          		   
	setRowBits(a,HTML_DEL, 64, HTML_BR,HTML_SPACER,HTML_WBR, 
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_SCRIPT, HTML_NOBR,
		   HTML_STYLE , HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
	setRowBits(a,HTML_DFN, 49, HTML_BR,HTML_SPACER,HTML_WBR, 
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE , HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
	setRowBits(a,HTML_DIR, 71, 
	           HTML_LI , HTML_SCRIPT,
		   HTML_UL, // prompted by http://gcc.gnu.org/onlinedocs/
		   HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U,  HTML_NOBR,
		   HTML_STYLE, HTML_COMMENT
                   );
	setRowBits(a,HTML_DIV,  76, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND,HTML_ADDRESS, HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, HTML_NOBR
		   , HTML_INPUT // prompted by mapquest.com should consider putting them all in 
		   , HTML_SELECT  //prompted by sex.com
		   , HTML_TEXTAREA
		   , HTML_LABEL 
	           , HTML_STYLE // prompted by news.bbc.co.uk 
		   , HTML_LI // prompted by www.cnn.com
		   , HTML_COMMENT
		   );
	setRowBits(a,HTML_DL, 4, HTML_DD, HTML_DT, HTML_SCRIPT, HTML_STYLE );
	setRowBits(a,HTML_DT, 2,  HTML_TEXT_,  HTML_SCRIPT );
		   
	setRowBits(a,HTML_EM, 49, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE , HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
	//I don't think embed should have any children... it's not listed as an element in the html spec
	setRowBits(a,HTML_EMBED, 67,
		   HTML_TEXT_,HTML_LI,HTML_A,HTML_ABBR,HTML_ACRONYM,HTML_ADDRESS,HTML_APPLET,HTML_B,HTML_BLINK,
		   HTML_BDO,HTML_BIG,HTML_BLOCKQUOTE,HTML_BR,HTML_SPACER,HTML_WBR,HTML_CENTER,HTML_CITE,HTML_CODE,
		   HTML_DEL,HTML_DIR,HTML_DIV,HTML_DL,HTML_EM, HTML_SAMP,HTML_FONT,HTML_FORM,HTML_FRAMESET,
		   HTML_H1,HTML_H2,HTML_H3,HTML_H4,HTML_H5,HTML_H6,HTML_HR,HTML_MARQUEE,HTML_BGSOUND,HTML_ADDRESS,HTML_I,HTML_ILAYER,HTML_IFRAME,
		   HTML_IMG,HTML_NOFRAMES,HTML_NOSCRIPT,HTML_OBJECT,HTML_OL,HTML_P,HTML_PRE,
		   HTML_Q,HTML_S,HTML_SAMP,HTML_SMALL,HTML_SPAN,HTML_STRIKE,HTML_STRONG,HTML_BASEFONT,
		   HTML_SUB,HTML_SUP,HTML_TABLE,HTML_MULTICOL, HTML_TT,HTML_U,HTML_UL,HTML_VAR, HTML_SCRIPT, HTML_NOBR,
                   HTML_STYLE , HTML_COMMENT  		   
		   );
	setRowBits(a,HTML_FIELDSET, 79, HTML_LEGEND, HTML_INPUT, 
		   HTML_HR,  HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND,HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EM, HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_FIELDSET, HTML_LABEL, HTML_SELECT, 
		   HTML_TEXTAREA, HTML_SCRIPT, HTML_NOBR,
		   HTML_STYLE , HTML_COMMENT
		   );
	setRowBits(a,HTML_FONT, 90,  
		   HTML_ABBR, HTML_ACRONYM, HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, 
		   HTML_Q, HTML_STRONG, HTML_VAR, HTML_TEXT_, HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, 
		   HTML_FONT, 
		   HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, HTML_A, HTML_P, 
		   HTML_LI
		   // , HTML_NOBR   //from slashdot.org
		   , HTML_DIV //prompted by http://news.bbc.co.uk/ 
		   , HTML_IFRAME //prompted by http://news.bbc.co.uk/
		   , HTML_BR //prompted by http://news.bbc.co.uk/
		   , HTML_IMG //prompted by http://news.bbc.co.uk/ and supported by jtidy
		   , HTML_NOBR //prompted by slashdot.org
		   , HTML_FORM //prompted by slashdot.org
		   , HTML_INPUT //prompted by http://dir.yahoo.com/News_and_Media/
		   , HTML_HR //prompted by http://auctions.yahoo.com/
		   , HTML_CENTER // prompted by http://www.amazon.com/o/dt/upda-1.0-pocketpc/subst/aa/upda/theat.html/107-6570798-4682127
		   , HTML_H1
		   , HTML_H2
		   , HTML_H3
		   , HTML_H4
		   , HTML_H5
		   , HTML_H6
		   , HTML_SELECT //prompted by yahoo.com/r/cr
		   , HTML_NOSCRIPT //prompted by yahoo.com/r/cr
		   , HTML_TABLE //prompted by www.cbc.ca
		   , HTML_STYLE 
		   , HTML_COMMENT
		   , HTML_SPACER,HTML_WBR,HTML_ADDRESS,HTML_BGSOUND,HTML_MARQUEE,HTML_ILAYER,HTML_BASEFONT
		   , HTML_TR, HTML_TH, HTML_TD, HTML_TABLE,
		     HTML_APPLET, HTML_BLOCKQUOTE, HTML_CAPTION, HTML_CENTER, HTML_DD, HTML_DEL, HTML_DIR, 
		     HTML_DL, HTML_DT, HTML_EMBED, HTML_ILAYER, HTML_INS, HTML_LAYER, HTML_MARQUEE, 
		     HTML_MENU, HTML_MULTICOL, HTML_NOBR, HTML_NOEMBED, HTML_NOFRAMES, HTML_NOSCRIPT,    
		     HTML_OBJECT, HTML_OL, HTML_PRE, HTML_SMALL, HTML_TBODY, HTML_TFOOT, HTML_THEAD,  
		     HTML_UL, HTML_WBR
		   );
		   
	setRowBits(a,HTML_FORM, 79,  
	           HTML_INPUT, HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, 
		   HTML_BASEFONT, HTML_BLOCKQUOTE,HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL,  HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_FIELDSET, HTML_LABEL, HTML_SELECT, 
		   HTML_TEXTAREA, HTML_SCRIPT, HTML_NOBR
		   , HTML_TD // for news.bbc.co.uk
		   , HTML_TR // prompted by www.yahoo.com/r/cr
		   , HTML_STYLE , HTML_COMMENT, HTML_BUTTON 
		   );
	setRowBits(a,HTML_FRAME, 2 , HTML_SCRIPT, HTML_COMMENT);
	setRowBits(a,HTML_FRAMESET, 5, HTML_FRAME, HTML_NOFRAMES, HTML_SCRIPT, HTML_FRAMESET, HTML_COMMENT);
	setRowBits(a,HTML_H1, 52, HTML_BR,HTML_SPACER, HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN,HTML_LI, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT
		   , HTML_UL, HTML_OL,HTML_BASEFONT
		   , HTML_STYLE , HTML_COMMENT,HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6, HTML_DEL, HTML_INS
		   );
	setRowBits(a,HTML_H2, 52, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, HTML_LI,
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT
		   , HTML_UL, HTML_OL,HTML_BASEFONT
		   , HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H3, HTML_H4, HTML_H5, HTML_H6 , HTML_DEL, HTML_INS
		   );
	setRowBits(a,HTML_H3, 52, HTML_BR,HTML_SPACER,HTML_WBR, 
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN,HTML_LI, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT
		   , HTML_UL, HTML_OL,HTML_BASEFONT
		   , HTML_STYLE , HTML_COMMENT,HTML_H1, HTML_H2, HTML_H4, HTML_H5, HTML_H6, HTML_DEL, HTML_INS
		   );
	setRowBits(a,HTML_H4, 52, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B, HTML_BLINK,HTML_LI,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT
		   ,HTML_UL, HTML_OL,HTML_H1, HTML_H2, HTML_H3, HTML_H5, HTML_H6
		   ,HTML_STYLE, HTML_COMMENT ,HTML_BASEFONT, HTML_DEL, HTML_INS
		   );
	setRowBits(a,HTML_H5, 52, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B, HTML_BLINK,HTML_LI,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT
		   ,HTML_UL, HTML_OL,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H6
		   ,HTML_STYLE , HTML_COMMENT,HTML_BASEFONT, HTML_DEL, HTML_INS
		   );
	setRowBits(a,HTML_H6, 52, HTML_BR,HTML_SPACER, HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, HTML_LI,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT
		   ,HTML_UL, HTML_OL,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5
		   ,HTML_STYLE , HTML_COMMENT,HTML_BASEFONT, HTML_DEL, HTML_INS
		   );
	setRowBits(a,HTML_HEAD, 17, HTML_TITLE, HTML_LINK, HTML_META, HTML_STYLE, HTML_SCRIPT, HTML_BASE
	           , HTML_MAP // for http://news.bbc.co.uk/
		   , HTML_A   // for http://www.cs.pdx.edu/~sanseri/kaffe/k2.html
		   , HTML_H1  // for http://www.cs.pdx.edu/~sanseri/kaffe/k2.html
		   , HTML_H2  
		   , HTML_H3 
		   , HTML_H4 
		   , HTML_H5 
		   , HTML_H6 
		   , HTML_P  // for http://www.cs.pdx.edu/~sanseri/kaffe/k2.html
		   , HTML_NOSCRIPT // prompted by sex.com
		   , HTML_COMMENT
		   );
	setRowBits(a,HTML_HR, 2, HTML_SCRIPT, HTML_COMMENT);
	setRowBits(a,HTML_HTML, 10
	           , HTML_HEAD, HTML_BODY, HTML_FRAMESET, HTML_SCRIPT, HTML_TITLE, HTML_NOFRAMES
		   , HTML_META // prompted by cbc.ca
		   , HTML_HTML // prompted by http://www.lineo.com/cgi-bin/rightnow
		   , HTML_STYLE
		   , HTML_COMMENT
		   );
		   
	setRowBits(a,HTML_I, 50, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, HTML_NOBR,
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U , HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
		   
	setRowBits(a,HTML_IFRAME, 80, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, 
		   HTML_SELECT, HTML_INPUT, HTML_BUTTON, HTML_TEXTAREA, HTML_LABEL, HTML_FIELDSET, 
		   HTML_LEGEND, HTML_NOBR
		   , HTML_LI 
		   , HTML_ADDRESS  
		   , HTML_STYLE 
		   , HTML_COMMENT

		   );
        
	setRowBits(a,HTML_ILAYER, 80, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, 
		   HTML_SELECT, HTML_INPUT, HTML_BUTTON, HTML_TEXTAREA, HTML_LABEL, HTML_FIELDSET, 
		   HTML_LEGEND, HTML_NOBR
		   , HTML_LI 
		   , HTML_ADDRESS  
		   , HTML_STYLE 
		   , HTML_COMMENT

		   );
	   
	setRowBits(a,HTML_IMG, 2 , HTML_SCRIPT, HTML_COMMENT);
	
	setRowBits(a,HTML_INPUT, 2 , HTML_SCRIPT, HTML_COMMENT);
	
	setRowBits(a,HTML_INS, 64, 
	           HTML_BR, HTML_SPACER,HTML_WBR,HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, HTML_LI,
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_SCRIPT, HTML_NOBR,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
		   
	setRowBits(a,HTML_ISINDEX, 2 , HTML_SCRIPT, HTML_COMMENT);
	setRowBits(a,HTML_KBD, 49, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE , HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
                  );
	setRowBits(a,HTML_LABEL, 74, HTML_INPUT, HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SELECT, HTML_TEXTAREA, 
		   HTML_SCRIPT, HTML_NOBR,
		   HTML_STYLE, HTML_COMMENT
		   );
        
	setRowBits(a,HTML_LAYER, 80, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, 
		   HTML_SELECT, HTML_INPUT, HTML_BUTTON, HTML_TEXTAREA, HTML_LABEL, HTML_FIELDSET, 
		   HTML_LEGEND, HTML_NOBR
		   , HTML_LI 
		   , HTML_ADDRESS  
		   , HTML_STYLE 
		   , HTML_COMMENT

		   );
	   
	setRowBits(a,HTML_LEGEND, 49, HTML_BR,HTML_SPACER,HTML_WBR, 
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
		   
	setRowBits(a,HTML_LI, 61, 
	           HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, 
		   HTML_FONT, 
		   HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL
		//   , HTML_FORM  //removal prompted by slashdot.org  this does not conform to HTML grammar
		   , HTML_MENU, HTML_OL, 
		 //  HTML_P,   //removal prompted by slashdot.org  this does not conform to HTML grammar
		   HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_SCRIPT, HTML_NOBR,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
		   
	setRowBits(a,HTML_LINK, 1 , HTML_SCRIPT);
	
	setRowBits(a,HTML_MAP, 3, HTML_AREA, HTML_SCRIPT, HTML_A);
	
	setRowBits(a,HTML_MARQUEE, 2, HTML_TEXT_, HTML_SCRIPT);
	
	setRowBits(a,HTML_MENU, 2, HTML_LI, HTML_SCRIPT);
	
	setRowBits(a,HTML_META, 1 , HTML_SCRIPT);
	
	setRowBits(a,HTML_MULTICOL, 80, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, 
		   HTML_SELECT, HTML_INPUT, HTML_BUTTON, HTML_TEXTAREA, HTML_LABEL, HTML_FIELDSET, 
		   HTML_LEGEND, HTML_NOBR
		   , HTML_LI 
		   , HTML_ADDRESS  
		   , HTML_STYLE 
		   , HTML_COMMENT

		   );
		   
        setRowBits(a,HTML_NOEMBED, 67, 
	           HTML_TEXT_,HTML_LI,HTML_A,HTML_ABBR,HTML_ACRONYM,HTML_ADDRESS,HTML_APPLET,HTML_B,HTML_BLINK,
		   HTML_BDO,HTML_BIG,HTML_BLOCKQUOTE,HTML_BR,HTML_SPACER,HTML_WBR,HTML_CENTER,HTML_CITE,HTML_CODE,
		   HTML_DEL,HTML_DIR,HTML_DIV,HTML_DL,HTML_EM, HTML_SAMP,HTML_FONT,HTML_FORM,HTML_FRAMESET,
		   HTML_H1,HTML_H2,HTML_H3,HTML_H4,HTML_H5,HTML_H6,HTML_HR,HTML_MARQUEE,HTML_BGSOUND,HTML_ADDRESS,HTML_I,HTML_ILAYER,HTML_IFRAME,
		   HTML_IMG,HTML_NOFRAMES,HTML_NOSCRIPT,HTML_OBJECT,HTML_OL,HTML_P,HTML_PRE,
		   HTML_Q,HTML_S,HTML_SAMP,HTML_SMALL,HTML_SPAN,HTML_STRIKE,HTML_STRONG,
		   HTML_SUB,HTML_SUP,HTML_TABLE,HTML_MULTICOL, HTML_TT,HTML_U,HTML_UL,HTML_VAR, 
		   HTML_SCRIPT, HTML_NOBR,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT
		   );	 
	  
	setRowBits(a,HTML_NOFRAMES, 80, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, 
		   HTML_SELECT, HTML_INPUT, HTML_BUTTON, HTML_TEXTAREA, HTML_LABEL, HTML_FIELDSET, 
		   HTML_LEGEND, HTML_NOBR
		   , HTML_LI 
		   , HTML_ADDRESS  
		   , HTML_STYLE 
		   , HTML_COMMENT

		   );
		   
	setRowBits(a,HTML_NOBR, 48, HTML_BR, HTML_SPACER,HTML_HR, HTML_ILAYER,HTML_MARQUEE, HTML_BGSOUND,HTML_ADDRESS,HTML_A, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_TEXT_, HTML_B,HTML_BLINK, HTML_LI,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, HTML_BASEFONT,
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, HTML_WBR
		   , HTML_FORM // prompted by slashdot.org
		   , HTML_NOSCRIPT // thought it should go there
		   , HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
        setRowBits(a,HTML_NOSCRIPT, 50, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, HTML_BASEFONT,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT
		   , HTML_INPUT // prompted by www.yahoo.com/r/cr
		   , HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
		   
	setRowBits(a,HTML_OBJECT, 81, HTML_PARAM, HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, 
		   HTML_SELECT, HTML_INPUT, HTML_BUTTON, HTML_TEXTAREA, HTML_LABEL, HTML_FIELDSET, 
		   HTML_LEGEND, HTML_NOBR
		   , HTML_LI 
		   , HTML_ADDRESS  
		   , HTML_STYLE 
		   , HTML_COMMENT
		   );
	setRowBits(a,HTML_OL, 71, 
	           HTML_LI , HTML_SCRIPT,
		   HTML_UL ,
		   HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U,  HTML_NOBR,
		   HTML_STYLE, HTML_COMMENT

		   );
	setRowBits(a,HTML_OPTGROUP, 2, HTML_OPTION, HTML_SCRIPT);
	
        setRowBits(a,HTML_OPTION, 33, 
	             HTML_TEXT_, HTML_SCRIPT,
	             HTML_B  // from nasdaq.com
		     ,HTML_STYLE,
		     HTML_ABBR, HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, 
		     HTML_KBD, HTML_Q, HTML_STRONG, HTML_VAR,HTML_BLINK, 
		     HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, 
		     HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
	           );
		   
	setRowBits(a,HTML_P, 48, 
	           HTML_BR, HTML_SPACER,HTML_WBR,HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT
		//   , HTML_TABLE  // removal prompted by slashdot.org and conform to jtidy
		  // ,HTML_LI // prompted by slashdot.org
		  // , HTML_CENTER
		  , HTML_COMMENT, HTML_WBR,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6,HTML_BASEFONT
		  
		   );
	setRowBits(a,HTML_PARAM, 2, HTML_SCRIPT, HTML_COMMENT);
	setRowBits(a,HTML_PRE, 45, 
	           HTML_BR, HTML_SPACER,HTML_WBR,HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_A, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_TEXT_, HTML_B, HTML_BLINK,HTML_BASEFONT,HTML_LI,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT
		   , HTML_NOSCRIPT // thought it should go there
		   , HTML_STYLE , HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6 
		   );
	setRowBits(a,HTML_Q, 73, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE, HTML_BGSOUND,HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, HTML_NOBR,
		   HTML_STYLE, HTML_COMMENT
		   );
	setRowBits(a,HTML_S, 50, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, HTML_NOBR,
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
	setRowBits(a,HTML_SAMP, 49, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK,HTML_BASEFONT, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
	setRowBits(a,HTML_SCRIPT, 2, HTML_TEXT_, HTML_SCRIPT);
	setRowBits(a,HTML_SELECT, 3, HTML_OPTION, HTML_OPTGROUP, HTML_SCRIPT);
	setRowBits(a,HTML_SMALL, 51, HTML_BR,HTML_SPACER,HTML_WBR, 
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK,HTML_BASEFONT, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN,HTML_NOBR, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U , HTML_SCRIPT
		   , HTML_P,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   , HTML_STYLE, HTML_COMMENT
		   );
	setRowBits(a,HTML_SPACER, 1, HTML_SCRIPT);	   
	setRowBits(a,HTML_SPAN, 82, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, HTML_NOBR,
		   HTML_SELECT, HTML_INPUT, HTML_BUTTON, HTML_TEXTAREA, HTML_LABEL, HTML_FIELDSET, 
		   HTML_LEGEND, HTML_NOBR,HTML_BASEFONT
		   , HTML_LI 
		   , HTML_ADDRESS  
		   , HTML_STYLE 
		   , HTML_COMMENT
/*41, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,
		   HTML_STYLE, HTML_COMMENT*/
		   );
		   
		   
		   
	setRowBits(a,HTML_STRIKE,50, HTML_BR,HTML_SPACER,HTML_WBR, 
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, HTML_NOBR,
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
	setRowBits(a,HTML_STRONG, 49, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
	
	setRowBits(a,HTML_STYLE, 2, HTML_TEXT_ , HTML_SCRIPT);
	setRowBits(a,HTML_SUB, 50, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN,HTML_NOBR, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
	setRowBits(a,HTML_SUP, 50, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, HTML_NOBR,
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
	setRowBits(a,HTML_TABLE, 11,
	             HTML_CAPTION, HTML_COLGROUP, HTML_TR ,HTML_THEAD,HTML_TFOOT,HTML_TBODY, 
	             HTML_SCRIPT, HTML_FORM
		   , HTML_NOSCRIPT 
		   , HTML_STYLE
		   , HTML_TD //prompted by the "breaking news" version of cnn.com
		   );
		   
	setRowBits(a,HTML_TBODY, 2, HTML_TR, HTML_SCRIPT);
	setRowBits(a,HTML_TD, 81, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, 
		   HTML_SELECT, HTML_INPUT, HTML_BUTTON, HTML_TEXTAREA, HTML_LABEL, HTML_FIELDSET, 
		   HTML_LEGEND, HTML_NOBR,HTML_BASEFONT
		   , HTML_LI // prompted by cnn.com
		   , HTML_ADDRESS  // prompted by http://www.arm.uk.linux.org/
		   , HTML_STYLE // prompted by www.cnn.com
		   , HTML_COMMENT
		   );
		   
        setRowBits(a,HTML_TEXTAREA, 2, HTML_TEXT_, HTML_SCRIPT);
	
	setRowBits(a,HTML_TFOOT, 2, HTML_TR, HTML_SCRIPT);
	
	setRowBits(a,HTML_TH, 80, 
	           HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ADDRESS,HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_UL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT, 
		   HTML_SELECT, HTML_INPUT, HTML_BUTTON, HTML_TEXTAREA, HTML_LABEL, HTML_FIELDSET, 
		   HTML_LEGEND, HTML_NOBR
		   , HTML_LI 
		   , HTML_ADDRESS  
		   , HTML_STYLE 
		   , HTML_COMMENT
		   );
		   
	setRowBits(a,HTML_THEAD, 2, HTML_TR, HTML_SCRIPT);
	
	setRowBits(a,HTML_TITLE, 2, HTML_TEXT_, HTML_SCRIPT);
	
	setRowBits(a,HTML_TR, 7
	            ,HTML_TD, HTML_TH, HTML_SCRIPT
	            , HTML_FORM  //prompted by http://news.bbc.co.uk
		    , HTML_NOSCRIPT  
		    , HTML_STYLE, HTML_COMMENT  
		   //  , HTML_TEXT_	//prompted by http://www.craigslist.org/aboutus-sf.html        
	           );
		   
	setRowBits(a,HTML_TT, 50, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, HTML_NOBR,
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
		   
	setRowBits(a,HTML_U, 50, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B, HTML_BLINK,
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, HTML_NOBR,
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
		   
	setRowBits(a,HTML_UL, 71, 
	           HTML_LI , HTML_SCRIPT,
		   HTML_UL, // prompted by http://gcc.gnu.org/onlinedocs/
		   HTML_HR, HTML_ILAYER,HTML_MARQUEE,HTML_BGSOUND, HTML_ISINDEX, HTML_BASEFONT, HTML_BLOCKQUOTE, 
		   HTML_CENTER, HTML_DIR, 
		   HTML_DIV, HTML_DL, HTML_FORM, HTML_MENU, HTML_OL, 
		   HTML_P, HTML_PRE, HTML_TABLE, HTML_MULTICOL, HTML_DEL,  HTML_H1, HTML_H2, HTML_H3, HTML_H4, 
		   HTML_H5, HTML_H6, HTML_INS, HTML_LAYER, HTML_MAP,  HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM,  HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U,  HTML_NOBR,
		   HTML_STYLE, HTML_COMMENT

		   );
		   
	setRowBits(a,HTML_VAR, 49, HTML_BR, HTML_SPACER,HTML_WBR,
		   HTML_EMBED, HTML_NOEMBED, HTML_ILAYER,HTML_IFRAME, HTML_IMG, HTML_A, HTML_APPLET, HTML_ABBR, 
		   HTML_ACRONYM, HTML_CITE, HTML_CODE, HTML_DFN, HTML_EM, HTML_SAMP, HTML_KBD, HTML_Q, HTML_STRONG, 
		   HTML_VAR, HTML_NOSCRIPT, HTML_OBJECT, HTML_TEXT_, HTML_LI,HTML_B,HTML_BLINK, 
		   HTML_BDO, HTML_BIG, HTML_FONT, HTML_I, HTML_S, HTML_SMALL, HTML_SPAN, 
		   HTML_STRIKE, HTML_SUB, HTML_SUP, HTML_TT, HTML_U, HTML_SCRIPT,HTML_BASEFONT,
		   HTML_STYLE, HTML_COMMENT,HTML_H1, HTML_H2, HTML_H3, HTML_H4, HTML_H5, HTML_H6
		   );
		   
	setRowBits(a,HTML_WBR, 2, HTML_TEXT_ , HTML_SCRIPT);	   
	
	printBitMatrix( a, "ht_pc");
//dumpBitMatrix( a);
	freeBitMatrix( a);
	
}                                                                      /*}}}*/

int main ( int argc, char* argv[] )                                    /*{{{*/
{
#ifdef HT_TEST
	int i1, i2;


        i1 = tagIndex(argv[1]);
        i2 = tagIndex(argv[2]);

        //dumpBitMatrix( &ba);
        //printf( "%s (%d)  %s (%d)  -> %d\n", argv[1], i1, argv[2], i2, isBitSet( &ba, i2, i1));
#else
        createPCmatrix();
	
#endif

        return 0;
}                                                                      /*}}}*/

