/*
 * HTML parsing helpers
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 *
 * @author Peter Mehlitz
 * 
 * $tvt: ht.h,v 1.12 2001/10/18 00:53:47 philippe Exp $ 
 */

#ifndef HT_H_INCLUDED
#define HT_H_INCLUDED

#include "util.h"

/* html tag ids */                                                     /*{{{*/

#define HTML_A           0
#define HTML_ABBR        1
#define HTML_ACRONYM     2
#define HTML_ADDRESS     3
#define HTML_APPLET      4
#define HTML_AREA        5
#define HTML_B           6
#define HTML_BASE        7
#define HTML_BASEFONT    8
#define HTML_BDO         9
#define HTML_BGSOUND     10
#define HTML_BIG         11
#define HTML_BLINK       12
#define HTML_BLOCKQUOTE  13
#define HTML_BODY        14
#define HTML_BR          15
#define HTML_BUTTON      16
#define HTML_CAPTION     17
#define HTML_CENTER      18
#define HTML_CITE        19
#define HTML_CODE        20
#define HTML_COL         21
#define HTML_COLGROUP    22
#define HTML_COMMENT     23
#define HTML_DD          24
#define HTML_DEL         25
#define HTML_DFN         26
#define HTML_DIR         27
#define HTML_DIV         28
#define HTML_DL          29
#define HTML_DT          30
#define HTML_EM          31
#define HTML_EMBED       32
#define HTML_FIELDSET    33
#define HTML_FONT        34
#define HTML_FORM        35
#define HTML_FRAME       36
#define HTML_FRAMESET    37
#define HTML_H1          38
#define HTML_H2          39
#define HTML_H3          40
#define HTML_H4          41
#define HTML_H5          42
#define HTML_H6          43
#define HTML_HEAD        44
#define HTML_HR          45
#define HTML_HTML        46
#define HTML_I           47
#define HTML_IFRAME      48
#define HTML_ILAYER      49
#define HTML_IMG         50
#define HTML_INPUT       51
#define HTML_INS         52
#define HTML_ISINDEX     53
#define HTML_KBD         54
#define HTML_LABEL       55
#define HTML_LAYER       56
#define HTML_LEGEND      57
#define HTML_LI          58
#define HTML_LINK        59
#define HTML_MAP         60
#define HTML_MARQUEE     61
#define HTML_MENU        62
#define HTML_META        63
#define HTML_MULTICOL    64
#define HTML_NOBR        65
#define HTML_NOEMBED     66
#define HTML_NOFRAMES    67
#define HTML_NOSCRIPT    68
#define HTML_OBJECT      69
#define HTML_OL          70
#define HTML_OPTGROUP    71
#define HTML_OPTION      72
#define HTML_P           73
#define HTML_PARAM       74
#define HTML_PRE         75
#define HTML_Q           76
#define HTML_S           77
#define HTML_SAMP        78
#define HTML_SCRIPT      79
#define HTML_SELECT      80
#define HTML_SMALL       81
#define HTML_SPACER      82
#define HTML_SPAN        83
#define HTML_STRIKE      84
#define HTML_STRONG      85
#define HTML_STYLE       86
#define HTML_SUB         87
#define HTML_SUP         88
#define HTML_TABLE       89
#define HTML_TBODY       90
#define HTML_TD          91
#define HTML_TEXTAREA    92
#define HTML_TFOOT       93
#define HTML_TH          94
#define HTML_THEAD       95
#define HTML_TITLE       96
#define HTML_TR          97
#define HTML_TT          98
#define HTML_U           99
#define HTML_UL          100
#define HTML_VAR         101
#define HTML_WBR         102

#define HTML_TEXT_       104   /* an artificial one we use to identify pcdata */
                                                                       /*}}}*/
int isStructNode ( int idx );

extern DocType htmlDocType;

char* expand ( char* word );

int tagIndex ( char* s );

#endif /* HT_H_INCLUDED */
