/*
 * queue of pending beginning tags to be matched, etc.
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 *
 * @author Philippe Laporte 
 *
 */



#include "queue.h"

#include "util.h"
#include <string.h>



#include <stdio.h>




QUEUENODE* queueHead;
QUEUENODE* queueTail;


void initTagQueue(void){
        queueHead = queueTail = 0;
}
/*
bool isTagQueueEmpty(void){
        return (queueHead == 0);
}
*/
void enqueueTag(char* tag){
     //   printf("inserting %s\n", tag);
/*	if(!strcasecmp(tag, "form")){
	  int i =6;
	}  */
        QUEUENODE* inserted = (QUEUENODE*) malloc(sizeof(QUEUENODE));
	inserted->tag = StrDup(tag);
	
	if(queueHead == 0){
	        queueHead = queueTail = inserted;
	}
        else{
	        queueTail->next = inserted;
		queueTail = inserted;
	}

        inserted->next = 0;
}

//find tag starting at head
bool findTagInTagQueue(char* tag){
     //   printf("looking for %s\n", tag);
        QUEUENODE* cur = queueHead, *prev = queueHead;
	
	while(cur != 0){
	
	      //  printf("Queue has %s\n", cur->tag); 
	
	        if(!strcasecmp(tag, cur->tag)){
		       prev->next = cur->next;
		       if(queueTail == cur && queueTail != queueHead){
		               if(prev->next != 0){ 
		                       queueTail = prev->next;
			       }
			       else{
			               queueTail = prev; 
			       }
		       }
		       else if(queueTail == queueHead){
		               queueHead = queueTail = 0;
		       }
		       else if(cur == prev){
		               queueHead = prev->next;
		       }
		       
		       free(cur->tag);
		       free(cur);
		     //  printf("found\n");
		       return true;          
	
	        }
		else{
		        prev = cur;
			cur = cur->next;        
	        }	
	} 
//	printf("not found\n");
	return false;
}
/*
char* dequeue(void){
      
        QUEUENODE* ret = queueHead;
    
        if(ret){
                char* tag = StrDup(ret->tag);
		
		if(queueTail == queueHead){
                        queueHead = queueTail = 0;
                }
                else{
                        queueHead = queueHead->next;
                }
                
		free(ret->tag);
                free(ret);
		
		return tag;     
        }
	else{
	        return 0;
	}
}

char* peek(void){
      
        if(queueHead){
	        return queueHead->tag;
	}
	else{
	        return 0;
        } 		    
}

void emptyQueue(void){
        
	QUEUENODE* cur = queueHead, *prev;
	
	while(cur != 0){
	        prev = cur;
		cur = cur->next;
	        free(prev->tag);
	        free(prev);
	} 
	
        queueHead = queueTail = 0;
}
*/

void deleteTagQueue(void){

        QUEUENODE* cur = queueHead, *prev = queueHead;
	
	for(; cur != 0;){
	        prev = cur;
		cur = cur->next;
		free(prev->tag);
		free(prev);
	}
}




//put in another file ??

/*
//review for mem leaks

char** stack;
int sp;
int stacksize;


void initTagStack(){

    stacksize = 5; 
    stack = (char**) calloc(stacksize, sizeof(char*));
    sp = 0;
}

void deleteTagStack(){
    free(stack);
}


void pushTag(char* tag){
    
    if(sp == stacksize){
        int newstacksize = stacksize + 5;
	char** newstack = (char**) calloc(newstacksize, sizeof(char*));
	memcpy(newstack, stack, stacksize*sizeof(char*));
	free(stack);
	stack = newstack;
	stacksize = newstacksize;
    }
    printf("Pushing %s\n", tag);
    stack[sp++] = StrDup(tag);

}


//make void ??
void popTag(){

     char* tag = stack[--sp];
     printf("Popping %s\n", tag);
}


char* peekTop(){
    
    return stack[sp - 1];
}

bool onStack(char* tag){

    int i;
    
    for(i = sp - 1; i >= 0; i--){
        if(!strcasecmp(tag, stack[i])){
	    return true;
	}     
    }    
    
    return false;
}

*/

