/*
 * label lookup. A simple stack
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * @author Philippe Laporte 
 * 
 * $tvt: labels.c,v 1.3 2001/07/14 01:51:43 samc Exp $
 */

#include "labels.h"
#include "xs_config.h"

#include <stdlib.h>
#include <string.h>

#ifdef KAFFELIB  //if used as a kaffe jni lib

#include <jni.h>

#endif


#define INITIAL_MAX_LEVEL 2 // whatever


char** labels;
int maxLevelLabels;

int levelLabels = 0;


void initLabels ()
{
	maxLevelLabels = INITIAL_MAX_LEVEL;
	labels = (char**) calloc(INITIAL_MAX_LEVEL,sizeof(char*));
}

void growLabels ()
{
	int newMaxLevel = maxLevelLabels + 10;
	char** newLabels = (char**) calloc(newMaxLevel,sizeof(char*));
	
	memcpy( newLabels, labels, maxLevelLabels*sizeof(char*));
        free( labels);
	labels = newLabels;
	maxLevelLabels = newMaxLevel;
}

void deleteLabels ()
{
	int i;
	for ( i=0; i < maxLevelLabels; i++ ){
		if ( labels[i] ){
			free( labels[i]);
		}
	}
	
	free( labels);
}


bool addLabel ( char* sym )
{
        if(levelLabels + 1 == maxLevelLabels)
	  growLabels();
      
        if(isLabelDefined(sym))
	  return false;
	else{ 
          labels[levelLabels++] = StrDup(sym);
          return true;
	}  
}

bool isLabelDefined(char* sym)
{
       for(int i = levelLabels; i >= 0; i--)
      	 if(labels[i])
           if(!strcmp(labels[i], sym))
	     return true;
       	 
       return false;
}


void removeLabel ()
{
       free(labels[--levelLabels]);

}
