/*
 * Symbol management
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * @author Philippe Laporte 
 * 
 * $tvt: symtab.h,v 1.3 2001/07/14 01:51:43 samc Exp $
 */

#ifndef _SYMTAB_H_INCLUDED
#define _SYMTAB_H_INCLUDED

#ifdef __cplusplus
extern "C" {
#endif

#include "util.h"  // StrDup used in symtab.c

typedef struct symtab* symtab_tPtr;

typedef struct symtab {
	char** sym;
	char*  type;
	//AST** node;
	
	symtab_tPtr next;
	
	//char* static_type;
        int    count;
	int    thresh;
	int    len;
	int    isCopy;
} symtab_t;


#define T_PROP 1       // any property
#define T_FUNC 2
#define T_DNUM 3
#define T_DSTR 4
#define T_DOBJ 5
#define T_DBOO 6
#define T_DARR 7


symtab_t* st_create ( int len, int isCopy );
//void st_reset ( symtab_t* t );
//void st_delete ( symtab_t* t );
void st_add ( symtab_t* t, char* sym, char type );
int st_contains ( symtab_t* t, char* sym );
//void st_remove ( symtab_t* t, char* sym );

#ifdef __cplusplus
}
#endif

#endif /* _SYMTAB_H_INCLUDED */
