/*
 * variable management
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * @author Peter Mehlitz
 * @author Philippe Laporte 
 * 
 * $tvt: vars.c,v 1.3 2001/07/14 01:51:43 samc Exp $
 */

#include "vars.h"
#include "symtab.h"
#include "xs_config.h"

#include <stdlib.h>
#include <string.h>


#ifdef KAFFELIB  //if used as a kaffe jni lib
#include <jni.h>
#endif


#define INITIAL_MAX_HANDLES 10  

/* keep an array of pointers to all symtab_t created and free them 
   between compiles */
symtab_t** handles;
int handles_number = 0;
int maxhandles;


symtab_t* current;

void initVars ()
{
	maxhandles = INITIAL_MAX_HANDLES;
	
	handles = (symtab_t**) calloc(INITIAL_MAX_HANDLES, sizeof(symtab_t*));
	
	current = st_create(10,1);
	
	handles[handles_number++] = current;
}

void growHandles ()
{
        int newMaxHandles = maxhandles + 10;
	symtab_t** newHandles = (symtab_t**) calloc(newMaxHandles,sizeof(symtab_t*));
	memcpy( newHandles, handles, maxhandles*sizeof(symtab_t*));
	free( handles);
	handles = newHandles;
	maxhandles = newMaxHandles;
}



void deleteVars ()
{       
        int i;
	for ( i=0; i< maxhandles; i++ ){
		free( handles[i]);
        }
	

        free(handles);
}


int varLevelt ( char* sym, int*type )
{
      	int i, t;
	symtab_t* temp;
	
	
	for(temp = current, i = getLevel(); temp != 0; temp = temp->next, i--){
            if (t = st_contains(temp, sym)){
               if ( type ) *type = t;
	       return i;
	    }
	}
	
	return -1;
}



void addVar ( char* sym, int type )
{
	st_add( current, sym, type);	
}


/*
void removeVar ( char* sym )
{
	if ( vars[level] ){
		st_remove( vars[level], sym);
	}
}*/
