/*
 * variable management
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * @author Peter Mehlitz
 * @author Philippe Laporte 
 * 
 * $tvt: vars.h,v 1.3 2001/07/14 01:51:43 samc Exp $
 */

#ifndef _VARS_H_INCLUDED
#define _VARS_H_INCLUDED

#include "symtab.h"

#ifdef __cplusplus
extern "C" {
#endif

extern int maxhandles;
extern int handles_number;
extern symtab_t** handles;

extern symtab_t* current;

void initVars ();
void growHandles ();
void deleteVars ();
int varLevelt ( char* sym, int*type );
void addVar ( char* sym, int type );
//void removeVar ( char* sym );
	

inline void incLevel ()
{ 
        symtab_t* t = st_create(10,1);
	
	t->next = current;
	
	current = t;

	if ( handles_number + 1 == maxhandles ){
		growHandles();
	}

        handles[handles_number++] = t;
}

inline void decLevel ()
{      //check if current->next == NULL ?
        current = current->next;
	
}

inline int getLevel()
{
  symtab_t* temp;
  int level = 0;
  for(temp =current; temp != 0; temp = temp->next)
    level++;

  return level - 1;
}


inline int varLevel ( char* sym )
{
	return varLevelt( sym, 0);
}

inline int isVar ( char* sym )
{
	return ( varLevel( sym) >= 0 );
}

inline bool isVarAtLevel(char* sym)
{		
       if ( st_contains( current, sym) )
	        return true;
       else
	        return false;			
}

#ifdef __cplusplus
}
#endif

#endif /* _VARS_H_INCLUDED */
