/*
 * Strips code that relates to ML-only processing from bc_gen and puts it in ml_only
 *
 * Copyright (c) 2001
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 *
 * @author Philippe Laporte
 *  
 * $tvt: stripper.g,v 1.4 2001/10/10 19:47:46 philippe Exp $ 
 */



<<

#include <string.h>

typedef ANTLRCommonToken ANTLRToken;

#include "DLGLexer.h"


char* files_to_do[] = { 
                        "../src/bc_gen/AST.h", "AST.h",
			"../src/bc_gen/main.c", "main.c",
			"../src/bc_gen/resourcer.sor", "resourcer.sor",
			"../src/bc_gen/util.h", "util.h",
			"../src/bc_gen/xs.g", "xs.g"
	              }; 		



FILE* cur_out_file;

FILE* dev_null;

FILE* out_file;

#define OUT_DIR "../src/ml_only/"

#define STRLEN(x) ( sizeof(x) / sizeof(char) - 1 )



int main(){
                    
		    
        DLGInputStream* in;
        DLGLexer* scanner;
        Parser* parser; 

        int i;
        FILE* cur_in_file;
	
        dev_null = fopen("/dev/null", "w");
		 
        if(!dev_null){
	        fprintf(stderr, "Could not open /dev/null for writing\n");
		abort();
	}

        
	cur_out_file = dev_null;
	
	for(i = 0; i < ( sizeof(files_to_do) / sizeof(files_to_do[0]) ) ;  i+=2, cur_out_file = dev_null){
	
	        cur_in_file = fopen(files_to_do[i], "r");
		 
		if(!cur_in_file){
		    //try with perror
		    fprintf(stderr, "Could not open file %s for reading, trying next one\n", files_to_do[i]);
		    continue;
		}  



                char* out_file_name = (char*) calloc(STRLEN(OUT_DIR) +
	                                             strlen(files_to_do[i + 1]) +
						     1
						     ,
						     sizeof(char));
						     
                strcpy(out_file_name, OUT_DIR);
		strcat(out_file_name, files_to_do[i + 1]);            
    

                out_file = fopen(out_file_name, "w");
		 
		if(!out_file){
		    //try with perror
		    fprintf(stderr, "Could not open file %s for writing\n", out_file_name);
		    continue;
		}
		
		

                DLGFileInput* fileinput = new DLGFileInput(cur_in_file);  //avoid some casting
                in = fileinput;
                scanner = new DLGLexer(fileinput);
 
                ANTLRTokenBuffer pipe(scanner);
                ANTLRToken tok;
                parser = new Parser(&pipe);
                scanner->setToken(&tok);
    
                parser->init();
	
                parser->xsfile();
        }
}
  
>>


#token TXT_SKIP "[\ \t]+"                              

#token ML_ONLY_START "\/\/[\ ]*ML_ONLY_START~[\n]*"      

#token ML_ONLY_END "\/\/[\ ]*ML_ONLY_END~[\n]*"     

#token SCRIPT "script"           

#token S "s"
//need all substrings of script 
#token SC "s[cC]"
#token SCR "s[cC][rR]"
#token SCRI "s[cC][rR][iI]"
#token SCRIP "s[cC][rR][iI][pP]"

//#token SCRIPT_END "SCRIPT_END!"   

#token TEXT "~[\/\ s]*"                               

#token COMMENT_BEGINNING "[\/]+[\ ]*"              


    
    
class Parser {

xsfile: 

         (
	 
	   ML_ONLY_START                <<  
	                                   cur_out_file = out_file;
					>>
	  | 
	   ML_ONLY_END                  <<  
	                                   cur_out_file = dev_null;
	                                >>
	  | 
           c:TXT_SKIP                   << fprintf(cur_out_file, "%s", $c->getText()); >>
	  |
	   d:TEXT                       << fprintf(cur_out_file, "%s", $d->getText()); >>
	  |
	   e:COMMENT_BEGINNING          << fprintf(cur_out_file, "%s", $e->getText()); >>
	  |
	   f:SCRIPT                     << fprintf(cur_out_file, "(TXT_WORD | TXT_WORD_NEEDS_CONVERSION | TXT_LT | TXT_BLANK | C_STRING | TXT_NL)*"); >>
	  |
	   g:S                          << fprintf(cur_out_file, "s"); >>
	  |
	   h:SC                         << fprintf(cur_out_file, "%s", $h->getText()); >> 
	  |
	   i:SCR                        << fprintf(cur_out_file, "%s", $i->getText()); >>
	  |
	   j:SCRI                       << fprintf(cur_out_file, "%s", $j->getText()); >>
	  |
	   k:SCRIP                      << fprintf(cur_out_file, "%s", $k->getText()); >> 
	 /* |
	   SCRIPT_END                   << fprintf(cur_out_file, "(XML_END_OPEN! ( XML_TAG! | SCRIPT_TAG! ) XML_CLOSE!)"); >>
	 */
	 )*              

;

}
