/*
 * Copyright (c) 1998
 *      Transvirtual Technologies, Inc.  All rights reserved.
 *
 * See the file "license.terms" for information on usage and redistribution 
 * of this file. 
 */

package java.awt;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import kaffe.awt.Defaults;

public class TextField
  extends TextComponent
{
	char echoChar;
	int cols;
	static int named;

public TextField() {
	this( "", 0);
}

public TextField( String text) {
	this( text, text.length() );
}

public TextField( String text, int cols) {
	this.cols = cols;

	cursor = Cursor.getPredefinedCursor( Cursor.TEXT_CURSOR);
	setBackground( Defaults.TextFieldBgClr);
	setForeground( Defaults.TextFieldTxtClr);
	setFont( Defaults.TextFieldFont);
	setText( text);
}

public TextField( int cols) {
	this( "", cols);
}

public void addActionListener( ActionListener l) {
}

public void addNotify() {
	if ( nativeData == null ) {
		nativeData = Toolkit.entryCreateEntry( text);
		super.addNotify();
	}
}

public boolean echoCharIsSet() {
	return echoChar != 0;
}

public int getColumns() {
	return cols;
}

public char getEchoChar() {
	return echoChar;
}

String getGenericName () {
	// Apparently, the JDK increments the running number each time
	// *after* there was a genericName request. And yes, the stem is of course
	// not the qualified class name
	
	return "textfield" + (named++);
}

public Dimension getMinimumSize() {
	return new Dimension( 50, 50);
}

public Dimension getMinimumSize( int cols) {
	return new Dimension( 50, 50);
}

public Dimension getPreferredSize() {
	return getPreferredSize( Math.max( 10, text.length() )); ;
}

public Dimension getPreferredSize( int cols) {
	FontMetrics fm = getFontMetrics( getFont() );
	return new Dimension( cols * fm.charWidth( 'x'), 3*fm.getHeight()/2);
}

protected String paramString() {
	return "";
}

public void removeActionListener( ActionListener l) {
}

public void setColumns( int cols) {
	this.cols = cols;
}

public void setEchoChar( char c) {
	echoChar = c;
}
}
