/*
 * Copyright (c) 2000, 2001 Transvirtual Technologies, Inc.  
 * All rights reserved. See the file "COPYING" for details.
 *
 * $tvt: XsObject.java,v 1.91 2001/09/22 00:17:59 philippe Exp $
 */
package kaffe.xs;

import java.awt.Component;
import java.lang.reflect.Field;
import java.lang.reflect.Method;
import java.net.URLEncoder;
import java.net.URLDecoder;
import java.util.Vector;
import java.util.Hashtable;
import java.util.Stack;

public class XsObject
{
	protected XsProps properties;
        protected Hashtable properties_attributes; //a parrallel hash table, property name -> attributes
	
        protected XsObject __proto__; //prototype object
	//Field ref;
	public static XsObject _undefined = new XsObject();
	public static XsObject _null = new XsObject();
	public static XsObject xTrue = new XsObject();
	public static XsObject xFalse = new XsObject();
	public static XsObject global = new XsObject();
	//public static XsFunc print;
        //public static XsFunc escape;  
	//public static XsFunc unescape;
        public static XsFunc eval;
        //public static XsFunc toString;
	//public static XsFunc valueOf;
	public static XsFunc _Array;
	public static XsFunc _Date;
	public static XsFunc _String;
	public static XsFunc _Number;
	public static XsFunc _Boolean;
	public static XsFunc ObjectInitializer;
	public static XsFunc ArrayInitializer;
        //needed apart from constructor otherwise takes length = 1 as meaning no content
	public static XsFunc _Object;
	public static XsFunc _Function;
        static XsString typeStrBool = new XsString("boolean");
	static XsString typeStrUndef = new XsString("undefined");
	static XsString typeStrObj = new XsString("object");
	static String docFactoryCls;
        //static String docFactoryCls = "com.pocketlinux.dom.DOM0Adaptor";
	static DocumentFactory docFactory;
	public static XsObject top = _undefined;

        //remove public and see the error in jdk. This to me shows a bug in Kaffe, since should not be accessible from xs generated code without public, unless we would have a kaffe.xs package decl in the xs generated class. 
        public static Stack callStack;
        public XsObject parent;

       
class NullDocFactory
  implements DocumentFactory
{
public void createElement( int level, String tag) {
}

public void createTextElement( int level, String text) {
}

public void finish() {
}

public int getCurrentLevel(){
	return -1;
}
	/*	
public void insertElement( XsObject node) {
	
}
	*/	
public void setAttribute( String key, String val) {
}

public void setEventAttribute( String key, XsObject action) {
}

public void setXsRoot( XsObject root) {
}
}
// class NullDocFactory
public class NameEnumeration
{
	Object[] names;
	int idx;
	int remain = 0;

NameEnumeration () {
	
        if(XsObject.this == _undefined)
		return;
  
        if (properties == null){
		properties = new XsProps(11);
                properties_attributes = new Hashtable(11);
	}

	names = new Object[properties.count + __proto__.properties.count];        
      
        remain = properties.count;
         
        idx = 0;       
 
        //take out builtin properties

        //ours
        for(int i = 0; remain > 0; i++){
		if(properties.keys[i] != null){
			remain--;
			if(!((XsPropertyAttributes)properties_attributes.get(properties.keys[i])).DontEnum) 
				names[idx++] = properties.keys[i];
                }
        } 

        remain = __proto__.properties.count;       

        //our prototype's
        //is this correct?? are the prototypes' properties included
        for(int i = 0; remain > 0; i++){
		if(__proto__.properties.keys[i] != null){
			remain--;
			if(!((XsPropertyAttributes)__proto__.properties_attributes.get(__proto__.properties.keys[i])).DontEnum &&
                           !__proto__.properties.keys[i].equals("constructor")
                          ) 
				names[idx++] = __proto__.properties.keys[i];
                }
        } 
        
        remain = idx;

        idx = 0;
}

NameEnumeration (boolean extensible){
	// not yet
}

public boolean hasMoreElements () {
	return (remain > 0);
}

public XsString nextElement () {
	//assume: hasMore gets called before next 
        
        remain--;
                     
        return new XsString(names[idx++]);
}
} // class NameEnumeration

//constructors have 2 _, converters have 3
static {

        //Call Stack initialization

        callStack = new Stack();
        //not sure if must do this, since global context can always find properties through the prototyype. To SOLVE later 
 
        callStack.push(XsObject.global); 

        //already null by default, so remove this
	XsObject.global.parent = null;



        XsPropertyAttributes propattrs;
        XsFunc func;
       
        //global properties

      	XsObject.global.xsPut("_Array", _Array = func = (XsFunc) XsFunc.getCtor( "_Array", XsArray.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("_Array")).DontEnum = true;
        
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        XsObject.global.xsPut("__Array", _Array = func = (XsFunc) XsFunc.getCtor( "__Array", XsArray.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("__Array")).DontEnum = true;

	XsObject.global.xsPut("_Date", _Date = func = (XsFunc) XsFunc.getCtor( "_Date", XsDate.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("_Date")).DontEnum = true;

        func.xsPut("length", new XsNumber(7));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;


	XsObject.global.xsPut("_String", func = _String = (XsFunc) XsFunc.getCtor( "_String", XsString.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("_String")).DontEnum = true;

        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        XsObject.global.xsPut("__String", (XsFunc) XsFunc.getFunc("__String", XsObject.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("__String")).DontEnum = true;


	XsObject.global.xsPut("_Number", _Number = func = (XsFunc) XsFunc.getCtor( "_Number", XsNumber.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("_Number")).DontEnum = true;

        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        XsObject.global.xsPut("__Number", (XsFunc) XsFunc.getFunc( "__Number", XsObject.class));
	((XsPropertyAttributes)XsObject.global.properties_attributes.get("__Number")).DontEnum = true;


        XsObject._Boolean = (XsFunc) XsFunc.getCtor( "_Boolean", XsObject.class);

	XsObject.global.xsPut("_Boolean", func = XsObject._Boolean);
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("_Boolean")).DontEnum = true;

        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        XsObject.global.xsPut("__Boolean", (XsFunc) XsFunc.getFunc( "__Boolean", XsObject.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("__Boolean")).DontEnum = true;


	
        XsObject._Object = (XsFunc) XsFunc.getCtor( "_Object", XsObject.class);

        XsObject.global.xsPut("_Object", func = XsObject._Object);
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("_Object")).DontEnum = true;
	
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

       
	

        XsObject.global.xsPut("__Object", (XsFunc) XsFunc.getCtor( "__Object", XsObject.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("__Object")).DontEnum = true;


	
       	XsObject.ObjectInitializer = (XsFunc) XsFunc.getCtor( "ObjectInitializer", XsObject.class);
        XsObject.global.xsPut("ObjectInitializer", XsObject.ObjectInitializer);
	((XsPropertyAttributes)XsObject.global.properties_attributes.get("ObjectInitializer")).DontEnum = true;


        XsObject.ArrayInitializer = (XsFunc) XsFunc.getCtor( "ArrayInitializer", XsArray.class);
        XsObject.global.xsPut("ArrayInitializer", XsObject.ArrayInitializer );
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("ArrayInitializer")).DontEnum = true;



        XsObject.eval = func = (XsFunc) XsFunc.getFunc("eval", XsObject.class);
	XsObject.global.xsPut( "eval", eval);
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("eval")).DontEnum = true;

        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;


        //toString
        
	XsObject.global.xsPut( "toString", func = (XsFunc) XsFunc.getFunc("toString", XsObject.class));
	((XsPropertyAttributes)XsObject.global.properties_attributes.get("toString")).DontEnum = true;

        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true; 
 
        //valueOf
        
        XsObject.global.xsPut( "valueOf", func = (XsFunc) XsFunc.getFunc("valueOf", XsObject.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("valueOf")).DontEnum = true;

        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true; 

        //toLocaleString
        XsObject.global.xsPut("toLocaleString", func = (XsFunc) XsFunc.getFunc("toLocaleString", XsObject.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("toLocaleString")).DontEnum = true;

        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        //hasOwnProperty
        XsObject.global.xsPut("hasOwnProperty", func = (XsFunc) XsFunc.getFunc("hasOwnProperty", XsObject.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("hasOwnProperty")).DontEnum = true;

        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        //isPrototypeOf
        XsObject.global.xsPut("isPrototypeOf", func = (XsFunc) XsFunc.getFunc("isPrototypeOf", XsObject.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("isPrototypeOf")).DontEnum = true;

        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;


        //propertyIsEnumerable
        XsObject.global.xsPut("propertyIsEnumerable", func = (XsFunc) XsFunc.getFunc("propertyIsEnumerable", XsObject.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("propertyIsEnumerable")).DontEnum = true;

        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;






	//putting these elsewhere causes an exception

        XsArray.array__proto__ = new XsObject();//new XsArray(0); this would give us some circularity
	
        XsObject array__proto__ = XsArray.array__proto__;

        array__proto__.xsPut( "concat", func = (XsFunc) XsFunc.getFunc("concat", XsArray.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true; 

        propattrs = ((XsPropertyAttributes)array__proto__.properties_attributes.get("concat"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
     



        array__proto__.xsPut( "join", func = (XsFunc) XsFunc.getFunc("join", XsArray.class)); 
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true; 

        propattrs = ((XsPropertyAttributes)array__proto__.properties_attributes.get("join"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       



        array__proto__.xsPut( "pop", func = (XsFunc) XsFunc.getFunc("pop", XsArray.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true; 

        propattrs = ((XsPropertyAttributes)array__proto__.properties_attributes.get("pop"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        array__proto__.xsPut( "push", func = (XsFunc) XsFunc.getFunc("push", XsArray.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true; 

        propattrs = ((XsPropertyAttributes)array__proto__.properties_attributes.get("push"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        array__proto__.xsPut( "reverse", func = (XsFunc) XsFunc.getFunc("reverse", XsArray.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)array__proto__.properties_attributes.get("reverse"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
    



        array__proto__.xsPut( "shift", func = (XsFunc) XsFunc.getFunc("shift", XsArray.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)array__proto__.properties_attributes.get("shift"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
     


        
        array__proto__.xsPut( "slice", func = (XsFunc) XsFunc.getFunc("slice", XsArray.class)); 
        func.xsPut("length", new XsNumber(2));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)array__proto__.properties_attributes.get("slice"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        array__proto__.xsPut( "sort", func = (XsFunc) XsFunc.getFunc("sort", XsArray.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)array__proto__.properties_attributes.get("sort"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      



        array__proto__.xsPut( "splice", func = (XsFunc) XsFunc.getFunc("splice", XsArray.class));
        func.xsPut("length", new XsNumber(2));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)array__proto__.properties_attributes.get("splice"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       


	
        array__proto__.xsPut( "toLocaleString", func = (XsFunc) XsFunc.getFunc("toLocaleString", XsArray.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)array__proto__.properties_attributes.get("toLocaleString"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       
	
        

        array__proto__.xsPut( "unshift", func = (XsFunc) XsFunc.getFunc("unshift", XsArray.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)array__proto__.properties_attributes.get("unshift"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      
        
        XsArray.array__proto__.__proto__ = XsFunc.function__proto__;

        //global objects, fields and methods


        //Array
        XsFunc xsArray;
        
        XsObject.global.xsPut("Array", xsArray = _Array);

        xsArray.__proto__ = XsArray.array__proto__;

        xsArray.__proto__.xsPut("constructor", xsArray);

        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("Array")).DontEnum = true;

        xsArray.xsPut("length", new XsNumber(1)); //from netscape testcases
        propattrs = ((XsPropertyAttributes)xsArray.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;



        //Math 
        //put in global?? must be able to replace the Math object (ex: Math = new Object; )
        XsMath xsMath;
        
        XsObject.global.xsPut("Math", xsMath = new XsMath());
        
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("Math")).DontEnum = true;
	   
        //methods
        xsMath.xsPut("abs", func = (XsFunc) XsFunc.getFunc("abs", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;
	
        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("abs"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;


	
        xsMath.xsPut("acos", func = (XsFunc) XsFunc.getFunc("acos", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("acos"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



        xsMath.xsPut("asin", func = (XsFunc) XsFunc.getFunc("asin", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("asin"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;


	
        xsMath.xsPut("atan", func = (XsFunc) XsFunc.getFunc("atan", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("atan"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



        xsMath.xsPut("atan2", func = (XsFunc) XsFunc.getFunc("atan2", XsMath.class));
        func.xsPut("length", new XsNumber(2));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("atan2"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;


	
        xsMath.xsPut("ceil", func = (XsFunc) XsFunc.getFunc("ceil", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("ceil"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



	xsMath.xsPut("cos", func = (XsFunc) XsFunc.getFunc("cos", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("cos"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



        xsMath.xsPut("exp", func = (XsFunc) XsFunc.getFunc("exp", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("exp"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



        xsMath.xsPut("floor", func = (XsFunc) XsFunc.getFunc("floor", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("floor"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



        xsMath.xsPut("log", func = (XsFunc) XsFunc.getFunc("log", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("log"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



        xsMath.xsPut("max", func = (XsFunc) XsFunc.getFunc("max", XsMath.class));
        func.xsPut("length", new XsNumber(2));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("max"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



        xsMath.xsPut("min", func = (XsFunc) XsFunc.getFunc("min", XsMath.class));
        func.xsPut("length", new XsNumber(2));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("min"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



	xsMath.xsPut("pow", func = (XsFunc) XsFunc.getFunc("pow", XsMath.class));
        func.xsPut("length", new XsNumber(2));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("pow"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;


 
        xsMath.xsPut("random", func = (XsFunc) XsFunc.getFunc("random", XsMath.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("random"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



        xsMath.xsPut("round", func = (XsFunc) XsFunc.getFunc("round", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true; 

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("round"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



        xsMath.xsPut("sin", func = (XsFunc) XsFunc.getFunc("sin", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("sin"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



        xsMath.xsPut("sqrt", func = (XsFunc) XsFunc.getFunc("sqrt", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("sqrt"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



        xsMath.xsPut("tan", func = (XsFunc) XsFunc.getFunc("tan", XsMath.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("tan"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;



        //fields
       
        xsMath.xsPut("E", XsMath.E);
        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("E"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

	xsMath.xsPut("PI", XsMath.PI);
        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("PI"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        xsMath.xsPut("LN10", XsMath.LN10);
        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("LN10"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        xsMath.xsPut("LN2", XsMath.LN2);
        propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("LN2"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        xsMath.xsPut("LOG10E", XsMath.LOG10E);
	propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("LOG10E"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        xsMath.xsPut("LOG2E", XsMath.LOG2E);
	propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("LOG2E"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        xsMath.xsPut("SQRT1_2", XsMath.SQRT1_2);
	propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("SQRT1_2"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        xsMath.xsPut("SQRT2", XsMath.SQRT2);
	propattrs = ((XsPropertyAttributes)xsMath.properties_attributes.get("SQRT2"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

       
        //Number

        XsFunc xsNumber;
        
        XsObject.global.xsPut("Number", xsNumber = _Number);

        xsNumber.__proto__ = XsNumber.number__proto__;

        xsNumber.__proto__.xsPut("constructor", xsNumber);

        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("Number")).DontEnum = true;
        
        xsNumber.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)xsNumber.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        //methods
        
        //fields
        xsNumber.xsPut((Object)"NaN", XsNumber.NaN);
        
        xsNumber.xsPut((Object)"MAX_VALUE", XsNumber.MAX_VALUE);
        xsNumber.xsPut((Object)"MIN_VALUE", XsNumber.MIN_VALUE);
        xsNumber.xsPut((Object)"POSITIVE_INFINITY", XsNumber.POSITIVE_INFINITY);
        xsNumber.xsPut((Object)"NEGATIVE_INFINITY", XsNumber.NEGATIVE_INFINITY);


        //String

        
        XsFunc xsString;        

        XsObject.global.xsPut("String", xsString = (XsFunc) XsFunc.getCtor("_String", XsString.class));

        xsString.__proto__ = XsString.string__proto__;

        xsString.__proto__.xsPut("constructor", xsString);

        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("String")).DontEnum = true;

        //methods
        xsString.xsPut((Object)"fromCharCode", func = (XsFunc) XsFunc.getFunc("fromCharCode", XsString.class));
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)xsString.properties_attributes.get("fromCharCode"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;
        
        xsString.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)xsString.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;


       
        //Date

        XsFunc xsDate;
        
        XsObject.global.xsPut("Date", xsDate = _Date);

        xsDate.__proto__ = XsDate.date__proto__;

        xsDate.__proto__.xsPut("constructor", xsDate);

        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("Date")).DontEnum = true;

        xsDate.xsPut("length", new XsNumber(7));
        propattrs = ((XsPropertyAttributes)xsDate.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;


        //Object 

        XsObject.global.xsPut("Object", XsObject._Object);
        
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("Object")).DontEnum = true;

         



        //Boolean
        

        XsObject.global.xsPut("Boolean", XsObject._Boolean);
        //so that don't conflict with Object
        XsObject._Boolean.__proto__ = new XsObject();
 
        XsObject boolean__proto__ = XsObject._Boolean.__proto__;

        //causes run-time problem
	boolean__proto__.properties = null;

        boolean__proto__.__proto__ = XsFunc.function__proto__;
        
        boolean__proto__.xsPut("constructor", XsObject._Boolean);

        boolean__proto__.xsPut("toString", func = (XsFunc) XsFunc.getFunc("toString", XsObject.class)); 
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;  

        propattrs = ((XsPropertyAttributes)boolean__proto__.properties_attributes.get("toString"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
       
        XsObject._Boolean.__proto__.xsPut("valueOf", func = (XsFunc) XsFunc.getFunc("valueOf", XsObject.class));
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        propattrs = ((XsPropertyAttributes)boolean__proto__.properties_attributes.get("valueOf"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
      


        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("Boolean")).DontEnum = true;

        
        xTrue.__proto__ = XsObject._Boolean.__proto__;
        xFalse.__proto__ = XsObject._Boolean.__proto__;




        //Function

        XsObject.global.xsPut("_Function", _Function = func = (XsFunc) XsFunc.getCtor( "_Function", XsFunc.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("_Function")).DontEnum = true;
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;

        XsObject.global.xsPut("__Function", func = (XsFunc) XsFunc.getCtor( "__Function", XsFunc.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("__Function")).DontEnum = true;


        XsFunc xsFunc;

        XsObject.global.xsPut("Function", xsFunc = _Function);

        xsFunc.__proto__ = XsFunc.function__proto__;

        xsFunc.__proto__.xsPut("constructor", xsFunc);

        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("Function")).DontEnum = true;


        //misc.
  
        //methods

        XsObject.global.xsPut("isFinite", func = (XsFunc) XsFunc.getFunc("isFinite", XsNumber.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("isFinite")).DontEnum = true;
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;	


        XsObject.global.xsPut("isNaN", func = (XsFunc) XsFunc.getFunc("isNaN", XsNumber.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("isNaN")).DontEnum = true;
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;	

	
        XsObject.global.xsPut("parseFloat", func = (XsFunc) XsFunc.getFunc("parseFloat", XsNumber.class));
	((XsPropertyAttributes)XsObject.global.properties_attributes.get("parseFloat")).DontEnum = true;
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;	

        XsObject.global.xsPut("parseInt", func = (XsFunc) XsFunc.getFunc("parseInt", XsNumber.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("parseInt")).DontEnum = true;
        func.xsPut("length", new XsNumber(2));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;	
        
        
	XsObject.global.xsPut( "print", func = (XsFunc) XsFunc.getFunc("print", XsObject.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("print")).DontEnum = true;
        func.xsPut("length", new XsNumber(0));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;	
        
        XsObject.global.xsPut( "escape", func = (XsFunc) XsFunc.getFunc("escape", XsObject.class));
        ((XsPropertyAttributes)XsObject.global.properties_attributes.get("escape")).DontEnum = true;
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;	
        
        XsObject.global.xsPut( "unescape", func = (XsFunc) XsFunc.getFunc("unescape", XsObject.class));
	((XsPropertyAttributes)XsObject.global.properties_attributes.get("unescape")).DontEnum = true;
        func.xsPut("length", new XsNumber(1));
        propattrs = ((XsPropertyAttributes)func.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;	

 
        //fields
        XsObject.global.xsPut("NaN", XsNumber.NaN);
        propattrs = ((XsPropertyAttributes)XsObject.global.properties_attributes.get("NaN"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        
        XsObject.global.xsPut("Infinity", XsNumber.POSITIVE_INFINITY);
        propattrs = ((XsPropertyAttributes)XsObject.global.properties_attributes.get("Infinity"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
 
        //not so sure about the next one
        XsObject.global.xsPut("undefined", _undefined);
        propattrs = ((XsPropertyAttributes)XsObject.global.properties_attributes.get("undefined"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
}

public XsObject () {
        //so that can find global methods in xsGet
        //take out when have scope chain
	__proto__ = global;  
}

public static XsObject ___Number ( XsObject xThis, XsArray args ){
	if(args.count == 0){
		return new XsNumber(0);
        }
        else{
		return new XsNumber(XsNumber.getNumberFromObject(args.elements[0]));
        }
}

final public static XsObject _ObjectInitializer ( XsObject xThis, XsArray args ){
 	for(int i = 0; i < args.count; i+=2)
		xThis.xsPut(args.elements[i].toString(), args.elements[i + 1]);

        xThis.__proto__ = XsObject._Object.__proto__;
 
        xThis.xsPut("constructor", XsObject._Object);

        XsPropertyAttributes propattrs = ((XsPropertyAttributes)xThis.properties_attributes.get("constructor"));
        propattrs.DontEnum = true;

        return xThis;
}

public static XsObject ___String ( XsObject xThis, XsArray args ){
	if(args.count == 0){
		return new XsString("");
        }
	else{
		return new XsString(args.elements[0].call("toString").toString());
	}
}

//rearrange method order, alphabetical, category etc...
final public static XsObject __Boolean ( XsObject xThis, XsArray args ){
	if(args.count == 0){
		return xFalse; 
        }
	else{
	        return args.elements[0].toBoolean();
        }
}

final public static XsObject ___Boolean ( XsObject xThis, XsArray args ){
	return XsObject.__Boolean(xThis, args);
}

final public static XsObject __Object ( XsObject xThis, XsArray args ){
	if(args.count == 0 || args.elements[0] == _undefined || args.elements[0] == _null){
		return xThis; 
	}
        else{
		XsObject value = args.elements[0];
                
                if(value instanceof XsString){
			return value;
                } 
                else if(value instanceof XsNumber){
			return value;
                }
                else if(value instanceof XsFunc){
			return value;
                }
                else if(value instanceof XsArray){
			return value;
                }
                else if(value instanceof XsDate){
			return value;
		}
                else if(value.xsGet("constructor") == XsObject._Object){
			return value;
                }
                else if(value == xTrue || value == xFalse){
			return value;
                }
                else{
			return xThis;
	        }
        }       
}

final public static XsObject ___Object ( XsObject xThis, XsArray args ){
	if(args.count == 0 || args.elements[0] == _undefined || args.elements[0] == _null){
		return new XsObject();
	}
	else{
		return args.elements[0];  
        }
}

public static XsObject _delete ( XsObject xThis, XsArray args ){
	// returns xTrue if success, xFalse if fail
        // args.count == 1 
	XsObject argument = args.elements[0];

        if(argument instanceof XsFunc)
		return xTrue;
        
        return xTrue;
}

public static XsObject _print (XsObject xThis, XsArray args ){
	int i = 0;

        if ( args.count > 0 ){
		while ( true ){
                        XsObject element_i = args.elements[i];

                        if(element_i == _undefined || element_i == _null || element_i == XsNumber.NaN){
			        System.out.print(element_i);
                        }
                        else{   //System.out.println("printing" + element_i);
			        if(element_i instanceof XsString){
					System.out.print( ((XsString)element_i).toString() );
				}
                                
				else{//System.out.println("printing calling " + (element_i instanceof XsNumber));
					System.out.print( element_i.call("toString") );
				}
                        }
			
                        i++;
			
                        if ( i == args.count ){
				System.out.println();
				break;
			}
			else {
				System.out.print(' ');
			}
		}
	}

	return _undefined;
}

public static XsObject _eval (XsObject xThis, XsArray args ){
	
         if(args.count == 0){
		 return _undefined;
         }
	 else{   
                 if(!(args.elements[0] instanceof XsString)){
			 return args.elements[0];
                 }
                 else{
                 //TODO: deal with syntax errors
			 return XsEngine.interpret(xThis, xThis, args.elements[0].toString());
         

                 }
         }	
}

public static XsObject _escape (XsObject xThis, XsArray args ){
	
         if(args.count == 0){
		 return _undefined;
         }
	 else{
		 String s = args.elements[0].toString();
 
                 StringBuffer result = new StringBuffer();

	         for (int pos = 0; pos <s.length(); pos++) {
			 char chr = s.charAt(pos);
			 if ((chr>='A') && (chr<='Z')) {
				 result.append(chr);
			 }
			 else if ((chr>='a') && (chr<='z')) {
				 result.append(chr);
			 }
			 else if ((chr>='0') && (chr<='9')) {
				 result.append(chr);
			 }
			 else {
				 result.append("%"+Integer.toString((int )chr, 16));
			 }
		 }

		 return new XsString(result.toString());
         }	
}

public static XsObject _unescape (XsObject xThis, XsArray args ){
	
         if(args.count == 0){
		 return _undefined;
         }
	 else{
		 String s = args.elements[0].toString();
 
                 StringBuffer buf = new StringBuffer();

		 for (int pos = 0; pos < s.length(); pos++) {
			char ch = s.charAt(pos);
			if ((ch >= 'a' && ch <= 'z')
			    || (ch >= 'A' && ch <= 'Z')
			    || (ch >= '0' && ch <= '9')) {
				buf.append(ch);
			} else if (ch == '%' && pos + 3 <= s.length()) {
                                int val;
                                if((val = Integer.parseInt(s.substring(pos + 1, pos + 3), 16)) == 0x20)
					buf.append(' '); 
                                else
					buf.append((char)val);
                                pos += 2;
			} else {
                                System.err.println("invalid input");
                                return _undefined;
				//throw new Exception("invalid input");
			}
		 }
		
	         return new XsString(buf.toString());
         }	
}

public static XsObject _toString (XsObject xThis, XsArray args ) {
        //System.out.println("HGERE");
	return new XsString(xThis.toString());
}

public static XsObject _toLocaleString (XsObject xThis, XsArray args ) {
	return _toString(xThis, args);
}

public static XsObject _hasOwnProperty(XsObject xThis, XsArray args ) {
	if(args.count == 0){
		return xFalse;
        }
        else{
	        String s;

                XsObject arg_0 = args.elements[0];  
 
                if(!(arg_0 instanceof XsString)){
			s = arg_0.xsGet("toString").invoke(arg_0).toString();
                }
                else{
			s = arg_0.toString();
                }

                int[] n_iter = new int[1];

                XsObject val = xThis.xsGet(s, n_iter);

                if(val != _undefined && n_iter[0] == 1){
			return xTrue;
                }
                else{
			return xFalse;
                }
        } 
}

public static XsObject _isPrototypeOf (XsObject xThis, XsArray args ) {
        if(args.count == 0){
		return xFalse; 
	}
        else{
                XsObject value = args.elements[0];
                
                if(value.xsGet("constructor") != XsObject._Object){
                        System.out.println("HERE too"); 
			return xFalse;
                }
		
                XsObject proto = value.__proto__;
               
                if(proto == null){
			return xFalse;
                } 
                else{
			return (proto == xThis) ? xTrue : xFalse;
                }
        }    
}

public static XsObject _propertyIsEnumerable (XsObject xThis, XsArray args ) {
        if(args.count == 0){
		return xFalse; 
	}
        else{
                String s;

                XsObject arg_0 = args.elements[0];  
 
                if(!(arg_0 instanceof XsString)){
			s = arg_0.xsGet("toString").invoke(arg_0).toString();
                }
                else{
			s = arg_0.toString();
                }

                int[] n_iter = new int[1];

                XsObject val = xThis.xsGet(s, n_iter);

                if(val != _undefined && n_iter[0] == 1){
			if(((XsPropertyAttributes)xThis.properties_attributes.get(s)).DontEnum){
				return xFalse;
                        } 
                        else{
				return xTrue;
                        }
                }
                else{
			return xFalse;
                }
        }    
}

public static XsObject _valueOf (XsObject xThis, XsArray args ) {
        return xThis.valueOf();
}

public static XsObject getPrimitiveFromObject(XsObject x){
	int[] n_iter = new int[1];
                        
	//check for valueOf 
	XsObject func = x.xsGet("valueOf", n_iter);

	//check exceptions on invoke ??

	if(!(func instanceof XsFunc) || n_iter[0] != 2){
		//check for toString
		func  = x.xsGet("toString", n_iter);
		if(func instanceof XsFunc || n_iter[0] != 2){
                        return func.invoke(x);
		}
		else{   
			return null;
		}                                  	
        }                       
	else{   
                return func.invoke(x);
	}
}

public static XsObject getPrimitiveFromDate(XsObject x){
	int[] n_iter = new int[1];
                        
	//check for toString 
	XsObject func = x.xsGet("toString");

	//check exceptions on invoke ??

	if(!(func instanceof XsFunc)){
		//check for valueOf
		func  = x.xsGet("valueOf");
		if(func instanceof XsFunc){
                        return func.invoke(x);
		}
		else{   
			return null;
		}                                  	
        }                       
	else{   
                return func.invoke(x);
	}
}

public XsObject and ( String s ){
        if(this == xTrue){
		return new XsNumber(1).and(s);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).and(s);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else{
		XsObject left = XsObject.getPrimitiveFromObject(this);

		//check exceptions on invoke ??

		if(left instanceof XsString){
			if(left instanceof XsString){
				return ((XsString) left).and(s);
			}
			else if(left instanceof XsNumber){
				if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
					return ((XsNumber)left).and(s);
				}
				else {
					return ((XsNumber)left).and(s);
				}
			}
			else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber)left).and(s);
			}
			else {
				return ((XsNumber)left).and(s);
			}
		}
                if(left == xTrue){
			return new XsNumber(1).and(s);
                }
                else if(left == xFalse){ 
                        return new XsNumber(0).and(s);
		}
                else if(left == _null){ 
                        return XsNumber.NaN;
		}
                else if(left == _undefined){ 
                        return XsNumber.NaN;
		}
		else{  
			XsObject func = this.xsGet("toString");

			if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return ((XsString) value).and(s);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return ((XsNumber)value).and(s);
					}
					else {
						return ((XsNumber)value).and(s);
					}
				}
                                if(value == xTrue){
					return new XsNumber(1).and(s);
				}
				else if(value == xFalse){ 
					return new XsNumber(0).and(s);
				}
                                else if(value == _null){ 
					return XsNumber.NaN;
				}
				else if(value == _undefined){ 
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}
		}
       }
}

public XsObject and ( XsObject x ){
        
        if(this == xTrue){
		return new XsNumber(1).and(x);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).and(x);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else if(x instanceof XsString){
		return and(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return and(((XsNumber)x).ival);
		}
		else {
			return and(((XsNumber)x).dval);
		}
        }
        else{  
		XsObject left = XsObject.getPrimitiveFromObject(this);
                
                if(left == xTrue){
			return new XsNumber(1).and(x);
                } 
                else if(left == xFalse){//System.err.println("GO");
			return new XsNumber(0).and(x);
                }
                else if(left instanceof XsString){ 
			return ((XsString) left).and(x);
                }
                else if(left instanceof XsNumber){//System.err.println("GO");
		        return ((XsNumber) left).and(x);	
                }
                else if(left instanceof XsFunc){  
                        return ((XsFunc) left).and(x);
                }
                else if(left instanceof XsArray){  // js gives error
                        return ((XsArray) left).and(x);
                }
                else{ 
			XsObject func = this.xsGet("toString");
                        
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{  
				XsObject value = func.invoke(this);

				if(value instanceof XsString){
                                        return ((XsString) value).and(x); 
				}
				else if(value instanceof XsNumber){
                                      	return ((XsNumber)value).and(x);
			       	}
                                if(value == xTrue){
					return new XsNumber(1).and(x);
				} 
				else if(value == xFalse){
					return new XsNumber(0).and(x);
				}
                                else{  
                                        XsObject right = XsObject.getPrimitiveFromObject(x);
                                        //System.err.println("right is " + right);
                                        if(left == _null || left == _undefined){
						if(right instanceof XsString){
							return new XsString(left.toString()).and(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }
                                       
                                        if(value == _null || value == _undefined){
						if(right instanceof XsString){
							return new XsString(value.toString()).and(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }                                     
					
                                        if(right instanceof XsString ||
                                           right instanceof XsNumber ||
                                           right instanceof XsArray  ||
                                           right instanceof XsFunc 
                                          )
						{      
						return value.and(right);
                                        }
                                        else{
					        if(value == _null || value == _undefined){
							return XsNumber.NaN; 
                                                }
                                                else{
							System.err.println("TypeError: can't convert Object to primitive type");
							return _undefined;
						}
                                        } 
				}
			} 
                }    
        }
}

public XsObject and ( double d ){
        if(this == xTrue){
		return new XsNumber(1 & (int)d);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0.0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).and(d);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival & (int)d);
			}
			else {
				return new XsNumber((int)((XsNumber)left).dval & (int)d);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 & (int)d);
                }
                else if(left == xFalse){
			return new XsNumber(0.0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).and(d);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival & (int)d);
					}
					else {
						return new XsNumber((int)((XsNumber)value).dval & (int)d);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 & (int)d);
				}
				else if(left == xFalse){
					return new XsNumber(0.0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject and ( int i ){
        if(this == xTrue){
		return new XsNumber(1 & i);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).and(i);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival & i);
			}
			else {
				return new XsNumber((int)((XsNumber)left).dval & i);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 & i);
                }
                else if(left == xFalse){
			return new XsNumber(0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).and(i);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival & i);
					}
					else {
						return new XsNumber((int)((XsNumber)value).dval & i);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 & i);
				}
				else if(left == xFalse){
					return new XsNumber(0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject andAssign ( XsObject index, String s ){
        return this;   
}

public XsObject andAssign ( XsObject index, XsObject x ){
        return this;
}

public XsObject andAssign ( XsObject index, double d ){
	return this;
}
	
public XsObject andAssign ( XsObject index, int i ){
        return this;
}

public XsObject andAssign ( String prop, String s ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).and(s));
        return ret;   
}

public XsObject andAssign ( String prop, XsObject x ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).and(x));
        return ret;
}

public XsObject andAssign ( String prop, double d ){
	XsObject ret;
        xsPut( prop, ret = xsGet(prop).and(d));
        return ret;
}
	
public XsObject andAssign ( String prop, int i ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).and(i));
        return ret;
}

//check these call for bad arguments or caller
public XsObject call ( Object key ) {
        //System.out.println("In call ( Object key )  before xsGet " + key); 
       
        XsObject o = xsGet(key);
         


	//        System.out.println("In call " + o);        
        if(o == _undefined){
                System.err.println("ReferenceError: " + key + " is not defined");
                return _undefined;
        }
        else if(!(o instanceof XsFunc)){
                

		System.err.println("TypeError: " + key + " is not a function");
                return _undefined; 
        }
        else{   //System.out.println("call ( Object key )");

 
                return o.invoke( this);

        }
}

public XsObject call ( Object key, XsArray args ) {
        XsObject o = xsGet(key);
        
        if(o == _undefined){
                System.err.println("ReferenceError: " + key + " is not defined");
                return _undefined;
        }
        else if(!(o instanceof XsFunc)){
        	System.err.println("TypeError: " + key + " is not a function");
		return _undefined; 
        }
	else {
                //experimental
                /*if(((XsFunc)o).ctorClass == ((XsFunc)o).mth.getClass())
                  System.out.println("In here " + ((XsFunc)o).mth   ); 
		*/
                //System.out.println("call ( Object key, XsArray args )");
		// System.out.println(this + " Calling " + key);
                return o.invoke( this, args);

        }

}
//the following two are never used anymore???
public XsObject call ( XsObject xFunc ) {

       	//System.out.println("In call  ( XsObject xFunc ) before xsGet " + xFunc); 
        if(!(xFunc instanceof XsFunc)){
                XsObject o = xsGet(xFunc);

                if(o != _undefined){

			if(!(o instanceof XsFunc)){
				System.err.println("TypeError: " + o + " is not a function");
	                        return _undefined;
                        }
                        else{
				return o.invoke( this);
                        }
                }
                else{ 
			System.err.println("TypeError: " + xFunc + " is not defined");
			return _undefined;
                }
        }
        else{   //System.out.println("call ( XsObject xFunc )");
 
                return xFunc.invoke( this);
            
        } 
}

public XsObject call ( XsObject xFunc, XsArray args ) {
        
	//System.out.println("In call  ( XsObject xFunc ) before xsGet " + xFunc + " instanceof = " + (xFunc instanceof XsFunc));
        if(!(xFunc instanceof XsFunc)){
		XsObject o = xsGet(xFunc);

                if(o != _undefined){

			if(!(o instanceof XsFunc)){
				System.err.println("TypeError: " + o + " is not a function");
	                        return _undefined;
                        }
                        else{
				return o.invoke( this, args);
                        }
                }
                else{ 
			System.err.println("TypeError: " + xFunc + " is not defined");
			return _undefined;
                }
        }
        else{
                //System.out.println("call ( XsObject xFunc, XsArray args )" + xFunc + " " + args);
 
                return xFunc.invoke( this, args);
        }
}

public XsObject callCtor (XsObject ctx) {
	return _undefined;
}

public XsObject callCtor (XsObject ctx, XsArray args ) {
	return _undefined;
}

public XsObject dec() {
	return XsNumber.getNumberFromObject(this).dec();
}

//this is being called in NewHour, find out why
//not used ???
public XsObject defFunc ( String mthName) {
        System.out.println("other defFunc being called"); 
	return  defProperty( mthName, XsFunc.getFunc( mthName, this));
}

public /*XsObject */void defFunc ( String mthName, int length ) {
	XsObject ret = defProperty( mthName, XsFunc.getFunc( mthName, this));

        XsNumber xn;
	
        ret.xsPut("length", xn = new XsNumber(length));
        XsPropertyAttributes propattrs = ((XsPropertyAttributes)ret.properties_attributes.get("length"));
        propattrs.DontEnum = true;
        propattrs.DontDelete = true;
        propattrs.ReadOnly = true;	

        ret.xsPut("arity", xn);//same reference, same thing
        ((XsPropertyAttributes)ret.properties_attributes.get("arity")).DontEnum = true;

        //return ret;
}

public XsObject defProperty ( String key, XsObject val ) {
	//this is called when declare a variable with "var"
	//System.out.println("defProperty for key = " + key + " " + val + " " + (val.__proto__ == XsArray.array__proto__));

        xsPut( key, val);
        
        if(!(val instanceof XsFunc)){ 
		//how to do the following for locals?
		((XsPropertyAttributes)properties_attributes.get(key)).DontDelete = true; 
        }
         
        //investigate what this is for 
	/*	
        
        try {
                System.out.println(getClass());

		val.ref = getClass().getField( key);
	}
	catch ( Exception e ) {
		System.out.println("Exception in defProperty key is " + key + " val is " + val);
	        System.out.println(e);
        }
	
        */

	return val;
}

private final boolean Delete(String key){
	if(properties == null){
		properties = new XsProps(11);
	        properties_attributes = new Hashtable(11);
	}

        if(properties.get(key) != null){
                if(((XsPropertyAttributes)properties_attributes.get(key)).DontDelete){
			return false;
                }
                else{
                        properties.remove(key);                        
                        return true;
                }
        }
        else{
		return true;
        }
}

public XsObject div ( String s ){
        if(this == xTrue){
		return new XsNumber(1).div(s);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).div(s);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else{
		XsObject left = XsObject.getPrimitiveFromObject(this);

		//check exceptions on invoke ??

		if(left instanceof XsString){
			if(left instanceof XsString){
				return ((XsString) left).div(s);
			}
			else if(left instanceof XsNumber){
				if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
					return ((XsNumber)left).div(s);
				}
				else {
					return ((XsNumber)left).div(s);
				}
			}
			else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber)left).div(s);
			}
			else {
				return ((XsNumber)left).div(s);
			}
		}
                if(left == xTrue){
			return new XsNumber(1).div(s);
                }
                else if(left == xFalse){ 
                        return new XsNumber(0).div(s);
		}
                else if(left == _null){ 
                        return XsNumber.NaN;
		}
                else if(left == _undefined){ 
                        return XsNumber.NaN;
		}
		else{  
			XsObject func = this.xsGet("toString");

			if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return ((XsString) value).div(s);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return ((XsNumber)value).div(s);
					}
					else {
						return ((XsNumber)value).div(s);
					}
				}
                                if(value == xTrue){
					return new XsNumber(1).div(s);
				}
				else if(value == xFalse){ 
					return new XsNumber(0).div(s);
				}
                                else if(value == _null){ 
					return XsNumber.NaN;
				}
				else if(value == _undefined){ 
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}
		}
       }
}

public XsObject div ( XsObject x ){
        
        if(this == xTrue){
		return new XsNumber(1).div(x);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).div(x);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else if(x instanceof XsString){
		return div(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return div(((XsNumber)x).ival);
		}
		else {
			return div(((XsNumber)x).dval);
		}
        }
        else{  
		XsObject left = XsObject.getPrimitiveFromObject(this);
                
                if(left == xTrue){
			return new XsNumber(1).div(x);
                } 
                else if(left == xFalse){//System.err.println("GO");
			return new XsNumber(0).div(x);
                }
                else if(left instanceof XsString){ 
			return ((XsString) left).div(x);
                }
                else if(left instanceof XsNumber){//System.err.println("GO");
		        return ((XsNumber) left).div(x);	
                }
                else if(left instanceof XsFunc){  
                        return ((XsFunc) left).div(x);
                }
                else if(left instanceof XsArray){  // js gives error
                        return ((XsArray) left).div(x);
                }
                else{ 
			XsObject func = this.xsGet("toString");
                        
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{  
				XsObject value = func.invoke(this);

				if(value instanceof XsString){
                                        return ((XsString) value).div(x); 
				}
				else if(value instanceof XsNumber){
                                      	return ((XsNumber)value).div(x);
			       	}
                                if(value == xTrue){
					return new XsNumber(1).div(x);
				} 
				else if(value == xFalse){
					return new XsNumber(0).div(x);
				}
                                else{  
                                        XsObject right = XsObject.getPrimitiveFromObject(x);
                                        //System.err.println("right is " + right);
                                        if(left == _null || left == _undefined){
						if(right instanceof XsString){
							return new XsString(left.toString()).div(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }
                                       
                                        if(value == _null || value == _undefined){
						if(right instanceof XsString){
							return new XsString(value.toString()).div(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }                                     
					
                                        if(right instanceof XsString ||
                                           right instanceof XsNumber ||
                                           right instanceof XsArray  ||
                                           right instanceof XsFunc 
                                          )
						{      
						return value.div(right);
                                        }
                                        else{
					        if(value == _null || value == _undefined){
							return XsNumber.NaN; 
                                                }
                                                else{
							System.err.println("TypeError: can't convert Object to primitive type");
							return _undefined;
						}
                                        } 
				}
			} 
                }    
        }
}

public XsObject div ( double d ){
        if(this == xTrue){
		return new XsNumber(1.0 / d);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0.0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).div(d);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival / d);
			}
			else {
				return new XsNumber(((XsNumber)left).dval / d);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1.0 / d);
                }
                else if(left == xFalse){
			return new XsNumber(0.0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).div(d);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival / d);
					}
					else {
						return new XsNumber(((XsNumber)value).dval / d);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1.0 / d);
				}
				else if(left == xFalse){
					return new XsNumber(0.0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject div ( int i ){
        if(this == xTrue){
		return new XsNumber(1 / i);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).div(i);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival / i);
			}
			else {
				return new XsNumber(((XsNumber)left).dval / i);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 / i);
                }
                else if(left == xFalse){
			return new XsNumber(0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).div(i);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival / i);
					}
					else {
						return new XsNumber(((XsNumber)value).dval / i);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 / i);
				}
				else if(left == xFalse){
					return new XsNumber(0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject divAssign ( XsObject index, String s ){
        return this;   
}

public XsObject divAssign ( XsObject index, XsObject x ){
        return this;
}

public XsObject divAssign ( XsObject index, double d ){
	return this;
}
	
public XsObject divAssign ( XsObject index, int i ){
        return this;
}

public XsObject divAssign ( String prop, String s ){

        XsObject ret;
        xsPut( prop, ret = xsGet(prop).div(s));
        return ret;   
}

public XsObject divAssign ( String prop, XsObject x ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).div(x));
        return ret;
}

public XsObject divAssign ( String prop, double d ){
	XsObject ret;
        xsPut( prop, ret = xsGet(prop).div(d));
        return ret;
}
	
public XsObject divAssign ( String prop, int i ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).div(i));
        return ret;
}

public XsObject eq ( String s ){
	XsObject left = XsObject.getPrimitiveFromObject(this);
	
        if(left instanceof XsString){
		return ((XsString) left).eq(s);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber) left).eq(s);
        }
        else if(left == xTrue){
                return (s.equals("1") || s.equals("1.0")) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return (s.equals("0") || s.equals("0.0")) ? xTrue : xFalse;  
        }
        else{
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).eq(s);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).eq(s);
		       }
		       else if(left == xTrue){
			       return (s.equals("1") || s.equals("1.0")) ? xTrue : xFalse; 
		       }
		       else if(left == xFalse || left == _null){
			       return (s.equals("0") || s.equals("0.0")) ? xTrue : xFalse;
		       }
                       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        }
}


public XsObject eq ( XsObject x ) {
        if(this == _null && x == _undefined || this == _undefined && x == _null)
		return xTrue;
	else{    
                if(x instanceof XsString){
			return eq(x.toString());
                }
                else if(x instanceof XsNumber){
			if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
				return eq(((XsNumber)x).ival);
		        }
			else {
				return eq(((XsNumber)x).dval);
		        }
		}
                else if(this == xTrue){
			return new XsNumber(1).eq(x);
                }
                else if(this == xFalse){
			return new XsNumber(0).eq(x);
                } 
                else{
                        if(x == xTrue){
				return eq(1);
                        }
                        else if(x == xTrue){
				return eq(0);
                        }
                        else{
				return ( (x == this) ? xTrue : xFalse); //maybe not correct
                        }
		}
        }
}

public XsObject eq ( double d ) {
	XsObject left = XsObject.getPrimitiveFromObject(this);
	
        if(left instanceof XsString){
		return ((XsString) left).eq(d);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber) left).eq(d);
        }
        else if(left == xTrue){
                return (d == 1.0) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return (d == 0.0) ? xTrue : xFalse; 
        }
        else{   
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).eq(d);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).eq(d);
		       }
		       else if(left == xTrue){
			       return (d == 1.0) ? xTrue : xFalse; 
		       }
		       else if(left == xFalse || left == _null){
			       return (d == 0.0) ? xTrue : xFalse; 
		       }
                       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        }
}

public XsObject eq ( int i ) {
        XsObject left = XsObject.getPrimitiveFromObject(this);
	
        if(left instanceof XsString){
		return ((XsString) left).eq(i);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber) left).eq(i);
        }
        else if(left == xTrue){
                return (i == 1) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return (i == 0) ? xTrue : xFalse; 
        }
        else{   
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).eq(i);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).eq(i);
		       }
		       else if(left == xTrue){
			       return (i == 1) ? xTrue : xFalse; 
		       }
		       else if(left == xFalse || left == _null){
			       return (i == 0) ? xTrue : xFalse; 
		       }
                       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        }
}
   
public XsObject ge ( String s ){
        XsObject left = XsObject.getPrimitiveFromObject(this);
	
        if(left instanceof XsString){
		return ((XsString) left).ge(s);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber) left).ge(s);
        }
        else if(left == xTrue){
                return ("1".compareTo(s) >= 0 || "1.0".compareTo(s) >= 0) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return ("0".compareTo(s) >= 0 || "0.0".compareTo(s) >= 0) ? xTrue : xFalse;  
        }
        else{
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).ge(s);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).ge(s);
		       }
                       else if(left == xTrue){
	                       return ("1".compareTo(s) >= 0 || "1.0".compareTo(s) >= 0) ? xTrue : xFalse; 
                       }
                       else if(left == xFalse || left == _null){
	                       return ("0".compareTo(s) >= 0 || "0.0".compareTo(s) >= 0) ? xTrue : xFalse;  
                       }
		       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        }
}

public XsObject ge ( XsObject x ) {
	if ( x instanceof XsString ){
                return ge(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return ge(((XsNumber)x).ival);
		}
		else {
			return ge(((XsNumber)x).dval);
		}
        }
        else if(this == xTrue){
                XsObject right = XsObject.getPrimitiveFromObject(x);

                if(right instanceof XsString){
                        String s = x.toString();

                        return ("1".compareTo(s) >= 0 || "1.0".compareTo(s) >= 0) ? xTrue : xFalse; 
                }
                else if(right instanceof XsNumber){
                        if (((XsNumber)right).type == XsNumber.TYPE_INT ){
                                return (1 >= ((XsNumber)right).ival) ? xTrue : xFalse; 
       		        }
			else {
				return (1.0 >= ((XsNumber)right).dval) ? xTrue : xFalse; 
			}
                }
                else if(right == xTrue || right == xFalse || right == _null){
			return xTrue;
                }
                else{
			System.err.println("TypeError: can't convert Object to primitive");
                        return _undefined;
                } 
        }
        else if(this == xFalse || this == _null){
                XsObject right = XsObject.getPrimitiveFromObject(x);

                if(right instanceof XsString){
                        String s = x.toString();

                        return ("0".compareTo(s) >= 0 || "0.0".compareTo(s) >= 0) ? xTrue : xFalse; 
                }
                else if(right instanceof XsNumber){
                        if (((XsNumber)right).type == XsNumber.TYPE_INT ){
                                return (0 >= ((XsNumber)right).ival) ? xTrue : xFalse; 
	       	        }
			else {
				return (0.0 >= ((XsNumber)right).dval) ? xTrue : xFalse; 
			}
                }
                else if(right == xFalse || right == _null){
			return xTrue;
                }
                else{
                        System.err.println("TypeError: can't convert Object to primitive");
                        return _undefined;
                }
        }
        else{  
                XsObject left = XsObject.getPrimitiveFromObject(this);
		//System.out.println("HERE" + left);
                if(left instanceof XsString){
                        return ((XsString) left).ge(x);
                }
                else if(left instanceof XsNumber){
			if (((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber) left).ge(x);
		        }
			else {
				return ((XsNumber) left).ge(x);
			}
                }
                else if(left == xTrue){
			XsObject right = XsObject.getPrimitiveFromObject(x);

			if(right instanceof XsString){
				String s = x.toString();

				return ("1".compareTo(s) >= 0 || "1.0".compareTo(s) >= 0) ? xTrue : xFalse; 
			}
			else if(right instanceof XsNumber){
				if (((XsNumber)right).type == XsNumber.TYPE_INT ){
					return (1 >= ((XsNumber)right).ival) ? xTrue : xFalse; 
			        }
				else {
					return (1.0 >= ((XsNumber)right).dval) ? xTrue : xFalse; 
				}
			}
			else if(right == xTrue || right == xFalse || right == _null){
				return xTrue;
			}
                        else if(right == _undefined){
				return xFalse;
			}
			else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			} 
		}
		else if(left == xFalse || left == _null){
			XsObject right = XsObject.getPrimitiveFromObject(x);
			//System.out.println("HERE" + right);
			if(right instanceof XsString){
				String s = x.toString();

				return ("0".compareTo(s) >= 0 || "0.0".compareTo(s) >= 0) ? xTrue : xFalse; 
			}
			else if(right instanceof XsNumber){
				if (((XsNumber)right).type == XsNumber.TYPE_INT ){
					return (0 >= ((XsNumber)right).ival) ? xTrue : xFalse; 
				}
				else {
					return (0.0 >= ((XsNumber)right).dval) ? xTrue : xFalse; 
				}
			}
			else if(right == xFalse || right == _null){
				return xTrue;
			}
                        else if(right == xTrue || right == _undefined){
				return xFalse;
			}
                        else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
                else if(left == _undefined){
                        return xFalse;
                } 
                else if(x instanceof XsFunc || x instanceof XsArray){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }
                else{
                        XsObject func = xsGet("toString");
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{
                                XsObject o = func.invoke(this);
			        
                                if(o instanceof XsString ||
                                   o instanceof XsNumber ||
                                   o == xTrue || o == xFalse ||
                                   o == _undefined || o == _null
				   )
				{
                                        return o.ge(x);
                                }
                                else{
					//try toString
					func = x.xsGet("toString");
					if(!(func instanceof XsFunc)){
						System.err.println("TypeError: can't convert Object to primitive type");
						return _undefined;
					}                                  	
					else{ //check exceptions on invoke ??
                                           //System.err.println("HERE");
						o = func.invoke(x);
						if(o instanceof XsString ||
						   o instanceof XsNumber ||
						   o == xTrue || o == xFalse ||
						   o == _undefined || o == _null
						  )
						{
							return ge(x);
						}
						else{
							System.err.println("TypeError: can't convert Object to primitive type");
							return _undefined;
						}
					}
                                }

                        }
                 } 
	        
        }
      
}

public XsObject ge ( double d ) {
        XsObject left = XsObject.getPrimitiveFromObject(this);

        if(left instanceof XsString){
                return ((XsString)left).ge(d);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber)left).ge(d);
	}
        else if(left == xTrue){
                return (1.0 >= d) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return (0.0 >= d) ? xTrue : xFalse; 
        }
        else{   
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).ge(d);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).ge(d);
		       }
                       else if(left == xTrue){
			       return (1.0 >= d) ? xTrue : xFalse; 
		       }
		       else if(left == xFalse || left == _null){
			       return (0.0 >= d) ? xTrue : xFalse; 
		       }
		       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        } 
}

public XsObject ge ( int i ) {
        XsObject left = XsObject.getPrimitiveFromObject(this);

        if(left instanceof XsString){
                return ((XsString)left).ge(i);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber)left).ge(i);
	}
        else if(left == xTrue){
                return (1 >= i) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return (0 >= i) ? xTrue : xFalse; 
        }
        else{
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).ge(i);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).ge(i);
		       }
                       else if(left == xTrue){
			       return (1 >= i) ? xTrue : xFalse; 
		       }
		       else if(left == xFalse || left == _null){
			       return (0 >= i) ? xTrue : xFalse; 
		       }
		       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        }
}

public Component getAWTComponent( boolean top ) {
	//to be resolved in DOM2
	return null;
}

public DocumentFactory getDocumentFactory() {
        //System.out.println("In getDocumentFactory");

	if ( docFactory != null ) {
                //System.out.println("In getDocumentFactory not null");
		docFactory.setXsRoot( this);
		return docFactory;
	} 
	if ( docFactoryCls == null ) {
		docFactory = new NullDocFactory();
	}
	else {//System.out.println("DocumentFactory is " + docFactoryCls);
		try {
			docFactory = (DocumentFactory)Class.forName( docFactoryCls).newInstance();
		}
		catch ( Exception _ ) {
			docFactory = new NullDocFactory();
		}
	}

	docFactory.setXsRoot( this);
	return docFactory;
}
/*
public XsNumber getNumber(){
	return XsNumber.getNumberFromObject(this);
}
*/
public NameEnumeration getPropertyNames () {
	return new NameEnumeration();
}

public XsObject gt ( String s ){
        XsObject left = XsObject.getPrimitiveFromObject(this);
	
        if(left instanceof XsString){
		return ((XsString) left).gt(s);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber) left).gt(s);
        }
        else if(left == xTrue){
                return ("1".compareTo(s) > 0 || "1.0".compareTo(s) > 0) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return ("0".compareTo(s) > 0 || "0.0".compareTo(s) > 0) ? xTrue : xFalse;  
        }
        else{
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).gt(s);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).gt(s);
		       }
                       else if(left == xTrue){
	                       return ("1".compareTo(s) > 0 || "1.0".compareTo(s) > 0) ? xTrue : xFalse; 
                       }
                       else if(left == xFalse || left == _null){
	                       return ("0".compareTo(s) > 0 || "0.0".compareTo(s) > 0) ? xTrue : xFalse;  
                       }
		       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        }
}

public XsObject gt ( XsObject x ) {
	if ( x instanceof XsString ){
                return gt(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return gt(((XsNumber)x).ival);
		}
		else {
			return gt(((XsNumber)x).dval);
		}
        }
        else if(this == xTrue){
                XsObject right = XsObject.getPrimitiveFromObject(x);

                if(right instanceof XsString){
                        String s = x.toString();

                        return ("1".compareTo(s) > 0 || "1.0".compareTo(s) > 0) ? xTrue : xFalse; 
                }
                else if(right instanceof XsNumber){
                        if (((XsNumber)right).type == XsNumber.TYPE_INT ){
                                return (1 > ((XsNumber)right).ival) ? xTrue : xFalse; 
       		        }
			else {
				return (1.0 > ((XsNumber)right).dval) ? xTrue : xFalse; 
			}
                }
                else if(right == xFalse || right == _null){
			return xTrue;
                }
                else if(right == xTrue){
			return xFalse;
                }
                else{
			System.err.println("TypeError: can't convert Object to primitive");
                        return _undefined;
                } 
        }
        else if(this == xFalse || this == _null){
                XsObject right = XsObject.getPrimitiveFromObject(x);

                if(right instanceof XsString){
                        String s = x.toString();

                        return ("0".compareTo(s) > 0 || "0.0".compareTo(s) > 0) ? xTrue : xFalse; 
                }
                else if(right instanceof XsNumber){
                        if (((XsNumber)right).type == XsNumber.TYPE_INT ){
                                return (0 > ((XsNumber)right).ival) ? xTrue : xFalse; 
	       	        }
			else {
				return (0.0 > ((XsNumber)right).dval) ? xTrue : xFalse; 
			}
                }
                else if(right == xTrue || right == xFalse || right == _null){
			return xFalse;
                }
                else{
                        System.err.println("TypeError: can't convert Object to primitive");
                        return _undefined;
                }
        }
        else{  
                XsObject left = XsObject.getPrimitiveFromObject(this);
		//System.out.println("HERE" + left);
                if(left instanceof XsString){
                        return ((XsString) left).gt(x);
                }
                else if(left instanceof XsNumber){
			if (((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber) left).gt(x);
		        }
			else {
				return ((XsNumber) left).gt(x);
			}
                }
                else if(left == xTrue){
			XsObject right = XsObject.getPrimitiveFromObject(x);

			if(right instanceof XsString){
				String s = x.toString();

				return ("1".compareTo(s) > 0 || "1.0".compareTo(s) > 0) ? xTrue : xFalse; 
			}
			else if(right instanceof XsNumber){
				if (((XsNumber)right).type == XsNumber.TYPE_INT ){
					return (1 > ((XsNumber)right).ival) ? xTrue : xFalse; 
			        }
				else {
					return (1.0 > ((XsNumber)right).dval) ? xTrue : xFalse; 
				}
			}
			else if(right == xFalse || right == _null){
				return xTrue;
			}
                        else if(right == xTrue || right == _undefined){
				return xFalse;
			}
			else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			} 
		}
		else if(left == xFalse || left == _null){
			XsObject right = XsObject.getPrimitiveFromObject(x);
			//System.out.println("HERE" + right);
			if(right instanceof XsString){
				String s = x.toString();

				return ("0".compareTo(s) > 0 || "0.0".compareTo(s) > 0) ? xTrue : xFalse; 
			}
			else if(right instanceof XsNumber){
				if (((XsNumber)right).type == XsNumber.TYPE_INT ){
					return (0 > ((XsNumber)right).ival) ? xTrue : xFalse; 
				}
				else {
					return (0.0 > ((XsNumber)right).dval) ? xTrue : xFalse; 
				}
			}
			else if(right == xFalse || right == _null || right == xTrue || right == _undefined){
				return xFalse;
			}
                        else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
                else if(left == _undefined){
                        return xFalse;
                } 
                else if(x instanceof XsFunc || x instanceof XsArray){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }
                else{
                        XsObject func = xsGet("toString");
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{
                                XsObject o = func.invoke(this);
			        
                                if(o instanceof XsString ||
                                   o instanceof XsNumber ||
                                   o == xTrue || o == xFalse ||
                                   o == _undefined || o == _null
				   )
				{
                                        return o.gt(x);
                                }
                                else{
					//try toString
					func = x.xsGet("toString");
					if(!(func instanceof XsFunc)){
						System.err.println("TypeError: can't convert Object to primitive type");
						return _undefined;
					}                                  	
					else{ //check exceptions on invoke ??
                                           //System.err.println("HERE");
						o = func.invoke(x);
						if(o instanceof XsString ||
						   o instanceof XsNumber ||
						   o == xTrue || o == xFalse ||
						   o == _undefined || o == _null
						  )
						{
							return gt(x);
						}
						else{
							System.err.println("TypeError: can't convert Object to primitive type");
							return _undefined;
						}
					}
                                }

                        }
                 } 
	        
        }
      
}

public XsObject gt ( double d ) {
        XsObject left = XsObject.getPrimitiveFromObject(this);

        if(left instanceof XsString){
                return ((XsString)left).gt(d);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber)left).gt(d);
	}
        else if(left == xTrue){
                return (1.0 > d) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return (0.0 > d) ? xTrue : xFalse; 
        }
        else{   
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).gt(d);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).gt(d);
		       }
                       else if(left == xTrue){
			       return (1.0 > d) ? xTrue : xFalse; 
		       }
		       else if(left == xFalse || left == _null){
			       return (0.0 > d) ? xTrue : xFalse; 
		       }
		       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        } 
}

public XsObject gt ( int i ) {
        XsObject left = XsObject.getPrimitiveFromObject(this);

        if(left instanceof XsString){
                return ((XsString)left).gt(i);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber)left).gt(i);
	}
        else if(left == xTrue){
                return (1 > i) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return (0 > i) ? xTrue : xFalse; 
        }
        else{
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).gt(i);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).gt(i);
		       }
                       else if(left == xTrue){
			       return (1 > i) ? xTrue : xFalse; 
		       }
		       else if(left == xFalse || left == _null){
			       return (0 > i) ? xTrue : xFalse; 
		       }
		       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        }
}

public XsObject inc() {
        return XsNumber.getNumberFromObject(this).inc();
}

public XsObject invoke ( XsObject xThis ) {
	return _undefined;
}

public XsObject invoke ( XsObject xThis, XsArray args ) {
	return _undefined;
}

public XsObject le ( String s ){
        XsObject left = XsObject.getPrimitiveFromObject(this);
	
        if(left instanceof XsString){
		return ((XsString) left).le(s);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber) left).le(s);
        }
        else if(left == xTrue){
                return ("1".compareTo(s) <= 0 || "1.0".compareTo(s) <= 0) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return ("0".compareTo(s) <= 0 || "0.0".compareTo(s) <= 0) ? xTrue : xFalse;  
        }
        else{
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).le(s);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).le(s);
		       }
                       else if(left == xTrue){
	                       return ("1".compareTo(s) <= 0 || "1.0".compareTo(s) <= 0) ? xTrue : xFalse; 
                       }
                       else if(left == xFalse || left == _null){
	                       return ("0".compareTo(s) <= 0 || "0.0".compareTo(s) <= 0) ? xTrue : xFalse;  
                       }
		       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        }
}

public XsObject le ( XsObject x ) {
	if ( x instanceof XsString ){
                return le(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return le(((XsNumber)x).ival);
		}
		else {
			return le(((XsNumber)x).dval);
		}
        }
        else if(this == xTrue){
                XsObject right = XsObject.getPrimitiveFromObject(x);

                if(right instanceof XsString){
                        String s = x.toString();

                        return ("1".compareTo(s) <= 0 || "1.0".compareTo(s) <= 0) ? xTrue : xFalse; 
                }
                else if(right instanceof XsNumber){
                        if (((XsNumber)right).type == XsNumber.TYPE_INT ){
                                return (1 <= ((XsNumber)right).ival) ? xTrue : xFalse; 
       		        }
			else {
				return (1.0 <= ((XsNumber)right).dval) ? xTrue : xFalse; 
			}
                }
                else if(right == xFalse || right == _null){
			return xFalse;
                }
                else if(right == xTrue){
			return xTrue;
                }
                else{
			System.err.println("TypeError: can't convert Object to primitive");
                        return _undefined;
                } 
        }
        else if(this == xFalse || this == _null){
                XsObject right = XsObject.getPrimitiveFromObject(x);

                if(right instanceof XsString){
                        String s = x.toString();

                        return ("0".compareTo(s) <= 0 || "0.0".compareTo(s) <= 0) ? xTrue : xFalse; 
                }
                else if(right instanceof XsNumber){
                        if (((XsNumber)right).type == XsNumber.TYPE_INT ){
                                return (0 <= ((XsNumber)right).ival) ? xTrue : xFalse; 
	       	        }
			else {
				return (0.0 <= ((XsNumber)right).dval) ? xTrue : xFalse; 
			}
                }
                else if(right == xTrue || right == xFalse || right == _null){
			return xTrue;
                }
                else{
                        System.err.println("TypeError: can't convert Object to primitive");
                        return _undefined;
                }
        }
        else{  
                XsObject left = XsObject.getPrimitiveFromObject(this);
		//System.out.println("HERE" + left);
                if(left instanceof XsString){
                        return ((XsString) left).le(x);
                }
                else if(left instanceof XsNumber){
			if (((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber) left).le(x);
		        }
			else {
				return ((XsNumber) left).le(x);
			}
                }
                else if(left == xTrue){
			XsObject right = XsObject.getPrimitiveFromObject(x);

			if(right instanceof XsString){
				String s = x.toString();

				return ("1".compareTo(s) <= 0 || "1.0".compareTo(s) <= 0) ? xTrue : xFalse; 
			}
			else if(right instanceof XsNumber){
				if (((XsNumber)right).type == XsNumber.TYPE_INT ){
					return (1 <= ((XsNumber)right).ival) ? xTrue : xFalse; 
			        }
				else {
					return (1.0 <= ((XsNumber)right).dval) ? xTrue : xFalse; 
				}
			}
			else if(right == xFalse || right == _null || right == xTrue || right == _undefined){
				return xTrue;
			}
                        else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			} 
		}
		else if(left == xFalse || left == _null){
			XsObject right = XsObject.getPrimitiveFromObject(x);
			//System.out.println("HERE" + right);
			if(right instanceof XsString){
				String s = x.toString();

				return ("0".compareTo(s) <= 0 || "0.0".compareTo(s) <= 0) ? xTrue : xFalse; 
			}
			else if(right instanceof XsNumber){
				if (((XsNumber)right).type == XsNumber.TYPE_INT ){
					return (0 <= ((XsNumber)right).ival) ? xTrue : xFalse; 
				}
				else {
					return (0.0 <= ((XsNumber)right).dval) ? xTrue : xFalse; 
				}
			}
			else if(right == xFalse || right == _null || right == xTrue || right == _undefined){
				return xTrue;
			}
                        else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
                else if(left == _undefined){
                        return xFalse;
                } 
                else if(x instanceof XsFunc || x instanceof XsArray){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }
                else{
                        XsObject func = xsGet("toString");
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{
                                XsObject o = func.invoke(this);
			        
                                if(o instanceof XsString ||
                                   o instanceof XsNumber ||
                                   o == xTrue || o == xFalse ||
                                   o == _undefined || o == _null
				   )
				{
                                        return o.le(x);
                                }
                                else{
					//try toString
					func = x.xsGet("toString");
					if(!(func instanceof XsFunc)){
						System.err.println("TypeError: can't convert Object to primitive type");
						return _undefined;
					}                                  	
					else{ //check exceptions on invoke ??
                                           //System.err.println("HERE");
						o = func.invoke(x);
						if(o instanceof XsString ||
						   o instanceof XsNumber ||
						   o == xTrue || o == xFalse ||
						   o == _undefined || o == _null
						  )
						{
							return le(x);
						}
						else{
							System.err.println("TypeError: can't convert Object to primitive type");
							return _undefined;
						}
					}
                                }

                        }
                 } 
        }
}

public XsObject le ( double d ) {
        XsObject left = XsObject.getPrimitiveFromObject(this);

        if(left instanceof XsString){
                return ((XsString)left).le(d);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber)left).le(d);
	}
        else if(left == xTrue){
                return (1.0 <= d) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return (0.0 <= d) ? xTrue : xFalse; 
        }
        else{   
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).le(d);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).le(d);
		       }
                       else if(left == xTrue){
			       return (1.0 <= d) ? xTrue : xFalse; 
		       }
		       else if(left == xFalse || left == _null){
			       return (0.0 <= d) ? xTrue : xFalse; 
		       }
		       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        } 
}

public XsObject le ( int i ) {
        XsObject left = XsObject.getPrimitiveFromObject(this);

        if(left instanceof XsString){
                return ((XsString)left).le(i);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber)left).le(i);
	}
        else if(left == xTrue){
                return (1 <= i) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return (0 <= i) ? xTrue : xFalse; 
        }
        else{
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).le(i);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).le(i);
		       }
                       else if(left == xTrue){
			       return (1 <= i) ? xTrue : xFalse; 
		       }
		       else if(left == xFalse || left == _null){
			       return (0 <= i) ? xTrue : xFalse; 
		       }
		       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        }
}

public XsObject lt ( String s ){
        XsObject left = XsObject.getPrimitiveFromObject(this);
	
        if(left instanceof XsString){
		return ((XsString) left).lt(s);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber) left).lt(s);
        }
        else if(left == xTrue){
                return ("1".compareTo(s) < 0 || "1.0".compareTo(s) < 0) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return ("0".compareTo(s) < 0 || "0.0".compareTo(s) < 0) ? xTrue : xFalse;  
        }
        else{
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).lt(s);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).lt(s);
		       }
                       else if(left == xTrue){
	                       return ("1".compareTo(s) < 0 || "1.0".compareTo(s) < 0) ? xTrue : xFalse; 
                       }
                       else if(left == xFalse || left == _null){
	                       return ("0".compareTo(s) < 0 || "0.0".compareTo(s) < 0) ? xTrue : xFalse;  
                       }
		       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        }
}

public XsObject lt ( XsObject x ) {
	if ( x instanceof XsString ){
                return lt(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return lt(((XsNumber)x).ival);
		}
		else {
			return lt(((XsNumber)x).dval);
		}
        }
        else if(this == xTrue){
                XsObject right = XsObject.getPrimitiveFromObject(x);

                if(right instanceof XsString){
                        String s = x.toString();

                        return ("1".compareTo(s) < 0 || "1.0".compareTo(s) < 0) ? xTrue : xFalse; 
                }
                else if(right instanceof XsNumber){
                        if (((XsNumber)right).type == XsNumber.TYPE_INT ){
                                return (1 < ((XsNumber)right).ival) ? xTrue : xFalse; 
       		        }
			else {
				return (1.0 < ((XsNumber)right).dval) ? xTrue : xFalse; 
			}
                }
                else if(right == xFalse || right == _null || right == xTrue){
			return xFalse;
                }
                else{
			System.err.println("TypeError: can't convert Object to primitive");
                        return _undefined;
                } 
        }
        else if(this == xFalse || this == _null){
                XsObject right = XsObject.getPrimitiveFromObject(x);

                if(right instanceof XsString){
                        String s = x.toString();

                        return ("0".compareTo(s) < 0 || "0.0".compareTo(s) < 0) ? xTrue : xFalse; 
                }
                else if(right instanceof XsNumber){
                        if (((XsNumber)right).type == XsNumber.TYPE_INT ){
                                return (0 < ((XsNumber)right).ival) ? xTrue : xFalse; 
	       	        }
			else {
				return (0.0 < ((XsNumber)right).dval) ? xTrue : xFalse; 
			}
                }
                else if(right == xTrue){
			return xTrue;
                }
                else if(right == xFalse || right == _null){
			return xFalse;
                }
                else{
                        System.err.println("TypeError: can't convert Object to primitive");
                        return _undefined;
                }
        }
        else{  
                XsObject left = XsObject.getPrimitiveFromObject(this);
		//System.out.println("HERE" + left);
                if(left instanceof XsString){
                        return ((XsString) left).lt(x);
                }
                else if(left instanceof XsNumber){
			if (((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber) left).lt(x);
		        }
			else {
				return ((XsNumber) left).lt(x);
			}
                }
                else if(left == xTrue){
			XsObject right = XsObject.getPrimitiveFromObject(x);

			if(right instanceof XsString){
				String s = x.toString();

				return ("1".compareTo(s) < 0 || "1.0".compareTo(s) < 0) ? xTrue : xFalse; 
			}
			else if(right instanceof XsNumber){
				if (((XsNumber)right).type == XsNumber.TYPE_INT ){
					return (1 < ((XsNumber)right).ival) ? xTrue : xFalse; 
			        }
				else {
					return (1.0 < ((XsNumber)right).dval) ? xTrue : xFalse; 
				}
			}
			else if(right == xFalse || right == _null || right == xTrue || right == _undefined){
				return xFalse;
			}
                        else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			} 
		}
		else if(left == xFalse || left == _null){
			XsObject right = XsObject.getPrimitiveFromObject(x);
			//System.out.println("HERE" + right);
			if(right instanceof XsString){
				String s = x.toString();

				return ("0".compareTo(s) < 0 || "0.0".compareTo(s) < 0) ? xTrue : xFalse; 
			}
			else if(right instanceof XsNumber){
				if (((XsNumber)right).type == XsNumber.TYPE_INT ){
					return (0 < ((XsNumber)right).ival) ? xTrue : xFalse; 
				}
				else {
					return (0.0 < ((XsNumber)right).dval) ? xTrue : xFalse; 
				}
			}
			else if(right == xTrue){
				return xTrue;
			}
                        else if(right == xFalse || right == _null || right == _undefined){
				return xFalse;
			} 
                        else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
                else if(left == _undefined){
                        return xFalse;
                } 
                else if(x instanceof XsFunc || x instanceof XsArray){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }
                else{
                        XsObject func = xsGet("toString");
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{
                                XsObject o = func.invoke(this);
			        
                                if(o instanceof XsString ||
                                   o instanceof XsNumber ||
                                   o == xTrue || o == xFalse ||
                                   o == _undefined || o == _null
				   )
				{
                                        return o.lt(x);
                                }
                                else{
					//try toString
					func = x.xsGet("toString");
					if(!(func instanceof XsFunc)){
						System.err.println("TypeError: can't convert Object to primitive type");
						return _undefined;
					}                                  	
					else{ //check exceptions on invoke ??
                                           //System.err.println("HERE");
						o = func.invoke(x);
						if(o instanceof XsString ||
						   o instanceof XsNumber ||
						   o == xTrue || o == xFalse ||
						   o == _undefined || o == _null
						  )
						{
							return lt(x);
						}
						else{
							System.err.println("TypeError: can't convert Object to primitive type");
							return _undefined;
						}
					}
                                }
                         }
                 } 
	}
      
}

public XsObject lt ( double d ) {
        XsObject left = XsObject.getPrimitiveFromObject(this);

        if(left instanceof XsString){
                return ((XsString)left).lt(d);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber)left).lt(d);
	}
        else if(left == xTrue){
                return (1.0 < d) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return (0.0 < d) ? xTrue : xFalse; 
        }
        else{   
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).lt(d);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).lt(d);
		       }
                       else if(left == xTrue){
			       return (1.0 < d) ? xTrue : xFalse; 
		       }
		       else if(left == xFalse || left == _null){
			       return (0.0 < d) ? xTrue : xFalse; 
		       }
		       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        } 
}

public XsObject lt ( int i ) {
        XsObject left = XsObject.getPrimitiveFromObject(this);

        if(left instanceof XsString){
                return ((XsString)left).lt(i);
        }
        else if(left instanceof XsNumber){
		return ((XsNumber)left).lt(i);
	}
        else if(left == xTrue){
                return (1 < i) ? xTrue : xFalse; 
        }
        else if(left == xFalse || left == _null){
		return (0 < i) ? xTrue : xFalse; 
        }
        else{
                //try toString
                XsObject func = this.xsGet("toString");

                //check exceptions on invoke ??

                if(!(func instanceof XsFunc)){
			System.err.println("TypeError: can't convert Object to primitive type");
			return _undefined;
                }                                  	
	        else{   
                       left = func.invoke(this);
                       if(left instanceof XsString){
			       return ((XsString) left).lt(i);
		       }
		       else if(left instanceof XsNumber){
			       return ((XsNumber) left).lt(i);
		       }
                       else if(left == xTrue){
			       return (1 < i) ? xTrue : xFalse; 
		       }
		       else if(left == xFalse || left == _null){
			       return (0 < i) ? xTrue : xFalse; 
		       }
		       else{
                              System.err.println("TypeError: can't convert Object to primitive");
                              return _undefined;
                       }
                }
        }
}

public XsObject minus ( String s ){
        if(this == xTrue){
		return new XsNumber(1).minus(s);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).minus(s);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else{
		XsObject left = XsObject.getPrimitiveFromObject(this);

		//check exceptions on invoke ??

		if(left instanceof XsString){
			if(left instanceof XsString){
				return ((XsString) left).minus(s);
			}
			else if(left instanceof XsNumber){
				if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
					return ((XsNumber)left).minus(s);
				}
				else {
					return ((XsNumber)left).minus(s);
				}
			}
			else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber)left).minus(s);
			}
			else {
				return ((XsNumber)left).minus(s);
			}
		}
                if(left == xTrue){
			return new XsNumber(1).minus(s);
                }
                else if(left == xFalse){ 
                        return new XsNumber(0).minus(s);
		}
                else if(left == _null){ 
                        return XsNumber.NaN;
		}
                else if(left == _undefined){ 
                        return XsNumber.NaN;
		}
		else{  
			XsObject func = this.xsGet("toString");

			if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return ((XsString) value).minus(s);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return ((XsNumber)value).minus(s);
					}
					else {
						return ((XsNumber)value).minus(s);
					}
				}
                                if(value == xTrue){
					return new XsNumber(1).minus(s);
				}
				else if(value == xFalse){ 
					return new XsNumber(0).minus(s);
				}
                                else if(value == _null){ 
					return XsNumber.NaN;
				}
				else if(value == _undefined){ 
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}
		}
       }
}

public XsObject minus ( XsObject x ){
        
        if(this == xTrue){
		return new XsNumber(1).minus(x);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).minus(x);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else if(x instanceof XsString){
		return minus(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return minus(((XsNumber)x).ival);
		}
		else {
			return minus(((XsNumber)x).dval);
		}
        }
        else{  
		XsObject left = XsObject.getPrimitiveFromObject(this);
                
                if(left == xTrue){
			return new XsNumber(1).minus(x);
                } 
                else if(left == xFalse){//System.err.println("GO");
			return new XsNumber(0).minus(x);
                }
                else if(left instanceof XsString){ 
			return ((XsString) left).minus(x);
                }
                else if(left instanceof XsNumber){//System.err.println("GO");
		        return ((XsNumber) left).minus(x);	
                }
                else if(left instanceof XsFunc){  
                        return ((XsFunc) left).minus(x);
                }
                else if(left instanceof XsArray){  // js gives error
                        return ((XsArray) left).minus(x);
                }
                else{ 
			XsObject func = this.xsGet("toString");
                        
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{  
				XsObject value = func.invoke(this);

				if(value instanceof XsString){
                                        return ((XsString) value).minus(x); 
				}
				else if(value instanceof XsNumber){
                                      	return ((XsNumber)value).minus(x);
			       	}
                                if(value == xTrue){
					return new XsNumber(1).minus(x);
				} 
				else if(value == xFalse){
					return new XsNumber(0).minus(x);
				}
                                else{  
                                        XsObject right = XsObject.getPrimitiveFromObject(x);
                                        //System.err.println("right is " + right);
                                        if(left == _null || left == _undefined){
						if(right instanceof XsString){
							return new XsString(left.toString()).minus(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }
                                       
                                        if(value == _null || value == _undefined){
						if(right instanceof XsString){
							return new XsString(value.toString()).minus(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }                                     
					
                                        if(right instanceof XsString ||
                                           right instanceof XsNumber ||
                                           right instanceof XsArray  ||
                                           right instanceof XsFunc 
                                          )
						{      
						return value.minus(right);
                                        }
                                        else{
					        if(value == _null || value == _undefined){
							return XsNumber.NaN; 
                                                }
                                                else{
							System.err.println("TypeError: can't convert Object to primitive type");
							return _undefined;
						}
                                        } 
				}
			} 
                }    
        }
}

public XsObject minus ( double d ){
        if(this == xTrue){
		return new XsNumber(1.0 - d);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0.0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).minus(d);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival - d);
			}
			else {
				return new XsNumber(((XsNumber)left).dval - d);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1.0 - d);
                }
                else if(left == xFalse){
			return new XsNumber(0.0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).minus(d);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival - d);
					}
					else {
						return new XsNumber(((XsNumber)value).dval - d);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1.0 - d);
				}
				else if(left == xFalse){
					return new XsNumber(0.0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject minus ( int i ){
        if(this == xTrue){
		return new XsNumber(1 - i);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).minus(i);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival - i);
			}
			else {
				return new XsNumber(((XsNumber)left).dval - i);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 - i);
                }
                else if(left == xFalse){
			return new XsNumber(0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).minus(i);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival - i);
					}
					else {
						return new XsNumber(((XsNumber)value).dval - i);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 - i);
				}
				else if(left == xFalse){
					return new XsNumber(0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject minusAssign ( XsObject index, String s ){
        return this;   
}

public XsObject minusAssign ( XsObject index, XsObject x ){
        return this;
}

public XsObject minusAssign ( XsObject index, double d ){
	return this;
}
	
public XsObject minusAssign ( XsObject index, int i ){
        return this;
}

public XsObject minusAssign ( String prop, String s ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).minus(s));
        return ret;   
}

public XsObject minusAssign ( String prop, XsObject x ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).minus(x));
        return ret;
}

public XsObject minusAssign ( String prop, double d ){
	XsObject ret;
        xsPut( prop, ret = xsGet(prop).minus(d));
        return ret;
}
	
public XsObject minusAssign ( String prop, int i ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).minus(i));
        return ret;
}

public XsObject mod ( String s ){
        if(this == xTrue){
		return new XsNumber(1).mod(s);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).mod(s);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else{
		XsObject left = XsObject.getPrimitiveFromObject(this);

		//check exceptions on invoke ??

		if(left instanceof XsString){
			if(left instanceof XsString){
				return ((XsString) left).mod(s);
			}
			else if(left instanceof XsNumber){
				if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
					return ((XsNumber)left).mod(s);
				}
				else {
					return ((XsNumber)left).mod(s);
				}
			}
			else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber)left).mod(s);
			}
			else {
				return ((XsNumber)left).mod(s);
			}
		}
                if(left == xTrue){
			return new XsNumber(1).mod(s);
                }
                else if(left == xFalse){ 
                        return new XsNumber(0).mod(s);
		}
                else if(left == _null){ 
                        return XsNumber.NaN;
		}
                else if(left == _undefined){ 
                        return XsNumber.NaN;
		}
		else{  
			XsObject func = this.xsGet("toString");

			if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return ((XsString) value).mod(s);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return ((XsNumber)value).mod(s);
					}
					else {
						return ((XsNumber)value).mod(s);
					}
				}
                                if(value == xTrue){
					return new XsNumber(1).mod(s);
				}
				else if(value == xFalse){ 
					return new XsNumber(0).mod(s);
				}
                                else if(value == _null){ 
					return XsNumber.NaN;
				}
				else if(value == _undefined){ 
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}
		}
       }
}

public XsObject mod ( XsObject x ){
        
        if(this == xTrue){
		return new XsNumber(1).mod(x);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).mod(x);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else if(x instanceof XsString){
		return mod(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return mod(((XsNumber)x).ival);
		}
		else {
			return mod(((XsNumber)x).dval);
		}
        }
        else{  
		XsObject left = XsObject.getPrimitiveFromObject(this);
                
                if(left == xTrue){
			return new XsNumber(1).mod(x);
                } 
                else if(left == xFalse){//System.err.println("GO");
			return new XsNumber(0).mod(x);
                }
                else if(left instanceof XsString){ 
			return ((XsString) left).mod(x);
                }
                else if(left instanceof XsNumber){//System.err.println("GO");
		        return ((XsNumber) left).mod(x);	
                }
                else if(left instanceof XsFunc){  
                        return ((XsFunc) left).mod(x);
                }
                else if(left instanceof XsArray){  // js gives error
                        return ((XsArray) left).mod(x);
                }
                else{ 
			XsObject func = this.xsGet("toString");
                        
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{  
				XsObject value = func.invoke(this);

				if(value instanceof XsString){
                                        return ((XsString) value).mod(x); 
				}
				else if(value instanceof XsNumber){
                                      	return ((XsNumber)value).mod(x);
			       	}
                                if(value == xTrue){
					return new XsNumber(1).mod(x);
				} 
				else if(value == xFalse){
					return new XsNumber(0).mod(x);
				}
                                else{  
                                        XsObject right = XsObject.getPrimitiveFromObject(x);
                                        //System.err.println("right is " + right);
                                        if(left == _null || left == _undefined){
						if(right instanceof XsString){
							return new XsString(left.toString()).mod(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }
                                       
                                        if(value == _null || value == _undefined){
						if(right instanceof XsString){
							return new XsString(value.toString()).mod(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }                                     
					
                                        if(right instanceof XsString ||
                                           right instanceof XsNumber ||
                                           right instanceof XsArray  ||
                                           right instanceof XsFunc 
                                          )
						{      
						return value.mod(right);
                                        }
                                        else{
					        if(value == _null || value == _undefined){
							return XsNumber.NaN; 
                                                }
                                                else{
							System.err.println("TypeError: can't convert Object to primitive type");
							return _undefined;
						}
                                        } 
				}
			} 
                }    
        }
}

public XsObject mod ( double d ){
        if(this == xTrue){
		return new XsNumber(1.0 - d);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0.0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).mod(d);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival - d);
			}
			else {
				return new XsNumber(((XsNumber)left).dval - d);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1.0 - d);
                }
                else if(left == xFalse){
			return new XsNumber(0.0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).mod(d);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival - d);
					}
					else {
						return new XsNumber(((XsNumber)value).dval - d);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1.0 - d);
				}
				else if(left == xFalse){
					return new XsNumber(0.0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject mod ( int i ){
        if(this == xTrue){
		return new XsNumber(1 - i);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).mod(i);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival - i);
			}
			else {
				return new XsNumber(((XsNumber)left).dval - i);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 - i);
                }
                else if(left == xFalse){
			return new XsNumber(0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).mod(i);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival - i);
					}
					else {
						return new XsNumber(((XsNumber)value).dval - i);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 - i);
				}
				else if(left == xFalse){
					return new XsNumber(0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject modAssign ( XsObject index, String s ){
        return this;   
}

public XsObject modAssign ( XsObject index, XsObject x ){
        return this;
}

public XsObject modAssign ( XsObject index, double d ){
	return this;
}
	
public XsObject modAssign ( XsObject index, int i ){
        return this;
}

public XsObject modAssign ( String prop, String s ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).mod(s));
        return ret;   
}

public XsObject modAssign ( String prop, XsObject x ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).mod(x));
        return ret;
}

public XsObject modAssign ( String prop, double d ){
	XsObject ret;
        xsPut( prop, ret = xsGet(prop).mod(d));
        return ret;
}
	
public XsObject modAssign ( String prop, int i ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).mod(i));
        return ret;
}

public XsObject mul ( String s ){
        if(this == xTrue){
		return new XsNumber(1).mul(s);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).mul(s);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else{
		XsObject left = XsObject.getPrimitiveFromObject(this);

		//check exceptions on invoke ??

		if(left instanceof XsString){
			if(left instanceof XsString){
				return ((XsString) left).mul(s);
			}
			else if(left instanceof XsNumber){
				if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
					return ((XsNumber)left).mul(s);
				}
				else {
					return ((XsNumber)left).mul(s);
				}
			}
			else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber)left).mul(s);
			}
			else {
				return ((XsNumber)left).mul(s);
			}
		}
                if(left == xTrue){
			return new XsNumber(1).mul(s);
                }
                else if(left == xFalse){ 
                        return new XsNumber(0).mul(s);
		}
                else if(left == _null){ 
                        return XsNumber.NaN;
		}
                else if(left == _undefined){ 
                        return XsNumber.NaN;
		}
		else{  
			XsObject func = this.xsGet("toString");

			if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return ((XsString) value).mul(s);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return ((XsNumber)value).mul(s);
					}
					else {
						return ((XsNumber)value).mul(s);
					}
				}
                                if(value == xTrue){
					return new XsNumber(1).mul(s);
				}
				else if(value == xFalse){ 
					return new XsNumber(0).mul(s);
				}
                                else if(value == _null){ 
					return XsNumber.NaN;
				}
				else if(value == _undefined){ 
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}
		}
       }
}

public XsObject mul ( XsObject x ){
        
        if(this == xTrue){
		return new XsNumber(1).mul(x);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).mul(x);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else if(x instanceof XsString){
		return mul(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return mul(((XsNumber)x).ival);
		}
		else {
			return mul(((XsNumber)x).dval);
		}
        }
        else{  
		XsObject left = XsObject.getPrimitiveFromObject(this);
                
                if(left == xTrue){
			return new XsNumber(1).mul(x);
                } 
                else if(left == xFalse){//System.err.println("GO");
			return new XsNumber(0).mul(x);
                }
                else if(left instanceof XsString){ 
			return ((XsString) left).mul(x);
                }
                else if(left instanceof XsNumber){//System.err.println("GO");
		        return ((XsNumber) left).mul(x);	
                }
                else if(left instanceof XsFunc){  
                        return ((XsFunc) left).mul(x);
                }
                else if(left instanceof XsArray){  // js gives error
                        return ((XsArray) left).mul(x);
                }
                else{ 
			XsObject func = this.xsGet("toString");
                        
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{  
				XsObject value = func.invoke(this);

				if(value instanceof XsString){
                                        return ((XsString) value).mul(x); 
				}
				else if(value instanceof XsNumber){
                                      	return ((XsNumber)value).mul(x);
			       	}
                                if(value == xTrue){
					return new XsNumber(1).mul(x);
				} 
				else if(value == xFalse){
					return new XsNumber(0).mul(x);
				}
                                else{  
                                        XsObject right = XsObject.getPrimitiveFromObject(x);
                                        //System.err.println("right is " + right);
                                        if(left == _null || left == _undefined){
						if(right instanceof XsString){
							return new XsString(left.toString()).mul(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }
                                       
                                        if(value == _null || value == _undefined){
						if(right instanceof XsString){
							return new XsString(value.toString()).mul(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }                                     
					
                                        if(right instanceof XsString ||
                                           right instanceof XsNumber ||
                                           right instanceof XsArray  ||
                                           right instanceof XsFunc 
                                          )
						{      
						return value.mul(right);
                                        }
                                        else{
					        if(value == _null || value == _undefined){
							return XsNumber.NaN; 
                                                }
                                                else{
							System.err.println("TypeError: can't convert Object to primitive type");
							return _undefined;
						}
                                        } 
				}
			} 
                }    
        }
}

public XsObject mul ( double d ){
        if(this == xTrue){
		return new XsNumber(1.0 * d);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0.0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).mul(d);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival * d);
			}
			else {
				return new XsNumber(((XsNumber)left).dval * d);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1.0 * d);
                }
                else if(left == xFalse){
			return new XsNumber(0.0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).mul(d);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival * d);
					}
					else {
						return new XsNumber(((XsNumber)value).dval * d);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1.0 * d);
				}
				else if(left == xFalse){
					return new XsNumber(0.0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject mul ( int i ){
        if(this == xTrue){
		return new XsNumber(1 * i);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).mul(i);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival * i);
			}
			else {
				return new XsNumber(((XsNumber)left).dval * i);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 * i);
                }
                else if(left == xFalse){
			return new XsNumber(0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).mul(i);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival * i);
					}
					else {
						return new XsNumber(((XsNumber)value).dval * i);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 * i);
				}
				else if(left == xFalse){
					return new XsNumber(0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject mulAssign ( XsObject index, String s ){
        return this;   
}

public XsObject mulAssign ( XsObject index, XsObject x ){
        return this;
}

public XsObject mulAssign ( XsObject index, double d ){
	return this;
}
	
public XsObject mulAssign ( XsObject index, int i ){
        return this;
}

public XsObject mulAssign ( String prop, String s ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).mul(s));
        return ret;   
}

public XsObject mulAssign ( String prop, XsObject x ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).mul(x));
        return ret;
}

public XsObject mulAssign ( String prop, double d ){
	XsObject ret;
        xsPut( prop, ret = xsGet(prop).mul(d));
        return ret;
}
	
public XsObject mulAssign ( String prop, int i ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).mul(i));
        return ret;
}

public XsObject neg ( ) {
        return XsNumber.getNumberFromObject(this).neg();
}

public XsObject not ( ) {
	XsNumber xn = XsNumber.getNumberFromObject(this);
        if(xn != XsNumber.NaN){
		if ( xn.type == XsNumber.TYPE_INT ){
			return new XsNumber(~xn.ival);
		}
		else {
			return new XsNumber(~(int)xn.dval);
		}
        }
        else
		return new XsNumber(-1);
}

public XsObject notEq ( String s ){
	return (eq(s) == xTrue) ? xFalse : xTrue;
}

public XsObject notEq (XsObject x ){
	return (eq(x) == xTrue) ? xFalse : xTrue;
}

public XsObject notEq ( double d ){
	return (eq(d) == xTrue) ? xFalse : xTrue;
}

public XsObject notEq ( int i ){
	return (eq(i) == xTrue) ? xFalse : xTrue;
}

public XsObject or ( String s ){
        if(this == xTrue){
		return new XsNumber(1).or(s);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).or(s);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else{
		XsObject left = XsObject.getPrimitiveFromObject(this);

		//check exceptions on invoke ??

		if(left instanceof XsString){
			if(left instanceof XsString){
				return ((XsString) left).or(s);
			}
			else if(left instanceof XsNumber){
				if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
					return ((XsNumber)left).or(s);
				}
				else {
					return ((XsNumber)left).or(s);
				}
			}
			else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber)left).or(s);
			}
			else {
				return ((XsNumber)left).or(s);
			}
		}
                if(left == xTrue){
			return new XsNumber(1).or(s);
                }
                else if(left == xFalse){ 
                        return new XsNumber(0).or(s);
		}
                else if(left == _null){ 
                        return XsNumber.NaN;
		}
                else if(left == _undefined){ 
                        return XsNumber.NaN;
		}
		else{  
			XsObject func = this.xsGet("toString");

			if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return ((XsString) value).or(s);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return ((XsNumber)value).or(s);
					}
					else {
						return ((XsNumber)value).or(s);
					}
				}
                                if(value == xTrue){
					return new XsNumber(1).or(s);
				}
				else if(value == xFalse){ 
					return new XsNumber(0).or(s);
				}
                                else if(value == _null){ 
					return XsNumber.NaN;
				}
				else if(value == _undefined){ 
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}
		}
       }
}

public XsObject or ( XsObject x ){
        
        if(this == xTrue){
		return new XsNumber(1).or(x);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).or(x);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else if(x instanceof XsString){
		return or(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return or(((XsNumber)x).ival);
		}
		else {
			return or(((XsNumber)x).dval);
		}
        }
        else{  
		XsObject left = XsObject.getPrimitiveFromObject(this);
                
                if(left == xTrue){
			return new XsNumber(1).or(x);
                } 
                else if(left == xFalse){//System.err.println("GO");
			return new XsNumber(0).or(x);
                }
                else if(left instanceof XsString){ 
			return ((XsString) left).or(x);
                }
                else if(left instanceof XsNumber){//System.err.println("GO");
		        return ((XsNumber) left).or(x);	
                }
                else if(left instanceof XsFunc){  
                        return ((XsFunc) left).or(x);
                }
                else if(left instanceof XsArray){  // js gives error
                        return ((XsArray) left).or(x);
                }
                else{ 
			XsObject func = this.xsGet("toString");
                        
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{  
				XsObject value = func.invoke(this);

				if(value instanceof XsString){
                                        return ((XsString) value).or(x); 
				}
				else if(value instanceof XsNumber){
                                      	return ((XsNumber)value).or(x);
			       	}
                                if(value == xTrue){
					return new XsNumber(1).or(x);
				} 
				else if(value == xFalse){
					return new XsNumber(0).or(x);
				}
                                else{  
                                        XsObject right = XsObject.getPrimitiveFromObject(x);
                                        //System.err.println("right is " + right);
                                        if(left == _null || left == _undefined){
						if(right instanceof XsString){
							return new XsString(left.toString()).or(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }
                                       
                                        if(value == _null || value == _undefined){
						if(right instanceof XsString){
							return new XsString(value.toString()).or(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }                                     
					
                                        if(right instanceof XsString ||
                                           right instanceof XsNumber ||
                                           right instanceof XsArray  ||
                                           right instanceof XsFunc 
                                          )
						{      
						return value.or(right);
                                        }
                                        else{
					        if(value == _null || value == _undefined){
							return XsNumber.NaN; 
                                                }
                                                else{
							System.err.println("TypeError: can't convert Object to primitive type");
							return _undefined;
						}
                                        } 
				}
			} 
                }    
        }
}

public XsObject or ( double d ){
        if(this == xTrue){
		return new XsNumber(1 | (int)d);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0.0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).or(d);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival | (int)d);
			}
			else {
				return new XsNumber((int)((XsNumber)left).dval | (int)d);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 | (int)d);
                }
                else if(left == xFalse){
			return new XsNumber(0.0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).or(d);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival | (int)d);
					}
					else {
						return new XsNumber((int)((XsNumber)value).dval | (int)d);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 | (int)d);
				}
				else if(left == xFalse){
					return new XsNumber(0.0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject or ( int i ){
        if(this == xTrue){
		return new XsNumber(1 | i);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).or(i);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival | i);
			}
			else {
				return new XsNumber((int)((XsNumber)left).dval | i);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 | i);
                }
                else if(left == xFalse){
			return new XsNumber(0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).or(i);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival | i);
					}
					else {
						return new XsNumber((int)((XsNumber)value).dval | i);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 | i);
				}
				else if(left == xFalse){
					return new XsNumber(0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject orAssign ( XsObject index, String s ){
        return this;   
}

public XsObject orAssign ( XsObject index, XsObject x ){
        return this;
}

public XsObject orAssign ( XsObject index, double d ){
	return this;
}
	
public XsObject orAssign ( XsObject index, int i ){
        return this;
}

public XsObject orAssign ( String prop, String s ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).or(s));
        return ret;   
}

public XsObject orAssign ( String prop, XsObject x ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).or(x));
        return ret;
}

public XsObject orAssign ( String prop, double d ){
	XsObject ret;
        xsPut( prop, ret = xsGet(prop).or(d));
        return ret;
}
	
public XsObject orAssign ( String prop, int i ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).or(i));
        return ret;
}

public XsObject plus ( String s ){
        if(this == xTrue || this == xFalse || this == _null || this == _undefined){
		return new XsString(this.toString() + s);
        }
        else{
		XsObject left = XsObject.getPrimitiveFromObject(this);

		//check exceptions on invoke ??

		if(left instanceof XsString){
			if(left instanceof XsString){
				return new XsString(left.toString() + s);
			}
			else if(left instanceof XsNumber){
				if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
					return new XsString(((XsNumber)left).ival + s);
				}
				else {
					return new XsString(((XsNumber)left).dval + s);
				}
			}
			else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsString(((XsNumber)left).ival + s);
			}
			else {
				return new XsString(((XsNumber)left).dval + s);
			}
		}
                if(left == xTrue || left == xFalse || left == _null || left == _undefined){
			return new XsString(left.toString() + s);
                }
		else{  
			XsObject func = this.xsGet("toString");

			if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return new XsString(value.toString() + s);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsString(((XsNumber)value).ival + s);
					}
					else {
						return new XsString(((XsNumber)value).dval + s);
					}
				}
				if(value == xTrue || value == xFalse || value == _null || value == _undefined){
					return new XsString(value.toString() + s);
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}
		}
       }
}

public XsObject plus ( XsObject x ){
        if(this == xTrue || this == xFalse || this == _null || this == _undefined){
		return new XsString(this.toString()).plus(x);
        }
        else if(x instanceof XsString)
		return plus(x.toString());
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return plus(((XsNumber)x).ival);
		}
		else {
			return plus(((XsNumber)x).dval);
		}
        }
        else{   //System.err.println("HERE HERE");
                XsObject left;

                if(!(this instanceof XsDate)){
			left = XsObject.getPrimitiveFromObject(this);
		}
		else{
			left = XsObject.getPrimitiveFromDate(this);
		}
		
                
                if(left == xTrue){
			return new XsNumber(1).plus(x);
                } 
                else if(left == xFalse){
			return new XsNumber(0).plus(x);
                }
                else if(left instanceof XsString){//System.err.println("HERE HERE");
			return ((XsString) left).plus(x);
                }
                else if(left instanceof XsNumber){
			return ((XsNumber) left).plus(x);	
                }
                else if(left instanceof XsFunc){  
                        return ((XsFunc) left).plus(x);
                }
                else if(left instanceof XsArray){  // js gives error
                        return ((XsArray) left).plus(x);
                }
                else{
                        XsObject func;

                        if(!(this instanceof XsDate)){
				func = this.xsGet("toString");
			}
			else{
				func = this.xsGet("valueOf");
			}
 
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);

				if(value instanceof XsString){
                                        return ((XsString) value).plus(x); 
				}
				else if(value instanceof XsNumber){
                                        
					return ((XsNumber)value).plus(x);
			       	}
                                if(value == xTrue){
					return new XsNumber(1).plus(x);
				} 
				else if(value == xFalse){
					return new XsNumber(0).plus(x);
				}
                                else{
                                        XsObject right;

					if(!(x instanceof XsDate)){
						 right = XsObject.getPrimitiveFromObject(x);
					}
					else{
						 right = XsObject.getPrimitiveFromDate(x);
					}

                                        
                                        if(left == _null || left == _undefined){
						if(right instanceof XsString){
							return new XsString(left.toString() + right.toString());
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }
                                        
                                        if(value == _null || value == _undefined){
						if(right instanceof XsString){
							return new XsString(value.toString() + right.toString());
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }                                     
					
                                        if(right instanceof XsString ||
                                           right instanceof XsNumber ||
                                           right instanceof XsArray  ||
                                           right instanceof XsFunc 
                                          )
					{      
						return value.plus(right);
                                        }
                                        else{
                                                if(value == _null || value == _undefined){
							return XsNumber.NaN; 
                                                }
                                                else{
							System.err.println("TypeError: can't convert Object to primitive type");
							return _undefined;
                                                }
                                        } 
				}
			} 
                }    
        }
}

public XsObject plus ( double d ){
        if(this == xTrue){
		return new XsNumber(1.0 + d);
        }
        else if(this == xFalse || this == _null || this == _undefined){
		return new XsNumber(d);
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return new XsString(left.toString() + d);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival + d);
			}
			else {
				return new XsNumber(((XsNumber)left).dval + d);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1.0 + d);
                }
                else if(left == xFalse){
			return new XsNumber(d);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return new XsString(value.toString() + d);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival + d);
					}
					else {
						return new XsNumber(((XsNumber)value).dval + d);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1.0 + d);
				}
				else if(left == xFalse){
					return new XsNumber(d);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject plus ( int i ){
        if(this == xTrue){
		return new XsNumber(1 + i);
        }
        else if(this == xFalse || this == _null || this == _undefined){
		return new XsNumber(i);
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return new XsString(left.toString() + i);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival + i);
			}
			else {
				return new XsNumber(((XsNumber)left).dval + i);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 + i);
                }
                else if(left == xFalse){
			return new XsNumber(i);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return new XsString(value.toString() + i);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival + i);
					}
					else {
						return new XsNumber(((XsNumber)value).dval + i);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 + i);
				}
				else if(left == xFalse){
					return new XsNumber(i);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject plusAssign ( XsObject index, String s ){
        return this;   
}

public XsObject plusAssign ( XsObject index, XsObject x ){
        return this;
}

public XsObject plusAssign ( XsObject index, double d ){
	return this;
}
	
public XsObject plusAssign ( XsObject index, int i ){
        return this;
}

public XsObject plusAssign ( String prop, String s ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).plus(s));
        return ret;   
}

public XsObject plusAssign ( String prop, XsObject x ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).plus(x));
        return ret;
}

public XsObject plusAssign ( String prop, double d ){
	XsObject ret;
        xsPut( prop, ret = xsGet(prop).plus(d));
        return ret;
}
	
public XsObject plusAssign ( String prop, int i ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).plus(i));
        return ret;
}

public XsObject postDec() {
	return XsNumber.getNumberFromObject(this).postDec();
}

public XsObject postInc() {
	return XsNumber.getNumberFromObject(this).postInc();
}

public void putNamedArrayObject( XsObject xElem, String arrName, String objName) {
	XsObject prop = xsGet( arrName);
	XsArray fa;

	if ( ! ( prop instanceof XsArray) ) {
		prop = new XsArray();
		xsPut( arrName, prop);
	}

	fa = (XsArray)prop;
	fa.push( xElem);

	if ( objName != null ) {
		xsPut( objName, xElem);
	}	
}

public void reset() {
	//resolved to init DOM2 tree
        //System.out.println("Doing nothing for reset");
}

public XsObject seq ( String s ){
	return xFalse;
}

public XsObject seq ( XsObject x ) {
	if(this == _null && x == _undefined || this == _undefined && x == _null)
		return xFalse;
	else
		return ( (x == this) ? xTrue : xFalse);
}

public XsObject seq ( double d ) {
	return xFalse;
}

public XsObject seq ( int i ) {
	return xFalse;
}

public XsObject shl ( String s ){
        if(this == xTrue){
		return new XsNumber(1).shl(s);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).shl(s);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else{
		XsObject left = XsObject.getPrimitiveFromObject(this);

		//check exceptions on invoke ??

		if(left instanceof XsString){
			if(left instanceof XsString){
				return ((XsString) left).shl(s);
			}
			else if(left instanceof XsNumber){
				if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
					return ((XsNumber)left).shl(s);
				}
				else {
					return ((XsNumber)left).shl(s);
				}
			}
			else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber)left).shl(s);
			}
			else {
				return ((XsNumber)left).shl(s);
			}
		}
                if(left == xTrue){
			return new XsNumber(1).shl(s);
                }
                else if(left == xFalse){ 
                        return new XsNumber(0).shl(s);
		}
                else if(left == _null){ 
                        return XsNumber.NaN;
		}
                else if(left == _undefined){ 
                        return XsNumber.NaN;
		}
		else{  
			XsObject func = this.xsGet("toString");

			if(!(func instanceof XsFunc)){
				System.err.println("TypeErrxor: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return ((XsString) value).shl(s);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return ((XsNumber)value).shl(s);
					}
					else {
						return ((XsNumber)value).shl(s);
					}
				}
                                if(value == xTrue){
					return new XsNumber(1).shl(s);
				}
				else if(value == xFalse){ 
					return new XsNumber(0).shl(s);
				}
                                else if(value == _null){ 
					return XsNumber.NaN;
				}
				else if(value == _undefined){ 
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeErrxor: can't convert Object to primitive");
					return _undefined;
				}
			}
		}
       }
}

public XsObject shl ( XsObject x ){
        
        if(this == xTrue){
		return new XsNumber(1).shl(x);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).shl(x);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else if(x instanceof XsString){
		return shl(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return shl(((XsNumber)x).ival);
		}
		else {
			return shl(((XsNumber)x).dval);
		}
        }
        else{  
		XsObject left = XsObject.getPrimitiveFromObject(this);
                
                if(left == xTrue){
			return new XsNumber(1).shl(x);
                } 
                else if(left == xFalse){//System.err.println("GO");
			return new XsNumber(0).shl(x);
                }
                else if(left instanceof XsString){ 
			return ((XsString) left).shl(x);
                }
                else if(left instanceof XsNumber){//System.err.println("GO");
		        return ((XsNumber) left).shl(x);	
                }
                else if(left instanceof XsFunc){  
                        return ((XsFunc) left).shl(x);
                }
                else if(left instanceof XsArray){  // js gives errxor
                        return ((XsArray) left).shl(x);
                }
                else{ 
			XsObject func = this.xsGet("toString");
                        
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeErrxor: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{  
				XsObject value = func.invoke(this);

				if(value instanceof XsString){
                                        return ((XsString) value).shl(x); 
				}
				else if(value instanceof XsNumber){
                                      	return ((XsNumber)value).shl(x);
			       	}
                                if(value == xTrue){
					return new XsNumber(1).shl(x);
				} 
				else if(value == xFalse){
					return new XsNumber(0).shl(x);
				}
                                else{  
                                        XsObject right = XsObject.getPrimitiveFromObject(x);
                                        //System.err.println("right is " + right);
                                        if(left == _null || left == _undefined){
						if(right instanceof XsString){
							return new XsString(left.toString()).shl(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }
                                       
                                        if(value == _null || value == _undefined){
						if(right instanceof XsString){
							return new XsString(value.toString()).shl(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }                                     
					
                                        if(right instanceof XsString ||
                                           right instanceof XsNumber ||
                                           right instanceof XsArray  ||
                                           right instanceof XsFunc 
                                          )
						{      
						return value.shl(right);
                                        }
                                        else{
					        if(value == _null || value == _undefined){
							return XsNumber.NaN; 
                                                }
                                                else{
							System.err.println("TypeErrxor: can't convert Object to primitive type");
							return _undefined;
						}
                                        } 
				}
			} 
                }    
        }
}

public XsObject shl ( double d ){
        if(this == xTrue){
		return new XsNumber(1 << (int)d);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0.0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).shl(d);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival << (int)d);
			}
			else {
				return new XsNumber((int)((XsNumber)left).dval << (int)d);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 << (int)d);
                }
                else if(left == xFalse){
			return new XsNumber(0.0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).shl(d);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival << (int)d);
					}
					else {
						return new XsNumber((int)((XsNumber)value).dval << (int)d);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 << (int)d);
				}
				else if(left == xFalse){
					return new XsNumber(0.0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject shl ( int i ){
        if(this == xTrue){
		return new XsNumber(1 << i);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).shl(i);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival << i);
			}
			else {
				return new XsNumber((int)((XsNumber)left).dval << i);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 << i);
                }
                else if(left == xFalse){
			return new XsNumber(0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).shl(i);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival << i);
					}
					else {
						return new XsNumber((int)((XsNumber)value).dval << i);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 << i);
				}
				else if(left == xFalse){
					return new XsNumber(0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject shlAssign ( XsObject index, String s ){
        return this;   
}

public XsObject shlAssign ( XsObject index, XsObject x ){
        return this;
}

public XsObject shlAssign ( XsObject index, double d ){
	return this;
}
	
public XsObject shlAssign ( XsObject index, int i ){
        return this;
}

public XsObject shlAssign ( String prop, String s ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).shl(s));
        return ret;   
}

public XsObject shlAssign ( String prop, XsObject x ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).shl(x));
        return ret;
}

public XsObject shlAssign ( String prop, double d ){
	XsObject ret;
        xsPut( prop, ret = xsGet(prop).shl(d));
        return ret;
}
	
public XsObject shlAssign ( String prop, int i ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).shl(i));
        return ret;
}

public XsObject shr ( String s ){
        if(this == xTrue){
		return new XsNumber(1).shr(s);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).shr(s);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else{
		XsObject left = XsObject.getPrimitiveFromObject(this);

		//check exceptions on invoke ??

		if(left instanceof XsString){
			if(left instanceof XsString){
				return ((XsString) left).shr(s);
			}
			else if(left instanceof XsNumber){
				if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
					return ((XsNumber)left).shr(s);
				}
				else {
					return ((XsNumber)left).shr(s);
				}
			}
			else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber)left).shr(s);
			}
			else {
				return ((XsNumber)left).shr(s);
			}
		}
                if(left == xTrue){
			return new XsNumber(1).shr(s);
                }
                else if(left == xFalse){ 
                        return new XsNumber(0).shr(s);
		}
                else if(left == _null){ 
                        return XsNumber.NaN;
		}
                else if(left == _undefined){ 
                        return XsNumber.NaN;
		}
		else{  
			XsObject func = this.xsGet("toString");

			if(!(func instanceof XsFunc)){
				System.err.println("TypeErrxor: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return ((XsString) value).shr(s);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return ((XsNumber)value).shr(s);
					}
					else {
						return ((XsNumber)value).shr(s);
					}
				}
                                if(value == xTrue){
					return new XsNumber(1).shr(s);
				}
				else if(value == xFalse){ 
					return new XsNumber(0).shr(s);
				}
                                else if(value == _null){ 
					return XsNumber.NaN;
				}
				else if(value == _undefined){ 
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeErrxor: can't convert Object to primitive");
					return _undefined;
				}
			}
		}
       }
}

public XsObject shr ( XsObject x ){
        
        if(this == xTrue){
		return new XsNumber(1).shr(x);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).shr(x);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else if(x instanceof XsString){
		return shr(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return shr(((XsNumber)x).ival);
		}
		else {
			return shr(((XsNumber)x).dval);
		}
        }
        else{  
		XsObject left = XsObject.getPrimitiveFromObject(this);
                
                if(left == xTrue){
			return new XsNumber(1).shr(x);
                } 
                else if(left == xFalse){//System.err.println("GO");
			return new XsNumber(0).shr(x);
                }
                else if(left instanceof XsString){ 
			return ((XsString) left).shr(x);
                }
                else if(left instanceof XsNumber){//System.err.println("GO");
		        return ((XsNumber) left).shr(x);	
                }
                else if(left instanceof XsFunc){  
                        return ((XsFunc) left).shr(x);
                }
                else if(left instanceof XsArray){  // js gives errxor
                        return ((XsArray) left).shr(x);
                }
                else{ 
			XsObject func = this.xsGet("toString");
                        
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeErrxor: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{  
				XsObject value = func.invoke(this);

				if(value instanceof XsString){
                                        return ((XsString) value).shr(x); 
				}
				else if(value instanceof XsNumber){
                                      	return ((XsNumber)value).shr(x);
			       	}
                                if(value == xTrue){
					return new XsNumber(1).shr(x);
				} 
				else if(value == xFalse){
					return new XsNumber(0).shr(x);
				}
                                else{  
                                        XsObject right = XsObject.getPrimitiveFromObject(x);
                                        //System.err.println("right is " + right);
                                        if(left == _null || left == _undefined){
						if(right instanceof XsString){
							return new XsString(left.toString()).shr(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }
                                       
                                        if(value == _null || value == _undefined){
						if(right instanceof XsString){
							return new XsString(value.toString()).shr(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }                                     
					
                                        if(right instanceof XsString ||
                                           right instanceof XsNumber ||
                                           right instanceof XsArray  ||
                                           right instanceof XsFunc 
                                          )
						{      
						return value.shr(right);
                                        }
                                        else{
					        if(value == _null || value == _undefined){
							return XsNumber.NaN; 
                                                }
                                                else{
							System.err.println("TypeErrxor: can't convert Object to primitive type");
							return _undefined;
						}
                                        } 
				}
			} 
                }    
        }
}

public XsObject shr ( double d ){
        if(this == xTrue){
		return new XsNumber(1 >> (int)d);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0.0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).shr(d);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival >> (int)d);
			}
			else {
				return new XsNumber((int)((XsNumber)left).dval >> (int)d);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 >> (int)d);
                }
                else if(left == xFalse){
			return new XsNumber(0.0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).shr(d);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival >> (int)d);
					}
					else {
						return new XsNumber((int)((XsNumber)value).dval >> (int)d);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 >> (int)d);
				}
				else if(left == xFalse){
					return new XsNumber(0.0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject shr ( int i ){
        if(this == xTrue){
		return new XsNumber(1 >> i);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).shr(i);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival >> i);
			}
			else {
				return new XsNumber((int)((XsNumber)left).dval >> i);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 >> i);
                }
                else if(left == xFalse){
			return new XsNumber(0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).shr(i);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival >> i);
					}
					else {
						return new XsNumber((int)((XsNumber)value).dval >> i);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 >> i);
				}
				else if(left == xFalse){
					return new XsNumber(0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject shrAssign ( XsObject index, String s ){
        return this;   
}

public XsObject shrAssign ( XsObject index, XsObject x ){
        return this;
}

public XsObject shrAssign ( XsObject index, double d ){
	return this;
}
	
public XsObject shrAssign ( XsObject index, int i ){
        return this;
}

public XsObject shrAssign ( String prop, String s ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).shr(s));
        return ret;   
}

public XsObject shrAssign ( String prop, XsObject x ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).shr(x));
        return ret;
}

public XsObject shrAssign ( String prop, double d ){
	XsObject ret;
        xsPut( prop, ret = xsGet(prop).shr(d));
        return ret;
}
	
public XsObject shrAssign ( String prop, int i ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).shr(i));
        return ret;
}

public XsObject snotEq ( String s ){
	return (seq(s) == xTrue) ? xFalse : xTrue;
}

public XsObject snotEq (XsObject x ){
	return (seq(x) == xTrue) ? xFalse : xTrue;
}

public XsObject snotEq ( double d ){
	return (seq(d) == xTrue) ? xFalse : xTrue;
}

public XsObject snotEq ( int i ){
	return (seq(i) == xTrue) ? xFalse : xTrue;
}

public XsObject toBoolean(){
        if ( this == _undefined ) 
		return xFalse;
	else if ( this == _null ) 
		return xFalse;
	else if ( this == xTrue ) 
		return this;
	else if ( this == xFalse ) 
		return this;
        else
                return xTrue;
}

public String toString() {
	
        if ( this == _undefined )  return "undefined";
	else if ( this == _null )  return "null";
	else if ( this == xTrue)   return "true";
	else if ( this == xFalse ) return "false";
	else if ( this == global ) return "[object global]";//does not work as intended

	else {
              return "[object Object]";
	}
}
/*
public static XsString typeof ( XsObject o ){
	return o.xsGetType();
}
*/

public XsObject ushr ( String s ){
        if(this == xTrue){
		return new XsNumber(1).ushr(s);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).ushr(s);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else{
		XsObject left = XsObject.getPrimitiveFromObject(this);

		//check exceptions on invoke ??

		if(left instanceof XsString){
			if(left instanceof XsString){
				return ((XsString) left).ushr(s);
			}
			else if(left instanceof XsNumber){
				if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
					return ((XsNumber)left).ushr(s);
				}
				else {
					return ((XsNumber)left).ushr(s);
				}
			}
			else{
				System.err.println("TypeError: can't convert Object to primitive");
				return _undefined;
			}
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber)left).ushr(s);
			}
			else {
				return ((XsNumber)left).ushr(s);
			}
		}
                if(left == xTrue){
			return new XsNumber(1).ushr(s);
                }
                else if(left == xFalse){ 
                        return new XsNumber(0).ushr(s);
		}
                else if(left == _null){ 
                        return XsNumber.NaN;
		}
                else if(left == _undefined){ 
                        return XsNumber.NaN;
		}
		else{  
			XsObject func = this.xsGet("toString");

			if(!(func instanceof XsFunc)){
				System.err.println("TypeErrxor: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return ((XsString) value).ushr(s);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return ((XsNumber)value).ushr(s);
					}
					else {
						return ((XsNumber)value).ushr(s);
					}
				}
                                if(value == xTrue){
					return new XsNumber(1).ushr(s);
				}
				else if(value == xFalse){ 
					return new XsNumber(0).ushr(s);
				}
                                else if(value == _null){ 
					return XsNumber.NaN;
				}
				else if(value == _undefined){ 
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeErrxor: can't convert Object to primitive");
					return _undefined;
				}
			}
		}
       }
}

public XsObject ushr ( XsObject x ){
        
        if(this == xTrue){
		return new XsNumber(1).ushr(x);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).ushr(x);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else if(x instanceof XsString){
		return ushr(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return ushr(((XsNumber)x).ival);
		}
		else {
			return ushr(((XsNumber)x).dval);
		}
        }
        else{  
		XsObject left = XsObject.getPrimitiveFromObject(this);
                
                if(left == xTrue){
			return new XsNumber(1).ushr(x);
                } 
                else if(left == xFalse){//System.err.println("GO");
			return new XsNumber(0).ushr(x);
                }
                else if(left instanceof XsString){ 
			return ((XsString) left).ushr(x);
                }
                else if(left instanceof XsNumber){//System.err.println("GO");
		        return ((XsNumber) left).ushr(x);	
                }
                else if(left instanceof XsFunc){  
                        return ((XsFunc) left).ushr(x);
                }
                else if(left instanceof XsArray){  // js gives errxor
                        return ((XsArray) left).ushr(x);
                }
                else{ 
			XsObject func = this.xsGet("toString");
                        
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeErrxor: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{  
				XsObject value = func.invoke(this);

				if(value instanceof XsString){
                                        return ((XsString) value).ushr(x); 
				}
				else if(value instanceof XsNumber){
                                      	return ((XsNumber)value).ushr(x);
			       	}
                                if(value == xTrue){
					return new XsNumber(1).ushr(x);
				} 
				else if(value == xFalse){
					return new XsNumber(0).ushr(x);
				}
                                else{  
                                        XsObject right = XsObject.getPrimitiveFromObject(x);
                                        //System.err.println("right is " + right);
                                        if(left == _null || left == _undefined){
						if(right instanceof XsString){
							return new XsString(left.toString()).ushr(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }
                                       
                                        if(value == _null || value == _undefined){
						if(right instanceof XsString){
							return new XsString(value.toString()).ushr(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }                                     
					
                                        if(right instanceof XsString ||
                                           right instanceof XsNumber ||
                                           right instanceof XsArray  ||
                                           right instanceof XsFunc 
                                          )
						{      
						return value.ushr(right);
                                        }
                                        else{
					        if(value == _null || value == _undefined){
							return XsNumber.NaN; 
                                                }
                                                else{
							System.err.println("TypeErrxor: can't convert Object to primitive type");
							return _undefined;
						}
                                        } 
				}
			} 
                }    
        }
}

public XsObject ushr ( double d ){
        if(this == xTrue){
		return new XsNumber(1 >>> (int)d);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0.0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).ushr(d);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival >>> (int)d);
			}
			else {
				return new XsNumber((int)((XsNumber)left).dval >>> (int)d);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 >>> (int)d);
                }
                else if(left == xFalse){
			return new XsNumber(0.0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).ushr(d);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival >>> (int)d);
					}
					else {
						return new XsNumber((int)((XsNumber)value).dval >>> (int)d);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 >>> (int)d);
				}
				else if(left == xFalse){
					return new XsNumber(0.0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject ushr ( int i ){
        if(this == xTrue){
		return new XsNumber(1 >>> i);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).ushr(i);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival >>> i);
			}
			else {
				return new XsNumber((int)((XsNumber)left).dval >>> i);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 >>> i);
                }
                else if(left == xFalse){
			return new XsNumber(0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).ushr(i);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival >>> i);
					}
					else {
						return new XsNumber((int)((XsNumber)value).dval >>> i);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 >>> i);
				}
				else if(left == xFalse){
					return new XsNumber(0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject ushrAssign ( XsObject index, String s ){
        return this;   
}

public XsObject ushrAssign ( XsObject index, XsObject x ){
        return this;
}

public XsObject ushrAssign ( XsObject index, double d ){
	return this;
}
	
public XsObject ushrAssign ( XsObject index, int i ){
        return this;
}

public XsObject ushrAssign ( String prop, String s ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).ushr(s));
        return ret;   
}

public XsObject ushrAssign ( String prop, XsObject x ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).ushr(x));
        return ret;
}

public XsObject ushrAssign ( String prop, double d ){
	XsObject ret;
        xsPut( prop, ret = xsGet(prop).ushr(d));
        return ret;
}
	
public XsObject ushrAssign ( String prop, int i ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).ushr(i));
        return ret;
}

public XsObject valueOf() {
	return this;
     // ????? return a reference or a copy  ?????
}

public XsObject xor ( String s ){
        if(this == xTrue){
		return new XsNumber(1).xor(s);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).xor(s);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else{
		XsObject left = XsObject.getPrimitiveFromObject(this);

		//check exceptions on invoke ??

		if(left instanceof XsString){
			if(left instanceof XsString){
				return ((XsString) left).xor(s);
			}
			else if(left instanceof XsNumber){
				if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
					return ((XsNumber)left).xor(s);
				}
				else {
					return ((XsNumber)left).xor(s);
				}
			}
			else{
				System.err.println("TypeErrxor: can't convert Object to primitive");
				return _undefined;
			}
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return ((XsNumber)left).xor(s);
			}
			else {
				return ((XsNumber)left).xor(s);
			}
		}
                if(left == xTrue){
			return new XsNumber(1).xor(s);
                }
                else if(left == xFalse){ 
                        return new XsNumber(0).xor(s);
		}
                else if(left == _null){ 
                        return XsNumber.NaN;
		}
                else if(left == _undefined){ 
                        return XsNumber.NaN;
		}
		else{  
			XsObject func = this.xsGet("toString");

			if(!(func instanceof XsFunc)){
				System.err.println("TypeErrxor: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
				if(value instanceof XsString){
					return ((XsString) value).xor(s);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return ((XsNumber)value).xor(s);
					}
					else {
						return ((XsNumber)value).xor(s);
					}
				}
                                if(value == xTrue){
					return new XsNumber(1).xor(s);
				}
				else if(value == xFalse){ 
					return new XsNumber(0).xor(s);
				}
                                else if(value == _null){ 
					return XsNumber.NaN;
				}
				else if(value == _undefined){ 
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeErrxor: can't convert Object to primitive");
					return _undefined;
				}
			}
		}
       }
}

public XsObject xor ( XsObject x ){
        
        if(this == xTrue){
		return new XsNumber(1).xor(x);
        }
        else if(this == xFalse || this == _null){ 
                return new XsNumber(0).xor(x);
	}
        else if(this == _undefined){ 
                return XsNumber.NaN;
	}
        else if(x instanceof XsString){
		return xor(x.toString());
        }
        else if(x instanceof XsNumber){
		if ( ((XsNumber)x).type == XsNumber.TYPE_INT ){
			return xor(((XsNumber)x).ival);
		}
		else {
			return xor(((XsNumber)x).dval);
		}
        }
        else{  
		XsObject left = XsObject.getPrimitiveFromObject(this);
                
                if(left == xTrue){
			return new XsNumber(1).xor(x);
                } 
                else if(left == xFalse){//System.err.println("GO");
			return new XsNumber(0).xor(x);
                }
                else if(left instanceof XsString){ 
			return ((XsString) left).xor(x);
                }
                else if(left instanceof XsNumber){//System.err.println("GO");
		        return ((XsNumber) left).xor(x);	
                }
                else if(left instanceof XsFunc){  
                        return ((XsFunc) left).xor(x);
                }
                else if(left instanceof XsArray){  // js gives errxor
                        return ((XsArray) left).xor(x);
                }
                else{ 
			XsObject func = this.xsGet("toString");
                        
                        if(!(func instanceof XsFunc)){
				System.err.println("TypeErrxor: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{  
				XsObject value = func.invoke(this);

				if(value instanceof XsString){
                                        return ((XsString) value).xor(x); 
				}
				else if(value instanceof XsNumber){
                                      	return ((XsNumber)value).xor(x);
			       	}
                                if(value == xTrue){
					return new XsNumber(1).xor(x);
				} 
				else if(value == xFalse){
					return new XsNumber(0).xor(x);
				}
                                else{  
                                        XsObject right = XsObject.getPrimitiveFromObject(x);
                                        //System.err.println("right is " + right);
                                        if(left == _null || left == _undefined){
						if(right instanceof XsString){
							return new XsString(left.toString()).xor(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }
                                       
                                        if(value == _null || value == _undefined){
						if(right instanceof XsString){
							return new XsString(value.toString()).xor(right);
                                                }
                                                else if(right instanceof XsNumber){
                                                        return XsNumber.NaN; 
                                                }    
                                        }                                     
					
                                        if(right instanceof XsString ||
                                           right instanceof XsNumber ||
                                           right instanceof XsArray  ||
                                           right instanceof XsFunc 
                                          )
						{      
						return value.xor(right);
                                        }
                                        else{
					        if(value == _null || value == _undefined){
							return XsNumber.NaN; 
                                                }
                                                else{
							System.err.println("TypeErrxor: can't convert Object to primitive type");
							return _undefined;
						}
                                        } 
				}
			} 
                }    
        }
}

public XsObject xor ( double d ){
        if(this == xTrue){
		return new XsNumber(1 ^ (int)d);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0.0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).xor(d);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival ^ (int)d);
			}
			else {
				return new XsNumber((int)((XsNumber)left).dval ^ (int)d);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 ^ (int)d);
                }
                else if(left == xFalse){
			return new XsNumber(0.0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).xor(d);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival ^ (int)d);
					}
					else {
						return new XsNumber((int)((XsNumber)value).dval ^ (int)d);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 ^ (int)d);
				}
				else if(left == xFalse){
					return new XsNumber(0.0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject xor ( int i ){
        if(this == xTrue){
		return new XsNumber(1 ^ i);
        }
        else if(this == xFalse || this == _null){
		return new XsNumber(0);
        }
        else if(this == _undefined){
		return XsNumber.NaN;
        }
	else{
                XsObject left = XsObject.getPrimitiveFromObject(this);
		
		//System.err.println("left = " + left);
	        if(left instanceof XsString){
			return ((XsString)left).xor(i);
		}
		else if(left instanceof XsNumber){
			if ( ((XsNumber)left).type == XsNumber.TYPE_INT ){
				return new XsNumber(((XsNumber)left).ival ^ i);
			}
			else {
				return new XsNumber((int)((XsNumber)left).dval ^ i);
			}
		}
                else if(left == xTrue){
			return new XsNumber(1 ^ i);
                }
                else if(left == xFalse){
			return new XsNumber(0);
                }
                else if(left == _null || left == _undefined){
                        //System.err.println("left = " + left);
			return XsNumber.NaN;
                }
		else{   //System.err.println("value is ");
			//try toString
			XsObject func = this.xsGet("toString");

                        if(!(func instanceof XsFunc)){
				System.err.println("TypeError: can't convert Object to primitive type");
				return _undefined;
			}                                  	
			else{   
				XsObject value = func.invoke(this);
                                //System.err.println("value is " + value);
				if(value instanceof XsString){
					return ((XsString)left).xor(i);
				}
				else if(value instanceof XsNumber){
					if ( ((XsNumber)value).type == XsNumber.TYPE_INT ){
						return new XsNumber(((XsNumber)value).ival ^ i);
					}
					else {
						return new XsNumber((int)((XsNumber)value).dval ^ i);
					}
				}
                                else if(left == xTrue){
					return new XsNumber(1 ^ i);
				}
				else if(left == xFalse){
					return new XsNumber(0);
				}
				else if(left == _null || left == _undefined){
					//System.err.println("left = " + left);
					return XsNumber.NaN;
				}
				else{
					System.err.println("TypeError: can't convert Object to primitive");
					return _undefined;
				}
			}	
		}  
        }
}

public XsObject xorAssign ( XsObject index, String s ){
        return this;   
}

public XsObject xorAssign ( XsObject index, XsObject x ){
        return this;
}

public XsObject xorAssign ( XsObject index, double d ){
	return this;
}
	
public XsObject xorAssign ( XsObject index, int i ){
        return this;
}

public XsObject xorAssign ( String prop, String s ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).xor(s));
        return ret;   
}

public XsObject xorAssign ( String prop, XsObject x ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).xor(x));
        return ret;
}

public XsObject xorAssign ( String prop, double d ){
	XsObject ret;
        xsPut( prop, ret = xsGet(prop).xor(d));
        return ret;
}
	
public XsObject xorAssign ( String prop, int i ){
        XsObject ret;
        xsPut( prop, ret = xsGet(prop).xor(i));
        return ret;
}

public XsObject xsGet ( Object key ) {
	return xsGet( key.toString());
}

public XsObject xsGet ( String key ) {
	XsObject o = this;
	XsObject v = null;
        int i  = 0;
       
	//System.out.println("In xsGet " + key );
        
        while ( v == null ) {
                i++;
		if ( (o.properties == null) || ((v = o.properties.get( key)) == null) ) {
			if ( o.__proto__ != null ){
				//System.out.println("Going to prototype");
				o = o.__proto__;
			}
			else {  //System.out.println("Performed " + i + " iterations");
				
                                
			if(this.parent != null){
				//System.out.println("going to parent");
                                         return this.parent.xsGet(key);
                                }
				else{
                                        //System.out.println("returning _undefined");
					return _undefined;
                                } 
			}
		}
	}
	//System.out.println("Performed " + i + " iterations");
	//System.out.println("returning " + v);
        return v;
}

//used only in XsString.getStringFromObject
public XsObject xsGet ( String key , int[] outval) {
	XsObject o = this;
	XsObject v = null;
        int i  = 0;
       
	
	
        while ( v == null ) {
                i++;
		if ( (o.properties == null) || ((v = o.properties.get( key)) == null) ) {
			if ( o.__proto__ != null ){
				//System.out.println("Going to prototype");
				o = o.__proto__;
			}
			else {  //System.out.println("Performed " + i + " iterations");
				outval[0] = i;
                                
			if(this.parent != null){
				//System.out.println("going to parent");
                                         return this.parent.xsGet(key);
                                }
				else{
                                        //System.out.println("returning _undefined");
					return _undefined;
                                } 
			}
		}
	}
	//System.out.println("Performed " + i + " iterations");
	//System.out.println("returning " + v);
        outval[0] = i;
        return v;
}

public XsObject xsGet ( int key ) {
	return xsGet( Integer.toString(key));
}

public XsString xsGetType () {
	if ( (this == xTrue) || (this == xFalse) ){
		return typeStrBool;
	}
	else if ( this == _undefined ){
		return typeStrUndef;
	}
	else {
		return typeStrObj;
	}
}

protected boolean canPut(String key){

	 if(properties == null){
                properties = new XsProps(11);
	        properties_attributes = new Hashtable(11);
	 }
         
         if( properties.get(key) != null ){

	         if(((XsPropertyAttributes)properties_attributes.get(key)).ReadOnly){
			 return false;
	         }
		 else{
		         return true;
		 }
         }
         else{
                 if(this.__proto__ != null){
			 return this.__proto__.canPut(key);
                 }
                 else{
			 return true;
                 }
        }
}

public XsObject xsPut ( Object key, XsObject val ) {
	return xsPut( key.toString(), val);
}

public XsObject xsPut ( String key, XsObject val ) {
	//System.out.println("in xsPut, for key = " + key + " added val = " + val );
        if ( this == _undefined ){ 
		System.err.println("TypeError: entity has no properties");
                System.err.println("Trying xsPut for property " + key + " with value " + val);
                return this;
        }

	if ( properties == null ) {
		properties = new XsProps(11);
	        properties_attributes = new Hashtable(11);
	}
        
        //check if already exists, if not create attributes
        if(properties.get(key) == null){
		properties_attributes.put(key, new XsPropertyAttributes());
        } 
	
        //check that assignment is permitted
        if(canPut(key)){

                /*XsObject old = */properties.put( key, val);

                //investigate what this is for 
		/* if ( (old != null) && (old.ref != null) ){
			// this is a statically defined property, update the field
			System.out.println("got in here");
			val.ref = old.ref;
			try {
				val.ref.set( null, val);
			}
			catch ( Exception x ) {
				x.printStackTrace();
			}
			}*/
                //System.out.println("for key = " + key + " added val = " + val + " to object " + this);
		if ( key.equals("prototype")){
			__proto__ = val;
                }

                return val;
	}
        else{
                //System.err.println("Error: cannot assign to " + key);
		return val;
	}
}

public XsObject xsPut ( int key, XsObject val ) {
       return xsPut( Integer.toString(key), val);
}

public void xsRemove ( Object key) {
	properties.remove(key);
}
/*
public void xsRemoveAll(){
	properties.removeAll();
}
*/
}







